SPOOL UpdateAudit.lst
WHENEVER SQLERROR EXIT FAILURE ROLLBACK
WHENEVER OSERROR EXIT FAILURE ROLLBACK

/* AUTOSANCTIONDATA */

ALTER TABLE A_AUTOSANCTIONDATA RENAME COLUMN PROMISE TO PROMIS$
/
ALTER TABLE A_AUTOSANCTIONDATA ADD PROMISE NUMBER(10,0)
/
UPDATE A_AUTOSANCTIONDATA SET PROMISE=PROMIS$
/
ALTER TABLE A_AUTOSANCTIONDATA DROP COLUMN PROMIS$
/

/* BUDSTRUCT */

ALTER TABLE A_BUDSTRUCT ADD ASSIGNMENTKIND NUMBER(10,0)
/

UPDATE A_BUDSTRUCT at SET 
  (ASSIGNMENTKIND) = (
    select ASSIGNMENTKIND
    from BUDSTRUCT
    where ID=at.ID)
/

/* BUDSTRUCTRIGHTS */

ALTER TABLE A_BUDSTRUCTRIGHTS ADD ASSIGNMENTKIND NUMBER(10,0)
/

ALTER TABLE A_BUDSTRUCTRIGHTS ADD ASSIGNMENTKINDUP NUMBER(10,0)
/

UPDATE A_BUDSTRUCTRIGHTS at SET 
  (ASSIGNMENTKIND,ASSIGNMENTKINDUP) = (
    select ASSIGNMENTKIND,ASSIGNMENTKINDUP
    from BUDSTRUCTRIGHTS
    where ID=at.ID)
/

/* CLIENTDFACCOUNTLIST */

ALTER TABLE A_CLIENTDFACCOUNTLIST ADD TYPEINF NUMBER(10,0)
/

UPDATE A_CLIENTDFACCOUNTLIST at SET 
  (TYPEINF) = (
    select TYPEINF
    from CLIENTDFACCOUNTLIST
    where ID=at.ID)
/

/* OOS_CONTRACT */

ALTER TABLE A_OOS_CONTRACT ADD PROGINDEX NUMBER(10,0)
/

UPDATE A_OOS_CONTRACT at SET 
  (PROGINDEX) = (
    select PROGINDEX
    from OOS_CONTRACT
    where ID=at.ID)
/

/* OOS_CONTRACT_FINANCES */

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD PROGINDEX NUMBER(10,0)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD ANUMBER VARCHAR2(50)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD PACKETSECTION VARCHAR2(512)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD SUBJECTNAME VARCHAR2(2000)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD MAXPRICE NUMBER(15,2)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD PLACINGWAY_CODE VARCHAR2(7)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD PLACINGWAY_NAME VARCHAR2(500)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD CHANGEREASON_ID VARCHAR2(50)
/

ALTER TABLE A_OOS_CONTRACT_FINANCES ADD CHANGEREASON_NAME VARCHAR2(1000)
/

UPDATE A_OOS_CONTRACT_FINANCES at SET 
  (PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME) = (
    select PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME
    from OOS_CONTRACT_FINANCES
    where ID=at.ID)
/

/* OOS_CONTRACT_PRODUCTS */

ALTER TABLE A_OOS_CONTRACT_PRODUCTS ADD PROGINDEX NUMBER(10,0)
/

UPDATE A_OOS_CONTRACT_PRODUCTS at SET 
  (PROGINDEX) = (
    select PROGINDEX
    from OOS_CONTRACT_PRODUCTS
    where ID=at.ID)
/

/* OOS_CONTRACTPROCEDURE */

ALTER TABLE A_OOS_CONTRACTPROCEDURE ADD PROGINDEX NUMBER(10,0)
/

UPDATE A_OOS_CONTRACTPROCEDURE at SET 
  (PROGINDEX) = (
    select PROGINDEX
    from OOS_CONTRACTPROCEDURE
    where ID=at.ID)
/

/* TB_AGREEMENTS */

ALTER TABLE A_TB_AGREEMENTS ADD PURCHASECODE VARCHAR2(150)
/

UPDATE A_TB_AGREEMENTS at SET 
  (PURCHASECODE) = (
    select PURCHASECODE
    from TB_AGREEMENTS
    where ID=at.ID)
/

/* TB_BUDNOTIFY */

ALTER TABLE A_TB_BUDNOTIFY RENAME COLUMN NOTE1 TO NOTE$
/
ALTER TABLE A_TB_BUDNOTIFY ADD NOTE1 VARCHAR2(4000)
/
UPDATE A_TB_BUDNOTIFY SET NOTE1=NOTE$
/
ALTER TABLE A_TB_BUDNOTIFY DROP COLUMN NOTE$
/

/* TB_DOCUMENTFIELDS */

ALTER TABLE A_TB_DOCUMENTFIELDS ADD ATTRIBUTENAME VARCHAR2(255)
/

UPDATE A_TB_DOCUMENTFIELDS at SET 
  (ATTRIBUTENAME) = (
    select ATTRIBUTENAME
    from TB_DOCUMENTFIELDS
    where ID=at.ID)
/

/* TB_FACIALACC_CLS */

ALTER TABLE A_TB_FACIALACC_CLS RENAME COLUMN FACIALCODEEX TO FACIALCODEE$
/
ALTER TABLE A_TB_FACIALACC_CLS ADD FACIALCODEEX VARCHAR2(4000)
/
UPDATE A_TB_FACIALACC_CLS SET FACIALCODEEX=FACIALCODEE$
/
ALTER TABLE A_TB_FACIALACC_CLS DROP COLUMN FACIALCODEE$
/

/* TB_TENDERCAPTION */

ALTER TABLE A_TB_TENDERCAPTION RENAME COLUMN PURCHASECODE TO PURCHASECOD$
/
ALTER TABLE A_TB_TENDERCAPTION ADD PURCHASECODE VARCHAR2(150)
/
UPDATE A_TB_TENDERCAPTION SET PURCHASECODE=PURCHASECOD$
/
ALTER TABLE A_TB_TENDERCAPTION DROP COLUMN PURCHASECOD$
/

ALTER TABLE A_TB_TENDERCAPTION RENAME COLUMN PURCHASESOCIALNKO TO PURCHASESOCIALNK$
/
ALTER TABLE A_TB_TENDERCAPTION ADD PURCHASESOCIALNKO NUMBER(10,0)
/
UPDATE A_TB_TENDERCAPTION SET PURCHASESOCIALNKO=PURCHASESOCIALNK$
/
ALTER TABLE A_TB_TENDERCAPTION DROP COLUMN PURCHASESOCIALNK$
/

ALTER TABLE A_TB_TENDERCAPTION ADD AVERSION NUMBER(10,0)
/

ALTER TABLE A_TB_TENDERCAPTION ADD PARENTREF NUMBER(10,0)
/

UPDATE A_TB_TENDERCAPTION at SET 
  (AVERSION,PARENTREF) = (
    select AVERSION,PARENTREF
    from TB_TENDERCAPTION
    where ID=at.ID)
/

/* TENDERPRODUCT */

ALTER TABLE A_TENDERPRODUCT ADD SUMMAOTHERYEARS NUMBER(15,2)
/

UPDATE A_TENDERPRODUCT at SET 
  (SUMMAOTHERYEARS) = (
    select SUMMAOTHERYEARS
    from TENDERPRODUCT
    where ID=at.ID)
/

/*        */
declare
  cursor c$ is
  select 'ALTER TABLE ' || t.Table_name || ' DROP COLUMN ' || c.column_name as str
  from user_tables t, user_tab_columns c
  where substr(t.Table_name,1,2) = 'A_'
    and t.Table_name = c.table_name
    and substr(c.column_name,1,5)!='OPER_'
  minus
  select 'ALTER TABLE ' || t.Table_name || ' DROP COLUMN ' || c.column_name as str
  from user_tables t, user_tab_columns c
  where substr(t.Table_name,1,2) = 'A_'
    and substr(t.Table_name,3,30) = c.table_name;
begin
  for r$ in c$ loop
    execute immediate r$.str;
  end loop;
end;
/

SPOOL OFF

exit
