SPOOL AuditTriggers.lst
WHENEVER SQLERROR EXIT FAILURE ROLLBACK
WHENEVER OSERROR EXIT FAILURE ROLLBACK

CREATE OR REPLACE TRIGGER ATI_ACC_CLS
  AFTER INSERT
  ON ACC_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACC_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACC_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,SERVICETYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.SERVICETYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ACC_CLS
  AFTER UPDATE
  ON ACC_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ACC_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ACC_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACC_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,SERVICETYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.SERVICETYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_ACC_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ACC_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,SERVICETYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.SERVICETYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ACC_CLS
  AFTER DELETE
  ON ACC_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACC_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ACCCUROPERATION
  AFTER INSERT
  ON ACCCUROPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCCUROPERATION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCCUROPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURRENCY
      ,EXCHANGE
      ,OPERATION
      ,CURSUMMA
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURRENCY
      , :new.EXCHANGE
      , :new.OPERATION
      , :new.CURSUMMA
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ACCCUROPERATION
  AFTER UPDATE
  ON ACCCUROPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ACCCUROPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ACCCUROPERATION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCCUROPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURRENCY
      ,EXCHANGE
      ,OPERATION
      ,CURSUMMA
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURRENCY
      , :new.EXCHANGE
      , :new.OPERATION
      , :new.CURSUMMA
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_ACCCUROPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ACCCUROPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURRENCY
      ,EXCHANGE
      ,OPERATION
      ,CURSUMMA
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURRENCY
      , :new.EXCHANGE
      , :new.OPERATION
      , :new.CURSUMMA
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ACCCUROPERATION
  AFTER DELETE
  ON ACCCUROPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCCUROPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ACCOUNTPLAN
  AFTER INSERT
  ON ACCOUNTPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCOUNTPLAN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCOUNTPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,STATE
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.STATE
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ACCOUNTPLAN
  AFTER UPDATE
  ON ACCOUNTPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ACCOUNTPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ACCOUNTPLAN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCOUNTPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,STATE
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.STATE
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_ACCOUNTPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ACCOUNTPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,STATE
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.STATE
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ACCOUNTPLAN
  AFTER DELETE
  ON ACCOUNTPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCOUNTPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ACCOUNTSCONFORMITY
  AFTER INSERT
  ON ACCOUNTSCONFORMITY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCOUNTSCONFORMITY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCOUNTSCONFORMITY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT15N
      ,ACCOUNT70N
      ,BALANCECLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT15N
      , :new.ACCOUNT70N
      , :new.BALANCECLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ACCOUNTSCONFORMITY
  AFTER UPDATE
  ON ACCOUNTSCONFORMITY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ACCOUNTSCONFORMITY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ACCOUNTSCONFORMITY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCOUNTSCONFORMITY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT15N
      ,ACCOUNT70N
      ,BALANCECLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT15N
      , :new.ACCOUNT70N
      , :new.BALANCECLS
    );
  else 
    update A_ACCOUNTSCONFORMITY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ACCOUNTSCONFORMITY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT15N
      ,ACCOUNT70N
      ,BALANCECLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT15N
      , :new.ACCOUNT70N
      , :new.BALANCECLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ACCOUNTSCONFORMITY
  AFTER DELETE
  ON ACCOUNTSCONFORMITY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCOUNTSCONFORMITY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ACCOUNTSCORR
  AFTER INSERT
  ON ACCOUNTSCORR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCOUNTSCORR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCOUNTSCORR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DEBIT
      ,CREDIT
      ,NOTE
      ,BUHOPERATIONID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DEBIT
      , :new.CREDIT
      , :new.NOTE
      , :new.BUHOPERATIONID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ACCOUNTSCORR
  AFTER UPDATE
  ON ACCOUNTSCORR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ACCOUNTSCORR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ACCOUNTSCORR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCOUNTSCORR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DEBIT
      ,CREDIT
      ,NOTE
      ,BUHOPERATIONID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DEBIT
      , :new.CREDIT
      , :new.NOTE
      , :new.BUHOPERATIONID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_ACCOUNTSCORR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ACCOUNTSCORR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DEBIT
      ,CREDIT
      ,NOTE
      ,BUHOPERATIONID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DEBIT
      , :new.CREDIT
      , :new.NOTE
      , :new.BUHOPERATIONID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ACCOUNTSCORR
  AFTER DELETE
  ON ACCOUNTSCORR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCOUNTSCORR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ACCSOPERTITLE
  AFTER INSERT
  ON ACCSOPERTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCSOPERTITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCSOPERTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,NOTE
      ,BUDGETREF
      ,BUILDDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.NOTE
      , :new.BUDGETREF
      , :new.BUILDDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ACCSOPERTITLE
  AFTER UPDATE
  ON ACCSOPERTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ACCSOPERTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ACCSOPERTITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ACCSOPERTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,NOTE
      ,BUDGETREF
      ,BUILDDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.NOTE
      , :new.BUDGETREF
      , :new.BUILDDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_ACCSOPERTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ACCSOPERTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,NOTE
      ,BUDGETREF
      ,BUILDDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.NOTE
      , :new.BUDGETREF
      , :new.BUILDDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ACCSOPERTITLE
  AFTER DELETE
  ON ACCSOPERTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ACCSOPERTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ADMISSION
  AFTER INSERT
  ON ADMISSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ADMISSION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ADMISSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDREF
      ,BUDSOURCE
      ,BUDDEST
      ,DAT
      ,SUMMA
      ,ACC
      ,FLAG
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCTYPE
      ,KD
      ,SUBKD
      ,GOSNI
      ,FACIALACC_CLS
      ,MEANSTYPE
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,FINSOURCE
      ,FINTYPE
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS_CORR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDREF
      , :new.BUDSOURCE
      , :new.BUDDEST
      , :new.DAT
      , :new.SUMMA
      , :new.ACC
      , :new.FLAG
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCTYPE
      , :new.KD
      , :new.SUBKD
      , :new.GOSNI
      , :new.FACIALACC_CLS
      , :new.MEANSTYPE
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ADMISSION
  AFTER UPDATE
  ON ADMISSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ADMISSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ADMISSION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ADMISSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDREF
      ,BUDSOURCE
      ,BUDDEST
      ,DAT
      ,SUMMA
      ,ACC
      ,FLAG
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCTYPE
      ,KD
      ,SUBKD
      ,GOSNI
      ,FACIALACC_CLS
      ,MEANSTYPE
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,FINSOURCE
      ,FINTYPE
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS_CORR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDREF
      , :new.BUDSOURCE
      , :new.BUDDEST
      , :new.DAT
      , :new.SUMMA
      , :new.ACC
      , :new.FLAG
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCTYPE
      , :new.KD
      , :new.SUBKD
      , :new.GOSNI
      , :new.FACIALACC_CLS
      , :new.MEANSTYPE
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
    );
  else 
    update A_ADMISSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ADMISSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDREF
      ,BUDSOURCE
      ,BUDDEST
      ,DAT
      ,SUMMA
      ,ACC
      ,FLAG
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCTYPE
      ,KD
      ,SUBKD
      ,GOSNI
      ,FACIALACC_CLS
      ,MEANSTYPE
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,FINSOURCE
      ,FINTYPE
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS_CORR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDREF
      , :new.BUDSOURCE
      , :new.BUDDEST
      , :new.DAT
      , :new.SUMMA
      , :new.ACC
      , :new.FLAG
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCTYPE
      , :new.KD
      , :new.SUBKD
      , :new.GOSNI
      , :new.FACIALACC_CLS
      , :new.MEANSTYPE
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ADMISSION
  AFTER DELETE
  ON ADMISSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ADMISSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_AGREEMENTSTEPS
  AFTER INSERT
  ON AGREEMENTSTEPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_AGREEMENTSTEPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_AGREEMENTSTEPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ANUMBER
      ,BEGINSTEPDATE
      ,ENDSTEPDATE
      ,SUMMA
      ,NOTE
      ,ACCEPTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,CLOSEDOC
      ,STEPSUMMA
      ,STEPFINSUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,RECORDINDEX
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ANUMBER
      , :new.BEGINSTEPDATE
      , :new.ENDSTEPDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.ACCEPTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.CLOSEDOC
      , :new.STEPSUMMA
      , :new.STEPFINSUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RECORDINDEX
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_AGREEMENTSTEPS
  AFTER UPDATE
  ON AGREEMENTSTEPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_AGREEMENTSTEPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_AGREEMENTSTEPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_AGREEMENTSTEPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ANUMBER
      ,BEGINSTEPDATE
      ,ENDSTEPDATE
      ,SUMMA
      ,NOTE
      ,ACCEPTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,CLOSEDOC
      ,STEPSUMMA
      ,STEPFINSUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,RECORDINDEX
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ANUMBER
      , :new.BEGINSTEPDATE
      , :new.ENDSTEPDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.ACCEPTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.CLOSEDOC
      , :new.STEPSUMMA
      , :new.STEPFINSUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RECORDINDEX
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_AGREEMENTSTEPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_AGREEMENTSTEPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ANUMBER
      ,BEGINSTEPDATE
      ,ENDSTEPDATE
      ,SUMMA
      ,NOTE
      ,ACCEPTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,CLOSEDOC
      ,STEPSUMMA
      ,STEPFINSUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,RECORDINDEX
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ANUMBER
      , :new.BEGINSTEPDATE
      , :new.ENDSTEPDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.ACCEPTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.CLOSEDOC
      , :new.STEPSUMMA
      , :new.STEPFINSUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RECORDINDEX
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_AGREEMENTSTEPS
  AFTER DELETE
  ON AGREEMENTSTEPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_AGREEMENTSTEPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ALLOWANCEDETAIL
  AFTER INSERT
  ON ALLOWANCEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ALLOWANCEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ALLOWANCEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NPACODE
      ,NPANUMBER
      ,NPADATE
      ,NPANAME
      ,NPACOMMENCEMENTDATE
      ,NPADURATION
      ,PROGINDEX
      ,CLSTYPE
      ,FUNDSSOURCE
      ,KD
      ,KVSR
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,MEANSTYPE
      ,FACT
      ,NOTE
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,RVERSION
      ,LINENUMBER
      ,PARENTID
      ,OPERATION
      ,NPADESCRIPTION
      ,BEGINDATE
      ,ENDDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NPACODE
      , :new.NPANUMBER
      , :new.NPADATE
      , :new.NPANAME
      , :new.NPACOMMENCEMENTDATE
      , :new.NPADURATION
      , :new.PROGINDEX
      , :new.CLSTYPE
      , :new.FUNDSSOURCE
      , :new.KD
      , :new.KVSR
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.MEANSTYPE
      , :new.FACT
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.RVERSION
      , :new.LINENUMBER
      , :new.PARENTID
      , :new.OPERATION
      , :new.NPADESCRIPTION
      , :new.BEGINDATE
      , :new.ENDDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ALLOWANCEDETAIL
  AFTER UPDATE
  ON ALLOWANCEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ALLOWANCEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ALLOWANCEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ALLOWANCEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NPACODE
      ,NPANUMBER
      ,NPADATE
      ,NPANAME
      ,NPACOMMENCEMENTDATE
      ,NPADURATION
      ,PROGINDEX
      ,CLSTYPE
      ,FUNDSSOURCE
      ,KD
      ,KVSR
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,MEANSTYPE
      ,FACT
      ,NOTE
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,RVERSION
      ,LINENUMBER
      ,PARENTID
      ,OPERATION
      ,NPADESCRIPTION
      ,BEGINDATE
      ,ENDDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NPACODE
      , :new.NPANUMBER
      , :new.NPADATE
      , :new.NPANAME
      , :new.NPACOMMENCEMENTDATE
      , :new.NPADURATION
      , :new.PROGINDEX
      , :new.CLSTYPE
      , :new.FUNDSSOURCE
      , :new.KD
      , :new.KVSR
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.MEANSTYPE
      , :new.FACT
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.RVERSION
      , :new.LINENUMBER
      , :new.PARENTID
      , :new.OPERATION
      , :new.NPADESCRIPTION
      , :new.BEGINDATE
      , :new.ENDDATE
    );
  else 
    update A_ALLOWANCEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ALLOWANCEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NPACODE
      ,NPANUMBER
      ,NPADATE
      ,NPANAME
      ,NPACOMMENCEMENTDATE
      ,NPADURATION
      ,PROGINDEX
      ,CLSTYPE
      ,FUNDSSOURCE
      ,KD
      ,KVSR
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,MEANSTYPE
      ,FACT
      ,NOTE
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,RVERSION
      ,LINENUMBER
      ,PARENTID
      ,OPERATION
      ,NPADESCRIPTION
      ,BEGINDATE
      ,ENDDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NPACODE
      , :new.NPANUMBER
      , :new.NPADATE
      , :new.NPANAME
      , :new.NPACOMMENCEMENTDATE
      , :new.NPADURATION
      , :new.PROGINDEX
      , :new.CLSTYPE
      , :new.FUNDSSOURCE
      , :new.KD
      , :new.KVSR
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.MEANSTYPE
      , :new.FACT
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.RVERSION
      , :new.LINENUMBER
      , :new.PARENTID
      , :new.OPERATION
      , :new.NPADESCRIPTION
      , :new.BEGINDATE
      , :new.ENDDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ALLOWANCEDETAIL
  AFTER DELETE
  ON ALLOWANCEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ALLOWANCEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ANALYTICALGROUPIFS
  AFTER INSERT
  ON ANALYTICALGROUPIFS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ANALYTICALGROUPIFS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ANALYTICALGROUPIFS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ANALYTICALGROUPIFS
  AFTER UPDATE
  ON ANALYTICALGROUPIFS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ANALYTICALGROUPIFS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ANALYTICALGROUPIFS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ANALYTICALGROUPIFS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
  else 
    update A_ANALYTICALGROUPIFS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ANALYTICALGROUPIFS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ANALYTICALGROUPIFS
  AFTER DELETE
  ON ANALYTICALGROUPIFS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ANALYTICALGROUPIFS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ANALYTICALGROUPKD
  AFTER INSERT
  ON ANALYTICALGROUPKD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ANALYTICALGROUPKD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ANALYTICALGROUPKD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ANALYTICALGROUPKD
  AFTER UPDATE
  ON ANALYTICALGROUPKD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ANALYTICALGROUPKD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ANALYTICALGROUPKD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ANALYTICALGROUPKD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
  else 
    update A_ANALYTICALGROUPKD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ANALYTICALGROUPKD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ANALYTICALGROUPKD
  AFTER DELETE
  ON ANALYTICALGROUPKD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ANALYTICALGROUPKD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ARCHIVEDOCPARAMS
  AFTER INSERT
  ON ARCHIVEDOCPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ARCHIVEDOCPARAMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ARCHIVEDOCPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NAME
      ,STORAGENAME
      ,NOTE
      ,PARAMTYPE
      ,PARAMSIZE
      ,CLSTYPE
      ,GROUPNAME
      ,PARAMORDER
      ,HINT
      ,PICKLIST
      ,REQUIREDATTR
      ,KEYATTR
      ,READONLYATTR
      ,HIDDENATTR
      ,FIXEDATTR
      ,CLOSEDATTR
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,VALUEATTR
      ,MAPPINGATTR
      ,BANMLTATTR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NAME
      , :new.STORAGENAME
      , :new.NOTE
      , :new.PARAMTYPE
      , :new.PARAMSIZE
      , :new.CLSTYPE
      , :new.GROUPNAME
      , :new.PARAMORDER
      , :new.HINT
      , :new.PICKLIST
      , :new.REQUIREDATTR
      , :new.KEYATTR
      , :new.READONLYATTR
      , :new.HIDDENATTR
      , :new.FIXEDATTR
      , :new.CLOSEDATTR
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.VALUEATTR
      , :new.MAPPINGATTR
      , :new.BANMLTATTR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ARCHIVEDOCPARAMS
  AFTER UPDATE
  ON ARCHIVEDOCPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ARCHIVEDOCPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ARCHIVEDOCPARAMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ARCHIVEDOCPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NAME
      ,STORAGENAME
      ,NOTE
      ,PARAMTYPE
      ,PARAMSIZE
      ,CLSTYPE
      ,GROUPNAME
      ,PARAMORDER
      ,HINT
      ,PICKLIST
      ,REQUIREDATTR
      ,KEYATTR
      ,READONLYATTR
      ,HIDDENATTR
      ,FIXEDATTR
      ,CLOSEDATTR
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,VALUEATTR
      ,MAPPINGATTR
      ,BANMLTATTR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NAME
      , :new.STORAGENAME
      , :new.NOTE
      , :new.PARAMTYPE
      , :new.PARAMSIZE
      , :new.CLSTYPE
      , :new.GROUPNAME
      , :new.PARAMORDER
      , :new.HINT
      , :new.PICKLIST
      , :new.REQUIREDATTR
      , :new.KEYATTR
      , :new.READONLYATTR
      , :new.HIDDENATTR
      , :new.FIXEDATTR
      , :new.CLOSEDATTR
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.VALUEATTR
      , :new.MAPPINGATTR
      , :new.BANMLTATTR
    );
  else 
    update A_ARCHIVEDOCPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ARCHIVEDOCPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NAME
      ,STORAGENAME
      ,NOTE
      ,PARAMTYPE
      ,PARAMSIZE
      ,CLSTYPE
      ,GROUPNAME
      ,PARAMORDER
      ,HINT
      ,PICKLIST
      ,REQUIREDATTR
      ,KEYATTR
      ,READONLYATTR
      ,HIDDENATTR
      ,FIXEDATTR
      ,CLOSEDATTR
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,VALUEATTR
      ,MAPPINGATTR
      ,BANMLTATTR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NAME
      , :new.STORAGENAME
      , :new.NOTE
      , :new.PARAMTYPE
      , :new.PARAMSIZE
      , :new.CLSTYPE
      , :new.GROUPNAME
      , :new.PARAMORDER
      , :new.HINT
      , :new.PICKLIST
      , :new.REQUIREDATTR
      , :new.KEYATTR
      , :new.READONLYATTR
      , :new.HIDDENATTR
      , :new.FIXEDATTR
      , :new.CLOSEDATTR
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.VALUEATTR
      , :new.MAPPINGATTR
      , :new.BANMLTATTR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ARCHIVEDOCPARAMS
  AFTER DELETE
  ON ARCHIVEDOCPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ARCHIVEDOCPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ARCHIVEDOCTYPE
  AFTER INSERT
  ON ARCHIVEDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ARCHIVEDOCTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ARCHIVEDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,TEMPLATECODE
      ,TEMPLATETYPE
      ,PERIODTYPE
      ,SECTIONTYPE
      ,CONSTRAINTSCRIPTNAME
      ,CREATINGSCRIPTNAME
      ,BEGINDATE
      ,ENDDATE
      ,SIGNSCHEME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ENABLEDIMPORTKINDS
      ,LIMITPARAMS
      ,DYNSETNAME
      ,STORETOLINK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.TEMPLATECODE
      , :new.TEMPLATETYPE
      , :new.PERIODTYPE
      , :new.SECTIONTYPE
      , :new.CONSTRAINTSCRIPTNAME
      , :new.CREATINGSCRIPTNAME
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.SIGNSCHEME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ENABLEDIMPORTKINDS
      , :new.LIMITPARAMS
      , :new.DYNSETNAME
      , :new.STORETOLINK
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ARCHIVEDOCTYPE
  AFTER UPDATE
  ON ARCHIVEDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ARCHIVEDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ARCHIVEDOCTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ARCHIVEDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,TEMPLATECODE
      ,TEMPLATETYPE
      ,PERIODTYPE
      ,SECTIONTYPE
      ,CONSTRAINTSCRIPTNAME
      ,CREATINGSCRIPTNAME
      ,BEGINDATE
      ,ENDDATE
      ,SIGNSCHEME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ENABLEDIMPORTKINDS
      ,LIMITPARAMS
      ,DYNSETNAME
      ,STORETOLINK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.TEMPLATECODE
      , :new.TEMPLATETYPE
      , :new.PERIODTYPE
      , :new.SECTIONTYPE
      , :new.CONSTRAINTSCRIPTNAME
      , :new.CREATINGSCRIPTNAME
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.SIGNSCHEME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ENABLEDIMPORTKINDS
      , :new.LIMITPARAMS
      , :new.DYNSETNAME
      , :new.STORETOLINK
    );
  else 
    update A_ARCHIVEDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ARCHIVEDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,TEMPLATECODE
      ,TEMPLATETYPE
      ,PERIODTYPE
      ,SECTIONTYPE
      ,CONSTRAINTSCRIPTNAME
      ,CREATINGSCRIPTNAME
      ,BEGINDATE
      ,ENDDATE
      ,SIGNSCHEME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ENABLEDIMPORTKINDS
      ,LIMITPARAMS
      ,DYNSETNAME
      ,STORETOLINK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.TEMPLATECODE
      , :new.TEMPLATETYPE
      , :new.PERIODTYPE
      , :new.SECTIONTYPE
      , :new.CONSTRAINTSCRIPTNAME
      , :new.CREATINGSCRIPTNAME
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.SIGNSCHEME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ENABLEDIMPORTKINDS
      , :new.LIMITPARAMS
      , :new.DYNSETNAME
      , :new.STORETOLINK
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ARCHIVEDOCTYPE
  AFTER DELETE
  ON ARCHIVEDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ARCHIVEDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ARCHIVEOPLOG
  AFTER INSERT
  ON ARCHIVEOPLOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ARCHIVEOPLOG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ARCHIVEOPLOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATAPACKETREF
      ,DOCSTATEREF
      ,OPTYPE
      ,CREATEDATE
      ,CREATERUSER
      ,CREATERINFO
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATAPACKETREF
      , :new.DOCSTATEREF
      , :new.OPTYPE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.CREATERINFO
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ARCHIVEOPLOG
  AFTER UPDATE
  ON ARCHIVEOPLOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ARCHIVEOPLOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ARCHIVEOPLOG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ARCHIVEOPLOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATAPACKETREF
      ,DOCSTATEREF
      ,OPTYPE
      ,CREATEDATE
      ,CREATERUSER
      ,CREATERINFO
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATAPACKETREF
      , :new.DOCSTATEREF
      , :new.OPTYPE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.CREATERINFO
    );
  else 
    update A_ARCHIVEOPLOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ARCHIVEOPLOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATAPACKETREF
      ,DOCSTATEREF
      ,OPTYPE
      ,CREATEDATE
      ,CREATERUSER
      ,CREATERINFO
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATAPACKETREF
      , :new.DOCSTATEREF
      , :new.OPTYPE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.CREATERINFO
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ARCHIVEOPLOG
  AFTER DELETE
  ON ARCHIVEOPLOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ARCHIVEOPLOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ASSIGNMENTKIND
  AFTER INSERT
  ON ASSIGNMENTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ASSIGNMENTKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ASSIGNMENTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,UNRESTRICTED
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,MARK
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.UNRESTRICTED
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.MARK
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ASSIGNMENTKIND
  AFTER UPDATE
  ON ASSIGNMENTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ASSIGNMENTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ASSIGNMENTKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ASSIGNMENTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,UNRESTRICTED
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,MARK
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.UNRESTRICTED
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.MARK
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_ASSIGNMENTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ASSIGNMENTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,UNRESTRICTED
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,MARK
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.UNRESTRICTED
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.MARK
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ASSIGNMENTKIND
  AFTER DELETE
  ON ASSIGNMENTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ASSIGNMENTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ASSIGNMENTSOURCE
  AFTER INSERT
  ON ASSIGNMENTSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ASSIGNMENTSOURCE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ASSIGNMENTSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,MARK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.MARK
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ASSIGNMENTSOURCE
  AFTER UPDATE
  ON ASSIGNMENTSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ASSIGNMENTSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ASSIGNMENTSOURCE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ASSIGNMENTSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,MARK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.MARK
    );
  else 
    update A_ASSIGNMENTSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ASSIGNMENTSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,MARK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.MARK
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ASSIGNMENTSOURCE
  AFTER DELETE
  ON ASSIGNMENTSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ASSIGNMENTSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_AUTOSANCTIONDATA
  AFTER INSERT
  ON AUTOSANCTIONDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_AUTOSANCTIONDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_AUTOSANCTIONDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CODE
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,KD
      ,IFS
      ,TAXNOTE
      ,AUTOSANCTION
      ,ACC
      ,NOTE
      ,CLSTYPE
      ,BUDGETREF
      ,DOCTYPE
      ,STARTDATE
      ,DELETEDATE
      ,PROMISE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CODE
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.KD
      , :new.IFS
      , :new.TAXNOTE
      , :new.AUTOSANCTION
      , :new.ACC
      , :new.NOTE
      , :new.CLSTYPE
      , :new.BUDGETREF
      , :new.DOCTYPE
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.PROMISE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_AUTOSANCTIONDATA
  AFTER UPDATE
  ON AUTOSANCTIONDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_AUTOSANCTIONDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_AUTOSANCTIONDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_AUTOSANCTIONDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CODE
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,KD
      ,IFS
      ,TAXNOTE
      ,AUTOSANCTION
      ,ACC
      ,NOTE
      ,CLSTYPE
      ,BUDGETREF
      ,DOCTYPE
      ,STARTDATE
      ,DELETEDATE
      ,PROMISE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CODE
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.KD
      , :new.IFS
      , :new.TAXNOTE
      , :new.AUTOSANCTION
      , :new.ACC
      , :new.NOTE
      , :new.CLSTYPE
      , :new.BUDGETREF
      , :new.DOCTYPE
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.PROMISE
    );
  else 
    update A_AUTOSANCTIONDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_AUTOSANCTIONDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CODE
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,KD
      ,IFS
      ,TAXNOTE
      ,AUTOSANCTION
      ,ACC
      ,NOTE
      ,CLSTYPE
      ,BUDGETREF
      ,DOCTYPE
      ,STARTDATE
      ,DELETEDATE
      ,PROMISE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CODE
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.KD
      , :new.IFS
      , :new.TAXNOTE
      , :new.AUTOSANCTION
      , :new.ACC
      , :new.NOTE
      , :new.CLSTYPE
      , :new.BUDGETREF
      , :new.DOCTYPE
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.PROMISE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_AUTOSANCTIONDATA
  AFTER DELETE
  ON AUTOSANCTIONDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_AUTOSANCTIONDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BALANCECLS
  AFTER INSERT
  ON BALANCECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BALANCECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BALANCECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHORTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHORTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BALANCECLS
  AFTER UPDATE
  ON BALANCECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BALANCECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BALANCECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BALANCECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHORTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHORTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_BALANCECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BALANCECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHORTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHORTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BALANCECLS
  AFTER DELETE
  ON BALANCECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BALANCECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_CLSREPLACEMENT
  AFTER INSERT
  ON BANKEXCH_CLSREPLACEMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_CLSREPLACEMENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_CLSREPLACEMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEMFO
      ,SOURCEKPP
      ,SOURCEACC
      ,SOURCENOTE
      ,SOURCEKD
      ,DESTNOTE
      ,DESTKD
      ,DESTSUBKD
      ,DESTREGION
      ,DESTGOSNI
      ,DESTFACIALACC_CLS
      ,DESTMEANSTYPE
      ,DESTDOCTYPE
      ,DESTFINTYPE
      ,BUHPAYMENTCLS
      ,DFACCOUNT
      ,PROCDOCCLASS
      ,SOURCEINN
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEMFO
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.SOURCENOTE
      , :new.SOURCEKD
      , :new.DESTNOTE
      , :new.DESTKD
      , :new.DESTSUBKD
      , :new.DESTREGION
      , :new.DESTGOSNI
      , :new.DESTFACIALACC_CLS
      , :new.DESTMEANSTYPE
      , :new.DESTDOCTYPE
      , :new.DESTFINTYPE
      , :new.BUHPAYMENTCLS
      , :new.DFACCOUNT
      , :new.PROCDOCCLASS
      , :new.SOURCEINN
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_CLSREPLACEMENT
  AFTER UPDATE
  ON BANKEXCH_CLSREPLACEMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_CLSREPLACEMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_CLSREPLACEMENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_CLSREPLACEMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEMFO
      ,SOURCEKPP
      ,SOURCEACC
      ,SOURCENOTE
      ,SOURCEKD
      ,DESTNOTE
      ,DESTKD
      ,DESTSUBKD
      ,DESTREGION
      ,DESTGOSNI
      ,DESTFACIALACC_CLS
      ,DESTMEANSTYPE
      ,DESTDOCTYPE
      ,DESTFINTYPE
      ,BUHPAYMENTCLS
      ,DFACCOUNT
      ,PROCDOCCLASS
      ,SOURCEINN
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEMFO
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.SOURCENOTE
      , :new.SOURCEKD
      , :new.DESTNOTE
      , :new.DESTKD
      , :new.DESTSUBKD
      , :new.DESTREGION
      , :new.DESTGOSNI
      , :new.DESTFACIALACC_CLS
      , :new.DESTMEANSTYPE
      , :new.DESTDOCTYPE
      , :new.DESTFINTYPE
      , :new.BUHPAYMENTCLS
      , :new.DFACCOUNT
      , :new.PROCDOCCLASS
      , :new.SOURCEINN
    );
  else 
    update A_BANKEXCH_CLSREPLACEMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_CLSREPLACEMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEMFO
      ,SOURCEKPP
      ,SOURCEACC
      ,SOURCENOTE
      ,SOURCEKD
      ,DESTNOTE
      ,DESTKD
      ,DESTSUBKD
      ,DESTREGION
      ,DESTGOSNI
      ,DESTFACIALACC_CLS
      ,DESTMEANSTYPE
      ,DESTDOCTYPE
      ,DESTFINTYPE
      ,BUHPAYMENTCLS
      ,DFACCOUNT
      ,PROCDOCCLASS
      ,SOURCEINN
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEMFO
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.SOURCENOTE
      , :new.SOURCEKD
      , :new.DESTNOTE
      , :new.DESTKD
      , :new.DESTSUBKD
      , :new.DESTREGION
      , :new.DESTGOSNI
      , :new.DESTFACIALACC_CLS
      , :new.DESTMEANSTYPE
      , :new.DESTDOCTYPE
      , :new.DESTFINTYPE
      , :new.BUHPAYMENTCLS
      , :new.DFACCOUNT
      , :new.PROCDOCCLASS
      , :new.SOURCEINN
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_CLSREPLACEMENT
  AFTER DELETE
  ON BANKEXCH_CLSREPLACEMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_CLSREPLACEMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_CONFIRM
  AFTER INSERT
  ON BANKEXCH_CONFIRM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_CONFIRM
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_CONFIRM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,ND
      ,DAV
      ,PRNUM
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,MF
      ,LSKOR
      ,SU
      ,KRKB
      ,KR
      ,SS
      ,EXTENSION
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.ND
      , :new.DAV
      , :new.PRNUM
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.MF
      , :new.LSKOR
      , :new.SU
      , :new.KRKB
      , :new.KR
      , :new.SS
      , :new.EXTENSION
      , :new.SENDER
      , :new.CODEFORMAT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_CONFIRM
  AFTER UPDATE
  ON BANKEXCH_CONFIRM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_CONFIRM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_CONFIRM
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_CONFIRM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,ND
      ,DAV
      ,PRNUM
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,MF
      ,LSKOR
      ,SU
      ,KRKB
      ,KR
      ,SS
      ,EXTENSION
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.ND
      , :new.DAV
      , :new.PRNUM
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.MF
      , :new.LSKOR
      , :new.SU
      , :new.KRKB
      , :new.KR
      , :new.SS
      , :new.EXTENSION
      , :new.SENDER
      , :new.CODEFORMAT
    );
  else 
    update A_BANKEXCH_CONFIRM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_CONFIRM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,ND
      ,DAV
      ,PRNUM
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,MF
      ,LSKOR
      ,SU
      ,KRKB
      ,KR
      ,SS
      ,EXTENSION
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.ND
      , :new.DAV
      , :new.PRNUM
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.MF
      , :new.LSKOR
      , :new.SU
      , :new.KRKB
      , :new.KR
      , :new.SS
      , :new.EXTENSION
      , :new.SENDER
      , :new.CODEFORMAT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_CONFIRM
  AFTER DELETE
  ON BANKEXCH_CONFIRM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_CONFIRM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_KO_SALDO
  AFTER INSERT
  ON BANKEXCH_KO_SALDO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_KO_SALDO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_KO_SALDO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LS
      ,DT
      ,KT
      ,IXSP
      ,IXSA
      ,VXSP
      ,VXSA
      ,DF
      ,T_CLOCK
      ,SENDER
      ,D_LAST
      ,CODEFORMAT
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,INREST
      ,SUBSIDYDAY
      ,OTHERSUMDAY
      ,PAYMENTSUM
      ,UNKNOWNSUM
      ,REESTRSUM
      ,OUTREST
      ,INACCREST
      ,OUTACCREST
      ,INACC
      ,OUTACC
      ,ABSTRACTKIND
      ,INQUIRYSESSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LS
      , :new.DT
      , :new.KT
      , :new.IXSP
      , :new.IXSA
      , :new.VXSP
      , :new.VXSA
      , :new.DF
      , :new.T_CLOCK
      , :new.SENDER
      , :new.D_LAST
      , :new.CODEFORMAT
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.INREST
      , :new.SUBSIDYDAY
      , :new.OTHERSUMDAY
      , :new.PAYMENTSUM
      , :new.UNKNOWNSUM
      , :new.REESTRSUM
      , :new.OUTREST
      , :new.INACCREST
      , :new.OUTACCREST
      , :new.INACC
      , :new.OUTACC
      , :new.ABSTRACTKIND
      , :new.INQUIRYSESSION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_KO_SALDO
  AFTER UPDATE
  ON BANKEXCH_KO_SALDO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_KO_SALDO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_KO_SALDO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_KO_SALDO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LS
      ,DT
      ,KT
      ,IXSP
      ,IXSA
      ,VXSP
      ,VXSA
      ,DF
      ,T_CLOCK
      ,SENDER
      ,D_LAST
      ,CODEFORMAT
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,INREST
      ,SUBSIDYDAY
      ,OTHERSUMDAY
      ,PAYMENTSUM
      ,UNKNOWNSUM
      ,REESTRSUM
      ,OUTREST
      ,INACCREST
      ,OUTACCREST
      ,INACC
      ,OUTACC
      ,ABSTRACTKIND
      ,INQUIRYSESSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LS
      , :new.DT
      , :new.KT
      , :new.IXSP
      , :new.IXSA
      , :new.VXSP
      , :new.VXSA
      , :new.DF
      , :new.T_CLOCK
      , :new.SENDER
      , :new.D_LAST
      , :new.CODEFORMAT
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.INREST
      , :new.SUBSIDYDAY
      , :new.OTHERSUMDAY
      , :new.PAYMENTSUM
      , :new.UNKNOWNSUM
      , :new.REESTRSUM
      , :new.OUTREST
      , :new.INACCREST
      , :new.OUTACCREST
      , :new.INACC
      , :new.OUTACC
      , :new.ABSTRACTKIND
      , :new.INQUIRYSESSION
    );
  else 
    update A_BANKEXCH_KO_SALDO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_KO_SALDO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LS
      ,DT
      ,KT
      ,IXSP
      ,IXSA
      ,VXSP
      ,VXSA
      ,DF
      ,T_CLOCK
      ,SENDER
      ,D_LAST
      ,CODEFORMAT
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,INREST
      ,SUBSIDYDAY
      ,OTHERSUMDAY
      ,PAYMENTSUM
      ,UNKNOWNSUM
      ,REESTRSUM
      ,OUTREST
      ,INACCREST
      ,OUTACCREST
      ,INACC
      ,OUTACC
      ,ABSTRACTKIND
      ,INQUIRYSESSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LS
      , :new.DT
      , :new.KT
      , :new.IXSP
      , :new.IXSA
      , :new.VXSP
      , :new.VXSA
      , :new.DF
      , :new.T_CLOCK
      , :new.SENDER
      , :new.D_LAST
      , :new.CODEFORMAT
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.INREST
      , :new.SUBSIDYDAY
      , :new.OTHERSUMDAY
      , :new.PAYMENTSUM
      , :new.UNKNOWNSUM
      , :new.REESTRSUM
      , :new.OUTREST
      , :new.INACCREST
      , :new.OUTACCREST
      , :new.INACC
      , :new.OUTACC
      , :new.ABSTRACTKIND
      , :new.INQUIRYSESSION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_KO_SALDO
  AFTER DELETE
  ON BANKEXCH_KO_SALDO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_KO_SALDO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_LS_KB
  AFTER INSERT
  ON BANKEXCH_LS_KB
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_LS_KB
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_LS_KB (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,AUTOPROCESSING
      ,PROCESSING
      ,PROCNOTE
      ,SU
      ,ND
      ,MF
      ,MFKB
      ,LSK
      ,LSD
      ,KRSKB
      ,DK
      ,NA
      ,VO
      ,ELNUM
      ,DVV
      ,INNMFKB
      ,INNMF
      ,MFKBFIL
      ,MFFIL
      ,LSKL
      ,LSKOR
      ,PFA
      ,T_EVENT
      ,SENDER
      ,CODEFORMAT
      ,PD_REF
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,ABSTRACTKIND
      ,INQUIRYSESSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.AUTOPROCESSING
      , :new.PROCESSING
      , :new.PROCNOTE
      , :new.SU
      , :new.ND
      , :new.MF
      , :new.MFKB
      , :new.LSK
      , :new.LSD
      , :new.KRSKB
      , :new.DK
      , :new.NA
      , :new.VO
      , :new.ELNUM
      , :new.DVV
      , :new.INNMFKB
      , :new.INNMF
      , :new.MFKBFIL
      , :new.MFFIL
      , :new.LSKL
      , :new.LSKOR
      , :new.PFA
      , :new.T_EVENT
      , :new.SENDER
      , :new.CODEFORMAT
      , :new.PD_REF
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.ABSTRACTKIND
      , :new.INQUIRYSESSION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_LS_KB
  AFTER UPDATE
  ON BANKEXCH_LS_KB
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_LS_KB
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_LS_KB
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_LS_KB (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,AUTOPROCESSING
      ,PROCESSING
      ,PROCNOTE
      ,SU
      ,ND
      ,MF
      ,MFKB
      ,LSK
      ,LSD
      ,KRSKB
      ,DK
      ,NA
      ,VO
      ,ELNUM
      ,DVV
      ,INNMFKB
      ,INNMF
      ,MFKBFIL
      ,MFFIL
      ,LSKL
      ,LSKOR
      ,PFA
      ,T_EVENT
      ,SENDER
      ,CODEFORMAT
      ,PD_REF
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,ABSTRACTKIND
      ,INQUIRYSESSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.AUTOPROCESSING
      , :new.PROCESSING
      , :new.PROCNOTE
      , :new.SU
      , :new.ND
      , :new.MF
      , :new.MFKB
      , :new.LSK
      , :new.LSD
      , :new.KRSKB
      , :new.DK
      , :new.NA
      , :new.VO
      , :new.ELNUM
      , :new.DVV
      , :new.INNMFKB
      , :new.INNMF
      , :new.MFKBFIL
      , :new.MFFIL
      , :new.LSKL
      , :new.LSKOR
      , :new.PFA
      , :new.T_EVENT
      , :new.SENDER
      , :new.CODEFORMAT
      , :new.PD_REF
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.ABSTRACTKIND
      , :new.INQUIRYSESSION
    );
  else 
    update A_BANKEXCH_LS_KB
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_LS_KB (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,AUTOPROCESSING
      ,PROCESSING
      ,PROCNOTE
      ,SU
      ,ND
      ,MF
      ,MFKB
      ,LSK
      ,LSD
      ,KRSKB
      ,DK
      ,NA
      ,VO
      ,ELNUM
      ,DVV
      ,INNMFKB
      ,INNMF
      ,MFKBFIL
      ,MFFIL
      ,LSKL
      ,LSKOR
      ,PFA
      ,T_EVENT
      ,SENDER
      ,CODEFORMAT
      ,PD_REF
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,ABSTRACTKIND
      ,INQUIRYSESSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.AUTOPROCESSING
      , :new.PROCESSING
      , :new.PROCNOTE
      , :new.SU
      , :new.ND
      , :new.MF
      , :new.MFKB
      , :new.LSK
      , :new.LSD
      , :new.KRSKB
      , :new.DK
      , :new.NA
      , :new.VO
      , :new.ELNUM
      , :new.DVV
      , :new.INNMFKB
      , :new.INNMF
      , :new.MFKBFIL
      , :new.MFFIL
      , :new.LSKL
      , :new.LSKOR
      , :new.PFA
      , :new.T_EVENT
      , :new.SENDER
      , :new.CODEFORMAT
      , :new.PD_REF
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.ABSTRACTKIND
      , :new.INQUIRYSESSION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_LS_KB
  AFTER DELETE
  ON BANKEXCH_LS_KB
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_LS_KB
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_MERDOC
  AFTER INSERT
  ON BANKEXCH_MERDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_MERDOC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_MERDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,NOTE
      ,PAYERKPP
      ,PAYERNAME
      ,KD
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,DK
      ,VO
      ,MFKB
      ,LSKL
      ,NAMKL
      ,MF
      ,LSKOR
      ,NAMKOR
      ,SU
      ,NKOR1
      ,NKOR2
      ,NKOR3
      ,NKOR4
      ,PAROL
      ,SS
      ,KRKB
      ,INNMFKB
      ,MFKBFIL
      ,KR
      ,INNMF
      ,MFFIL
      ,DFA
      ,NA
      ,T_CLOCK
      ,PR_DOC
      ,DPLAT
      ,SUB_ID
      ,ELNUMS
      ,LS_ERR
      ,SENDER
      ,APRIOR
      ,PAYKIND
      ,IMPORTDOCREF
      ,PRNUM
      ,KPPA
      ,KPPB
      ,DPPL
      ,DKART
      ,DSPL
      ,D_OTMET
      ,SSTATUS
      ,CODOKATO
      ,NALPLAT
      ,NALPER
      ,NDNAL
      ,DDNAL
      ,TYPNAL
      ,SU_OST
      ,N_CH_PL
      ,D_PL
      ,SHIFR
      ,N_PLDOK
      ,TAXNOTE
      ,CODEFORMAT
      ,PRINTED
      ,SOP
      ,NOTINCOME
      ,UFK_PRIM
      ,PROCDOCCLASS
      ,PROCUSEINFO
      ,CODBCLAS
      ,ND
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,SOURCEFILIALBANKNAME
      ,DESTFILIALBANKNAME
      ,SOURCEBANKNAME
      ,DESTBANKNAME
      ,DOCUMENTNAME
      ,SOURCEFACIALCODE
      ,DESTFACIALCODE
      ,SOURCEINN
      ,DESTINN
      ,ELNUM
      ,EXTPAYID
      ,KOD_IST
      ,DEPARTMENTCLS
      ,PROCNOTE
      ,UINCODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.NOTE
      , :new.PAYERKPP
      , :new.PAYERNAME
      , :new.KD
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.DK
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.NAMKL
      , :new.MF
      , :new.LSKOR
      , :new.NAMKOR
      , :new.SU
      , :new.NKOR1
      , :new.NKOR2
      , :new.NKOR3
      , :new.NKOR4
      , :new.PAROL
      , :new.SS
      , :new.KRKB
      , :new.INNMFKB
      , :new.MFKBFIL
      , :new.KR
      , :new.INNMF
      , :new.MFFIL
      , :new.DFA
      , :new.NA
      , :new.T_CLOCK
      , :new.PR_DOC
      , :new.DPLAT
      , :new.SUB_ID
      , :new.ELNUMS
      , :new.LS_ERR
      , :new.SENDER
      , :new.APRIOR
      , :new.PAYKIND
      , :new.IMPORTDOCREF
      , :new.PRNUM
      , :new.KPPA
      , :new.KPPB
      , :new.DPPL
      , :new.DKART
      , :new.DSPL
      , :new.D_OTMET
      , :new.SSTATUS
      , :new.CODOKATO
      , :new.NALPLAT
      , :new.NALPER
      , :new.NDNAL
      , :new.DDNAL
      , :new.TYPNAL
      , :new.SU_OST
      , :new.N_CH_PL
      , :new.D_PL
      , :new.SHIFR
      , :new.N_PLDOK
      , :new.TAXNOTE
      , :new.CODEFORMAT
      , :new.PRINTED
      , :new.SOP
      , :new.NOTINCOME
      , :new.UFK_PRIM
      , :new.PROCDOCCLASS
      , :new.PROCUSEINFO
      , :new.CODBCLAS
      , :new.ND
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.SOURCEFILIALBANKNAME
      , :new.DESTFILIALBANKNAME
      , :new.SOURCEBANKNAME
      , :new.DESTBANKNAME
      , :new.DOCUMENTNAME
      , :new.SOURCEFACIALCODE
      , :new.DESTFACIALCODE
      , :new.SOURCEINN
      , :new.DESTINN
      , :new.ELNUM
      , :new.EXTPAYID
      , :new.KOD_IST
      , :new.DEPARTMENTCLS
      , :new.PROCNOTE
      , :new.UINCODE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_MERDOC
  AFTER UPDATE
  ON BANKEXCH_MERDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_MERDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_MERDOC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_MERDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,NOTE
      ,PAYERKPP
      ,PAYERNAME
      ,KD
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,DK
      ,VO
      ,MFKB
      ,LSKL
      ,NAMKL
      ,MF
      ,LSKOR
      ,NAMKOR
      ,SU
      ,NKOR1
      ,NKOR2
      ,NKOR3
      ,NKOR4
      ,PAROL
      ,SS
      ,KRKB
      ,INNMFKB
      ,MFKBFIL
      ,KR
      ,INNMF
      ,MFFIL
      ,DFA
      ,NA
      ,T_CLOCK
      ,PR_DOC
      ,DPLAT
      ,SUB_ID
      ,ELNUMS
      ,LS_ERR
      ,SENDER
      ,APRIOR
      ,PAYKIND
      ,IMPORTDOCREF
      ,PRNUM
      ,KPPA
      ,KPPB
      ,DPPL
      ,DKART
      ,DSPL
      ,D_OTMET
      ,SSTATUS
      ,CODOKATO
      ,NALPLAT
      ,NALPER
      ,NDNAL
      ,DDNAL
      ,TYPNAL
      ,SU_OST
      ,N_CH_PL
      ,D_PL
      ,SHIFR
      ,N_PLDOK
      ,TAXNOTE
      ,CODEFORMAT
      ,PRINTED
      ,SOP
      ,NOTINCOME
      ,UFK_PRIM
      ,PROCDOCCLASS
      ,PROCUSEINFO
      ,CODBCLAS
      ,ND
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,SOURCEFILIALBANKNAME
      ,DESTFILIALBANKNAME
      ,SOURCEBANKNAME
      ,DESTBANKNAME
      ,DOCUMENTNAME
      ,SOURCEFACIALCODE
      ,DESTFACIALCODE
      ,SOURCEINN
      ,DESTINN
      ,ELNUM
      ,EXTPAYID
      ,KOD_IST
      ,DEPARTMENTCLS
      ,PROCNOTE
      ,UINCODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.NOTE
      , :new.PAYERKPP
      , :new.PAYERNAME
      , :new.KD
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.DK
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.NAMKL
      , :new.MF
      , :new.LSKOR
      , :new.NAMKOR
      , :new.SU
      , :new.NKOR1
      , :new.NKOR2
      , :new.NKOR3
      , :new.NKOR4
      , :new.PAROL
      , :new.SS
      , :new.KRKB
      , :new.INNMFKB
      , :new.MFKBFIL
      , :new.KR
      , :new.INNMF
      , :new.MFFIL
      , :new.DFA
      , :new.NA
      , :new.T_CLOCK
      , :new.PR_DOC
      , :new.DPLAT
      , :new.SUB_ID
      , :new.ELNUMS
      , :new.LS_ERR
      , :new.SENDER
      , :new.APRIOR
      , :new.PAYKIND
      , :new.IMPORTDOCREF
      , :new.PRNUM
      , :new.KPPA
      , :new.KPPB
      , :new.DPPL
      , :new.DKART
      , :new.DSPL
      , :new.D_OTMET
      , :new.SSTATUS
      , :new.CODOKATO
      , :new.NALPLAT
      , :new.NALPER
      , :new.NDNAL
      , :new.DDNAL
      , :new.TYPNAL
      , :new.SU_OST
      , :new.N_CH_PL
      , :new.D_PL
      , :new.SHIFR
      , :new.N_PLDOK
      , :new.TAXNOTE
      , :new.CODEFORMAT
      , :new.PRINTED
      , :new.SOP
      , :new.NOTINCOME
      , :new.UFK_PRIM
      , :new.PROCDOCCLASS
      , :new.PROCUSEINFO
      , :new.CODBCLAS
      , :new.ND
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.SOURCEFILIALBANKNAME
      , :new.DESTFILIALBANKNAME
      , :new.SOURCEBANKNAME
      , :new.DESTBANKNAME
      , :new.DOCUMENTNAME
      , :new.SOURCEFACIALCODE
      , :new.DESTFACIALCODE
      , :new.SOURCEINN
      , :new.DESTINN
      , :new.ELNUM
      , :new.EXTPAYID
      , :new.KOD_IST
      , :new.DEPARTMENTCLS
      , :new.PROCNOTE
      , :new.UINCODE
    );
  else 
    update A_BANKEXCH_MERDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_MERDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,NOTE
      ,PAYERKPP
      ,PAYERNAME
      ,KD
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,DK
      ,VO
      ,MFKB
      ,LSKL
      ,NAMKL
      ,MF
      ,LSKOR
      ,NAMKOR
      ,SU
      ,NKOR1
      ,NKOR2
      ,NKOR3
      ,NKOR4
      ,PAROL
      ,SS
      ,KRKB
      ,INNMFKB
      ,MFKBFIL
      ,KR
      ,INNMF
      ,MFFIL
      ,DFA
      ,NA
      ,T_CLOCK
      ,PR_DOC
      ,DPLAT
      ,SUB_ID
      ,ELNUMS
      ,LS_ERR
      ,SENDER
      ,APRIOR
      ,PAYKIND
      ,IMPORTDOCREF
      ,PRNUM
      ,KPPA
      ,KPPB
      ,DPPL
      ,DKART
      ,DSPL
      ,D_OTMET
      ,SSTATUS
      ,CODOKATO
      ,NALPLAT
      ,NALPER
      ,NDNAL
      ,DDNAL
      ,TYPNAL
      ,SU_OST
      ,N_CH_PL
      ,D_PL
      ,SHIFR
      ,N_PLDOK
      ,TAXNOTE
      ,CODEFORMAT
      ,PRINTED
      ,SOP
      ,NOTINCOME
      ,UFK_PRIM
      ,PROCDOCCLASS
      ,PROCUSEINFO
      ,CODBCLAS
      ,ND
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,SOURCEFILIALBANKNAME
      ,DESTFILIALBANKNAME
      ,SOURCEBANKNAME
      ,DESTBANKNAME
      ,DOCUMENTNAME
      ,SOURCEFACIALCODE
      ,DESTFACIALCODE
      ,SOURCEINN
      ,DESTINN
      ,ELNUM
      ,EXTPAYID
      ,KOD_IST
      ,DEPARTMENTCLS
      ,PROCNOTE
      ,UINCODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.NOTE
      , :new.PAYERKPP
      , :new.PAYERNAME
      , :new.KD
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.DK
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.NAMKL
      , :new.MF
      , :new.LSKOR
      , :new.NAMKOR
      , :new.SU
      , :new.NKOR1
      , :new.NKOR2
      , :new.NKOR3
      , :new.NKOR4
      , :new.PAROL
      , :new.SS
      , :new.KRKB
      , :new.INNMFKB
      , :new.MFKBFIL
      , :new.KR
      , :new.INNMF
      , :new.MFFIL
      , :new.DFA
      , :new.NA
      , :new.T_CLOCK
      , :new.PR_DOC
      , :new.DPLAT
      , :new.SUB_ID
      , :new.ELNUMS
      , :new.LS_ERR
      , :new.SENDER
      , :new.APRIOR
      , :new.PAYKIND
      , :new.IMPORTDOCREF
      , :new.PRNUM
      , :new.KPPA
      , :new.KPPB
      , :new.DPPL
      , :new.DKART
      , :new.DSPL
      , :new.D_OTMET
      , :new.SSTATUS
      , :new.CODOKATO
      , :new.NALPLAT
      , :new.NALPER
      , :new.NDNAL
      , :new.DDNAL
      , :new.TYPNAL
      , :new.SU_OST
      , :new.N_CH_PL
      , :new.D_PL
      , :new.SHIFR
      , :new.N_PLDOK
      , :new.TAXNOTE
      , :new.CODEFORMAT
      , :new.PRINTED
      , :new.SOP
      , :new.NOTINCOME
      , :new.UFK_PRIM
      , :new.PROCDOCCLASS
      , :new.PROCUSEINFO
      , :new.CODBCLAS
      , :new.ND
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.SOURCEFILIALBANKNAME
      , :new.DESTFILIALBANKNAME
      , :new.SOURCEBANKNAME
      , :new.DESTBANKNAME
      , :new.DOCUMENTNAME
      , :new.SOURCEFACIALCODE
      , :new.DESTFACIALCODE
      , :new.SOURCEINN
      , :new.DESTINN
      , :new.ELNUM
      , :new.EXTPAYID
      , :new.KOD_IST
      , :new.DEPARTMENTCLS
      , :new.PROCNOTE
      , :new.UINCODE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_MERDOC
  AFTER DELETE
  ON BANKEXCH_MERDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_MERDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_MERKWI
  AFTER INSERT
  ON BANKEXCH_MERKWI
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_MERKWI
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_MERKWI (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,MFA
      ,MFB
      ,IDA
      ,IDB
      ,SUM_
      ,COUNT_
      ,NAMPOST
      ,DW2
      ,T_CLOCK
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.MFA
      , :new.MFB
      , :new.IDA
      , :new.IDB
      , :new.SUM_
      , :new.COUNT_
      , :new.NAMPOST
      , :new.DW2
      , :new.T_CLOCK
      , :new.SENDER
      , :new.CODEFORMAT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_MERKWI
  AFTER UPDATE
  ON BANKEXCH_MERKWI
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_MERKWI
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_MERKWI
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_MERKWI (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,MFA
      ,MFB
      ,IDA
      ,IDB
      ,SUM_
      ,COUNT_
      ,NAMPOST
      ,DW2
      ,T_CLOCK
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.MFA
      , :new.MFB
      , :new.IDA
      , :new.IDB
      , :new.SUM_
      , :new.COUNT_
      , :new.NAMPOST
      , :new.DW2
      , :new.T_CLOCK
      , :new.SENDER
      , :new.CODEFORMAT
    );
  else 
    update A_BANKEXCH_MERKWI
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_MERKWI (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,MFA
      ,MFB
      ,IDA
      ,IDB
      ,SUM_
      ,COUNT_
      ,NAMPOST
      ,DW2
      ,T_CLOCK
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.MFA
      , :new.MFB
      , :new.IDA
      , :new.IDB
      , :new.SUM_
      , :new.COUNT_
      , :new.NAMPOST
      , :new.DW2
      , :new.T_CLOCK
      , :new.SENDER
      , :new.CODEFORMAT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_MERKWI
  AFTER DELETE
  ON BANKEXCH_MERKWI
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_MERKWI
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_POST
  AFTER INSERT
  ON BANKEXCH_POST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_POST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_POST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DO_
      ,TO_
      ,NAMPOST
      ,SUM_
      ,COUNT_
      ,SUM_P
      ,COUNT_P
      ,ZSUM
      ,ZCOUNT
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DO_
      , :new.TO_
      , :new.NAMPOST
      , :new.SUM_
      , :new.COUNT_
      , :new.SUM_P
      , :new.COUNT_P
      , :new.ZSUM
      , :new.ZCOUNT
      , :new.SENDER
      , :new.CODEFORMAT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_POST
  AFTER UPDATE
  ON BANKEXCH_POST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_POST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_POST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_POST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DO_
      ,TO_
      ,NAMPOST
      ,SUM_
      ,COUNT_
      ,SUM_P
      ,COUNT_P
      ,ZSUM
      ,ZCOUNT
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DO_
      , :new.TO_
      , :new.NAMPOST
      , :new.SUM_
      , :new.COUNT_
      , :new.SUM_P
      , :new.COUNT_P
      , :new.ZSUM
      , :new.ZCOUNT
      , :new.SENDER
      , :new.CODEFORMAT
    );
  else 
    update A_BANKEXCH_POST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_POST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DO_
      ,TO_
      ,NAMPOST
      ,SUM_
      ,COUNT_
      ,SUM_P
      ,COUNT_P
      ,ZSUM
      ,ZCOUNT
      ,SENDER
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DO_
      , :new.TO_
      , :new.NAMPOST
      , :new.SUM_
      , :new.COUNT_
      , :new.SUM_P
      , :new.COUNT_P
      , :new.ZSUM
      , :new.ZCOUNT
      , :new.SENDER
      , :new.CODEFORMAT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_POST
  AFTER DELETE
  ON BANKEXCH_POST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_POST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_QUERY
  AFTER INSERT
  ON BANKEXCH_QUERY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_QUERY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_QUERY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,COD_QU
      ,DD
      ,DV
      ,ND
      ,SUM_
      ,ELNUM
      ,MFA
      ,LSKL
      ,MFB
      ,LSKOR
      ,SENDER
      ,ELNUMREF
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.COD_QU
      , :new.DD
      , :new.DV
      , :new.ND
      , :new.SUM_
      , :new.ELNUM
      , :new.MFA
      , :new.LSKL
      , :new.MFB
      , :new.LSKOR
      , :new.SENDER
      , :new.ELNUMREF
      , :new.CODEFORMAT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_QUERY
  AFTER UPDATE
  ON BANKEXCH_QUERY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_QUERY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_QUERY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_QUERY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,COD_QU
      ,DD
      ,DV
      ,ND
      ,SUM_
      ,ELNUM
      ,MFA
      ,LSKL
      ,MFB
      ,LSKOR
      ,SENDER
      ,ELNUMREF
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.COD_QU
      , :new.DD
      , :new.DV
      , :new.ND
      , :new.SUM_
      , :new.ELNUM
      , :new.MFA
      , :new.LSKL
      , :new.MFB
      , :new.LSKOR
      , :new.SENDER
      , :new.ELNUMREF
      , :new.CODEFORMAT
    );
  else 
    update A_BANKEXCH_QUERY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_QUERY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,COD_QU
      ,DD
      ,DV
      ,ND
      ,SUM_
      ,ELNUM
      ,MFA
      ,LSKL
      ,MFB
      ,LSKOR
      ,SENDER
      ,ELNUMREF
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.COD_QU
      , :new.DD
      , :new.DV
      , :new.ND
      , :new.SUM_
      , :new.ELNUM
      , :new.MFA
      , :new.LSKL
      , :new.MFB
      , :new.LSKOR
      , :new.SENDER
      , :new.ELNUMREF
      , :new.CODEFORMAT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_QUERY
  AFTER DELETE
  ON BANKEXCH_QUERY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_QUERY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_QUEUE
  AFTER INSERT
  ON BANKEXCH_QUEUE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_QUEUE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_QUEUE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,ND
      ,DK
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,KRKB
      ,MF
      ,LSKOR
      ,KR
      ,SU
      ,T_EVENT
      ,SENDER
      ,APRIOR
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.ND
      , :new.DK
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.KRKB
      , :new.MF
      , :new.LSKOR
      , :new.KR
      , :new.SU
      , :new.T_EVENT
      , :new.SENDER
      , :new.APRIOR
      , :new.CODEFORMAT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_QUEUE
  AFTER UPDATE
  ON BANKEXCH_QUEUE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_QUEUE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_QUEUE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_QUEUE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,ND
      ,DK
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,KRKB
      ,MF
      ,LSKOR
      ,KR
      ,SU
      ,T_EVENT
      ,SENDER
      ,APRIOR
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.ND
      , :new.DK
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.KRKB
      , :new.MF
      , :new.LSKOR
      , :new.KR
      , :new.SU
      , :new.T_EVENT
      , :new.SENDER
      , :new.APRIOR
      , :new.CODEFORMAT
    );
  else 
    update A_BANKEXCH_QUEUE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_QUEUE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,ND
      ,DK
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,KRKB
      ,MF
      ,LSKOR
      ,KR
      ,SU
      ,T_EVENT
      ,SENDER
      ,APRIOR
      ,CODEFORMAT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.ND
      , :new.DK
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.KRKB
      , :new.MF
      , :new.LSKOR
      , :new.KR
      , :new.SU
      , :new.T_EVENT
      , :new.SENDER
      , :new.APRIOR
      , :new.CODEFORMAT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_QUEUE
  AFTER DELETE
  ON BANKEXCH_QUEUE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_QUEUE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_REOUT
  AFTER INSERT
  ON BANKEXCH_REOUT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_REOUT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_REOUT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,ND
      ,DK
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,KRKB
      ,MF
      ,LSKOR
      ,KR
      ,SU
      ,SS
      ,DFA
      ,NA
      ,TYP_DOC
      ,PR_DOC
      ,T_EVENT
      ,SENDER
      ,KPPA
      ,KPPB
      ,DPPL
      ,DKART
      ,DSPL
      ,SSTATUS
      ,CODOKATO
      ,NALPLAT
      ,NALPER
      ,NDNAL
      ,DDNAL
      ,TYPNAL
      ,SU_OST
      ,N_CH_PL
      ,D_PL
      ,SHIFR
      ,N_PLDOK
      ,D_OTMET
      ,CODEFORMAT
      ,SOP
      ,CODBCLAS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.ND
      , :new.DK
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.KRKB
      , :new.MF
      , :new.LSKOR
      , :new.KR
      , :new.SU
      , :new.SS
      , :new.DFA
      , :new.NA
      , :new.TYP_DOC
      , :new.PR_DOC
      , :new.T_EVENT
      , :new.SENDER
      , :new.KPPA
      , :new.KPPB
      , :new.DPPL
      , :new.DKART
      , :new.DSPL
      , :new.SSTATUS
      , :new.CODOKATO
      , :new.NALPLAT
      , :new.NALPER
      , :new.NDNAL
      , :new.DDNAL
      , :new.TYPNAL
      , :new.SU_OST
      , :new.N_CH_PL
      , :new.D_PL
      , :new.SHIFR
      , :new.N_PLDOK
      , :new.D_OTMET
      , :new.CODEFORMAT
      , :new.SOP
      , :new.CODBCLAS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_REOUT
  AFTER UPDATE
  ON BANKEXCH_REOUT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_REOUT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_REOUT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_REOUT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,ND
      ,DK
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,KRKB
      ,MF
      ,LSKOR
      ,KR
      ,SU
      ,SS
      ,DFA
      ,NA
      ,TYP_DOC
      ,PR_DOC
      ,T_EVENT
      ,SENDER
      ,KPPA
      ,KPPB
      ,DPPL
      ,DKART
      ,DSPL
      ,SSTATUS
      ,CODOKATO
      ,NALPLAT
      ,NALPER
      ,NDNAL
      ,DDNAL
      ,TYPNAL
      ,SU_OST
      ,N_CH_PL
      ,D_PL
      ,SHIFR
      ,N_PLDOK
      ,D_OTMET
      ,CODEFORMAT
      ,SOP
      ,CODBCLAS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.ND
      , :new.DK
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.KRKB
      , :new.MF
      , :new.LSKOR
      , :new.KR
      , :new.SU
      , :new.SS
      , :new.DFA
      , :new.NA
      , :new.TYP_DOC
      , :new.PR_DOC
      , :new.T_EVENT
      , :new.SENDER
      , :new.KPPA
      , :new.KPPB
      , :new.DPPL
      , :new.DKART
      , :new.DSPL
      , :new.SSTATUS
      , :new.CODOKATO
      , :new.NALPLAT
      , :new.NALPER
      , :new.NDNAL
      , :new.DDNAL
      , :new.TYPNAL
      , :new.SU_OST
      , :new.N_CH_PL
      , :new.D_PL
      , :new.SHIFR
      , :new.N_PLDOK
      , :new.D_OTMET
      , :new.CODEFORMAT
      , :new.SOP
      , :new.CODBCLAS
    );
  else 
    update A_BANKEXCH_REOUT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_REOUT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DVV
      ,DD
      ,DV
      ,DAV
      ,ND
      ,DK
      ,ELNUM
      ,VO
      ,MFKB
      ,LSKL
      ,KRKB
      ,MF
      ,LSKOR
      ,KR
      ,SU
      ,SS
      ,DFA
      ,NA
      ,TYP_DOC
      ,PR_DOC
      ,T_EVENT
      ,SENDER
      ,KPPA
      ,KPPB
      ,DPPL
      ,DKART
      ,DSPL
      ,SSTATUS
      ,CODOKATO
      ,NALPLAT
      ,NALPER
      ,NDNAL
      ,DDNAL
      ,TYPNAL
      ,SU_OST
      ,N_CH_PL
      ,D_PL
      ,SHIFR
      ,N_PLDOK
      ,D_OTMET
      ,CODEFORMAT
      ,SOP
      ,CODBCLAS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DVV
      , :new.DD
      , :new.DV
      , :new.DAV
      , :new.ND
      , :new.DK
      , :new.ELNUM
      , :new.VO
      , :new.MFKB
      , :new.LSKL
      , :new.KRKB
      , :new.MF
      , :new.LSKOR
      , :new.KR
      , :new.SU
      , :new.SS
      , :new.DFA
      , :new.NA
      , :new.TYP_DOC
      , :new.PR_DOC
      , :new.T_EVENT
      , :new.SENDER
      , :new.KPPA
      , :new.KPPB
      , :new.DPPL
      , :new.DKART
      , :new.DSPL
      , :new.SSTATUS
      , :new.CODOKATO
      , :new.NALPLAT
      , :new.NALPER
      , :new.NDNAL
      , :new.DDNAL
      , :new.TYPNAL
      , :new.SU_OST
      , :new.N_CH_PL
      , :new.D_PL
      , :new.SHIFR
      , :new.N_PLDOK
      , :new.D_OTMET
      , :new.CODEFORMAT
      , :new.SOP
      , :new.CODBCLAS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_REOUT
  AFTER DELETE
  ON BANKEXCH_REOUT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_REOUT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BANKEXCH_SUBSTITUTION
  AFTER INSERT
  ON BANKEXCH_SUBSTITUTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_SUBSTITUTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_SUBSTITUTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROCLEVEL
      ,ORDERRULES
      ,SOURCEMFO
      ,SOURCEKPP
      ,SOURCEACC
      ,SOURCENOTE
      ,SOURCEKD
      ,SOURCEIFS
      ,SOURCEDIRECTIONCLS
      ,SOURCEBUHPAYMENTCLS
      ,SOURCEKDFULL
      ,SOURCEFINSOURCEFULL
      ,SOURCEDFACCOUNT
      ,SOURCEPROCDOCCLASS
      ,DESTNOTE
      ,DESTKD
      ,DESTSUBKD
      ,DESTREGIONCLS
      ,DESTGOSNI
      ,DESTFACIALACC_CLS
      ,DESTDOCTYPE
      ,DESTFINTYPE
      ,DESTBUHPAYMENTCLS
      ,DESTIFS
      ,DESTKVSR
      ,DESTKFSR
      ,DESTKESR
      ,DESTKVR
      ,DESTKCSR
      ,DESTDIRECTIONCLS
      ,DESTKDFULL
      ,DESTFINSOURCEFULL
      ,DESTPROCDOCCLASS
      ,DESTORG_REF
      ,DESTACC_REF
      ,NAMERULE
      ,NAMEABLACTION
      ,NOTERULE
      ,DESTFACT
      ,FORMTYPE
      ,BUHOPERATIONCLS
      ,SOURCEFEDERALFUNDSREF
      ,DESTFEDERALFUNDSREF
      ,SOURCETARGETCLS
      ,DESTSUBKESR
      ,SOURCEINN
      ,SOURCEKVSR
      ,SOURCEKFSR
      ,SOURCEKESR
      ,SOURCEKVR
      ,SOURCEKCSR
      ,DESTFUNDSSOURCE
      ,DISABLED
      ,SOURCESUMMAKIND
      ,SOURCEKOD_IST
      ,SOURCEDOCUMENTNAME
      ,DESTOPERATIONDIRECTION
      ,DESTTRANSFERTCLS
      ,DESTSUBSIDYCLS
      ,SOURCEFACIALACC_ORG_TYPE
      ,SOURCEFACIALACC_CLS
      ,DESTBUDALLOCATIONCLS
      ,DESTPAYPROMISECLS
      ,DESTMEANSTYPE
      ,SOURCEDEREFERENCE
      ,SOURCETRANSFERTCLS
      ,SOURCESUBSIDYCLS
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESTDFACCOUNT
      ,SOURCECLSTYPE
      ,DESTCLSTYPE
      ,SOURCEINVESTOBJECT
      ,DESTINVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROCLEVEL
      , :new.ORDERRULES
      , :new.SOURCEMFO
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.SOURCENOTE
      , :new.SOURCEKD
      , :new.SOURCEIFS
      , :new.SOURCEDIRECTIONCLS
      , :new.SOURCEBUHPAYMENTCLS
      , :new.SOURCEKDFULL
      , :new.SOURCEFINSOURCEFULL
      , :new.SOURCEDFACCOUNT
      , :new.SOURCEPROCDOCCLASS
      , :new.DESTNOTE
      , :new.DESTKD
      , :new.DESTSUBKD
      , :new.DESTREGIONCLS
      , :new.DESTGOSNI
      , :new.DESTFACIALACC_CLS
      , :new.DESTDOCTYPE
      , :new.DESTFINTYPE
      , :new.DESTBUHPAYMENTCLS
      , :new.DESTIFS
      , :new.DESTKVSR
      , :new.DESTKFSR
      , :new.DESTKESR
      , :new.DESTKVR
      , :new.DESTKCSR
      , :new.DESTDIRECTIONCLS
      , :new.DESTKDFULL
      , :new.DESTFINSOURCEFULL
      , :new.DESTPROCDOCCLASS
      , :new.DESTORG_REF
      , :new.DESTACC_REF
      , :new.NAMERULE
      , :new.NAMEABLACTION
      , :new.NOTERULE
      , :new.DESTFACT
      , :new.FORMTYPE
      , :new.BUHOPERATIONCLS
      , :new.SOURCEFEDERALFUNDSREF
      , :new.DESTFEDERALFUNDSREF
      , :new.SOURCETARGETCLS
      , :new.DESTSUBKESR
      , :new.SOURCEINN
      , :new.SOURCEKVSR
      , :new.SOURCEKFSR
      , :new.SOURCEKESR
      , :new.SOURCEKVR
      , :new.SOURCEKCSR
      , :new.DESTFUNDSSOURCE
      , :new.DISABLED
      , :new.SOURCESUMMAKIND
      , :new.SOURCEKOD_IST
      , :new.SOURCEDOCUMENTNAME
      , :new.DESTOPERATIONDIRECTION
      , :new.DESTTRANSFERTCLS
      , :new.DESTSUBSIDYCLS
      , :new.SOURCEFACIALACC_ORG_TYPE
      , :new.SOURCEFACIALACC_CLS
      , :new.DESTBUDALLOCATIONCLS
      , :new.DESTPAYPROMISECLS
      , :new.DESTMEANSTYPE
      , :new.SOURCEDEREFERENCE
      , :new.SOURCETRANSFERTCLS
      , :new.SOURCESUBSIDYCLS
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESTDFACCOUNT
      , :new.SOURCECLSTYPE
      , :new.DESTCLSTYPE
      , :new.SOURCEINVESTOBJECT
      , :new.DESTINVESTOBJECT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BANKEXCH_SUBSTITUTION
  AFTER UPDATE
  ON BANKEXCH_SUBSTITUTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BANKEXCH_SUBSTITUTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BANKEXCH_SUBSTITUTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BANKEXCH_SUBSTITUTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROCLEVEL
      ,ORDERRULES
      ,SOURCEMFO
      ,SOURCEKPP
      ,SOURCEACC
      ,SOURCENOTE
      ,SOURCEKD
      ,SOURCEIFS
      ,SOURCEDIRECTIONCLS
      ,SOURCEBUHPAYMENTCLS
      ,SOURCEKDFULL
      ,SOURCEFINSOURCEFULL
      ,SOURCEDFACCOUNT
      ,SOURCEPROCDOCCLASS
      ,DESTNOTE
      ,DESTKD
      ,DESTSUBKD
      ,DESTREGIONCLS
      ,DESTGOSNI
      ,DESTFACIALACC_CLS
      ,DESTDOCTYPE
      ,DESTFINTYPE
      ,DESTBUHPAYMENTCLS
      ,DESTIFS
      ,DESTKVSR
      ,DESTKFSR
      ,DESTKESR
      ,DESTKVR
      ,DESTKCSR
      ,DESTDIRECTIONCLS
      ,DESTKDFULL
      ,DESTFINSOURCEFULL
      ,DESTPROCDOCCLASS
      ,DESTORG_REF
      ,DESTACC_REF
      ,NAMERULE
      ,NAMEABLACTION
      ,NOTERULE
      ,DESTFACT
      ,FORMTYPE
      ,BUHOPERATIONCLS
      ,SOURCEFEDERALFUNDSREF
      ,DESTFEDERALFUNDSREF
      ,SOURCETARGETCLS
      ,DESTSUBKESR
      ,SOURCEINN
      ,SOURCEKVSR
      ,SOURCEKFSR
      ,SOURCEKESR
      ,SOURCEKVR
      ,SOURCEKCSR
      ,DESTFUNDSSOURCE
      ,DISABLED
      ,SOURCESUMMAKIND
      ,SOURCEKOD_IST
      ,SOURCEDOCUMENTNAME
      ,DESTOPERATIONDIRECTION
      ,DESTTRANSFERTCLS
      ,DESTSUBSIDYCLS
      ,SOURCEFACIALACC_ORG_TYPE
      ,SOURCEFACIALACC_CLS
      ,DESTBUDALLOCATIONCLS
      ,DESTPAYPROMISECLS
      ,DESTMEANSTYPE
      ,SOURCEDEREFERENCE
      ,SOURCETRANSFERTCLS
      ,SOURCESUBSIDYCLS
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESTDFACCOUNT
      ,SOURCECLSTYPE
      ,DESTCLSTYPE
      ,SOURCEINVESTOBJECT
      ,DESTINVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROCLEVEL
      , :new.ORDERRULES
      , :new.SOURCEMFO
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.SOURCENOTE
      , :new.SOURCEKD
      , :new.SOURCEIFS
      , :new.SOURCEDIRECTIONCLS
      , :new.SOURCEBUHPAYMENTCLS
      , :new.SOURCEKDFULL
      , :new.SOURCEFINSOURCEFULL
      , :new.SOURCEDFACCOUNT
      , :new.SOURCEPROCDOCCLASS
      , :new.DESTNOTE
      , :new.DESTKD
      , :new.DESTSUBKD
      , :new.DESTREGIONCLS
      , :new.DESTGOSNI
      , :new.DESTFACIALACC_CLS
      , :new.DESTDOCTYPE
      , :new.DESTFINTYPE
      , :new.DESTBUHPAYMENTCLS
      , :new.DESTIFS
      , :new.DESTKVSR
      , :new.DESTKFSR
      , :new.DESTKESR
      , :new.DESTKVR
      , :new.DESTKCSR
      , :new.DESTDIRECTIONCLS
      , :new.DESTKDFULL
      , :new.DESTFINSOURCEFULL
      , :new.DESTPROCDOCCLASS
      , :new.DESTORG_REF
      , :new.DESTACC_REF
      , :new.NAMERULE
      , :new.NAMEABLACTION
      , :new.NOTERULE
      , :new.DESTFACT
      , :new.FORMTYPE
      , :new.BUHOPERATIONCLS
      , :new.SOURCEFEDERALFUNDSREF
      , :new.DESTFEDERALFUNDSREF
      , :new.SOURCETARGETCLS
      , :new.DESTSUBKESR
      , :new.SOURCEINN
      , :new.SOURCEKVSR
      , :new.SOURCEKFSR
      , :new.SOURCEKESR
      , :new.SOURCEKVR
      , :new.SOURCEKCSR
      , :new.DESTFUNDSSOURCE
      , :new.DISABLED
      , :new.SOURCESUMMAKIND
      , :new.SOURCEKOD_IST
      , :new.SOURCEDOCUMENTNAME
      , :new.DESTOPERATIONDIRECTION
      , :new.DESTTRANSFERTCLS
      , :new.DESTSUBSIDYCLS
      , :new.SOURCEFACIALACC_ORG_TYPE
      , :new.SOURCEFACIALACC_CLS
      , :new.DESTBUDALLOCATIONCLS
      , :new.DESTPAYPROMISECLS
      , :new.DESTMEANSTYPE
      , :new.SOURCEDEREFERENCE
      , :new.SOURCETRANSFERTCLS
      , :new.SOURCESUBSIDYCLS
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESTDFACCOUNT
      , :new.SOURCECLSTYPE
      , :new.DESTCLSTYPE
      , :new.SOURCEINVESTOBJECT
      , :new.DESTINVESTOBJECT
    );
  else 
    update A_BANKEXCH_SUBSTITUTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BANKEXCH_SUBSTITUTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROCLEVEL
      ,ORDERRULES
      ,SOURCEMFO
      ,SOURCEKPP
      ,SOURCEACC
      ,SOURCENOTE
      ,SOURCEKD
      ,SOURCEIFS
      ,SOURCEDIRECTIONCLS
      ,SOURCEBUHPAYMENTCLS
      ,SOURCEKDFULL
      ,SOURCEFINSOURCEFULL
      ,SOURCEDFACCOUNT
      ,SOURCEPROCDOCCLASS
      ,DESTNOTE
      ,DESTKD
      ,DESTSUBKD
      ,DESTREGIONCLS
      ,DESTGOSNI
      ,DESTFACIALACC_CLS
      ,DESTDOCTYPE
      ,DESTFINTYPE
      ,DESTBUHPAYMENTCLS
      ,DESTIFS
      ,DESTKVSR
      ,DESTKFSR
      ,DESTKESR
      ,DESTKVR
      ,DESTKCSR
      ,DESTDIRECTIONCLS
      ,DESTKDFULL
      ,DESTFINSOURCEFULL
      ,DESTPROCDOCCLASS
      ,DESTORG_REF
      ,DESTACC_REF
      ,NAMERULE
      ,NAMEABLACTION
      ,NOTERULE
      ,DESTFACT
      ,FORMTYPE
      ,BUHOPERATIONCLS
      ,SOURCEFEDERALFUNDSREF
      ,DESTFEDERALFUNDSREF
      ,SOURCETARGETCLS
      ,DESTSUBKESR
      ,SOURCEINN
      ,SOURCEKVSR
      ,SOURCEKFSR
      ,SOURCEKESR
      ,SOURCEKVR
      ,SOURCEKCSR
      ,DESTFUNDSSOURCE
      ,DISABLED
      ,SOURCESUMMAKIND
      ,SOURCEKOD_IST
      ,SOURCEDOCUMENTNAME
      ,DESTOPERATIONDIRECTION
      ,DESTTRANSFERTCLS
      ,DESTSUBSIDYCLS
      ,SOURCEFACIALACC_ORG_TYPE
      ,SOURCEFACIALACC_CLS
      ,DESTBUDALLOCATIONCLS
      ,DESTPAYPROMISECLS
      ,DESTMEANSTYPE
      ,SOURCEDEREFERENCE
      ,SOURCETRANSFERTCLS
      ,SOURCESUBSIDYCLS
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESTDFACCOUNT
      ,SOURCECLSTYPE
      ,DESTCLSTYPE
      ,SOURCEINVESTOBJECT
      ,DESTINVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROCLEVEL
      , :new.ORDERRULES
      , :new.SOURCEMFO
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.SOURCENOTE
      , :new.SOURCEKD
      , :new.SOURCEIFS
      , :new.SOURCEDIRECTIONCLS
      , :new.SOURCEBUHPAYMENTCLS
      , :new.SOURCEKDFULL
      , :new.SOURCEFINSOURCEFULL
      , :new.SOURCEDFACCOUNT
      , :new.SOURCEPROCDOCCLASS
      , :new.DESTNOTE
      , :new.DESTKD
      , :new.DESTSUBKD
      , :new.DESTREGIONCLS
      , :new.DESTGOSNI
      , :new.DESTFACIALACC_CLS
      , :new.DESTDOCTYPE
      , :new.DESTFINTYPE
      , :new.DESTBUHPAYMENTCLS
      , :new.DESTIFS
      , :new.DESTKVSR
      , :new.DESTKFSR
      , :new.DESTKESR
      , :new.DESTKVR
      , :new.DESTKCSR
      , :new.DESTDIRECTIONCLS
      , :new.DESTKDFULL
      , :new.DESTFINSOURCEFULL
      , :new.DESTPROCDOCCLASS
      , :new.DESTORG_REF
      , :new.DESTACC_REF
      , :new.NAMERULE
      , :new.NAMEABLACTION
      , :new.NOTERULE
      , :new.DESTFACT
      , :new.FORMTYPE
      , :new.BUHOPERATIONCLS
      , :new.SOURCEFEDERALFUNDSREF
      , :new.DESTFEDERALFUNDSREF
      , :new.SOURCETARGETCLS
      , :new.DESTSUBKESR
      , :new.SOURCEINN
      , :new.SOURCEKVSR
      , :new.SOURCEKFSR
      , :new.SOURCEKESR
      , :new.SOURCEKVR
      , :new.SOURCEKCSR
      , :new.DESTFUNDSSOURCE
      , :new.DISABLED
      , :new.SOURCESUMMAKIND
      , :new.SOURCEKOD_IST
      , :new.SOURCEDOCUMENTNAME
      , :new.DESTOPERATIONDIRECTION
      , :new.DESTTRANSFERTCLS
      , :new.DESTSUBSIDYCLS
      , :new.SOURCEFACIALACC_ORG_TYPE
      , :new.SOURCEFACIALACC_CLS
      , :new.DESTBUDALLOCATIONCLS
      , :new.DESTPAYPROMISECLS
      , :new.DESTMEANSTYPE
      , :new.SOURCEDEREFERENCE
      , :new.SOURCETRANSFERTCLS
      , :new.SOURCESUBSIDYCLS
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESTDFACCOUNT
      , :new.SOURCECLSTYPE
      , :new.DESTCLSTYPE
      , :new.SOURCEINVESTOBJECT
      , :new.DESTINVESTOBJECT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BANKEXCH_SUBSTITUTION
  AFTER DELETE
  ON BANKEXCH_SUBSTITUTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BANKEXCH_SUBSTITUTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BILL_ACCORDDOC
  AFTER INSERT
  ON BILL_ACCORDDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BILL_ACCORDDOC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BILL_ACCORDDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_ACCORD
      ,BUILDDATE
      ,ACCEPTDATE
      ,NOTE
      ,BUDGETREF
      ,SUMBYFIN
      ,SUMBYBILLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_ACCORD
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SUMBYFIN
      , :new.SUMBYBILLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BILL_ACCORDDOC
  AFTER UPDATE
  ON BILL_ACCORDDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BILL_ACCORDDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BILL_ACCORDDOC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BILL_ACCORDDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_ACCORD
      ,BUILDDATE
      ,ACCEPTDATE
      ,NOTE
      ,BUDGETREF
      ,SUMBYFIN
      ,SUMBYBILLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_ACCORD
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SUMBYFIN
      , :new.SUMBYBILLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_BILL_ACCORDDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BILL_ACCORDDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_ACCORD
      ,BUILDDATE
      ,ACCEPTDATE
      ,NOTE
      ,BUDGETREF
      ,SUMBYFIN
      ,SUMBYBILLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_ACCORD
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SUMBYFIN
      , :new.SUMBYBILLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BILL_ACCORDDOC
  AFTER DELETE
  ON BILL_ACCORDDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BILL_ACCORDDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BILLS
  AFTER INSERT
  ON BILLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BILLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BILLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATE_INPUT
      ,ID_ORG
      ,NUM_NOTIF
      ,NOTE
      ,BUDGETREF
      ,SUMBYINCOMES
      ,SUMBYBILLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATE_INPUT
      , :new.ID_ORG
      , :new.NUM_NOTIF
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SUMBYINCOMES
      , :new.SUMBYBILLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BILLS
  AFTER UPDATE
  ON BILLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BILLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BILLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BILLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATE_INPUT
      ,ID_ORG
      ,NUM_NOTIF
      ,NOTE
      ,BUDGETREF
      ,SUMBYINCOMES
      ,SUMBYBILLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATE_INPUT
      , :new.ID_ORG
      , :new.NUM_NOTIF
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SUMBYINCOMES
      , :new.SUMBYBILLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_BILLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BILLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATE_INPUT
      ,ID_ORG
      ,NUM_NOTIF
      ,NOTE
      ,BUDGETREF
      ,SUMBYINCOMES
      ,SUMBYBILLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATE_INPUT
      , :new.ID_ORG
      , :new.NUM_NOTIF
      , :new.NOTE
      , :new.BUDGETREF
      , :new.SUMBYINCOMES
      , :new.SUMBYBILLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BILLS
  AFTER DELETE
  ON BILLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BILLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BILLS_DET
  AFTER INSERT
  ON BILLS_DET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BILLS_DET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BILLS_DET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SERIES
      ,NOMINAL
      ,DATEAMORTIZATION
      ,SUMMAOUT
      ,NOMINALPRICE
      ,PROGINDEX_BILL
      ,RECORDINDEX_BILL
      ,REF_ISSUE
      ,DATE_OUT
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SERIES
      , :new.NOMINAL
      , :new.DATEAMORTIZATION
      , :new.SUMMAOUT
      , :new.NOMINALPRICE
      , :new.PROGINDEX_BILL
      , :new.RECORDINDEX_BILL
      , :new.REF_ISSUE
      , :new.DATE_OUT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BILLS_DET
  AFTER UPDATE
  ON BILLS_DET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BILLS_DET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BILLS_DET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BILLS_DET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SERIES
      ,NOMINAL
      ,DATEAMORTIZATION
      ,SUMMAOUT
      ,NOMINALPRICE
      ,PROGINDEX_BILL
      ,RECORDINDEX_BILL
      ,REF_ISSUE
      ,DATE_OUT
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SERIES
      , :new.NOMINAL
      , :new.DATEAMORTIZATION
      , :new.SUMMAOUT
      , :new.NOMINALPRICE
      , :new.PROGINDEX_BILL
      , :new.RECORDINDEX_BILL
      , :new.REF_ISSUE
      , :new.DATE_OUT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
    );
  else 
    update A_BILLS_DET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BILLS_DET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SERIES
      ,NOMINAL
      ,DATEAMORTIZATION
      ,SUMMAOUT
      ,NOMINALPRICE
      ,PROGINDEX_BILL
      ,RECORDINDEX_BILL
      ,REF_ISSUE
      ,DATE_OUT
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SERIES
      , :new.NOMINAL
      , :new.DATEAMORTIZATION
      , :new.SUMMAOUT
      , :new.NOMINALPRICE
      , :new.PROGINDEX_BILL
      , :new.RECORDINDEX_BILL
      , :new.REF_ISSUE
      , :new.DATE_OUT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BILLS_DET
  AFTER DELETE
  ON BILLS_DET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BILLS_DET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BNK_DSIGNDOCUMENTS
  AFTER INSERT
  ON BNK_DSIGNDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BNK_DSIGNDOCUMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BNK_DSIGNDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,DOCUMENTID
      ,DOCSTATUS
      ,REJECTCAUSE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.DOCUMENTID
      , :new.DOCSTATUS
      , :new.REJECTCAUSE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BNK_DSIGNDOCUMENTS
  AFTER UPDATE
  ON BNK_DSIGNDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BNK_DSIGNDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BNK_DSIGNDOCUMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BNK_DSIGNDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,DOCUMENTID
      ,DOCSTATUS
      ,REJECTCAUSE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.DOCUMENTID
      , :new.DOCSTATUS
      , :new.REJECTCAUSE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  else 
    update A_BNK_DSIGNDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BNK_DSIGNDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,DOCUMENTID
      ,DOCSTATUS
      ,REJECTCAUSE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.DOCUMENTID
      , :new.DOCSTATUS
      , :new.REJECTCAUSE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BNK_DSIGNDOCUMENTS
  AFTER DELETE
  ON BNK_DSIGNDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BNK_DSIGNDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BNKINPUTDOC_JOURNAL
  AFTER INSERT
  ON BNKINPUTDOC_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BNKINPUTDOC_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BNKINPUTDOC_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BNKINPUTDOC_JOURNAL
  AFTER UPDATE
  ON BNKINPUTDOC_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BNKINPUTDOC_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BNKINPUTDOC_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BNKINPUTDOC_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  else 
    update A_BNKINPUTDOC_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BNKINPUTDOC_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BNKINPUTDOC_JOURNAL
  AFTER DELETE
  ON BNKINPUTDOC_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BNKINPUTDOC_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BNKOUTPUTDOC_JOURNAL
  AFTER INSERT
  ON BNKOUTPUTDOC_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BNKOUTPUTDOC_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BNKOUTPUTDOC_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,STATUS
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.STATUS
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BNKOUTPUTDOC_JOURNAL
  AFTER UPDATE
  ON BNKOUTPUTDOC_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BNKOUTPUTDOC_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BNKOUTPUTDOC_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BNKOUTPUTDOC_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,STATUS
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.STATUS
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  else 
    update A_BNKOUTPUTDOC_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BNKOUTPUTDOC_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,STATUS
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.STATUS
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BNKOUTPUTDOC_JOURNAL
  AFTER DELETE
  ON BNKOUTPUTDOC_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BNKOUTPUTDOC_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDALLOCATIONCLS
  AFTER INSERT
  ON BUDALLOCATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDALLOCATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDALLOCATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ASSIGNMENTKIND
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ASSIGNMENTKIND
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDALLOCATIONCLS
  AFTER UPDATE
  ON BUDALLOCATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDALLOCATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDALLOCATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDALLOCATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ASSIGNMENTKIND
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ASSIGNMENTKIND
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_BUDALLOCATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDALLOCATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ASSIGNMENTKIND
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ASSIGNMENTKIND
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDALLOCATIONCLS
  AFTER DELETE
  ON BUDALLOCATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDALLOCATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDGETACCOUNTS
  AFTER INSERT
  ON BUDGETACCOUNTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDGETACCOUNTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDGETACCOUNTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDGETACCOUNTS
  AFTER UPDATE
  ON BUDGETACCOUNTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDGETACCOUNTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDGETACCOUNTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDGETACCOUNTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_BUDGETACCOUNTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDGETACCOUNTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDGETACCOUNTS
  AFTER DELETE
  ON BUDGETACCOUNTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDGETACCOUNTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDGETDATA
  AFTER INSERT
  ON BUDGETDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDGETDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDGETDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FACT
      ,FACIALACC_CLS
      ,ACC_REF
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,FINTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDINDEX
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,MEANSTYPE
      ,SENDERID
      ,SENDERRECORDID
      ,STIMATEID
      ,RVERSION
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS
      ,CLSTYPE
      ,ORG_REF
      ,UNIONNOTIFYREF
      ,FUNDSSOURCE
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,KESRCORR
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,KD
      ,SUBKD
      ,DAYPLAN
      ,DAYPLANSUMMA
      ,NOTE
      ,SUBSIDYCLS
      ,SUBSIDYCLSOLD
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,TRANSFERTORG_REF
      ,DEPARTMENTCLS
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,KVRCORR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.ACC_REF
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.FINTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.MEANSTYPE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.STIMATEID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.CLSTYPE
      , :new.ORG_REF
      , :new.UNIONNOTIFYREF
      , :new.FUNDSSOURCE
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.KESRCORR
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.KD
      , :new.SUBKD
      , :new.DAYPLAN
      , :new.DAYPLANSUMMA
      , :new.NOTE
      , :new.SUBSIDYCLS
      , :new.SUBSIDYCLSOLD
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.TRANSFERTORG_REF
      , :new.DEPARTMENTCLS
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.KVRCORR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDGETDATA
  AFTER UPDATE
  ON BUDGETDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDGETDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDGETDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDGETDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FACT
      ,FACIALACC_CLS
      ,ACC_REF
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,FINTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDINDEX
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,MEANSTYPE
      ,SENDERID
      ,SENDERRECORDID
      ,STIMATEID
      ,RVERSION
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS
      ,CLSTYPE
      ,ORG_REF
      ,UNIONNOTIFYREF
      ,FUNDSSOURCE
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,KESRCORR
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,KD
      ,SUBKD
      ,DAYPLAN
      ,DAYPLANSUMMA
      ,NOTE
      ,SUBSIDYCLS
      ,SUBSIDYCLSOLD
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,TRANSFERTORG_REF
      ,DEPARTMENTCLS
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,KVRCORR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.ACC_REF
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.FINTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.MEANSTYPE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.STIMATEID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.CLSTYPE
      , :new.ORG_REF
      , :new.UNIONNOTIFYREF
      , :new.FUNDSSOURCE
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.KESRCORR
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.KD
      , :new.SUBKD
      , :new.DAYPLAN
      , :new.DAYPLANSUMMA
      , :new.NOTE
      , :new.SUBSIDYCLS
      , :new.SUBSIDYCLSOLD
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.TRANSFERTORG_REF
      , :new.DEPARTMENTCLS
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.KVRCORR
    );
  else 
    update A_BUDGETDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDGETDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FACT
      ,FACIALACC_CLS
      ,ACC_REF
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,FINTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDINDEX
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,MEANSTYPE
      ,SENDERID
      ,SENDERRECORDID
      ,STIMATEID
      ,RVERSION
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS
      ,CLSTYPE
      ,ORG_REF
      ,UNIONNOTIFYREF
      ,FUNDSSOURCE
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,KESRCORR
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,KD
      ,SUBKD
      ,DAYPLAN
      ,DAYPLANSUMMA
      ,NOTE
      ,SUBSIDYCLS
      ,SUBSIDYCLSOLD
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,TRANSFERTORG_REF
      ,DEPARTMENTCLS
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,KVRCORR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.ACC_REF
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.FINTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.MEANSTYPE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.STIMATEID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.CLSTYPE
      , :new.ORG_REF
      , :new.UNIONNOTIFYREF
      , :new.FUNDSSOURCE
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.KESRCORR
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.KD
      , :new.SUBKD
      , :new.DAYPLAN
      , :new.DAYPLANSUMMA
      , :new.NOTE
      , :new.SUBSIDYCLS
      , :new.SUBSIDYCLSOLD
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.TRANSFERTORG_REF
      , :new.DEPARTMENTCLS
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.KVRCORR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDGETDATA
  AFTER DELETE
  ON BUDGETDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDGETDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDGETTYPE
  AFTER INSERT
  ON BUDGETTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDGETTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDGETTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT1
      ,ACCOUNT2
      ,ACCOUNT3
      ,NAME
      ,TRANSFERTLEVELKIND
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT1
      , :new.ACCOUNT2
      , :new.ACCOUNT3
      , :new.NAME
      , :new.TRANSFERTLEVELKIND
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDGETTYPE
  AFTER UPDATE
  ON BUDGETTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDGETTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDGETTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDGETTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT1
      ,ACCOUNT2
      ,ACCOUNT3
      ,NAME
      ,TRANSFERTLEVELKIND
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT1
      , :new.ACCOUNT2
      , :new.ACCOUNT3
      , :new.NAME
      , :new.TRANSFERTLEVELKIND
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_BUDGETTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDGETTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT1
      ,ACCOUNT2
      ,ACCOUNT3
      ,NAME
      ,TRANSFERTLEVELKIND
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT1
      , :new.ACCOUNT2
      , :new.ACCOUNT3
      , :new.NAME
      , :new.TRANSFERTLEVELKIND
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDGETTYPE
  AFTER DELETE
  ON BUDGETTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDGETTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDSTRLINK
  AFTER INSERT
  ON BUDSTRLINK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDSTRLINK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDSTRLINK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDSTRUCT
      ,ORG_REF
      ,FACIALACC
      ,CREATEDATE
      ,UPDATEDATE
      ,FILTERKIND
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDSTRUCT
      , :new.ORG_REF
      , :new.FACIALACC
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FILTERKIND
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDSTRLINK
  AFTER UPDATE
  ON BUDSTRLINK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDSTRLINK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDSTRLINK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDSTRLINK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDSTRUCT
      ,ORG_REF
      ,FACIALACC
      ,CREATEDATE
      ,UPDATEDATE
      ,FILTERKIND
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDSTRUCT
      , :new.ORG_REF
      , :new.FACIALACC
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FILTERKIND
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_BUDSTRLINK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDSTRLINK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDSTRUCT
      ,ORG_REF
      ,FACIALACC
      ,CREATEDATE
      ,UPDATEDATE
      ,FILTERKIND
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDSTRUCT
      , :new.ORG_REF
      , :new.FACIALACC
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FILTERKIND
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDSTRLINK
  AFTER DELETE
  ON BUDSTRLINK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDSTRLINK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDSTRUCT
  AFTER INSERT
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDSTRUCT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDSTRUCT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FACT
      ,FINTYPE
      ,MEANSTYPE
      ,ACTUALDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,DIRECTIONCLS
      ,BUDGETREF
      ,TRANSFERTCLS
      ,STARTDATE
      ,ISLIMITSPEND
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,SUBSIDYCLS
      ,ASSIGNMENTKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FACT
      , :new.FINTYPE
      , :new.MEANSTYPE
      , :new.ACTUALDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DIRECTIONCLS
      , :new.BUDGETREF
      , :new.TRANSFERTCLS
      , :new.STARTDATE
      , :new.ISLIMITSPEND
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.SUBSIDYCLS
      , :new.ASSIGNMENTKIND
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDSTRUCT
  AFTER UPDATE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDSTRUCT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDSTRUCT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDSTRUCT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FACT
      ,FINTYPE
      ,MEANSTYPE
      ,ACTUALDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,DIRECTIONCLS
      ,BUDGETREF
      ,TRANSFERTCLS
      ,STARTDATE
      ,ISLIMITSPEND
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,SUBSIDYCLS
      ,ASSIGNMENTKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FACT
      , :new.FINTYPE
      , :new.MEANSTYPE
      , :new.ACTUALDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DIRECTIONCLS
      , :new.BUDGETREF
      , :new.TRANSFERTCLS
      , :new.STARTDATE
      , :new.ISLIMITSPEND
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.SUBSIDYCLS
      , :new.ASSIGNMENTKIND
    );
  else 
    update A_BUDSTRUCT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDSTRUCT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FACT
      ,FINTYPE
      ,MEANSTYPE
      ,ACTUALDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,DIRECTIONCLS
      ,BUDGETREF
      ,TRANSFERTCLS
      ,STARTDATE
      ,ISLIMITSPEND
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,SUBSIDYCLS
      ,ASSIGNMENTKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FACT
      , :new.FINTYPE
      , :new.MEANSTYPE
      , :new.ACTUALDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DIRECTIONCLS
      , :new.BUDGETREF
      , :new.TRANSFERTCLS
      , :new.STARTDATE
      , :new.ISLIMITSPEND
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.SUBSIDYCLS
      , :new.ASSIGNMENTKIND
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDSTRUCT
  AFTER DELETE
  ON BUDSTRUCT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDSTRUCT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUDSTRUCTRIGHTS
  AFTER INSERT
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDSTRUCTRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDSTRUCTRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,ISGROUP
      ,RIGHTREF
      ,KFSR
      ,KVSR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,MEANSTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,KFSRUP
      ,KVSRUP
      ,KESRUP
      ,SUBKESRUP
      ,REGIONCLSUP
      ,MEANSTYPEUP
      ,KVR
      ,KVRUP
      ,TRANSFERTCLS
      ,TRANSFERTCLSUP
      ,KCSR
      ,KCSRUP
      ,BUDALLOCATIONCLS
      ,BUDALLOCATIONCLSUP
      ,PAYPROMISECLS
      ,PAYPROMISECLSUP
      ,SUBSIDYCLS
      ,SUBSIDYCLSUP
      ,DIRECTIONCLS
      ,DIRECTIONCLSUP
      ,FACT
      ,FACTUP
      ,FINTYPE
      ,FINTYPEUP
      ,CREATERUSER
      ,UPDATERUSER
      ,ASSIGNMENTKIND
      ,ASSIGNMENTKINDUP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.ISGROUP
      , :new.RIGHTREF
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.MEANSTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KFSRUP
      , :new.KVSRUP
      , :new.KESRUP
      , :new.SUBKESRUP
      , :new.REGIONCLSUP
      , :new.MEANSTYPEUP
      , :new.KVR
      , :new.KVRUP
      , :new.TRANSFERTCLS
      , :new.TRANSFERTCLSUP
      , :new.KCSR
      , :new.KCSRUP
      , :new.BUDALLOCATIONCLS
      , :new.BUDALLOCATIONCLSUP
      , :new.PAYPROMISECLS
      , :new.PAYPROMISECLSUP
      , :new.SUBSIDYCLS
      , :new.SUBSIDYCLSUP
      , :new.DIRECTIONCLS
      , :new.DIRECTIONCLSUP
      , :new.FACT
      , :new.FACTUP
      , :new.FINTYPE
      , :new.FINTYPEUP
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ASSIGNMENTKIND
      , :new.ASSIGNMENTKINDUP
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUDSTRUCTRIGHTS
  AFTER UPDATE
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUDSTRUCTRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUDSTRUCTRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUDSTRUCTRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,ISGROUP
      ,RIGHTREF
      ,KFSR
      ,KVSR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,MEANSTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,KFSRUP
      ,KVSRUP
      ,KESRUP
      ,SUBKESRUP
      ,REGIONCLSUP
      ,MEANSTYPEUP
      ,KVR
      ,KVRUP
      ,TRANSFERTCLS
      ,TRANSFERTCLSUP
      ,KCSR
      ,KCSRUP
      ,BUDALLOCATIONCLS
      ,BUDALLOCATIONCLSUP
      ,PAYPROMISECLS
      ,PAYPROMISECLSUP
      ,SUBSIDYCLS
      ,SUBSIDYCLSUP
      ,DIRECTIONCLS
      ,DIRECTIONCLSUP
      ,FACT
      ,FACTUP
      ,FINTYPE
      ,FINTYPEUP
      ,CREATERUSER
      ,UPDATERUSER
      ,ASSIGNMENTKIND
      ,ASSIGNMENTKINDUP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.ISGROUP
      , :new.RIGHTREF
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.MEANSTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KFSRUP
      , :new.KVSRUP
      , :new.KESRUP
      , :new.SUBKESRUP
      , :new.REGIONCLSUP
      , :new.MEANSTYPEUP
      , :new.KVR
      , :new.KVRUP
      , :new.TRANSFERTCLS
      , :new.TRANSFERTCLSUP
      , :new.KCSR
      , :new.KCSRUP
      , :new.BUDALLOCATIONCLS
      , :new.BUDALLOCATIONCLSUP
      , :new.PAYPROMISECLS
      , :new.PAYPROMISECLSUP
      , :new.SUBSIDYCLS
      , :new.SUBSIDYCLSUP
      , :new.DIRECTIONCLS
      , :new.DIRECTIONCLSUP
      , :new.FACT
      , :new.FACTUP
      , :new.FINTYPE
      , :new.FINTYPEUP
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ASSIGNMENTKIND
      , :new.ASSIGNMENTKINDUP
    );
  else 
    update A_BUDSTRUCTRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUDSTRUCTRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,ISGROUP
      ,RIGHTREF
      ,KFSR
      ,KVSR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,MEANSTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,KFSRUP
      ,KVSRUP
      ,KESRUP
      ,SUBKESRUP
      ,REGIONCLSUP
      ,MEANSTYPEUP
      ,KVR
      ,KVRUP
      ,TRANSFERTCLS
      ,TRANSFERTCLSUP
      ,KCSR
      ,KCSRUP
      ,BUDALLOCATIONCLS
      ,BUDALLOCATIONCLSUP
      ,PAYPROMISECLS
      ,PAYPROMISECLSUP
      ,SUBSIDYCLS
      ,SUBSIDYCLSUP
      ,DIRECTIONCLS
      ,DIRECTIONCLSUP
      ,FACT
      ,FACTUP
      ,FINTYPE
      ,FINTYPEUP
      ,CREATERUSER
      ,UPDATERUSER
      ,ASSIGNMENTKIND
      ,ASSIGNMENTKINDUP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.ISGROUP
      , :new.RIGHTREF
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.MEANSTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KFSRUP
      , :new.KVSRUP
      , :new.KESRUP
      , :new.SUBKESRUP
      , :new.REGIONCLSUP
      , :new.MEANSTYPEUP
      , :new.KVR
      , :new.KVRUP
      , :new.TRANSFERTCLS
      , :new.TRANSFERTCLSUP
      , :new.KCSR
      , :new.KCSRUP
      , :new.BUDALLOCATIONCLS
      , :new.BUDALLOCATIONCLSUP
      , :new.PAYPROMISECLS
      , :new.PAYPROMISECLSUP
      , :new.SUBSIDYCLS
      , :new.SUBSIDYCLSUP
      , :new.DIRECTIONCLS
      , :new.DIRECTIONCLSUP
      , :new.FACT
      , :new.FACTUP
      , :new.FINTYPE
      , :new.FINTYPEUP
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ASSIGNMENTKIND
      , :new.ASSIGNMENTKINDUP
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUDSTRUCTRIGHTS
  AFTER DELETE
  ON BUDSTRUCTRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUDSTRUCTRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUH_JOURNAL
  AFTER INSERT
  ON BUH_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUH_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUH_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DAT
      ,DEBIT
      ,CREDIT
      ,REGIONCLS
      ,BUDGETREF
      ,SUMMA
      ,CURRENCY
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,ACCOUNTREF
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
      ,KVSR
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,KVSR_CORR
      ,KFSR_CORR
      ,KESR_CORR
      ,KVR_CORR
      ,KCSR_CORR
      ,KD
      ,KD_CORR
      ,IFS
      ,CLSTYPE
      ,CLSTYPE_CORR
      ,DOCNUMBER
      ,ACCEPTDATE
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,ORIGINALSUMMA
      ,ORIGINALPAYERREF
      ,ORIGINALACCEPTORREF
      ,ORIGINALNOTE
      ,ORIGINALPROGINDEX
      ,ORIGINALRECORDINDEX
      ,SOURCEPROGINDEX
      ,SOURCERECORDINDEX
      ,DESTPROGINDEX
      ,DESTRECORDINDEX
      ,FACT
      ,FACT_CORR
      ,MEANSTYPE_CORR
      ,REGIONCLS_CORR
      ,FACIALACC_CLS
      ,FACIALACC_CLS_CORR
      ,FINSOURCE
      ,FINSOURCE_CORR
      ,NOTEEX
      ,DIRECTIONCLS
      ,DIRECTIONCLS_CORR
      ,FINTYPE
      ,FINTYPE_CORR
      ,DOCTYPE
      ,DOCTYPE_CORR
      ,NEEDSENDUFK
      ,NEEDPERFORM
      ,SUBKESR
      ,SUBKESR_CORR
      ,DESTORGREF
      ,REJECT_CLS
      ,REJECTCAUSE
      ,FUNDSSOURCE
      ,FUNDSSOURCE_CORR
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,ISBLOCKED_COR
      ,BLOCKEDCAUSE_COR
      ,UNBLOCKEDDATE_COR
      ,UNBLOCKEDCAUSE_COR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DAT
      , :new.DEBIT
      , :new.CREDIT
      , :new.REGIONCLS
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CURRENCY
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.ACCOUNTREF
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.KVSR
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.KVSR_CORR
      , :new.KFSR_CORR
      , :new.KESR_CORR
      , :new.KVR_CORR
      , :new.KCSR_CORR
      , :new.KD
      , :new.KD_CORR
      , :new.IFS
      , :new.CLSTYPE
      , :new.CLSTYPE_CORR
      , :new.DOCNUMBER
      , :new.ACCEPTDATE
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.ORIGINALSUMMA
      , :new.ORIGINALPAYERREF
      , :new.ORIGINALACCEPTORREF
      , :new.ORIGINALNOTE
      , :new.ORIGINALPROGINDEX
      , :new.ORIGINALRECORDINDEX
      , :new.SOURCEPROGINDEX
      , :new.SOURCERECORDINDEX
      , :new.DESTPROGINDEX
      , :new.DESTRECORDINDEX
      , :new.FACT
      , :new.FACT_CORR
      , :new.MEANSTYPE_CORR
      , :new.REGIONCLS_CORR
      , :new.FACIALACC_CLS
      , :new.FACIALACC_CLS_CORR
      , :new.FINSOURCE
      , :new.FINSOURCE_CORR
      , :new.NOTEEX
      , :new.DIRECTIONCLS
      , :new.DIRECTIONCLS_CORR
      , :new.FINTYPE
      , :new.FINTYPE_CORR
      , :new.DOCTYPE
      , :new.DOCTYPE_CORR
      , :new.NEEDSENDUFK
      , :new.NEEDPERFORM
      , :new.SUBKESR
      , :new.SUBKESR_CORR
      , :new.DESTORGREF
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.FUNDSSOURCE
      , :new.FUNDSSOURCE_CORR
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.ISBLOCKED_COR
      , :new.BLOCKEDCAUSE_COR
      , :new.UNBLOCKEDDATE_COR
      , :new.UNBLOCKEDCAUSE_COR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUH_JOURNAL
  AFTER UPDATE
  ON BUH_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUH_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUH_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUH_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DAT
      ,DEBIT
      ,CREDIT
      ,REGIONCLS
      ,BUDGETREF
      ,SUMMA
      ,CURRENCY
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,ACCOUNTREF
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
      ,KVSR
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,KVSR_CORR
      ,KFSR_CORR
      ,KESR_CORR
      ,KVR_CORR
      ,KCSR_CORR
      ,KD
      ,KD_CORR
      ,IFS
      ,CLSTYPE
      ,CLSTYPE_CORR
      ,DOCNUMBER
      ,ACCEPTDATE
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,ORIGINALSUMMA
      ,ORIGINALPAYERREF
      ,ORIGINALACCEPTORREF
      ,ORIGINALNOTE
      ,ORIGINALPROGINDEX
      ,ORIGINALRECORDINDEX
      ,SOURCEPROGINDEX
      ,SOURCERECORDINDEX
      ,DESTPROGINDEX
      ,DESTRECORDINDEX
      ,FACT
      ,FACT_CORR
      ,MEANSTYPE_CORR
      ,REGIONCLS_CORR
      ,FACIALACC_CLS
      ,FACIALACC_CLS_CORR
      ,FINSOURCE
      ,FINSOURCE_CORR
      ,NOTEEX
      ,DIRECTIONCLS
      ,DIRECTIONCLS_CORR
      ,FINTYPE
      ,FINTYPE_CORR
      ,DOCTYPE
      ,DOCTYPE_CORR
      ,NEEDSENDUFK
      ,NEEDPERFORM
      ,SUBKESR
      ,SUBKESR_CORR
      ,DESTORGREF
      ,REJECT_CLS
      ,REJECTCAUSE
      ,FUNDSSOURCE
      ,FUNDSSOURCE_CORR
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,ISBLOCKED_COR
      ,BLOCKEDCAUSE_COR
      ,UNBLOCKEDDATE_COR
      ,UNBLOCKEDCAUSE_COR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DAT
      , :new.DEBIT
      , :new.CREDIT
      , :new.REGIONCLS
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CURRENCY
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.ACCOUNTREF
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.KVSR
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.KVSR_CORR
      , :new.KFSR_CORR
      , :new.KESR_CORR
      , :new.KVR_CORR
      , :new.KCSR_CORR
      , :new.KD
      , :new.KD_CORR
      , :new.IFS
      , :new.CLSTYPE
      , :new.CLSTYPE_CORR
      , :new.DOCNUMBER
      , :new.ACCEPTDATE
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.ORIGINALSUMMA
      , :new.ORIGINALPAYERREF
      , :new.ORIGINALACCEPTORREF
      , :new.ORIGINALNOTE
      , :new.ORIGINALPROGINDEX
      , :new.ORIGINALRECORDINDEX
      , :new.SOURCEPROGINDEX
      , :new.SOURCERECORDINDEX
      , :new.DESTPROGINDEX
      , :new.DESTRECORDINDEX
      , :new.FACT
      , :new.FACT_CORR
      , :new.MEANSTYPE_CORR
      , :new.REGIONCLS_CORR
      , :new.FACIALACC_CLS
      , :new.FACIALACC_CLS_CORR
      , :new.FINSOURCE
      , :new.FINSOURCE_CORR
      , :new.NOTEEX
      , :new.DIRECTIONCLS
      , :new.DIRECTIONCLS_CORR
      , :new.FINTYPE
      , :new.FINTYPE_CORR
      , :new.DOCTYPE
      , :new.DOCTYPE_CORR
      , :new.NEEDSENDUFK
      , :new.NEEDPERFORM
      , :new.SUBKESR
      , :new.SUBKESR_CORR
      , :new.DESTORGREF
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.FUNDSSOURCE
      , :new.FUNDSSOURCE_CORR
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.ISBLOCKED_COR
      , :new.BLOCKEDCAUSE_COR
      , :new.UNBLOCKEDDATE_COR
      , :new.UNBLOCKEDCAUSE_COR
    );
  else 
    update A_BUH_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUH_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DAT
      ,DEBIT
      ,CREDIT
      ,REGIONCLS
      ,BUDGETREF
      ,SUMMA
      ,CURRENCY
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,ACCOUNTREF
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
      ,KVSR
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,KVSR_CORR
      ,KFSR_CORR
      ,KESR_CORR
      ,KVR_CORR
      ,KCSR_CORR
      ,KD
      ,KD_CORR
      ,IFS
      ,CLSTYPE
      ,CLSTYPE_CORR
      ,DOCNUMBER
      ,ACCEPTDATE
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,ORIGINALSUMMA
      ,ORIGINALPAYERREF
      ,ORIGINALACCEPTORREF
      ,ORIGINALNOTE
      ,ORIGINALPROGINDEX
      ,ORIGINALRECORDINDEX
      ,SOURCEPROGINDEX
      ,SOURCERECORDINDEX
      ,DESTPROGINDEX
      ,DESTRECORDINDEX
      ,FACT
      ,FACT_CORR
      ,MEANSTYPE_CORR
      ,REGIONCLS_CORR
      ,FACIALACC_CLS
      ,FACIALACC_CLS_CORR
      ,FINSOURCE
      ,FINSOURCE_CORR
      ,NOTEEX
      ,DIRECTIONCLS
      ,DIRECTIONCLS_CORR
      ,FINTYPE
      ,FINTYPE_CORR
      ,DOCTYPE
      ,DOCTYPE_CORR
      ,NEEDSENDUFK
      ,NEEDPERFORM
      ,SUBKESR
      ,SUBKESR_CORR
      ,DESTORGREF
      ,REJECT_CLS
      ,REJECTCAUSE
      ,FUNDSSOURCE
      ,FUNDSSOURCE_CORR
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,ISBLOCKED_COR
      ,BLOCKEDCAUSE_COR
      ,UNBLOCKEDDATE_COR
      ,UNBLOCKEDCAUSE_COR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DAT
      , :new.DEBIT
      , :new.CREDIT
      , :new.REGIONCLS
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CURRENCY
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.ACCOUNTREF
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.KVSR
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.KVSR_CORR
      , :new.KFSR_CORR
      , :new.KESR_CORR
      , :new.KVR_CORR
      , :new.KCSR_CORR
      , :new.KD
      , :new.KD_CORR
      , :new.IFS
      , :new.CLSTYPE
      , :new.CLSTYPE_CORR
      , :new.DOCNUMBER
      , :new.ACCEPTDATE
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.ORIGINALSUMMA
      , :new.ORIGINALPAYERREF
      , :new.ORIGINALACCEPTORREF
      , :new.ORIGINALNOTE
      , :new.ORIGINALPROGINDEX
      , :new.ORIGINALRECORDINDEX
      , :new.SOURCEPROGINDEX
      , :new.SOURCERECORDINDEX
      , :new.DESTPROGINDEX
      , :new.DESTRECORDINDEX
      , :new.FACT
      , :new.FACT_CORR
      , :new.MEANSTYPE_CORR
      , :new.REGIONCLS_CORR
      , :new.FACIALACC_CLS
      , :new.FACIALACC_CLS_CORR
      , :new.FINSOURCE
      , :new.FINSOURCE_CORR
      , :new.NOTEEX
      , :new.DIRECTIONCLS
      , :new.DIRECTIONCLS_CORR
      , :new.FINTYPE
      , :new.FINTYPE_CORR
      , :new.DOCTYPE
      , :new.DOCTYPE_CORR
      , :new.NEEDSENDUFK
      , :new.NEEDPERFORM
      , :new.SUBKESR
      , :new.SUBKESR_CORR
      , :new.DESTORGREF
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.FUNDSSOURCE
      , :new.FUNDSSOURCE_CORR
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.ISBLOCKED_COR
      , :new.BLOCKEDCAUSE_COR
      , :new.UNBLOCKEDDATE_COR
      , :new.UNBLOCKEDCAUSE_COR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUH_JOURNAL
  AFTER DELETE
  ON BUH_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUH_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUHACCPLAN
  AFTER INSERT
  ON BUHACCPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUHACCPLAN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUHACCPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUHACC
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,CLSTYPE
      ,ECCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUHACC
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.CLSTYPE
      , :new.ECCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUHACCPLAN
  AFTER UPDATE
  ON BUHACCPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUHACCPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUHACCPLAN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUHACCPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUHACC
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,CLSTYPE
      ,ECCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUHACC
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.CLSTYPE
      , :new.ECCLS
    );
  else 
    update A_BUHACCPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUHACCPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUHACC
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,CLSTYPE
      ,ECCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUHACC
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.CLSTYPE
      , :new.ECCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUHACCPLAN
  AFTER DELETE
  ON BUHACCPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUHACCPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_BUHPAYMENTCLS
  AFTER INSERT
  ON BUHPAYMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUHPAYMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUHPAYMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCETYPE
      ,DESTTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_BUHPAYMENTCLS
  AFTER UPDATE
  ON BUHPAYMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_BUHPAYMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_BUHPAYMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_BUHPAYMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCETYPE
      ,DESTTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_BUHPAYMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_BUHPAYMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCETYPE
      ,DESTTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_BUHPAYMENTCLS
  AFTER DELETE
  ON BUHPAYMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_BUHPAYMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CARDS
  AFTER INSERT
  ON CARDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CARDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CARDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ACOMMENT
      ,FACIALACC_CLS
      ,CARDNUMBER
      ,ACCOUNT
      ,FULLCARDNUMBER
      ,REQUEST_NUMBER
      ,REQUEST_DATE
      ,BANKCREATEDATE
      ,CLIENTRECEIVEDATE
      ,CLIENTRETURNDATE
      ,BANKRETURNDATE
      ,CLIENTORG
      ,DOCSTATEREF
      ,EMPLOYEENAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ACOMMENT
      , :new.FACIALACC_CLS
      , :new.CARDNUMBER
      , :new.ACCOUNT
      , :new.FULLCARDNUMBER
      , :new.REQUEST_NUMBER
      , :new.REQUEST_DATE
      , :new.BANKCREATEDATE
      , :new.CLIENTRECEIVEDATE
      , :new.CLIENTRETURNDATE
      , :new.BANKRETURNDATE
      , :new.CLIENTORG
      , :new.DOCSTATEREF
      , :new.EMPLOYEENAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CARDS
  AFTER UPDATE
  ON CARDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CARDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CARDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CARDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ACOMMENT
      ,FACIALACC_CLS
      ,CARDNUMBER
      ,ACCOUNT
      ,FULLCARDNUMBER
      ,REQUEST_NUMBER
      ,REQUEST_DATE
      ,BANKCREATEDATE
      ,CLIENTRECEIVEDATE
      ,CLIENTRETURNDATE
      ,BANKRETURNDATE
      ,CLIENTORG
      ,DOCSTATEREF
      ,EMPLOYEENAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ACOMMENT
      , :new.FACIALACC_CLS
      , :new.CARDNUMBER
      , :new.ACCOUNT
      , :new.FULLCARDNUMBER
      , :new.REQUEST_NUMBER
      , :new.REQUEST_DATE
      , :new.BANKCREATEDATE
      , :new.CLIENTRECEIVEDATE
      , :new.CLIENTRETURNDATE
      , :new.BANKRETURNDATE
      , :new.CLIENTORG
      , :new.DOCSTATEREF
      , :new.EMPLOYEENAME
    );
  else 
    update A_CARDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CARDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ACOMMENT
      ,FACIALACC_CLS
      ,CARDNUMBER
      ,ACCOUNT
      ,FULLCARDNUMBER
      ,REQUEST_NUMBER
      ,REQUEST_DATE
      ,BANKCREATEDATE
      ,CLIENTRECEIVEDATE
      ,CLIENTRETURNDATE
      ,BANKRETURNDATE
      ,CLIENTORG
      ,DOCSTATEREF
      ,EMPLOYEENAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ACOMMENT
      , :new.FACIALACC_CLS
      , :new.CARDNUMBER
      , :new.ACCOUNT
      , :new.FULLCARDNUMBER
      , :new.REQUEST_NUMBER
      , :new.REQUEST_DATE
      , :new.BANKCREATEDATE
      , :new.CLIENTRECEIVEDATE
      , :new.CLIENTRETURNDATE
      , :new.BANKRETURNDATE
      , :new.CLIENTORG
      , :new.DOCSTATEREF
      , :new.EMPLOYEENAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CARDS
  AFTER DELETE
  ON CARDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CARDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CARDSDETAIL_FACC
  AFTER INSERT
  ON CARDSDETAIL_FACC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CARDSDETAIL_FACC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CARDSDETAIL_FACC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CARDSDETAIL_FACC
  AFTER UPDATE
  ON CARDSDETAIL_FACC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CARDSDETAIL_FACC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CARDSDETAIL_FACC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CARDSDETAIL_FACC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_CARDSDETAIL_FACC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CARDSDETAIL_FACC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CARDSDETAIL_FACC
  AFTER DELETE
  ON CARDSDETAIL_FACC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CARDSDETAIL_FACC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CARDSDETAIL_KESR
  AFTER INSERT
  ON CARDSDETAIL_KESR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CARDSDETAIL_KESR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CARDSDETAIL_KESR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KESR
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KESR
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CARDSDETAIL_KESR
  AFTER UPDATE
  ON CARDSDETAIL_KESR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CARDSDETAIL_KESR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CARDSDETAIL_KESR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CARDSDETAIL_KESR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KESR
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KESR
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_CARDSDETAIL_KESR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CARDSDETAIL_KESR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KESR
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KESR
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CARDSDETAIL_KESR
  AFTER DELETE
  ON CARDSDETAIL_KESR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CARDSDETAIL_KESR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CBPERCENTJOURNAL
  AFTER INSERT
  ON CBPERCENTJOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CBPERCENTJOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CBPERCENTJOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,ACCEPTDATE
      ,PERCENT
      ,NOTE
      ,ISLAST
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.ACCEPTDATE
      , :new.PERCENT
      , :new.NOTE
      , :new.ISLAST
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CBPERCENTJOURNAL
  AFTER UPDATE
  ON CBPERCENTJOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CBPERCENTJOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CBPERCENTJOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CBPERCENTJOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,ACCEPTDATE
      ,PERCENT
      ,NOTE
      ,ISLAST
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.ACCEPTDATE
      , :new.PERCENT
      , :new.NOTE
      , :new.ISLAST
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_CBPERCENTJOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CBPERCENTJOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,ACCEPTDATE
      ,PERCENT
      ,NOTE
      ,ISLAST
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.ACCEPTDATE
      , :new.PERCENT
      , :new.NOTE
      , :new.ISLAST
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CBPERCENTJOURNAL
  AFTER DELETE
  ON CBPERCENTJOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CBPERCENTJOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CLIENTDFACCOUNTLIST
  AFTER INSERT
  ON CLIENTDFACCOUNTLIST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CLIENTDFACCOUNTLIST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CLIENTDFACCOUNTLIST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,CODEFORMAT
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,TYPEINF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.CODEFORMAT
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TYPEINF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CLIENTDFACCOUNTLIST
  AFTER UPDATE
  ON CLIENTDFACCOUNTLIST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CLIENTDFACCOUNTLIST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CLIENTDFACCOUNTLIST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CLIENTDFACCOUNTLIST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,CODEFORMAT
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,TYPEINF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.CODEFORMAT
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TYPEINF
    );
  else 
    update A_CLIENTDFACCOUNTLIST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CLIENTDFACCOUNTLIST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,CODEFORMAT
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,TYPEINF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.CODEFORMAT
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TYPEINF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CLIENTDFACCOUNTLIST
  AFTER DELETE
  ON CLIENTDFACCOUNTLIST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CLIENTDFACCOUNTLIST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CLSCORRESPONDENTS
  AFTER INSERT
  ON CLSCORRESPONDENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CLSCORRESPONDENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CLSCORRESPONDENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KVR
      ,KESR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,KFSR
      ,CORRTYPE
      ,CORRBEL
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KVR
      , :new.KESR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.KFSR
      , :new.CORRTYPE
      , :new.CORRBEL
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CLSCORRESPONDENTS
  AFTER UPDATE
  ON CLSCORRESPONDENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CLSCORRESPONDENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CLSCORRESPONDENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CLSCORRESPONDENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KVR
      ,KESR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,KFSR
      ,CORRTYPE
      ,CORRBEL
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KVR
      , :new.KESR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.KFSR
      , :new.CORRTYPE
      , :new.CORRBEL
    );
  else 
    update A_CLSCORRESPONDENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CLSCORRESPONDENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KVR
      ,KESR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,KFSR
      ,CORRTYPE
      ,CORRBEL
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KVR
      , :new.KESR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.KFSR
      , :new.CORRTYPE
      , :new.CORRBEL
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CLSCORRESPONDENTS
  AFTER DELETE
  ON CLSCORRESPONDENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CLSCORRESPONDENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_COLLATERAL
  AFTER INSERT
  ON COLLATERAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COLLATERAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COLLATERAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,PROGINDEX
      ,RECORDINDEX
      ,COLLATERALTYPE
      ,SUMMA
      ,NOMINALSUMMA
      ,NAME
      ,ORG_REF
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CURRENCYCLS
      ,CURRENCYSUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.COLLATERALTYPE
      , :new.SUMMA
      , :new.NOMINALSUMMA
      , :new.NAME
      , :new.ORG_REF
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CURRENCYCLS
      , :new.CURRENCYSUMMA
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_COLLATERAL
  AFTER UPDATE
  ON COLLATERAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_COLLATERAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_COLLATERAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COLLATERAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,PROGINDEX
      ,RECORDINDEX
      ,COLLATERALTYPE
      ,SUMMA
      ,NOMINALSUMMA
      ,NAME
      ,ORG_REF
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CURRENCYCLS
      ,CURRENCYSUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.COLLATERALTYPE
      , :new.SUMMA
      , :new.NOMINALSUMMA
      , :new.NAME
      , :new.ORG_REF
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CURRENCYCLS
      , :new.CURRENCYSUMMA
    );
  else 
    update A_COLLATERAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_COLLATERAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,PROGINDEX
      ,RECORDINDEX
      ,COLLATERALTYPE
      ,SUMMA
      ,NOMINALSUMMA
      ,NAME
      ,ORG_REF
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CURRENCYCLS
      ,CURRENCYSUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.COLLATERALTYPE
      , :new.SUMMA
      , :new.NOMINALSUMMA
      , :new.NAME
      , :new.ORG_REF
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CURRENCYCLS
      , :new.CURRENCYSUMMA
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_COLLATERAL
  AFTER DELETE
  ON COLLATERAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COLLATERAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_COLLATERALTYPE
  AFTER INSERT
  ON COLLATERALTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COLLATERALTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COLLATERALTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_COLLATERALTYPE
  AFTER UPDATE
  ON COLLATERALTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_COLLATERALTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_COLLATERALTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COLLATERALTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_COLLATERALTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_COLLATERALTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_COLLATERALTYPE
  AFTER DELETE
  ON COLLATERALTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COLLATERALTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_COMMDIRECTIONEXPENCECLS
  AFTER INSERT
  ON COMMDIRECTIONEXPENCECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COMMDIRECTIONEXPENCECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COMMDIRECTIONEXPENCECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,OWNERLEVEL
      ,CREATEDATE
      ,UPDATEDATE
      ,DELETEDATE
      ,STARTDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.OWNERLEVEL
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_COMMDIRECTIONEXPENCECLS
  AFTER UPDATE
  ON COMMDIRECTIONEXPENCECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_COMMDIRECTIONEXPENCECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_COMMDIRECTIONEXPENCECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COMMDIRECTIONEXPENCECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,OWNERLEVEL
      ,CREATEDATE
      ,UPDATEDATE
      ,DELETEDATE
      ,STARTDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.OWNERLEVEL
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_COMMDIRECTIONEXPENCECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_COMMDIRECTIONEXPENCECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,OWNERLEVEL
      ,CREATEDATE
      ,UPDATEDATE
      ,DELETEDATE
      ,STARTDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.OWNERLEVEL
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_COMMDIRECTIONEXPENCECLS
  AFTER DELETE
  ON COMMDIRECTIONEXPENCECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COMMDIRECTIONEXPENCECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_COMPOUNDCLS
  AFTER INSERT
  ON COMPOUNDCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COMPOUNDCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COMPOUNDCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,PROGINDEX
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.PROGINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_COMPOUNDCLS
  AFTER UPDATE
  ON COMPOUNDCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_COMPOUNDCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_COMPOUNDCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COMPOUNDCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,PROGINDEX
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.PROGINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_COMPOUNDCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_COMPOUNDCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,PROGINDEX
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.PROGINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_COMPOUNDCLS
  AFTER DELETE
  ON COMPOUNDCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COMPOUNDCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_COMPOUNDCLSDETAIL
  AFTER INSERT
  ON COMPOUNDCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COMPOUNDCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COMPOUNDCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KESR
      ,SUBKESR
      ,FINSOURCECLS
      ,FACTCLS
      ,MEANSTYPECLS
      ,TYPEOPERATIONCLS
      ,COMPOUNDCLS
      ,PROGINDEX
      ,CREATEDATE
      ,UPDATEDATE
      ,KVSR
      ,KCSR
      ,KVR
      ,DIRECTIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KESR
      , :new.SUBKESR
      , :new.FINSOURCECLS
      , :new.FACTCLS
      , :new.MEANSTYPECLS
      , :new.TYPEOPERATIONCLS
      , :new.COMPOUNDCLS
      , :new.PROGINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.DIRECTIONCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_COMPOUNDCLSDETAIL
  AFTER UPDATE
  ON COMPOUNDCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_COMPOUNDCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_COMPOUNDCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_COMPOUNDCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KESR
      ,SUBKESR
      ,FINSOURCECLS
      ,FACTCLS
      ,MEANSTYPECLS
      ,TYPEOPERATIONCLS
      ,COMPOUNDCLS
      ,PROGINDEX
      ,CREATEDATE
      ,UPDATEDATE
      ,KVSR
      ,KCSR
      ,KVR
      ,DIRECTIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KESR
      , :new.SUBKESR
      , :new.FINSOURCECLS
      , :new.FACTCLS
      , :new.MEANSTYPECLS
      , :new.TYPEOPERATIONCLS
      , :new.COMPOUNDCLS
      , :new.PROGINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.DIRECTIONCLS
    );
  else 
    update A_COMPOUNDCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_COMPOUNDCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KESR
      ,SUBKESR
      ,FINSOURCECLS
      ,FACTCLS
      ,MEANSTYPECLS
      ,TYPEOPERATIONCLS
      ,COMPOUNDCLS
      ,PROGINDEX
      ,CREATEDATE
      ,UPDATEDATE
      ,KVSR
      ,KCSR
      ,KVR
      ,DIRECTIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KESR
      , :new.SUBKESR
      , :new.FINSOURCECLS
      , :new.FACTCLS
      , :new.MEANSTYPECLS
      , :new.TYPEOPERATIONCLS
      , :new.COMPOUNDCLS
      , :new.PROGINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.DIRECTIONCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_COMPOUNDCLSDETAIL
  AFTER DELETE
  ON COMPOUNDCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_COMPOUNDCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CONTACTPERSONS
  AFTER INSERT
  ON CONTACTPERSONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CONTACTPERSONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CONTACTPERSONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,ORGREF
      ,NAME
      ,HOLDRANK
      ,PHONENO
      ,EMAIL
      ,NOTE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.ORGREF
      , :new.NAME
      , :new.HOLDRANK
      , :new.PHONENO
      , :new.EMAIL
      , :new.NOTE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CONTACTPERSONS
  AFTER UPDATE
  ON CONTACTPERSONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CONTACTPERSONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CONTACTPERSONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CONTACTPERSONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,ORGREF
      ,NAME
      ,HOLDRANK
      ,PHONENO
      ,EMAIL
      ,NOTE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.ORGREF
      , :new.NAME
      , :new.HOLDRANK
      , :new.PHONENO
      , :new.EMAIL
      , :new.NOTE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_CONTACTPERSONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CONTACTPERSONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,ORGREF
      ,NAME
      ,HOLDRANK
      ,PHONENO
      ,EMAIL
      ,NOTE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.ORGREF
      , :new.NAME
      , :new.HOLDRANK
      , :new.PHONENO
      , :new.EMAIL
      , :new.NOTE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CONTACTPERSONS
  AFTER DELETE
  ON CONTACTPERSONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CONTACTPERSONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CORRECTIONCAPTION
  AFTER INSERT
  ON CORRECTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CORRECTIONCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CORRECTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTID
      ,BUDGETREF
      ,DOCNUMBER
      ,INPUTDATE
      ,ACCEPTDATE
      ,SUMMA
      ,NOTE
      ,DOCTYPE
      ,PROGINDEX
      ,OPERATIONDIRECTION
      ,SOURCETYPE
      ,DESTTYPE
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,ORIGINALSUMMA
      ,ORIGINALNOTE
      ,ORIGINALPROGINDEX
      ,ORIGINALRECORDINDEX
      ,ORIGINALPAYERACC_REF
      ,ORIGINALPAYERACC
      ,ORIGINALPAYERORGNAME
      ,ORIGINALPAYERORGINN20
      ,ORIGINALPAYERBANKNAME
      ,ORIGINALPAYERBANKMFO
      ,ORIGINALPAYERBANKCOR
      ,ORIGINALPAYERFKORGINN
      ,ORIGINALPAYERFKORGNAME
      ,ORIGINALPAYERFKLS
      ,ORIGINALACCEPTORACC_REF
      ,ORIGINALACCEPTORACC
      ,ORIGINALACCEPTORORGNAME
      ,ORIGINALACCEPTORORGINN20
      ,ORIGINALACCEPTORBANKNAME
      ,ORIGINALACCEPTORBANKMFO
      ,ORIGINALACCEPTORBANKCOR
      ,ORIGINALACCEPTORFKORGINN
      ,ORIGINALACCEPTORFKORGNAME
      ,ORIGINALACCEPTORFKLS
      ,REJECT_CLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ORIGINALACCEPTORFKCODE
      ,ORIGINALPAYERFKCODE
      ,ADMINACCEPTORINN
      ,ADMINACCEPTORINN20
      ,FKINN
      ,FKINN20
      ,FKNAME
      ,TERRITORIALFKINN
      ,TERRITORIALFKINN20
      ,ORIGINALPAYERORGINN
      ,ORIGINALACCEPTORORGINN
      ,ORIGINALPAYERBANKFILNAME
      ,ORIGINALACCEPTORBANKFILNAME
      ,RECORDDATE
      ,BASICNOTE
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,OKATO
      ,ELNUM
      ,FACIALACC_CLS
      ,ADDOKATO
      ,PERSONALINFO
      ,ELDOCREF
      ,REQUESTNUMBER
      ,DEPARTMENTCLS
      ,DOCCHANGEDATE
      ,SIGNERS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.INPUTDATE
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.DOCTYPE
      , :new.PROGINDEX
      , :new.OPERATIONDIRECTION
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.ORIGINALSUMMA
      , :new.ORIGINALNOTE
      , :new.ORIGINALPROGINDEX
      , :new.ORIGINALRECORDINDEX
      , :new.ORIGINALPAYERACC_REF
      , :new.ORIGINALPAYERACC
      , :new.ORIGINALPAYERORGNAME
      , :new.ORIGINALPAYERORGINN20
      , :new.ORIGINALPAYERBANKNAME
      , :new.ORIGINALPAYERBANKMFO
      , :new.ORIGINALPAYERBANKCOR
      , :new.ORIGINALPAYERFKORGINN
      , :new.ORIGINALPAYERFKORGNAME
      , :new.ORIGINALPAYERFKLS
      , :new.ORIGINALACCEPTORACC_REF
      , :new.ORIGINALACCEPTORACC
      , :new.ORIGINALACCEPTORORGNAME
      , :new.ORIGINALACCEPTORORGINN20
      , :new.ORIGINALACCEPTORBANKNAME
      , :new.ORIGINALACCEPTORBANKMFO
      , :new.ORIGINALACCEPTORBANKCOR
      , :new.ORIGINALACCEPTORFKORGINN
      , :new.ORIGINALACCEPTORFKORGNAME
      , :new.ORIGINALACCEPTORFKLS
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ORIGINALACCEPTORFKCODE
      , :new.ORIGINALPAYERFKCODE
      , :new.ADMINACCEPTORINN
      , :new.ADMINACCEPTORINN20
      , :new.FKINN
      , :new.FKINN20
      , :new.FKNAME
      , :new.TERRITORIALFKINN
      , :new.TERRITORIALFKINN20
      , :new.ORIGINALPAYERORGINN
      , :new.ORIGINALACCEPTORORGINN
      , :new.ORIGINALPAYERBANKFILNAME
      , :new.ORIGINALACCEPTORBANKFILNAME
      , :new.RECORDDATE
      , :new.BASICNOTE
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.OKATO
      , :new.ELNUM
      , :new.FACIALACC_CLS
      , :new.ADDOKATO
      , :new.PERSONALINFO
      , :new.ELDOCREF
      , :new.REQUESTNUMBER
      , :new.DEPARTMENTCLS
      , :new.DOCCHANGEDATE
      , :new.SIGNERS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CORRECTIONCAPTION
  AFTER UPDATE
  ON CORRECTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CORRECTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CORRECTIONCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CORRECTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTID
      ,BUDGETREF
      ,DOCNUMBER
      ,INPUTDATE
      ,ACCEPTDATE
      ,SUMMA
      ,NOTE
      ,DOCTYPE
      ,PROGINDEX
      ,OPERATIONDIRECTION
      ,SOURCETYPE
      ,DESTTYPE
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,ORIGINALSUMMA
      ,ORIGINALNOTE
      ,ORIGINALPROGINDEX
      ,ORIGINALRECORDINDEX
      ,ORIGINALPAYERACC_REF
      ,ORIGINALPAYERACC
      ,ORIGINALPAYERORGNAME
      ,ORIGINALPAYERORGINN20
      ,ORIGINALPAYERBANKNAME
      ,ORIGINALPAYERBANKMFO
      ,ORIGINALPAYERBANKCOR
      ,ORIGINALPAYERFKORGINN
      ,ORIGINALPAYERFKORGNAME
      ,ORIGINALPAYERFKLS
      ,ORIGINALACCEPTORACC_REF
      ,ORIGINALACCEPTORACC
      ,ORIGINALACCEPTORORGNAME
      ,ORIGINALACCEPTORORGINN20
      ,ORIGINALACCEPTORBANKNAME
      ,ORIGINALACCEPTORBANKMFO
      ,ORIGINALACCEPTORBANKCOR
      ,ORIGINALACCEPTORFKORGINN
      ,ORIGINALACCEPTORFKORGNAME
      ,ORIGINALACCEPTORFKLS
      ,REJECT_CLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ORIGINALACCEPTORFKCODE
      ,ORIGINALPAYERFKCODE
      ,ADMINACCEPTORINN
      ,ADMINACCEPTORINN20
      ,FKINN
      ,FKINN20
      ,FKNAME
      ,TERRITORIALFKINN
      ,TERRITORIALFKINN20
      ,ORIGINALPAYERORGINN
      ,ORIGINALACCEPTORORGINN
      ,ORIGINALPAYERBANKFILNAME
      ,ORIGINALACCEPTORBANKFILNAME
      ,RECORDDATE
      ,BASICNOTE
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,OKATO
      ,ELNUM
      ,FACIALACC_CLS
      ,ADDOKATO
      ,PERSONALINFO
      ,ELDOCREF
      ,REQUESTNUMBER
      ,DEPARTMENTCLS
      ,DOCCHANGEDATE
      ,SIGNERS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.INPUTDATE
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.DOCTYPE
      , :new.PROGINDEX
      , :new.OPERATIONDIRECTION
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.ORIGINALSUMMA
      , :new.ORIGINALNOTE
      , :new.ORIGINALPROGINDEX
      , :new.ORIGINALRECORDINDEX
      , :new.ORIGINALPAYERACC_REF
      , :new.ORIGINALPAYERACC
      , :new.ORIGINALPAYERORGNAME
      , :new.ORIGINALPAYERORGINN20
      , :new.ORIGINALPAYERBANKNAME
      , :new.ORIGINALPAYERBANKMFO
      , :new.ORIGINALPAYERBANKCOR
      , :new.ORIGINALPAYERFKORGINN
      , :new.ORIGINALPAYERFKORGNAME
      , :new.ORIGINALPAYERFKLS
      , :new.ORIGINALACCEPTORACC_REF
      , :new.ORIGINALACCEPTORACC
      , :new.ORIGINALACCEPTORORGNAME
      , :new.ORIGINALACCEPTORORGINN20
      , :new.ORIGINALACCEPTORBANKNAME
      , :new.ORIGINALACCEPTORBANKMFO
      , :new.ORIGINALACCEPTORBANKCOR
      , :new.ORIGINALACCEPTORFKORGINN
      , :new.ORIGINALACCEPTORFKORGNAME
      , :new.ORIGINALACCEPTORFKLS
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ORIGINALACCEPTORFKCODE
      , :new.ORIGINALPAYERFKCODE
      , :new.ADMINACCEPTORINN
      , :new.ADMINACCEPTORINN20
      , :new.FKINN
      , :new.FKINN20
      , :new.FKNAME
      , :new.TERRITORIALFKINN
      , :new.TERRITORIALFKINN20
      , :new.ORIGINALPAYERORGINN
      , :new.ORIGINALACCEPTORORGINN
      , :new.ORIGINALPAYERBANKFILNAME
      , :new.ORIGINALACCEPTORBANKFILNAME
      , :new.RECORDDATE
      , :new.BASICNOTE
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.OKATO
      , :new.ELNUM
      , :new.FACIALACC_CLS
      , :new.ADDOKATO
      , :new.PERSONALINFO
      , :new.ELDOCREF
      , :new.REQUESTNUMBER
      , :new.DEPARTMENTCLS
      , :new.DOCCHANGEDATE
      , :new.SIGNERS
    );
  else 
    update A_CORRECTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CORRECTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTID
      ,BUDGETREF
      ,DOCNUMBER
      ,INPUTDATE
      ,ACCEPTDATE
      ,SUMMA
      ,NOTE
      ,DOCTYPE
      ,PROGINDEX
      ,OPERATIONDIRECTION
      ,SOURCETYPE
      ,DESTTYPE
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,ORIGINALSUMMA
      ,ORIGINALNOTE
      ,ORIGINALPROGINDEX
      ,ORIGINALRECORDINDEX
      ,ORIGINALPAYERACC_REF
      ,ORIGINALPAYERACC
      ,ORIGINALPAYERORGNAME
      ,ORIGINALPAYERORGINN20
      ,ORIGINALPAYERBANKNAME
      ,ORIGINALPAYERBANKMFO
      ,ORIGINALPAYERBANKCOR
      ,ORIGINALPAYERFKORGINN
      ,ORIGINALPAYERFKORGNAME
      ,ORIGINALPAYERFKLS
      ,ORIGINALACCEPTORACC_REF
      ,ORIGINALACCEPTORACC
      ,ORIGINALACCEPTORORGNAME
      ,ORIGINALACCEPTORORGINN20
      ,ORIGINALACCEPTORBANKNAME
      ,ORIGINALACCEPTORBANKMFO
      ,ORIGINALACCEPTORBANKCOR
      ,ORIGINALACCEPTORFKORGINN
      ,ORIGINALACCEPTORFKORGNAME
      ,ORIGINALACCEPTORFKLS
      ,REJECT_CLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ORIGINALACCEPTORFKCODE
      ,ORIGINALPAYERFKCODE
      ,ADMINACCEPTORINN
      ,ADMINACCEPTORINN20
      ,FKINN
      ,FKINN20
      ,FKNAME
      ,TERRITORIALFKINN
      ,TERRITORIALFKINN20
      ,ORIGINALPAYERORGINN
      ,ORIGINALACCEPTORORGINN
      ,ORIGINALPAYERBANKFILNAME
      ,ORIGINALACCEPTORBANKFILNAME
      ,RECORDDATE
      ,BASICNOTE
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,OKATO
      ,ELNUM
      ,FACIALACC_CLS
      ,ADDOKATO
      ,PERSONALINFO
      ,ELDOCREF
      ,REQUESTNUMBER
      ,DEPARTMENTCLS
      ,DOCCHANGEDATE
      ,SIGNERS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.INPUTDATE
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.DOCTYPE
      , :new.PROGINDEX
      , :new.OPERATIONDIRECTION
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.ORIGINALSUMMA
      , :new.ORIGINALNOTE
      , :new.ORIGINALPROGINDEX
      , :new.ORIGINALRECORDINDEX
      , :new.ORIGINALPAYERACC_REF
      , :new.ORIGINALPAYERACC
      , :new.ORIGINALPAYERORGNAME
      , :new.ORIGINALPAYERORGINN20
      , :new.ORIGINALPAYERBANKNAME
      , :new.ORIGINALPAYERBANKMFO
      , :new.ORIGINALPAYERBANKCOR
      , :new.ORIGINALPAYERFKORGINN
      , :new.ORIGINALPAYERFKORGNAME
      , :new.ORIGINALPAYERFKLS
      , :new.ORIGINALACCEPTORACC_REF
      , :new.ORIGINALACCEPTORACC
      , :new.ORIGINALACCEPTORORGNAME
      , :new.ORIGINALACCEPTORORGINN20
      , :new.ORIGINALACCEPTORBANKNAME
      , :new.ORIGINALACCEPTORBANKMFO
      , :new.ORIGINALACCEPTORBANKCOR
      , :new.ORIGINALACCEPTORFKORGINN
      , :new.ORIGINALACCEPTORFKORGNAME
      , :new.ORIGINALACCEPTORFKLS
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ORIGINALACCEPTORFKCODE
      , :new.ORIGINALPAYERFKCODE
      , :new.ADMINACCEPTORINN
      , :new.ADMINACCEPTORINN20
      , :new.FKINN
      , :new.FKINN20
      , :new.FKNAME
      , :new.TERRITORIALFKINN
      , :new.TERRITORIALFKINN20
      , :new.ORIGINALPAYERORGINN
      , :new.ORIGINALACCEPTORORGINN
      , :new.ORIGINALPAYERBANKFILNAME
      , :new.ORIGINALACCEPTORBANKFILNAME
      , :new.RECORDDATE
      , :new.BASICNOTE
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.OKATO
      , :new.ELNUM
      , :new.FACIALACC_CLS
      , :new.ADDOKATO
      , :new.PERSONALINFO
      , :new.ELDOCREF
      , :new.REQUESTNUMBER
      , :new.DEPARTMENTCLS
      , :new.DOCCHANGEDATE
      , :new.SIGNERS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CORRECTIONCAPTION
  AFTER DELETE
  ON CORRECTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CORRECTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CURRENCYCLS
  AFTER INSERT
  ON CURRENCYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CURRENCYCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CURRENCYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,KIND
      ,VARIANT1
      ,VARIANT2
      ,VARIANT7
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.KIND
      , :new.VARIANT1
      , :new.VARIANT2
      , :new.VARIANT7
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CURRENCYCLS
  AFTER UPDATE
  ON CURRENCYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CURRENCYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CURRENCYCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CURRENCYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,KIND
      ,VARIANT1
      ,VARIANT2
      ,VARIANT7
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.KIND
      , :new.VARIANT1
      , :new.VARIANT2
      , :new.VARIANT7
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_CURRENCYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CURRENCYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,KIND
      ,VARIANT1
      ,VARIANT2
      ,VARIANT7
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.KIND
      , :new.VARIANT1
      , :new.VARIANT2
      , :new.VARIANT7
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CURRENCYCLS
  AFTER DELETE
  ON CURRENCYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CURRENCYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CURRENCYEXCHANGE
  AFTER INSERT
  ON CURRENCYEXCHANGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CURRENCYEXCHANGE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CURRENCYEXCHANGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,CURRENCY
      ,DAT
      ,ID
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,EXCHANGE
      ,MVBEXCHANGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.CURRENCY
      , :new.DAT
      , :new.ID
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.EXCHANGE
      , :new.MVBEXCHANGE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CURRENCYEXCHANGE
  AFTER UPDATE
  ON CURRENCYEXCHANGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CURRENCYEXCHANGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CURRENCYEXCHANGE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CURRENCYEXCHANGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,CURRENCY
      ,DAT
      ,ID
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,EXCHANGE
      ,MVBEXCHANGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.CURRENCY
      , :new.DAT
      , :new.ID
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.EXCHANGE
      , :new.MVBEXCHANGE
    );
  else 
    update A_CURRENCYEXCHANGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CURRENCYEXCHANGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,CURRENCY
      ,DAT
      ,ID
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,EXCHANGE
      ,MVBEXCHANGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.CURRENCY
      , :new.DAT
      , :new.ID
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.EXCHANGE
      , :new.MVBEXCHANGE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CURRENCYEXCHANGE
  AFTER DELETE
  ON CURRENCYEXCHANGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CURRENCYEXCHANGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_CURRENCYINCOMES
  AFTER INSERT
  ON CURRENCYINCOMES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CURRENCYINCOMES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CURRENCYINCOMES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURDATE
      ,CURRENCYINDEX
      ,EXCHANGEPRICE
      ,CURRENCYVALUE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURDATE
      , :new.CURRENCYINDEX
      , :new.EXCHANGEPRICE
      , :new.CURRENCYVALUE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_CURRENCYINCOMES
  AFTER UPDATE
  ON CURRENCYINCOMES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_CURRENCYINCOMES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_CURRENCYINCOMES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_CURRENCYINCOMES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURDATE
      ,CURRENCYINDEX
      ,EXCHANGEPRICE
      ,CURRENCYVALUE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURDATE
      , :new.CURRENCYINDEX
      , :new.EXCHANGEPRICE
      , :new.CURRENCYVALUE
    );
  else 
    update A_CURRENCYINCOMES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_CURRENCYINCOMES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURDATE
      ,CURRENCYINDEX
      ,EXCHANGEPRICE
      ,CURRENCYVALUE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURDATE
      , :new.CURRENCYINDEX
      , :new.EXCHANGEPRICE
      , :new.CURRENCYVALUE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_CURRENCYINCOMES
  AFTER DELETE
  ON CURRENCYINCOMES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_CURRENCYINCOMES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DATABASEVERSION
  AFTER INSERT
  ON DATABASEVERSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATABASEVERSION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and MAJOR = :new.MAJOR
      and MINOR = :new.MINOR
      and BUILD = :new.BUILD
    ;
    insert into A_DATABASEVERSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,VERSION
      ,MAJOR
      ,MINOR
      ,UPDATEDATE
      ,ACOMMENT
      ,BUILD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.VERSION
      , :new.MAJOR
      , :new.MINOR
      , :new.UPDATEDATE
      , :new.ACOMMENT
      , :new.BUILD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DATABASEVERSION
  AFTER UPDATE
  ON DATABASEVERSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.MAJOR != :old.MAJOR)
    or (:new.MINOR != :old.MINOR)
    or (:new.BUILD != :old.BUILD) then
    update A_DATABASEVERSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and MAJOR = :old.MAJOR
      and MINOR = :old.MINOR
      and BUILD = :old.BUILD
    ;
    update A_DATABASEVERSION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and MAJOR = :new.MAJOR
      and MINOR = :new.MINOR
      and BUILD = :new.BUILD
    ;
    insert into A_DATABASEVERSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,VERSION
      ,MAJOR
      ,MINOR
      ,UPDATEDATE
      ,ACOMMENT
      ,BUILD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.VERSION
      , :new.MAJOR
      , :new.MINOR
      , :new.UPDATEDATE
      , :new.ACOMMENT
      , :new.BUILD
    );
  else 
    update A_DATABASEVERSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and MAJOR = :old.MAJOR
      and MINOR = :old.MINOR
      and BUILD = :old.BUILD
    ;
    insert into A_DATABASEVERSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,VERSION
      ,MAJOR
      ,MINOR
      ,UPDATEDATE
      ,ACOMMENT
      ,BUILD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.VERSION
      , :new.MAJOR
      , :new.MINOR
      , :new.UPDATEDATE
      , :new.ACOMMENT
      , :new.BUILD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DATABASEVERSION
  AFTER DELETE
  ON DATABASEVERSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATABASEVERSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and MAJOR = :old.MAJOR
      and MINOR = :old.MINOR
      and BUILD = :old.BUILD
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DATAPACKET
  AFTER INSERT
  ON DATAPACKET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATAPACKET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATAPACKET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLIENTCODE
      ,PACKETID
      ,RECIPIENTCODE
      ,PACKETCREATEDATE
      ,REJECTDATE
      ,PACKETDELIVERYDATE
      ,REJECTDELIVERYDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,PRIMARYDOCREF
      ,NOTE
      ,RVERSION
      ,PROGINDEX
      ,CRYPTOSTATUS
      ,PACKETSTATE
      ,DOCSTATEREF
      ,ARCHIVEDOCTYPE
      ,NAME
      ,BUDGETREF
      ,RSFO
      ,DOCNUMBER
      ,REJECTCAUSE
      ,BINARYDATASIZE
      ,DATALOCATION
      ,PACKETTYPECLS
      ,FACIALACC_CLS
      ,REPORTDATE
      ,SPCONSTRAINTCRC
      ,FILECRC
      ,FORMAT
      ,DEPARTMENTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLIENTCODE
      , :new.PACKETID
      , :new.RECIPIENTCODE
      , :new.PACKETCREATEDATE
      , :new.REJECTDATE
      , :new.PACKETDELIVERYDATE
      , :new.REJECTDELIVERYDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.PRIMARYDOCREF
      , :new.NOTE
      , :new.RVERSION
      , :new.PROGINDEX
      , :new.CRYPTOSTATUS
      , :new.PACKETSTATE
      , :new.DOCSTATEREF
      , :new.ARCHIVEDOCTYPE
      , :new.NAME
      , :new.BUDGETREF
      , :new.RSFO
      , :new.DOCNUMBER
      , :new.REJECTCAUSE
      , :new.BINARYDATASIZE
      , :new.DATALOCATION
      , :new.PACKETTYPECLS
      , :new.FACIALACC_CLS
      , :new.REPORTDATE
      , :new.SPCONSTRAINTCRC
      , :new.FILECRC
      , :new.FORMAT
      , :new.DEPARTMENTCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DATAPACKET
  AFTER UPDATE
  ON DATAPACKET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DATAPACKET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DATAPACKET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATAPACKET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLIENTCODE
      ,PACKETID
      ,RECIPIENTCODE
      ,PACKETCREATEDATE
      ,REJECTDATE
      ,PACKETDELIVERYDATE
      ,REJECTDELIVERYDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,PRIMARYDOCREF
      ,NOTE
      ,RVERSION
      ,PROGINDEX
      ,CRYPTOSTATUS
      ,PACKETSTATE
      ,DOCSTATEREF
      ,ARCHIVEDOCTYPE
      ,NAME
      ,BUDGETREF
      ,RSFO
      ,DOCNUMBER
      ,REJECTCAUSE
      ,BINARYDATASIZE
      ,DATALOCATION
      ,PACKETTYPECLS
      ,FACIALACC_CLS
      ,REPORTDATE
      ,SPCONSTRAINTCRC
      ,FILECRC
      ,FORMAT
      ,DEPARTMENTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLIENTCODE
      , :new.PACKETID
      , :new.RECIPIENTCODE
      , :new.PACKETCREATEDATE
      , :new.REJECTDATE
      , :new.PACKETDELIVERYDATE
      , :new.REJECTDELIVERYDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.PRIMARYDOCREF
      , :new.NOTE
      , :new.RVERSION
      , :new.PROGINDEX
      , :new.CRYPTOSTATUS
      , :new.PACKETSTATE
      , :new.DOCSTATEREF
      , :new.ARCHIVEDOCTYPE
      , :new.NAME
      , :new.BUDGETREF
      , :new.RSFO
      , :new.DOCNUMBER
      , :new.REJECTCAUSE
      , :new.BINARYDATASIZE
      , :new.DATALOCATION
      , :new.PACKETTYPECLS
      , :new.FACIALACC_CLS
      , :new.REPORTDATE
      , :new.SPCONSTRAINTCRC
      , :new.FILECRC
      , :new.FORMAT
      , :new.DEPARTMENTCLS
    );
  else 
    update A_DATAPACKET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DATAPACKET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLIENTCODE
      ,PACKETID
      ,RECIPIENTCODE
      ,PACKETCREATEDATE
      ,REJECTDATE
      ,PACKETDELIVERYDATE
      ,REJECTDELIVERYDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,PRIMARYDOCREF
      ,NOTE
      ,RVERSION
      ,PROGINDEX
      ,CRYPTOSTATUS
      ,PACKETSTATE
      ,DOCSTATEREF
      ,ARCHIVEDOCTYPE
      ,NAME
      ,BUDGETREF
      ,RSFO
      ,DOCNUMBER
      ,REJECTCAUSE
      ,BINARYDATASIZE
      ,DATALOCATION
      ,PACKETTYPECLS
      ,FACIALACC_CLS
      ,REPORTDATE
      ,SPCONSTRAINTCRC
      ,FILECRC
      ,FORMAT
      ,DEPARTMENTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLIENTCODE
      , :new.PACKETID
      , :new.RECIPIENTCODE
      , :new.PACKETCREATEDATE
      , :new.REJECTDATE
      , :new.PACKETDELIVERYDATE
      , :new.REJECTDELIVERYDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.PRIMARYDOCREF
      , :new.NOTE
      , :new.RVERSION
      , :new.PROGINDEX
      , :new.CRYPTOSTATUS
      , :new.PACKETSTATE
      , :new.DOCSTATEREF
      , :new.ARCHIVEDOCTYPE
      , :new.NAME
      , :new.BUDGETREF
      , :new.RSFO
      , :new.DOCNUMBER
      , :new.REJECTCAUSE
      , :new.BINARYDATASIZE
      , :new.DATALOCATION
      , :new.PACKETTYPECLS
      , :new.FACIALACC_CLS
      , :new.REPORTDATE
      , :new.SPCONSTRAINTCRC
      , :new.FILECRC
      , :new.FORMAT
      , :new.DEPARTMENTCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DATAPACKET
  AFTER DELETE
  ON DATAPACKET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATAPACKET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DATAPACKETCONTENT
  AFTER INSERT
  ON DATAPACKETCONTENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATAPACKETCONTENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATAPACKETCONTENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATAPACKETTYPE
      ,DATASECTIONTYPE
      ,GENERATIONTEMPLATE
      ,PROCESSINGTEMPLATE
      ,CREATINGSCRIPTNAME
      ,PROCESSINGSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,NAME
      ,PREVIEWSCRIPTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATAPACKETTYPE
      , :new.DATASECTIONTYPE
      , :new.GENERATIONTEMPLATE
      , :new.PROCESSINGTEMPLATE
      , :new.CREATINGSCRIPTNAME
      , :new.PROCESSINGSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NAME
      , :new.PREVIEWSCRIPTNAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DATAPACKETCONTENT
  AFTER UPDATE
  ON DATAPACKETCONTENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DATAPACKETCONTENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DATAPACKETCONTENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATAPACKETCONTENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATAPACKETTYPE
      ,DATASECTIONTYPE
      ,GENERATIONTEMPLATE
      ,PROCESSINGTEMPLATE
      ,CREATINGSCRIPTNAME
      ,PROCESSINGSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,NAME
      ,PREVIEWSCRIPTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATAPACKETTYPE
      , :new.DATASECTIONTYPE
      , :new.GENERATIONTEMPLATE
      , :new.PROCESSINGTEMPLATE
      , :new.CREATINGSCRIPTNAME
      , :new.PROCESSINGSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NAME
      , :new.PREVIEWSCRIPTNAME
    );
  else 
    update A_DATAPACKETCONTENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DATAPACKETCONTENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATAPACKETTYPE
      ,DATASECTIONTYPE
      ,GENERATIONTEMPLATE
      ,PROCESSINGTEMPLATE
      ,CREATINGSCRIPTNAME
      ,PROCESSINGSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,NAME
      ,PREVIEWSCRIPTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATAPACKETTYPE
      , :new.DATASECTIONTYPE
      , :new.GENERATIONTEMPLATE
      , :new.PROCESSINGTEMPLATE
      , :new.CREATINGSCRIPTNAME
      , :new.PROCESSINGSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NAME
      , :new.PREVIEWSCRIPTNAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DATAPACKETCONTENT
  AFTER DELETE
  ON DATAPACKETCONTENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATAPACKETCONTENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DATAPACKETTYPES
  AFTER INSERT
  ON DATAPACKETTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATAPACKETTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATAPACKETTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,PERIOD
      ,PROCESSINGTYPE
      ,CREATIONPERMISSIONS
      ,ENABLED
      ,CONSTRAINTSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ARCHIVEDOCTYPE
      ,SIGNSCHEME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.PERIOD
      , :new.PROCESSINGTYPE
      , :new.CREATIONPERMISSIONS
      , :new.ENABLED
      , :new.CONSTRAINTSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ARCHIVEDOCTYPE
      , :new.SIGNSCHEME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DATAPACKETTYPES
  AFTER UPDATE
  ON DATAPACKETTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DATAPACKETTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DATAPACKETTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATAPACKETTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,PERIOD
      ,PROCESSINGTYPE
      ,CREATIONPERMISSIONS
      ,ENABLED
      ,CONSTRAINTSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ARCHIVEDOCTYPE
      ,SIGNSCHEME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.PERIOD
      , :new.PROCESSINGTYPE
      , :new.CREATIONPERMISSIONS
      , :new.ENABLED
      , :new.CONSTRAINTSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ARCHIVEDOCTYPE
      , :new.SIGNSCHEME
    );
  else 
    update A_DATAPACKETTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DATAPACKETTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,PERIOD
      ,PROCESSINGTYPE
      ,CREATIONPERMISSIONS
      ,ENABLED
      ,CONSTRAINTSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ARCHIVEDOCTYPE
      ,SIGNSCHEME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.PERIOD
      , :new.PROCESSINGTYPE
      , :new.CREATIONPERMISSIONS
      , :new.ENABLED
      , :new.CONSTRAINTSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ARCHIVEDOCTYPE
      , :new.SIGNSCHEME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DATAPACKETTYPES
  AFTER DELETE
  ON DATAPACKETTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATAPACKETTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DATASECTIONTYPES
  AFTER INSERT
  ON DATASECTIONTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATASECTIONTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATASECTIONTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATINGSCRIPTNAME
      ,PROCESSINGSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,PREVIEWSCRIPTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATINGSCRIPTNAME
      , :new.PROCESSINGSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.PREVIEWSCRIPTNAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DATASECTIONTYPES
  AFTER UPDATE
  ON DATASECTIONTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DATASECTIONTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DATASECTIONTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATASECTIONTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATINGSCRIPTNAME
      ,PROCESSINGSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,PREVIEWSCRIPTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATINGSCRIPTNAME
      , :new.PROCESSINGSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.PREVIEWSCRIPTNAME
    );
  else 
    update A_DATASECTIONTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DATASECTIONTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATINGSCRIPTNAME
      ,PROCESSINGSCRIPTNAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,PREVIEWSCRIPTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATINGSCRIPTNAME
      , :new.PROCESSINGSCRIPTNAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.PREVIEWSCRIPTNAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DATASECTIONTYPES
  AFTER DELETE
  ON DATASECTIONTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATASECTIONTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DATECONST
  AFTER INSERT
  ON DATECONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATECONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATECONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DATECONST
  AFTER UPDATE
  ON DATECONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DATECONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DATECONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DATECONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  else 
    update A_DATECONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DATECONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DATECONST
  AFTER DELETE
  ON DATECONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DATECONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DBGROUPS
  AFTER INSERT
  ON DBGROUPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DBGROUPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DBGROUPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,SYSTEMGROUPID
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.SYSTEMGROUPID
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DBGROUPS
  AFTER UPDATE
  ON DBGROUPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DBGROUPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DBGROUPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DBGROUPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,SYSTEMGROUPID
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.SYSTEMGROUPID
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_DBGROUPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DBGROUPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,SYSTEMGROUPID
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.SYSTEMGROUPID
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DBGROUPS
  AFTER DELETE
  ON DBGROUPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DBGROUPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DBRIGHTS
  AFTER INSERT
  ON DBRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DBRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DBRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OBJREF
      ,RIGHTKINDREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OBJREF
      , :new.RIGHTKINDREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DBRIGHTS
  AFTER UPDATE
  ON DBRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DBRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DBRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DBRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OBJREF
      ,RIGHTKINDREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OBJREF
      , :new.RIGHTKINDREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_DBRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DBRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OBJREF
      ,RIGHTKINDREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OBJREF
      , :new.RIGHTKINDREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DBRIGHTS
  AFTER DELETE
  ON DBRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DBRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DEBT
  AFTER INSERT
  ON DEBT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DEBT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DEBT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,PROGINDEX
      ,RECORDINDEX
      ,ACCEPTDATE
      ,RECORDDATE
      ,PLANDATE
      ,DFACCOUNT
      ,DEBIT
      ,CREDIT
      ,ACCREF
      ,IFS
      ,SUBKD
      ,DOCTYPE
      ,SOURCEDOCNUMBER
      ,REGIONCLS
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACCEPTORACCREF
      ,OFS
      ,CURRENCYCLS
      ,BUHPAYMENTCLS
      ,RECORDINDEX2
      ,TOTALREF
      ,REQUESTSINDEX
      ,TAXNOTE
      ,CURRENCYSUMMA
      ,RVERSION
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,FEDERALFUNDSREF
      ,MEANSTYPE
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,BONDCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.ACCEPTDATE
      , :new.RECORDDATE
      , :new.PLANDATE
      , :new.DFACCOUNT
      , :new.DEBIT
      , :new.CREDIT
      , :new.ACCREF
      , :new.IFS
      , :new.SUBKD
      , :new.DOCTYPE
      , :new.SOURCEDOCNUMBER
      , :new.REGIONCLS
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACCEPTORACCREF
      , :new.OFS
      , :new.CURRENCYCLS
      , :new.BUHPAYMENTCLS
      , :new.RECORDINDEX2
      , :new.TOTALREF
      , :new.REQUESTSINDEX
      , :new.TAXNOTE
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.FEDERALFUNDSREF
      , :new.MEANSTYPE
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.BONDCOUNT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DEBT
  AFTER UPDATE
  ON DEBT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DEBT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DEBT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DEBT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,PROGINDEX
      ,RECORDINDEX
      ,ACCEPTDATE
      ,RECORDDATE
      ,PLANDATE
      ,DFACCOUNT
      ,DEBIT
      ,CREDIT
      ,ACCREF
      ,IFS
      ,SUBKD
      ,DOCTYPE
      ,SOURCEDOCNUMBER
      ,REGIONCLS
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACCEPTORACCREF
      ,OFS
      ,CURRENCYCLS
      ,BUHPAYMENTCLS
      ,RECORDINDEX2
      ,TOTALREF
      ,REQUESTSINDEX
      ,TAXNOTE
      ,CURRENCYSUMMA
      ,RVERSION
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,FEDERALFUNDSREF
      ,MEANSTYPE
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,BONDCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.ACCEPTDATE
      , :new.RECORDDATE
      , :new.PLANDATE
      , :new.DFACCOUNT
      , :new.DEBIT
      , :new.CREDIT
      , :new.ACCREF
      , :new.IFS
      , :new.SUBKD
      , :new.DOCTYPE
      , :new.SOURCEDOCNUMBER
      , :new.REGIONCLS
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACCEPTORACCREF
      , :new.OFS
      , :new.CURRENCYCLS
      , :new.BUHPAYMENTCLS
      , :new.RECORDINDEX2
      , :new.TOTALREF
      , :new.REQUESTSINDEX
      , :new.TAXNOTE
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.FEDERALFUNDSREF
      , :new.MEANSTYPE
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.BONDCOUNT
    );
  else 
    update A_DEBT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DEBT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,PROGINDEX
      ,RECORDINDEX
      ,ACCEPTDATE
      ,RECORDDATE
      ,PLANDATE
      ,DFACCOUNT
      ,DEBIT
      ,CREDIT
      ,ACCREF
      ,IFS
      ,SUBKD
      ,DOCTYPE
      ,SOURCEDOCNUMBER
      ,REGIONCLS
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACCEPTORACCREF
      ,OFS
      ,CURRENCYCLS
      ,BUHPAYMENTCLS
      ,RECORDINDEX2
      ,TOTALREF
      ,REQUESTSINDEX
      ,TAXNOTE
      ,CURRENCYSUMMA
      ,RVERSION
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,FEDERALFUNDSREF
      ,MEANSTYPE
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,BONDCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.ACCEPTDATE
      , :new.RECORDDATE
      , :new.PLANDATE
      , :new.DFACCOUNT
      , :new.DEBIT
      , :new.CREDIT
      , :new.ACCREF
      , :new.IFS
      , :new.SUBKD
      , :new.DOCTYPE
      , :new.SOURCEDOCNUMBER
      , :new.REGIONCLS
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACCEPTORACCREF
      , :new.OFS
      , :new.CURRENCYCLS
      , :new.BUHPAYMENTCLS
      , :new.RECORDINDEX2
      , :new.TOTALREF
      , :new.REQUESTSINDEX
      , :new.TAXNOTE
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.FEDERALFUNDSREF
      , :new.MEANSTYPE
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.BONDCOUNT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DEBT
  AFTER DELETE
  ON DEBT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DEBT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DEBTTYPE
  AFTER INSERT
  ON DEBTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DEBTTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DEBTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,BUHACCOUNT
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUHACCOUNT
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DEBTTYPE
  AFTER UPDATE
  ON DEBTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DEBTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DEBTTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DEBTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,BUHACCOUNT
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUHACCOUNT
      , :new.NAME
    );
  else 
    update A_DEBTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DEBTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,BUHACCOUNT
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUHACCOUNT
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DEBTTYPE
  AFTER DELETE
  ON DEBTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DEBTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOCORRESPONDENT
  AFTER INSERT
  ON DELOCORRESPONDENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOCORRESPONDENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOCORRESPONDENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOCORRESPONDENT
  AFTER UPDATE
  ON DELOCORRESPONDENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOCORRESPONDENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOCORRESPONDENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOCORRESPONDENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_DELOCORRESPONDENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOCORRESPONDENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOCORRESPONDENT
  AFTER DELETE
  ON DELOCORRESPONDENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOCORRESPONDENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOEXEC
  AFTER INSERT
  ON DELOEXEC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOEXEC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOEXEC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,OTDEL
      ,EXECUTOR
      ,DATETO
      ,DATEBACK
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.OTDEL
      , :new.EXECUTOR
      , :new.DATETO
      , :new.DATEBACK
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOEXEC
  AFTER UPDATE
  ON DELOEXEC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOEXEC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOEXEC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOEXEC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,OTDEL
      ,EXECUTOR
      ,DATETO
      ,DATEBACK
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.OTDEL
      , :new.EXECUTOR
      , :new.DATETO
      , :new.DATEBACK
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_DELOEXEC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOEXEC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,OTDEL
      ,EXECUTOR
      ,DATETO
      ,DATEBACK
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.OTDEL
      , :new.EXECUTOR
      , :new.DATETO
      , :new.DATEBACK
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOEXEC
  AFTER DELETE
  ON DELOEXEC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOEXEC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOEXECUTOR
  AFTER INSERT
  ON DELOEXECUTOR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOEXECUTOR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOEXECUTOR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,FULLNAME
      ,PHONE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.FULLNAME
      , :new.PHONE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOEXECUTOR
  AFTER UPDATE
  ON DELOEXECUTOR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOEXECUTOR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOEXECUTOR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOEXECUTOR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,FULLNAME
      ,PHONE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.FULLNAME
      , :new.PHONE
    );
  else 
    update A_DELOEXECUTOR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOEXECUTOR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,FULLNAME
      ,PHONE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.FULLNAME
      , :new.PHONE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOEXECUTOR
  AFTER DELETE
  ON DELOEXECUTOR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOEXECUTOR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOGRIF
  AFTER INSERT
  ON DELOGRIF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOGRIF
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOGRIF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOGRIF
  AFTER UPDATE
  ON DELOGRIF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOGRIF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOGRIF
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOGRIF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_DELOGRIF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOGRIF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOGRIF
  AFTER DELETE
  ON DELOGRIF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOGRIF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOIN
  AFTER INSERT
  ON DELOIN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOIN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOIN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDOC
      ,NUMBERIN
      ,DATEIN
      ,CORRESPONDENT
      ,DATEOUT
      ,NUMBEROUT
      ,RESOLUTION
      ,DATEEXEC
      ,GRIF
      ,DATEANSWER
      ,TOM
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NEEDCARD
      ,DELO
      ,CONTENTS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDOC
      , :new.NUMBERIN
      , :new.DATEIN
      , :new.CORRESPONDENT
      , :new.DATEOUT
      , :new.NUMBEROUT
      , :new.RESOLUTION
      , :new.DATEEXEC
      , :new.GRIF
      , :new.DATEANSWER
      , :new.TOM
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NEEDCARD
      , :new.DELO
      , :new.CONTENTS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOIN
  AFTER UPDATE
  ON DELOIN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOIN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOIN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOIN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDOC
      ,NUMBERIN
      ,DATEIN
      ,CORRESPONDENT
      ,DATEOUT
      ,NUMBEROUT
      ,RESOLUTION
      ,DATEEXEC
      ,GRIF
      ,DATEANSWER
      ,TOM
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NEEDCARD
      ,DELO
      ,CONTENTS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDOC
      , :new.NUMBERIN
      , :new.DATEIN
      , :new.CORRESPONDENT
      , :new.DATEOUT
      , :new.NUMBEROUT
      , :new.RESOLUTION
      , :new.DATEEXEC
      , :new.GRIF
      , :new.DATEANSWER
      , :new.TOM
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NEEDCARD
      , :new.DELO
      , :new.CONTENTS
    );
  else 
    update A_DELOIN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOIN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDOC
      ,NUMBERIN
      ,DATEIN
      ,CORRESPONDENT
      ,DATEOUT
      ,NUMBEROUT
      ,RESOLUTION
      ,DATEEXEC
      ,GRIF
      ,DATEANSWER
      ,TOM
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NEEDCARD
      ,DELO
      ,CONTENTS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDOC
      , :new.NUMBERIN
      , :new.DATEIN
      , :new.CORRESPONDENT
      , :new.DATEOUT
      , :new.NUMBEROUT
      , :new.RESOLUTION
      , :new.DATEEXEC
      , :new.GRIF
      , :new.DATEANSWER
      , :new.TOM
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NEEDCARD
      , :new.DELO
      , :new.CONTENTS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOIN
  AFTER DELETE
  ON DELOIN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOIN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOOTDEL
  AFTER INSERT
  ON DELOOTDEL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOOTDEL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOOTDEL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GR1
      ,GR2
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GR1
      , :new.GR2
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOOTDEL
  AFTER UPDATE
  ON DELOOTDEL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOOTDEL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOOTDEL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOOTDEL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GR1
      ,GR2
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GR1
      , :new.GR2
    );
  else 
    update A_DELOOTDEL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOOTDEL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GR1
      ,GR2
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GR1
      , :new.GR2
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOOTDEL
  AFTER DELETE
  ON DELOOTDEL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOOTDEL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELOOUT
  AFTER INSERT
  ON DELOOUT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOOUT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOOUT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDOC
      ,CORRESPONDENT
      ,DATEOUT
      ,NUMBEROUT
      ,CONTENTS
      ,GRIF
      ,EXECUTOR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDOC
      , :new.CORRESPONDENT
      , :new.DATEOUT
      , :new.NUMBEROUT
      , :new.CONTENTS
      , :new.GRIF
      , :new.EXECUTOR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELOOUT
  AFTER UPDATE
  ON DELOOUT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELOOUT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELOOUT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELOOUT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDOC
      ,CORRESPONDENT
      ,DATEOUT
      ,NUMBEROUT
      ,CONTENTS
      ,GRIF
      ,EXECUTOR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDOC
      , :new.CORRESPONDENT
      , :new.DATEOUT
      , :new.NUMBEROUT
      , :new.CONTENTS
      , :new.GRIF
      , :new.EXECUTOR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_DELOOUT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELOOUT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDOC
      ,CORRESPONDENT
      ,DATEOUT
      ,NUMBEROUT
      ,CONTENTS
      ,GRIF
      ,EXECUTOR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDOC
      , :new.CORRESPONDENT
      , :new.DATEOUT
      , :new.NUMBEROUT
      , :new.CONTENTS
      , :new.GRIF
      , :new.EXECUTOR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELOOUT
  AFTER DELETE
  ON DELOOUT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELOOUT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DELORESOLUTION
  AFTER INSERT
  ON DELORESOLUTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELORESOLUTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELORESOLUTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DELORESOLUTION
  AFTER UPDATE
  ON DELORESOLUTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DELORESOLUTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DELORESOLUTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DELORESOLUTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_DELORESOLUTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DELORESOLUTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DELORESOLUTION
  AFTER DELETE
  ON DELORESOLUTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DELORESOLUTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DEPARTMENTCLS
  AFTER INSERT
  ON DEPARTMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DEPARTMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DEPARTMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,USER_REF
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.USER_REF
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DEPARTMENTCLS
  AFTER UPDATE
  ON DEPARTMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DEPARTMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DEPARTMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DEPARTMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,USER_REF
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.USER_REF
      , :new.NAME
    );
  else 
    update A_DEPARTMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DEPARTMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,USER_REF
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.USER_REF
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DEPARTMENTCLS
  AFTER DELETE
  ON DEPARTMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DEPARTMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DESCRDOCUMENTFIELDS
  AFTER INSERT
  ON DESCRDOCUMENTFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DESCRDOCUMENTFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DESCRDOCUMENTFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,VISUALFIELDTYPE
      ,NAME
      ,DBFIELDNAME
      ,SOURCENAME
      ,DOCTYPEREF
      ,GROUPTYPE
      ,FIELDSIZE
      ,FIELDMASK
      ,VALUEREQUIRED
      ,DEFAULTVALUE
      ,VISIBLE
      ,DISPLAYLABEL
      ,SOURCEDOCTYPEREF
      ,SYSTEMFIELDTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,FIELDTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.VISUALFIELDTYPE
      , :new.NAME
      , :new.DBFIELDNAME
      , :new.SOURCENAME
      , :new.DOCTYPEREF
      , :new.GROUPTYPE
      , :new.FIELDSIZE
      , :new.FIELDMASK
      , :new.VALUEREQUIRED
      , :new.DEFAULTVALUE
      , :new.VISIBLE
      , :new.DISPLAYLABEL
      , :new.SOURCEDOCTYPEREF
      , :new.SYSTEMFIELDTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.FIELDTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DESCRDOCUMENTFIELDS
  AFTER UPDATE
  ON DESCRDOCUMENTFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DESCRDOCUMENTFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DESCRDOCUMENTFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DESCRDOCUMENTFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,VISUALFIELDTYPE
      ,NAME
      ,DBFIELDNAME
      ,SOURCENAME
      ,DOCTYPEREF
      ,GROUPTYPE
      ,FIELDSIZE
      ,FIELDMASK
      ,VALUEREQUIRED
      ,DEFAULTVALUE
      ,VISIBLE
      ,DISPLAYLABEL
      ,SOURCEDOCTYPEREF
      ,SYSTEMFIELDTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,FIELDTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.VISUALFIELDTYPE
      , :new.NAME
      , :new.DBFIELDNAME
      , :new.SOURCENAME
      , :new.DOCTYPEREF
      , :new.GROUPTYPE
      , :new.FIELDSIZE
      , :new.FIELDMASK
      , :new.VALUEREQUIRED
      , :new.DEFAULTVALUE
      , :new.VISIBLE
      , :new.DISPLAYLABEL
      , :new.SOURCEDOCTYPEREF
      , :new.SYSTEMFIELDTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.FIELDTYPE
    );
  else 
    update A_DESCRDOCUMENTFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DESCRDOCUMENTFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,VISUALFIELDTYPE
      ,NAME
      ,DBFIELDNAME
      ,SOURCENAME
      ,DOCTYPEREF
      ,GROUPTYPE
      ,FIELDSIZE
      ,FIELDMASK
      ,VALUEREQUIRED
      ,DEFAULTVALUE
      ,VISIBLE
      ,DISPLAYLABEL
      ,SOURCEDOCTYPEREF
      ,SYSTEMFIELDTYPE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,FIELDTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.VISUALFIELDTYPE
      , :new.NAME
      , :new.DBFIELDNAME
      , :new.SOURCENAME
      , :new.DOCTYPEREF
      , :new.GROUPTYPE
      , :new.FIELDSIZE
      , :new.FIELDMASK
      , :new.VALUEREQUIRED
      , :new.DEFAULTVALUE
      , :new.VISIBLE
      , :new.DISPLAYLABEL
      , :new.SOURCEDOCTYPEREF
      , :new.SYSTEMFIELDTYPE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.FIELDTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DESCRDOCUMENTFIELDS
  AFTER DELETE
  ON DESCRDOCUMENTFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DESCRDOCUMENTFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DFACCOUNTOPERATION
  AFTER INSERT
  ON DFACCOUNTOPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DFACCOUNTOPERATION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DFACCOUNTOPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,SDFACCOUNT
      ,DDFACCOUNT
      ,REGIONCLS
      ,BUDGETREF
      ,SUMMA
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,BUHOPERATIONCLS
      ,MEANSTYPE
      ,DOCNUMBER
      ,FUNDSSOURCE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,FACT
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.SDFACCOUNT
      , :new.DDFACCOUNT
      , :new.REGIONCLS
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUHOPERATIONCLS
      , :new.MEANSTYPE
      , :new.DOCNUMBER
      , :new.FUNDSSOURCE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.FACT
      , :new.TRANSFERTCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DFACCOUNTOPERATION
  AFTER UPDATE
  ON DFACCOUNTOPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DFACCOUNTOPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DFACCOUNTOPERATION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DFACCOUNTOPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,SDFACCOUNT
      ,DDFACCOUNT
      ,REGIONCLS
      ,BUDGETREF
      ,SUMMA
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,BUHOPERATIONCLS
      ,MEANSTYPE
      ,DOCNUMBER
      ,FUNDSSOURCE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,FACT
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.SDFACCOUNT
      , :new.DDFACCOUNT
      , :new.REGIONCLS
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUHOPERATIONCLS
      , :new.MEANSTYPE
      , :new.DOCNUMBER
      , :new.FUNDSSOURCE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.FACT
      , :new.TRANSFERTCLS
    );
  else 
    update A_DFACCOUNTOPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DFACCOUNTOPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,SDFACCOUNT
      ,DDFACCOUNT
      ,REGIONCLS
      ,BUDGETREF
      ,SUMMA
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,BUHOPERATIONCLS
      ,MEANSTYPE
      ,DOCNUMBER
      ,FUNDSSOURCE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,FACT
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.SDFACCOUNT
      , :new.DDFACCOUNT
      , :new.REGIONCLS
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUHOPERATIONCLS
      , :new.MEANSTYPE
      , :new.DOCNUMBER
      , :new.FUNDSSOURCE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.FACT
      , :new.TRANSFERTCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DFACCOUNTOPERATION
  AFTER DELETE
  ON DFACCOUNTOPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DFACCOUNTOPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DFUCHANGELOG
  AFTER INSERT
  ON DFUCHANGELOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DFUCHANGELOG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DFUCHANGELOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,VERSIONID
      ,BEGINUPDATECODE
      ,ENDUPDATECODE
      ,LASTUPDATEDFU
      ,ISBUDGET
      ,INCLUDEDEL
      ,INCLUDEBLOCKS
      ,INCLUDEDOCS
      ,SCRIPTCREATOR
      ,SCRIPTCREATEDATE
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.VERSIONID
      , :new.BEGINUPDATECODE
      , :new.ENDUPDATECODE
      , :new.LASTUPDATEDFU
      , :new.ISBUDGET
      , :new.INCLUDEDEL
      , :new.INCLUDEBLOCKS
      , :new.INCLUDEDOCS
      , :new.SCRIPTCREATOR
      , :new.SCRIPTCREATEDATE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DFUCHANGELOG
  AFTER UPDATE
  ON DFUCHANGELOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DFUCHANGELOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DFUCHANGELOG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DFUCHANGELOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,VERSIONID
      ,BEGINUPDATECODE
      ,ENDUPDATECODE
      ,LASTUPDATEDFU
      ,ISBUDGET
      ,INCLUDEDEL
      ,INCLUDEBLOCKS
      ,INCLUDEDOCS
      ,SCRIPTCREATOR
      ,SCRIPTCREATEDATE
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.VERSIONID
      , :new.BEGINUPDATECODE
      , :new.ENDUPDATECODE
      , :new.LASTUPDATEDFU
      , :new.ISBUDGET
      , :new.INCLUDEDEL
      , :new.INCLUDEBLOCKS
      , :new.INCLUDEDOCS
      , :new.SCRIPTCREATOR
      , :new.SCRIPTCREATEDATE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  else 
    update A_DFUCHANGELOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DFUCHANGELOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,VERSIONID
      ,BEGINUPDATECODE
      ,ENDUPDATECODE
      ,LASTUPDATEDFU
      ,ISBUDGET
      ,INCLUDEDEL
      ,INCLUDEBLOCKS
      ,INCLUDEDOCS
      ,SCRIPTCREATOR
      ,SCRIPTCREATEDATE
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.VERSIONID
      , :new.BEGINUPDATECODE
      , :new.ENDUPDATECODE
      , :new.LASTUPDATEDFU
      , :new.ISBUDGET
      , :new.INCLUDEDEL
      , :new.INCLUDEBLOCKS
      , :new.INCLUDEDOCS
      , :new.SCRIPTCREATOR
      , :new.SCRIPTCREATEDATE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DFUCHANGELOG
  AFTER DELETE
  ON DFUCHANGELOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DFUCHANGELOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DIRECTIONCLS
  AFTER INSERT
  ON DIRECTIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DIRECTIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DIRECTIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DIRECTIONCLS
  AFTER UPDATE
  ON DIRECTIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DIRECTIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DIRECTIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DIRECTIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_DIRECTIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DIRECTIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DIRECTIONCLS
  AFTER DELETE
  ON DIRECTIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DIRECTIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCBASE
  AFTER INSERT
  ON DOCBASE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCBASE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCBASE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCUMENTBASEDATE
      ,DOCUMENTBASENUM
      ,NAME
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,STARTDATE
      ,KVSR
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCUMENTBASEDATE
      , :new.DOCUMENTBASENUM
      , :new.NAME
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.KVSR
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCBASE
  AFTER UPDATE
  ON DOCBASE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCBASE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCBASE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCBASE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCUMENTBASEDATE
      ,DOCUMENTBASENUM
      ,NAME
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,STARTDATE
      ,KVSR
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCUMENTBASEDATE
      , :new.DOCUMENTBASENUM
      , :new.NAME
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.KVSR
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_DOCBASE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCBASE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCUMENTBASEDATE
      ,DOCUMENTBASENUM
      ,NAME
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,STARTDATE
      ,KVSR
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCUMENTBASEDATE
      , :new.DOCUMENTBASENUM
      , :new.NAME
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.KVSR
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCBASE
  AFTER DELETE
  ON DOCBASE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCBASE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCLOCK
  AFTER INSERT
  ON DOCLOCK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCLOCK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCLOCK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LOCKMASK
      ,DOCREF
      ,DETAILNUM
      ,RUNPOS
      ,LOCKACTION
      ,USERIGHTS
      ,FORDELETE
      ,ISSYSTEM
      ,FORINSERT
      ,DOCPARAM
      ,VALIDATEMESSAGE
      ,FORMULA
      ,VALIDATELEVEL
      ,VALIDATEFILTER
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LOCKMASK
      , :new.DOCREF
      , :new.DETAILNUM
      , :new.RUNPOS
      , :new.LOCKACTION
      , :new.USERIGHTS
      , :new.FORDELETE
      , :new.ISSYSTEM
      , :new.FORINSERT
      , :new.DOCPARAM
      , :new.VALIDATEMESSAGE
      , :new.FORMULA
      , :new.VALIDATELEVEL
      , :new.VALIDATEFILTER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCLOCK
  AFTER UPDATE
  ON DOCLOCK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCLOCK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCLOCK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCLOCK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LOCKMASK
      ,DOCREF
      ,DETAILNUM
      ,RUNPOS
      ,LOCKACTION
      ,USERIGHTS
      ,FORDELETE
      ,ISSYSTEM
      ,FORINSERT
      ,DOCPARAM
      ,VALIDATEMESSAGE
      ,FORMULA
      ,VALIDATELEVEL
      ,VALIDATEFILTER
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LOCKMASK
      , :new.DOCREF
      , :new.DETAILNUM
      , :new.RUNPOS
      , :new.LOCKACTION
      , :new.USERIGHTS
      , :new.FORDELETE
      , :new.ISSYSTEM
      , :new.FORINSERT
      , :new.DOCPARAM
      , :new.VALIDATEMESSAGE
      , :new.FORMULA
      , :new.VALIDATELEVEL
      , :new.VALIDATEFILTER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
      , :new.NOTE
    );
  else 
    update A_DOCLOCK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCLOCK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LOCKMASK
      ,DOCREF
      ,DETAILNUM
      ,RUNPOS
      ,LOCKACTION
      ,USERIGHTS
      ,FORDELETE
      ,ISSYSTEM
      ,FORINSERT
      ,DOCPARAM
      ,VALIDATEMESSAGE
      ,FORMULA
      ,VALIDATELEVEL
      ,VALIDATEFILTER
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LOCKMASK
      , :new.DOCREF
      , :new.DETAILNUM
      , :new.RUNPOS
      , :new.LOCKACTION
      , :new.USERIGHTS
      , :new.FORDELETE
      , :new.ISSYSTEM
      , :new.FORINSERT
      , :new.DOCPARAM
      , :new.VALIDATEMESSAGE
      , :new.FORMULA
      , :new.VALIDATELEVEL
      , :new.VALIDATEFILTER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCLOCK
  AFTER DELETE
  ON DOCLOCK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCLOCK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCLOCKFIELDS
  AFTER INSERT
  ON DOCLOCKFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCLOCKFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCLOCKFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCLOCKREF
      ,FIELDREF
      ,ISSYSTEM
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCLOCKREF
      , :new.FIELDREF
      , :new.ISSYSTEM
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCLOCKFIELDS
  AFTER UPDATE
  ON DOCLOCKFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCLOCKFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCLOCKFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCLOCKFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCLOCKREF
      ,FIELDREF
      ,ISSYSTEM
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCLOCKREF
      , :new.FIELDREF
      , :new.ISSYSTEM
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_DOCLOCKFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCLOCKFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCLOCKREF
      ,FIELDREF
      ,ISSYSTEM
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCLOCKREF
      , :new.FIELDREF
      , :new.ISSYSTEM
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCLOCKFIELDS
  AFTER DELETE
  ON DOCLOCKFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCLOCKFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCTYPES
  AFTER INSERT
  ON DOCTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,RVERSION
      ,REGISTRATIONTYPE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RVERSION
      , :new.REGISTRATIONTYPE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCTYPES
  AFTER UPDATE
  ON DOCTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,RVERSION
      ,REGISTRATIONTYPE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RVERSION
      , :new.REGISTRATIONTYPE
      , :new.NAME
    );
  else 
    update A_DOCTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,RVERSION
      ,REGISTRATIONTYPE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RVERSION
      , :new.REGISTRATIONTYPE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCTYPES
  AFTER DELETE
  ON DOCTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCUMENTCLS
  AFTER INSERT
  ON DOCUMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCTYPENOTE
      ,TABLENAME
      ,TABLENAMEURM
      ,PRIMARYKEYNAME
      ,PRIMARYKEYNAMEURM
      ,LINKFIELDNAME
      ,LINKFIELDNAMEURM
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CLSTYPE
      ,TEMPLATEVISIBLE
      ,SELECTIONREFBUDGET
      ,SELECTIONREFURM
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCTYPENOTE
      , :new.TABLENAME
      , :new.TABLENAMEURM
      , :new.PRIMARYKEYNAME
      , :new.PRIMARYKEYNAMEURM
      , :new.LINKFIELDNAME
      , :new.LINKFIELDNAMEURM
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CLSTYPE
      , :new.TEMPLATEVISIBLE
      , :new.SELECTIONREFBUDGET
      , :new.SELECTIONREFURM
      , :new.PROGINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCUMENTCLS
  AFTER UPDATE
  ON DOCUMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCUMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCUMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCTYPENOTE
      ,TABLENAME
      ,TABLENAMEURM
      ,PRIMARYKEYNAME
      ,PRIMARYKEYNAMEURM
      ,LINKFIELDNAME
      ,LINKFIELDNAMEURM
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CLSTYPE
      ,TEMPLATEVISIBLE
      ,SELECTIONREFBUDGET
      ,SELECTIONREFURM
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCTYPENOTE
      , :new.TABLENAME
      , :new.TABLENAMEURM
      , :new.PRIMARYKEYNAME
      , :new.PRIMARYKEYNAMEURM
      , :new.LINKFIELDNAME
      , :new.LINKFIELDNAMEURM
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CLSTYPE
      , :new.TEMPLATEVISIBLE
      , :new.SELECTIONREFBUDGET
      , :new.SELECTIONREFURM
      , :new.PROGINDEX
    );
  else 
    update A_DOCUMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCUMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCTYPENOTE
      ,TABLENAME
      ,TABLENAMEURM
      ,PRIMARYKEYNAME
      ,PRIMARYKEYNAMEURM
      ,LINKFIELDNAME
      ,LINKFIELDNAMEURM
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CLSTYPE
      ,TEMPLATEVISIBLE
      ,SELECTIONREFBUDGET
      ,SELECTIONREFURM
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCTYPENOTE
      , :new.TABLENAME
      , :new.TABLENAMEURM
      , :new.PRIMARYKEYNAME
      , :new.PRIMARYKEYNAMEURM
      , :new.LINKFIELDNAME
      , :new.LINKFIELDNAMEURM
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CLSTYPE
      , :new.TEMPLATEVISIBLE
      , :new.SELECTIONREFBUDGET
      , :new.SELECTIONREFURM
      , :new.PROGINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCUMENTCLS
  AFTER DELETE
  ON DOCUMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCUMENTTEMPLATE
  AFTER INSERT
  ON DOCUMENTTEMPLATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTTEMPLATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTTEMPLATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTCLSREF
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTCLSREF
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCUMENTTEMPLATE
  AFTER UPDATE
  ON DOCUMENTTEMPLATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCUMENTTEMPLATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCUMENTTEMPLATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTTEMPLATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTCLSREF
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTCLSREF
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_DOCUMENTTEMPLATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCUMENTTEMPLATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTCLSREF
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTCLSREF
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCUMENTTEMPLATE
  AFTER DELETE
  ON DOCUMENTTEMPLATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTTEMPLATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCUMENTTEMPLATEFIELDS
  AFTER INSERT
  ON DOCUMENTTEMPLATEFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTTEMPLATEFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTTEMPLATEFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTCLSREF
      ,FIELDS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTCLSREF
      , :new.FIELDS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCUMENTTEMPLATEFIELDS
  AFTER UPDATE
  ON DOCUMENTTEMPLATEFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCUMENTTEMPLATEFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCUMENTTEMPLATEFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTTEMPLATEFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTCLSREF
      ,FIELDS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTCLSREF
      , :new.FIELDS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_DOCUMENTTEMPLATEFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCUMENTTEMPLATEFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTCLSREF
      ,FIELDS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTCLSREF
      , :new.FIELDS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCUMENTTEMPLATEFIELDS
  AFTER DELETE
  ON DOCUMENTTEMPLATEFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTTEMPLATEFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DOCUMENTTYPES
  AFTER INSERT
  ON DOCUMENTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,NAME
      ,NOTE
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,USESTATE
      ,DBTABLE
      ,NEEDEDS
      ,URMDBTABLE
      ,ICONCOLLECTION
      ,NEEDHIDEEDSFORM
      ,SCHEMAVERSION
      ,LOCKMASK
      ,DEFAULTACTIONMACROSNAME
      ,DOCUMENTKIND
      ,SHORTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.NAME
      , :new.NOTE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.USESTATE
      , :new.DBTABLE
      , :new.NEEDEDS
      , :new.URMDBTABLE
      , :new.ICONCOLLECTION
      , :new.NEEDHIDEEDSFORM
      , :new.SCHEMAVERSION
      , :new.LOCKMASK
      , :new.DEFAULTACTIONMACROSNAME
      , :new.DOCUMENTKIND
      , :new.SHORTNAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DOCUMENTTYPES
  AFTER UPDATE
  ON DOCUMENTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DOCUMENTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DOCUMENTTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DOCUMENTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,NAME
      ,NOTE
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,USESTATE
      ,DBTABLE
      ,NEEDEDS
      ,URMDBTABLE
      ,ICONCOLLECTION
      ,NEEDHIDEEDSFORM
      ,SCHEMAVERSION
      ,LOCKMASK
      ,DEFAULTACTIONMACROSNAME
      ,DOCUMENTKIND
      ,SHORTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.NAME
      , :new.NOTE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.USESTATE
      , :new.DBTABLE
      , :new.NEEDEDS
      , :new.URMDBTABLE
      , :new.ICONCOLLECTION
      , :new.NEEDHIDEEDSFORM
      , :new.SCHEMAVERSION
      , :new.LOCKMASK
      , :new.DEFAULTACTIONMACROSNAME
      , :new.DOCUMENTKIND
      , :new.SHORTNAME
    );
  else 
    update A_DOCUMENTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DOCUMENTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,NAME
      ,NOTE
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,USESTATE
      ,DBTABLE
      ,NEEDEDS
      ,URMDBTABLE
      ,ICONCOLLECTION
      ,NEEDHIDEEDSFORM
      ,SCHEMAVERSION
      ,LOCKMASK
      ,DEFAULTACTIONMACROSNAME
      ,DOCUMENTKIND
      ,SHORTNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.NAME
      , :new.NOTE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.USESTATE
      , :new.DBTABLE
      , :new.NEEDEDS
      , :new.URMDBTABLE
      , :new.ICONCOLLECTION
      , :new.NEEDHIDEEDSFORM
      , :new.SCHEMAVERSION
      , :new.LOCKMASK
      , :new.DEFAULTACTIONMACROSNAME
      , :new.DOCUMENTKIND
      , :new.SHORTNAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DOCUMENTTYPES
  AFTER DELETE
  ON DOCUMENTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DOCUMENTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_DUALRIGHTS
  AFTER INSERT
  ON DUALRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DUALRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DUALRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,ISGROUP
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF1
      ,OBJREF2
      ,CREATEDATE
      ,UPDATEDATE
      ,OBJREF1UP
      ,OBJREF2UP
      ,RIGHTKINDREF
      ,OBJECTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.ISGROUP
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF1
      , :new.OBJREF2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.OBJREF1UP
      , :new.OBJREF2UP
      , :new.RIGHTKINDREF
      , :new.OBJECTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_DUALRIGHTS
  AFTER UPDATE
  ON DUALRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_DUALRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_DUALRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_DUALRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,ISGROUP
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF1
      ,OBJREF2
      ,CREATEDATE
      ,UPDATEDATE
      ,OBJREF1UP
      ,OBJREF2UP
      ,RIGHTKINDREF
      ,OBJECTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.ISGROUP
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF1
      , :new.OBJREF2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.OBJREF1UP
      , :new.OBJREF2UP
      , :new.RIGHTKINDREF
      , :new.OBJECTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_DUALRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_DUALRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,ISGROUP
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF1
      ,OBJREF2
      ,CREATEDATE
      ,UPDATEDATE
      ,OBJREF1UP
      ,OBJREF2UP
      ,RIGHTKINDREF
      ,OBJECTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.ISGROUP
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF1
      , :new.OBJREF2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.OBJREF1UP
      , :new.OBJREF2UP
      , :new.RIGHTKINDREF
      , :new.OBJECTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_DUALRIGHTS
  AFTER DELETE
  ON DUALRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_DUALRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ED_BUFF_DATA
  AFTER INSERT
  ON ED_BUFF_DATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_BUFF_DATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_BUFF_DATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATATYPECODE
      ,RECORDINDEX
      ,INT_1
      ,INT_2
      ,INT_3
      ,INT_4
      ,INT_5
      ,INT_6
      ,INT_7
      ,INT_8
      ,INT_9
      ,INT_10
      ,INT_11
      ,INT_12
      ,INT_13
      ,INT_14
      ,INT_15
      ,INT_16
      ,INT_17
      ,INT_18
      ,INT_19
      ,INT_20
      ,SUM_1
      ,SUM_2
      ,SUM_3
      ,SUM_4
      ,SUM_5
      ,SUM_6
      ,SUM_7
      ,SUM_8
      ,SUM_9
      ,SUM_10
      ,SUM_11
      ,SUM_12
      ,SUM_13
      ,SUM_14
      ,SUM_15
      ,SUM_16
      ,SUM_17
      ,SUM_18
      ,SUM_19
      ,SUM_20
      ,SUM_21
      ,SUM_22
      ,SUM_23
      ,SUM_24
      ,SUM_25
      ,SUM_26
      ,SUM_27
      ,SUM_28
      ,SUM_29
      ,SUM_30
      ,SUM_31
      ,SUM_32
      ,SUM_33
      ,SUM_34
      ,SUM_35
      ,SUM_36
      ,SUM_37
      ,SUM_38
      ,SUM_39
      ,SUM_40
      ,SUM_41
      ,SUM_42
      ,SUM_43
      ,SUM_44
      ,SUM_45
      ,NEWDATE_1
      ,NEWDATE_2
      ,NEWDATE_3
      ,NEWDATE_4
      ,NEWDATE_5
      ,NEWDATE_6
      ,NEWDATE_7
      ,NEWDATE_8
      ,NEWDATE_9
      ,NEWDATE_10
      ,NOTE10_1
      ,NOTE10_2
      ,NOTE10_3
      ,NOTE10_4
      ,NOTE10_5
      ,NOTE10_6
      ,NOTE10_7
      ,NOTE10_8
      ,NOTE10_9
      ,NOTE10_10
      ,NOTE50_1
      ,NOTE50_2
      ,NOTE50_3
      ,NOTE50_4
      ,NOTE50_5
      ,NOTE50_6
      ,NOTE50_7
      ,NOTE50_8
      ,NOTE50_9
      ,NOTE50_10
      ,NOTE255_1
      ,NOTE255_2
      ,NOTE255_3
      ,NOTE255_4
      ,NOTE255_5
      ,NOTE255_6
      ,NOTE255_7
      ,NOTE255_8
      ,NOTE255_9
      ,NOTE255_10
      ,NOTE1024_1
      ,NOTE1024_2
      ,NOTE1024_3
      ,NOTE1024_4
      ,NOTE1024_5
      ,NOTE1024_6
      ,NOTE1024_7
      ,NOTE1024_8
      ,NOTE1024_9
      ,NOTE1024_10
      ,NOTE4000_1
      ,NOTE4000_2
      ,NOTE4000_3
      ,NOTE4000_4
      ,NOTE4000_5
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATATYPECODE
      , :new.RECORDINDEX
      , :new.INT_1
      , :new.INT_2
      , :new.INT_3
      , :new.INT_4
      , :new.INT_5
      , :new.INT_6
      , :new.INT_7
      , :new.INT_8
      , :new.INT_9
      , :new.INT_10
      , :new.INT_11
      , :new.INT_12
      , :new.INT_13
      , :new.INT_14
      , :new.INT_15
      , :new.INT_16
      , :new.INT_17
      , :new.INT_18
      , :new.INT_19
      , :new.INT_20
      , :new.SUM_1
      , :new.SUM_2
      , :new.SUM_3
      , :new.SUM_4
      , :new.SUM_5
      , :new.SUM_6
      , :new.SUM_7
      , :new.SUM_8
      , :new.SUM_9
      , :new.SUM_10
      , :new.SUM_11
      , :new.SUM_12
      , :new.SUM_13
      , :new.SUM_14
      , :new.SUM_15
      , :new.SUM_16
      , :new.SUM_17
      , :new.SUM_18
      , :new.SUM_19
      , :new.SUM_20
      , :new.SUM_21
      , :new.SUM_22
      , :new.SUM_23
      , :new.SUM_24
      , :new.SUM_25
      , :new.SUM_26
      , :new.SUM_27
      , :new.SUM_28
      , :new.SUM_29
      , :new.SUM_30
      , :new.SUM_31
      , :new.SUM_32
      , :new.SUM_33
      , :new.SUM_34
      , :new.SUM_35
      , :new.SUM_36
      , :new.SUM_37
      , :new.SUM_38
      , :new.SUM_39
      , :new.SUM_40
      , :new.SUM_41
      , :new.SUM_42
      , :new.SUM_43
      , :new.SUM_44
      , :new.SUM_45
      , :new.NEWDATE_1
      , :new.NEWDATE_2
      , :new.NEWDATE_3
      , :new.NEWDATE_4
      , :new.NEWDATE_5
      , :new.NEWDATE_6
      , :new.NEWDATE_7
      , :new.NEWDATE_8
      , :new.NEWDATE_9
      , :new.NEWDATE_10
      , :new.NOTE10_1
      , :new.NOTE10_2
      , :new.NOTE10_3
      , :new.NOTE10_4
      , :new.NOTE10_5
      , :new.NOTE10_6
      , :new.NOTE10_7
      , :new.NOTE10_8
      , :new.NOTE10_9
      , :new.NOTE10_10
      , :new.NOTE50_1
      , :new.NOTE50_2
      , :new.NOTE50_3
      , :new.NOTE50_4
      , :new.NOTE50_5
      , :new.NOTE50_6
      , :new.NOTE50_7
      , :new.NOTE50_8
      , :new.NOTE50_9
      , :new.NOTE50_10
      , :new.NOTE255_1
      , :new.NOTE255_2
      , :new.NOTE255_3
      , :new.NOTE255_4
      , :new.NOTE255_5
      , :new.NOTE255_6
      , :new.NOTE255_7
      , :new.NOTE255_8
      , :new.NOTE255_9
      , :new.NOTE255_10
      , :new.NOTE1024_1
      , :new.NOTE1024_2
      , :new.NOTE1024_3
      , :new.NOTE1024_4
      , :new.NOTE1024_5
      , :new.NOTE1024_6
      , :new.NOTE1024_7
      , :new.NOTE1024_8
      , :new.NOTE1024_9
      , :new.NOTE1024_10
      , :new.NOTE4000_1
      , :new.NOTE4000_2
      , :new.NOTE4000_3
      , :new.NOTE4000_4
      , :new.NOTE4000_5
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ED_BUFF_DATA
  AFTER UPDATE
  ON ED_BUFF_DATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ED_BUFF_DATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ED_BUFF_DATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_BUFF_DATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATATYPECODE
      ,RECORDINDEX
      ,INT_1
      ,INT_2
      ,INT_3
      ,INT_4
      ,INT_5
      ,INT_6
      ,INT_7
      ,INT_8
      ,INT_9
      ,INT_10
      ,INT_11
      ,INT_12
      ,INT_13
      ,INT_14
      ,INT_15
      ,INT_16
      ,INT_17
      ,INT_18
      ,INT_19
      ,INT_20
      ,SUM_1
      ,SUM_2
      ,SUM_3
      ,SUM_4
      ,SUM_5
      ,SUM_6
      ,SUM_7
      ,SUM_8
      ,SUM_9
      ,SUM_10
      ,SUM_11
      ,SUM_12
      ,SUM_13
      ,SUM_14
      ,SUM_15
      ,SUM_16
      ,SUM_17
      ,SUM_18
      ,SUM_19
      ,SUM_20
      ,SUM_21
      ,SUM_22
      ,SUM_23
      ,SUM_24
      ,SUM_25
      ,SUM_26
      ,SUM_27
      ,SUM_28
      ,SUM_29
      ,SUM_30
      ,SUM_31
      ,SUM_32
      ,SUM_33
      ,SUM_34
      ,SUM_35
      ,SUM_36
      ,SUM_37
      ,SUM_38
      ,SUM_39
      ,SUM_40
      ,SUM_41
      ,SUM_42
      ,SUM_43
      ,SUM_44
      ,SUM_45
      ,NEWDATE_1
      ,NEWDATE_2
      ,NEWDATE_3
      ,NEWDATE_4
      ,NEWDATE_5
      ,NEWDATE_6
      ,NEWDATE_7
      ,NEWDATE_8
      ,NEWDATE_9
      ,NEWDATE_10
      ,NOTE10_1
      ,NOTE10_2
      ,NOTE10_3
      ,NOTE10_4
      ,NOTE10_5
      ,NOTE10_6
      ,NOTE10_7
      ,NOTE10_8
      ,NOTE10_9
      ,NOTE10_10
      ,NOTE50_1
      ,NOTE50_2
      ,NOTE50_3
      ,NOTE50_4
      ,NOTE50_5
      ,NOTE50_6
      ,NOTE50_7
      ,NOTE50_8
      ,NOTE50_9
      ,NOTE50_10
      ,NOTE255_1
      ,NOTE255_2
      ,NOTE255_3
      ,NOTE255_4
      ,NOTE255_5
      ,NOTE255_6
      ,NOTE255_7
      ,NOTE255_8
      ,NOTE255_9
      ,NOTE255_10
      ,NOTE1024_1
      ,NOTE1024_2
      ,NOTE1024_3
      ,NOTE1024_4
      ,NOTE1024_5
      ,NOTE1024_6
      ,NOTE1024_7
      ,NOTE1024_8
      ,NOTE1024_9
      ,NOTE1024_10
      ,NOTE4000_1
      ,NOTE4000_2
      ,NOTE4000_3
      ,NOTE4000_4
      ,NOTE4000_5
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATATYPECODE
      , :new.RECORDINDEX
      , :new.INT_1
      , :new.INT_2
      , :new.INT_3
      , :new.INT_4
      , :new.INT_5
      , :new.INT_6
      , :new.INT_7
      , :new.INT_8
      , :new.INT_9
      , :new.INT_10
      , :new.INT_11
      , :new.INT_12
      , :new.INT_13
      , :new.INT_14
      , :new.INT_15
      , :new.INT_16
      , :new.INT_17
      , :new.INT_18
      , :new.INT_19
      , :new.INT_20
      , :new.SUM_1
      , :new.SUM_2
      , :new.SUM_3
      , :new.SUM_4
      , :new.SUM_5
      , :new.SUM_6
      , :new.SUM_7
      , :new.SUM_8
      , :new.SUM_9
      , :new.SUM_10
      , :new.SUM_11
      , :new.SUM_12
      , :new.SUM_13
      , :new.SUM_14
      , :new.SUM_15
      , :new.SUM_16
      , :new.SUM_17
      , :new.SUM_18
      , :new.SUM_19
      , :new.SUM_20
      , :new.SUM_21
      , :new.SUM_22
      , :new.SUM_23
      , :new.SUM_24
      , :new.SUM_25
      , :new.SUM_26
      , :new.SUM_27
      , :new.SUM_28
      , :new.SUM_29
      , :new.SUM_30
      , :new.SUM_31
      , :new.SUM_32
      , :new.SUM_33
      , :new.SUM_34
      , :new.SUM_35
      , :new.SUM_36
      , :new.SUM_37
      , :new.SUM_38
      , :new.SUM_39
      , :new.SUM_40
      , :new.SUM_41
      , :new.SUM_42
      , :new.SUM_43
      , :new.SUM_44
      , :new.SUM_45
      , :new.NEWDATE_1
      , :new.NEWDATE_2
      , :new.NEWDATE_3
      , :new.NEWDATE_4
      , :new.NEWDATE_5
      , :new.NEWDATE_6
      , :new.NEWDATE_7
      , :new.NEWDATE_8
      , :new.NEWDATE_9
      , :new.NEWDATE_10
      , :new.NOTE10_1
      , :new.NOTE10_2
      , :new.NOTE10_3
      , :new.NOTE10_4
      , :new.NOTE10_5
      , :new.NOTE10_6
      , :new.NOTE10_7
      , :new.NOTE10_8
      , :new.NOTE10_9
      , :new.NOTE10_10
      , :new.NOTE50_1
      , :new.NOTE50_2
      , :new.NOTE50_3
      , :new.NOTE50_4
      , :new.NOTE50_5
      , :new.NOTE50_6
      , :new.NOTE50_7
      , :new.NOTE50_8
      , :new.NOTE50_9
      , :new.NOTE50_10
      , :new.NOTE255_1
      , :new.NOTE255_2
      , :new.NOTE255_3
      , :new.NOTE255_4
      , :new.NOTE255_5
      , :new.NOTE255_6
      , :new.NOTE255_7
      , :new.NOTE255_8
      , :new.NOTE255_9
      , :new.NOTE255_10
      , :new.NOTE1024_1
      , :new.NOTE1024_2
      , :new.NOTE1024_3
      , :new.NOTE1024_4
      , :new.NOTE1024_5
      , :new.NOTE1024_6
      , :new.NOTE1024_7
      , :new.NOTE1024_8
      , :new.NOTE1024_9
      , :new.NOTE1024_10
      , :new.NOTE4000_1
      , :new.NOTE4000_2
      , :new.NOTE4000_3
      , :new.NOTE4000_4
      , :new.NOTE4000_5
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_ED_BUFF_DATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ED_BUFF_DATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATATYPECODE
      ,RECORDINDEX
      ,INT_1
      ,INT_2
      ,INT_3
      ,INT_4
      ,INT_5
      ,INT_6
      ,INT_7
      ,INT_8
      ,INT_9
      ,INT_10
      ,INT_11
      ,INT_12
      ,INT_13
      ,INT_14
      ,INT_15
      ,INT_16
      ,INT_17
      ,INT_18
      ,INT_19
      ,INT_20
      ,SUM_1
      ,SUM_2
      ,SUM_3
      ,SUM_4
      ,SUM_5
      ,SUM_6
      ,SUM_7
      ,SUM_8
      ,SUM_9
      ,SUM_10
      ,SUM_11
      ,SUM_12
      ,SUM_13
      ,SUM_14
      ,SUM_15
      ,SUM_16
      ,SUM_17
      ,SUM_18
      ,SUM_19
      ,SUM_20
      ,SUM_21
      ,SUM_22
      ,SUM_23
      ,SUM_24
      ,SUM_25
      ,SUM_26
      ,SUM_27
      ,SUM_28
      ,SUM_29
      ,SUM_30
      ,SUM_31
      ,SUM_32
      ,SUM_33
      ,SUM_34
      ,SUM_35
      ,SUM_36
      ,SUM_37
      ,SUM_38
      ,SUM_39
      ,SUM_40
      ,SUM_41
      ,SUM_42
      ,SUM_43
      ,SUM_44
      ,SUM_45
      ,NEWDATE_1
      ,NEWDATE_2
      ,NEWDATE_3
      ,NEWDATE_4
      ,NEWDATE_5
      ,NEWDATE_6
      ,NEWDATE_7
      ,NEWDATE_8
      ,NEWDATE_9
      ,NEWDATE_10
      ,NOTE10_1
      ,NOTE10_2
      ,NOTE10_3
      ,NOTE10_4
      ,NOTE10_5
      ,NOTE10_6
      ,NOTE10_7
      ,NOTE10_8
      ,NOTE10_9
      ,NOTE10_10
      ,NOTE50_1
      ,NOTE50_2
      ,NOTE50_3
      ,NOTE50_4
      ,NOTE50_5
      ,NOTE50_6
      ,NOTE50_7
      ,NOTE50_8
      ,NOTE50_9
      ,NOTE50_10
      ,NOTE255_1
      ,NOTE255_2
      ,NOTE255_3
      ,NOTE255_4
      ,NOTE255_5
      ,NOTE255_6
      ,NOTE255_7
      ,NOTE255_8
      ,NOTE255_9
      ,NOTE255_10
      ,NOTE1024_1
      ,NOTE1024_2
      ,NOTE1024_3
      ,NOTE1024_4
      ,NOTE1024_5
      ,NOTE1024_6
      ,NOTE1024_7
      ,NOTE1024_8
      ,NOTE1024_9
      ,NOTE1024_10
      ,NOTE4000_1
      ,NOTE4000_2
      ,NOTE4000_3
      ,NOTE4000_4
      ,NOTE4000_5
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATATYPECODE
      , :new.RECORDINDEX
      , :new.INT_1
      , :new.INT_2
      , :new.INT_3
      , :new.INT_4
      , :new.INT_5
      , :new.INT_6
      , :new.INT_7
      , :new.INT_8
      , :new.INT_9
      , :new.INT_10
      , :new.INT_11
      , :new.INT_12
      , :new.INT_13
      , :new.INT_14
      , :new.INT_15
      , :new.INT_16
      , :new.INT_17
      , :new.INT_18
      , :new.INT_19
      , :new.INT_20
      , :new.SUM_1
      , :new.SUM_2
      , :new.SUM_3
      , :new.SUM_4
      , :new.SUM_5
      , :new.SUM_6
      , :new.SUM_7
      , :new.SUM_8
      , :new.SUM_9
      , :new.SUM_10
      , :new.SUM_11
      , :new.SUM_12
      , :new.SUM_13
      , :new.SUM_14
      , :new.SUM_15
      , :new.SUM_16
      , :new.SUM_17
      , :new.SUM_18
      , :new.SUM_19
      , :new.SUM_20
      , :new.SUM_21
      , :new.SUM_22
      , :new.SUM_23
      , :new.SUM_24
      , :new.SUM_25
      , :new.SUM_26
      , :new.SUM_27
      , :new.SUM_28
      , :new.SUM_29
      , :new.SUM_30
      , :new.SUM_31
      , :new.SUM_32
      , :new.SUM_33
      , :new.SUM_34
      , :new.SUM_35
      , :new.SUM_36
      , :new.SUM_37
      , :new.SUM_38
      , :new.SUM_39
      , :new.SUM_40
      , :new.SUM_41
      , :new.SUM_42
      , :new.SUM_43
      , :new.SUM_44
      , :new.SUM_45
      , :new.NEWDATE_1
      , :new.NEWDATE_2
      , :new.NEWDATE_3
      , :new.NEWDATE_4
      , :new.NEWDATE_5
      , :new.NEWDATE_6
      , :new.NEWDATE_7
      , :new.NEWDATE_8
      , :new.NEWDATE_9
      , :new.NEWDATE_10
      , :new.NOTE10_1
      , :new.NOTE10_2
      , :new.NOTE10_3
      , :new.NOTE10_4
      , :new.NOTE10_5
      , :new.NOTE10_6
      , :new.NOTE10_7
      , :new.NOTE10_8
      , :new.NOTE10_9
      , :new.NOTE10_10
      , :new.NOTE50_1
      , :new.NOTE50_2
      , :new.NOTE50_3
      , :new.NOTE50_4
      , :new.NOTE50_5
      , :new.NOTE50_6
      , :new.NOTE50_7
      , :new.NOTE50_8
      , :new.NOTE50_9
      , :new.NOTE50_10
      , :new.NOTE255_1
      , :new.NOTE255_2
      , :new.NOTE255_3
      , :new.NOTE255_4
      , :new.NOTE255_5
      , :new.NOTE255_6
      , :new.NOTE255_7
      , :new.NOTE255_8
      , :new.NOTE255_9
      , :new.NOTE255_10
      , :new.NOTE1024_1
      , :new.NOTE1024_2
      , :new.NOTE1024_3
      , :new.NOTE1024_4
      , :new.NOTE1024_5
      , :new.NOTE1024_6
      , :new.NOTE1024_7
      , :new.NOTE1024_8
      , :new.NOTE1024_9
      , :new.NOTE1024_10
      , :new.NOTE4000_1
      , :new.NOTE4000_2
      , :new.NOTE4000_3
      , :new.NOTE4000_4
      , :new.NOTE4000_5
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ED_BUFF_DATA
  AFTER DELETE
  ON ED_BUFF_DATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_BUFF_DATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ED_CORRECTIONCAPTION
  AFTER INSERT
  ON ED_CORRECTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_CORRECTIONCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_CORRECTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ELDOCNUMBER
      ,DOCDATE
      ,INN
      ,KPP
      ,NAME
      ,FACIALCODE
      ,FUND_SOURCE
      ,SOURCEINN
      ,SOURCEKPP
      ,SOURCEACC
      ,PROCSTATE
      ,PACKETNUMBER
      ,PROCDOCCLASS
      ,DOCUMENTNAME
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DEPARTMENTCLS
      ,SOURCENAME
      ,PROCUSEINFO
      ,DOL_RUK
      ,NAME_RUK
      ,DOL_ISP
      ,NAME_ISP
      ,TEL_ISP
      ,DATE_POD
      ,DOCNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ELDOCNUMBER
      , :new.DOCDATE
      , :new.INN
      , :new.KPP
      , :new.NAME
      , :new.FACIALCODE
      , :new.FUND_SOURCE
      , :new.SOURCEINN
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.PROCSTATE
      , :new.PACKETNUMBER
      , :new.PROCDOCCLASS
      , :new.DOCUMENTNAME
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DEPARTMENTCLS
      , :new.SOURCENAME
      , :new.PROCUSEINFO
      , :new.DOL_RUK
      , :new.NAME_RUK
      , :new.DOL_ISP
      , :new.NAME_ISP
      , :new.TEL_ISP
      , :new.DATE_POD
      , :new.DOCNUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ED_CORRECTIONCAPTION
  AFTER UPDATE
  ON ED_CORRECTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ED_CORRECTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ED_CORRECTIONCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_CORRECTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ELDOCNUMBER
      ,DOCDATE
      ,INN
      ,KPP
      ,NAME
      ,FACIALCODE
      ,FUND_SOURCE
      ,SOURCEINN
      ,SOURCEKPP
      ,SOURCEACC
      ,PROCSTATE
      ,PACKETNUMBER
      ,PROCDOCCLASS
      ,DOCUMENTNAME
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DEPARTMENTCLS
      ,SOURCENAME
      ,PROCUSEINFO
      ,DOL_RUK
      ,NAME_RUK
      ,DOL_ISP
      ,NAME_ISP
      ,TEL_ISP
      ,DATE_POD
      ,DOCNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ELDOCNUMBER
      , :new.DOCDATE
      , :new.INN
      , :new.KPP
      , :new.NAME
      , :new.FACIALCODE
      , :new.FUND_SOURCE
      , :new.SOURCEINN
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.PROCSTATE
      , :new.PACKETNUMBER
      , :new.PROCDOCCLASS
      , :new.DOCUMENTNAME
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DEPARTMENTCLS
      , :new.SOURCENAME
      , :new.PROCUSEINFO
      , :new.DOL_RUK
      , :new.NAME_RUK
      , :new.DOL_ISP
      , :new.NAME_ISP
      , :new.TEL_ISP
      , :new.DATE_POD
      , :new.DOCNUMBER
    );
  else 
    update A_ED_CORRECTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ED_CORRECTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ELDOCNUMBER
      ,DOCDATE
      ,INN
      ,KPP
      ,NAME
      ,FACIALCODE
      ,FUND_SOURCE
      ,SOURCEINN
      ,SOURCEKPP
      ,SOURCEACC
      ,PROCSTATE
      ,PACKETNUMBER
      ,PROCDOCCLASS
      ,DOCUMENTNAME
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,DEPARTMENTCLS
      ,SOURCENAME
      ,PROCUSEINFO
      ,DOL_RUK
      ,NAME_RUK
      ,DOL_ISP
      ,NAME_ISP
      ,TEL_ISP
      ,DATE_POD
      ,DOCNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ELDOCNUMBER
      , :new.DOCDATE
      , :new.INN
      , :new.KPP
      , :new.NAME
      , :new.FACIALCODE
      , :new.FUND_SOURCE
      , :new.SOURCEINN
      , :new.SOURCEKPP
      , :new.SOURCEACC
      , :new.PROCSTATE
      , :new.PACKETNUMBER
      , :new.PROCDOCCLASS
      , :new.DOCUMENTNAME
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.DEPARTMENTCLS
      , :new.SOURCENAME
      , :new.PROCUSEINFO
      , :new.DOL_RUK
      , :new.NAME_RUK
      , :new.DOL_ISP
      , :new.NAME_ISP
      , :new.TEL_ISP
      , :new.DATE_POD
      , :new.DOCNUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ED_CORRECTIONCAPTION
  AFTER DELETE
  ON ED_CORRECTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_CORRECTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ED_CORRECTIONDETAIL
  AFTER INSERT
  ON ED_CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_CORRECTIONDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_CORRECTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ELDOCNUMBER
      ,KOD_DOC
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,FACIALCODE
      ,SUMMA
      ,CLSVALUE
      ,CLSTYPE
      ,DESTNAME
      ,DESTINN
      ,DESTKPP
      ,ADDCLS
      ,PURPOSE
      ,FUND_SOURCE
      ,NOM_ZR
      ,DATE_ZR
      ,NOTE
      ,RECORDINDEX
      ,PARENTID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OKTMO
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ELDOCNUMBER
      , :new.KOD_DOC
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.FACIALCODE
      , :new.SUMMA
      , :new.CLSVALUE
      , :new.CLSTYPE
      , :new.DESTNAME
      , :new.DESTINN
      , :new.DESTKPP
      , :new.ADDCLS
      , :new.PURPOSE
      , :new.FUND_SOURCE
      , :new.NOM_ZR
      , :new.DATE_ZR
      , :new.NOTE
      , :new.RECORDINDEX
      , :new.PARENTID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OKTMO
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ED_CORRECTIONDETAIL
  AFTER UPDATE
  ON ED_CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ED_CORRECTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ED_CORRECTIONDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_CORRECTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ELDOCNUMBER
      ,KOD_DOC
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,FACIALCODE
      ,SUMMA
      ,CLSVALUE
      ,CLSTYPE
      ,DESTNAME
      ,DESTINN
      ,DESTKPP
      ,ADDCLS
      ,PURPOSE
      ,FUND_SOURCE
      ,NOM_ZR
      ,DATE_ZR
      ,NOTE
      ,RECORDINDEX
      ,PARENTID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OKTMO
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ELDOCNUMBER
      , :new.KOD_DOC
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.FACIALCODE
      , :new.SUMMA
      , :new.CLSVALUE
      , :new.CLSTYPE
      , :new.DESTNAME
      , :new.DESTINN
      , :new.DESTKPP
      , :new.ADDCLS
      , :new.PURPOSE
      , :new.FUND_SOURCE
      , :new.NOM_ZR
      , :new.DATE_ZR
      , :new.NOTE
      , :new.RECORDINDEX
      , :new.PARENTID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OKTMO
    );
  else 
    update A_ED_CORRECTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ED_CORRECTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ELDOCNUMBER
      ,KOD_DOC
      ,ORIGINALNUMBER
      ,ORIGINALDATE
      ,FACIALCODE
      ,SUMMA
      ,CLSVALUE
      ,CLSTYPE
      ,DESTNAME
      ,DESTINN
      ,DESTKPP
      ,ADDCLS
      ,PURPOSE
      ,FUND_SOURCE
      ,NOM_ZR
      ,DATE_ZR
      ,NOTE
      ,RECORDINDEX
      ,PARENTID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OKTMO
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ELDOCNUMBER
      , :new.KOD_DOC
      , :new.ORIGINALNUMBER
      , :new.ORIGINALDATE
      , :new.FACIALCODE
      , :new.SUMMA
      , :new.CLSVALUE
      , :new.CLSTYPE
      , :new.DESTNAME
      , :new.DESTINN
      , :new.DESTKPP
      , :new.ADDCLS
      , :new.PURPOSE
      , :new.FUND_SOURCE
      , :new.NOM_ZR
      , :new.DATE_ZR
      , :new.NOTE
      , :new.RECORDINDEX
      , :new.PARENTID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OKTMO
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ED_CORRECTIONDETAIL
  AFTER DELETE
  ON ED_CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_CORRECTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ED_DETAIL
  AFTER INSERT
  ON ED_DETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_DETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_DETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,HEADERTYPE
      ,KR
      ,IFS
      ,KD
      ,ADDCLS
      ,SUMMA
      ,SUMMAKIND
      ,PROMISE
      ,NOTE
      ,PURPOSE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.HEADERTYPE
      , :new.KR
      , :new.IFS
      , :new.KD
      , :new.ADDCLS
      , :new.SUMMA
      , :new.SUMMAKIND
      , :new.PROMISE
      , :new.NOTE
      , :new.PURPOSE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ED_DETAIL
  AFTER UPDATE
  ON ED_DETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ED_DETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ED_DETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_DETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,HEADERTYPE
      ,KR
      ,IFS
      ,KD
      ,ADDCLS
      ,SUMMA
      ,SUMMAKIND
      ,PROMISE
      ,NOTE
      ,PURPOSE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.HEADERTYPE
      , :new.KR
      , :new.IFS
      , :new.KD
      , :new.ADDCLS
      , :new.SUMMA
      , :new.SUMMAKIND
      , :new.PROMISE
      , :new.NOTE
      , :new.PURPOSE
    );
  else 
    update A_ED_DETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ED_DETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,HEADERTYPE
      ,KR
      ,IFS
      ,KD
      ,ADDCLS
      ,SUMMA
      ,SUMMAKIND
      ,PROMISE
      ,NOTE
      ,PURPOSE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.HEADERTYPE
      , :new.KR
      , :new.IFS
      , :new.KD
      , :new.ADDCLS
      , :new.SUMMA
      , :new.SUMMAKIND
      , :new.PROMISE
      , :new.NOTE
      , :new.PURPOSE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ED_DETAIL
  AFTER DELETE
  ON ED_DETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_DETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ED_OUTPAYDOC
  AFTER INSERT
  ON ED_OUTPAYDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_OUTPAYDOC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_OUTPAYDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCDATE
      ,PAYQUEUE
      ,PAYKIND
      ,NOTE
      ,TAXNOTE
      ,BUDGETCLS
      ,SUMMA
      ,SOURCEKPP
      ,SOURCENAME
      ,SOURCEACC
      ,SOURCEUFK_ORGNAME
      ,SOURCEUFK_ACC
      ,SOURCEBANKMFO
      ,SOURCEBANKNAME
      ,SOURCEBANKCOR
      ,DESTKPP
      ,DESTNAME
      ,DESTUFK_ORGNAME
      ,DESTACC
      ,DESTFACIALCODE
      ,DESTBANKMFO
      ,DESTBANKNAME
      ,DESTBANKCOR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ELDOCNUMBER
      ,PACKETDATE
      ,PROCSTATE
      ,PROCDOCCLASS
      ,PROCUSEINFO
      ,PROCNOTE
      ,DOCSOURCE
      ,DOCREF
      ,ELDOCREF
      ,PROGINDEX
      ,ISLASTVERSION
      ,PACKETNUMBER
      ,SOURCEFILIALBANKNAME
      ,DESTFILIALBANKNAME
      ,DOCUMENTNAME
      ,SOURCEUFKCODE
      ,SOURCETOFK
      ,SOURCEFACIALACC_CLS
      ,KOD_IST
      ,VOS_GUID
      ,VOS_NOM
      ,VOS_DATE
      ,VOS_SUM
      ,VOS_PAYERINN
      ,VOS_PAYERKPP
      ,DEPARTMENTCLS
      ,DOCNUMBER
      ,SOURCEINN
      ,SOURCEUFK_INN
      ,DESTINN
      ,DESTUFK_INN
      ,DOCOSN
      ,UINCODE
      ,SIGNERS
      ,CARDNUMBER
      ,SENDERKOD
      ,SENDERNAME
      ,GETERKOD
      ,GETERNAME
      ,BUDGETLEVEL
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCDATE
      , :new.PAYQUEUE
      , :new.PAYKIND
      , :new.NOTE
      , :new.TAXNOTE
      , :new.BUDGETCLS
      , :new.SUMMA
      , :new.SOURCEKPP
      , :new.SOURCENAME
      , :new.SOURCEACC
      , :new.SOURCEUFK_ORGNAME
      , :new.SOURCEUFK_ACC
      , :new.SOURCEBANKMFO
      , :new.SOURCEBANKNAME
      , :new.SOURCEBANKCOR
      , :new.DESTKPP
      , :new.DESTNAME
      , :new.DESTUFK_ORGNAME
      , :new.DESTACC
      , :new.DESTFACIALCODE
      , :new.DESTBANKMFO
      , :new.DESTBANKNAME
      , :new.DESTBANKCOR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ELDOCNUMBER
      , :new.PACKETDATE
      , :new.PROCSTATE
      , :new.PROCDOCCLASS
      , :new.PROCUSEINFO
      , :new.PROCNOTE
      , :new.DOCSOURCE
      , :new.DOCREF
      , :new.ELDOCREF
      , :new.PROGINDEX
      , :new.ISLASTVERSION
      , :new.PACKETNUMBER
      , :new.SOURCEFILIALBANKNAME
      , :new.DESTFILIALBANKNAME
      , :new.DOCUMENTNAME
      , :new.SOURCEUFKCODE
      , :new.SOURCETOFK
      , :new.SOURCEFACIALACC_CLS
      , :new.KOD_IST
      , :new.VOS_GUID
      , :new.VOS_NOM
      , :new.VOS_DATE
      , :new.VOS_SUM
      , :new.VOS_PAYERINN
      , :new.VOS_PAYERKPP
      , :new.DEPARTMENTCLS
      , :new.DOCNUMBER
      , :new.SOURCEINN
      , :new.SOURCEUFK_INN
      , :new.DESTINN
      , :new.DESTUFK_INN
      , :new.DOCOSN
      , :new.UINCODE
      , :new.SIGNERS
      , :new.CARDNUMBER
      , :new.SENDERKOD
      , :new.SENDERNAME
      , :new.GETERKOD
      , :new.GETERNAME
      , :new.BUDGETLEVEL
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ED_OUTPAYDOC
  AFTER UPDATE
  ON ED_OUTPAYDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ED_OUTPAYDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ED_OUTPAYDOC
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_OUTPAYDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCDATE
      ,PAYQUEUE
      ,PAYKIND
      ,NOTE
      ,TAXNOTE
      ,BUDGETCLS
      ,SUMMA
      ,SOURCEKPP
      ,SOURCENAME
      ,SOURCEACC
      ,SOURCEUFK_ORGNAME
      ,SOURCEUFK_ACC
      ,SOURCEBANKMFO
      ,SOURCEBANKNAME
      ,SOURCEBANKCOR
      ,DESTKPP
      ,DESTNAME
      ,DESTUFK_ORGNAME
      ,DESTACC
      ,DESTFACIALCODE
      ,DESTBANKMFO
      ,DESTBANKNAME
      ,DESTBANKCOR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ELDOCNUMBER
      ,PACKETDATE
      ,PROCSTATE
      ,PROCDOCCLASS
      ,PROCUSEINFO
      ,PROCNOTE
      ,DOCSOURCE
      ,DOCREF
      ,ELDOCREF
      ,PROGINDEX
      ,ISLASTVERSION
      ,PACKETNUMBER
      ,SOURCEFILIALBANKNAME
      ,DESTFILIALBANKNAME
      ,DOCUMENTNAME
      ,SOURCEUFKCODE
      ,SOURCETOFK
      ,SOURCEFACIALACC_CLS
      ,KOD_IST
      ,VOS_GUID
      ,VOS_NOM
      ,VOS_DATE
      ,VOS_SUM
      ,VOS_PAYERINN
      ,VOS_PAYERKPP
      ,DEPARTMENTCLS
      ,DOCNUMBER
      ,SOURCEINN
      ,SOURCEUFK_INN
      ,DESTINN
      ,DESTUFK_INN
      ,DOCOSN
      ,UINCODE
      ,SIGNERS
      ,CARDNUMBER
      ,SENDERKOD
      ,SENDERNAME
      ,GETERKOD
      ,GETERNAME
      ,BUDGETLEVEL
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCDATE
      , :new.PAYQUEUE
      , :new.PAYKIND
      , :new.NOTE
      , :new.TAXNOTE
      , :new.BUDGETCLS
      , :new.SUMMA
      , :new.SOURCEKPP
      , :new.SOURCENAME
      , :new.SOURCEACC
      , :new.SOURCEUFK_ORGNAME
      , :new.SOURCEUFK_ACC
      , :new.SOURCEBANKMFO
      , :new.SOURCEBANKNAME
      , :new.SOURCEBANKCOR
      , :new.DESTKPP
      , :new.DESTNAME
      , :new.DESTUFK_ORGNAME
      , :new.DESTACC
      , :new.DESTFACIALCODE
      , :new.DESTBANKMFO
      , :new.DESTBANKNAME
      , :new.DESTBANKCOR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ELDOCNUMBER
      , :new.PACKETDATE
      , :new.PROCSTATE
      , :new.PROCDOCCLASS
      , :new.PROCUSEINFO
      , :new.PROCNOTE
      , :new.DOCSOURCE
      , :new.DOCREF
      , :new.ELDOCREF
      , :new.PROGINDEX
      , :new.ISLASTVERSION
      , :new.PACKETNUMBER
      , :new.SOURCEFILIALBANKNAME
      , :new.DESTFILIALBANKNAME
      , :new.DOCUMENTNAME
      , :new.SOURCEUFKCODE
      , :new.SOURCETOFK
      , :new.SOURCEFACIALACC_CLS
      , :new.KOD_IST
      , :new.VOS_GUID
      , :new.VOS_NOM
      , :new.VOS_DATE
      , :new.VOS_SUM
      , :new.VOS_PAYERINN
      , :new.VOS_PAYERKPP
      , :new.DEPARTMENTCLS
      , :new.DOCNUMBER
      , :new.SOURCEINN
      , :new.SOURCEUFK_INN
      , :new.DESTINN
      , :new.DESTUFK_INN
      , :new.DOCOSN
      , :new.UINCODE
      , :new.SIGNERS
      , :new.CARDNUMBER
      , :new.SENDERKOD
      , :new.SENDERNAME
      , :new.GETERKOD
      , :new.GETERNAME
      , :new.BUDGETLEVEL
    );
  else 
    update A_ED_OUTPAYDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ED_OUTPAYDOC (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCDATE
      ,PAYQUEUE
      ,PAYKIND
      ,NOTE
      ,TAXNOTE
      ,BUDGETCLS
      ,SUMMA
      ,SOURCEKPP
      ,SOURCENAME
      ,SOURCEACC
      ,SOURCEUFK_ORGNAME
      ,SOURCEUFK_ACC
      ,SOURCEBANKMFO
      ,SOURCEBANKNAME
      ,SOURCEBANKCOR
      ,DESTKPP
      ,DESTNAME
      ,DESTUFK_ORGNAME
      ,DESTACC
      ,DESTFACIALCODE
      ,DESTBANKMFO
      ,DESTBANKNAME
      ,DESTBANKCOR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ELDOCNUMBER
      ,PACKETDATE
      ,PROCSTATE
      ,PROCDOCCLASS
      ,PROCUSEINFO
      ,PROCNOTE
      ,DOCSOURCE
      ,DOCREF
      ,ELDOCREF
      ,PROGINDEX
      ,ISLASTVERSION
      ,PACKETNUMBER
      ,SOURCEFILIALBANKNAME
      ,DESTFILIALBANKNAME
      ,DOCUMENTNAME
      ,SOURCEUFKCODE
      ,SOURCETOFK
      ,SOURCEFACIALACC_CLS
      ,KOD_IST
      ,VOS_GUID
      ,VOS_NOM
      ,VOS_DATE
      ,VOS_SUM
      ,VOS_PAYERINN
      ,VOS_PAYERKPP
      ,DEPARTMENTCLS
      ,DOCNUMBER
      ,SOURCEINN
      ,SOURCEUFK_INN
      ,DESTINN
      ,DESTUFK_INN
      ,DOCOSN
      ,UINCODE
      ,SIGNERS
      ,CARDNUMBER
      ,SENDERKOD
      ,SENDERNAME
      ,GETERKOD
      ,GETERNAME
      ,BUDGETLEVEL
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCDATE
      , :new.PAYQUEUE
      , :new.PAYKIND
      , :new.NOTE
      , :new.TAXNOTE
      , :new.BUDGETCLS
      , :new.SUMMA
      , :new.SOURCEKPP
      , :new.SOURCENAME
      , :new.SOURCEACC
      , :new.SOURCEUFK_ORGNAME
      , :new.SOURCEUFK_ACC
      , :new.SOURCEBANKMFO
      , :new.SOURCEBANKNAME
      , :new.SOURCEBANKCOR
      , :new.DESTKPP
      , :new.DESTNAME
      , :new.DESTUFK_ORGNAME
      , :new.DESTACC
      , :new.DESTFACIALCODE
      , :new.DESTBANKMFO
      , :new.DESTBANKNAME
      , :new.DESTBANKCOR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ELDOCNUMBER
      , :new.PACKETDATE
      , :new.PROCSTATE
      , :new.PROCDOCCLASS
      , :new.PROCUSEINFO
      , :new.PROCNOTE
      , :new.DOCSOURCE
      , :new.DOCREF
      , :new.ELDOCREF
      , :new.PROGINDEX
      , :new.ISLASTVERSION
      , :new.PACKETNUMBER
      , :new.SOURCEFILIALBANKNAME
      , :new.DESTFILIALBANKNAME
      , :new.DOCUMENTNAME
      , :new.SOURCEUFKCODE
      , :new.SOURCETOFK
      , :new.SOURCEFACIALACC_CLS
      , :new.KOD_IST
      , :new.VOS_GUID
      , :new.VOS_NOM
      , :new.VOS_DATE
      , :new.VOS_SUM
      , :new.VOS_PAYERINN
      , :new.VOS_PAYERKPP
      , :new.DEPARTMENTCLS
      , :new.DOCNUMBER
      , :new.SOURCEINN
      , :new.SOURCEUFK_INN
      , :new.DESTINN
      , :new.DESTUFK_INN
      , :new.DOCOSN
      , :new.UINCODE
      , :new.SIGNERS
      , :new.CARDNUMBER
      , :new.SENDERKOD
      , :new.SENDERNAME
      , :new.GETERKOD
      , :new.GETERNAME
      , :new.BUDGETLEVEL
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ED_OUTPAYDOC
  AFTER DELETE
  ON ED_OUTPAYDOC
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_OUTPAYDOC
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ED_SALDO
  AFTER INSERT
  ON ED_SALDO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_SALDO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_SALDO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACC
      ,DEBIT
      ,CREDIT
      ,OUTBALANCEPASSIVE
      ,OUTBALANCEACTIVE
      ,INBALANCEPASSIVE
      ,INBALANCEACTIVE
      ,FORMDATE
      ,TIMEACCEPT
      ,LASTDATE
      ,CODEFORMAT
      ,INYEARLIMIT
      ,INCASHCHARGE
      ,INLIMIT
      ,INFIN
      ,OUTYEARLIMIT
      ,OUTCASHCHARGE
      ,OUTLIMIT
      ,OUTFIN
      ,PACKETNUMBER
      ,ELPACKETNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACC
      , :new.DEBIT
      , :new.CREDIT
      , :new.OUTBALANCEPASSIVE
      , :new.OUTBALANCEACTIVE
      , :new.INBALANCEPASSIVE
      , :new.INBALANCEACTIVE
      , :new.FORMDATE
      , :new.TIMEACCEPT
      , :new.LASTDATE
      , :new.CODEFORMAT
      , :new.INYEARLIMIT
      , :new.INCASHCHARGE
      , :new.INLIMIT
      , :new.INFIN
      , :new.OUTYEARLIMIT
      , :new.OUTCASHCHARGE
      , :new.OUTLIMIT
      , :new.OUTFIN
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ED_SALDO
  AFTER UPDATE
  ON ED_SALDO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ED_SALDO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ED_SALDO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ED_SALDO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACC
      ,DEBIT
      ,CREDIT
      ,OUTBALANCEPASSIVE
      ,OUTBALANCEACTIVE
      ,INBALANCEPASSIVE
      ,INBALANCEACTIVE
      ,FORMDATE
      ,TIMEACCEPT
      ,LASTDATE
      ,CODEFORMAT
      ,INYEARLIMIT
      ,INCASHCHARGE
      ,INLIMIT
      ,INFIN
      ,OUTYEARLIMIT
      ,OUTCASHCHARGE
      ,OUTLIMIT
      ,OUTFIN
      ,PACKETNUMBER
      ,ELPACKETNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACC
      , :new.DEBIT
      , :new.CREDIT
      , :new.OUTBALANCEPASSIVE
      , :new.OUTBALANCEACTIVE
      , :new.INBALANCEPASSIVE
      , :new.INBALANCEACTIVE
      , :new.FORMDATE
      , :new.TIMEACCEPT
      , :new.LASTDATE
      , :new.CODEFORMAT
      , :new.INYEARLIMIT
      , :new.INCASHCHARGE
      , :new.INLIMIT
      , :new.INFIN
      , :new.OUTYEARLIMIT
      , :new.OUTCASHCHARGE
      , :new.OUTLIMIT
      , :new.OUTFIN
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
    );
  else 
    update A_ED_SALDO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ED_SALDO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GETDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACC
      ,DEBIT
      ,CREDIT
      ,OUTBALANCEPASSIVE
      ,OUTBALANCEACTIVE
      ,INBALANCEPASSIVE
      ,INBALANCEACTIVE
      ,FORMDATE
      ,TIMEACCEPT
      ,LASTDATE
      ,CODEFORMAT
      ,INYEARLIMIT
      ,INCASHCHARGE
      ,INLIMIT
      ,INFIN
      ,OUTYEARLIMIT
      ,OUTCASHCHARGE
      ,OUTLIMIT
      ,OUTFIN
      ,PACKETNUMBER
      ,ELPACKETNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GETDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACC
      , :new.DEBIT
      , :new.CREDIT
      , :new.OUTBALANCEPASSIVE
      , :new.OUTBALANCEACTIVE
      , :new.INBALANCEPASSIVE
      , :new.INBALANCEACTIVE
      , :new.FORMDATE
      , :new.TIMEACCEPT
      , :new.LASTDATE
      , :new.CODEFORMAT
      , :new.INYEARLIMIT
      , :new.INCASHCHARGE
      , :new.INLIMIT
      , :new.INFIN
      , :new.OUTYEARLIMIT
      , :new.OUTCASHCHARGE
      , :new.OUTLIMIT
      , :new.OUTFIN
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ED_SALDO
  AFTER DELETE
  ON ED_SALDO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ED_SALDO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ENUMS
  AFTER INSERT
  ON ENUMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ENUMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ENUMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,ISSYSTEM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ISSYSTEM
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ENUMS
  AFTER UPDATE
  ON ENUMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ENUMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ENUMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ENUMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,ISSYSTEM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ISSYSTEM
    );
  else 
    update A_ENUMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ENUMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,ISSYSTEM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ISSYSTEM
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ENUMS
  AFTER DELETE
  ON ENUMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ENUMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ENUMVALUES
  AFTER INSERT
  ON ENUMVALUES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ENUMVALUES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ENUMVALUES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ENUMREF
      ,VAL
      ,NAME
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ENUMREF
      , :new.VAL
      , :new.NAME
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ENUMVALUES
  AFTER UPDATE
  ON ENUMVALUES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ENUMVALUES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ENUMVALUES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ENUMVALUES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ENUMREF
      ,VAL
      ,NAME
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ENUMREF
      , :new.VAL
      , :new.NAME
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_ENUMVALUES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ENUMVALUES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ENUMREF
      ,VAL
      ,NAME
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ENUMREF
      , :new.VAL
      , :new.NAME
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ENUMVALUES
  AFTER DELETE
  ON ENUMVALUES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ENUMVALUES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ERROR
  AFTER INSERT
  ON ERROR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ERROR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ERROR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,IMPORTANCE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.IMPORTANCE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ERROR
  AFTER UPDATE
  ON ERROR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ERROR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ERROR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ERROR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,IMPORTANCE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.IMPORTANCE
      , :new.NAME
    );
  else 
    update A_ERROR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ERROR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,IMPORTANCE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.IMPORTANCE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ERROR
  AFTER DELETE
  ON ERROR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ERROR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ESTIMATE
  AFTER INSERT
  ON ESTIMATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ESTIMATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ESTIMATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OBJECT
      ,AMOUNT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,SUMMA
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,CLOSEDATE
      ,PAYMENTDATE
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,PRODUCTCLS
      ,FINSUMMA
      ,PRICE
      ,RVERSION
      ,PRICEVAT
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OBJECT
      , :new.AMOUNT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.CLOSEDATE
      , :new.PAYMENTDATE
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PRODUCTCLS
      , :new.FINSUMMA
      , :new.PRICE
      , :new.RVERSION
      , :new.PRICEVAT
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.PROGINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ESTIMATE
  AFTER UPDATE
  ON ESTIMATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ESTIMATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ESTIMATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ESTIMATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OBJECT
      ,AMOUNT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,SUMMA
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,CLOSEDATE
      ,PAYMENTDATE
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,PRODUCTCLS
      ,FINSUMMA
      ,PRICE
      ,RVERSION
      ,PRICEVAT
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OBJECT
      , :new.AMOUNT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.CLOSEDATE
      , :new.PAYMENTDATE
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PRODUCTCLS
      , :new.FINSUMMA
      , :new.PRICE
      , :new.RVERSION
      , :new.PRICEVAT
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.PROGINDEX
    );
  else 
    update A_ESTIMATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ESTIMATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OBJECT
      ,AMOUNT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,SUMMA
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,CLOSEDATE
      ,PAYMENTDATE
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,PRODUCTCLS
      ,FINSUMMA
      ,PRICE
      ,RVERSION
      ,PRICEVAT
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OBJECT
      , :new.AMOUNT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.CLOSEDATE
      , :new.PAYMENTDATE
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PRODUCTCLS
      , :new.FINSUMMA
      , :new.PRICE
      , :new.RVERSION
      , :new.PRICEVAT
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.PROGINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ESTIMATE
  AFTER DELETE
  ON ESTIMATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ESTIMATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_EXCHNUMBER
  AFTER INSERT
  ON EXCHNUMBER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXCHNUMBER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and DATEEX = :new.DATEEX
      and CODEFORMAT = :new.CODEFORMAT
      and NUMBERTYPE = :new.NUMBERTYPE
    ;
    insert into A_EXCHNUMBER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,DATEEX
      ,CODEFORMAT
      ,NUMBERTYPE
      ,ELNUM
      ,LOCKUSER
      ,LOCKDATE
      ,LOCKINGFLAG
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.DATEEX
      , :new.CODEFORMAT
      , :new.NUMBERTYPE
      , :new.ELNUM
      , :new.LOCKUSER
      , :new.LOCKDATE
      , :new.LOCKINGFLAG
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_EXCHNUMBER
  AFTER UPDATE
  ON EXCHNUMBER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.DATEEX != :old.DATEEX)
    or (:new.CODEFORMAT != :old.CODEFORMAT)
    or (:new.NUMBERTYPE != :old.NUMBERTYPE) then
    update A_EXCHNUMBER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and DATEEX = :old.DATEEX
      and CODEFORMAT = :old.CODEFORMAT
      and NUMBERTYPE = :old.NUMBERTYPE
    ;
    update A_EXCHNUMBER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and DATEEX = :new.DATEEX
      and CODEFORMAT = :new.CODEFORMAT
      and NUMBERTYPE = :new.NUMBERTYPE
    ;
    insert into A_EXCHNUMBER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,DATEEX
      ,CODEFORMAT
      ,NUMBERTYPE
      ,ELNUM
      ,LOCKUSER
      ,LOCKDATE
      ,LOCKINGFLAG
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.DATEEX
      , :new.CODEFORMAT
      , :new.NUMBERTYPE
      , :new.ELNUM
      , :new.LOCKUSER
      , :new.LOCKDATE
      , :new.LOCKINGFLAG
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
  else 
    update A_EXCHNUMBER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and DATEEX = :old.DATEEX
      and CODEFORMAT = :old.CODEFORMAT
      and NUMBERTYPE = :old.NUMBERTYPE
    ;
    insert into A_EXCHNUMBER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,DATEEX
      ,CODEFORMAT
      ,NUMBERTYPE
      ,ELNUM
      ,LOCKUSER
      ,LOCKDATE
      ,LOCKINGFLAG
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.DATEEX
      , :new.CODEFORMAT
      , :new.NUMBERTYPE
      , :new.ELNUM
      , :new.LOCKUSER
      , :new.LOCKDATE
      , :new.LOCKINGFLAG
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_EXCHNUMBER
  AFTER DELETE
  ON EXCHNUMBER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXCHNUMBER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and DATEEX = :old.DATEEX
      and CODEFORMAT = :old.CODEFORMAT
      and NUMBERTYPE = :old.NUMBERTYPE
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_EXCHNUMBERLIMITS
  AFTER INSERT
  ON EXCHNUMBERLIMITS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXCHNUMBERLIMITS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and CODEFORMAT = :new.CODEFORMAT
      and NUMBERTYPE = :new.NUMBERTYPE
    ;
    insert into A_EXCHNUMBERLIMITS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,CODEFORMAT
      ,NUMBERTYPE
      ,MINNUMBER
      ,MAXNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.CODEFORMAT
      , :new.NUMBERTYPE
      , :new.MINNUMBER
      , :new.MAXNUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_EXCHNUMBERLIMITS
  AFTER UPDATE
  ON EXCHNUMBERLIMITS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.CODEFORMAT != :old.CODEFORMAT)
    or (:new.NUMBERTYPE != :old.NUMBERTYPE) then
    update A_EXCHNUMBERLIMITS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and CODEFORMAT = :old.CODEFORMAT
      and NUMBERTYPE = :old.NUMBERTYPE
    ;
    update A_EXCHNUMBERLIMITS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and CODEFORMAT = :new.CODEFORMAT
      and NUMBERTYPE = :new.NUMBERTYPE
    ;
    insert into A_EXCHNUMBERLIMITS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,CODEFORMAT
      ,NUMBERTYPE
      ,MINNUMBER
      ,MAXNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.CODEFORMAT
      , :new.NUMBERTYPE
      , :new.MINNUMBER
      , :new.MAXNUMBER
    );
  else 
    update A_EXCHNUMBERLIMITS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and CODEFORMAT = :old.CODEFORMAT
      and NUMBERTYPE = :old.NUMBERTYPE
    ;
    insert into A_EXCHNUMBERLIMITS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,CODEFORMAT
      ,NUMBERTYPE
      ,MINNUMBER
      ,MAXNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.CODEFORMAT
      , :new.NUMBERTYPE
      , :new.MINNUMBER
      , :new.MAXNUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_EXCHNUMBERLIMITS
  AFTER DELETE
  ON EXCHNUMBERLIMITS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXCHNUMBERLIMITS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and CODEFORMAT = :old.CODEFORMAT
      and NUMBERTYPE = :old.NUMBERTYPE
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_EXECUTIONDOCUMENTSDETAIL
  AFTER INSERT
  ON EXECUTIONDOCUMENTSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXECUTIONDOCUMENTSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_EXECUTIONDOCUMENTSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,AMOUNT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,SUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,PRODUCTCLS
      ,RECORDINDEX
      ,PRICE
      ,RVERSION
      ,OBJECT
      ,PRICEVAT
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.AMOUNT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PRODUCTCLS
      , :new.RECORDINDEX
      , :new.PRICE
      , :new.RVERSION
      , :new.OBJECT
      , :new.PRICEVAT
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_EXECUTIONDOCUMENTSDETAIL
  AFTER UPDATE
  ON EXECUTIONDOCUMENTSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_EXECUTIONDOCUMENTSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_EXECUTIONDOCUMENTSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_EXECUTIONDOCUMENTSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,AMOUNT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,SUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,PRODUCTCLS
      ,RECORDINDEX
      ,PRICE
      ,RVERSION
      ,OBJECT
      ,PRICEVAT
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.AMOUNT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PRODUCTCLS
      , :new.RECORDINDEX
      , :new.PRICE
      , :new.RVERSION
      , :new.OBJECT
      , :new.PRICEVAT
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_EXECUTIONDOCUMENTSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_EXECUTIONDOCUMENTSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,AMOUNT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,SUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,PRODUCTCLS
      ,RECORDINDEX
      ,PRICE
      ,RVERSION
      ,OBJECT
      ,PRICEVAT
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.AMOUNT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PRODUCTCLS
      , :new.RECORDINDEX
      , :new.PRICE
      , :new.RVERSION
      , :new.OBJECT
      , :new.PRICEVAT
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_EXECUTIONDOCUMENTSDETAIL
  AFTER DELETE
  ON EXECUTIONDOCUMENTSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXECUTIONDOCUMENTSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_EXEMPTIONTITLE
  AFTER INSERT
  ON EXEMPTIONTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXEMPTIONTITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_EXEMPTIONTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,IDATE
      ,ACCEPTDATE
      ,NUMINQUIRY
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.IDATE
      , :new.ACCEPTDATE
      , :new.NUMINQUIRY
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_EXEMPTIONTITLE
  AFTER UPDATE
  ON EXEMPTIONTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_EXEMPTIONTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_EXEMPTIONTITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_EXEMPTIONTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,IDATE
      ,ACCEPTDATE
      ,NUMINQUIRY
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.IDATE
      , :new.ACCEPTDATE
      , :new.NUMINQUIRY
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
    );
  else 
    update A_EXEMPTIONTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_EXEMPTIONTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,IDATE
      ,ACCEPTDATE
      ,NUMINQUIRY
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.IDATE
      , :new.ACCEPTDATE
      , :new.NUMINQUIRY
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_EXEMPTIONTITLE
  AFTER DELETE
  ON EXEMPTIONTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_EXEMPTIONTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FACT
  AFTER INSERT
  ON FACT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FACT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FACT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FACT
  AFTER UPDATE
  ON FACT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FACT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FACT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FACT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_FACT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FACT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FACT
  AFTER DELETE
  ON FACT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FACT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FAXDOCS
  AFTER INSERT
  ON FAXDOCS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FAXDOCS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FAXDOCS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OWNERID
      ,OWNERDOCNUMBER
      ,OWNERDATE
      ,FILENAME
      ,CLIENTID
      ,DOCTYPE
      ,REJECT
      ,REJECTNOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,FACIALACC_CLS
      ,PRIMARYDOCTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OWNERID
      , :new.OWNERDOCNUMBER
      , :new.OWNERDATE
      , :new.FILENAME
      , :new.CLIENTID
      , :new.DOCTYPE
      , :new.REJECT
      , :new.REJECTNOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACIALACC_CLS
      , :new.PRIMARYDOCTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FAXDOCS
  AFTER UPDATE
  ON FAXDOCS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FAXDOCS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FAXDOCS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FAXDOCS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OWNERID
      ,OWNERDOCNUMBER
      ,OWNERDATE
      ,FILENAME
      ,CLIENTID
      ,DOCTYPE
      ,REJECT
      ,REJECTNOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,FACIALACC_CLS
      ,PRIMARYDOCTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OWNERID
      , :new.OWNERDOCNUMBER
      , :new.OWNERDATE
      , :new.FILENAME
      , :new.CLIENTID
      , :new.DOCTYPE
      , :new.REJECT
      , :new.REJECTNOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACIALACC_CLS
      , :new.PRIMARYDOCTYPE
    );
  else 
    update A_FAXDOCS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FAXDOCS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OWNERID
      ,OWNERDOCNUMBER
      ,OWNERDATE
      ,FILENAME
      ,CLIENTID
      ,DOCTYPE
      ,REJECT
      ,REJECTNOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,FACIALACC_CLS
      ,PRIMARYDOCTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OWNERID
      , :new.OWNERDOCNUMBER
      , :new.OWNERDATE
      , :new.FILENAME
      , :new.CLIENTID
      , :new.DOCTYPE
      , :new.REJECT
      , :new.REJECTNOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACIALACC_CLS
      , :new.PRIMARYDOCTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FAXDOCS
  AFTER DELETE
  ON FAXDOCS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FAXDOCS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FIELDSINFO
  AFTER INSERT
  ON FIELDSINFO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FIELDSINFO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FIELDSINFO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FIELDKIND
      ,DESCRIPTIONLEVEL
      ,ANCESTORREF
      ,SELECTIONREF
      ,TABLEREF
      ,FIELDNAME
      ,DATATYPE
      ,SUBDATATYPE
      ,FIELDSIZE
      ,DISPLAYLABEL
      ,NOTE
      ,DEFAULTWIDTH
      ,EDITMASK
      ,DISPLAYFORMAT
      ,EDITFORMAT
      ,CANTEDIT
      ,NOVISUALIZE
      ,ENUMSREF
      ,REQUIRED
      ,FOREIGNKEY
      ,ONDELACTION
      ,PRIMARYKEY
      ,ISRVERSION
      ,LIMITPARAMNAMES
      ,FOLLOWORDER
      ,SORTDIRECTION
      ,SORTORDER
      ,AGRFUNCTION
      ,FLAGFIELDNAME
      ,FLAGDISPLAYLABEL
      ,FLAGNOTE
      ,FLAGDEFAULTWIDTH
      ,FLAGCANTEDIT
      ,FLAGNOVISUALIZE
      ,FLAGREQUIRED
      ,FLAGLIMITPARAMNAMES
      ,FLAGAGRFUNCTION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ISTIMESTAMPFIELD
      ,ISBUDGET
      ,AVAILABLEINDEREF
      ,ANNOTATION
      ,ALIAS
      ,DEREFNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FIELDKIND
      , :new.DESCRIPTIONLEVEL
      , :new.ANCESTORREF
      , :new.SELECTIONREF
      , :new.TABLEREF
      , :new.FIELDNAME
      , :new.DATATYPE
      , :new.SUBDATATYPE
      , :new.FIELDSIZE
      , :new.DISPLAYLABEL
      , :new.NOTE
      , :new.DEFAULTWIDTH
      , :new.EDITMASK
      , :new.DISPLAYFORMAT
      , :new.EDITFORMAT
      , :new.CANTEDIT
      , :new.NOVISUALIZE
      , :new.ENUMSREF
      , :new.REQUIRED
      , :new.FOREIGNKEY
      , :new.ONDELACTION
      , :new.PRIMARYKEY
      , :new.ISRVERSION
      , :new.LIMITPARAMNAMES
      , :new.FOLLOWORDER
      , :new.SORTDIRECTION
      , :new.SORTORDER
      , :new.AGRFUNCTION
      , :new.FLAGFIELDNAME
      , :new.FLAGDISPLAYLABEL
      , :new.FLAGNOTE
      , :new.FLAGDEFAULTWIDTH
      , :new.FLAGCANTEDIT
      , :new.FLAGNOVISUALIZE
      , :new.FLAGREQUIRED
      , :new.FLAGLIMITPARAMNAMES
      , :new.FLAGAGRFUNCTION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ISTIMESTAMPFIELD
      , :new.ISBUDGET
      , :new.AVAILABLEINDEREF
      , :new.ANNOTATION
      , :new.ALIAS
      , :new.DEREFNAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FIELDSINFO
  AFTER UPDATE
  ON FIELDSINFO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FIELDSINFO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FIELDSINFO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FIELDSINFO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FIELDKIND
      ,DESCRIPTIONLEVEL
      ,ANCESTORREF
      ,SELECTIONREF
      ,TABLEREF
      ,FIELDNAME
      ,DATATYPE
      ,SUBDATATYPE
      ,FIELDSIZE
      ,DISPLAYLABEL
      ,NOTE
      ,DEFAULTWIDTH
      ,EDITMASK
      ,DISPLAYFORMAT
      ,EDITFORMAT
      ,CANTEDIT
      ,NOVISUALIZE
      ,ENUMSREF
      ,REQUIRED
      ,FOREIGNKEY
      ,ONDELACTION
      ,PRIMARYKEY
      ,ISRVERSION
      ,LIMITPARAMNAMES
      ,FOLLOWORDER
      ,SORTDIRECTION
      ,SORTORDER
      ,AGRFUNCTION
      ,FLAGFIELDNAME
      ,FLAGDISPLAYLABEL
      ,FLAGNOTE
      ,FLAGDEFAULTWIDTH
      ,FLAGCANTEDIT
      ,FLAGNOVISUALIZE
      ,FLAGREQUIRED
      ,FLAGLIMITPARAMNAMES
      ,FLAGAGRFUNCTION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ISTIMESTAMPFIELD
      ,ISBUDGET
      ,AVAILABLEINDEREF
      ,ANNOTATION
      ,ALIAS
      ,DEREFNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FIELDKIND
      , :new.DESCRIPTIONLEVEL
      , :new.ANCESTORREF
      , :new.SELECTIONREF
      , :new.TABLEREF
      , :new.FIELDNAME
      , :new.DATATYPE
      , :new.SUBDATATYPE
      , :new.FIELDSIZE
      , :new.DISPLAYLABEL
      , :new.NOTE
      , :new.DEFAULTWIDTH
      , :new.EDITMASK
      , :new.DISPLAYFORMAT
      , :new.EDITFORMAT
      , :new.CANTEDIT
      , :new.NOVISUALIZE
      , :new.ENUMSREF
      , :new.REQUIRED
      , :new.FOREIGNKEY
      , :new.ONDELACTION
      , :new.PRIMARYKEY
      , :new.ISRVERSION
      , :new.LIMITPARAMNAMES
      , :new.FOLLOWORDER
      , :new.SORTDIRECTION
      , :new.SORTORDER
      , :new.AGRFUNCTION
      , :new.FLAGFIELDNAME
      , :new.FLAGDISPLAYLABEL
      , :new.FLAGNOTE
      , :new.FLAGDEFAULTWIDTH
      , :new.FLAGCANTEDIT
      , :new.FLAGNOVISUALIZE
      , :new.FLAGREQUIRED
      , :new.FLAGLIMITPARAMNAMES
      , :new.FLAGAGRFUNCTION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ISTIMESTAMPFIELD
      , :new.ISBUDGET
      , :new.AVAILABLEINDEREF
      , :new.ANNOTATION
      , :new.ALIAS
      , :new.DEREFNAME
    );
  else 
    update A_FIELDSINFO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FIELDSINFO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FIELDKIND
      ,DESCRIPTIONLEVEL
      ,ANCESTORREF
      ,SELECTIONREF
      ,TABLEREF
      ,FIELDNAME
      ,DATATYPE
      ,SUBDATATYPE
      ,FIELDSIZE
      ,DISPLAYLABEL
      ,NOTE
      ,DEFAULTWIDTH
      ,EDITMASK
      ,DISPLAYFORMAT
      ,EDITFORMAT
      ,CANTEDIT
      ,NOVISUALIZE
      ,ENUMSREF
      ,REQUIRED
      ,FOREIGNKEY
      ,ONDELACTION
      ,PRIMARYKEY
      ,ISRVERSION
      ,LIMITPARAMNAMES
      ,FOLLOWORDER
      ,SORTDIRECTION
      ,SORTORDER
      ,AGRFUNCTION
      ,FLAGFIELDNAME
      ,FLAGDISPLAYLABEL
      ,FLAGNOTE
      ,FLAGDEFAULTWIDTH
      ,FLAGCANTEDIT
      ,FLAGNOVISUALIZE
      ,FLAGREQUIRED
      ,FLAGLIMITPARAMNAMES
      ,FLAGAGRFUNCTION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ISTIMESTAMPFIELD
      ,ISBUDGET
      ,AVAILABLEINDEREF
      ,ANNOTATION
      ,ALIAS
      ,DEREFNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FIELDKIND
      , :new.DESCRIPTIONLEVEL
      , :new.ANCESTORREF
      , :new.SELECTIONREF
      , :new.TABLEREF
      , :new.FIELDNAME
      , :new.DATATYPE
      , :new.SUBDATATYPE
      , :new.FIELDSIZE
      , :new.DISPLAYLABEL
      , :new.NOTE
      , :new.DEFAULTWIDTH
      , :new.EDITMASK
      , :new.DISPLAYFORMAT
      , :new.EDITFORMAT
      , :new.CANTEDIT
      , :new.NOVISUALIZE
      , :new.ENUMSREF
      , :new.REQUIRED
      , :new.FOREIGNKEY
      , :new.ONDELACTION
      , :new.PRIMARYKEY
      , :new.ISRVERSION
      , :new.LIMITPARAMNAMES
      , :new.FOLLOWORDER
      , :new.SORTDIRECTION
      , :new.SORTORDER
      , :new.AGRFUNCTION
      , :new.FLAGFIELDNAME
      , :new.FLAGDISPLAYLABEL
      , :new.FLAGNOTE
      , :new.FLAGDEFAULTWIDTH
      , :new.FLAGCANTEDIT
      , :new.FLAGNOVISUALIZE
      , :new.FLAGREQUIRED
      , :new.FLAGLIMITPARAMNAMES
      , :new.FLAGAGRFUNCTION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ISTIMESTAMPFIELD
      , :new.ISBUDGET
      , :new.AVAILABLEINDEREF
      , :new.ANNOTATION
      , :new.ALIAS
      , :new.DEREFNAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FIELDSINFO
  AFTER DELETE
  ON FIELDSINFO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FIELDSINFO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINCLAIM
  AFTER INSERT
  ON FINCLAIM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINCLAIM
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINCLAIM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,DAT
      ,ACC_REF
      ,NUMSTR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.DAT
      , :new.ACC_REF
      , :new.NUMSTR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINCLAIM
  AFTER UPDATE
  ON FINCLAIM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINCLAIM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINCLAIM
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINCLAIM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,DAT
      ,ACC_REF
      ,NUMSTR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.DAT
      , :new.ACC_REF
      , :new.NUMSTR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_FINCLAIM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINCLAIM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,DAT
      ,ACC_REF
      ,NUMSTR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.DAT
      , :new.ACC_REF
      , :new.NUMSTR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINCLAIM
  AFTER DELETE
  ON FINCLAIM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINCLAIM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINCLAIMDET
  AFTER INSERT
  ON FINCLAIMDET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINCLAIMDET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINCLAIMDET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,REF
      ,KD
      ,SUBKD
      ,GOSNI
      ,SUMMA
      ,ASUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.REF
      , :new.KD
      , :new.SUBKD
      , :new.GOSNI
      , :new.SUMMA
      , :new.ASUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINCLAIMDET
  AFTER UPDATE
  ON FINCLAIMDET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINCLAIMDET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINCLAIMDET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINCLAIMDET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,REF
      ,KD
      ,SUBKD
      ,GOSNI
      ,SUMMA
      ,ASUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.REF
      , :new.KD
      , :new.SUBKD
      , :new.GOSNI
      , :new.SUMMA
      , :new.ASUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_FINCLAIMDET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINCLAIMDET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,REF
      ,KD
      ,SUBKD
      ,GOSNI
      ,SUMMA
      ,ASUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.REF
      , :new.KD
      , :new.SUBKD
      , :new.GOSNI
      , :new.SUMMA
      , :new.ASUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINCLAIMDET
  AFTER DELETE
  ON FINCLAIMDET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINCLAIMDET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINDOCCAPTION
  AFTER INSERT
  ON FINDOCCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINDOCCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINDOCCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MAKEDATE
      ,ACCEPTDATE
      ,USERNOTE
      ,DFACCOUNT
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ANUMBER
      ,ELPACKETNAME
      ,RVERSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MAKEDATE
      , :new.ACCEPTDATE
      , :new.USERNOTE
      , :new.DFACCOUNT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ANUMBER
      , :new.ELPACKETNAME
      , :new.RVERSION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINDOCCAPTION
  AFTER UPDATE
  ON FINDOCCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINDOCCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINDOCCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINDOCCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MAKEDATE
      ,ACCEPTDATE
      ,USERNOTE
      ,DFACCOUNT
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ANUMBER
      ,ELPACKETNAME
      ,RVERSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MAKEDATE
      , :new.ACCEPTDATE
      , :new.USERNOTE
      , :new.DFACCOUNT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ANUMBER
      , :new.ELPACKETNAME
      , :new.RVERSION
    );
  else 
    update A_FINDOCCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINDOCCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MAKEDATE
      ,ACCEPTDATE
      ,USERNOTE
      ,DFACCOUNT
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ANUMBER
      ,ELPACKETNAME
      ,RVERSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MAKEDATE
      , :new.ACCEPTDATE
      , :new.USERNOTE
      , :new.DFACCOUNT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ANUMBER
      , :new.ELPACKETNAME
      , :new.RVERSION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINDOCCAPTION
  AFTER DELETE
  ON FINDOCCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINDOCCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINTENDER
  AFTER INSERT
  ON FINTENDER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTENDER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTENDER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,DAT
      ,ACC_REF
      ,NUMSTR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.DAT
      , :new.ACC_REF
      , :new.NUMSTR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINTENDER
  AFTER UPDATE
  ON FINTENDER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINTENDER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINTENDER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTENDER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,DAT
      ,ACC_REF
      ,NUMSTR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.DAT
      , :new.ACC_REF
      , :new.NUMSTR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_FINTENDER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINTENDER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,DAT
      ,ACC_REF
      ,NUMSTR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.DAT
      , :new.ACC_REF
      , :new.NUMSTR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINTENDER
  AFTER DELETE
  ON FINTENDER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTENDER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINTENDERDET
  AFTER INSERT
  ON FINTENDERDET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTENDERDET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTENDERDET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,REF
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,REGION
      ,FINTYPE
      ,MEANSTYPE
      ,SUMMA
      ,ASUMMA
      ,NOTE
      ,REESRT
      ,ACC_REF
      ,FACIALACC
      ,DOGNUM
      ,DOGDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.REF
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.REGION
      , :new.FINTYPE
      , :new.MEANSTYPE
      , :new.SUMMA
      , :new.ASUMMA
      , :new.NOTE
      , :new.REESRT
      , :new.ACC_REF
      , :new.FACIALACC
      , :new.DOGNUM
      , :new.DOGDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINTENDERDET
  AFTER UPDATE
  ON FINTENDERDET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINTENDERDET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINTENDERDET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTENDERDET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,REF
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,REGION
      ,FINTYPE
      ,MEANSTYPE
      ,SUMMA
      ,ASUMMA
      ,NOTE
      ,REESRT
      ,ACC_REF
      ,FACIALACC
      ,DOGNUM
      ,DOGDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.REF
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.REGION
      , :new.FINTYPE
      , :new.MEANSTYPE
      , :new.SUMMA
      , :new.ASUMMA
      , :new.NOTE
      , :new.REESRT
      , :new.ACC_REF
      , :new.FACIALACC
      , :new.DOGNUM
      , :new.DOGDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_FINTENDERDET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINTENDERDET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUD_REF
      ,REF
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,REGION
      ,FINTYPE
      ,MEANSTYPE
      ,SUMMA
      ,ASUMMA
      ,NOTE
      ,REESRT
      ,ACC_REF
      ,FACIALACC
      ,DOGNUM
      ,DOGDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUD_REF
      , :new.REF
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.REGION
      , :new.FINTYPE
      , :new.MEANSTYPE
      , :new.SUMMA
      , :new.ASUMMA
      , :new.NOTE
      , :new.REESRT
      , :new.ACC_REF
      , :new.FACIALACC
      , :new.DOGNUM
      , :new.DOGDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINTENDERDET
  AFTER DELETE
  ON FINTENDERDET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTENDERDET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINTENDERORG
  AFTER INSERT
  ON FINTENDERORG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTENDERORG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTENDERORG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,REF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.REF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINTENDERORG
  AFTER UPDATE
  ON FINTENDERORG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINTENDERORG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINTENDERORG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTENDERORG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,REF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.REF
    );
  else 
    update A_FINTENDERORG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINTENDERORG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,REF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.REF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINTENDERORG
  AFTER DELETE
  ON FINTENDERORG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTENDERORG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FINTYPE
  AFTER INSERT
  ON FINTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT
      ,CREATEDATE
      ,UPDATEDATE
      ,GENBUHACCFLAG
      ,NAME
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.GENBUHACCFLAG
      , :new.NAME
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FINTYPE
  AFTER UPDATE
  ON FINTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FINTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FINTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FINTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT
      ,CREATEDATE
      ,UPDATEDATE
      ,GENBUHACCFLAG
      ,NAME
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.GENBUHACCFLAG
      , :new.NAME
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_FINTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FINTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCOUNT
      ,CREATEDATE
      ,UPDATEDATE
      ,GENBUHACCFLAG
      ,NAME
      ,CODE
      ,BUDGETREF
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCOUNT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.GENBUHACCFLAG
      , :new.NAME
      , :new.CODE
      , :new.BUDGETREF
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FINTYPE
  AFTER DELETE
  ON FINTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FINTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_FUNDSSOURCE
  AFTER INSERT
  ON FUNDSSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FUNDSSOURCE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FUNDSSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NAME
      ,SHORTNAME
      ,NOTE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_FUNDSSOURCE
  AFTER UPDATE
  ON FUNDSSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_FUNDSSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_FUNDSSOURCE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_FUNDSSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NAME
      ,SHORTNAME
      ,NOTE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_FUNDSSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_FUNDSSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NAME
      ,SHORTNAME
      ,NOTE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_FUNDSSOURCE
  AFTER DELETE
  ON FUNDSSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_FUNDSSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GENERALDOCSDETAIL
  AFTER INSERT
  ON GENERALDOCSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GENERALDOCSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GENERALDOCSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,RECORDINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.RECORDINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GENERALDOCSDETAIL
  AFTER UPDATE
  ON GENERALDOCSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GENERALDOCSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GENERALDOCSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GENERALDOCSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,RECORDINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.RECORDINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_GENERALDOCSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GENERALDOCSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,RECORDINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.RECORDINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GENERALDOCSDETAIL
  AFTER DELETE
  ON GENERALDOCSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GENERALDOCSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GENERALDOCUMENTS
  AFTER INSERT
  ON GENERALDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GENERALDOCUMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GENERALDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,DOCNUMBER
      ,DOCBASE
      ,ARCHIVEDOCTYPE
      ,NAME
      ,BEGINDATE
      ,ENDDATE
      ,REGISTRATIONDATE
      ,DOCTYPESLIST
      ,REJECTCLS
      ,REJECTCAUSE
      ,PROGINDEX
      ,DOCSTATEREF
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.DOCNUMBER
      , :new.DOCBASE
      , :new.ARCHIVEDOCTYPE
      , :new.NAME
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.REGISTRATIONDATE
      , :new.DOCTYPESLIST
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.PROGINDEX
      , :new.DOCSTATEREF
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GENERALDOCUMENTS
  AFTER UPDATE
  ON GENERALDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GENERALDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GENERALDOCUMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GENERALDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,DOCNUMBER
      ,DOCBASE
      ,ARCHIVEDOCTYPE
      ,NAME
      ,BEGINDATE
      ,ENDDATE
      ,REGISTRATIONDATE
      ,DOCTYPESLIST
      ,REJECTCLS
      ,REJECTCAUSE
      ,PROGINDEX
      ,DOCSTATEREF
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.DOCNUMBER
      , :new.DOCBASE
      , :new.ARCHIVEDOCTYPE
      , :new.NAME
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.REGISTRATIONDATE
      , :new.DOCTYPESLIST
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.PROGINDEX
      , :new.DOCSTATEREF
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_GENERALDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GENERALDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,DOCNUMBER
      ,DOCBASE
      ,ARCHIVEDOCTYPE
      ,NAME
      ,BEGINDATE
      ,ENDDATE
      ,REGISTRATIONDATE
      ,DOCTYPESLIST
      ,REJECTCLS
      ,REJECTCAUSE
      ,PROGINDEX
      ,DOCSTATEREF
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.DOCNUMBER
      , :new.DOCBASE
      , :new.ARCHIVEDOCTYPE
      , :new.NAME
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.REGISTRATIONDATE
      , :new.DOCTYPESLIST
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.PROGINDEX
      , :new.DOCSTATEREF
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GENERALDOCUMENTS
  AFTER DELETE
  ON GENERALDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GENERALDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GOSNI
  AFTER INSERT
  ON GOSNI
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GOSNI
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GOSNI (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GOSNI
  AFTER UPDATE
  ON GOSNI
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GOSNI
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GOSNI
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GOSNI (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_GOSNI
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GOSNI (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GOSNI
  AFTER DELETE
  ON GOSNI
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GOSNI
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GROUPINF_CLS
  AFTER INSERT
  ON GROUPINF_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GROUPINF_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GROUPINF_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GROUPINF_CLS
  AFTER UPDATE
  ON GROUPINF_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GROUPINF_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GROUPINF_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GROUPINF_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_GROUPINF_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GROUPINF_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GROUPINF_CLS
  AFTER DELETE
  ON GROUPINF_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GROUPINF_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GROUPSRIGHTS
  AFTER INSERT
  ON GROUPSRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GROUPSRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GROUPSRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,RIGHTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RIGHTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GROUPSRIGHTS
  AFTER UPDATE
  ON GROUPSRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GROUPSRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GROUPSRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GROUPSRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,RIGHTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RIGHTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_GROUPSRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GROUPSRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,RIGHTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RIGHTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GROUPSRIGHTS
  AFTER DELETE
  ON GROUPSRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GROUPSRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GROUPSWORKPLACES
  AFTER INSERT
  ON GROUPSWORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GROUPSWORKPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GROUPSWORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,WORKPLACEREF
      ,DEFAULTWORKPLACE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.WORKPLACEREF
      , :new.DEFAULTWORKPLACE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GROUPSWORKPLACES
  AFTER UPDATE
  ON GROUPSWORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GROUPSWORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GROUPSWORKPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GROUPSWORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,WORKPLACEREF
      ,DEFAULTWORKPLACE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.WORKPLACEREF
      , :new.DEFAULTWORKPLACE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_GROUPSWORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GROUPSWORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,WORKPLACEREF
      ,DEFAULTWORKPLACE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.WORKPLACEREF
      , :new.DEFAULTWORKPLACE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GROUPSWORKPLACES
  AFTER DELETE
  ON GROUPSWORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GROUPSWORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_GUARANTEE
  AFTER INSERT
  ON GUARANTEE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GUARANTEE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GUARANTEE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,PROGINDEX
      ,ACCEPTDATE
      ,RECORDDATE
      ,PLANDATE
      ,CREDIT
      ,DEBIT
      ,SOURCEDOCNUMBER
      ,NOTE
      ,BUHPAYMENTCLS
      ,DOCTYPE
      ,PERIODSTART
      ,PERIODEND
      ,CURRENCYCLS
      ,SUBRECORDINDEX
      ,SUBPROGINDEX
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,PARENTID
      ,CURRENCYSUMMA
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.ACCEPTDATE
      , :new.RECORDDATE
      , :new.PLANDATE
      , :new.CREDIT
      , :new.DEBIT
      , :new.SOURCEDOCNUMBER
      , :new.NOTE
      , :new.BUHPAYMENTCLS
      , :new.DOCTYPE
      , :new.PERIODSTART
      , :new.PERIODEND
      , :new.CURRENCYCLS
      , :new.SUBRECORDINDEX
      , :new.SUBPROGINDEX
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.PARENTID
      , :new.CURRENCYSUMMA
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_GUARANTEE
  AFTER UPDATE
  ON GUARANTEE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_GUARANTEE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_GUARANTEE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_GUARANTEE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,PROGINDEX
      ,ACCEPTDATE
      ,RECORDDATE
      ,PLANDATE
      ,CREDIT
      ,DEBIT
      ,SOURCEDOCNUMBER
      ,NOTE
      ,BUHPAYMENTCLS
      ,DOCTYPE
      ,PERIODSTART
      ,PERIODEND
      ,CURRENCYCLS
      ,SUBRECORDINDEX
      ,SUBPROGINDEX
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,PARENTID
      ,CURRENCYSUMMA
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.ACCEPTDATE
      , :new.RECORDDATE
      , :new.PLANDATE
      , :new.CREDIT
      , :new.DEBIT
      , :new.SOURCEDOCNUMBER
      , :new.NOTE
      , :new.BUHPAYMENTCLS
      , :new.DOCTYPE
      , :new.PERIODSTART
      , :new.PERIODEND
      , :new.CURRENCYCLS
      , :new.SUBRECORDINDEX
      , :new.SUBPROGINDEX
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.PARENTID
      , :new.CURRENCYSUMMA
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
    );
  else 
    update A_GUARANTEE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_GUARANTEE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,PROGINDEX
      ,ACCEPTDATE
      ,RECORDDATE
      ,PLANDATE
      ,CREDIT
      ,DEBIT
      ,SOURCEDOCNUMBER
      ,NOTE
      ,BUHPAYMENTCLS
      ,DOCTYPE
      ,PERIODSTART
      ,PERIODEND
      ,CURRENCYCLS
      ,SUBRECORDINDEX
      ,SUBPROGINDEX
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,PARENTID
      ,CURRENCYSUMMA
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.ACCEPTDATE
      , :new.RECORDDATE
      , :new.PLANDATE
      , :new.CREDIT
      , :new.DEBIT
      , :new.SOURCEDOCNUMBER
      , :new.NOTE
      , :new.BUHPAYMENTCLS
      , :new.DOCTYPE
      , :new.PERIODSTART
      , :new.PERIODEND
      , :new.CURRENCYCLS
      , :new.SUBRECORDINDEX
      , :new.SUBPROGINDEX
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.PARENTID
      , :new.CURRENCYSUMMA
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_GUARANTEE
  AFTER DELETE
  ON GUARANTEE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_GUARANTEE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INCCURRENCY
  AFTER INSERT
  ON INCCURRENCY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCCURRENCY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCCURRENCY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURRENCYSUM
      ,EXCHANGE
      ,DELTA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURRENCYSUM
      , :new.EXCHANGE
      , :new.DELTA
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INCCURRENCY
  AFTER UPDATE
  ON INCCURRENCY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INCCURRENCY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INCCURRENCY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCCURRENCY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURRENCYSUM
      ,EXCHANGE
      ,DELTA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURRENCYSUM
      , :new.EXCHANGE
      , :new.DELTA
    );
  else 
    update A_INCCURRENCY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INCCURRENCY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CURRENCYSUM
      ,EXCHANGE
      ,DELTA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CURRENCYSUM
      , :new.EXCHANGE
      , :new.DELTA
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INCCURRENCY
  AFTER DELETE
  ON INCCURRENCY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCCURRENCY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INCOMES_ARREARS
  AFTER INSERT
  ON INCOMES_ARREARS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCOMES_ARREARS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCOMES_ARREARS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARREARSDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARREARSDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INCOMES_ARREARS
  AFTER UPDATE
  ON INCOMES_ARREARS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INCOMES_ARREARS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INCOMES_ARREARS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCOMES_ARREARS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARREARSDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARREARSDATE
    );
  else 
    update A_INCOMES_ARREARS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INCOMES_ARREARS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARREARSDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARREARSDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INCOMES_ARREARS
  AFTER DELETE
  ON INCOMES_ARREARS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCOMES_ARREARS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INCOMESDATA
  AFTER INSERT
  ON INCOMESDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCOMESDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCOMESDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,DOCTYPE
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,FACIALACC_CLS
      ,MEANSTYPE
      ,RVERSION
      ,FACT
      ,SENDERID
      ,SENDERRECORDID
      ,FUNDSSOURCE
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,ASSIGNMENTKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.FACIALACC_CLS
      , :new.MEANSTYPE
      , :new.RVERSION
      , :new.FACT
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.FUNDSSOURCE
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.ASSIGNMENTKIND
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INCOMESDATA
  AFTER UPDATE
  ON INCOMESDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INCOMESDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INCOMESDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCOMESDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,DOCTYPE
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,FACIALACC_CLS
      ,MEANSTYPE
      ,RVERSION
      ,FACT
      ,SENDERID
      ,SENDERRECORDID
      ,FUNDSSOURCE
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,ASSIGNMENTKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.FACIALACC_CLS
      , :new.MEANSTYPE
      , :new.RVERSION
      , :new.FACT
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.FUNDSSOURCE
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.ASSIGNMENTKIND
    );
  else 
    update A_INCOMESDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INCOMESDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,DOCTYPE
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,FACIALACC_CLS
      ,MEANSTYPE
      ,RVERSION
      ,FACT
      ,SENDERID
      ,SENDERRECORDID
      ,FUNDSSOURCE
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,ASSIGNMENTKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.FACIALACC_CLS
      , :new.MEANSTYPE
      , :new.RVERSION
      , :new.FACT
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.FUNDSSOURCE
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.ASSIGNMENTKIND
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INCOMESDATA
  AFTER DELETE
  ON INCOMESDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCOMESDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INCOMESNOTIF
  AFTER INSERT
  ON INCOMESNOTIF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCOMESNOTIF
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCOMESNOTIF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,BUILDDATE
      ,ACCEPTDATE
      ,DOCBASEDATE
      ,DOCBASETYPE
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,VARIANT
      ,ANUMBER
      ,ATYPE
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,DOCBASENUMBER
      ,LASTEXTRCHANGE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,PLANDOCTYPE
      ,STIMATEID
      ,PROGINDEX
      ,ASSIGNMENTSOURCE
      ,KPPERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.DOCBASEDATE
      , :new.DOCBASETYPE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.VARIANT
      , :new.ANUMBER
      , :new.ATYPE
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCBASENUMBER
      , :new.LASTEXTRCHANGE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.PLANDOCTYPE
      , :new.STIMATEID
      , :new.PROGINDEX
      , :new.ASSIGNMENTSOURCE
      , :new.KPPERIOD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INCOMESNOTIF
  AFTER UPDATE
  ON INCOMESNOTIF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INCOMESNOTIF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INCOMESNOTIF
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCOMESNOTIF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,BUILDDATE
      ,ACCEPTDATE
      ,DOCBASEDATE
      ,DOCBASETYPE
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,VARIANT
      ,ANUMBER
      ,ATYPE
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,DOCBASENUMBER
      ,LASTEXTRCHANGE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,PLANDOCTYPE
      ,STIMATEID
      ,PROGINDEX
      ,ASSIGNMENTSOURCE
      ,KPPERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.DOCBASEDATE
      , :new.DOCBASETYPE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.VARIANT
      , :new.ANUMBER
      , :new.ATYPE
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCBASENUMBER
      , :new.LASTEXTRCHANGE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.PLANDOCTYPE
      , :new.STIMATEID
      , :new.PROGINDEX
      , :new.ASSIGNMENTSOURCE
      , :new.KPPERIOD
    );
  else 
    update A_INCOMESNOTIF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INCOMESNOTIF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,BUILDDATE
      ,ACCEPTDATE
      ,DOCBASEDATE
      ,DOCBASETYPE
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,VARIANT
      ,ANUMBER
      ,ATYPE
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,DOCBASENUMBER
      ,LASTEXTRCHANGE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,PLANDOCTYPE
      ,STIMATEID
      ,PROGINDEX
      ,ASSIGNMENTSOURCE
      ,KPPERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.DOCBASEDATE
      , :new.DOCBASETYPE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.VARIANT
      , :new.ANUMBER
      , :new.ATYPE
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCBASENUMBER
      , :new.LASTEXTRCHANGE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.PLANDOCTYPE
      , :new.STIMATEID
      , :new.PROGINDEX
      , :new.ASSIGNMENTSOURCE
      , :new.KPPERIOD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INCOMESNOTIF
  AFTER DELETE
  ON INCOMESNOTIF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCOMESNOTIF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INCTEMPLATEDETAIL
  AFTER INSERT
  ON INCTEMPLATEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCTEMPLATEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCTEMPLATEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,DOCTYPE
      ,ACCOUNTINDEX
      ,TITLE_REF
      ,PERCENT
      ,PERCENTTOTAL
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.ACCOUNTINDEX
      , :new.TITLE_REF
      , :new.PERCENT
      , :new.PERCENTTOTAL
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.BUDGETREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INCTEMPLATEDETAIL
  AFTER UPDATE
  ON INCTEMPLATEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INCTEMPLATEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INCTEMPLATEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCTEMPLATEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,DOCTYPE
      ,ACCOUNTINDEX
      ,TITLE_REF
      ,PERCENT
      ,PERCENTTOTAL
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.ACCOUNTINDEX
      , :new.TITLE_REF
      , :new.PERCENT
      , :new.PERCENTTOTAL
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.BUDGETREF
    );
  else 
    update A_INCTEMPLATEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INCTEMPLATEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,DOCTYPE
      ,ACCOUNTINDEX
      ,TITLE_REF
      ,PERCENT
      ,PERCENTTOTAL
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.ACCOUNTINDEX
      , :new.TITLE_REF
      , :new.PERCENT
      , :new.PERCENTTOTAL
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.BUDGETREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INCTEMPLATEDETAIL
  AFTER DELETE
  ON INCTEMPLATEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCTEMPLATEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INCTEMPLATETITLE
  AFTER INSERT
  ON INCTEMPLATETITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCTEMPLATETITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCTEMPLATETITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,PERCENTTOTAL
      ,ACCEPTFLAG
      ,KD
      ,TEMPLATETYPE
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.PERCENTTOTAL
      , :new.ACCEPTFLAG
      , :new.KD
      , :new.TEMPLATETYPE
      , :new.BUDGETREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INCTEMPLATETITLE
  AFTER UPDATE
  ON INCTEMPLATETITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INCTEMPLATETITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INCTEMPLATETITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INCTEMPLATETITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,PERCENTTOTAL
      ,ACCEPTFLAG
      ,KD
      ,TEMPLATETYPE
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.PERCENTTOTAL
      , :new.ACCEPTFLAG
      , :new.KD
      , :new.TEMPLATETYPE
      , :new.BUDGETREF
    );
  else 
    update A_INCTEMPLATETITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INCTEMPLATETITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,PERCENTTOTAL
      ,ACCEPTFLAG
      ,KD
      ,TEMPLATETYPE
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.PERCENTTOTAL
      , :new.ACCEPTFLAG
      , :new.KD
      , :new.TEMPLATETYPE
      , :new.BUDGETREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INCTEMPLATETITLE
  AFTER DELETE
  ON INCTEMPLATETITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INCTEMPLATETITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INTCONST
  AFTER INSERT
  ON INTCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INTCONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INTCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,ID
      ,CREATERUSER
      ,UPDATERUSER
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ID
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INTCONST
  AFTER UPDATE
  ON INTCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INTCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INTCONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INTCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,ID
      ,CREATERUSER
      ,UPDATERUSER
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ID
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  else 
    update A_INTCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INTCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,ID
      ,CREATERUSER
      ,UPDATERUSER
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ID
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INTCONST
  AFTER DELETE
  ON INTCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INTCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INTERFACESBUHOP
  AFTER INSERT
  ON INTERFACESBUHOP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INTERFACESBUHOP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INTERFACESBUHOP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INTERFACECLS
      ,BUHOPERATIONCLS
      ,BUHOPERATIONPRIORITY
      ,CREATEDATE
      ,UPDATEDATE
      ,DETAILNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INTERFACECLS
      , :new.BUHOPERATIONCLS
      , :new.BUHOPERATIONPRIORITY
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DETAILNUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INTERFACESBUHOP
  AFTER UPDATE
  ON INTERFACESBUHOP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INTERFACESBUHOP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INTERFACESBUHOP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INTERFACESBUHOP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INTERFACECLS
      ,BUHOPERATIONCLS
      ,BUHOPERATIONPRIORITY
      ,CREATEDATE
      ,UPDATEDATE
      ,DETAILNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INTERFACECLS
      , :new.BUHOPERATIONCLS
      , :new.BUHOPERATIONPRIORITY
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DETAILNUMBER
    );
  else 
    update A_INTERFACESBUHOP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INTERFACESBUHOP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INTERFACECLS
      ,BUHOPERATIONCLS
      ,BUHOPERATIONPRIORITY
      ,CREATEDATE
      ,UPDATEDATE
      ,DETAILNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INTERFACECLS
      , :new.BUHOPERATIONCLS
      , :new.BUHOPERATIONPRIORITY
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DETAILNUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INTERFACESBUHOP
  AFTER DELETE
  ON INTERFACESBUHOP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INTERFACESBUHOP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_INVESTOBJECT
  AFTER INSERT
  ON INVESTOBJECT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INVESTOBJECT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INVESTOBJECT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,SUBCODE
      ,BUDGETFINSOURCEOBJECTCODE
      ,NAME
      ,SHORTNAME
      ,OWNERLEVEL
      ,BUDGETREF
      ,REGIONCLS
      ,BUDGETFINSOURCELEVEL
      ,PARENTREF
      ,STARTDATE
      ,DELETEDATE
      ,KVSR
      ,KCSR
      ,TARGETCLS
      ,NOTE
      ,MEANSTYPE
      ,TRANSFERTCLS
      ,FACT
      ,OKTMO
      ,NPAID
      ,NPADATE
      ,NPANUMBER
      ,NPAGROUP
      ,NPANAME
      ,ADDRESS
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,SUBSIDYCLS
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.SUBCODE
      , :new.BUDGETFINSOURCEOBJECTCODE
      , :new.NAME
      , :new.SHORTNAME
      , :new.OWNERLEVEL
      , :new.BUDGETREF
      , :new.REGIONCLS
      , :new.BUDGETFINSOURCELEVEL
      , :new.PARENTREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.KVSR
      , :new.KCSR
      , :new.TARGETCLS
      , :new.NOTE
      , :new.MEANSTYPE
      , :new.TRANSFERTCLS
      , :new.FACT
      , :new.OKTMO
      , :new.NPAID
      , :new.NPADATE
      , :new.NPANUMBER
      , :new.NPAGROUP
      , :new.NPANAME
      , :new.ADDRESS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.SUBSIDYCLS
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_INVESTOBJECT
  AFTER UPDATE
  ON INVESTOBJECT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_INVESTOBJECT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_INVESTOBJECT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_INVESTOBJECT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,SUBCODE
      ,BUDGETFINSOURCEOBJECTCODE
      ,NAME
      ,SHORTNAME
      ,OWNERLEVEL
      ,BUDGETREF
      ,REGIONCLS
      ,BUDGETFINSOURCELEVEL
      ,PARENTREF
      ,STARTDATE
      ,DELETEDATE
      ,KVSR
      ,KCSR
      ,TARGETCLS
      ,NOTE
      ,MEANSTYPE
      ,TRANSFERTCLS
      ,FACT
      ,OKTMO
      ,NPAID
      ,NPADATE
      ,NPANUMBER
      ,NPAGROUP
      ,NPANAME
      ,ADDRESS
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,SUBSIDYCLS
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.SUBCODE
      , :new.BUDGETFINSOURCEOBJECTCODE
      , :new.NAME
      , :new.SHORTNAME
      , :new.OWNERLEVEL
      , :new.BUDGETREF
      , :new.REGIONCLS
      , :new.BUDGETFINSOURCELEVEL
      , :new.PARENTREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.KVSR
      , :new.KCSR
      , :new.TARGETCLS
      , :new.NOTE
      , :new.MEANSTYPE
      , :new.TRANSFERTCLS
      , :new.FACT
      , :new.OKTMO
      , :new.NPAID
      , :new.NPADATE
      , :new.NPANUMBER
      , :new.NPAGROUP
      , :new.NPANAME
      , :new.ADDRESS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.SUBSIDYCLS
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_INVESTOBJECT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_INVESTOBJECT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,SUBCODE
      ,BUDGETFINSOURCEOBJECTCODE
      ,NAME
      ,SHORTNAME
      ,OWNERLEVEL
      ,BUDGETREF
      ,REGIONCLS
      ,BUDGETFINSOURCELEVEL
      ,PARENTREF
      ,STARTDATE
      ,DELETEDATE
      ,KVSR
      ,KCSR
      ,TARGETCLS
      ,NOTE
      ,MEANSTYPE
      ,TRANSFERTCLS
      ,FACT
      ,OKTMO
      ,NPAID
      ,NPADATE
      ,NPANUMBER
      ,NPAGROUP
      ,NPANAME
      ,ADDRESS
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,SUBSIDYCLS
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.SUBCODE
      , :new.BUDGETFINSOURCEOBJECTCODE
      , :new.NAME
      , :new.SHORTNAME
      , :new.OWNERLEVEL
      , :new.BUDGETREF
      , :new.REGIONCLS
      , :new.BUDGETFINSOURCELEVEL
      , :new.PARENTREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.KVSR
      , :new.KCSR
      , :new.TARGETCLS
      , :new.NOTE
      , :new.MEANSTYPE
      , :new.TRANSFERTCLS
      , :new.FACT
      , :new.OKTMO
      , :new.NPAID
      , :new.NPADATE
      , :new.NPANUMBER
      , :new.NPAGROUP
      , :new.NPANAME
      , :new.ADDRESS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.SUBSIDYCLS
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_INVESTOBJECT
  AFTER DELETE
  ON INVESTOBJECT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_INVESTOBJECT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ITF_CTRL
  AFTER INSERT
  ON ITF_CTRL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ITF_CTRL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ITF_CTRL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ITF_REF
      ,CTRL_REF
      ,NOTE
      ,ORDERBY
      ,CTRLOPTIONS
      ,DOCINDEX
      ,SCENARIOREF
      ,ELEMFILTER
      ,ENABLE
      ,ERRORMESSAGE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,CONTROLFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ITF_REF
      , :new.CTRL_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.CTRLOPTIONS
      , :new.DOCINDEX
      , :new.SCENARIOREF
      , :new.ELEMFILTER
      , :new.ENABLE
      , :new.ERRORMESSAGE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CONTROLFIELD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ITF_CTRL
  AFTER UPDATE
  ON ITF_CTRL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ITF_CTRL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ITF_CTRL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ITF_CTRL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ITF_REF
      ,CTRL_REF
      ,NOTE
      ,ORDERBY
      ,CTRLOPTIONS
      ,DOCINDEX
      ,SCENARIOREF
      ,ELEMFILTER
      ,ENABLE
      ,ERRORMESSAGE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,CONTROLFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ITF_REF
      , :new.CTRL_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.CTRLOPTIONS
      , :new.DOCINDEX
      , :new.SCENARIOREF
      , :new.ELEMFILTER
      , :new.ENABLE
      , :new.ERRORMESSAGE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CONTROLFIELD
    );
  else 
    update A_ITF_CTRL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ITF_CTRL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ITF_REF
      ,CTRL_REF
      ,NOTE
      ,ORDERBY
      ,CTRLOPTIONS
      ,DOCINDEX
      ,SCENARIOREF
      ,ELEMFILTER
      ,ENABLE
      ,ERRORMESSAGE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,CONTROLFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ITF_REF
      , :new.CTRL_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.CTRLOPTIONS
      , :new.DOCINDEX
      , :new.SCENARIOREF
      , :new.ELEMFILTER
      , :new.ENABLE
      , :new.ERRORMESSAGE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CONTROLFIELD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ITF_CTRL
  AFTER DELETE
  ON ITF_CTRL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ITF_CTRL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ITF_DOCS
  AFTER INSERT
  ON ITF_DOCS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ITF_DOCS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ITF_DOCS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ITF_REF
      ,DOC_REF
      ,NOTE
      ,ORDERBY
      ,DEFAULTEXEC
      ,DOCINDEX
      ,ELEMFILTER
      ,ENABLE
      ,ERRORMESSAGE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ITF_REF
      , :new.DOC_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.DEFAULTEXEC
      , :new.DOCINDEX
      , :new.ELEMFILTER
      , :new.ENABLE
      , :new.ERRORMESSAGE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ITF_DOCS
  AFTER UPDATE
  ON ITF_DOCS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ITF_DOCS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ITF_DOCS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ITF_DOCS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ITF_REF
      ,DOC_REF
      ,NOTE
      ,ORDERBY
      ,DEFAULTEXEC
      ,DOCINDEX
      ,ELEMFILTER
      ,ENABLE
      ,ERRORMESSAGE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ITF_REF
      , :new.DOC_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.DEFAULTEXEC
      , :new.DOCINDEX
      , :new.ELEMFILTER
      , :new.ENABLE
      , :new.ERRORMESSAGE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_ITF_DOCS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ITF_DOCS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ITF_REF
      ,DOC_REF
      ,NOTE
      ,ORDERBY
      ,DEFAULTEXEC
      ,DOCINDEX
      ,ELEMFILTER
      ,ENABLE
      ,ERRORMESSAGE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ITF_REF
      , :new.DOC_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.DEFAULTEXEC
      , :new.DOCINDEX
      , :new.ELEMFILTER
      , :new.ENABLE
      , :new.ERRORMESSAGE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ITF_DOCS
  AFTER DELETE
  ON ITF_DOCS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ITF_DOCS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KCSR
  AFTER INSERT
  ON KCSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KCSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KCSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,CODE
      ,CONFORMITYCODE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CODE
      , :new.CONFORMITYCODE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KCSR
  AFTER UPDATE
  ON KCSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KCSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KCSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KCSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,CODE
      ,CONFORMITYCODE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CODE
      , :new.CONFORMITYCODE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_KCSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KCSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,CODE
      ,CONFORMITYCODE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CODE
      , :new.CONFORMITYCODE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KCSR
  AFTER DELETE
  ON KCSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KCSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KDSHIFR
  AFTER INSERT
  ON KDSHIFR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KDSHIFR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KDSHIFR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHIFR
      ,NAME
      ,SECTIONNAME
      ,ROWLEVEL
      ,TEMPLATENAME
      ,LAYER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHIFR
      , :new.NAME
      , :new.SECTIONNAME
      , :new.ROWLEVEL
      , :new.TEMPLATENAME
      , :new.LAYER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KDSHIFR
  AFTER UPDATE
  ON KDSHIFR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KDSHIFR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KDSHIFR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KDSHIFR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHIFR
      ,NAME
      ,SECTIONNAME
      ,ROWLEVEL
      ,TEMPLATENAME
      ,LAYER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHIFR
      , :new.NAME
      , :new.SECTIONNAME
      , :new.ROWLEVEL
      , :new.TEMPLATENAME
      , :new.LAYER
    );
  else 
    update A_KDSHIFR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KDSHIFR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHIFR
      ,NAME
      ,SECTIONNAME
      ,ROWLEVEL
      ,TEMPLATENAME
      ,LAYER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHIFR
      , :new.NAME
      , :new.SECTIONNAME
      , :new.ROWLEVEL
      , :new.TEMPLATENAME
      , :new.LAYER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KDSHIFR
  AFTER DELETE
  ON KDSHIFR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KDSHIFR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KDSHIFRDETAIL
  AFTER INSERT
  ON KDSHIFRDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KDSHIFRDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KDSHIFRDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KD
      ,USEOLD
      ,USENEW
      ,KDEXT
      ,KDEXTMASK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KD
      , :new.USEOLD
      , :new.USENEW
      , :new.KDEXT
      , :new.KDEXTMASK
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KDSHIFRDETAIL
  AFTER UPDATE
  ON KDSHIFRDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KDSHIFRDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KDSHIFRDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KDSHIFRDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KD
      ,USEOLD
      ,USENEW
      ,KDEXT
      ,KDEXTMASK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KD
      , :new.USEOLD
      , :new.USENEW
      , :new.KDEXT
      , :new.KDEXTMASK
    );
  else 
    update A_KDSHIFRDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KDSHIFRDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KD
      ,USEOLD
      ,USENEW
      ,KDEXT
      ,KDEXTMASK
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KD
      , :new.USEOLD
      , :new.USENEW
      , :new.KDEXT
      , :new.KDEXTMASK
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KDSHIFRDETAIL
  AFTER DELETE
  ON KDSHIFRDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KDSHIFRDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KESR
  AFTER INSERT
  ON KESR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KESR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KESR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CONTROLCODE
      ,CREATEDATE
      ,UPDATEDATE
      ,ISEKR
      ,ISEKD
      ,ISEKI
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CONTROLCODE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ISEKR
      , :new.ISEKD
      , :new.ISEKI
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KESR
  AFTER UPDATE
  ON KESR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KESR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KESR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KESR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CONTROLCODE
      ,CREATEDATE
      ,UPDATEDATE
      ,ISEKR
      ,ISEKD
      ,ISEKI
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CONTROLCODE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ISEKR
      , :new.ISEKD
      , :new.ISEKI
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_KESR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KESR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CONTROLCODE
      ,CREATEDATE
      ,UPDATEDATE
      ,ISEKR
      ,ISEKD
      ,ISEKI
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CONTROLCODE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ISEKR
      , :new.ISEKD
      , :new.ISEKI
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KESR
  AFTER DELETE
  ON KESR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KESR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KESRSUBCODE
  AFTER INSERT
  ON KESRSUBCODE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KESRSUBCODE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KESRSUBCODE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KESRSUBCODE
  AFTER UPDATE
  ON KESRSUBCODE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KESRSUBCODE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KESRSUBCODE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KESRSUBCODE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_KESRSUBCODE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KESRSUBCODE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KESRSUBCODE
  AFTER DELETE
  ON KESRSUBCODE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KESRSUBCODE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KFSR
  AFTER INSERT
  ON KFSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KFSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KFSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KFSR
  AFTER UPDATE
  ON KFSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KFSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KFSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KFSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_KFSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KFSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KFSR
  AFTER DELETE
  ON KFSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KFSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KSHK
  AFTER INSERT
  ON KSHK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KSHK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KSHK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KSHK
  AFTER UPDATE
  ON KSHK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KSHK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KSHK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KSHK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_KSHK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KSHK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KSHK
  AFTER DELETE
  ON KSHK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KSHK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KVR
  AFTER INSERT
  ON KVR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KVR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KVR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KVR
  AFTER UPDATE
  ON KVR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KVR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KVR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KVR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_KVR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KVR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KVR
  AFTER DELETE
  ON KVR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KVR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_KVSR
  AFTER INSERT
  ON KVSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KVSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KVSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,ORG_REF
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ORG_REF
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_KVSR
  AFTER UPDATE
  ON KVSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_KVSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_KVSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_KVSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,ORG_REF
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ORG_REF
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_KVSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_KVSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,ORG_REF
      ,CODE
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ORG_REF
      , :new.CODE
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_KVSR
  AFTER DELETE
  ON KVSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_KVSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERBLOBS
  AFTER INSERT
  ON LAYERBLOBS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERBLOBS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERBLOBS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDID
      ,VALUEINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDID
      , :new.VALUEINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERBLOBS
  AFTER UPDATE
  ON LAYERBLOBS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERBLOBS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERBLOBS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERBLOBS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDID
      ,VALUEINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDID
      , :new.VALUEINDEX
    );
  else 
    update A_LAYERBLOBS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERBLOBS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDID
      ,VALUEINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDID
      , :new.VALUEINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERBLOBS
  AFTER DELETE
  ON LAYERBLOBS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERBLOBS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERCONTROLRULES
  AFTER INSERT
  ON LAYERCONTROLRULES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERCONTROLRULES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERCONTROLRULES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,CONTROLRULE
      ,CONTROLMESSAGE
      ,SOFTCONTROL
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CONTROLRULE
      , :new.CONTROLMESSAGE
      , :new.SOFTCONTROL
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERCONTROLRULES
  AFTER UPDATE
  ON LAYERCONTROLRULES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERCONTROLRULES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERCONTROLRULES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERCONTROLRULES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,CONTROLRULE
      ,CONTROLMESSAGE
      ,SOFTCONTROL
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CONTROLRULE
      , :new.CONTROLMESSAGE
      , :new.SOFTCONTROL
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERCONTROLRULES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERCONTROLRULES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,CONTROLRULE
      ,CONTROLMESSAGE
      ,SOFTCONTROL
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CONTROLRULE
      , :new.CONTROLMESSAGE
      , :new.SOFTCONTROL
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERCONTROLRULES
  AFTER DELETE
  ON LAYERCONTROLRULES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERCONTROLRULES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERDATA
  AFTER INSERT
  ON LAYERDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,KFSR
      ,KVSR
      ,KESR
      ,KVR
      ,SUBKESR
      ,FINSOURCE
      ,MEANSTYPE
      ,PRODUCTREF
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,INTFIELD11
      ,INTFIELD12
      ,INTFIELD13
      ,INTFIELD14
      ,INTFIELD15
      ,INTFIELD16
      ,INTFIELD17
      ,INTFIELD18
      ,INTFIELD19
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,SUMFIELD16
      ,SUMFIELD17
      ,SUMFIELD18
      ,SUMFIELD19
      ,SUMFIELD20
      ,SUMFIELD21
      ,SUMFIELD22
      ,SUMFIELD23
      ,SUMFIELD24
      ,SUMFIELD25
      ,SUMFIELD26
      ,SUMFIELD27
      ,SUMFIELD28
      ,SUMFIELD29
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,STRFIELD05
      ,STRFIELD06
      ,STRFIELD07
      ,STRFIELD08
      ,STRFIELD09
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,STRFIELD10
      ,STRFIELD11
      ,STRFIELD12
      ,STRFIELD13
      ,STRFIELD14
      ,STRFIELD15
      ,STRFIELD16
      ,STRFIELD17
      ,STRFIELD18
      ,STRFIELD19
      ,STRFIELD20
      ,STRFIELD21
      ,STRFIELD22
      ,STRFIELD23
      ,STRFIELD24
      ,NATURALKEY
      ,ACCEPTDATE
      ,REJECTDATE
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,REJECTCAUSE
      ,DEPARTMENTCLS
      ,DATEOPEN
      ,DATECLOSE
      ,VARIANT
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,REGIONCLS
      ,LOCKSTATUS
      ,LOCKINFO
      ,INTFIELD20
      ,INTFIELD21
      ,INTFIELD22
      ,ORG_REF
      ,SUMFIELD30
      ,SUMFIELD31
      ,SUMFIELD32
      ,SUMFIELD33
      ,SUMFIELD34
      ,FLOATFIELD05
      ,FLOATFIELD06
      ,FLOATFIELD07
      ,STRFIELD25
      ,SENDERID_FORCHECK
      ,KCSR
      ,BUDGETREF
      ,INVESTOBJECT
      ,FINTYPE
      ,OKPD
      ,FACT
      ,DIRECTIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.KVR
      , :new.SUBKESR
      , :new.FINSOURCE
      , :new.MEANSTYPE
      , :new.PRODUCTREF
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.INTFIELD11
      , :new.INTFIELD12
      , :new.INTFIELD13
      , :new.INTFIELD14
      , :new.INTFIELD15
      , :new.INTFIELD16
      , :new.INTFIELD17
      , :new.INTFIELD18
      , :new.INTFIELD19
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.SUMFIELD16
      , :new.SUMFIELD17
      , :new.SUMFIELD18
      , :new.SUMFIELD19
      , :new.SUMFIELD20
      , :new.SUMFIELD21
      , :new.SUMFIELD22
      , :new.SUMFIELD23
      , :new.SUMFIELD24
      , :new.SUMFIELD25
      , :new.SUMFIELD26
      , :new.SUMFIELD27
      , :new.SUMFIELD28
      , :new.SUMFIELD29
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.STRFIELD05
      , :new.STRFIELD06
      , :new.STRFIELD07
      , :new.STRFIELD08
      , :new.STRFIELD09
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.STRFIELD10
      , :new.STRFIELD11
      , :new.STRFIELD12
      , :new.STRFIELD13
      , :new.STRFIELD14
      , :new.STRFIELD15
      , :new.STRFIELD16
      , :new.STRFIELD17
      , :new.STRFIELD18
      , :new.STRFIELD19
      , :new.STRFIELD20
      , :new.STRFIELD21
      , :new.STRFIELD22
      , :new.STRFIELD23
      , :new.STRFIELD24
      , :new.NATURALKEY
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.REJECTCAUSE
      , :new.DEPARTMENTCLS
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.VARIANT
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.INTFIELD20
      , :new.INTFIELD21
      , :new.INTFIELD22
      , :new.ORG_REF
      , :new.SUMFIELD30
      , :new.SUMFIELD31
      , :new.SUMFIELD32
      , :new.SUMFIELD33
      , :new.SUMFIELD34
      , :new.FLOATFIELD05
      , :new.FLOATFIELD06
      , :new.FLOATFIELD07
      , :new.STRFIELD25
      , :new.SENDERID_FORCHECK
      , :new.KCSR
      , :new.BUDGETREF
      , :new.INVESTOBJECT
      , :new.FINTYPE
      , :new.OKPD
      , :new.FACT
      , :new.DIRECTIONCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERDATA
  AFTER UPDATE
  ON LAYERDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERDATA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,KFSR
      ,KVSR
      ,KESR
      ,KVR
      ,SUBKESR
      ,FINSOURCE
      ,MEANSTYPE
      ,PRODUCTREF
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,INTFIELD11
      ,INTFIELD12
      ,INTFIELD13
      ,INTFIELD14
      ,INTFIELD15
      ,INTFIELD16
      ,INTFIELD17
      ,INTFIELD18
      ,INTFIELD19
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,SUMFIELD16
      ,SUMFIELD17
      ,SUMFIELD18
      ,SUMFIELD19
      ,SUMFIELD20
      ,SUMFIELD21
      ,SUMFIELD22
      ,SUMFIELD23
      ,SUMFIELD24
      ,SUMFIELD25
      ,SUMFIELD26
      ,SUMFIELD27
      ,SUMFIELD28
      ,SUMFIELD29
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,STRFIELD05
      ,STRFIELD06
      ,STRFIELD07
      ,STRFIELD08
      ,STRFIELD09
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,STRFIELD10
      ,STRFIELD11
      ,STRFIELD12
      ,STRFIELD13
      ,STRFIELD14
      ,STRFIELD15
      ,STRFIELD16
      ,STRFIELD17
      ,STRFIELD18
      ,STRFIELD19
      ,STRFIELD20
      ,STRFIELD21
      ,STRFIELD22
      ,STRFIELD23
      ,STRFIELD24
      ,NATURALKEY
      ,ACCEPTDATE
      ,REJECTDATE
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,REJECTCAUSE
      ,DEPARTMENTCLS
      ,DATEOPEN
      ,DATECLOSE
      ,VARIANT
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,REGIONCLS
      ,LOCKSTATUS
      ,LOCKINFO
      ,INTFIELD20
      ,INTFIELD21
      ,INTFIELD22
      ,ORG_REF
      ,SUMFIELD30
      ,SUMFIELD31
      ,SUMFIELD32
      ,SUMFIELD33
      ,SUMFIELD34
      ,FLOATFIELD05
      ,FLOATFIELD06
      ,FLOATFIELD07
      ,STRFIELD25
      ,SENDERID_FORCHECK
      ,KCSR
      ,BUDGETREF
      ,INVESTOBJECT
      ,FINTYPE
      ,OKPD
      ,FACT
      ,DIRECTIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.KVR
      , :new.SUBKESR
      , :new.FINSOURCE
      , :new.MEANSTYPE
      , :new.PRODUCTREF
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.INTFIELD11
      , :new.INTFIELD12
      , :new.INTFIELD13
      , :new.INTFIELD14
      , :new.INTFIELD15
      , :new.INTFIELD16
      , :new.INTFIELD17
      , :new.INTFIELD18
      , :new.INTFIELD19
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.SUMFIELD16
      , :new.SUMFIELD17
      , :new.SUMFIELD18
      , :new.SUMFIELD19
      , :new.SUMFIELD20
      , :new.SUMFIELD21
      , :new.SUMFIELD22
      , :new.SUMFIELD23
      , :new.SUMFIELD24
      , :new.SUMFIELD25
      , :new.SUMFIELD26
      , :new.SUMFIELD27
      , :new.SUMFIELD28
      , :new.SUMFIELD29
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.STRFIELD05
      , :new.STRFIELD06
      , :new.STRFIELD07
      , :new.STRFIELD08
      , :new.STRFIELD09
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.STRFIELD10
      , :new.STRFIELD11
      , :new.STRFIELD12
      , :new.STRFIELD13
      , :new.STRFIELD14
      , :new.STRFIELD15
      , :new.STRFIELD16
      , :new.STRFIELD17
      , :new.STRFIELD18
      , :new.STRFIELD19
      , :new.STRFIELD20
      , :new.STRFIELD21
      , :new.STRFIELD22
      , :new.STRFIELD23
      , :new.STRFIELD24
      , :new.NATURALKEY
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.REJECTCAUSE
      , :new.DEPARTMENTCLS
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.VARIANT
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.INTFIELD20
      , :new.INTFIELD21
      , :new.INTFIELD22
      , :new.ORG_REF
      , :new.SUMFIELD30
      , :new.SUMFIELD31
      , :new.SUMFIELD32
      , :new.SUMFIELD33
      , :new.SUMFIELD34
      , :new.FLOATFIELD05
      , :new.FLOATFIELD06
      , :new.FLOATFIELD07
      , :new.STRFIELD25
      , :new.SENDERID_FORCHECK
      , :new.KCSR
      , :new.BUDGETREF
      , :new.INVESTOBJECT
      , :new.FINTYPE
      , :new.OKPD
      , :new.FACT
      , :new.DIRECTIONCLS
    );
  else 
    update A_LAYERDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERDATA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,KFSR
      ,KVSR
      ,KESR
      ,KVR
      ,SUBKESR
      ,FINSOURCE
      ,MEANSTYPE
      ,PRODUCTREF
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,INTFIELD11
      ,INTFIELD12
      ,INTFIELD13
      ,INTFIELD14
      ,INTFIELD15
      ,INTFIELD16
      ,INTFIELD17
      ,INTFIELD18
      ,INTFIELD19
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,SUMFIELD16
      ,SUMFIELD17
      ,SUMFIELD18
      ,SUMFIELD19
      ,SUMFIELD20
      ,SUMFIELD21
      ,SUMFIELD22
      ,SUMFIELD23
      ,SUMFIELD24
      ,SUMFIELD25
      ,SUMFIELD26
      ,SUMFIELD27
      ,SUMFIELD28
      ,SUMFIELD29
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,STRFIELD05
      ,STRFIELD06
      ,STRFIELD07
      ,STRFIELD08
      ,STRFIELD09
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,STRFIELD10
      ,STRFIELD11
      ,STRFIELD12
      ,STRFIELD13
      ,STRFIELD14
      ,STRFIELD15
      ,STRFIELD16
      ,STRFIELD17
      ,STRFIELD18
      ,STRFIELD19
      ,STRFIELD20
      ,STRFIELD21
      ,STRFIELD22
      ,STRFIELD23
      ,STRFIELD24
      ,NATURALKEY
      ,ACCEPTDATE
      ,REJECTDATE
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,REJECTCAUSE
      ,DEPARTMENTCLS
      ,DATEOPEN
      ,DATECLOSE
      ,VARIANT
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,REGIONCLS
      ,LOCKSTATUS
      ,LOCKINFO
      ,INTFIELD20
      ,INTFIELD21
      ,INTFIELD22
      ,ORG_REF
      ,SUMFIELD30
      ,SUMFIELD31
      ,SUMFIELD32
      ,SUMFIELD33
      ,SUMFIELD34
      ,FLOATFIELD05
      ,FLOATFIELD06
      ,FLOATFIELD07
      ,STRFIELD25
      ,SENDERID_FORCHECK
      ,KCSR
      ,BUDGETREF
      ,INVESTOBJECT
      ,FINTYPE
      ,OKPD
      ,FACT
      ,DIRECTIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.KVR
      , :new.SUBKESR
      , :new.FINSOURCE
      , :new.MEANSTYPE
      , :new.PRODUCTREF
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.INTFIELD11
      , :new.INTFIELD12
      , :new.INTFIELD13
      , :new.INTFIELD14
      , :new.INTFIELD15
      , :new.INTFIELD16
      , :new.INTFIELD17
      , :new.INTFIELD18
      , :new.INTFIELD19
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.SUMFIELD16
      , :new.SUMFIELD17
      , :new.SUMFIELD18
      , :new.SUMFIELD19
      , :new.SUMFIELD20
      , :new.SUMFIELD21
      , :new.SUMFIELD22
      , :new.SUMFIELD23
      , :new.SUMFIELD24
      , :new.SUMFIELD25
      , :new.SUMFIELD26
      , :new.SUMFIELD27
      , :new.SUMFIELD28
      , :new.SUMFIELD29
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.STRFIELD05
      , :new.STRFIELD06
      , :new.STRFIELD07
      , :new.STRFIELD08
      , :new.STRFIELD09
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.STRFIELD10
      , :new.STRFIELD11
      , :new.STRFIELD12
      , :new.STRFIELD13
      , :new.STRFIELD14
      , :new.STRFIELD15
      , :new.STRFIELD16
      , :new.STRFIELD17
      , :new.STRFIELD18
      , :new.STRFIELD19
      , :new.STRFIELD20
      , :new.STRFIELD21
      , :new.STRFIELD22
      , :new.STRFIELD23
      , :new.STRFIELD24
      , :new.NATURALKEY
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.REJECTCAUSE
      , :new.DEPARTMENTCLS
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.VARIANT
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.INTFIELD20
      , :new.INTFIELD21
      , :new.INTFIELD22
      , :new.ORG_REF
      , :new.SUMFIELD30
      , :new.SUMFIELD31
      , :new.SUMFIELD32
      , :new.SUMFIELD33
      , :new.SUMFIELD34
      , :new.FLOATFIELD05
      , :new.FLOATFIELD06
      , :new.FLOATFIELD07
      , :new.STRFIELD25
      , :new.SENDERID_FORCHECK
      , :new.KCSR
      , :new.BUDGETREF
      , :new.INVESTOBJECT
      , :new.FINTYPE
      , :new.OKPD
      , :new.FACT
      , :new.DIRECTIONCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERDATA
  AFTER DELETE
  ON LAYERDATA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERDATA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERDATA_BACKUP
  AFTER INSERT
  ON LAYERDATA_BACKUP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERDATA_BACKUP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERDATA_BACKUP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERID_FORCHECK
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,ACCEPTDATE
      ,REJECTDATE
      ,REJECTCAUSE
      ,NATURALKEY
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,LOCKSTATUS
      ,LOCKINFO
      ,DATEOPEN
      ,DATECLOSE
      ,BUDGETREF
      ,PRODUCTREF
      ,KFSR
      ,KVSR
      ,KESR
      ,KVR
      ,SUBKESR
      ,FINSOURCE
      ,FACT
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,INTFIELD11
      ,INTFIELD12
      ,INTFIELD13
      ,INTFIELD14
      ,INTFIELD15
      ,INTFIELD16
      ,INTFIELD17
      ,INTFIELD18
      ,INTFIELD19
      ,INTFIELD20
      ,INTFIELD21
      ,INTFIELD22
      ,INTFIELD23
      ,INTFIELD24
      ,INTFIELD25
      ,INTFIELD26
      ,INTFIELD27
      ,INTFIELD28
      ,INTFIELD29
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,SUMFIELD16
      ,SUMFIELD17
      ,SUMFIELD18
      ,SUMFIELD19
      ,SUMFIELD20
      ,SUMFIELD21
      ,SUMFIELD22
      ,SUMFIELD23
      ,SUMFIELD24
      ,SUMFIELD25
      ,SUMFIELD26
      ,SUMFIELD27
      ,SUMFIELD28
      ,SUMFIELD29
      ,SUMFIELD30
      ,SUMFIELD31
      ,SUMFIELD32
      ,SUMFIELD33
      ,SUMFIELD34
      ,SUMFIELD35
      ,SUMFIELD36
      ,SUMFIELD37
      ,SUMFIELD38
      ,SUMFIELD39
      ,SUMFIELD40
      ,SUMFIELD41
      ,SUMFIELD42
      ,SUMFIELD43
      ,SUMFIELD44
      ,SUMFIELD45
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,DATEFIELD05
      ,DATEFIELD06
      ,DATEFIELD07
      ,DATEFIELD08
      ,DATEFIELD09
      ,DATEFIELD10
      ,DATEFIELD11
      ,DATEFIELD12
      ,DATEFIELD13
      ,DATEFIELD14
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,STRFIELD05
      ,STRFIELD06
      ,STRFIELD07
      ,STRFIELD08
      ,STRFIELD09
      ,STRFIELD10
      ,STRFIELD11
      ,STRFIELD12
      ,STRFIELD13
      ,STRFIELD14
      ,STRFIELD15
      ,STRFIELD16
      ,STRFIELD17
      ,STRFIELD18
      ,STRFIELD19
      ,STRFIELD20
      ,STRFIELD21
      ,STRFIELD22
      ,STRFIELD23
      ,STRFIELD24
      ,STRFIELD25
      ,STRFIELD26
      ,STRFIELD27
      ,STRFIELD28
      ,STRFIELD29
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,FLOATFIELD05
      ,FLOATFIELD06
      ,FLOATFIELD07
      ,FLOATFIELD08
      ,FLOATFIELD09
      ,FLOATFIELD10
      ,DEPARTMENTCLS
      ,VARIANT
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,REGIONCLS
      ,ORG_REF
      ,KCSR
      ,DOCUMENTID
      ,BACKUPDATE
      ,SOURCEID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERID_FORCHECK
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.REJECTCAUSE
      , :new.NATURALKEY
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.BUDGETREF
      , :new.PRODUCTREF
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.KVR
      , :new.SUBKESR
      , :new.FINSOURCE
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.INTFIELD11
      , :new.INTFIELD12
      , :new.INTFIELD13
      , :new.INTFIELD14
      , :new.INTFIELD15
      , :new.INTFIELD16
      , :new.INTFIELD17
      , :new.INTFIELD18
      , :new.INTFIELD19
      , :new.INTFIELD20
      , :new.INTFIELD21
      , :new.INTFIELD22
      , :new.INTFIELD23
      , :new.INTFIELD24
      , :new.INTFIELD25
      , :new.INTFIELD26
      , :new.INTFIELD27
      , :new.INTFIELD28
      , :new.INTFIELD29
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.SUMFIELD16
      , :new.SUMFIELD17
      , :new.SUMFIELD18
      , :new.SUMFIELD19
      , :new.SUMFIELD20
      , :new.SUMFIELD21
      , :new.SUMFIELD22
      , :new.SUMFIELD23
      , :new.SUMFIELD24
      , :new.SUMFIELD25
      , :new.SUMFIELD26
      , :new.SUMFIELD27
      , :new.SUMFIELD28
      , :new.SUMFIELD29
      , :new.SUMFIELD30
      , :new.SUMFIELD31
      , :new.SUMFIELD32
      , :new.SUMFIELD33
      , :new.SUMFIELD34
      , :new.SUMFIELD35
      , :new.SUMFIELD36
      , :new.SUMFIELD37
      , :new.SUMFIELD38
      , :new.SUMFIELD39
      , :new.SUMFIELD40
      , :new.SUMFIELD41
      , :new.SUMFIELD42
      , :new.SUMFIELD43
      , :new.SUMFIELD44
      , :new.SUMFIELD45
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.DATEFIELD05
      , :new.DATEFIELD06
      , :new.DATEFIELD07
      , :new.DATEFIELD08
      , :new.DATEFIELD09
      , :new.DATEFIELD10
      , :new.DATEFIELD11
      , :new.DATEFIELD12
      , :new.DATEFIELD13
      , :new.DATEFIELD14
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.STRFIELD05
      , :new.STRFIELD06
      , :new.STRFIELD07
      , :new.STRFIELD08
      , :new.STRFIELD09
      , :new.STRFIELD10
      , :new.STRFIELD11
      , :new.STRFIELD12
      , :new.STRFIELD13
      , :new.STRFIELD14
      , :new.STRFIELD15
      , :new.STRFIELD16
      , :new.STRFIELD17
      , :new.STRFIELD18
      , :new.STRFIELD19
      , :new.STRFIELD20
      , :new.STRFIELD21
      , :new.STRFIELD22
      , :new.STRFIELD23
      , :new.STRFIELD24
      , :new.STRFIELD25
      , :new.STRFIELD26
      , :new.STRFIELD27
      , :new.STRFIELD28
      , :new.STRFIELD29
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.FLOATFIELD05
      , :new.FLOATFIELD06
      , :new.FLOATFIELD07
      , :new.FLOATFIELD08
      , :new.FLOATFIELD09
      , :new.FLOATFIELD10
      , :new.DEPARTMENTCLS
      , :new.VARIANT
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.ORG_REF
      , :new.KCSR
      , :new.DOCUMENTID
      , :new.BACKUPDATE
      , :new.SOURCEID
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERDATA_BACKUP
  AFTER UPDATE
  ON LAYERDATA_BACKUP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERDATA_BACKUP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERDATA_BACKUP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERDATA_BACKUP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERID_FORCHECK
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,ACCEPTDATE
      ,REJECTDATE
      ,REJECTCAUSE
      ,NATURALKEY
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,LOCKSTATUS
      ,LOCKINFO
      ,DATEOPEN
      ,DATECLOSE
      ,BUDGETREF
      ,PRODUCTREF
      ,KFSR
      ,KVSR
      ,KESR
      ,KVR
      ,SUBKESR
      ,FINSOURCE
      ,FACT
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,INTFIELD11
      ,INTFIELD12
      ,INTFIELD13
      ,INTFIELD14
      ,INTFIELD15
      ,INTFIELD16
      ,INTFIELD17
      ,INTFIELD18
      ,INTFIELD19
      ,INTFIELD20
      ,INTFIELD21
      ,INTFIELD22
      ,INTFIELD23
      ,INTFIELD24
      ,INTFIELD25
      ,INTFIELD26
      ,INTFIELD27
      ,INTFIELD28
      ,INTFIELD29
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,SUMFIELD16
      ,SUMFIELD17
      ,SUMFIELD18
      ,SUMFIELD19
      ,SUMFIELD20
      ,SUMFIELD21
      ,SUMFIELD22
      ,SUMFIELD23
      ,SUMFIELD24
      ,SUMFIELD25
      ,SUMFIELD26
      ,SUMFIELD27
      ,SUMFIELD28
      ,SUMFIELD29
      ,SUMFIELD30
      ,SUMFIELD31
      ,SUMFIELD32
      ,SUMFIELD33
      ,SUMFIELD34
      ,SUMFIELD35
      ,SUMFIELD36
      ,SUMFIELD37
      ,SUMFIELD38
      ,SUMFIELD39
      ,SUMFIELD40
      ,SUMFIELD41
      ,SUMFIELD42
      ,SUMFIELD43
      ,SUMFIELD44
      ,SUMFIELD45
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,DATEFIELD05
      ,DATEFIELD06
      ,DATEFIELD07
      ,DATEFIELD08
      ,DATEFIELD09
      ,DATEFIELD10
      ,DATEFIELD11
      ,DATEFIELD12
      ,DATEFIELD13
      ,DATEFIELD14
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,STRFIELD05
      ,STRFIELD06
      ,STRFIELD07
      ,STRFIELD08
      ,STRFIELD09
      ,STRFIELD10
      ,STRFIELD11
      ,STRFIELD12
      ,STRFIELD13
      ,STRFIELD14
      ,STRFIELD15
      ,STRFIELD16
      ,STRFIELD17
      ,STRFIELD18
      ,STRFIELD19
      ,STRFIELD20
      ,STRFIELD21
      ,STRFIELD22
      ,STRFIELD23
      ,STRFIELD24
      ,STRFIELD25
      ,STRFIELD26
      ,STRFIELD27
      ,STRFIELD28
      ,STRFIELD29
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,FLOATFIELD05
      ,FLOATFIELD06
      ,FLOATFIELD07
      ,FLOATFIELD08
      ,FLOATFIELD09
      ,FLOATFIELD10
      ,DEPARTMENTCLS
      ,VARIANT
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,REGIONCLS
      ,ORG_REF
      ,KCSR
      ,DOCUMENTID
      ,BACKUPDATE
      ,SOURCEID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERID_FORCHECK
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.REJECTCAUSE
      , :new.NATURALKEY
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.BUDGETREF
      , :new.PRODUCTREF
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.KVR
      , :new.SUBKESR
      , :new.FINSOURCE
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.INTFIELD11
      , :new.INTFIELD12
      , :new.INTFIELD13
      , :new.INTFIELD14
      , :new.INTFIELD15
      , :new.INTFIELD16
      , :new.INTFIELD17
      , :new.INTFIELD18
      , :new.INTFIELD19
      , :new.INTFIELD20
      , :new.INTFIELD21
      , :new.INTFIELD22
      , :new.INTFIELD23
      , :new.INTFIELD24
      , :new.INTFIELD25
      , :new.INTFIELD26
      , :new.INTFIELD27
      , :new.INTFIELD28
      , :new.INTFIELD29
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.SUMFIELD16
      , :new.SUMFIELD17
      , :new.SUMFIELD18
      , :new.SUMFIELD19
      , :new.SUMFIELD20
      , :new.SUMFIELD21
      , :new.SUMFIELD22
      , :new.SUMFIELD23
      , :new.SUMFIELD24
      , :new.SUMFIELD25
      , :new.SUMFIELD26
      , :new.SUMFIELD27
      , :new.SUMFIELD28
      , :new.SUMFIELD29
      , :new.SUMFIELD30
      , :new.SUMFIELD31
      , :new.SUMFIELD32
      , :new.SUMFIELD33
      , :new.SUMFIELD34
      , :new.SUMFIELD35
      , :new.SUMFIELD36
      , :new.SUMFIELD37
      , :new.SUMFIELD38
      , :new.SUMFIELD39
      , :new.SUMFIELD40
      , :new.SUMFIELD41
      , :new.SUMFIELD42
      , :new.SUMFIELD43
      , :new.SUMFIELD44
      , :new.SUMFIELD45
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.DATEFIELD05
      , :new.DATEFIELD06
      , :new.DATEFIELD07
      , :new.DATEFIELD08
      , :new.DATEFIELD09
      , :new.DATEFIELD10
      , :new.DATEFIELD11
      , :new.DATEFIELD12
      , :new.DATEFIELD13
      , :new.DATEFIELD14
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.STRFIELD05
      , :new.STRFIELD06
      , :new.STRFIELD07
      , :new.STRFIELD08
      , :new.STRFIELD09
      , :new.STRFIELD10
      , :new.STRFIELD11
      , :new.STRFIELD12
      , :new.STRFIELD13
      , :new.STRFIELD14
      , :new.STRFIELD15
      , :new.STRFIELD16
      , :new.STRFIELD17
      , :new.STRFIELD18
      , :new.STRFIELD19
      , :new.STRFIELD20
      , :new.STRFIELD21
      , :new.STRFIELD22
      , :new.STRFIELD23
      , :new.STRFIELD24
      , :new.STRFIELD25
      , :new.STRFIELD26
      , :new.STRFIELD27
      , :new.STRFIELD28
      , :new.STRFIELD29
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.FLOATFIELD05
      , :new.FLOATFIELD06
      , :new.FLOATFIELD07
      , :new.FLOATFIELD08
      , :new.FLOATFIELD09
      , :new.FLOATFIELD10
      , :new.DEPARTMENTCLS
      , :new.VARIANT
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.ORG_REF
      , :new.KCSR
      , :new.DOCUMENTID
      , :new.BACKUPDATE
      , :new.SOURCEID
    );
  else 
    update A_LAYERDATA_BACKUP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERDATA_BACKUP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERID_FORCHECK
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,ACCEPTDATE
      ,REJECTDATE
      ,REJECTCAUSE
      ,NATURALKEY
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,LOCKSTATUS
      ,LOCKINFO
      ,DATEOPEN
      ,DATECLOSE
      ,BUDGETREF
      ,PRODUCTREF
      ,KFSR
      ,KVSR
      ,KESR
      ,KVR
      ,SUBKESR
      ,FINSOURCE
      ,FACT
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,INTFIELD11
      ,INTFIELD12
      ,INTFIELD13
      ,INTFIELD14
      ,INTFIELD15
      ,INTFIELD16
      ,INTFIELD17
      ,INTFIELD18
      ,INTFIELD19
      ,INTFIELD20
      ,INTFIELD21
      ,INTFIELD22
      ,INTFIELD23
      ,INTFIELD24
      ,INTFIELD25
      ,INTFIELD26
      ,INTFIELD27
      ,INTFIELD28
      ,INTFIELD29
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,SUMFIELD16
      ,SUMFIELD17
      ,SUMFIELD18
      ,SUMFIELD19
      ,SUMFIELD20
      ,SUMFIELD21
      ,SUMFIELD22
      ,SUMFIELD23
      ,SUMFIELD24
      ,SUMFIELD25
      ,SUMFIELD26
      ,SUMFIELD27
      ,SUMFIELD28
      ,SUMFIELD29
      ,SUMFIELD30
      ,SUMFIELD31
      ,SUMFIELD32
      ,SUMFIELD33
      ,SUMFIELD34
      ,SUMFIELD35
      ,SUMFIELD36
      ,SUMFIELD37
      ,SUMFIELD38
      ,SUMFIELD39
      ,SUMFIELD40
      ,SUMFIELD41
      ,SUMFIELD42
      ,SUMFIELD43
      ,SUMFIELD44
      ,SUMFIELD45
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,DATEFIELD05
      ,DATEFIELD06
      ,DATEFIELD07
      ,DATEFIELD08
      ,DATEFIELD09
      ,DATEFIELD10
      ,DATEFIELD11
      ,DATEFIELD12
      ,DATEFIELD13
      ,DATEFIELD14
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,STRFIELD05
      ,STRFIELD06
      ,STRFIELD07
      ,STRFIELD08
      ,STRFIELD09
      ,STRFIELD10
      ,STRFIELD11
      ,STRFIELD12
      ,STRFIELD13
      ,STRFIELD14
      ,STRFIELD15
      ,STRFIELD16
      ,STRFIELD17
      ,STRFIELD18
      ,STRFIELD19
      ,STRFIELD20
      ,STRFIELD21
      ,STRFIELD22
      ,STRFIELD23
      ,STRFIELD24
      ,STRFIELD25
      ,STRFIELD26
      ,STRFIELD27
      ,STRFIELD28
      ,STRFIELD29
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,FLOATFIELD05
      ,FLOATFIELD06
      ,FLOATFIELD07
      ,FLOATFIELD08
      ,FLOATFIELD09
      ,FLOATFIELD10
      ,DEPARTMENTCLS
      ,VARIANT
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,REGIONCLS
      ,ORG_REF
      ,KCSR
      ,DOCUMENTID
      ,BACKUPDATE
      ,SOURCEID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERID_FORCHECK
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.REJECTCAUSE
      , :new.NATURALKEY
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.BUDGETREF
      , :new.PRODUCTREF
      , :new.KFSR
      , :new.KVSR
      , :new.KESR
      , :new.KVR
      , :new.SUBKESR
      , :new.FINSOURCE
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.INTFIELD11
      , :new.INTFIELD12
      , :new.INTFIELD13
      , :new.INTFIELD14
      , :new.INTFIELD15
      , :new.INTFIELD16
      , :new.INTFIELD17
      , :new.INTFIELD18
      , :new.INTFIELD19
      , :new.INTFIELD20
      , :new.INTFIELD21
      , :new.INTFIELD22
      , :new.INTFIELD23
      , :new.INTFIELD24
      , :new.INTFIELD25
      , :new.INTFIELD26
      , :new.INTFIELD27
      , :new.INTFIELD28
      , :new.INTFIELD29
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.SUMFIELD16
      , :new.SUMFIELD17
      , :new.SUMFIELD18
      , :new.SUMFIELD19
      , :new.SUMFIELD20
      , :new.SUMFIELD21
      , :new.SUMFIELD22
      , :new.SUMFIELD23
      , :new.SUMFIELD24
      , :new.SUMFIELD25
      , :new.SUMFIELD26
      , :new.SUMFIELD27
      , :new.SUMFIELD28
      , :new.SUMFIELD29
      , :new.SUMFIELD30
      , :new.SUMFIELD31
      , :new.SUMFIELD32
      , :new.SUMFIELD33
      , :new.SUMFIELD34
      , :new.SUMFIELD35
      , :new.SUMFIELD36
      , :new.SUMFIELD37
      , :new.SUMFIELD38
      , :new.SUMFIELD39
      , :new.SUMFIELD40
      , :new.SUMFIELD41
      , :new.SUMFIELD42
      , :new.SUMFIELD43
      , :new.SUMFIELD44
      , :new.SUMFIELD45
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.DATEFIELD05
      , :new.DATEFIELD06
      , :new.DATEFIELD07
      , :new.DATEFIELD08
      , :new.DATEFIELD09
      , :new.DATEFIELD10
      , :new.DATEFIELD11
      , :new.DATEFIELD12
      , :new.DATEFIELD13
      , :new.DATEFIELD14
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.STRFIELD05
      , :new.STRFIELD06
      , :new.STRFIELD07
      , :new.STRFIELD08
      , :new.STRFIELD09
      , :new.STRFIELD10
      , :new.STRFIELD11
      , :new.STRFIELD12
      , :new.STRFIELD13
      , :new.STRFIELD14
      , :new.STRFIELD15
      , :new.STRFIELD16
      , :new.STRFIELD17
      , :new.STRFIELD18
      , :new.STRFIELD19
      , :new.STRFIELD20
      , :new.STRFIELD21
      , :new.STRFIELD22
      , :new.STRFIELD23
      , :new.STRFIELD24
      , :new.STRFIELD25
      , :new.STRFIELD26
      , :new.STRFIELD27
      , :new.STRFIELD28
      , :new.STRFIELD29
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.FLOATFIELD05
      , :new.FLOATFIELD06
      , :new.FLOATFIELD07
      , :new.FLOATFIELD08
      , :new.FLOATFIELD09
      , :new.FLOATFIELD10
      , :new.DEPARTMENTCLS
      , :new.VARIANT
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.ORG_REF
      , :new.KCSR
      , :new.DOCUMENTID
      , :new.BACKUPDATE
      , :new.SOURCEID
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERDATA_BACKUP
  AFTER DELETE
  ON LAYERDATA_BACKUP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERDATA_BACKUP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERDATA_REGBK
  AFTER INSERT
  ON LAYERDATA_REGBK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERDATA_REGBK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERDATA_REGBK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERID_FORCHECK
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,PRODUCTREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,ACCEPTDATE
      ,REJECTDATE
      ,REJECTCAUSE
      ,NATURALKEY
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,LOCKSTATUS
      ,LOCKINFO
      ,DATEOPEN
      ,DATECLOSE
      ,BUDGETREF
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,FLOATFIELD05
      ,ORG_REF
      ,ID_KBK
      ,REG_DATE
      ,YEAR_SUM
      ,YEAR_PLAN
      ,ID_DOCUMENT
      ,KVSR
      ,BA
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,MEANSTYPE
      ,FACT
      ,DIRECTION
      ,SUBSIDY
      ,CS
      ,REGION
      ,DEPARTMENT
      ,OKPD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERID_FORCHECK
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.PRODUCTREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.REJECTCAUSE
      , :new.NATURALKEY
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.BUDGETREF
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.FLOATFIELD05
      , :new.ORG_REF
      , :new.ID_KBK
      , :new.REG_DATE
      , :new.YEAR_SUM
      , :new.YEAR_PLAN
      , :new.ID_DOCUMENT
      , :new.KVSR
      , :new.BA
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.MEANSTYPE
      , :new.FACT
      , :new.DIRECTION
      , :new.SUBSIDY
      , :new.CS
      , :new.REGION
      , :new.DEPARTMENT
      , :new.OKPD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERDATA_REGBK
  AFTER UPDATE
  ON LAYERDATA_REGBK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERDATA_REGBK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERDATA_REGBK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERDATA_REGBK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERID_FORCHECK
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,PRODUCTREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,ACCEPTDATE
      ,REJECTDATE
      ,REJECTCAUSE
      ,NATURALKEY
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,LOCKSTATUS
      ,LOCKINFO
      ,DATEOPEN
      ,DATECLOSE
      ,BUDGETREF
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,FLOATFIELD05
      ,ORG_REF
      ,ID_KBK
      ,REG_DATE
      ,YEAR_SUM
      ,YEAR_PLAN
      ,ID_DOCUMENT
      ,KVSR
      ,BA
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,MEANSTYPE
      ,FACT
      ,DIRECTION
      ,SUBSIDY
      ,CS
      ,REGION
      ,DEPARTMENT
      ,OKPD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERID_FORCHECK
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.PRODUCTREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.REJECTCAUSE
      , :new.NATURALKEY
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.BUDGETREF
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.FLOATFIELD05
      , :new.ORG_REF
      , :new.ID_KBK
      , :new.REG_DATE
      , :new.YEAR_SUM
      , :new.YEAR_PLAN
      , :new.ID_DOCUMENT
      , :new.KVSR
      , :new.BA
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.MEANSTYPE
      , :new.FACT
      , :new.DIRECTION
      , :new.SUBSIDY
      , :new.CS
      , :new.REGION
      , :new.DEPARTMENT
      , :new.OKPD
    );
  else 
    update A_LAYERDATA_REGBK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERDATA_REGBK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LAYERREF
      ,LAYERVERSION
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERID_FORCHECK
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,TASKREF
      ,PRODUCTREF
      ,OWNERUSER
      ,EXECUTERUSER
      ,UPDATESTATUS
      ,UPDATEDRECORDINDEX
      ,UPDATEGROUPINDEX
      ,ACCEPTDATE
      ,REJECTDATE
      ,REJECTCAUSE
      ,NATURALKEY
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,LOCKSTATUS
      ,LOCKINFO
      ,DATEOPEN
      ,DATECLOSE
      ,BUDGETREF
      ,INTFIELD00
      ,INTFIELD01
      ,INTFIELD02
      ,INTFIELD03
      ,INTFIELD04
      ,INTFIELD05
      ,INTFIELD06
      ,INTFIELD07
      ,INTFIELD08
      ,INTFIELD09
      ,INTFIELD10
      ,SUMFIELD00
      ,SUMFIELD01
      ,SUMFIELD02
      ,SUMFIELD03
      ,SUMFIELD04
      ,SUMFIELD05
      ,SUMFIELD06
      ,SUMFIELD07
      ,SUMFIELD08
      ,SUMFIELD09
      ,SUMFIELD10
      ,SUMFIELD11
      ,SUMFIELD12
      ,SUMFIELD13
      ,SUMFIELD14
      ,SUMFIELD15
      ,DATEFIELD00
      ,DATEFIELD01
      ,DATEFIELD02
      ,DATEFIELD03
      ,DATEFIELD04
      ,STRFIELD00
      ,STRFIELD01
      ,STRFIELD02
      ,STRFIELD03
      ,STRFIELD04
      ,FLOATFIELD00
      ,FLOATFIELD01
      ,FLOATFIELD02
      ,FLOATFIELD03
      ,FLOATFIELD04
      ,FLOATFIELD05
      ,ORG_REF
      ,ID_KBK
      ,REG_DATE
      ,YEAR_SUM
      ,YEAR_PLAN
      ,ID_DOCUMENT
      ,KVSR
      ,BA
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,MEANSTYPE
      ,FACT
      ,DIRECTION
      ,SUBSIDY
      ,CS
      ,REGION
      ,DEPARTMENT
      ,OKPD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERID_FORCHECK
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.TASKREF
      , :new.PRODUCTREF
      , :new.OWNERUSER
      , :new.EXECUTERUSER
      , :new.UPDATESTATUS
      , :new.UPDATEDRECORDINDEX
      , :new.UPDATEGROUPINDEX
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.REJECTCAUSE
      , :new.NATURALKEY
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.LOCKSTATUS
      , :new.LOCKINFO
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.BUDGETREF
      , :new.INTFIELD00
      , :new.INTFIELD01
      , :new.INTFIELD02
      , :new.INTFIELD03
      , :new.INTFIELD04
      , :new.INTFIELD05
      , :new.INTFIELD06
      , :new.INTFIELD07
      , :new.INTFIELD08
      , :new.INTFIELD09
      , :new.INTFIELD10
      , :new.SUMFIELD00
      , :new.SUMFIELD01
      , :new.SUMFIELD02
      , :new.SUMFIELD03
      , :new.SUMFIELD04
      , :new.SUMFIELD05
      , :new.SUMFIELD06
      , :new.SUMFIELD07
      , :new.SUMFIELD08
      , :new.SUMFIELD09
      , :new.SUMFIELD10
      , :new.SUMFIELD11
      , :new.SUMFIELD12
      , :new.SUMFIELD13
      , :new.SUMFIELD14
      , :new.SUMFIELD15
      , :new.DATEFIELD00
      , :new.DATEFIELD01
      , :new.DATEFIELD02
      , :new.DATEFIELD03
      , :new.DATEFIELD04
      , :new.STRFIELD00
      , :new.STRFIELD01
      , :new.STRFIELD02
      , :new.STRFIELD03
      , :new.STRFIELD04
      , :new.FLOATFIELD00
      , :new.FLOATFIELD01
      , :new.FLOATFIELD02
      , :new.FLOATFIELD03
      , :new.FLOATFIELD04
      , :new.FLOATFIELD05
      , :new.ORG_REF
      , :new.ID_KBK
      , :new.REG_DATE
      , :new.YEAR_SUM
      , :new.YEAR_PLAN
      , :new.ID_DOCUMENT
      , :new.KVSR
      , :new.BA
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.MEANSTYPE
      , :new.FACT
      , :new.DIRECTION
      , :new.SUBSIDY
      , :new.CS
      , :new.REGION
      , :new.DEPARTMENT
      , :new.OKPD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERDATA_REGBK
  AFTER DELETE
  ON LAYERDATA_REGBK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERDATA_REGBK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERFIELDS
  AFTER INSERT
  ON LAYERFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,FIELDNAME
      ,DISPLAYLABEL
      ,DBNAME
      ,FIELDTYPE
      ,FIELDROLE
      ,DEFAULTVALUE
      ,READONLY
      ,REQUIRED
      ,HIDDEN
      ,FIELDSIZE
      ,MASK
      ,CLSNAME
      ,ENUMREF
      ,HANDLERNAME
      ,LINKEDFIELD
      ,LINKEDNAME
      ,AGGREGATEFUNC
      ,FIELDPOSITION
      ,WIDTH
      ,VALIDATEVALUES
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,AGGREGATIONTYPE
      ,NATURALKEY
      ,CLSSTOREDNAME
      ,FORMULA1
      ,FORMULA2
      ,FIELDTYPEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.FIELDNAME
      , :new.DISPLAYLABEL
      , :new.DBNAME
      , :new.FIELDTYPE
      , :new.FIELDROLE
      , :new.DEFAULTVALUE
      , :new.READONLY
      , :new.REQUIRED
      , :new.HIDDEN
      , :new.FIELDSIZE
      , :new.MASK
      , :new.CLSNAME
      , :new.ENUMREF
      , :new.HANDLERNAME
      , :new.LINKEDFIELD
      , :new.LINKEDNAME
      , :new.AGGREGATEFUNC
      , :new.FIELDPOSITION
      , :new.WIDTH
      , :new.VALIDATEVALUES
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.AGGREGATIONTYPE
      , :new.NATURALKEY
      , :new.CLSSTOREDNAME
      , :new.FORMULA1
      , :new.FORMULA2
      , :new.FIELDTYPEREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERFIELDS
  AFTER UPDATE
  ON LAYERFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,FIELDNAME
      ,DISPLAYLABEL
      ,DBNAME
      ,FIELDTYPE
      ,FIELDROLE
      ,DEFAULTVALUE
      ,READONLY
      ,REQUIRED
      ,HIDDEN
      ,FIELDSIZE
      ,MASK
      ,CLSNAME
      ,ENUMREF
      ,HANDLERNAME
      ,LINKEDFIELD
      ,LINKEDNAME
      ,AGGREGATEFUNC
      ,FIELDPOSITION
      ,WIDTH
      ,VALIDATEVALUES
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,AGGREGATIONTYPE
      ,NATURALKEY
      ,CLSSTOREDNAME
      ,FORMULA1
      ,FORMULA2
      ,FIELDTYPEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.FIELDNAME
      , :new.DISPLAYLABEL
      , :new.DBNAME
      , :new.FIELDTYPE
      , :new.FIELDROLE
      , :new.DEFAULTVALUE
      , :new.READONLY
      , :new.REQUIRED
      , :new.HIDDEN
      , :new.FIELDSIZE
      , :new.MASK
      , :new.CLSNAME
      , :new.ENUMREF
      , :new.HANDLERNAME
      , :new.LINKEDFIELD
      , :new.LINKEDNAME
      , :new.AGGREGATEFUNC
      , :new.FIELDPOSITION
      , :new.WIDTH
      , :new.VALIDATEVALUES
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.AGGREGATIONTYPE
      , :new.NATURALKEY
      , :new.CLSSTOREDNAME
      , :new.FORMULA1
      , :new.FORMULA2
      , :new.FIELDTYPEREF
    );
  else 
    update A_LAYERFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,FIELDNAME
      ,DISPLAYLABEL
      ,DBNAME
      ,FIELDTYPE
      ,FIELDROLE
      ,DEFAULTVALUE
      ,READONLY
      ,REQUIRED
      ,HIDDEN
      ,FIELDSIZE
      ,MASK
      ,CLSNAME
      ,ENUMREF
      ,HANDLERNAME
      ,LINKEDFIELD
      ,LINKEDNAME
      ,AGGREGATEFUNC
      ,FIELDPOSITION
      ,WIDTH
      ,VALIDATEVALUES
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,AGGREGATIONTYPE
      ,NATURALKEY
      ,CLSSTOREDNAME
      ,FORMULA1
      ,FORMULA2
      ,FIELDTYPEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.FIELDNAME
      , :new.DISPLAYLABEL
      , :new.DBNAME
      , :new.FIELDTYPE
      , :new.FIELDROLE
      , :new.DEFAULTVALUE
      , :new.READONLY
      , :new.REQUIRED
      , :new.HIDDEN
      , :new.FIELDSIZE
      , :new.MASK
      , :new.CLSNAME
      , :new.ENUMREF
      , :new.HANDLERNAME
      , :new.LINKEDFIELD
      , :new.LINKEDNAME
      , :new.AGGREGATEFUNC
      , :new.FIELDPOSITION
      , :new.WIDTH
      , :new.VALIDATEVALUES
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.AGGREGATIONTYPE
      , :new.NATURALKEY
      , :new.CLSSTOREDNAME
      , :new.FORMULA1
      , :new.FORMULA2
      , :new.FIELDTYPEREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERFIELDS
  AFTER DELETE
  ON LAYERFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERFIELDSRELATIONS
  AFTER INSERT
  ON LAYERFIELDSRELATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDSRELATIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDSRELATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,RELATIONTYPE
      ,LEFTFIELDREF
      ,RIGHTFIELDREF
      ,LEFTAGRFUNCTION
      ,RIGHTAGRFUNCTION
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.RELATIONTYPE
      , :new.LEFTFIELDREF
      , :new.RIGHTFIELDREF
      , :new.LEFTAGRFUNCTION
      , :new.RIGHTAGRFUNCTION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERFIELDSRELATIONS
  AFTER UPDATE
  ON LAYERFIELDSRELATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERFIELDSRELATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERFIELDSRELATIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDSRELATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,RELATIONTYPE
      ,LEFTFIELDREF
      ,RIGHTFIELDREF
      ,LEFTAGRFUNCTION
      ,RIGHTAGRFUNCTION
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.RELATIONTYPE
      , :new.LEFTFIELDREF
      , :new.RIGHTFIELDREF
      , :new.LEFTAGRFUNCTION
      , :new.RIGHTAGRFUNCTION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERFIELDSRELATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERFIELDSRELATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,RELATIONTYPE
      ,LEFTFIELDREF
      ,RIGHTFIELDREF
      ,LEFTAGRFUNCTION
      ,RIGHTAGRFUNCTION
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.RELATIONTYPE
      , :new.LEFTFIELDREF
      , :new.RIGHTFIELDREF
      , :new.LEFTAGRFUNCTION
      , :new.RIGHTAGRFUNCTION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERFIELDSRELATIONS
  AFTER DELETE
  ON LAYERFIELDSRELATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDSRELATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERFIELDTYPES
  AFTER INSERT
  ON LAYERFIELDTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALIAS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECOMMENDFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALIAS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECOMMENDFIELD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERFIELDTYPES
  AFTER UPDATE
  ON LAYERFIELDTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERFIELDTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERFIELDTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALIAS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECOMMENDFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALIAS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECOMMENDFIELD
    );
  else 
    update A_LAYERFIELDTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERFIELDTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALIAS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECOMMENDFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALIAS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECOMMENDFIELD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERFIELDTYPES
  AFTER DELETE
  ON LAYERFIELDTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERFIELDTYPESDETAIL
  AFTER INSERT
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDTYPESDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDTYPESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALIAS
      ,RECORDINDEX
      ,MASK
      ,NOTE
      ,REGEXP
      ,FIELDSIZE
      ,MASTERFIELDTYPE
      ,CONTEXT
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,ERRORMESSAGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALIAS
      , :new.RECORDINDEX
      , :new.MASK
      , :new.NOTE
      , :new.REGEXP
      , :new.FIELDSIZE
      , :new.MASTERFIELDTYPE
      , :new.CONTEXT
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ERRORMESSAGE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERFIELDTYPESDETAIL
  AFTER UPDATE
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERFIELDTYPESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERFIELDTYPESDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERFIELDTYPESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALIAS
      ,RECORDINDEX
      ,MASK
      ,NOTE
      ,REGEXP
      ,FIELDSIZE
      ,MASTERFIELDTYPE
      ,CONTEXT
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,ERRORMESSAGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALIAS
      , :new.RECORDINDEX
      , :new.MASK
      , :new.NOTE
      , :new.REGEXP
      , :new.FIELDSIZE
      , :new.MASTERFIELDTYPE
      , :new.CONTEXT
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ERRORMESSAGE
    );
  else 
    update A_LAYERFIELDTYPESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERFIELDTYPESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALIAS
      ,RECORDINDEX
      ,MASK
      ,NOTE
      ,REGEXP
      ,FIELDSIZE
      ,MASTERFIELDTYPE
      ,CONTEXT
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,ERRORMESSAGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALIAS
      , :new.RECORDINDEX
      , :new.MASK
      , :new.NOTE
      , :new.REGEXP
      , :new.FIELDSIZE
      , :new.MASTERFIELDTYPE
      , :new.CONTEXT
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ERRORMESSAGE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERFIELDTYPESDETAIL
  AFTER DELETE
  ON LAYERFIELDTYPESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERFIELDTYPESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERNEEDCONTROL
  AFTER INSERT
  ON LAYERNEEDCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERNEEDCONTROL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERNEEDCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKREF
      ,LAYERREF
      ,CONTROLREF
      ,SOFTCONTROL
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKREF
      , :new.LAYERREF
      , :new.CONTROLREF
      , :new.SOFTCONTROL
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERNEEDCONTROL
  AFTER UPDATE
  ON LAYERNEEDCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERNEEDCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERNEEDCONTROL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERNEEDCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKREF
      ,LAYERREF
      ,CONTROLREF
      ,SOFTCONTROL
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKREF
      , :new.LAYERREF
      , :new.CONTROLREF
      , :new.SOFTCONTROL
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERNEEDCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERNEEDCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKREF
      ,LAYERREF
      ,CONTROLREF
      ,SOFTCONTROL
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKREF
      , :new.LAYERREF
      , :new.CONTROLREF
      , :new.SOFTCONTROL
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERNEEDCONTROL
  AFTER DELETE
  ON LAYERNEEDCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERNEEDCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERRELATIONS
  AFTER INSERT
  ON LAYERRELATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERRELATIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERRELATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RELATIONTYPE
      ,NAME
      ,LEFTLAYER
      ,RIGHTLAYER
      ,MACROSNAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RELATIONTYPE
      , :new.NAME
      , :new.LEFTLAYER
      , :new.RIGHTLAYER
      , :new.MACROSNAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERRELATIONS
  AFTER UPDATE
  ON LAYERRELATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERRELATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERRELATIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERRELATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RELATIONTYPE
      ,NAME
      ,LEFTLAYER
      ,RIGHTLAYER
      ,MACROSNAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RELATIONTYPE
      , :new.NAME
      , :new.LEFTLAYER
      , :new.RIGHTLAYER
      , :new.MACROSNAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERRELATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERRELATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RELATIONTYPE
      ,NAME
      ,LEFTLAYER
      ,RIGHTLAYER
      ,MACROSNAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RELATIONTYPE
      , :new.NAME
      , :new.LEFTLAYER
      , :new.RIGHTLAYER
      , :new.MACROSNAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERRELATIONS
  AFTER DELETE
  ON LAYERRELATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERRELATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERS
  AFTER INSERT
  ON LAYERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ALIAS
      ,LAYERTYPE
      ,TABLENAME
      ,READONLY
      ,USEVERSIONS
      ,MACROSNAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,VERSION
      ,NOTE
      ,ISGENERALIZED
      ,ISDEPRECATED
      ,ISMULTIBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ALIAS
      , :new.LAYERTYPE
      , :new.TABLENAME
      , :new.READONLY
      , :new.USEVERSIONS
      , :new.MACROSNAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.VERSION
      , :new.NOTE
      , :new.ISGENERALIZED
      , :new.ISDEPRECATED
      , :new.ISMULTIBUDGET
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERS
  AFTER UPDATE
  ON LAYERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ALIAS
      ,LAYERTYPE
      ,TABLENAME
      ,READONLY
      ,USEVERSIONS
      ,MACROSNAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,VERSION
      ,NOTE
      ,ISGENERALIZED
      ,ISDEPRECATED
      ,ISMULTIBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ALIAS
      , :new.LAYERTYPE
      , :new.TABLENAME
      , :new.READONLY
      , :new.USEVERSIONS
      , :new.MACROSNAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.VERSION
      , :new.NOTE
      , :new.ISGENERALIZED
      , :new.ISDEPRECATED
      , :new.ISMULTIBUDGET
    );
  else 
    update A_LAYERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ALIAS
      ,LAYERTYPE
      ,TABLENAME
      ,READONLY
      ,USEVERSIONS
      ,MACROSNAME
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CRYPTOSTATUS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,VERSION
      ,NOTE
      ,ISGENERALIZED
      ,ISDEPRECATED
      ,ISMULTIBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ALIAS
      , :new.LAYERTYPE
      , :new.TABLENAME
      , :new.READONLY
      , :new.USEVERSIONS
      , :new.MACROSNAME
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.VERSION
      , :new.NOTE
      , :new.ISGENERALIZED
      , :new.ISDEPRECATED
      , :new.ISMULTIBUDGET
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERS
  AFTER DELETE
  ON LAYERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTABLES
  AFTER INSERT
  ON LAYERTABLES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SYNCID
      ,TABLENAME
      ,NAME
      ,DESCR
      ,TBTYPE
      ,SYNC
      ,SYSTABLE
      ,URM
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SYNCID
      , :new.TABLENAME
      , :new.NAME
      , :new.DESCR
      , :new.TBTYPE
      , :new.SYNC
      , :new.SYSTABLE
      , :new.URM
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTABLES
  AFTER UPDATE
  ON LAYERTABLES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTABLES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTABLES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SYNCID
      ,TABLENAME
      ,NAME
      ,DESCR
      ,TBTYPE
      ,SYNC
      ,SYSTABLE
      ,URM
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SYNCID
      , :new.TABLENAME
      , :new.NAME
      , :new.DESCR
      , :new.TBTYPE
      , :new.SYNC
      , :new.SYSTABLE
      , :new.URM
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERTABLES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTABLES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SYNCID
      ,TABLENAME
      ,NAME
      ,DESCR
      ,TBTYPE
      ,SYNC
      ,SYSTABLE
      ,URM
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SYNCID
      , :new.TABLENAME
      , :new.NAME
      , :new.DESCR
      , :new.TBTYPE
      , :new.SYNC
      , :new.SYSTABLE
      , :new.URM
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTABLES
  AFTER DELETE
  ON LAYERTABLES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTABLESFIELDS
  AFTER INSERT
  ON LAYERTABLESFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDTYPE
      ,FIELDSIZE
      ,SYNC
      ,URM
      ,REQUIRED
      ,DEFVALUE
      ,SYNCVALUE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDTYPE
      , :new.FIELDSIZE
      , :new.SYNC
      , :new.URM
      , :new.REQUIRED
      , :new.DEFVALUE
      , :new.SYNCVALUE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTABLESFIELDS
  AFTER UPDATE
  ON LAYERTABLESFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTABLESFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTABLESFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDTYPE
      ,FIELDSIZE
      ,SYNC
      ,URM
      ,REQUIRED
      ,DEFVALUE
      ,SYNCVALUE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDTYPE
      , :new.FIELDSIZE
      , :new.SYNC
      , :new.URM
      , :new.REQUIRED
      , :new.DEFVALUE
      , :new.SYNCVALUE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERTABLESFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTABLESFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDTYPE
      ,FIELDSIZE
      ,SYNC
      ,URM
      ,REQUIRED
      ,DEFVALUE
      ,SYNCVALUE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDTYPE
      , :new.FIELDSIZE
      , :new.SYNC
      , :new.URM
      , :new.REQUIRED
      , :new.DEFVALUE
      , :new.SYNCVALUE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTABLESFIELDS
  AFTER DELETE
  ON LAYERTABLESFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTABLESFK
  AFTER INSERT
  ON LAYERTABLESFK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESFK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESFK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDS
      ,TABLENAME
      ,FIELDSREF
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDS
      , :new.TABLENAME
      , :new.FIELDSREF
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTABLESFK
  AFTER UPDATE
  ON LAYERTABLESFK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTABLESFK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTABLESFK
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESFK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDS
      ,TABLENAME
      ,FIELDSREF
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDS
      , :new.TABLENAME
      , :new.FIELDSREF
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERTABLESFK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTABLESFK (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDS
      ,TABLENAME
      ,FIELDSREF
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDS
      , :new.TABLENAME
      , :new.FIELDSREF
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTABLESFK
  AFTER DELETE
  ON LAYERTABLESFK
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESFK
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTABLESIDX
  AFTER INSERT
  ON LAYERTABLESIDX
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESIDX
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESIDX (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTABLESIDX
  AFTER UPDATE
  ON LAYERTABLESIDX
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTABLESIDX
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTABLESIDX
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESIDX (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERTABLESIDX
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTABLESIDX (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,FIELDS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.FIELDS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTABLESIDX
  AFTER DELETE
  ON LAYERTABLESIDX
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESIDX
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTABLESTRIGGERS
  AFTER INSERT
  ON LAYERTABLESTRIGGERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESTRIGGERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESTRIGGERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,TRTEXT
      ,TRTYPE
      ,TRPOSITION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.TRTEXT
      , :new.TRTYPE
      , :new.TRPOSITION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTABLESTRIGGERS
  AFTER UPDATE
  ON LAYERTABLESTRIGGERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTABLESTRIGGERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTABLESTRIGGERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTABLESTRIGGERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,TRTEXT
      ,TRTYPE
      ,TRPOSITION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.TRTEXT
      , :new.TRTYPE
      , :new.TRPOSITION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERTABLESTRIGGERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTABLESTRIGGERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TABLEID
      ,DBNAME
      ,DESCR
      ,TRTEXT
      ,TRTYPE
      ,TRPOSITION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TABLEID
      , :new.DBNAME
      , :new.DESCR
      , :new.TRTEXT
      , :new.TRTYPE
      , :new.TRPOSITION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTABLESTRIGGERS
  AFTER DELETE
  ON LAYERTABLESTRIGGERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTABLESTRIGGERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTASKS
  AFTER INSERT
  ON LAYERTASKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTASKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTASKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKNUMBER
      ,LAYERREF
      ,LAYERVERSION
      ,NOTE
      ,FACIALACCCLS
      ,DEADLINEDATE
      ,ACCEPTDATE
      ,REJECTDATE
      ,DOCSTATEREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,OWNERUSER
      ,EXECUTERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKNUMBER
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.NOTE
      , :new.FACIALACCCLS
      , :new.DEADLINEDATE
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.DOCSTATEREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.OWNERUSER
      , :new.EXECUTERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTASKS
  AFTER UPDATE
  ON LAYERTASKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTASKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTASKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTASKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKNUMBER
      ,LAYERREF
      ,LAYERVERSION
      ,NOTE
      ,FACIALACCCLS
      ,DEADLINEDATE
      ,ACCEPTDATE
      ,REJECTDATE
      ,DOCSTATEREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,OWNERUSER
      ,EXECUTERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKNUMBER
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.NOTE
      , :new.FACIALACCCLS
      , :new.DEADLINEDATE
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.DOCSTATEREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.OWNERUSER
      , :new.EXECUTERUSER
    );
  else 
    update A_LAYERTASKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTASKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKNUMBER
      ,LAYERREF
      ,LAYERVERSION
      ,NOTE
      ,FACIALACCCLS
      ,DEADLINEDATE
      ,ACCEPTDATE
      ,REJECTDATE
      ,DOCSTATEREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,RVERSION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,OWNERUSER
      ,EXECUTERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKNUMBER
      , :new.LAYERREF
      , :new.LAYERVERSION
      , :new.NOTE
      , :new.FACIALACCCLS
      , :new.DEADLINEDATE
      , :new.ACCEPTDATE
      , :new.REJECTDATE
      , :new.DOCSTATEREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.RVERSION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.OWNERUSER
      , :new.EXECUTERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTASKS
  AFTER DELETE
  ON LAYERTASKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTASKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LAYERTYPES
  AFTER INSERT
  ON LAYERTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,TABLENAME
      ,READONLY
      ,USEVERSIONS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.TABLENAME
      , :new.READONLY
      , :new.USEVERSIONS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LAYERTYPES
  AFTER UPDATE
  ON LAYERTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LAYERTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LAYERTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LAYERTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,TABLENAME
      ,READONLY
      ,USEVERSIONS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.TABLENAME
      , :new.READONLY
      , :new.USEVERSIONS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LAYERTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LAYERTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,TABLENAME
      ,READONLY
      ,USEVERSIONS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.TABLENAME
      , :new.READONLY
      , :new.USEVERSIONS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LAYERTYPES
  AFTER DELETE
  ON LAYERTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LAYERTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LIMITFINCAPTION
  AFTER INSERT
  ON LIMITFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LIMITFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LIMITFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.AMONTH
      , :new.AYEAR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LIMITFINCAPTION
  AFTER UPDATE
  ON LIMITFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LIMITFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LIMITFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LIMITFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.AMONTH
      , :new.AYEAR
    );
  else 
    update A_LIMITFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LIMITFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.AMONTH
      , :new.AYEAR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LIMITFINCAPTION
  AFTER DELETE
  ON LIMITFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LIMITFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LIMITFINDETAIL
  AFTER INSERT
  ON LIMITFINDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LIMITFINDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LIMITFINDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KVR
      ,KESR
      ,BUDGETREF
      ,FACIALACC
      ,FINSOURCE
      ,FINTYPE
      ,SUBKESR
      ,FACT
      ,ACCEPTDATE
      ,SUMMA
      ,ACCEPTSUMMA
      ,NOTE
      ,REQUESTFLAG
      ,RECORDINDEX
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,DOCTYPES
      ,KVSR
      ,KCSR
      ,KFSR
      ,IMPORTID
      ,SENDERINN
      ,MEANSTYPE
      ,ACC_REF
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,DIRECTIONCLS
      ,DOCBASE
      ,BUHOPERATIONCLS
      ,IFS
      ,CLSTYPE
      ,STIMATEID
      ,UNIONNOTIFYREF
      ,FUNDSSOURCE
      ,AMONTH
      ,AYEAR
      ,TRANSFERTCLS
      ,REGIONCLS
      ,SUBSIDYCLS
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KVR
      , :new.KESR
      , :new.BUDGETREF
      , :new.FACIALACC
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.SUBKESR
      , :new.FACT
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.ACCEPTSUMMA
      , :new.NOTE
      , :new.REQUESTFLAG
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DOCTYPES
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.IMPORTID
      , :new.SENDERINN
      , :new.MEANSTYPE
      , :new.ACC_REF
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.DOCBASE
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.CLSTYPE
      , :new.STIMATEID
      , :new.UNIONNOTIFYREF
      , :new.FUNDSSOURCE
      , :new.AMONTH
      , :new.AYEAR
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.SUBSIDYCLS
      , :new.INVESTOBJECT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LIMITFINDETAIL
  AFTER UPDATE
  ON LIMITFINDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LIMITFINDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LIMITFINDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LIMITFINDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KVR
      ,KESR
      ,BUDGETREF
      ,FACIALACC
      ,FINSOURCE
      ,FINTYPE
      ,SUBKESR
      ,FACT
      ,ACCEPTDATE
      ,SUMMA
      ,ACCEPTSUMMA
      ,NOTE
      ,REQUESTFLAG
      ,RECORDINDEX
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,DOCTYPES
      ,KVSR
      ,KCSR
      ,KFSR
      ,IMPORTID
      ,SENDERINN
      ,MEANSTYPE
      ,ACC_REF
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,DIRECTIONCLS
      ,DOCBASE
      ,BUHOPERATIONCLS
      ,IFS
      ,CLSTYPE
      ,STIMATEID
      ,UNIONNOTIFYREF
      ,FUNDSSOURCE
      ,AMONTH
      ,AYEAR
      ,TRANSFERTCLS
      ,REGIONCLS
      ,SUBSIDYCLS
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KVR
      , :new.KESR
      , :new.BUDGETREF
      , :new.FACIALACC
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.SUBKESR
      , :new.FACT
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.ACCEPTSUMMA
      , :new.NOTE
      , :new.REQUESTFLAG
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DOCTYPES
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.IMPORTID
      , :new.SENDERINN
      , :new.MEANSTYPE
      , :new.ACC_REF
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.DOCBASE
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.CLSTYPE
      , :new.STIMATEID
      , :new.UNIONNOTIFYREF
      , :new.FUNDSSOURCE
      , :new.AMONTH
      , :new.AYEAR
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.SUBSIDYCLS
      , :new.INVESTOBJECT
    );
  else 
    update A_LIMITFINDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LIMITFINDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KVR
      ,KESR
      ,BUDGETREF
      ,FACIALACC
      ,FINSOURCE
      ,FINTYPE
      ,SUBKESR
      ,FACT
      ,ACCEPTDATE
      ,SUMMA
      ,ACCEPTSUMMA
      ,NOTE
      ,REQUESTFLAG
      ,RECORDINDEX
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,DOCTYPES
      ,KVSR
      ,KCSR
      ,KFSR
      ,IMPORTID
      ,SENDERINN
      ,MEANSTYPE
      ,ACC_REF
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,DIRECTIONCLS
      ,DOCBASE
      ,BUHOPERATIONCLS
      ,IFS
      ,CLSTYPE
      ,STIMATEID
      ,UNIONNOTIFYREF
      ,FUNDSSOURCE
      ,AMONTH
      ,AYEAR
      ,TRANSFERTCLS
      ,REGIONCLS
      ,SUBSIDYCLS
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KVR
      , :new.KESR
      , :new.BUDGETREF
      , :new.FACIALACC
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.SUBKESR
      , :new.FACT
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.ACCEPTSUMMA
      , :new.NOTE
      , :new.REQUESTFLAG
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DOCTYPES
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.IMPORTID
      , :new.SENDERINN
      , :new.MEANSTYPE
      , :new.ACC_REF
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.DOCBASE
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.CLSTYPE
      , :new.STIMATEID
      , :new.UNIONNOTIFYREF
      , :new.FUNDSSOURCE
      , :new.AMONTH
      , :new.AYEAR
      , :new.TRANSFERTCLS
      , :new.REGIONCLS
      , :new.SUBSIDYCLS
      , :new.INVESTOBJECT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LIMITFINDETAIL
  AFTER DELETE
  ON LIMITFINDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LIMITFINDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LINKRECORDS
  AFTER INSERT
  ON LINKRECORDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LINKRECORDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LINKRECORDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LINKTYPEREF
      ,PARENTID
      ,CHILDID
      ,CREATERUSER
      ,CREATEDATE
      ,SENDERID
      ,SENDERRECORDID
      ,ISREJECTED
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LINKTYPEREF
      , :new.PARENTID
      , :new.CHILDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.ISREJECTED
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LINKRECORDS
  AFTER UPDATE
  ON LINKRECORDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LINKRECORDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LINKRECORDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LINKRECORDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LINKTYPEREF
      ,PARENTID
      ,CHILDID
      ,CREATERUSER
      ,CREATEDATE
      ,SENDERID
      ,SENDERRECORDID
      ,ISREJECTED
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LINKTYPEREF
      , :new.PARENTID
      , :new.CHILDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.ISREJECTED
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LINKRECORDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LINKRECORDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,LINKTYPEREF
      ,PARENTID
      ,CHILDID
      ,CREATERUSER
      ,CREATEDATE
      ,SENDERID
      ,SENDERRECORDID
      ,ISREJECTED
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.LINKTYPEREF
      , :new.PARENTID
      , :new.CHILDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.ISREJECTED
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LINKRECORDS
  AFTER DELETE
  ON LINKRECORDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LINKRECORDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LOANCREDIT
  AFTER INSERT
  ON LOANCREDIT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDIT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDIT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATEINPUT
      ,DATEAMORTIZATION
      ,SUMMA
      ,PROGINDEX
      ,BUDGETREF
      ,ORG_REF
      ,NOTE
      ,CONTRACTTYPE
      ,PERIODSTART
      ,PERIODLENGTH
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LONGDATE
      ,ACCEPTDATE
      ,ANUMBER
      ,YEARTYPE
      ,REGIONCLS
      ,FACT
      ,FACIALACC_CLS
      ,LOANTYPE
      ,DEBTTYPE
      ,CURRENCYCLS
      ,CBPERCENTRATE
      ,CBFINERATE
      ,CBFINEPERCENTRATE
      ,PERCENT
      ,FINE
      ,RETURNSTARTDATE
      ,RETURNPERIODLENGTH
      ,PAYPERCENTSTARTDATE
      ,PAYPERCENTPERIODLENGTH
      ,DOCBASE
      ,GUARANTEEKIND
      ,GUARANTEEACCREF
      ,EXECUTEPERIOD
      ,DFACCOUNT
      ,ACCREF
      ,ADDITIONALACCREF
      ,CURRENCYSUMMA
      ,CONTRACTINFO
      ,BONDCOUNT
      ,BONDCOST
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATEINPUT
      , :new.DATEAMORTIZATION
      , :new.SUMMA
      , :new.PROGINDEX
      , :new.BUDGETREF
      , :new.ORG_REF
      , :new.NOTE
      , :new.CONTRACTTYPE
      , :new.PERIODSTART
      , :new.PERIODLENGTH
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LONGDATE
      , :new.ACCEPTDATE
      , :new.ANUMBER
      , :new.YEARTYPE
      , :new.REGIONCLS
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.LOANTYPE
      , :new.DEBTTYPE
      , :new.CURRENCYCLS
      , :new.CBPERCENTRATE
      , :new.CBFINERATE
      , :new.CBFINEPERCENTRATE
      , :new.PERCENT
      , :new.FINE
      , :new.RETURNSTARTDATE
      , :new.RETURNPERIODLENGTH
      , :new.PAYPERCENTSTARTDATE
      , :new.PAYPERCENTPERIODLENGTH
      , :new.DOCBASE
      , :new.GUARANTEEKIND
      , :new.GUARANTEEACCREF
      , :new.EXECUTEPERIOD
      , :new.DFACCOUNT
      , :new.ACCREF
      , :new.ADDITIONALACCREF
      , :new.CURRENCYSUMMA
      , :new.CONTRACTINFO
      , :new.BONDCOUNT
      , :new.BONDCOST
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LOANCREDIT
  AFTER UPDATE
  ON LOANCREDIT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LOANCREDIT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LOANCREDIT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDIT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATEINPUT
      ,DATEAMORTIZATION
      ,SUMMA
      ,PROGINDEX
      ,BUDGETREF
      ,ORG_REF
      ,NOTE
      ,CONTRACTTYPE
      ,PERIODSTART
      ,PERIODLENGTH
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LONGDATE
      ,ACCEPTDATE
      ,ANUMBER
      ,YEARTYPE
      ,REGIONCLS
      ,FACT
      ,FACIALACC_CLS
      ,LOANTYPE
      ,DEBTTYPE
      ,CURRENCYCLS
      ,CBPERCENTRATE
      ,CBFINERATE
      ,CBFINEPERCENTRATE
      ,PERCENT
      ,FINE
      ,RETURNSTARTDATE
      ,RETURNPERIODLENGTH
      ,PAYPERCENTSTARTDATE
      ,PAYPERCENTPERIODLENGTH
      ,DOCBASE
      ,GUARANTEEKIND
      ,GUARANTEEACCREF
      ,EXECUTEPERIOD
      ,DFACCOUNT
      ,ACCREF
      ,ADDITIONALACCREF
      ,CURRENCYSUMMA
      ,CONTRACTINFO
      ,BONDCOUNT
      ,BONDCOST
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATEINPUT
      , :new.DATEAMORTIZATION
      , :new.SUMMA
      , :new.PROGINDEX
      , :new.BUDGETREF
      , :new.ORG_REF
      , :new.NOTE
      , :new.CONTRACTTYPE
      , :new.PERIODSTART
      , :new.PERIODLENGTH
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LONGDATE
      , :new.ACCEPTDATE
      , :new.ANUMBER
      , :new.YEARTYPE
      , :new.REGIONCLS
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.LOANTYPE
      , :new.DEBTTYPE
      , :new.CURRENCYCLS
      , :new.CBPERCENTRATE
      , :new.CBFINERATE
      , :new.CBFINEPERCENTRATE
      , :new.PERCENT
      , :new.FINE
      , :new.RETURNSTARTDATE
      , :new.RETURNPERIODLENGTH
      , :new.PAYPERCENTSTARTDATE
      , :new.PAYPERCENTPERIODLENGTH
      , :new.DOCBASE
      , :new.GUARANTEEKIND
      , :new.GUARANTEEACCREF
      , :new.EXECUTEPERIOD
      , :new.DFACCOUNT
      , :new.ACCREF
      , :new.ADDITIONALACCREF
      , :new.CURRENCYSUMMA
      , :new.CONTRACTINFO
      , :new.BONDCOUNT
      , :new.BONDCOST
    );
  else 
    update A_LOANCREDIT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LOANCREDIT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATEINPUT
      ,DATEAMORTIZATION
      ,SUMMA
      ,PROGINDEX
      ,BUDGETREF
      ,ORG_REF
      ,NOTE
      ,CONTRACTTYPE
      ,PERIODSTART
      ,PERIODLENGTH
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LONGDATE
      ,ACCEPTDATE
      ,ANUMBER
      ,YEARTYPE
      ,REGIONCLS
      ,FACT
      ,FACIALACC_CLS
      ,LOANTYPE
      ,DEBTTYPE
      ,CURRENCYCLS
      ,CBPERCENTRATE
      ,CBFINERATE
      ,CBFINEPERCENTRATE
      ,PERCENT
      ,FINE
      ,RETURNSTARTDATE
      ,RETURNPERIODLENGTH
      ,PAYPERCENTSTARTDATE
      ,PAYPERCENTPERIODLENGTH
      ,DOCBASE
      ,GUARANTEEKIND
      ,GUARANTEEACCREF
      ,EXECUTEPERIOD
      ,DFACCOUNT
      ,ACCREF
      ,ADDITIONALACCREF
      ,CURRENCYSUMMA
      ,CONTRACTINFO
      ,BONDCOUNT
      ,BONDCOST
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATEINPUT
      , :new.DATEAMORTIZATION
      , :new.SUMMA
      , :new.PROGINDEX
      , :new.BUDGETREF
      , :new.ORG_REF
      , :new.NOTE
      , :new.CONTRACTTYPE
      , :new.PERIODSTART
      , :new.PERIODLENGTH
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LONGDATE
      , :new.ACCEPTDATE
      , :new.ANUMBER
      , :new.YEARTYPE
      , :new.REGIONCLS
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.LOANTYPE
      , :new.DEBTTYPE
      , :new.CURRENCYCLS
      , :new.CBPERCENTRATE
      , :new.CBFINERATE
      , :new.CBFINEPERCENTRATE
      , :new.PERCENT
      , :new.FINE
      , :new.RETURNSTARTDATE
      , :new.RETURNPERIODLENGTH
      , :new.PAYPERCENTSTARTDATE
      , :new.PAYPERCENTPERIODLENGTH
      , :new.DOCBASE
      , :new.GUARANTEEKIND
      , :new.GUARANTEEACCREF
      , :new.EXECUTEPERIOD
      , :new.DFACCOUNT
      , :new.ACCREF
      , :new.ADDITIONALACCREF
      , :new.CURRENCYSUMMA
      , :new.CONTRACTINFO
      , :new.BONDCOUNT
      , :new.BONDCOST
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LOANCREDIT
  AFTER DELETE
  ON LOANCREDIT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDIT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LOANCREDITCONTRACTS
  AFTER INSERT
  ON LOANCREDITCONTRACTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDITCONTRACTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDITCONTRACTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,CONTRACTNUMBER
      ,CONTRACTDATE
      ,ENDDATE
      ,CONTRACTTYPE
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CONTRACTNUMBER
      , :new.CONTRACTDATE
      , :new.ENDDATE
      , :new.CONTRACTTYPE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LOANCREDITCONTRACTS
  AFTER UPDATE
  ON LOANCREDITCONTRACTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LOANCREDITCONTRACTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LOANCREDITCONTRACTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDITCONTRACTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,CONTRACTNUMBER
      ,CONTRACTDATE
      ,ENDDATE
      ,CONTRACTTYPE
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CONTRACTNUMBER
      , :new.CONTRACTDATE
      , :new.ENDDATE
      , :new.CONTRACTTYPE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_LOANCREDITCONTRACTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LOANCREDITCONTRACTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,CONTRACTNUMBER
      ,CONTRACTDATE
      ,ENDDATE
      ,CONTRACTTYPE
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.CONTRACTNUMBER
      , :new.CONTRACTDATE
      , :new.ENDDATE
      , :new.CONTRACTTYPE
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LOANCREDITCONTRACTS
  AFTER DELETE
  ON LOANCREDITCONTRACTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDITCONTRACTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LOANCREDITPERCENTS
  AFTER INSERT
  ON LOANCREDITPERCENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDITPERCENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDITPERCENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ACCEPTDATE
      ,SUMMA
      ,SUBKD
      ,BUHPAYMENTCLS
      ,NOTE
      ,PERIODSTART
      ,PERIODEND
      ,PAYPERCENTDATE
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,RECORDDATE
      ,CURRENCYCLS
      ,DFACCOUNT
      ,CURRENCYSUMMA
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
      ,KD
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,CLSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.SUBKD
      , :new.BUHPAYMENTCLS
      , :new.NOTE
      , :new.PERIODSTART
      , :new.PERIODEND
      , :new.PAYPERCENTDATE
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.RECORDDATE
      , :new.CURRENCYCLS
      , :new.DFACCOUNT
      , :new.CURRENCYSUMMA
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.KD
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.CLSTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LOANCREDITPERCENTS
  AFTER UPDATE
  ON LOANCREDITPERCENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LOANCREDITPERCENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LOANCREDITPERCENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDITPERCENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ACCEPTDATE
      ,SUMMA
      ,SUBKD
      ,BUHPAYMENTCLS
      ,NOTE
      ,PERIODSTART
      ,PERIODEND
      ,PAYPERCENTDATE
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,RECORDDATE
      ,CURRENCYCLS
      ,DFACCOUNT
      ,CURRENCYSUMMA
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
      ,KD
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,CLSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.SUBKD
      , :new.BUHPAYMENTCLS
      , :new.NOTE
      , :new.PERIODSTART
      , :new.PERIODEND
      , :new.PAYPERCENTDATE
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.RECORDDATE
      , :new.CURRENCYCLS
      , :new.DFACCOUNT
      , :new.CURRENCYSUMMA
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.KD
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.CLSTYPE
    );
  else 
    update A_LOANCREDITPERCENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LOANCREDITPERCENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ACCEPTDATE
      ,SUMMA
      ,SUBKD
      ,BUHPAYMENTCLS
      ,NOTE
      ,PERIODSTART
      ,PERIODEND
      ,PAYPERCENTDATE
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,RECORDDATE
      ,CURRENCYCLS
      ,DFACCOUNT
      ,CURRENCYSUMMA
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
      ,KD
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,CLSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.SUBKD
      , :new.BUHPAYMENTCLS
      , :new.NOTE
      , :new.PERIODSTART
      , :new.PERIODEND
      , :new.PAYPERCENTDATE
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.RECORDDATE
      , :new.CURRENCYCLS
      , :new.DFACCOUNT
      , :new.CURRENCYSUMMA
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.KD
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.CLSTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LOANCREDITPERCENTS
  AFTER DELETE
  ON LOANCREDITPERCENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDITPERCENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LOANCREDITPLAN
  AFTER INSERT
  ON LOANCREDITPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDITPLAN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDITPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,PLANDATE
      ,SUMMA
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CURRENCYCLS
      ,CURRENCYSUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.PLANDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CURRENCYCLS
      , :new.CURRENCYSUMMA
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LOANCREDITPLAN
  AFTER UPDATE
  ON LOANCREDITPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LOANCREDITPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LOANCREDITPLAN
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANCREDITPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,PLANDATE
      ,SUMMA
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CURRENCYCLS
      ,CURRENCYSUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.PLANDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CURRENCYCLS
      , :new.CURRENCYSUMMA
    );
  else 
    update A_LOANCREDITPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LOANCREDITPLAN (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PROGINDEX
      ,PLANDATE
      ,SUMMA
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CURRENCYCLS
      ,CURRENCYSUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.PLANDATE
      , :new.SUMMA
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CURRENCYCLS
      , :new.CURRENCYSUMMA
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LOANCREDITPLAN
  AFTER DELETE
  ON LOANCREDITPLAN
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANCREDITPLAN
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_LOANTYPE
  AFTER INSERT
  ON LOANTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,BUHACCOUNT
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUHACCOUNT
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_LOANTYPE
  AFTER UPDATE
  ON LOANTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_LOANTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_LOANTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_LOANTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,BUHACCOUNT
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUHACCOUNT
      , :new.NAME
    );
  else 
    update A_LOANTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_LOANTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,BUHACCOUNT
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.BUHACCOUNT
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_LOANTYPE
  AFTER DELETE
  ON LOANTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_LOANTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MANAGERBID
  AFTER INSERT
  ON MANAGERBID
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MANAGERBID
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MANAGERBID (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MANAGERFACIALACCCLS
      ,ARHIVEDOC
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,MANAGERBIDNUMBER
      ,MANAGERBIDDATE
      ,DOCSTATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MANAGERFACIALACCCLS
      , :new.ARHIVEDOC
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MANAGERBIDNUMBER
      , :new.MANAGERBIDDATE
      , :new.DOCSTATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MANAGERBID
  AFTER UPDATE
  ON MANAGERBID
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MANAGERBID
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MANAGERBID
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MANAGERBID (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MANAGERFACIALACCCLS
      ,ARHIVEDOC
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,MANAGERBIDNUMBER
      ,MANAGERBIDDATE
      ,DOCSTATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MANAGERFACIALACCCLS
      , :new.ARHIVEDOC
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MANAGERBIDNUMBER
      , :new.MANAGERBIDDATE
      , :new.DOCSTATE
    );
  else 
    update A_MANAGERBID
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MANAGERBID (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MANAGERFACIALACCCLS
      ,ARHIVEDOC
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,MANAGERBIDNUMBER
      ,MANAGERBIDDATE
      ,DOCSTATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MANAGERFACIALACCCLS
      , :new.ARHIVEDOC
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MANAGERBIDNUMBER
      , :new.MANAGERBIDDATE
      , :new.DOCSTATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MANAGERBID
  AFTER DELETE
  ON MANAGERBID
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MANAGERBID
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MEANSCLS
  AFTER INSERT
  ON MEANSCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEANSCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEANSCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MEANSCLS
  AFTER UPDATE
  ON MEANSCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MEANSCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MEANSCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEANSCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_MEANSCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MEANSCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MEANSCLS
  AFTER DELETE
  ON MEANSCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEANSCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MEANSTYPE
  AFTER INSERT
  ON MEANSTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEANSTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEANSTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,ACTIVITYKIND
      ,TARGETCLS
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,ACTIVITYTYPE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ACTIVITYKIND
      , :new.TARGETCLS
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.ACTIVITYTYPE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MEANSTYPE
  AFTER UPDATE
  ON MEANSTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MEANSTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MEANSTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEANSTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,ACTIVITYKIND
      ,TARGETCLS
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,ACTIVITYTYPE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ACTIVITYKIND
      , :new.TARGETCLS
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.ACTIVITYTYPE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_MEANSTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MEANSTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,ACTIVITYKIND
      ,TARGETCLS
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,ACTIVITYTYPE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ACTIVITYKIND
      , :new.TARGETCLS
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.ACTIVITYTYPE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MEANSTYPE
  AFTER DELETE
  ON MEANSTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEANSTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MEASUREMENTCLS
  AFTER INSERT
  ON MEASUREMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEASUREMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEASUREMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHORTNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MEASUREMENTCLS
  AFTER UPDATE
  ON MEASUREMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MEASUREMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MEASUREMENTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEASUREMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHORTNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NAME
    );
  else 
    update A_MEASUREMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MEASUREMENTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SHORTNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MEASUREMENTCLS
  AFTER DELETE
  ON MEASUREMENTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEASUREMENTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MEM_WARRANT
  AFTER INSERT
  ON MEM_WARRANT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEM_WARRANT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEM_WARRANT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATE_MONTH
      ,NUM_MEM
      ,WORK_FL
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATE_MONTH
      , :new.NUM_MEM
      , :new.WORK_FL
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MEM_WARRANT
  AFTER UPDATE
  ON MEM_WARRANT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MEM_WARRANT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MEM_WARRANT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MEM_WARRANT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATE_MONTH
      ,NUM_MEM
      ,WORK_FL
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATE_MONTH
      , :new.NUM_MEM
      , :new.WORK_FL
      , :new.NOTE
    );
  else 
    update A_MEM_WARRANT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MEM_WARRANT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DATE_MONTH
      ,NUM_MEM
      ,WORK_FL
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DATE_MONTH
      , :new.NUM_MEM
      , :new.WORK_FL
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MEM_WARRANT
  AFTER DELETE
  ON MEM_WARRANT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MEM_WARRANT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MONTHREPORTCAPTION
  AFTER INSERT
  ON MONTHREPORTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MONTHREPORTCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MONTHREPORTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,REPORTFLAG
      ,PERIOD
      ,KVB
      ,ORG
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.REPORTFLAG
      , :new.PERIOD
      , :new.KVB
      , :new.ORG
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.AMONTH
      , :new.AYEAR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MONTHREPORTCAPTION
  AFTER UPDATE
  ON MONTHREPORTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MONTHREPORTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MONTHREPORTCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MONTHREPORTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,REPORTFLAG
      ,PERIOD
      ,KVB
      ,ORG
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.REPORTFLAG
      , :new.PERIOD
      , :new.KVB
      , :new.ORG
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.AMONTH
      , :new.AYEAR
    );
  else 
    update A_MONTHREPORTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MONTHREPORTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,REPORTFLAG
      ,PERIOD
      ,KVB
      ,ORG
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.REPORTFLAG
      , :new.PERIOD
      , :new.KVB
      , :new.ORG
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.AMONTH
      , :new.AYEAR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MONTHREPORTCAPTION
  AFTER DELETE
  ON MONTHREPORTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MONTHREPORTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MONTHREPORTDETAIL
  AFTER INSERT
  ON MONTHREPORTDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MONTHREPORTDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MONTHREPORTDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,REPORTCODE
      ,PAGECODE
      ,STRINGCODE
      ,YEARSUMMA
      ,PLANSUMMA
      ,FACTSUMMA
      ,YEARSUMMAFINISH
      ,PLANSUMMAFINISH
      ,FACTSUMMAFINISH
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.REPORTCODE
      , :new.PAGECODE
      , :new.STRINGCODE
      , :new.YEARSUMMA
      , :new.PLANSUMMA
      , :new.FACTSUMMA
      , :new.YEARSUMMAFINISH
      , :new.PLANSUMMAFINISH
      , :new.FACTSUMMAFINISH
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MONTHREPORTDETAIL
  AFTER UPDATE
  ON MONTHREPORTDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MONTHREPORTDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MONTHREPORTDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MONTHREPORTDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,REPORTCODE
      ,PAGECODE
      ,STRINGCODE
      ,YEARSUMMA
      ,PLANSUMMA
      ,FACTSUMMA
      ,YEARSUMMAFINISH
      ,PLANSUMMAFINISH
      ,FACTSUMMAFINISH
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.REPORTCODE
      , :new.PAGECODE
      , :new.STRINGCODE
      , :new.YEARSUMMA
      , :new.PLANSUMMA
      , :new.FACTSUMMA
      , :new.YEARSUMMAFINISH
      , :new.PLANSUMMAFINISH
      , :new.FACTSUMMAFINISH
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_MONTHREPORTDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MONTHREPORTDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,REPORTCODE
      ,PAGECODE
      ,STRINGCODE
      ,YEARSUMMA
      ,PLANSUMMA
      ,FACTSUMMA
      ,YEARSUMMAFINISH
      ,PLANSUMMAFINISH
      ,FACTSUMMAFINISH
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.REPORTCODE
      , :new.PAGECODE
      , :new.STRINGCODE
      , :new.YEARSUMMA
      , :new.PLANSUMMA
      , :new.FACTSUMMA
      , :new.YEARSUMMAFINISH
      , :new.PLANSUMMAFINISH
      , :new.FACTSUMMAFINISH
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MONTHREPORTDETAIL
  AFTER DELETE
  ON MONTHREPORTDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MONTHREPORTDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MUTNOTIFCAPT
  AFTER INSERT
  ON MUTNOTIFCAPT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MUTNOTIFCAPT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MUTNOTIFCAPT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,INPUTDATE
      ,BUDSOURCE
      ,BUDDIST
      ,INOUT
      ,NOTE
      ,SPECIAL
      ,OSNOVANIE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.INPUTDATE
      , :new.BUDSOURCE
      , :new.BUDDIST
      , :new.INOUT
      , :new.NOTE
      , :new.SPECIAL
      , :new.OSNOVANIE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ANUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MUTNOTIFCAPT
  AFTER UPDATE
  ON MUTNOTIFCAPT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MUTNOTIFCAPT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MUTNOTIFCAPT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MUTNOTIFCAPT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,INPUTDATE
      ,BUDSOURCE
      ,BUDDIST
      ,INOUT
      ,NOTE
      ,SPECIAL
      ,OSNOVANIE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.INPUTDATE
      , :new.BUDSOURCE
      , :new.BUDDIST
      , :new.INOUT
      , :new.NOTE
      , :new.SPECIAL
      , :new.OSNOVANIE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ANUMBER
    );
  else 
    update A_MUTNOTIFCAPT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MUTNOTIFCAPT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,INPUTDATE
      ,BUDSOURCE
      ,BUDDIST
      ,INOUT
      ,NOTE
      ,SPECIAL
      ,OSNOVANIE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.INPUTDATE
      , :new.BUDSOURCE
      , :new.BUDDIST
      , :new.INOUT
      , :new.NOTE
      , :new.SPECIAL
      , :new.OSNOVANIE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ANUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MUTNOTIFCAPT
  AFTER DELETE
  ON MUTNOTIFCAPT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MUTNOTIFCAPT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_MUTNOTIFDETAIL
  AFTER INSERT
  ON MUTNOTIFDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MUTNOTIFDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MUTNOTIFDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CAPTREF
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,KFSR
      ,KVSR
      ,KVR
      ,KCSR
      ,KESR
      ,SUBKESR
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CAPTREF
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.KFSR
      , :new.KVSR
      , :new.KVR
      , :new.KCSR
      , :new.KESR
      , :new.SUBKESR
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_MUTNOTIFDETAIL
  AFTER UPDATE
  ON MUTNOTIFDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_MUTNOTIFDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_MUTNOTIFDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_MUTNOTIFDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CAPTREF
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,KFSR
      ,KVSR
      ,KVR
      ,KCSR
      ,KESR
      ,SUBKESR
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CAPTREF
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.KFSR
      , :new.KVSR
      , :new.KVR
      , :new.KCSR
      , :new.KESR
      , :new.SUBKESR
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_MUTNOTIFDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_MUTNOTIFDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CAPTREF
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,KFSR
      ,KVSR
      ,KVR
      ,KCSR
      ,KESR
      ,SUBKESR
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CAPTREF
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.KFSR
      , :new.KVSR
      , :new.KVR
      , :new.KCSR
      , :new.KESR
      , :new.SUBKESR
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_MUTNOTIFDETAIL
  AFTER DELETE
  ON MUTNOTIFDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_MUTNOTIFDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_NOTIFYTYPES
  AFTER INSERT
  ON NOTIFYTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_NOTIFYTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_NOTIFYTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_NOTIFYTYPES
  AFTER UPDATE
  ON NOTIFYTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_NOTIFYTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_NOTIFYTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_NOTIFYTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_NOTIFYTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_NOTIFYTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_NOTIFYTYPES
  AFTER DELETE
  ON NOTIFYTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_NOTIFYTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OBJECTCAPTION
  AFTER INSERT
  ON OBJECTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OBJECTCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OBJECTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
      ,NAME
      ,CNT
      ,INTERFACE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
      , :new.NAME
      , :new.CNT
      , :new.INTERFACE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OBJECTCAPTION
  AFTER UPDATE
  ON OBJECTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OBJECTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OBJECTCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OBJECTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
      ,NAME
      ,CNT
      ,INTERFACE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
      , :new.NAME
      , :new.CNT
      , :new.INTERFACE
    );
  else 
    update A_OBJECTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OBJECTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
      ,NAME
      ,CNT
      ,INTERFACE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
      , :new.NAME
      , :new.CNT
      , :new.INTERFACE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OBJECTCAPTION
  AFTER DELETE
  ON OBJECTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OBJECTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OBJECTDETAIL
  AFTER INSERT
  ON OBJECTDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OBJECTDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OBJECTDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ANUMBER
      ,DETAILID
      ,MASTERFIELD
      ,DETAILFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ANUMBER
      , :new.DETAILID
      , :new.MASTERFIELD
      , :new.DETAILFIELD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OBJECTDETAIL
  AFTER UPDATE
  ON OBJECTDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OBJECTDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OBJECTDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OBJECTDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ANUMBER
      ,DETAILID
      ,MASTERFIELD
      ,DETAILFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ANUMBER
      , :new.DETAILID
      , :new.MASTERFIELD
      , :new.DETAILFIELD
    );
  else 
    update A_OBJECTDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OBJECTDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ANUMBER
      ,DETAILID
      ,MASTERFIELD
      ,DETAILFIELD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ANUMBER
      , :new.DETAILID
      , :new.MASTERFIELD
      , :new.DETAILFIELD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OBJECTDETAIL
  AFTER DELETE
  ON OBJECTDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OBJECTDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OBJECTKIND
  AFTER INSERT
  ON OBJECTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OBJECTKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OBJECTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OBJECTKIND
  AFTER UPDATE
  ON OBJECTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OBJECTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OBJECTKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OBJECTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_OBJECTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OBJECTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OBJECTKIND
  AFTER DELETE
  ON OBJECTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OBJECTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKATO
  AFTER INSERT
  ON OKATO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKATO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKATO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,EXTENSION
      ,REGIONCLS
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.EXTENSION
      , :new.REGIONCLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKATO
  AFTER UPDATE
  ON OKATO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKATO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKATO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKATO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,EXTENSION
      ,REGIONCLS
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.EXTENSION
      , :new.REGIONCLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_OKATO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKATO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,EXTENSION
      ,REGIONCLS
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.EXTENSION
      , :new.REGIONCLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKATO
  AFTER DELETE
  ON OKATO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKATO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKDP
  AFTER INSERT
  ON OKDP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKDP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKDP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CODE4
      ,CODE5
      ,CODE6
      ,SOURCECODE
      ,NAME
      ,MEASUREMENTCLS
      ,HASCHILDS
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CODE4
      , :new.CODE5
      , :new.CODE6
      , :new.SOURCECODE
      , :new.NAME
      , :new.MEASUREMENTCLS
      , :new.HASCHILDS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKDP
  AFTER UPDATE
  ON OKDP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKDP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKDP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKDP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CODE4
      ,CODE5
      ,CODE6
      ,SOURCECODE
      ,NAME
      ,MEASUREMENTCLS
      ,HASCHILDS
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CODE4
      , :new.CODE5
      , :new.CODE6
      , :new.SOURCECODE
      , :new.NAME
      , :new.MEASUREMENTCLS
      , :new.HASCHILDS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  else 
    update A_OKDP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKDP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CODE4
      ,CODE5
      ,CODE6
      ,SOURCECODE
      ,NAME
      ,MEASUREMENTCLS
      ,HASCHILDS
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CODE4
      , :new.CODE5
      , :new.CODE6
      , :new.SOURCECODE
      , :new.NAME
      , :new.MEASUREMENTCLS
      , :new.HASCHILDS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKDP
  AFTER DELETE
  ON OKDP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKDP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKFS
  AFTER INSERT
  ON OKFS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKFS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKFS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKFS
  AFTER UPDATE
  ON OKFS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKFS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKFS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKFS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_OKFS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKFS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKFS
  AFTER DELETE
  ON OKFS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKFS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKOPF
  AFTER INSERT
  ON OKOPF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKOPF
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKOPF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKOPF
  AFTER UPDATE
  ON OKOPF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKOPF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKOPF
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKOPF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_OKOPF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKOPF (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKOPF
  AFTER DELETE
  ON OKOPF
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKOPF
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKP
  AFTER INSERT
  ON OKP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,HASCHILDS
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.HASCHILDS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKP
  AFTER UPDATE
  ON OKP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,HASCHILDS
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.HASCHILDS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.NAME
    );
  else 
    update A_OKP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,HASCHILDS
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.HASCHILDS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKP
  AFTER DELETE
  ON OKP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKPD
  AFTER INSERT
  ON OKPD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKPD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKPD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,HASCHILDS
      ,DELETEDATE
      ,STARTDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.HASCHILDS
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKPD
  AFTER UPDATE
  ON OKPD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKPD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKPD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKPD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,HASCHILDS
      ,DELETEDATE
      ,STARTDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.HASCHILDS
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  else 
    update A_OKPD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKPD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,HASCHILDS
      ,DELETEDATE
      ,STARTDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.HASCHILDS
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKPD
  AFTER DELETE
  ON OKPD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKPD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKPD2
  AFTER INSERT
  ON OKPD2
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKPD2
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKPD2 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKPD2
  AFTER UPDATE
  ON OKPD2
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKPD2
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKPD2
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKPD2 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_OKPD2
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKPD2 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKPD2
  AFTER DELETE
  ON OKPD2
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKPD2
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKTMO
  AFTER INSERT
  ON OKTMO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKTMO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKTMO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,CODE1
      ,CODE2
      ,NAME
      ,NAMEOKTMO8
      ,NOTEOKTMO8
      ,REGIONCLS
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.CODE1
      , :new.CODE2
      , :new.NAME
      , :new.NAMEOKTMO8
      , :new.NOTEOKTMO8
      , :new.REGIONCLS
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKTMO
  AFTER UPDATE
  ON OKTMO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKTMO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKTMO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKTMO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,CODE1
      ,CODE2
      ,NAME
      ,NAMEOKTMO8
      ,NOTEOKTMO8
      ,REGIONCLS
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.CODE1
      , :new.CODE2
      , :new.NAME
      , :new.NAMEOKTMO8
      , :new.NOTEOKTMO8
      , :new.REGIONCLS
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_OKTMO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKTMO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,CODE1
      ,CODE2
      ,NAME
      ,NAMEOKTMO8
      ,NOTEOKTMO8
      ,REGIONCLS
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.CODE1
      , :new.CODE2
      , :new.NAME
      , :new.NAMEOKTMO8
      , :new.NOTEOKTMO8
      , :new.REGIONCLS
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKTMO
  AFTER DELETE
  ON OKTMO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKTMO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKVED
  AFTER INSERT
  ON OKVED
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKVED
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKVED (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,HASCHILDS
      ,DELETEDATE
      ,STARTDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.HASCHILDS
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKVED
  AFTER UPDATE
  ON OKVED
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKVED
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKVED
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKVED (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,HASCHILDS
      ,DELETEDATE
      ,STARTDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.HASCHILDS
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  else 
    update A_OKVED
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKVED (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,HASCHILDS
      ,DELETEDATE
      ,STARTDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.HASCHILDS
      , :new.DELETEDATE
      , :new.STARTDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKVED
  AFTER DELETE
  ON OKVED
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKVED
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OKVED2
  AFTER INSERT
  ON OKVED2
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKVED2
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKVED2 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OKVED2
  AFTER UPDATE
  ON OKVED2
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OKVED2
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OKVED2
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OKVED2 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_OKVED2
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OKVED2 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OKVED2
  AFTER DELETE
  ON OKVED2
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OKVED2
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OLDINCOMES
  AFTER INSERT
  ON OLDINCOMES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OLDINCOMES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OLDINCOMES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KD
      ,ACCEPTDATE
      ,SUMMA
      ,REGIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KD
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.REGIONCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OLDINCOMES
  AFTER UPDATE
  ON OLDINCOMES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OLDINCOMES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OLDINCOMES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OLDINCOMES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KD
      ,ACCEPTDATE
      ,SUMMA
      ,REGIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KD
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.REGIONCLS
    );
  else 
    update A_OLDINCOMES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OLDINCOMES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KD
      ,ACCEPTDATE
      ,SUMMA
      ,REGIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KD
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.REGIONCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OLDINCOMES
  AFTER DELETE
  ON OLDINCOMES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OLDINCOMES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OOS_CONTRACT
  AFTER INSERT
  ON OOS_CONTRACT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARCHIVENAME
      ,PACKETNAME
      ,REGNUM
      ,ANUMBER
      ,SIGNDATE
      ,VERSIONNUMBER
      ,CUSTOMER_REGNUM
      ,CUSTOMER_FULLNAME
      ,CUSTOMER_INN
      ,CUSTOMER_KPP
      ,PROTOCOLDATE
      ,DOCUMENTBASE
      ,PRICE
      ,SINGLECUSTOMERREASON_ID
      ,SINGLECUSTOMERREASON_NAME
      ,EXECUTIONDATE_MONTH
      ,EXECUTIONDATE_YEAR
      ,SUPPLIER_INN
      ,SUPPLIER_KPP
      ,SUPPLIER_ORGANIZATIONNAME
      ,HREF
      ,FCSORDER_PLACING
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,BUDGET_CODE
      ,SUPPLIER_LF_SINGULARNAME
      ,PUBLISHDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARCHIVENAME
      , :new.PACKETNAME
      , :new.REGNUM
      , :new.ANUMBER
      , :new.SIGNDATE
      , :new.VERSIONNUMBER
      , :new.CUSTOMER_REGNUM
      , :new.CUSTOMER_FULLNAME
      , :new.CUSTOMER_INN
      , :new.CUSTOMER_KPP
      , :new.PROTOCOLDATE
      , :new.DOCUMENTBASE
      , :new.PRICE
      , :new.SINGLECUSTOMERREASON_ID
      , :new.SINGLECUSTOMERREASON_NAME
      , :new.EXECUTIONDATE_MONTH
      , :new.EXECUTIONDATE_YEAR
      , :new.SUPPLIER_INN
      , :new.SUPPLIER_KPP
      , :new.SUPPLIER_ORGANIZATIONNAME
      , :new.HREF
      , :new.FCSORDER_PLACING
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.BUDGET_CODE
      , :new.SUPPLIER_LF_SINGULARNAME
      , :new.PUBLISHDATE
      , :new.PROGINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OOS_CONTRACT
  AFTER UPDATE
  ON OOS_CONTRACT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OOS_CONTRACT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OOS_CONTRACT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARCHIVENAME
      ,PACKETNAME
      ,REGNUM
      ,ANUMBER
      ,SIGNDATE
      ,VERSIONNUMBER
      ,CUSTOMER_REGNUM
      ,CUSTOMER_FULLNAME
      ,CUSTOMER_INN
      ,CUSTOMER_KPP
      ,PROTOCOLDATE
      ,DOCUMENTBASE
      ,PRICE
      ,SINGLECUSTOMERREASON_ID
      ,SINGLECUSTOMERREASON_NAME
      ,EXECUTIONDATE_MONTH
      ,EXECUTIONDATE_YEAR
      ,SUPPLIER_INN
      ,SUPPLIER_KPP
      ,SUPPLIER_ORGANIZATIONNAME
      ,HREF
      ,FCSORDER_PLACING
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,BUDGET_CODE
      ,SUPPLIER_LF_SINGULARNAME
      ,PUBLISHDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARCHIVENAME
      , :new.PACKETNAME
      , :new.REGNUM
      , :new.ANUMBER
      , :new.SIGNDATE
      , :new.VERSIONNUMBER
      , :new.CUSTOMER_REGNUM
      , :new.CUSTOMER_FULLNAME
      , :new.CUSTOMER_INN
      , :new.CUSTOMER_KPP
      , :new.PROTOCOLDATE
      , :new.DOCUMENTBASE
      , :new.PRICE
      , :new.SINGLECUSTOMERREASON_ID
      , :new.SINGLECUSTOMERREASON_NAME
      , :new.EXECUTIONDATE_MONTH
      , :new.EXECUTIONDATE_YEAR
      , :new.SUPPLIER_INN
      , :new.SUPPLIER_KPP
      , :new.SUPPLIER_ORGANIZATIONNAME
      , :new.HREF
      , :new.FCSORDER_PLACING
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.BUDGET_CODE
      , :new.SUPPLIER_LF_SINGULARNAME
      , :new.PUBLISHDATE
      , :new.PROGINDEX
    );
  else 
    update A_OOS_CONTRACT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OOS_CONTRACT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARCHIVENAME
      ,PACKETNAME
      ,REGNUM
      ,ANUMBER
      ,SIGNDATE
      ,VERSIONNUMBER
      ,CUSTOMER_REGNUM
      ,CUSTOMER_FULLNAME
      ,CUSTOMER_INN
      ,CUSTOMER_KPP
      ,PROTOCOLDATE
      ,DOCUMENTBASE
      ,PRICE
      ,SINGLECUSTOMERREASON_ID
      ,SINGLECUSTOMERREASON_NAME
      ,EXECUTIONDATE_MONTH
      ,EXECUTIONDATE_YEAR
      ,SUPPLIER_INN
      ,SUPPLIER_KPP
      ,SUPPLIER_ORGANIZATIONNAME
      ,HREF
      ,FCSORDER_PLACING
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,BUDGET_CODE
      ,SUPPLIER_LF_SINGULARNAME
      ,PUBLISHDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARCHIVENAME
      , :new.PACKETNAME
      , :new.REGNUM
      , :new.ANUMBER
      , :new.SIGNDATE
      , :new.VERSIONNUMBER
      , :new.CUSTOMER_REGNUM
      , :new.CUSTOMER_FULLNAME
      , :new.CUSTOMER_INN
      , :new.CUSTOMER_KPP
      , :new.PROTOCOLDATE
      , :new.DOCUMENTBASE
      , :new.PRICE
      , :new.SINGLECUSTOMERREASON_ID
      , :new.SINGLECUSTOMERREASON_NAME
      , :new.EXECUTIONDATE_MONTH
      , :new.EXECUTIONDATE_YEAR
      , :new.SUPPLIER_INN
      , :new.SUPPLIER_KPP
      , :new.SUPPLIER_ORGANIZATIONNAME
      , :new.HREF
      , :new.FCSORDER_PLACING
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.BUDGET_CODE
      , :new.SUPPLIER_LF_SINGULARNAME
      , :new.PUBLISHDATE
      , :new.PROGINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OOS_CONTRACT
  AFTER DELETE
  ON OOS_CONTRACT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OOS_CONTRACT_FINANCES
  AFTER INSERT
  ON OOS_CONTRACT_FINANCES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACT_FINANCES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACT_FINANCES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ISBUDGETARY
      ,AYEAR
      ,SUBSTAGEMONTH
      ,SUBSTAGEYEAR
      ,KBK
      ,PRICE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PROGINDEX
      ,ANUMBER
      ,PACKETSECTION
      ,SUBJECTNAME
      ,MAXPRICE
      ,PLACINGWAY_CODE
      ,PLACINGWAY_NAME
      ,CHANGEREASON_ID
      ,CHANGEREASON_NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ISBUDGETARY
      , :new.AYEAR
      , :new.SUBSTAGEMONTH
      , :new.SUBSTAGEYEAR
      , :new.KBK
      , :new.PRICE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PROGINDEX
      , :new.ANUMBER
      , :new.PACKETSECTION
      , :new.SUBJECTNAME
      , :new.MAXPRICE
      , :new.PLACINGWAY_CODE
      , :new.PLACINGWAY_NAME
      , :new.CHANGEREASON_ID
      , :new.CHANGEREASON_NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OOS_CONTRACT_FINANCES
  AFTER UPDATE
  ON OOS_CONTRACT_FINANCES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OOS_CONTRACT_FINANCES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OOS_CONTRACT_FINANCES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACT_FINANCES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ISBUDGETARY
      ,AYEAR
      ,SUBSTAGEMONTH
      ,SUBSTAGEYEAR
      ,KBK
      ,PRICE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PROGINDEX
      ,ANUMBER
      ,PACKETSECTION
      ,SUBJECTNAME
      ,MAXPRICE
      ,PLACINGWAY_CODE
      ,PLACINGWAY_NAME
      ,CHANGEREASON_ID
      ,CHANGEREASON_NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ISBUDGETARY
      , :new.AYEAR
      , :new.SUBSTAGEMONTH
      , :new.SUBSTAGEYEAR
      , :new.KBK
      , :new.PRICE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PROGINDEX
      , :new.ANUMBER
      , :new.PACKETSECTION
      , :new.SUBJECTNAME
      , :new.MAXPRICE
      , :new.PLACINGWAY_CODE
      , :new.PLACINGWAY_NAME
      , :new.CHANGEREASON_ID
      , :new.CHANGEREASON_NAME
    );
  else 
    update A_OOS_CONTRACT_FINANCES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OOS_CONTRACT_FINANCES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,ISBUDGETARY
      ,AYEAR
      ,SUBSTAGEMONTH
      ,SUBSTAGEYEAR
      ,KBK
      ,PRICE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PROGINDEX
      ,ANUMBER
      ,PACKETSECTION
      ,SUBJECTNAME
      ,MAXPRICE
      ,PLACINGWAY_CODE
      ,PLACINGWAY_NAME
      ,CHANGEREASON_ID
      ,CHANGEREASON_NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.ISBUDGETARY
      , :new.AYEAR
      , :new.SUBSTAGEMONTH
      , :new.SUBSTAGEYEAR
      , :new.KBK
      , :new.PRICE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PROGINDEX
      , :new.ANUMBER
      , :new.PACKETSECTION
      , :new.SUBJECTNAME
      , :new.MAXPRICE
      , :new.PLACINGWAY_CODE
      , :new.PLACINGWAY_NAME
      , :new.CHANGEREASON_ID
      , :new.CHANGEREASON_NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OOS_CONTRACT_FINANCES
  AFTER DELETE
  ON OOS_CONTRACT_FINANCES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACT_FINANCES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OOS_CONTRACT_PRODUCTS
  AFTER INSERT
  ON OOS_CONTRACT_PRODUCTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACT_PRODUCTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACT_PRODUCTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PROGINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OOS_CONTRACT_PRODUCTS
  AFTER UPDATE
  ON OOS_CONTRACT_PRODUCTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OOS_CONTRACT_PRODUCTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OOS_CONTRACT_PRODUCTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACT_PRODUCTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PROGINDEX
    );
  else 
    update A_OOS_CONTRACT_PRODUCTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OOS_CONTRACT_PRODUCTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PROGINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OOS_CONTRACT_PRODUCTS
  AFTER DELETE
  ON OOS_CONTRACT_PRODUCTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACT_PRODUCTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OOS_CONTRACTPROCEDURE
  AFTER INSERT
  ON OOS_CONTRACTPROCEDURE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACTPROCEDURE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACTPROCEDURE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARCHIVENAME
      ,PACKETNAME
      ,REGNUM
      ,VERSIONNUMBER
      ,TERMINATION_PAID
      ,CURRENTCONTRACTSTAGE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PUBLISHDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARCHIVENAME
      , :new.PACKETNAME
      , :new.REGNUM
      , :new.VERSIONNUMBER
      , :new.TERMINATION_PAID
      , :new.CURRENTCONTRACTSTAGE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PUBLISHDATE
      , :new.PROGINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OOS_CONTRACTPROCEDURE
  AFTER UPDATE
  ON OOS_CONTRACTPROCEDURE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OOS_CONTRACTPROCEDURE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OOS_CONTRACTPROCEDURE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OOS_CONTRACTPROCEDURE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARCHIVENAME
      ,PACKETNAME
      ,REGNUM
      ,VERSIONNUMBER
      ,TERMINATION_PAID
      ,CURRENTCONTRACTSTAGE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PUBLISHDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARCHIVENAME
      , :new.PACKETNAME
      , :new.REGNUM
      , :new.VERSIONNUMBER
      , :new.TERMINATION_PAID
      , :new.CURRENTCONTRACTSTAGE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PUBLISHDATE
      , :new.PROGINDEX
    );
  else 
    update A_OOS_CONTRACTPROCEDURE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OOS_CONTRACTPROCEDURE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ARCHIVENAME
      ,PACKETNAME
      ,REGNUM
      ,VERSIONNUMBER
      ,TERMINATION_PAID
      ,CURRENTCONTRACTSTAGE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PUBLISHDATE
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ARCHIVENAME
      , :new.PACKETNAME
      , :new.REGNUM
      , :new.VERSIONNUMBER
      , :new.TERMINATION_PAID
      , :new.CURRENTCONTRACTSTAGE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PUBLISHDATE
      , :new.PROGINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OOS_CONTRACTPROCEDURE
  AFTER DELETE
  ON OOS_CONTRACTPROCEDURE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OOS_CONTRACTPROCEDURE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORG_ACCDEFAULTS
  AFTER INSERT
  ON ORG_ACCDEFAULTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORG_ACCDEFAULTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORG_ACCDEFAULTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PAYTYPE
      ,PAYQUEUE
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PAYTYPE
      , :new.PAYQUEUE
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORG_ACCDEFAULTS
  AFTER UPDATE
  ON ORG_ACCDEFAULTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORG_ACCDEFAULTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORG_ACCDEFAULTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORG_ACCDEFAULTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PAYTYPE
      ,PAYQUEUE
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PAYTYPE
      , :new.PAYQUEUE
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_ORG_ACCDEFAULTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORG_ACCDEFAULTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PAYTYPE
      ,PAYQUEUE
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PAYTYPE
      , :new.PAYQUEUE
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORG_ACCDEFAULTS
  AFTER DELETE
  ON ORG_ACCDEFAULTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORG_ACCDEFAULTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORG_CLS
  AFTER INSERT
  ON ORG_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORG_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORG_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORG_CLS
  AFTER UPDATE
  ON ORG_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORG_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORG_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORG_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_ORG_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORG_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORG_CLS
  AFTER DELETE
  ON ORG_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORG_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORG_TYPE
  AFTER INSERT
  ON ORG_TYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORG_TYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORG_TYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORG_TYPE
  AFTER UPDATE
  ON ORG_TYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORG_TYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORG_TYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORG_TYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_ORG_TYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORG_TYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORG_TYPE
  AFTER DELETE
  ON ORG_TYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORG_TYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORGATTRIBUTES
  AFTER INSERT
  ON ORGATTRIBUTES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGATTRIBUTES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGATTRIBUTES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,ORGNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ORGINN
      ,ACC
      ,ORGINN20
      ,BANKNAME
      ,BANKMFO
      ,BANKCOR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.ORGNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ORGINN
      , :new.ACC
      , :new.ORGINN20
      , :new.BANKNAME
      , :new.BANKMFO
      , :new.BANKCOR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORGATTRIBUTES
  AFTER UPDATE
  ON ORGATTRIBUTES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORGATTRIBUTES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORGATTRIBUTES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGATTRIBUTES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,ORGNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ORGINN
      ,ACC
      ,ORGINN20
      ,BANKNAME
      ,BANKMFO
      ,BANKCOR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.ORGNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ORGINN
      , :new.ACC
      , :new.ORGINN20
      , :new.BANKNAME
      , :new.BANKMFO
      , :new.BANKCOR
    );
  else 
    update A_ORGATTRIBUTES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORGATTRIBUTES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,ORGNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ORGINN
      ,ACC
      ,ORGINN20
      ,BANKNAME
      ,BANKMFO
      ,BANKCOR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.ORGNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ORGINN
      , :new.ACC
      , :new.ORGINN20
      , :new.BANKNAME
      , :new.BANKMFO
      , :new.BANKCOR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORGATTRIBUTES
  AFTER DELETE
  ON ORGATTRIBUTES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGATTRIBUTES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORGOPERAT
  AFTER INSERT
  ON ORGOPERAT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGOPERAT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGOPERAT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,ACCOUNTREF
      ,NOWDATE
      ,YEARREPORT
      ,MONTHREPORT
      ,SUMMA
      ,GROUPINF
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SUMMA1
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,FACIALACC_CLS
      ,FACT
      ,MEANSTYPE
      ,ACCEPTORACCREF
      ,IFS
      ,SUBKCSR
      ,DIRECTIONCLS
      ,DOCBASE
      ,CLSTYPE
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.ACCOUNTREF
      , :new.NOWDATE
      , :new.YEARREPORT
      , :new.MONTHREPORT
      , :new.SUMMA
      , :new.GROUPINF
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SUMMA1
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.FACIALACC_CLS
      , :new.FACT
      , :new.MEANSTYPE
      , :new.ACCEPTORACCREF
      , :new.IFS
      , :new.SUBKCSR
      , :new.DIRECTIONCLS
      , :new.DOCBASE
      , :new.CLSTYPE
      , :new.TRANSFERTCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORGOPERAT
  AFTER UPDATE
  ON ORGOPERAT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORGOPERAT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORGOPERAT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGOPERAT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,ACCOUNTREF
      ,NOWDATE
      ,YEARREPORT
      ,MONTHREPORT
      ,SUMMA
      ,GROUPINF
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SUMMA1
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,FACIALACC_CLS
      ,FACT
      ,MEANSTYPE
      ,ACCEPTORACCREF
      ,IFS
      ,SUBKCSR
      ,DIRECTIONCLS
      ,DOCBASE
      ,CLSTYPE
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.ACCOUNTREF
      , :new.NOWDATE
      , :new.YEARREPORT
      , :new.MONTHREPORT
      , :new.SUMMA
      , :new.GROUPINF
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SUMMA1
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.FACIALACC_CLS
      , :new.FACT
      , :new.MEANSTYPE
      , :new.ACCEPTORACCREF
      , :new.IFS
      , :new.SUBKCSR
      , :new.DIRECTIONCLS
      , :new.DOCBASE
      , :new.CLSTYPE
      , :new.TRANSFERTCLS
    );
  else 
    update A_ORGOPERAT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORGOPERAT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,ACCOUNTREF
      ,NOWDATE
      ,YEARREPORT
      ,MONTHREPORT
      ,SUMMA
      ,GROUPINF
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SUMMA1
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,FACIALACC_CLS
      ,FACT
      ,MEANSTYPE
      ,ACCEPTORACCREF
      ,IFS
      ,SUBKCSR
      ,DIRECTIONCLS
      ,DOCBASE
      ,CLSTYPE
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.ACCOUNTREF
      , :new.NOWDATE
      , :new.YEARREPORT
      , :new.MONTHREPORT
      , :new.SUMMA
      , :new.GROUPINF
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SUMMA1
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.FACIALACC_CLS
      , :new.FACT
      , :new.MEANSTYPE
      , :new.ACCEPTORACCREF
      , :new.IFS
      , :new.SUBKCSR
      , :new.DIRECTIONCLS
      , :new.DOCBASE
      , :new.CLSTYPE
      , :new.TRANSFERTCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORGOPERAT
  AFTER DELETE
  ON ORGOPERAT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGOPERAT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORGSHARECAPTION
  AFTER INSERT
  ON ORGSHARECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGSHARECAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGSHARECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORGSHARECAPTION
  AFTER UPDATE
  ON ORGSHARECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORGSHARECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORGSHARECAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGSHARECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_ORGSHARECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORGSHARECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORGSHARECAPTION
  AFTER DELETE
  ON ORGSHARECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGSHARECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_ORGSHAREDETAIL
  AFTER INSERT
  ON ORGSHAREDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGSHAREDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGSHAREDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,SUMMA
      ,BUDGETREF
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.SUMMA
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_ORGSHAREDETAIL
  AFTER UPDATE
  ON ORGSHAREDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_ORGSHAREDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_ORGSHAREDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_ORGSHAREDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,SUMMA
      ,BUDGETREF
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.SUMMA
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_ORGSHAREDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_ORGSHAREDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACC_REF
      ,SUMMA
      ,BUDGETREF
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACC_REF
      , :new.SUMMA
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_ORGSHAREDETAIL
  AFTER DELETE
  ON ORGSHAREDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_ORGSHAREDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OTHBUDNOTIFCAPTION
  AFTER INSERT
  ON OTHBUDNOTIFCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OTHBUDNOTIFCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OTHBUDNOTIFCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,INPUTDATE
      ,BUDDIST
      ,INOUT
      ,NOTE
      ,SPECIAL
      ,OSNOVANIE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ANUMBER
      ,DOCBASE
      ,DOCSTATEREF
      ,CRYPTOSTATUS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.INPUTDATE
      , :new.BUDDIST
      , :new.INOUT
      , :new.NOTE
      , :new.SPECIAL
      , :new.OSNOVANIE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.DOCBASE
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OTHBUDNOTIFCAPTION
  AFTER UPDATE
  ON OTHBUDNOTIFCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OTHBUDNOTIFCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OTHBUDNOTIFCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OTHBUDNOTIFCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,INPUTDATE
      ,BUDDIST
      ,INOUT
      ,NOTE
      ,SPECIAL
      ,OSNOVANIE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ANUMBER
      ,DOCBASE
      ,DOCSTATEREF
      ,CRYPTOSTATUS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.INPUTDATE
      , :new.BUDDIST
      , :new.INOUT
      , :new.NOTE
      , :new.SPECIAL
      , :new.OSNOVANIE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.DOCBASE
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
    );
  else 
    update A_OTHBUDNOTIFCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OTHBUDNOTIFCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,ACCEPTDATE
      ,INPUTDATE
      ,BUDDIST
      ,INOUT
      ,NOTE
      ,SPECIAL
      ,OSNOVANIE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ANUMBER
      ,DOCBASE
      ,DOCSTATEREF
      ,CRYPTOSTATUS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.INPUTDATE
      , :new.BUDDIST
      , :new.INOUT
      , :new.NOTE
      , :new.SPECIAL
      , :new.OSNOVANIE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.DOCBASE
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OTHBUDNOTIFCAPTION
  AFTER DELETE
  ON OTHBUDNOTIFCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OTHBUDNOTIFCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_OTHBUDNOTIFDETAIL
  AFTER INSERT
  ON OTHBUDNOTIFDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OTHBUDNOTIFDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OTHBUDNOTIFDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,KFSR
      ,KVSR
      ,KVR
      ,KCSR
      ,KESR
      ,SUBKESR
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,FACT
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.KFSR
      , :new.KVSR
      , :new.KVR
      , :new.KCSR
      , :new.KESR
      , :new.SUBKESR
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_OTHBUDNOTIFDETAIL
  AFTER UPDATE
  ON OTHBUDNOTIFDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_OTHBUDNOTIFDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_OTHBUDNOTIFDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_OTHBUDNOTIFDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,KFSR
      ,KVSR
      ,KVR
      ,KCSR
      ,KESR
      ,SUBKESR
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,FACT
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.KFSR
      , :new.KVSR
      , :new.KVR
      , :new.KCSR
      , :new.KESR
      , :new.SUBKESR
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
    );
  else 
    update A_OTHBUDNOTIFDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_OTHBUDNOTIFDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,KFSR
      ,KVSR
      ,KVR
      ,KCSR
      ,KESR
      ,SUBKESR
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,FACT
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,MEANSTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.KFSR
      , :new.KVSR
      , :new.KVR
      , :new.KCSR
      , :new.KESR
      , :new.SUBKESR
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.MEANSTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_OTHBUDNOTIFDETAIL
  AFTER DELETE
  ON OTHBUDNOTIFDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_OTHBUDNOTIFDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAPEROPERATION
  AFTER INSERT
  ON PAPEROPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAPEROPERATION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAPEROPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ACC_REF
      ,ACCEPTORACC_REF
      ,ACCEPTDATE
      ,BUHPAYMENTCLS
      ,DFACCOUNT
      ,DEBIT
      ,CREDIT
      ,NOTE
      ,DOCTYPE
      ,DOCNUMBER
      ,FACIALACC_CLS
      ,REGIONCLS
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
      ,CLSTYPE
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ACC_REF
      , :new.ACCEPTORACC_REF
      , :new.ACCEPTDATE
      , :new.BUHPAYMENTCLS
      , :new.DFACCOUNT
      , :new.DEBIT
      , :new.CREDIT
      , :new.NOTE
      , :new.DOCTYPE
      , :new.DOCNUMBER
      , :new.FACIALACC_CLS
      , :new.REGIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.CLSTYPE
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAPEROPERATION
  AFTER UPDATE
  ON PAPEROPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAPEROPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAPEROPERATION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAPEROPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ACC_REF
      ,ACCEPTORACC_REF
      ,ACCEPTDATE
      ,BUHPAYMENTCLS
      ,DFACCOUNT
      ,DEBIT
      ,CREDIT
      ,NOTE
      ,DOCTYPE
      ,DOCNUMBER
      ,FACIALACC_CLS
      ,REGIONCLS
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
      ,CLSTYPE
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ACC_REF
      , :new.ACCEPTORACC_REF
      , :new.ACCEPTDATE
      , :new.BUHPAYMENTCLS
      , :new.DFACCOUNT
      , :new.DEBIT
      , :new.CREDIT
      , :new.NOTE
      , :new.DOCTYPE
      , :new.DOCNUMBER
      , :new.FACIALACC_CLS
      , :new.REGIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.CLSTYPE
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
    );
  else 
    update A_PAPEROPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAPEROPERATION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ACC_REF
      ,ACCEPTORACC_REF
      ,ACCEPTDATE
      ,BUHPAYMENTCLS
      ,DFACCOUNT
      ,DEBIT
      ,CREDIT
      ,NOTE
      ,DOCTYPE
      ,DOCNUMBER
      ,FACIALACC_CLS
      ,REGIONCLS
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,MEANSTYPE
      ,CLSTYPE
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ACC_REF
      , :new.ACCEPTORACC_REF
      , :new.ACCEPTDATE
      , :new.BUHPAYMENTCLS
      , :new.DFACCOUNT
      , :new.DEBIT
      , :new.CREDIT
      , :new.NOTE
      , :new.DOCTYPE
      , :new.DOCNUMBER
      , :new.FACIALACC_CLS
      , :new.REGIONCLS
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.MEANSTYPE
      , :new.CLSTYPE
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAPEROPERATION
  AFTER DELETE
  ON PAPEROPERATION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAPEROPERATION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAYDESTINATIONCLS
  AFTER INSERT
  ON PAYDESTINATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYDESTINATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYDESTINATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PRIORITY
      ,TAXNOTE
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PRIORITY
      , :new.TAXNOTE
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAYDESTINATIONCLS
  AFTER UPDATE
  ON PAYDESTINATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAYDESTINATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAYDESTINATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYDESTINATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PRIORITY
      ,TAXNOTE
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PRIORITY
      , :new.TAXNOTE
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_PAYDESTINATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAYDESTINATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PRIORITY
      ,TAXNOTE
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PRIORITY
      , :new.TAXNOTE
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAYDESTINATIONCLS
  AFTER DELETE
  ON PAYDESTINATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYDESTINATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAYDOCEXCHANGE
  AFTER INSERT
  ON PAYDOCEXCHANGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYDOCEXCHANGE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYDOCEXCHANGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SENDDATE
      ,ERROR
      ,NOTE
      ,PAYDOCREF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,TYPEINF
      ,STATUS
      ,QUEUETIME
      ,REESTRNUMBER
      ,CODEFORMAT
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,DOCNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SENDDATE
      , :new.ERROR
      , :new.NOTE
      , :new.PAYDOCREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.TYPEINF
      , :new.STATUS
      , :new.QUEUETIME
      , :new.REESTRNUMBER
      , :new.CODEFORMAT
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.DOCNUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAYDOCEXCHANGE
  AFTER UPDATE
  ON PAYDOCEXCHANGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAYDOCEXCHANGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAYDOCEXCHANGE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYDOCEXCHANGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SENDDATE
      ,ERROR
      ,NOTE
      ,PAYDOCREF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,TYPEINF
      ,STATUS
      ,QUEUETIME
      ,REESTRNUMBER
      ,CODEFORMAT
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,DOCNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SENDDATE
      , :new.ERROR
      , :new.NOTE
      , :new.PAYDOCREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.TYPEINF
      , :new.STATUS
      , :new.QUEUETIME
      , :new.REESTRNUMBER
      , :new.CODEFORMAT
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.DOCNUMBER
    );
  else 
    update A_PAYDOCEXCHANGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAYDOCEXCHANGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SENDDATE
      ,ERROR
      ,NOTE
      ,PAYDOCREF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,TYPEINF
      ,STATUS
      ,QUEUETIME
      ,REESTRNUMBER
      ,CODEFORMAT
      ,PACKETNUMBER
      ,ELPACKETNUMBER
      ,DOCNUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SENDDATE
      , :new.ERROR
      , :new.NOTE
      , :new.PAYDOCREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.TYPEINF
      , :new.STATUS
      , :new.QUEUETIME
      , :new.REESTRNUMBER
      , :new.CODEFORMAT
      , :new.PACKETNUMBER
      , :new.ELPACKETNUMBER
      , :new.DOCNUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAYDOCEXCHANGE
  AFTER DELETE
  ON PAYDOCEXCHANGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYDOCEXCHANGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAYDOCTEMPLATES
  AFTER INSERT
  ON PAYDOCTEMPLATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYDOCTEMPLATES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYDOCTEMPLATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PAYERATTRREF
      ,ACCEPTORATTRREF
      ,SENDBY
      ,SUMMA
      ,CURRENCY
      ,PAYDATE
      ,PAYQUEUE
      ,TEXTNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,ACOMMENT
      ,CURSUM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PAYERATTRREF
      , :new.ACCEPTORATTRREF
      , :new.SENDBY
      , :new.SUMMA
      , :new.CURRENCY
      , :new.PAYDATE
      , :new.PAYQUEUE
      , :new.TEXTNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.ACOMMENT
      , :new.CURSUM
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAYDOCTEMPLATES
  AFTER UPDATE
  ON PAYDOCTEMPLATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAYDOCTEMPLATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAYDOCTEMPLATES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYDOCTEMPLATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PAYERATTRREF
      ,ACCEPTORATTRREF
      ,SENDBY
      ,SUMMA
      ,CURRENCY
      ,PAYDATE
      ,PAYQUEUE
      ,TEXTNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,ACOMMENT
      ,CURSUM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PAYERATTRREF
      , :new.ACCEPTORATTRREF
      , :new.SENDBY
      , :new.SUMMA
      , :new.CURRENCY
      , :new.PAYDATE
      , :new.PAYQUEUE
      , :new.TEXTNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.ACOMMENT
      , :new.CURSUM
    );
  else 
    update A_PAYDOCTEMPLATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAYDOCTEMPLATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PAYERATTRREF
      ,ACCEPTORATTRREF
      ,SENDBY
      ,SUMMA
      ,CURRENCY
      ,PAYDATE
      ,PAYQUEUE
      ,TEXTNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,ACOMMENT
      ,CURSUM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PAYERATTRREF
      , :new.ACCEPTORATTRREF
      , :new.SENDBY
      , :new.SUMMA
      , :new.CURRENCY
      , :new.PAYDATE
      , :new.PAYQUEUE
      , :new.TEXTNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.ACOMMENT
      , :new.CURSUM
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAYDOCTEMPLATES
  AFTER DELETE
  ON PAYDOCTEMPLATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYDOCTEMPLATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAYPROMISECLS
  AFTER INSERT
  ON PAYPROMISECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYPROMISECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYPROMISECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAYPROMISECLS
  AFTER UPDATE
  ON PAYPROMISECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAYPROMISECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAYPROMISECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYPROMISECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_PAYPROMISECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAYPROMISECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAYPROMISECLS
  AFTER DELETE
  ON PAYPROMISECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYPROMISECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAYSYMBOLCLS
  AFTER INSERT
  ON PAYSYMBOLCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYSYMBOLCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYSYMBOLCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAYSYMBOLCLS
  AFTER UPDATE
  ON PAYSYMBOLCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAYSYMBOLCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAYSYMBOLCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYSYMBOLCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_PAYSYMBOLCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAYSYMBOLCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAYSYMBOLCLS
  AFTER DELETE
  ON PAYSYMBOLCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYSYMBOLCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PAYTYPECLS
  AFTER INSERT
  ON PAYTYPECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYTYPECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYTYPECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PAYTYPECLS
  AFTER UPDATE
  ON PAYTYPECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PAYTYPECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PAYTYPECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PAYTYPECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_PAYTYPECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PAYTYPECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PAYTYPECLS
  AFTER DELETE
  ON PAYTYPECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PAYTYPECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PERMISSIONS
  AFTER INSERT
  ON PERMISSIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PERMISSIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PERMISSIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INTERFACEREF
      ,NAME
      ,VAL
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INTERFACEREF
      , :new.NAME
      , :new.VAL
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PERMISSIONS
  AFTER UPDATE
  ON PERMISSIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PERMISSIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PERMISSIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PERMISSIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INTERFACEREF
      ,NAME
      ,VAL
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INTERFACEREF
      , :new.NAME
      , :new.VAL
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_PERMISSIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PERMISSIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INTERFACEREF
      ,NAME
      ,VAL
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INTERFACEREF
      , :new.NAME
      , :new.VAL
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PERMISSIONS
  AFTER DELETE
  ON PERMISSIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PERMISSIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PLANDOCTYPE
  AFTER INSERT
  ON PLANDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PLANDOCTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PLANDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PLANDOCTYPE
  AFTER UPDATE
  ON PLANDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PLANDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PLANDOCTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PLANDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_PLANDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PLANDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PLANDOCTYPE
  AFTER DELETE
  ON PLANDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PLANDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PLANKIND
  AFTER INSERT
  ON PLANKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PLANKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PLANKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PLANKIND
  AFTER UPDATE
  ON PLANKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PLANKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PLANKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PLANKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
  else 
    update A_PLANKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PLANKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PLANKIND
  AFTER DELETE
  ON PLANKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PLANKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PROGRAMCODE
  AFTER INSERT
  ON PROGRAMCODE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PROGRAMCODE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PROGRAMCODE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,SHORTNAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.SHORTNAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PROGRAMCODE
  AFTER UPDATE
  ON PROGRAMCODE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PROGRAMCODE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PROGRAMCODE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PROGRAMCODE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,SHORTNAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.SHORTNAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_PROGRAMCODE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PROGRAMCODE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,SHORTNAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.SHORTNAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PROGRAMCODE
  AFTER DELETE
  ON PROGRAMCODE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PROGRAMCODE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PROTOCOLDOCTYPE
  AFTER INSERT
  ON PROTOCOLDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PROTOCOLDOCTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PROTOCOLDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ATYPE
      ,WEBID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ATYPE
      , :new.WEBID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PROTOCOLDOCTYPE
  AFTER UPDATE
  ON PROTOCOLDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PROTOCOLDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PROTOCOLDOCTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PROTOCOLDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ATYPE
      ,WEBID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ATYPE
      , :new.WEBID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_PROTOCOLDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PROTOCOLDOCTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ATYPE
      ,WEBID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ATYPE
      , :new.WEBID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PROTOCOLDOCTYPE
  AFTER DELETE
  ON PROTOCOLDOCTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PROTOCOLDOCTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_PROTOCOLREASON
  AFTER INSERT
  ON PROTOCOLREASON
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PROTOCOLREASON
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PROTOCOLREASON (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,WEBID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.WEBID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_PROTOCOLREASON
  AFTER UPDATE
  ON PROTOCOLREASON
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_PROTOCOLREASON
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_PROTOCOLREASON
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_PROTOCOLREASON (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,WEBID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.WEBID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_PROTOCOLREASON
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_PROTOCOLREASON (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,WEBID
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.WEBID
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_PROTOCOLREASON
  AFTER DELETE
  ON PROTOCOLREASON
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_PROTOCOLREASON
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REALCONST
  AFTER INSERT
  ON REALCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REALCONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REALCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REALCONST
  AFTER UPDATE
  ON REALCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REALCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REALCONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REALCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  else 
    update A_REALCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REALCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REALCONST
  AFTER DELETE
  ON REALCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REALCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_RECORDPARAMS
  AFTER INSERT
  ON RECORDPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RECORDPARAMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RECORDPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCCLS
      ,CHILDCOUNT
      ,PARENTCOUNT
      ,DISABLEDELCOUNT
      ,PARENTBLOCKCOUNT
      ,CHILDBLOCKCOUNT
      ,COMMONPICTURECOUNT
      ,UNIQUEPICTURECOUNT
      ,REJECTCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCCLS
      , :new.CHILDCOUNT
      , :new.PARENTCOUNT
      , :new.DISABLEDELCOUNT
      , :new.PARENTBLOCKCOUNT
      , :new.CHILDBLOCKCOUNT
      , :new.COMMONPICTURECOUNT
      , :new.UNIQUEPICTURECOUNT
      , :new.REJECTCOUNT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_RECORDPARAMS
  AFTER UPDATE
  ON RECORDPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_RECORDPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_RECORDPARAMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RECORDPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCCLS
      ,CHILDCOUNT
      ,PARENTCOUNT
      ,DISABLEDELCOUNT
      ,PARENTBLOCKCOUNT
      ,CHILDBLOCKCOUNT
      ,COMMONPICTURECOUNT
      ,UNIQUEPICTURECOUNT
      ,REJECTCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCCLS
      , :new.CHILDCOUNT
      , :new.PARENTCOUNT
      , :new.DISABLEDELCOUNT
      , :new.PARENTBLOCKCOUNT
      , :new.CHILDBLOCKCOUNT
      , :new.COMMONPICTURECOUNT
      , :new.UNIQUEPICTURECOUNT
      , :new.REJECTCOUNT
    );
  else 
    update A_RECORDPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_RECORDPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCCLS
      ,CHILDCOUNT
      ,PARENTCOUNT
      ,DISABLEDELCOUNT
      ,PARENTBLOCKCOUNT
      ,CHILDBLOCKCOUNT
      ,COMMONPICTURECOUNT
      ,UNIQUEPICTURECOUNT
      ,REJECTCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCCLS
      , :new.CHILDCOUNT
      , :new.PARENTCOUNT
      , :new.DISABLEDELCOUNT
      , :new.PARENTBLOCKCOUNT
      , :new.CHILDBLOCKCOUNT
      , :new.COMMONPICTURECOUNT
      , :new.UNIQUEPICTURECOUNT
      , :new.REJECTCOUNT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_RECORDPARAMS
  AFTER DELETE
  ON RECORDPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RECORDPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REESTRTYPE
  AFTER INSERT
  ON REESTRTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REESTRTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REESTRTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,TREASUARYITFLIST
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.TREASUARYITFLIST
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REESTRTYPE
  AFTER UPDATE
  ON REESTRTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REESTRTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REESTRTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REESTRTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,TREASUARYITFLIST
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.TREASUARYITFLIST
      , :new.NAME
    );
  else 
    update A_REESTRTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REESTRTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,TREASUARYITFLIST
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.TREASUARYITFLIST
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REESTRTYPE
  AFTER DELETE
  ON REESTRTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REESTRTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REFCLS
  AFTER INSERT
  ON REFCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REFCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REFCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REFCLS
  AFTER UPDATE
  ON REFCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REFCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REFCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REFCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_REFCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REFCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REFCLS
  AFTER DELETE
  ON REFCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REFCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REG_JOURNAL
  AFTER INSERT
  ON REG_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REG_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REG_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGUSERS_REF
      ,OBJECT_ID
      ,OBJECT_TYPE
      ,DATEBEGIN
      ,DATEEND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGUSERS_REF
      , :new.OBJECT_ID
      , :new.OBJECT_TYPE
      , :new.DATEBEGIN
      , :new.DATEEND
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REG_JOURNAL
  AFTER UPDATE
  ON REG_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REG_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REG_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REG_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGUSERS_REF
      ,OBJECT_ID
      ,OBJECT_TYPE
      ,DATEBEGIN
      ,DATEEND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGUSERS_REF
      , :new.OBJECT_ID
      , :new.OBJECT_TYPE
      , :new.DATEBEGIN
      , :new.DATEEND
    );
  else 
    update A_REG_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REG_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGUSERS_REF
      ,OBJECT_ID
      ,OBJECT_TYPE
      ,DATEBEGIN
      ,DATEEND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGUSERS_REF
      , :new.OBJECT_ID
      , :new.OBJECT_TYPE
      , :new.DATEBEGIN
      , :new.DATEEND
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REG_JOURNAL
  AFTER DELETE
  ON REG_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REG_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REGIONCLS
  AFTER INSERT
  ON REGIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REGIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REGIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,BUDGETTYPE
      ,ORGANIZATIONS
      ,KVB_EXPORT
      ,ORG_EXPORT
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.BUDGETTYPE
      , :new.ORGANIZATIONS
      , :new.KVB_EXPORT
      , :new.ORG_EXPORT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REGIONCLS
  AFTER UPDATE
  ON REGIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REGIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REGIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REGIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,BUDGETTYPE
      ,ORGANIZATIONS
      ,KVB_EXPORT
      ,ORG_EXPORT
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.BUDGETTYPE
      , :new.ORGANIZATIONS
      , :new.KVB_EXPORT
      , :new.ORG_EXPORT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_REGIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REGIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,BUDGETTYPE
      ,ORGANIZATIONS
      ,KVB_EXPORT
      ,ORG_EXPORT
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.BUDGETTYPE
      , :new.ORGANIZATIONS
      , :new.KVB_EXPORT
      , :new.ORG_EXPORT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REGIONCLS
  AFTER DELETE
  ON REGIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REGIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REGUSERS
  AFTER INSERT
  ON REGUSERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REGUSERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REGUSERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DBUSERNAME
      ,DATEBEGIN
      ,DATEEND
      ,NETUSERNAME
      ,NETCOMPNAME
      ,ASESSION
      ,PROCPID
      ,PROCNAME
      ,PROCVER
      ,NETIP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DBUSERNAME
      , :new.DATEBEGIN
      , :new.DATEEND
      , :new.NETUSERNAME
      , :new.NETCOMPNAME
      , :new.ASESSION
      , :new.PROCPID
      , :new.PROCNAME
      , :new.PROCVER
      , :new.NETIP
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REGUSERS
  AFTER UPDATE
  ON REGUSERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REGUSERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REGUSERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REGUSERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DBUSERNAME
      ,DATEBEGIN
      ,DATEEND
      ,NETUSERNAME
      ,NETCOMPNAME
      ,ASESSION
      ,PROCPID
      ,PROCNAME
      ,PROCVER
      ,NETIP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DBUSERNAME
      , :new.DATEBEGIN
      , :new.DATEEND
      , :new.NETUSERNAME
      , :new.NETCOMPNAME
      , :new.ASESSION
      , :new.PROCPID
      , :new.PROCNAME
      , :new.PROCVER
      , :new.NETIP
    );
  else 
    update A_REGUSERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REGUSERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DBUSERNAME
      ,DATEBEGIN
      ,DATEEND
      ,NETUSERNAME
      ,NETCOMPNAME
      ,ASESSION
      ,PROCPID
      ,PROCNAME
      ,PROCVER
      ,NETIP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DBUSERNAME
      , :new.DATEBEGIN
      , :new.DATEEND
      , :new.NETUSERNAME
      , :new.NETCOMPNAME
      , :new.ASESSION
      , :new.PROCPID
      , :new.PROCNAME
      , :new.PROCVER
      , :new.NETIP
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REGUSERS
  AFTER DELETE
  ON REGUSERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REGUSERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REJECTCLS
  AFTER INSERT
  ON REJECTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REJECTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REJECTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REJECTCLS
  AFTER UPDATE
  ON REJECTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REJECTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REJECTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REJECTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_REJECTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REJECTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REJECTCLS
  AFTER DELETE
  ON REJECTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REJECTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTECLIENT
  AFTER INSERT
  ON REMOTECLIENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTECLIENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTECLIENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLIENTID
      ,PASS
      ,ORGANIZATION
      ,CLIENTVERSION
      ,NOTE
      ,DATELASTSYNCHRO
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REMOTECLIENTTYPE
      ,USESIGN
      ,BLOCKLIST
      ,LINKSPEED
      ,CERTEXPIRATIONDAYS
      ,CERTOWNERNAMES
      ,BSID
      ,CRYPTOID
      ,PACKETBLOCKLIST
      ,ISEXECUTIONUSED
      ,USEDCOPIES
      ,ALLOWEDCOPIES
      ,CERTEXPIRATIONDATE
      ,OWNCOPIES
      ,TRANSFERTCOPIES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLIENTID
      , :new.PASS
      , :new.ORGANIZATION
      , :new.CLIENTVERSION
      , :new.NOTE
      , :new.DATELASTSYNCHRO
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REMOTECLIENTTYPE
      , :new.USESIGN
      , :new.BLOCKLIST
      , :new.LINKSPEED
      , :new.CERTEXPIRATIONDAYS
      , :new.CERTOWNERNAMES
      , :new.BSID
      , :new.CRYPTOID
      , :new.PACKETBLOCKLIST
      , :new.ISEXECUTIONUSED
      , :new.USEDCOPIES
      , :new.ALLOWEDCOPIES
      , :new.CERTEXPIRATIONDATE
      , :new.OWNCOPIES
      , :new.TRANSFERTCOPIES
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTECLIENT
  AFTER UPDATE
  ON REMOTECLIENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTECLIENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTECLIENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTECLIENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLIENTID
      ,PASS
      ,ORGANIZATION
      ,CLIENTVERSION
      ,NOTE
      ,DATELASTSYNCHRO
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REMOTECLIENTTYPE
      ,USESIGN
      ,BLOCKLIST
      ,LINKSPEED
      ,CERTEXPIRATIONDAYS
      ,CERTOWNERNAMES
      ,BSID
      ,CRYPTOID
      ,PACKETBLOCKLIST
      ,ISEXECUTIONUSED
      ,USEDCOPIES
      ,ALLOWEDCOPIES
      ,CERTEXPIRATIONDATE
      ,OWNCOPIES
      ,TRANSFERTCOPIES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLIENTID
      , :new.PASS
      , :new.ORGANIZATION
      , :new.CLIENTVERSION
      , :new.NOTE
      , :new.DATELASTSYNCHRO
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REMOTECLIENTTYPE
      , :new.USESIGN
      , :new.BLOCKLIST
      , :new.LINKSPEED
      , :new.CERTEXPIRATIONDAYS
      , :new.CERTOWNERNAMES
      , :new.BSID
      , :new.CRYPTOID
      , :new.PACKETBLOCKLIST
      , :new.ISEXECUTIONUSED
      , :new.USEDCOPIES
      , :new.ALLOWEDCOPIES
      , :new.CERTEXPIRATIONDATE
      , :new.OWNCOPIES
      , :new.TRANSFERTCOPIES
    );
  else 
    update A_REMOTECLIENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTECLIENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLIENTID
      ,PASS
      ,ORGANIZATION
      ,CLIENTVERSION
      ,NOTE
      ,DATELASTSYNCHRO
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REMOTECLIENTTYPE
      ,USESIGN
      ,BLOCKLIST
      ,LINKSPEED
      ,CERTEXPIRATIONDAYS
      ,CERTOWNERNAMES
      ,BSID
      ,CRYPTOID
      ,PACKETBLOCKLIST
      ,ISEXECUTIONUSED
      ,USEDCOPIES
      ,ALLOWEDCOPIES
      ,CERTEXPIRATIONDATE
      ,OWNCOPIES
      ,TRANSFERTCOPIES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLIENTID
      , :new.PASS
      , :new.ORGANIZATION
      , :new.CLIENTVERSION
      , :new.NOTE
      , :new.DATELASTSYNCHRO
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REMOTECLIENTTYPE
      , :new.USESIGN
      , :new.BLOCKLIST
      , :new.LINKSPEED
      , :new.CERTEXPIRATIONDAYS
      , :new.CERTOWNERNAMES
      , :new.BSID
      , :new.CRYPTOID
      , :new.PACKETBLOCKLIST
      , :new.ISEXECUTIONUSED
      , :new.USEDCOPIES
      , :new.ALLOWEDCOPIES
      , :new.CERTEXPIRATIONDATE
      , :new.OWNCOPIES
      , :new.TRANSFERTCOPIES
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTECLIENT
  AFTER DELETE
  ON REMOTECLIENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTECLIENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTECLIENTACCOUNT
  AFTER INSERT
  ON REMOTECLIENTACCOUNT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTECLIENTACCOUNT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTECLIENTACCOUNT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REMOTEDOCUMENT
      ,REMOTECLIENT
      ,DEFAULTACCOUNT
      ,ACCOUNT
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REMOTEDOCUMENT
      , :new.REMOTECLIENT
      , :new.DEFAULTACCOUNT
      , :new.ACCOUNT
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTECLIENTACCOUNT
  AFTER UPDATE
  ON REMOTECLIENTACCOUNT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTECLIENTACCOUNT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTECLIENTACCOUNT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTECLIENTACCOUNT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REMOTEDOCUMENT
      ,REMOTECLIENT
      ,DEFAULTACCOUNT
      ,ACCOUNT
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REMOTEDOCUMENT
      , :new.REMOTECLIENT
      , :new.DEFAULTACCOUNT
      , :new.ACCOUNT
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTECLIENTACCOUNT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTECLIENTACCOUNT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REMOTEDOCUMENT
      ,REMOTECLIENT
      ,DEFAULTACCOUNT
      ,ACCOUNT
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REMOTEDOCUMENT
      , :new.REMOTECLIENT
      , :new.DEFAULTACCOUNT
      , :new.ACCOUNT
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTECLIENTACCOUNT
  AFTER DELETE
  ON REMOTECLIENTACCOUNT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTECLIENTACCOUNT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTECLIENTTYPE
  AFTER INSERT
  ON REMOTECLIENTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTECLIENTTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTECLIENTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTECLIENTTYPE
  AFTER UPDATE
  ON REMOTECLIENTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTECLIENTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTECLIENTTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTECLIENTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTECLIENTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTECLIENTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTECLIENTTYPE
  AFTER DELETE
  ON REMOTECLIENTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTECLIENTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEDOCUMENT
  AFTER INSERT
  ON REMOTEDOCUMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEDOCUMENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEDOCUMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEDOCUMENT
  AFTER UPDATE
  ON REMOTEDOCUMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEDOCUMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEDOCUMENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEDOCUMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTEDOCUMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEDOCUMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEDOCUMENT
  AFTER DELETE
  ON REMOTEDOCUMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEDOCUMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEEDSRIGHT
  AFTER INSERT
  ON REMOTEEDSRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEEDSRIGHT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEEDSRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,RIGHTTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,FACIALACCCLSUP
      ,ARECURSIVE
      ,DATAPACKETTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.RIGHTTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.FACIALACCCLSUP
      , :new.ARECURSIVE
      , :new.DATAPACKETTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEEDSRIGHT
  AFTER UPDATE
  ON REMOTEEDSRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEEDSRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEEDSRIGHT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEEDSRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,RIGHTTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,FACIALACCCLSUP
      ,ARECURSIVE
      ,DATAPACKETTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.RIGHTTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.FACIALACCCLSUP
      , :new.ARECURSIVE
      , :new.DATAPACKETTYPE
    );
  else 
    update A_REMOTEEDSRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEEDSRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,RIGHTTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,FACIALACCCLSUP
      ,ARECURSIVE
      ,DATAPACKETTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.RIGHTTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.FACIALACCCLSUP
      , :new.ARECURSIVE
      , :new.DATAPACKETTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEEDSRIGHT
  AFTER DELETE
  ON REMOTEEDSRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEEDSRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEINPUTRIGHT
  AFTER INSERT
  ON REMOTEINPUTRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEINPUTRIGHT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEINPUTRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,REMOTEDOCUMENT
      ,EXCLUDE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.REMOTEDOCUMENT
      , :new.EXCLUDE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEINPUTRIGHT
  AFTER UPDATE
  ON REMOTEINPUTRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEINPUTRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEINPUTRIGHT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEINPUTRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,REMOTEDOCUMENT
      ,EXCLUDE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.REMOTEDOCUMENT
      , :new.EXCLUDE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTEINPUTRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEINPUTRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,REMOTEDOCUMENT
      ,EXCLUDE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.REMOTEDOCUMENT
      , :new.EXCLUDE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEINPUTRIGHT
  AFTER DELETE
  ON REMOTEINPUTRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEINPUTRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEMAILATTACHEDFILES
  AFTER INSERT
  ON REMOTEMAILATTACHEDFILES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEMAILATTACHEDFILES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEMAILATTACHEDFILES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ATTACHEDFILENAME
      ,MESSAGEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ATTACHEDFILENAME
      , :new.MESSAGEREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEMAILATTACHEDFILES
  AFTER UPDATE
  ON REMOTEMAILATTACHEDFILES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEMAILATTACHEDFILES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEMAILATTACHEDFILES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEMAILATTACHEDFILES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ATTACHEDFILENAME
      ,MESSAGEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ATTACHEDFILENAME
      , :new.MESSAGEREF
    );
  else 
    update A_REMOTEMAILATTACHEDFILES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEMAILATTACHEDFILES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ATTACHEDFILENAME
      ,MESSAGEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ATTACHEDFILENAME
      , :new.MESSAGEREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEMAILATTACHEDFILES
  AFTER DELETE
  ON REMOTEMAILATTACHEDFILES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEMAILATTACHEDFILES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEMAILCLIENTMESSAGES
  AFTER INSERT
  ON REMOTEMAILCLIENTMESSAGES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEMAILCLIENTMESSAGES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEMAILCLIENTMESSAGES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MESSAGEREF
      ,REMOTECLIENTREF
      ,SENTDATE
      ,RECEIVEDDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MESSAGEREF
      , :new.REMOTECLIENTREF
      , :new.SENTDATE
      , :new.RECEIVEDDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEMAILCLIENTMESSAGES
  AFTER UPDATE
  ON REMOTEMAILCLIENTMESSAGES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEMAILCLIENTMESSAGES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEMAILCLIENTMESSAGES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEMAILCLIENTMESSAGES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MESSAGEREF
      ,REMOTECLIENTREF
      ,SENTDATE
      ,RECEIVEDDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MESSAGEREF
      , :new.REMOTECLIENTREF
      , :new.SENTDATE
      , :new.RECEIVEDDATE
    );
  else 
    update A_REMOTEMAILCLIENTMESSAGES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEMAILCLIENTMESSAGES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MESSAGEREF
      ,REMOTECLIENTREF
      ,SENTDATE
      ,RECEIVEDDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MESSAGEREF
      , :new.REMOTECLIENTREF
      , :new.SENTDATE
      , :new.RECEIVEDDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEMAILCLIENTMESSAGES
  AFTER DELETE
  ON REMOTEMAILCLIENTMESSAGES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEMAILCLIENTMESSAGES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEMAILMESSAGES
  AFTER INSERT
  ON REMOTEMAILMESSAGES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEMAILMESSAGES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEMAILMESSAGES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUBJECT
      ,TEXTFILENAME
      ,REMINDER
      ,CREATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUBJECT
      , :new.TEXTFILENAME
      , :new.REMINDER
      , :new.CREATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEMAILMESSAGES
  AFTER UPDATE
  ON REMOTEMAILMESSAGES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEMAILMESSAGES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEMAILMESSAGES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEMAILMESSAGES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUBJECT
      ,TEXTFILENAME
      ,REMINDER
      ,CREATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUBJECT
      , :new.TEXTFILENAME
      , :new.REMINDER
      , :new.CREATEDATE
    );
  else 
    update A_REMOTEMAILMESSAGES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEMAILMESSAGES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUBJECT
      ,TEXTFILENAME
      ,REMINDER
      ,CREATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUBJECT
      , :new.TEXTFILENAME
      , :new.REMINDER
      , :new.CREATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEMAILMESSAGES
  AFTER DELETE
  ON REMOTEMAILMESSAGES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEMAILMESSAGES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTEREADRIGHT
  AFTER INSERT
  ON REMOTEREADRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEREADRIGHT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEREADRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,CLIENTID
      ,FACIALACCCLSUP
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.CLIENTID
      , :new.FACIALACCCLSUP
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTEREADRIGHT
  AFTER UPDATE
  ON REMOTEREADRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTEREADRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTEREADRIGHT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTEREADRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,CLIENTID
      ,FACIALACCCLSUP
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.CLIENTID
      , :new.FACIALACCCLSUP
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTEREADRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTEREADRIGHT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,FACIALACCCLS
      ,REMOTECLIENT
      ,CLIENTID
      ,FACIALACCCLSUP
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.FACIALACCCLS
      , :new.REMOTECLIENT
      , :new.CLIENTID
      , :new.FACIALACCCLSUP
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTEREADRIGHT
  AFTER DELETE
  ON REMOTEREADRIGHT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTEREADRIGHT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTETASKMANAGER
  AFTER INSERT
  ON REMOTETASKMANAGER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKMANAGER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKMANAGER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKENABLE
      ,TASKDATE
      ,TASKTIME
      ,ISGROUP
      ,REMOTECLIENT
      ,REMOTEGROUP
      ,REMOTETASKREGIME
      ,DAYOFWEEK
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKENABLE
      , :new.TASKDATE
      , :new.TASKTIME
      , :new.ISGROUP
      , :new.REMOTECLIENT
      , :new.REMOTEGROUP
      , :new.REMOTETASKREGIME
      , :new.DAYOFWEEK
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTETASKMANAGER
  AFTER UPDATE
  ON REMOTETASKMANAGER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTETASKMANAGER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTETASKMANAGER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKMANAGER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKENABLE
      ,TASKDATE
      ,TASKTIME
      ,ISGROUP
      ,REMOTECLIENT
      ,REMOTEGROUP
      ,REMOTETASKREGIME
      ,DAYOFWEEK
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKENABLE
      , :new.TASKDATE
      , :new.TASKTIME
      , :new.ISGROUP
      , :new.REMOTECLIENT
      , :new.REMOTEGROUP
      , :new.REMOTETASKREGIME
      , :new.DAYOFWEEK
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTETASKMANAGER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTETASKMANAGER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TASKENABLE
      ,TASKDATE
      ,TASKTIME
      ,ISGROUP
      ,REMOTECLIENT
      ,REMOTEGROUP
      ,REMOTETASKREGIME
      ,DAYOFWEEK
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TASKENABLE
      , :new.TASKDATE
      , :new.TASKTIME
      , :new.ISGROUP
      , :new.REMOTECLIENT
      , :new.REMOTEGROUP
      , :new.REMOTETASKREGIME
      , :new.DAYOFWEEK
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTETASKMANAGER
  AFTER DELETE
  ON REMOTETASKMANAGER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKMANAGER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTETASKMANAGERDETAIL
  AFTER INSERT
  ON REMOTETASKMANAGERDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKMANAGERDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKMANAGERDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REMOTETASKMANAGER
      ,REMOTETASKTYPE
      ,DOCTYPES
      ,ORDERBY
      ,PATH
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REMOTETASKMANAGER
      , :new.REMOTETASKTYPE
      , :new.DOCTYPES
      , :new.ORDERBY
      , :new.PATH
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTETASKMANAGERDETAIL
  AFTER UPDATE
  ON REMOTETASKMANAGERDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTETASKMANAGERDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTETASKMANAGERDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKMANAGERDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REMOTETASKMANAGER
      ,REMOTETASKTYPE
      ,DOCTYPES
      ,ORDERBY
      ,PATH
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REMOTETASKMANAGER
      , :new.REMOTETASKTYPE
      , :new.DOCTYPES
      , :new.ORDERBY
      , :new.PATH
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_REMOTETASKMANAGERDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTETASKMANAGERDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REMOTETASKMANAGER
      ,REMOTETASKTYPE
      ,DOCTYPES
      ,ORDERBY
      ,PATH
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REMOTETASKMANAGER
      , :new.REMOTETASKTYPE
      , :new.DOCTYPES
      , :new.ORDERBY
      , :new.PATH
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTETASKMANAGERDETAIL
  AFTER DELETE
  ON REMOTETASKMANAGERDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKMANAGERDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTETASKREGIME
  AFTER INSERT
  ON REMOTETASKREGIME
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKREGIME
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKREGIME (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTETASKREGIME
  AFTER UPDATE
  ON REMOTETASKREGIME
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTETASKREGIME
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTETASKREGIME
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKREGIME (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_REMOTETASKREGIME
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTETASKREGIME (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTETASKREGIME
  AFTER DELETE
  ON REMOTETASKREGIME
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKREGIME
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REMOTETASKTYPE
  AFTER INSERT
  ON REMOTETASKTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REMOTETASKTYPE
  AFTER UPDATE
  ON REMOTETASKTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REMOTETASKTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REMOTETASKTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REMOTETASKTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_REMOTETASKTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REMOTETASKTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REMOTETASKTYPE
  AFTER DELETE
  ON REMOTETASKTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REMOTETASKTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REPLACEMENTCLSCAPTION
  AFTER INSERT
  ON REPLACEMENTCLSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPLACEMENTCLSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPLACEMENTCLSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,INPUTDATE
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACCEPTDATE
      ,REJECT_CLS
      ,REJECT_CAUSE
      ,PZKUSER
      ,PZKSTARTDATE
      ,PZKENDDATE
      ,CLASSORIGINALDOC
      ,NUMBERRECORDS
      ,DOCSTATEREF
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.INPUTDATE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACCEPTDATE
      , :new.REJECT_CLS
      , :new.REJECT_CAUSE
      , :new.PZKUSER
      , :new.PZKSTARTDATE
      , :new.PZKENDDATE
      , :new.CLASSORIGINALDOC
      , :new.NUMBERRECORDS
      , :new.DOCSTATEREF
      , :new.BUDGETREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REPLACEMENTCLSCAPTION
  AFTER UPDATE
  ON REPLACEMENTCLSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REPLACEMENTCLSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REPLACEMENTCLSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPLACEMENTCLSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,INPUTDATE
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACCEPTDATE
      ,REJECT_CLS
      ,REJECT_CAUSE
      ,PZKUSER
      ,PZKSTARTDATE
      ,PZKENDDATE
      ,CLASSORIGINALDOC
      ,NUMBERRECORDS
      ,DOCSTATEREF
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.INPUTDATE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACCEPTDATE
      , :new.REJECT_CLS
      , :new.REJECT_CAUSE
      , :new.PZKUSER
      , :new.PZKSTARTDATE
      , :new.PZKENDDATE
      , :new.CLASSORIGINALDOC
      , :new.NUMBERRECORDS
      , :new.DOCSTATEREF
      , :new.BUDGETREF
    );
  else 
    update A_REPLACEMENTCLSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REPLACEMENTCLSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,INPUTDATE
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ACCEPTDATE
      ,REJECT_CLS
      ,REJECT_CAUSE
      ,PZKUSER
      ,PZKSTARTDATE
      ,PZKENDDATE
      ,CLASSORIGINALDOC
      ,NUMBERRECORDS
      ,DOCSTATEREF
      ,BUDGETREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.INPUTDATE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ACCEPTDATE
      , :new.REJECT_CLS
      , :new.REJECT_CAUSE
      , :new.PZKUSER
      , :new.PZKSTARTDATE
      , :new.PZKENDDATE
      , :new.CLASSORIGINALDOC
      , :new.NUMBERRECORDS
      , :new.DOCSTATEREF
      , :new.BUDGETREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REPLACEMENTCLSCAPTION
  AFTER DELETE
  ON REPLACEMENTCLSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPLACEMENTCLSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REPLACEMENTCLSDETAIL
  AFTER INSERT
  ON REPLACEMENTCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPLACEMENTCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPLACEMENTCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LINKID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LINKID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REPLACEMENTCLSDETAIL
  AFTER UPDATE
  ON REPLACEMENTCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REPLACEMENTCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REPLACEMENTCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPLACEMENTCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LINKID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LINKID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
    );
  else 
    update A_REPLACEMENTCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REPLACEMENTCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LINKID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LINKID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REPLACEMENTCLSDETAIL
  AFTER DELETE
  ON REPLACEMENTCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPLACEMENTCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REPLACEMENTCLSDETAILINFO
  AFTER INSERT
  ON REPLACEMENTCLSDETAILINFO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPLACEMENTCLSDETAILINFO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPLACEMENTCLSDETAILINFO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,REGIONCLS
      ,CLSTYPE
      ,PROGINDEX
      ,PARENTID
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FINTYPE
      ,FACIALACC_CLS
      ,KD
      ,IFS
      ,FINSOURCE
      ,TRANSFERTCLS
      ,DOCBASE
      ,ASSIGNMENTKIND
      ,VARIANT
      ,REESTRNUMBER
      ,BUDGETREF
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.REGIONCLS
      , :new.CLSTYPE
      , :new.PROGINDEX
      , :new.PARENTID
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FINTYPE
      , :new.FACIALACC_CLS
      , :new.KD
      , :new.IFS
      , :new.FINSOURCE
      , :new.TRANSFERTCLS
      , :new.DOCBASE
      , :new.ASSIGNMENTKIND
      , :new.VARIANT
      , :new.REESTRNUMBER
      , :new.BUDGETREF
      , :new.INVESTOBJECT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REPLACEMENTCLSDETAILINFO
  AFTER UPDATE
  ON REPLACEMENTCLSDETAILINFO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REPLACEMENTCLSDETAILINFO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REPLACEMENTCLSDETAILINFO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPLACEMENTCLSDETAILINFO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,REGIONCLS
      ,CLSTYPE
      ,PROGINDEX
      ,PARENTID
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FINTYPE
      ,FACIALACC_CLS
      ,KD
      ,IFS
      ,FINSOURCE
      ,TRANSFERTCLS
      ,DOCBASE
      ,ASSIGNMENTKIND
      ,VARIANT
      ,REESTRNUMBER
      ,BUDGETREF
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.REGIONCLS
      , :new.CLSTYPE
      , :new.PROGINDEX
      , :new.PARENTID
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FINTYPE
      , :new.FACIALACC_CLS
      , :new.KD
      , :new.IFS
      , :new.FINSOURCE
      , :new.TRANSFERTCLS
      , :new.DOCBASE
      , :new.ASSIGNMENTKIND
      , :new.VARIANT
      , :new.REESTRNUMBER
      , :new.BUDGETREF
      , :new.INVESTOBJECT
    );
  else 
    update A_REPLACEMENTCLSDETAILINFO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REPLACEMENTCLSDETAILINFO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,REGIONCLS
      ,CLSTYPE
      ,PROGINDEX
      ,PARENTID
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FINTYPE
      ,FACIALACC_CLS
      ,KD
      ,IFS
      ,FINSOURCE
      ,TRANSFERTCLS
      ,DOCBASE
      ,ASSIGNMENTKIND
      ,VARIANT
      ,REESTRNUMBER
      ,BUDGETREF
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.REGIONCLS
      , :new.CLSTYPE
      , :new.PROGINDEX
      , :new.PARENTID
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FINTYPE
      , :new.FACIALACC_CLS
      , :new.KD
      , :new.IFS
      , :new.FINSOURCE
      , :new.TRANSFERTCLS
      , :new.DOCBASE
      , :new.ASSIGNMENTKIND
      , :new.VARIANT
      , :new.REESTRNUMBER
      , :new.BUDGETREF
      , :new.INVESTOBJECT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REPLACEMENTCLSDETAILINFO
  AFTER DELETE
  ON REPLACEMENTCLSDETAILINFO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPLACEMENTCLSDETAILINFO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REPORTSPERMISSIONS
  AFTER INSERT
  ON REPORTSPERMISSIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPORTSPERMISSIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPORTSPERMISSIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REPORTID
      ,USERID
      ,PERMISSIONSTR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REPORTID
      , :new.USERID
      , :new.PERMISSIONSTR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REPORTSPERMISSIONS
  AFTER UPDATE
  ON REPORTSPERMISSIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REPORTSPERMISSIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REPORTSPERMISSIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPORTSPERMISSIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REPORTID
      ,USERID
      ,PERMISSIONSTR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REPORTID
      , :new.USERID
      , :new.PERMISSIONSTR
    );
  else 
    update A_REPORTSPERMISSIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REPORTSPERMISSIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REPORTID
      ,USERID
      ,PERMISSIONSTR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REPORTID
      , :new.USERID
      , :new.PERMISSIONSTR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REPORTSPERMISSIONS
  AFTER DELETE
  ON REPORTSPERMISSIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPORTSPERMISSIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REPORTTESTERCONTROL
  AFTER INSERT
  ON REPORTTESTERCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPORTTESTERCONTROL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPORTTESTERCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REPORTTESTERCONTROL
  AFTER UPDATE
  ON REPORTTESTERCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REPORTTESTERCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REPORTTESTERCONTROL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPORTTESTERCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
    );
  else 
    update A_REPORTTESTERCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REPORTTESTERCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REPORTTESTERCONTROL
  AFTER DELETE
  ON REPORTTESTERCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPORTTESTERCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REPORTTYPE
  AFTER INSERT
  ON REPORTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPORTTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPORTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REPORTTYPE
  AFTER UPDATE
  ON REPORTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REPORTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REPORTTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REPORTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_REPORTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REPORTTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REPORTTYPE
  AFTER DELETE
  ON REPORTTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REPORTTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_REQUESTFINCAPTION
  AFTER INSERT
  ON REQUESTFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REQUESTFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REQUESTFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ANUMBER
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,SUMMA
      ,STATE
      ,RVERSION
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ANUMBER
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.SUMMA
      , :new.STATE
      , :new.RVERSION
      , :new.AMONTH
      , :new.AYEAR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_REQUESTFINCAPTION
  AFTER UPDATE
  ON REQUESTFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_REQUESTFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_REQUESTFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_REQUESTFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ANUMBER
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,SUMMA
      ,STATE
      ,RVERSION
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ANUMBER
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.SUMMA
      , :new.STATE
      , :new.RVERSION
      , :new.AMONTH
      , :new.AYEAR
    );
  else 
    update A_REQUESTFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_REQUESTFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ANUMBER
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,SUMMA
      ,STATE
      ,RVERSION
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ANUMBER
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.SUMMA
      , :new.STATE
      , :new.RVERSION
      , :new.AMONTH
      , :new.AYEAR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_REQUESTFINCAPTION
  AFTER DELETE
  ON REQUESTFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_REQUESTFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_RESERVEFUNDS
  AFTER INSERT
  ON RESERVEFUNDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RESERVEFUNDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RESERVEFUNDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MANAGERFACIALACCCLS
      ,KFSR
      ,GROUPITEM
      ,TYPEFUNDSOPERATION
      ,RESERVEDATE
      ,SUMMA
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MANAGERFACIALACCCLS
      , :new.KFSR
      , :new.GROUPITEM
      , :new.TYPEFUNDSOPERATION
      , :new.RESERVEDATE
      , :new.SUMMA
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_RESERVEFUNDS
  AFTER UPDATE
  ON RESERVEFUNDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_RESERVEFUNDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_RESERVEFUNDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RESERVEFUNDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MANAGERFACIALACCCLS
      ,KFSR
      ,GROUPITEM
      ,TYPEFUNDSOPERATION
      ,RESERVEDATE
      ,SUMMA
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MANAGERFACIALACCCLS
      , :new.KFSR
      , :new.GROUPITEM
      , :new.TYPEFUNDSOPERATION
      , :new.RESERVEDATE
      , :new.SUMMA
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NOTE
    );
  else 
    update A_RESERVEFUNDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_RESERVEFUNDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MANAGERFACIALACCCLS
      ,KFSR
      ,GROUPITEM
      ,TYPEFUNDSOPERATION
      ,RESERVEDATE
      ,SUMMA
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MANAGERFACIALACCCLS
      , :new.KFSR
      , :new.GROUPITEM
      , :new.TYPEFUNDSOPERATION
      , :new.RESERVEDATE
      , :new.SUMMA
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_RESERVEFUNDS
  AFTER DELETE
  ON RESERVEFUNDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RESERVEFUNDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_RIGHTKIND
  AFTER INSERT
  ON RIGHTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RIGHTKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RIGHTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_RIGHTKIND
  AFTER UPDATE
  ON RIGHTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_RIGHTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_RIGHTKIND
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RIGHTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_RIGHTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_RIGHTKIND (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_RIGHTKIND
  AFTER DELETE
  ON RIGHTKIND
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RIGHTKIND
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_RPS_DOCUMENT_JOURNAL
  AFTER INSERT
  ON RPS_DOCUMENT_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RPS_DOCUMENT_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RPS_DOCUMENT_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTDATE
      ,PACKETSIZE
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTDATE
      , :new.PACKETSIZE
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_RPS_DOCUMENT_JOURNAL
  AFTER UPDATE
  ON RPS_DOCUMENT_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_RPS_DOCUMENT_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_RPS_DOCUMENT_JOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_RPS_DOCUMENT_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTDATE
      ,PACKETSIZE
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTDATE
      , :new.PACKETSIZE
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  else 
    update A_RPS_DOCUMENT_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_RPS_DOCUMENT_JOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCUMENTDATE
      ,PACKETSIZE
      ,CREATEDATE
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCUMENTDATE
      , :new.PACKETSIZE
      , :new.CREATEDATE
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_RPS_DOCUMENT_JOURNAL
  AFTER DELETE
  ON RPS_DOCUMENT_JOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_RPS_DOCUMENT_JOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SCENARIO
  AFTER INSERT
  ON SCENARIO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SCENARIO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SCENARIO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GENERATION
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,OPTIONSPATH
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GENERATION
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.OPTIONSPATH
      , :new.ISBUDGET
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SCENARIO
  AFTER UPDATE
  ON SCENARIO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SCENARIO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SCENARIO
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SCENARIO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GENERATION
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,OPTIONSPATH
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GENERATION
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.OPTIONSPATH
      , :new.ISBUDGET
    );
  else 
    update A_SCENARIO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SCENARIO (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GENERATION
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,OPTIONSPATH
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GENERATION
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.OPTIONSPATH
      , :new.ISBUDGET
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SCENARIO
  AFTER DELETE
  ON SCENARIO
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SCENARIO
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SCHEMEBUHCACH
  AFTER INSERT
  ON SCHEMEBUHCACH
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SCHEMEBUHCACH
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SCHEMEBUHCACH (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DAT
      ,DEBET
      ,CREDIT
      ,REGIONCLS
      ,SUMMA
      ,ACCREF1
      ,ACCREF2
      ,FILTERINDEX
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DAT
      , :new.DEBET
      , :new.CREDIT
      , :new.REGIONCLS
      , :new.SUMMA
      , :new.ACCREF1
      , :new.ACCREF2
      , :new.FILTERINDEX
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SCHEMEBUHCACH
  AFTER UPDATE
  ON SCHEMEBUHCACH
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SCHEMEBUHCACH
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SCHEMEBUHCACH
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SCHEMEBUHCACH (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DAT
      ,DEBET
      ,CREDIT
      ,REGIONCLS
      ,SUMMA
      ,ACCREF1
      ,ACCREF2
      ,FILTERINDEX
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DAT
      , :new.DEBET
      , :new.CREDIT
      , :new.REGIONCLS
      , :new.SUMMA
      , :new.ACCREF1
      , :new.ACCREF2
      , :new.FILTERINDEX
      , :new.NOTE
    );
  else 
    update A_SCHEMEBUHCACH
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SCHEMEBUHCACH (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DAT
      ,DEBET
      ,CREDIT
      ,REGIONCLS
      ,SUMMA
      ,ACCREF1
      ,ACCREF2
      ,FILTERINDEX
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DAT
      , :new.DEBET
      , :new.CREDIT
      , :new.REGIONCLS
      , :new.SUMMA
      , :new.ACCREF1
      , :new.ACCREF2
      , :new.FILTERINDEX
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SCHEMEBUHCACH
  AFTER DELETE
  ON SCHEMEBUHCACH
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SCHEMEBUHCACH
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SELECTIONEVENTS
  AFTER INSERT
  ON SELECTIONEVENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SELECTIONEVENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SELECTIONEVENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,EVENTCODE
      ,SELECTIONREF
      ,SCRIPTNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.EVENTCODE
      , :new.SELECTIONREF
      , :new.SCRIPTNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SELECTIONEVENTS
  AFTER UPDATE
  ON SELECTIONEVENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SELECTIONEVENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SELECTIONEVENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SELECTIONEVENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,EVENTCODE
      ,SELECTIONREF
      ,SCRIPTNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.EVENTCODE
      , :new.SELECTIONREF
      , :new.SCRIPTNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_SELECTIONEVENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SELECTIONEVENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,EVENTCODE
      ,SELECTIONREF
      ,SCRIPTNAME
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.EVENTCODE
      , :new.SELECTIONREF
      , :new.SCRIPTNAME
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SELECTIONEVENTS
  AFTER DELETE
  ON SELECTIONEVENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SELECTIONEVENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SELECTIONS
  AFTER INSERT
  ON SELECTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SELECTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SELECTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KIND
      ,NAME
      ,NOTE
      ,READONLY
      ,USEINDOC
      ,TABLENAME
      ,ALIAS
      ,TABLECODE
      ,NEEDGROUPONDB
      ,NEEDDISTINCT
      ,MASTER
      ,DISCRIMVALUE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,AVAILABLEINDEREF
      ,CACHETYPE
      ,FULLORMODINSREFRTIME
      ,DELETEREFRTIME
      ,FINDTIMEREFRESH
      ,ANNOTATION
      ,DEREFNAME
      ,GROUPID
      ,ISLOGGED
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KIND
      , :new.NAME
      , :new.NOTE
      , :new.READONLY
      , :new.USEINDOC
      , :new.TABLENAME
      , :new.ALIAS
      , :new.TABLECODE
      , :new.NEEDGROUPONDB
      , :new.NEEDDISTINCT
      , :new.MASTER
      , :new.DISCRIMVALUE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.AVAILABLEINDEREF
      , :new.CACHETYPE
      , :new.FULLORMODINSREFRTIME
      , :new.DELETEREFRTIME
      , :new.FINDTIMEREFRESH
      , :new.ANNOTATION
      , :new.DEREFNAME
      , :new.GROUPID
      , :new.ISLOGGED
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SELECTIONS
  AFTER UPDATE
  ON SELECTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SELECTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SELECTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SELECTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KIND
      ,NAME
      ,NOTE
      ,READONLY
      ,USEINDOC
      ,TABLENAME
      ,ALIAS
      ,TABLECODE
      ,NEEDGROUPONDB
      ,NEEDDISTINCT
      ,MASTER
      ,DISCRIMVALUE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,AVAILABLEINDEREF
      ,CACHETYPE
      ,FULLORMODINSREFRTIME
      ,DELETEREFRTIME
      ,FINDTIMEREFRESH
      ,ANNOTATION
      ,DEREFNAME
      ,GROUPID
      ,ISLOGGED
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KIND
      , :new.NAME
      , :new.NOTE
      , :new.READONLY
      , :new.USEINDOC
      , :new.TABLENAME
      , :new.ALIAS
      , :new.TABLECODE
      , :new.NEEDGROUPONDB
      , :new.NEEDDISTINCT
      , :new.MASTER
      , :new.DISCRIMVALUE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.AVAILABLEINDEREF
      , :new.CACHETYPE
      , :new.FULLORMODINSREFRTIME
      , :new.DELETEREFRTIME
      , :new.FINDTIMEREFRESH
      , :new.ANNOTATION
      , :new.DEREFNAME
      , :new.GROUPID
      , :new.ISLOGGED
    );
  else 
    update A_SELECTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SELECTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KIND
      ,NAME
      ,NOTE
      ,READONLY
      ,USEINDOC
      ,TABLENAME
      ,ALIAS
      ,TABLECODE
      ,NEEDGROUPONDB
      ,NEEDDISTINCT
      ,MASTER
      ,DISCRIMVALUE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,AVAILABLEINDEREF
      ,CACHETYPE
      ,FULLORMODINSREFRTIME
      ,DELETEREFRTIME
      ,FINDTIMEREFRESH
      ,ANNOTATION
      ,DEREFNAME
      ,GROUPID
      ,ISLOGGED
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KIND
      , :new.NAME
      , :new.NOTE
      , :new.READONLY
      , :new.USEINDOC
      , :new.TABLENAME
      , :new.ALIAS
      , :new.TABLECODE
      , :new.NEEDGROUPONDB
      , :new.NEEDDISTINCT
      , :new.MASTER
      , :new.DISCRIMVALUE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.AVAILABLEINDEREF
      , :new.CACHETYPE
      , :new.FULLORMODINSREFRTIME
      , :new.DELETEREFRTIME
      , :new.FINDTIMEREFRESH
      , :new.ANNOTATION
      , :new.DEREFNAME
      , :new.GROUPID
      , :new.ISLOGGED
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SELECTIONS
  AFTER DELETE
  ON SELECTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SELECTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SELECTIONSDETAIL
  AFTER INSERT
  ON SELECTIONSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SELECTIONSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SELECTIONSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SELECTIONREF
      ,TABLEREF
      ,ALIAS
      ,JOINORDER
      ,JOINTYPE
      ,RELATIONTYPE
      ,JOINCONDITION
      ,DONTUSETABLELIMITS
      ,ADDCONDITION
      ,LIMITNAMESLIST
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,QUERYGROUP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SELECTIONREF
      , :new.TABLEREF
      , :new.ALIAS
      , :new.JOINORDER
      , :new.JOINTYPE
      , :new.RELATIONTYPE
      , :new.JOINCONDITION
      , :new.DONTUSETABLELIMITS
      , :new.ADDCONDITION
      , :new.LIMITNAMESLIST
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.QUERYGROUP
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SELECTIONSDETAIL
  AFTER UPDATE
  ON SELECTIONSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SELECTIONSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SELECTIONSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SELECTIONSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SELECTIONREF
      ,TABLEREF
      ,ALIAS
      ,JOINORDER
      ,JOINTYPE
      ,RELATIONTYPE
      ,JOINCONDITION
      ,DONTUSETABLELIMITS
      ,ADDCONDITION
      ,LIMITNAMESLIST
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,QUERYGROUP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SELECTIONREF
      , :new.TABLEREF
      , :new.ALIAS
      , :new.JOINORDER
      , :new.JOINTYPE
      , :new.RELATIONTYPE
      , :new.JOINCONDITION
      , :new.DONTUSETABLELIMITS
      , :new.ADDCONDITION
      , :new.LIMITNAMESLIST
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.QUERYGROUP
    );
  else 
    update A_SELECTIONSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SELECTIONSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SELECTIONREF
      ,TABLEREF
      ,ALIAS
      ,JOINORDER
      ,JOINTYPE
      ,RELATIONTYPE
      ,JOINCONDITION
      ,DONTUSETABLELIMITS
      ,ADDCONDITION
      ,LIMITNAMESLIST
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,QUERYGROUP
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SELECTIONREF
      , :new.TABLEREF
      , :new.ALIAS
      , :new.JOINORDER
      , :new.JOINTYPE
      , :new.RELATIONTYPE
      , :new.JOINCONDITION
      , :new.DONTUSETABLELIMITS
      , :new.ADDCONDITION
      , :new.LIMITNAMESLIST
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.QUERYGROUP
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SELECTIONSDETAIL
  AFTER DELETE
  ON SELECTIONSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SELECTIONSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNCERTIFICATE
  AFTER INSERT
  ON SIGNCERTIFICATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNCERTIFICATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNCERTIFICATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SERIALNUMBER
      ,ISENABLED
      ,STARTDATE
      ,ENDDATE
      ,OWNER
      ,OWNERORGANIZATION
      ,NOTE
      ,USERREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,OWNERTITLE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SERIALNUMBER
      , :new.ISENABLED
      , :new.STARTDATE
      , :new.ENDDATE
      , :new.OWNER
      , :new.OWNERORGANIZATION
      , :new.NOTE
      , :new.USERREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.OWNERTITLE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNCERTIFICATE
  AFTER UPDATE
  ON SIGNCERTIFICATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNCERTIFICATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNCERTIFICATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNCERTIFICATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SERIALNUMBER
      ,ISENABLED
      ,STARTDATE
      ,ENDDATE
      ,OWNER
      ,OWNERORGANIZATION
      ,NOTE
      ,USERREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,OWNERTITLE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SERIALNUMBER
      , :new.ISENABLED
      , :new.STARTDATE
      , :new.ENDDATE
      , :new.OWNER
      , :new.OWNERORGANIZATION
      , :new.NOTE
      , :new.USERREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.OWNERTITLE
    );
  else 
    update A_SIGNCERTIFICATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNCERTIFICATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SERIALNUMBER
      ,ISENABLED
      ,STARTDATE
      ,ENDDATE
      ,OWNER
      ,OWNERORGANIZATION
      ,NOTE
      ,USERREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,OWNERTITLE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SERIALNUMBER
      , :new.ISENABLED
      , :new.STARTDATE
      , :new.ENDDATE
      , :new.OWNER
      , :new.OWNERORGANIZATION
      , :new.NOTE
      , :new.USERREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.OWNERTITLE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNCERTIFICATE
  AFTER DELETE
  ON SIGNCERTIFICATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNCERTIFICATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNDOCUMENTSGROUP
  AFTER INSERT
  ON SIGNDOCUMENTSGROUP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNDOCUMENTSGROUP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNDOCUMENTSGROUP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CLIENTREF
      ,SCHEMAREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CLIENTREF
      , :new.SCHEMAREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNDOCUMENTSGROUP
  AFTER UPDATE
  ON SIGNDOCUMENTSGROUP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNDOCUMENTSGROUP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNDOCUMENTSGROUP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNDOCUMENTSGROUP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CLIENTREF
      ,SCHEMAREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CLIENTREF
      , :new.SCHEMAREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_SIGNDOCUMENTSGROUP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNDOCUMENTSGROUP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,CLIENTREF
      ,SCHEMAREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.CLIENTREF
      , :new.SCHEMAREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNDOCUMENTSGROUP
  AFTER DELETE
  ON SIGNDOCUMENTSGROUP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNDOCUMENTSGROUP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNDOCUMENTSGROUPDETAIL
  AFTER INSERT
  ON SIGNDOCUMENTSGROUPDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNDOCUMENTSGROUPDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNDOCUMENTSGROUPDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCSTATE
      ,FACIALACCCLS
      ,FACIALACCCLSUP
      ,RECORDINDEX
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCSTATE
      , :new.FACIALACCCLS
      , :new.FACIALACCCLSUP
      , :new.RECORDINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNDOCUMENTSGROUPDETAIL
  AFTER UPDATE
  ON SIGNDOCUMENTSGROUPDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNDOCUMENTSGROUPDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNDOCUMENTSGROUPDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNDOCUMENTSGROUPDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCSTATE
      ,FACIALACCCLS
      ,FACIALACCCLSUP
      ,RECORDINDEX
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCSTATE
      , :new.FACIALACCCLS
      , :new.FACIALACCCLSUP
      , :new.RECORDINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_SIGNDOCUMENTSGROUPDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNDOCUMENTSGROUPDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCSTATE
      ,FACIALACCCLS
      ,FACIALACCCLSUP
      ,RECORDINDEX
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCSTATE
      , :new.FACIALACCCLS
      , :new.FACIALACCCLSUP
      , :new.RECORDINDEX
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNDOCUMENTSGROUPDETAIL
  AFTER DELETE
  ON SIGNDOCUMENTSGROUPDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNDOCUMENTSGROUPDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNLOG
  AFTER INSERT
  ON SIGNLOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNLOG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNLOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,EDS_REF
      ,SIGNREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATERINFO
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SIGNID
      ,SIGNDATE
      ,DOCTYPE
      ,STATEHISTORYREF
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.EDS_REF
      , :new.SIGNREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATERINFO
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SIGNID
      , :new.SIGNDATE
      , :new.DOCTYPE
      , :new.STATEHISTORYREF
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNLOG
  AFTER UPDATE
  ON SIGNLOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNLOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNLOG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNLOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,EDS_REF
      ,SIGNREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATERINFO
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SIGNID
      ,SIGNDATE
      ,DOCTYPE
      ,STATEHISTORYREF
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.EDS_REF
      , :new.SIGNREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATERINFO
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SIGNID
      , :new.SIGNDATE
      , :new.DOCTYPE
      , :new.STATEHISTORYREF
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_SIGNLOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNLOG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,EDS_REF
      ,SIGNREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATERINFO
      ,FACIALACCCLS
      ,SENDERID
      ,SENDERRECORDID
      ,SIGNID
      ,SIGNDATE
      ,DOCTYPE
      ,STATEHISTORYREF
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.EDS_REF
      , :new.SIGNREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATERINFO
      , :new.FACIALACCCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SIGNID
      , :new.SIGNDATE
      , :new.DOCTYPE
      , :new.STATEHISTORYREF
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNLOG
  AFTER DELETE
  ON SIGNLOG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNLOG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNPARAMS
  AFTER INSERT
  ON SIGNPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNPARAMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,SIGNREF
      ,ISSTEPEND
      ,ISSIGNEND
      ,SIGNMASK
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.SIGNREF
      , :new.ISSTEPEND
      , :new.ISSIGNEND
      , :new.SIGNMASK
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNPARAMS
  AFTER UPDATE
  ON SIGNPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNPARAMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,SIGNREF
      ,ISSTEPEND
      ,ISSIGNEND
      ,SIGNMASK
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.SIGNREF
      , :new.ISSTEPEND
      , :new.ISSIGNEND
      , :new.SIGNMASK
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_SIGNPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNPARAMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,SIGNREF
      ,ISSTEPEND
      ,ISSIGNEND
      ,SIGNMASK
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.SIGNREF
      , :new.ISSTEPEND
      , :new.ISSIGNEND
      , :new.SIGNMASK
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNPARAMS
  AFTER DELETE
  ON SIGNPARAMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNPARAMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNPROFILE
  AFTER INSERT
  ON SIGNPROFILE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNPROFILE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNPROFILE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SIGNREF
      ,SIGNDOCUMENTSGROUPREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SIGNREF
      , :new.SIGNDOCUMENTSGROUPREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNPROFILE
  AFTER UPDATE
  ON SIGNPROFILE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNPROFILE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNPROFILE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNPROFILE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SIGNREF
      ,SIGNDOCUMENTSGROUPREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SIGNREF
      , :new.SIGNDOCUMENTSGROUPREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_SIGNPROFILE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNPROFILE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SIGNREF
      ,SIGNDOCUMENTSGROUPREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SIGNREF
      , :new.SIGNDOCUMENTSGROUPREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNPROFILE
  AFTER DELETE
  ON SIGNPROFILE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNPROFILE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNPROFILEDETAIL
  AFTER INSERT
  ON SIGNPROFILEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNPROFILEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNPROFILEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CERTIFICATEREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CERTIFICATEREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNPROFILEDETAIL
  AFTER UPDATE
  ON SIGNPROFILEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNPROFILEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNPROFILEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNPROFILEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CERTIFICATEREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CERTIFICATEREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_SIGNPROFILEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNPROFILEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CERTIFICATEREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CERTIFICATEREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNPROFILEDETAIL
  AFTER DELETE
  ON SIGNPROFILEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNPROFILEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNS
  AFTER INSERT
  ON SIGNS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNS
  AFTER UPDATE
  ON SIGNS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
      , :new.NOTE
    );
  else 
    update A_SIGNS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNS
  AFTER DELETE
  ON SIGNS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SIGNSCHEMECAPTION
  AFTER INSERT
  ON SIGNSCHEMECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNSCHEMECAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNSCHEMECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,DOCTYPEREF
      ,CLOSEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.DOCTYPEREF
      , :new.CLOSEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SIGNSCHEMECAPTION
  AFTER UPDATE
  ON SIGNSCHEMECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SIGNSCHEMECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SIGNSCHEMECAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SIGNSCHEMECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,DOCTYPEREF
      ,CLOSEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.DOCTYPEREF
      , :new.CLOSEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
    );
  else 
    update A_SIGNSCHEMECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SIGNSCHEMECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,DOCTYPEREF
      ,CLOSEDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.DOCTYPEREF
      , :new.CLOSEDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SIGNSCHEMECAPTION
  AFTER DELETE
  ON SIGNSCHEMECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SIGNSCHEMECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SINGLE
  AFTER INSERT
  ON SINGLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SINGLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SINGLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SINGLE
  AFTER UPDATE
  ON SINGLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SINGLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SINGLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SINGLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
    );
  else 
    update A_SINGLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SINGLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SINGLE
  AFTER DELETE
  ON SINGLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SINGLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SQLEXCEPTIONS
  AFTER INSERT
  ON SQLEXCEPTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SQLEXCEPTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SQLEXCEPTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,TEXT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.TEXT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SQLEXCEPTIONS
  AFTER UPDATE
  ON SQLEXCEPTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SQLEXCEPTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SQLEXCEPTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SQLEXCEPTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,TEXT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.TEXT
    );
  else 
    update A_SQLEXCEPTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SQLEXCEPTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,TEXT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.TEXT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SQLEXCEPTIONS
  AFTER DELETE
  ON SQLEXCEPTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SQLEXCEPTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_ACTIONJUMPS
  AFTER INSERT
  ON STATE_ACTIONJUMPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_ACTIONJUMPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_ACTIONJUMPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACTIONREF
      ,JUMPREF
      ,FILTERCODE
      ,OPTIONS
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACTIONREF
      , :new.JUMPREF
      , :new.FILTERCODE
      , :new.OPTIONS
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_ACTIONJUMPS
  AFTER UPDATE
  ON STATE_ACTIONJUMPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_ACTIONJUMPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_ACTIONJUMPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_ACTIONJUMPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACTIONREF
      ,JUMPREF
      ,FILTERCODE
      ,OPTIONS
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACTIONREF
      , :new.JUMPREF
      , :new.FILTERCODE
      , :new.OPTIONS
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_STATE_ACTIONJUMPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_ACTIONJUMPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACTIONREF
      ,JUMPREF
      ,FILTERCODE
      ,OPTIONS
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACTIONREF
      , :new.JUMPREF
      , :new.FILTERCODE
      , :new.OPTIONS
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_ACTIONJUMPS
  AFTER DELETE
  ON STATE_ACTIONJUMPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_ACTIONJUMPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_CASCADEACTIONS
  AFTER INSERT
  ON STATE_CASCADEACTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_CASCADEACTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_CASCADEACTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEJUMPREF
      ,MASTERFIELDNAME
      ,ENABLED
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESTACTIONNAME
      ,DESTDOCTYPEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEJUMPREF
      , :new.MASTERFIELDNAME
      , :new.ENABLED
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESTACTIONNAME
      , :new.DESTDOCTYPEREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_CASCADEACTIONS
  AFTER UPDATE
  ON STATE_CASCADEACTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_CASCADEACTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_CASCADEACTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_CASCADEACTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEJUMPREF
      ,MASTERFIELDNAME
      ,ENABLED
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESTACTIONNAME
      ,DESTDOCTYPEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEJUMPREF
      , :new.MASTERFIELDNAME
      , :new.ENABLED
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESTACTIONNAME
      , :new.DESTDOCTYPEREF
    );
  else 
    update A_STATE_CASCADEACTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_CASCADEACTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEJUMPREF
      ,MASTERFIELDNAME
      ,ENABLED
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESTACTIONNAME
      ,DESTDOCTYPEREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEJUMPREF
      , :new.MASTERFIELDNAME
      , :new.ENABLED
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESTACTIONNAME
      , :new.DESTDOCTYPEREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_CASCADEACTIONS
  AFTER DELETE
  ON STATE_CASCADEACTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_CASCADEACTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_DOCSTATES
  AFTER INSERT
  ON STATE_DOCSTATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_DOCSTATES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_DOCSTATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,DOCTYPEREF
      ,STATETYPEREF
      ,ICONNAME
      ,STATENUMBER
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATEORDER
      ,CONTROLLEVEL
      ,COMMON_STATENAME
      ,ISACTIVE
      ,ISSYSTEM
      ,POSX
      ,POSY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.DOCTYPEREF
      , :new.STATETYPEREF
      , :new.ICONNAME
      , :new.STATENUMBER
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATEORDER
      , :new.CONTROLLEVEL
      , :new.COMMON_STATENAME
      , :new.ISACTIVE
      , :new.ISSYSTEM
      , :new.POSX
      , :new.POSY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_DOCSTATES
  AFTER UPDATE
  ON STATE_DOCSTATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_DOCSTATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_DOCSTATES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_DOCSTATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,DOCTYPEREF
      ,STATETYPEREF
      ,ICONNAME
      ,STATENUMBER
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATEORDER
      ,CONTROLLEVEL
      ,COMMON_STATENAME
      ,ISACTIVE
      ,ISSYSTEM
      ,POSX
      ,POSY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.DOCTYPEREF
      , :new.STATETYPEREF
      , :new.ICONNAME
      , :new.STATENUMBER
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATEORDER
      , :new.CONTROLLEVEL
      , :new.COMMON_STATENAME
      , :new.ISACTIVE
      , :new.ISSYSTEM
      , :new.POSX
      , :new.POSY
    );
  else 
    update A_STATE_DOCSTATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_DOCSTATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,DOCTYPEREF
      ,STATETYPEREF
      ,ICONNAME
      ,STATENUMBER
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATEORDER
      ,CONTROLLEVEL
      ,COMMON_STATENAME
      ,ISACTIVE
      ,ISSYSTEM
      ,POSX
      ,POSY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.DOCTYPEREF
      , :new.STATETYPEREF
      , :new.ICONNAME
      , :new.STATENUMBER
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATEORDER
      , :new.CONTROLLEVEL
      , :new.COMMON_STATENAME
      , :new.ISACTIVE
      , :new.ISSYSTEM
      , :new.POSX
      , :new.POSY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_DOCSTATES
  AFTER DELETE
  ON STATE_DOCSTATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_DOCSTATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_FILTER
  AFTER INSERT
  ON STATE_FILTER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_FILTER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_FILTER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,FILTERVALUE
      ,FILTERFORMAT
      ,FILTERACTIVE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ISBUDGET
      ,FILTERVALUEURM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.FILTERVALUE
      , :new.FILTERFORMAT
      , :new.FILTERACTIVE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ISBUDGET
      , :new.FILTERVALUEURM
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_FILTER
  AFTER UPDATE
  ON STATE_FILTER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_FILTER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_FILTER
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_FILTER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,FILTERVALUE
      ,FILTERFORMAT
      ,FILTERACTIVE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ISBUDGET
      ,FILTERVALUEURM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.FILTERVALUE
      , :new.FILTERFORMAT
      , :new.FILTERACTIVE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ISBUDGET
      , :new.FILTERVALUEURM
    );
  else 
    update A_STATE_FILTER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_FILTER (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,FILTERVALUE
      ,FILTERFORMAT
      ,FILTERACTIVE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ISBUDGET
      ,FILTERVALUEURM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.FILTERVALUE
      , :new.FILTERFORMAT
      , :new.FILTERACTIVE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ISBUDGET
      , :new.FILTERVALUEURM
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_FILTER
  AFTER DELETE
  ON STATE_FILTER
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_FILTER
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_JUMPCONTROL
  AFTER INSERT
  ON STATE_JUMPCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_JUMPCONTROL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_JUMPCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,JUMPREF
      ,CONTROLCODE
      ,CONTROLOPTIONS
      ,CONDITION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDTYPE
      ,EXECTYPE
      ,EXECORDER
      ,ENABLED
      ,ACTIONREF
      ,FILTERCODE
      ,FILTERNOTE
      ,ENDSTATEREF
      ,REFERENCEREF
      ,STATICLINKREF
      ,BEGINSTATEREF
      ,SCENARIOREF
      ,ELEMENTSCENARIOREF
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.JUMPREF
      , :new.CONTROLCODE
      , :new.CONTROLOPTIONS
      , :new.CONDITION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDTYPE
      , :new.EXECTYPE
      , :new.EXECORDER
      , :new.ENABLED
      , :new.ACTIONREF
      , :new.FILTERCODE
      , :new.FILTERNOTE
      , :new.ENDSTATEREF
      , :new.REFERENCEREF
      , :new.STATICLINKREF
      , :new.BEGINSTATEREF
      , :new.SCENARIOREF
      , :new.ELEMENTSCENARIOREF
      , :new.ISBUDGET
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_JUMPCONTROL
  AFTER UPDATE
  ON STATE_JUMPCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_JUMPCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_JUMPCONTROL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_JUMPCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,JUMPREF
      ,CONTROLCODE
      ,CONTROLOPTIONS
      ,CONDITION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDTYPE
      ,EXECTYPE
      ,EXECORDER
      ,ENABLED
      ,ACTIONREF
      ,FILTERCODE
      ,FILTERNOTE
      ,ENDSTATEREF
      ,REFERENCEREF
      ,STATICLINKREF
      ,BEGINSTATEREF
      ,SCENARIOREF
      ,ELEMENTSCENARIOREF
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.JUMPREF
      , :new.CONTROLCODE
      , :new.CONTROLOPTIONS
      , :new.CONDITION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDTYPE
      , :new.EXECTYPE
      , :new.EXECORDER
      , :new.ENABLED
      , :new.ACTIONREF
      , :new.FILTERCODE
      , :new.FILTERNOTE
      , :new.ENDSTATEREF
      , :new.REFERENCEREF
      , :new.STATICLINKREF
      , :new.BEGINSTATEREF
      , :new.SCENARIOREF
      , :new.ELEMENTSCENARIOREF
      , :new.ISBUDGET
    );
  else 
    update A_STATE_JUMPCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_JUMPCONTROL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,JUMPREF
      ,CONTROLCODE
      ,CONTROLOPTIONS
      ,CONDITION
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDTYPE
      ,EXECTYPE
      ,EXECORDER
      ,ENABLED
      ,ACTIONREF
      ,FILTERCODE
      ,FILTERNOTE
      ,ENDSTATEREF
      ,REFERENCEREF
      ,STATICLINKREF
      ,BEGINSTATEREF
      ,SCENARIOREF
      ,ELEMENTSCENARIOREF
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.JUMPREF
      , :new.CONTROLCODE
      , :new.CONTROLOPTIONS
      , :new.CONDITION
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDTYPE
      , :new.EXECTYPE
      , :new.EXECORDER
      , :new.ENABLED
      , :new.ACTIONREF
      , :new.FILTERCODE
      , :new.FILTERNOTE
      , :new.ENDSTATEREF
      , :new.REFERENCEREF
      , :new.STATICLINKREF
      , :new.BEGINSTATEREF
      , :new.SCENARIOREF
      , :new.ELEMENTSCENARIOREF
      , :new.ISBUDGET
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_JUMPCONTROL
  AFTER DELETE
  ON STATE_JUMPCONTROL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_JUMPCONTROL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_JUMPS
  AFTER INSERT
  ON STATE_JUMPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_JUMPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_JUMPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,BEGINSTATEREF
      ,ENDSTATEREF
      ,DOCTYPEREF
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NEEDEDS
      ,BACKJUMP
      ,NEEDCHECKEDS
      ,CONTROLLIST
      ,DOCSEVENT
      ,DOCSLIST
      ,OPTIONSPATH
      ,CANATTACHFILES
      ,CANDETACTHFILES
      ,CANREJECTATTACHEDFILES
      ,ISACTIVE
      ,SIGNATTACHEDFILES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.BEGINSTATEREF
      , :new.ENDSTATEREF
      , :new.DOCTYPEREF
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NEEDEDS
      , :new.BACKJUMP
      , :new.NEEDCHECKEDS
      , :new.CONTROLLIST
      , :new.DOCSEVENT
      , :new.DOCSLIST
      , :new.OPTIONSPATH
      , :new.CANATTACHFILES
      , :new.CANDETACTHFILES
      , :new.CANREJECTATTACHEDFILES
      , :new.ISACTIVE
      , :new.SIGNATTACHEDFILES
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_JUMPS
  AFTER UPDATE
  ON STATE_JUMPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_JUMPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_JUMPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_JUMPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,BEGINSTATEREF
      ,ENDSTATEREF
      ,DOCTYPEREF
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NEEDEDS
      ,BACKJUMP
      ,NEEDCHECKEDS
      ,CONTROLLIST
      ,DOCSEVENT
      ,DOCSLIST
      ,OPTIONSPATH
      ,CANATTACHFILES
      ,CANDETACTHFILES
      ,CANREJECTATTACHEDFILES
      ,ISACTIVE
      ,SIGNATTACHEDFILES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.BEGINSTATEREF
      , :new.ENDSTATEREF
      , :new.DOCTYPEREF
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NEEDEDS
      , :new.BACKJUMP
      , :new.NEEDCHECKEDS
      , :new.CONTROLLIST
      , :new.DOCSEVENT
      , :new.DOCSLIST
      , :new.OPTIONSPATH
      , :new.CANATTACHFILES
      , :new.CANDETACTHFILES
      , :new.CANREJECTATTACHEDFILES
      , :new.ISACTIVE
      , :new.SIGNATTACHEDFILES
    );
  else 
    update A_STATE_JUMPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_JUMPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,NOTE
      ,BEGINSTATEREF
      ,ENDSTATEREF
      ,DOCTYPEREF
      ,UPDATERUSER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NEEDEDS
      ,BACKJUMP
      ,NEEDCHECKEDS
      ,CONTROLLIST
      ,DOCSEVENT
      ,DOCSLIST
      ,OPTIONSPATH
      ,CANATTACHFILES
      ,CANDETACTHFILES
      ,CANREJECTATTACHEDFILES
      ,ISACTIVE
      ,SIGNATTACHEDFILES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.NOTE
      , :new.BEGINSTATEREF
      , :new.ENDSTATEREF
      , :new.DOCTYPEREF
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NEEDEDS
      , :new.BACKJUMP
      , :new.NEEDCHECKEDS
      , :new.CONTROLLIST
      , :new.DOCSEVENT
      , :new.DOCSLIST
      , :new.OPTIONSPATH
      , :new.CANATTACHFILES
      , :new.CANDETACTHFILES
      , :new.CANREJECTATTACHEDFILES
      , :new.ISACTIVE
      , :new.SIGNATTACHEDFILES
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_JUMPS
  AFTER DELETE
  ON STATE_JUMPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_JUMPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_OPENFIELDS
  AFTER INSERT
  ON STATE_OPENFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_OPENFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_OPENFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCFIELDREF
      ,JUMPREF
      ,UPDATEDATE
      ,CREATEDATE
      ,UPDATERUSER
      ,CREATERUSER
      ,NONUSEREDIT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCFIELDREF
      , :new.JUMPREF
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.NONUSEREDIT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_OPENFIELDS
  AFTER UPDATE
  ON STATE_OPENFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_OPENFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_OPENFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_OPENFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCFIELDREF
      ,JUMPREF
      ,UPDATEDATE
      ,CREATEDATE
      ,UPDATERUSER
      ,CREATERUSER
      ,NONUSEREDIT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCFIELDREF
      , :new.JUMPREF
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.NONUSEREDIT
    );
  else 
    update A_STATE_OPENFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_OPENFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCFIELDREF
      ,JUMPREF
      ,UPDATEDATE
      ,CREATEDATE
      ,UPDATERUSER
      ,CREATERUSER
      ,NONUSEREDIT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCFIELDREF
      , :new.JUMPREF
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
      , :new.NONUSEREDIT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_OPENFIELDS
  AFTER DELETE
  ON STATE_OPENFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_OPENFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATE_TYPES
  AFTER INSERT
  ON STATE_TYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_TYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_TYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATE_TYPES
  AFTER UPDATE
  ON STATE_TYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATE_TYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATE_TYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATE_TYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  else 
    update A_STATE_TYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATE_TYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATE_TYPES
  AFTER DELETE
  ON STATE_TYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATE_TYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATEJUMPHISTORY
  AFTER INSERT
  ON STATEJUMPHISTORY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATEJUMPHISTORY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATEJUMPHISTORY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,BEGINSTATEREF
      ,ENDSTATEREF
      ,CREATERUSER
      ,CREATEDATE
      ,BACKJUMP
      ,EDSREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.BEGINSTATEREF
      , :new.ENDSTATEREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.BACKJUMP
      , :new.EDSREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATEJUMPHISTORY
  AFTER UPDATE
  ON STATEJUMPHISTORY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATEJUMPHISTORY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATEJUMPHISTORY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATEJUMPHISTORY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,BEGINSTATEREF
      ,ENDSTATEREF
      ,CREATERUSER
      ,CREATEDATE
      ,BACKJUMP
      ,EDSREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.BEGINSTATEREF
      , :new.ENDSTATEREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.BACKJUMP
      , :new.EDSREF
    );
  else 
    update A_STATEJUMPHISTORY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATEJUMPHISTORY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCID
      ,BEGINSTATEREF
      ,ENDSTATEREF
      ,CREATERUSER
      ,CREATEDATE
      ,BACKJUMP
      ,EDSREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCID
      , :new.BEGINSTATEREF
      , :new.ENDSTATEREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.BACKJUMP
      , :new.EDSREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATEJUMPHISTORY
  AFTER DELETE
  ON STATEJUMPHISTORY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATEJUMPHISTORY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STATUSICONS
  AFTER INSERT
  ON STATUSICONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATUSICONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATUSICONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,DOCREF
      ,DOCPARAM
      ,DETAILNUM
      ,ICONNAME
      ,ISSYSTEM
      ,ICONPOS
      ,RUNPOS
      ,RESERVEPOS
      ,ICONHINT
      ,ICONKIND
      ,LOCKMASK
      ,FORMULA
      ,ISBUDGET
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.DOCREF
      , :new.DOCPARAM
      , :new.DETAILNUM
      , :new.ICONNAME
      , :new.ISSYSTEM
      , :new.ICONPOS
      , :new.RUNPOS
      , :new.RESERVEPOS
      , :new.ICONHINT
      , :new.ICONKIND
      , :new.LOCKMASK
      , :new.FORMULA
      , :new.ISBUDGET
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STATUSICONS
  AFTER UPDATE
  ON STATUSICONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STATUSICONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STATUSICONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STATUSICONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,DOCREF
      ,DOCPARAM
      ,DETAILNUM
      ,ICONNAME
      ,ISSYSTEM
      ,ICONPOS
      ,RUNPOS
      ,RESERVEPOS
      ,ICONHINT
      ,ICONKIND
      ,LOCKMASK
      ,FORMULA
      ,ISBUDGET
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.DOCREF
      , :new.DOCPARAM
      , :new.DETAILNUM
      , :new.ICONNAME
      , :new.ISSYSTEM
      , :new.ICONPOS
      , :new.RUNPOS
      , :new.RESERVEPOS
      , :new.ICONHINT
      , :new.ICONKIND
      , :new.LOCKMASK
      , :new.FORMULA
      , :new.ISBUDGET
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_STATUSICONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STATUSICONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,DOCREF
      ,DOCPARAM
      ,DETAILNUM
      ,ICONNAME
      ,ISSYSTEM
      ,ICONPOS
      ,RUNPOS
      ,RESERVEPOS
      ,ICONHINT
      ,ICONKIND
      ,LOCKMASK
      ,FORMULA
      ,ISBUDGET
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.DOCREF
      , :new.DOCPARAM
      , :new.DETAILNUM
      , :new.ICONNAME
      , :new.ISSYSTEM
      , :new.ICONPOS
      , :new.RUNPOS
      , :new.RESERVEPOS
      , :new.ICONHINT
      , :new.ICONKIND
      , :new.LOCKMASK
      , :new.FORMULA
      , :new.ISBUDGET
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STATUSICONS
  AFTER DELETE
  ON STATUSICONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STATUSICONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STOREDATTRIBUTESCAPTION
  AFTER INSERT
  ON STOREDATTRIBUTESCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STOREDATTRIBUTESCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STOREDATTRIBUTESCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCREF
      ,DOCPARAM
      ,DATEOPEN
      ,DATECLOSE
      ,ISACTIVE
      ,PREVVERSIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCREF
      , :new.DOCPARAM
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.ISACTIVE
      , :new.PREVVERSIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STOREDATTRIBUTESCAPTION
  AFTER UPDATE
  ON STOREDATTRIBUTESCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STOREDATTRIBUTESCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STOREDATTRIBUTESCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STOREDATTRIBUTESCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCREF
      ,DOCPARAM
      ,DATEOPEN
      ,DATECLOSE
      ,ISACTIVE
      ,PREVVERSIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCREF
      , :new.DOCPARAM
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.ISACTIVE
      , :new.PREVVERSIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
    );
  else 
    update A_STOREDATTRIBUTESCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STOREDATTRIBUTESCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCREF
      ,DOCPARAM
      ,DATEOPEN
      ,DATECLOSE
      ,ISACTIVE
      ,PREVVERSIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,ISBUDGET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCREF
      , :new.DOCPARAM
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.ISACTIVE
      , :new.PREVVERSIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.ISBUDGET
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STOREDATTRIBUTESCAPTION
  AFTER DELETE
  ON STOREDATTRIBUTESCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STOREDATTRIBUTESCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_STOREDATTRIBUTESDETAIL
  AFTER INSERT
  ON STOREDATTRIBUTESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STOREDATTRIBUTESDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STOREDATTRIBUTESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CONTAINER_REF
      ,ATTRIBUTE_REF
      ,FIELDTYPE
      ,FIELDSIZE
      ,NAME
      ,SOURCEFIELD
      ,FIELDORDER
      ,FORMULA
      ,READONLY
      ,PREVVERSIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,RECORDINDEX
      ,CALCMETHOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CONTAINER_REF
      , :new.ATTRIBUTE_REF
      , :new.FIELDTYPE
      , :new.FIELDSIZE
      , :new.NAME
      , :new.SOURCEFIELD
      , :new.FIELDORDER
      , :new.FORMULA
      , :new.READONLY
      , :new.PREVVERSIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.CALCMETHOD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_STOREDATTRIBUTESDETAIL
  AFTER UPDATE
  ON STOREDATTRIBUTESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_STOREDATTRIBUTESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_STOREDATTRIBUTESDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_STOREDATTRIBUTESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CONTAINER_REF
      ,ATTRIBUTE_REF
      ,FIELDTYPE
      ,FIELDSIZE
      ,NAME
      ,SOURCEFIELD
      ,FIELDORDER
      ,FORMULA
      ,READONLY
      ,PREVVERSIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,RECORDINDEX
      ,CALCMETHOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CONTAINER_REF
      , :new.ATTRIBUTE_REF
      , :new.FIELDTYPE
      , :new.FIELDSIZE
      , :new.NAME
      , :new.SOURCEFIELD
      , :new.FIELDORDER
      , :new.FORMULA
      , :new.READONLY
      , :new.PREVVERSIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.CALCMETHOD
    );
  else 
    update A_STOREDATTRIBUTESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_STOREDATTRIBUTESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CONTAINER_REF
      ,ATTRIBUTE_REF
      ,FIELDTYPE
      ,FIELDSIZE
      ,NAME
      ,SOURCEFIELD
      ,FIELDORDER
      ,FORMULA
      ,READONLY
      ,PREVVERSIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,RECORDINDEX
      ,CALCMETHOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CONTAINER_REF
      , :new.ATTRIBUTE_REF
      , :new.FIELDTYPE
      , :new.FIELDSIZE
      , :new.NAME
      , :new.SOURCEFIELD
      , :new.FIELDORDER
      , :new.FORMULA
      , :new.READONLY
      , :new.PREVVERSIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.CALCMETHOD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_STOREDATTRIBUTESDETAIL
  AFTER DELETE
  ON STOREDATTRIBUTESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_STOREDATTRIBUTESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SUBKCSR
  AFTER INSERT
  ON SUBKCSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUBKCSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUBKCSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SUBKCSR
  AFTER UPDATE
  ON SUBKCSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SUBKCSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SUBKCSR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUBKCSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_SUBKCSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SUBKCSR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SUBKCSR
  AFTER DELETE
  ON SUBKCSR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUBKCSR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SUBKD
  AFTER INSERT
  ON SUBKD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUBKD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUBKD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,BUHACCOUNT
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.BUHACCOUNT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SUBKD
  AFTER UPDATE
  ON SUBKD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SUBKD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SUBKD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUBKD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,BUHACCOUNT
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.BUHACCOUNT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  else 
    update A_SUBKD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SUBKD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,BUHACCOUNT
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.BUHACCOUNT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SUBKD
  AFTER DELETE
  ON SUBKD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUBKD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SUBSIDYCLS
  AFTER INSERT
  ON SUBSIDYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUBSIDYCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUBSIDYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,ORG_REF
      ,SUBSIDYKIND
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,BELONGINGKIND
      ,SUBSIDYYEAR
      ,DOCUMENTCLS
      ,DOCBASE
      ,NPAGROUP
      ,NPANAME
      ,NPADATE
      ,NPANUMBER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.ORG_REF
      , :new.SUBSIDYKIND
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.BELONGINGKIND
      , :new.SUBSIDYYEAR
      , :new.DOCUMENTCLS
      , :new.DOCBASE
      , :new.NPAGROUP
      , :new.NPANAME
      , :new.NPADATE
      , :new.NPANUMBER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SUBSIDYCLS
  AFTER UPDATE
  ON SUBSIDYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SUBSIDYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SUBSIDYCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUBSIDYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,ORG_REF
      ,SUBSIDYKIND
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,BELONGINGKIND
      ,SUBSIDYYEAR
      ,DOCUMENTCLS
      ,DOCBASE
      ,NPAGROUP
      ,NPANAME
      ,NPADATE
      ,NPANUMBER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.ORG_REF
      , :new.SUBSIDYKIND
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.BELONGINGKIND
      , :new.SUBSIDYYEAR
      , :new.DOCUMENTCLS
      , :new.DOCBASE
      , :new.NPAGROUP
      , :new.NPANAME
      , :new.NPADATE
      , :new.NPANUMBER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_SUBSIDYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SUBSIDYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE
      ,NAME
      ,ORG_REF
      ,SUBSIDYKIND
      ,BUDGETREF
      ,STARTDATE
      ,DELETEDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,BELONGINGKIND
      ,SUBSIDYYEAR
      ,DOCUMENTCLS
      ,DOCBASE
      ,NPAGROUP
      ,NPANAME
      ,NPADATE
      ,NPANUMBER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE
      , :new.NAME
      , :new.ORG_REF
      , :new.SUBSIDYKIND
      , :new.BUDGETREF
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.BELONGINGKIND
      , :new.SUBSIDYYEAR
      , :new.DOCUMENTCLS
      , :new.DOCBASE
      , :new.NPAGROUP
      , :new.NPANAME
      , :new.NPADATE
      , :new.NPANUMBER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SUBSIDYCLS
  AFTER DELETE
  ON SUBSIDYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUBSIDYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SUMINPASSAGE
  AFTER INSERT
  ON SUMINPASSAGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUMINPASSAGE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUMINPASSAGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ODATE
      ,BUHACCOUNT
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUHOPERATIONCLS
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ODATE
      , :new.BUHACCOUNT
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUHOPERATIONCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SUMINPASSAGE
  AFTER UPDATE
  ON SUMINPASSAGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SUMINPASSAGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SUMINPASSAGE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUMINPASSAGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ODATE
      ,BUHACCOUNT
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUHOPERATIONCLS
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ODATE
      , :new.BUHACCOUNT
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUHOPERATIONCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
    );
  else 
    update A_SUMINPASSAGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SUMINPASSAGE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ODATE
      ,BUHACCOUNT
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUHOPERATIONCLS
      ,SENDERID
      ,SENDERRECORDID
      ,CREATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ODATE
      , :new.BUHACCOUNT
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUHOPERATIONCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SUMINPASSAGE
  AFTER DELETE
  ON SUMINPASSAGE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUMINPASSAGE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_SUPDOCTYPECLS
  AFTER INSERT
  ON SUPDOCTYPECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUPDOCTYPECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUPDOCTYPECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,YARDSTICKREF
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.YARDSTICKREF
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_SUPDOCTYPECLS
  AFTER UPDATE
  ON SUPDOCTYPECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_SUPDOCTYPECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_SUPDOCTYPECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_SUPDOCTYPECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,YARDSTICKREF
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.YARDSTICKREF
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
    );
  else 
    update A_SUPDOCTYPECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_SUPDOCTYPECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,YARDSTICKREF
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.YARDSTICKREF
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_SUPDOCTYPECLS
  AFTER DELETE
  ON SUPDOCTYPECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_SUPDOCTYPECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TARGETCLS
  AFTER INSERT
  ON TARGETCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TARGETCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TARGETCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,STRCODE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STRCODE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TARGETCLS
  AFTER UPDATE
  ON TARGETCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TARGETCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TARGETCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TARGETCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,STRCODE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STRCODE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_TARGETCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TARGETCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,STRCODE
      ,NAME
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STRCODE
      , :new.NAME
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TARGETCLS
  AFTER DELETE
  ON TARGETCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TARGETCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_AGREEMENTS
  AFTER INSERT
  ON TB_AGREEMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_AGREEMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_AGREEMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUMMA
      ,AGREEMENTDATE
      ,AGREEMENTENDDATE
      ,EXECUTER_REF
      ,CLIENT_REF
      ,FACIALACC_CLS
      ,AGREEMENTTYPE
      ,ACCEPTED
      ,ACCEPTDATE
      ,CARDADVANCEPERCENT
      ,CARDADVANCE
      ,CLOSEDOC
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,LASTADJUSTMENT
      ,LASTACCEPTED
      ,FACT
      ,REGION
      ,CLOSEDATE
      ,DELIVERYRULES
      ,AGREEMENTSUMMA
      ,AGREEMENTFINSUMMA
      ,ADJUSTMENTREF
      ,REESTRNUMBER
      ,PAYMENTDATE
      ,AGREEMENTCARDADVANCE
      ,FINCARDADVANCE
      ,STATEORDERREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,AGREEMENTBEGINDATE
      ,PROTOCOLNUMBER
      ,PROTOCOLDATE
      ,REVIEWNOTE
      ,DOCSTATEREF
      ,RVERSION
      ,EXPORTDATE
      ,FSORGAN
      ,FSBUDGETNAME
      ,FSOFFBUDGET
      ,RNYEAR
      ,RNNUMBER
      ,RNDATE
      ,PROTOCOLNOTICE
      ,PROTOCOLRESULTDATE
      ,PROTOCOLDOCTYPE
      ,PROTOCOLSALETYPE
      ,NOTIFYDATE
      ,EXECUTERACCREF
      ,DOCBASEDATE
      ,DOCBASENOTIFYDATE
      ,DOCBASETEXT
      ,DOCBASETYPE
      ,DOCBASESUMMA
      ,UNKNOWNAMOUNT
      ,PROTOCOLREASON
      ,DOCNUMBER
      ,ADJUSTMENTDOCNUMBER
      ,OLDDOCNUMBER
      ,LOTMAXSUM
      ,CLIENT_INN
      ,CLIENT_INN20
      ,CLIENT_NAME
      ,EXECUTER_INN
      ,EXECUTER_INN20
      ,EXECUTER_NAME
      ,EXECUTER_STATUS
      ,EXECUTER_COUNTRY
      ,EXECUTER_ADDRESS
      ,EXECUTER_PHONE
      ,REALID
      ,ADJUSTMENTNUMBER
      ,INNERNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,REESTRVERSION
      ,DOCTYPE
      ,RNCLIENTID
      ,INFONUMBER
      ,STATEORDERINNERNUMBER
      ,PROGINDEX
      ,NOTE
      ,PURPORTDOC
      ,REESTRRECORDNUMBER
      ,EXECUTERSTOREDPROPS
      ,AUTOSANCTION
      ,PURCHASECODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUMMA
      , :new.AGREEMENTDATE
      , :new.AGREEMENTENDDATE
      , :new.EXECUTER_REF
      , :new.CLIENT_REF
      , :new.FACIALACC_CLS
      , :new.AGREEMENTTYPE
      , :new.ACCEPTED
      , :new.ACCEPTDATE
      , :new.CARDADVANCEPERCENT
      , :new.CARDADVANCE
      , :new.CLOSEDOC
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.LASTADJUSTMENT
      , :new.LASTACCEPTED
      , :new.FACT
      , :new.REGION
      , :new.CLOSEDATE
      , :new.DELIVERYRULES
      , :new.AGREEMENTSUMMA
      , :new.AGREEMENTFINSUMMA
      , :new.ADJUSTMENTREF
      , :new.REESTRNUMBER
      , :new.PAYMENTDATE
      , :new.AGREEMENTCARDADVANCE
      , :new.FINCARDADVANCE
      , :new.STATEORDERREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.AGREEMENTBEGINDATE
      , :new.PROTOCOLNUMBER
      , :new.PROTOCOLDATE
      , :new.REVIEWNOTE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.EXPORTDATE
      , :new.FSORGAN
      , :new.FSBUDGETNAME
      , :new.FSOFFBUDGET
      , :new.RNYEAR
      , :new.RNNUMBER
      , :new.RNDATE
      , :new.PROTOCOLNOTICE
      , :new.PROTOCOLRESULTDATE
      , :new.PROTOCOLDOCTYPE
      , :new.PROTOCOLSALETYPE
      , :new.NOTIFYDATE
      , :new.EXECUTERACCREF
      , :new.DOCBASEDATE
      , :new.DOCBASENOTIFYDATE
      , :new.DOCBASETEXT
      , :new.DOCBASETYPE
      , :new.DOCBASESUMMA
      , :new.UNKNOWNAMOUNT
      , :new.PROTOCOLREASON
      , :new.DOCNUMBER
      , :new.ADJUSTMENTDOCNUMBER
      , :new.OLDDOCNUMBER
      , :new.LOTMAXSUM
      , :new.CLIENT_INN
      , :new.CLIENT_INN20
      , :new.CLIENT_NAME
      , :new.EXECUTER_INN
      , :new.EXECUTER_INN20
      , :new.EXECUTER_NAME
      , :new.EXECUTER_STATUS
      , :new.EXECUTER_COUNTRY
      , :new.EXECUTER_ADDRESS
      , :new.EXECUTER_PHONE
      , :new.REALID
      , :new.ADJUSTMENTNUMBER
      , :new.INNERNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.REESTRVERSION
      , :new.DOCTYPE
      , :new.RNCLIENTID
      , :new.INFONUMBER
      , :new.STATEORDERINNERNUMBER
      , :new.PROGINDEX
      , :new.NOTE
      , :new.PURPORTDOC
      , :new.REESTRRECORDNUMBER
      , :new.EXECUTERSTOREDPROPS
      , :new.AUTOSANCTION
      , :new.PURCHASECODE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_AGREEMENTS
  AFTER UPDATE
  ON TB_AGREEMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_AGREEMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_AGREEMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_AGREEMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUMMA
      ,AGREEMENTDATE
      ,AGREEMENTENDDATE
      ,EXECUTER_REF
      ,CLIENT_REF
      ,FACIALACC_CLS
      ,AGREEMENTTYPE
      ,ACCEPTED
      ,ACCEPTDATE
      ,CARDADVANCEPERCENT
      ,CARDADVANCE
      ,CLOSEDOC
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,LASTADJUSTMENT
      ,LASTACCEPTED
      ,FACT
      ,REGION
      ,CLOSEDATE
      ,DELIVERYRULES
      ,AGREEMENTSUMMA
      ,AGREEMENTFINSUMMA
      ,ADJUSTMENTREF
      ,REESTRNUMBER
      ,PAYMENTDATE
      ,AGREEMENTCARDADVANCE
      ,FINCARDADVANCE
      ,STATEORDERREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,AGREEMENTBEGINDATE
      ,PROTOCOLNUMBER
      ,PROTOCOLDATE
      ,REVIEWNOTE
      ,DOCSTATEREF
      ,RVERSION
      ,EXPORTDATE
      ,FSORGAN
      ,FSBUDGETNAME
      ,FSOFFBUDGET
      ,RNYEAR
      ,RNNUMBER
      ,RNDATE
      ,PROTOCOLNOTICE
      ,PROTOCOLRESULTDATE
      ,PROTOCOLDOCTYPE
      ,PROTOCOLSALETYPE
      ,NOTIFYDATE
      ,EXECUTERACCREF
      ,DOCBASEDATE
      ,DOCBASENOTIFYDATE
      ,DOCBASETEXT
      ,DOCBASETYPE
      ,DOCBASESUMMA
      ,UNKNOWNAMOUNT
      ,PROTOCOLREASON
      ,DOCNUMBER
      ,ADJUSTMENTDOCNUMBER
      ,OLDDOCNUMBER
      ,LOTMAXSUM
      ,CLIENT_INN
      ,CLIENT_INN20
      ,CLIENT_NAME
      ,EXECUTER_INN
      ,EXECUTER_INN20
      ,EXECUTER_NAME
      ,EXECUTER_STATUS
      ,EXECUTER_COUNTRY
      ,EXECUTER_ADDRESS
      ,EXECUTER_PHONE
      ,REALID
      ,ADJUSTMENTNUMBER
      ,INNERNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,REESTRVERSION
      ,DOCTYPE
      ,RNCLIENTID
      ,INFONUMBER
      ,STATEORDERINNERNUMBER
      ,PROGINDEX
      ,NOTE
      ,PURPORTDOC
      ,REESTRRECORDNUMBER
      ,EXECUTERSTOREDPROPS
      ,AUTOSANCTION
      ,PURCHASECODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUMMA
      , :new.AGREEMENTDATE
      , :new.AGREEMENTENDDATE
      , :new.EXECUTER_REF
      , :new.CLIENT_REF
      , :new.FACIALACC_CLS
      , :new.AGREEMENTTYPE
      , :new.ACCEPTED
      , :new.ACCEPTDATE
      , :new.CARDADVANCEPERCENT
      , :new.CARDADVANCE
      , :new.CLOSEDOC
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.LASTADJUSTMENT
      , :new.LASTACCEPTED
      , :new.FACT
      , :new.REGION
      , :new.CLOSEDATE
      , :new.DELIVERYRULES
      , :new.AGREEMENTSUMMA
      , :new.AGREEMENTFINSUMMA
      , :new.ADJUSTMENTREF
      , :new.REESTRNUMBER
      , :new.PAYMENTDATE
      , :new.AGREEMENTCARDADVANCE
      , :new.FINCARDADVANCE
      , :new.STATEORDERREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.AGREEMENTBEGINDATE
      , :new.PROTOCOLNUMBER
      , :new.PROTOCOLDATE
      , :new.REVIEWNOTE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.EXPORTDATE
      , :new.FSORGAN
      , :new.FSBUDGETNAME
      , :new.FSOFFBUDGET
      , :new.RNYEAR
      , :new.RNNUMBER
      , :new.RNDATE
      , :new.PROTOCOLNOTICE
      , :new.PROTOCOLRESULTDATE
      , :new.PROTOCOLDOCTYPE
      , :new.PROTOCOLSALETYPE
      , :new.NOTIFYDATE
      , :new.EXECUTERACCREF
      , :new.DOCBASEDATE
      , :new.DOCBASENOTIFYDATE
      , :new.DOCBASETEXT
      , :new.DOCBASETYPE
      , :new.DOCBASESUMMA
      , :new.UNKNOWNAMOUNT
      , :new.PROTOCOLREASON
      , :new.DOCNUMBER
      , :new.ADJUSTMENTDOCNUMBER
      , :new.OLDDOCNUMBER
      , :new.LOTMAXSUM
      , :new.CLIENT_INN
      , :new.CLIENT_INN20
      , :new.CLIENT_NAME
      , :new.EXECUTER_INN
      , :new.EXECUTER_INN20
      , :new.EXECUTER_NAME
      , :new.EXECUTER_STATUS
      , :new.EXECUTER_COUNTRY
      , :new.EXECUTER_ADDRESS
      , :new.EXECUTER_PHONE
      , :new.REALID
      , :new.ADJUSTMENTNUMBER
      , :new.INNERNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.REESTRVERSION
      , :new.DOCTYPE
      , :new.RNCLIENTID
      , :new.INFONUMBER
      , :new.STATEORDERINNERNUMBER
      , :new.PROGINDEX
      , :new.NOTE
      , :new.PURPORTDOC
      , :new.REESTRRECORDNUMBER
      , :new.EXECUTERSTOREDPROPS
      , :new.AUTOSANCTION
      , :new.PURCHASECODE
    );
  else 
    update A_TB_AGREEMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_AGREEMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUMMA
      ,AGREEMENTDATE
      ,AGREEMENTENDDATE
      ,EXECUTER_REF
      ,CLIENT_REF
      ,FACIALACC_CLS
      ,AGREEMENTTYPE
      ,ACCEPTED
      ,ACCEPTDATE
      ,CARDADVANCEPERCENT
      ,CARDADVANCE
      ,CLOSEDOC
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,LASTADJUSTMENT
      ,LASTACCEPTED
      ,FACT
      ,REGION
      ,CLOSEDATE
      ,DELIVERYRULES
      ,AGREEMENTSUMMA
      ,AGREEMENTFINSUMMA
      ,ADJUSTMENTREF
      ,REESTRNUMBER
      ,PAYMENTDATE
      ,AGREEMENTCARDADVANCE
      ,FINCARDADVANCE
      ,STATEORDERREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,AGREEMENTBEGINDATE
      ,PROTOCOLNUMBER
      ,PROTOCOLDATE
      ,REVIEWNOTE
      ,DOCSTATEREF
      ,RVERSION
      ,EXPORTDATE
      ,FSORGAN
      ,FSBUDGETNAME
      ,FSOFFBUDGET
      ,RNYEAR
      ,RNNUMBER
      ,RNDATE
      ,PROTOCOLNOTICE
      ,PROTOCOLRESULTDATE
      ,PROTOCOLDOCTYPE
      ,PROTOCOLSALETYPE
      ,NOTIFYDATE
      ,EXECUTERACCREF
      ,DOCBASEDATE
      ,DOCBASENOTIFYDATE
      ,DOCBASETEXT
      ,DOCBASETYPE
      ,DOCBASESUMMA
      ,UNKNOWNAMOUNT
      ,PROTOCOLREASON
      ,DOCNUMBER
      ,ADJUSTMENTDOCNUMBER
      ,OLDDOCNUMBER
      ,LOTMAXSUM
      ,CLIENT_INN
      ,CLIENT_INN20
      ,CLIENT_NAME
      ,EXECUTER_INN
      ,EXECUTER_INN20
      ,EXECUTER_NAME
      ,EXECUTER_STATUS
      ,EXECUTER_COUNTRY
      ,EXECUTER_ADDRESS
      ,EXECUTER_PHONE
      ,REALID
      ,ADJUSTMENTNUMBER
      ,INNERNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,REESTRVERSION
      ,DOCTYPE
      ,RNCLIENTID
      ,INFONUMBER
      ,STATEORDERINNERNUMBER
      ,PROGINDEX
      ,NOTE
      ,PURPORTDOC
      ,REESTRRECORDNUMBER
      ,EXECUTERSTOREDPROPS
      ,AUTOSANCTION
      ,PURCHASECODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUMMA
      , :new.AGREEMENTDATE
      , :new.AGREEMENTENDDATE
      , :new.EXECUTER_REF
      , :new.CLIENT_REF
      , :new.FACIALACC_CLS
      , :new.AGREEMENTTYPE
      , :new.ACCEPTED
      , :new.ACCEPTDATE
      , :new.CARDADVANCEPERCENT
      , :new.CARDADVANCE
      , :new.CLOSEDOC
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.LASTADJUSTMENT
      , :new.LASTACCEPTED
      , :new.FACT
      , :new.REGION
      , :new.CLOSEDATE
      , :new.DELIVERYRULES
      , :new.AGREEMENTSUMMA
      , :new.AGREEMENTFINSUMMA
      , :new.ADJUSTMENTREF
      , :new.REESTRNUMBER
      , :new.PAYMENTDATE
      , :new.AGREEMENTCARDADVANCE
      , :new.FINCARDADVANCE
      , :new.STATEORDERREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.AGREEMENTBEGINDATE
      , :new.PROTOCOLNUMBER
      , :new.PROTOCOLDATE
      , :new.REVIEWNOTE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.EXPORTDATE
      , :new.FSORGAN
      , :new.FSBUDGETNAME
      , :new.FSOFFBUDGET
      , :new.RNYEAR
      , :new.RNNUMBER
      , :new.RNDATE
      , :new.PROTOCOLNOTICE
      , :new.PROTOCOLRESULTDATE
      , :new.PROTOCOLDOCTYPE
      , :new.PROTOCOLSALETYPE
      , :new.NOTIFYDATE
      , :new.EXECUTERACCREF
      , :new.DOCBASEDATE
      , :new.DOCBASENOTIFYDATE
      , :new.DOCBASETEXT
      , :new.DOCBASETYPE
      , :new.DOCBASESUMMA
      , :new.UNKNOWNAMOUNT
      , :new.PROTOCOLREASON
      , :new.DOCNUMBER
      , :new.ADJUSTMENTDOCNUMBER
      , :new.OLDDOCNUMBER
      , :new.LOTMAXSUM
      , :new.CLIENT_INN
      , :new.CLIENT_INN20
      , :new.CLIENT_NAME
      , :new.EXECUTER_INN
      , :new.EXECUTER_INN20
      , :new.EXECUTER_NAME
      , :new.EXECUTER_STATUS
      , :new.EXECUTER_COUNTRY
      , :new.EXECUTER_ADDRESS
      , :new.EXECUTER_PHONE
      , :new.REALID
      , :new.ADJUSTMENTNUMBER
      , :new.INNERNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.REESTRVERSION
      , :new.DOCTYPE
      , :new.RNCLIENTID
      , :new.INFONUMBER
      , :new.STATEORDERINNERNUMBER
      , :new.PROGINDEX
      , :new.NOTE
      , :new.PURPORTDOC
      , :new.REESTRRECORDNUMBER
      , :new.EXECUTERSTOREDPROPS
      , :new.AUTOSANCTION
      , :new.PURCHASECODE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_AGREEMENTS
  AFTER DELETE
  ON TB_AGREEMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_AGREEMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_ALLOWANCECAPTION
  AFTER INSERT
  ON TB_ALLOWANCECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_ALLOWANCECAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_ALLOWANCECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALLOWANCETYPE
      ,ACCEPTORORGREF
      ,FACIALACC_CLS
      ,NUMBERGENERAL
      ,NUMBERGENERALADD
      ,NUMBERDOC
      ,NUMBERADD
      ,BEGINDATE
      ,ENDDATE
      ,CONSTITUTIVEDOCTYPE
      ,CONSTITUTIVEDATE
      ,CONSTITUTIVENUMBER
      ,CONSTITUTIVEORGAN
      ,REGISTERFIO
      ,REGISTERJOB
      ,REGISTERDATE
      ,REGISTERORGAN
      ,RETURNNOTIFYNUMBER
      ,RETURNNOTIFYDATE
      ,RETURNREJECTCAUSE
      ,RETURNDATE
      ,RETURNFIO
      ,RETURNJOB
      ,SENDERID
      ,SENDERRECORDID
      ,REJECT_CLS
      ,REJECTCAUSE
      ,NUMBERRETURNTRANZACTION
      ,NUMBERREJECTTRANZACTION
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,PROGINDEX
      ,RVERSION
      ,INPUTDATE
      ,REQUESTNUMBER
      ,NOTE
      ,LASTEXTRCHANGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALLOWANCETYPE
      , :new.ACCEPTORORGREF
      , :new.FACIALACC_CLS
      , :new.NUMBERGENERAL
      , :new.NUMBERGENERALADD
      , :new.NUMBERDOC
      , :new.NUMBERADD
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.CONSTITUTIVEDOCTYPE
      , :new.CONSTITUTIVEDATE
      , :new.CONSTITUTIVENUMBER
      , :new.CONSTITUTIVEORGAN
      , :new.REGISTERFIO
      , :new.REGISTERJOB
      , :new.REGISTERDATE
      , :new.REGISTERORGAN
      , :new.RETURNNOTIFYNUMBER
      , :new.RETURNNOTIFYDATE
      , :new.RETURNREJECTCAUSE
      , :new.RETURNDATE
      , :new.RETURNFIO
      , :new.RETURNJOB
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.NUMBERRETURNTRANZACTION
      , :new.NUMBERREJECTTRANZACTION
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.PROGINDEX
      , :new.RVERSION
      , :new.INPUTDATE
      , :new.REQUESTNUMBER
      , :new.NOTE
      , :new.LASTEXTRCHANGE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_ALLOWANCECAPTION
  AFTER UPDATE
  ON TB_ALLOWANCECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_ALLOWANCECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_ALLOWANCECAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_ALLOWANCECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALLOWANCETYPE
      ,ACCEPTORORGREF
      ,FACIALACC_CLS
      ,NUMBERGENERAL
      ,NUMBERGENERALADD
      ,NUMBERDOC
      ,NUMBERADD
      ,BEGINDATE
      ,ENDDATE
      ,CONSTITUTIVEDOCTYPE
      ,CONSTITUTIVEDATE
      ,CONSTITUTIVENUMBER
      ,CONSTITUTIVEORGAN
      ,REGISTERFIO
      ,REGISTERJOB
      ,REGISTERDATE
      ,REGISTERORGAN
      ,RETURNNOTIFYNUMBER
      ,RETURNNOTIFYDATE
      ,RETURNREJECTCAUSE
      ,RETURNDATE
      ,RETURNFIO
      ,RETURNJOB
      ,SENDERID
      ,SENDERRECORDID
      ,REJECT_CLS
      ,REJECTCAUSE
      ,NUMBERRETURNTRANZACTION
      ,NUMBERREJECTTRANZACTION
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,PROGINDEX
      ,RVERSION
      ,INPUTDATE
      ,REQUESTNUMBER
      ,NOTE
      ,LASTEXTRCHANGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALLOWANCETYPE
      , :new.ACCEPTORORGREF
      , :new.FACIALACC_CLS
      , :new.NUMBERGENERAL
      , :new.NUMBERGENERALADD
      , :new.NUMBERDOC
      , :new.NUMBERADD
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.CONSTITUTIVEDOCTYPE
      , :new.CONSTITUTIVEDATE
      , :new.CONSTITUTIVENUMBER
      , :new.CONSTITUTIVEORGAN
      , :new.REGISTERFIO
      , :new.REGISTERJOB
      , :new.REGISTERDATE
      , :new.REGISTERORGAN
      , :new.RETURNNOTIFYNUMBER
      , :new.RETURNNOTIFYDATE
      , :new.RETURNREJECTCAUSE
      , :new.RETURNDATE
      , :new.RETURNFIO
      , :new.RETURNJOB
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.NUMBERRETURNTRANZACTION
      , :new.NUMBERREJECTTRANZACTION
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.PROGINDEX
      , :new.RVERSION
      , :new.INPUTDATE
      , :new.REQUESTNUMBER
      , :new.NOTE
      , :new.LASTEXTRCHANGE
    );
  else 
    update A_TB_ALLOWANCECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_ALLOWANCECAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ALLOWANCETYPE
      ,ACCEPTORORGREF
      ,FACIALACC_CLS
      ,NUMBERGENERAL
      ,NUMBERGENERALADD
      ,NUMBERDOC
      ,NUMBERADD
      ,BEGINDATE
      ,ENDDATE
      ,CONSTITUTIVEDOCTYPE
      ,CONSTITUTIVEDATE
      ,CONSTITUTIVENUMBER
      ,CONSTITUTIVEORGAN
      ,REGISTERFIO
      ,REGISTERJOB
      ,REGISTERDATE
      ,REGISTERORGAN
      ,RETURNNOTIFYNUMBER
      ,RETURNNOTIFYDATE
      ,RETURNREJECTCAUSE
      ,RETURNDATE
      ,RETURNFIO
      ,RETURNJOB
      ,SENDERID
      ,SENDERRECORDID
      ,REJECT_CLS
      ,REJECTCAUSE
      ,NUMBERRETURNTRANZACTION
      ,NUMBERREJECTTRANZACTION
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,PROGINDEX
      ,RVERSION
      ,INPUTDATE
      ,REQUESTNUMBER
      ,NOTE
      ,LASTEXTRCHANGE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ALLOWANCETYPE
      , :new.ACCEPTORORGREF
      , :new.FACIALACC_CLS
      , :new.NUMBERGENERAL
      , :new.NUMBERGENERALADD
      , :new.NUMBERDOC
      , :new.NUMBERADD
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.CONSTITUTIVEDOCTYPE
      , :new.CONSTITUTIVEDATE
      , :new.CONSTITUTIVENUMBER
      , :new.CONSTITUTIVEORGAN
      , :new.REGISTERFIO
      , :new.REGISTERJOB
      , :new.REGISTERDATE
      , :new.REGISTERORGAN
      , :new.RETURNNOTIFYNUMBER
      , :new.RETURNNOTIFYDATE
      , :new.RETURNREJECTCAUSE
      , :new.RETURNDATE
      , :new.RETURNFIO
      , :new.RETURNJOB
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.NUMBERRETURNTRANZACTION
      , :new.NUMBERREJECTTRANZACTION
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.PROGINDEX
      , :new.RVERSION
      , :new.INPUTDATE
      , :new.REQUESTNUMBER
      , :new.NOTE
      , :new.LASTEXTRCHANGE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_ALLOWANCECAPTION
  AFTER DELETE
  ON TB_ALLOWANCECAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_ALLOWANCECAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_BANKS
  AFTER INSERT
  ON TB_BANKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BANKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BANKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MFO
      ,COR
      ,CLOSED
      ,UER
      ,UERREAL
      ,PZN
      ,DATECLOSE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MFO
      , :new.COR
      , :new.CLOSED
      , :new.UER
      , :new.UERREAL
      , :new.PZN
      , :new.DATECLOSE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_BANKS
  AFTER UPDATE
  ON TB_BANKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_BANKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_BANKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BANKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MFO
      ,COR
      ,CLOSED
      ,UER
      ,UERREAL
      ,PZN
      ,DATECLOSE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MFO
      , :new.COR
      , :new.CLOSED
      , :new.UER
      , :new.UERREAL
      , :new.PZN
      , :new.DATECLOSE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_TB_BANKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_BANKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,MFO
      ,COR
      ,CLOSED
      ,UER
      ,UERREAL
      ,PZN
      ,DATECLOSE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.MFO
      , :new.COR
      , :new.CLOSED
      , :new.UER
      , :new.UERREAL
      , :new.PZN
      , :new.DATECLOSE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_BANKS
  AFTER DELETE
  ON TB_BANKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BANKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_BUDGETS_S
  AFTER INSERT
  ON TB_BUDGETS_S
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUDGETS_S
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUDGETS_S (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LASTMODIFDATE_B
      ,CURRENTBUDGET
      ,NOTE
      ,OKATO
      ,ADDOKATO
      ,CREATEDATE
      ,UPDATEDATE
      ,AYEAR
      ,CREATERUSER
      ,UPDATERUSER
      ,BUDGETLEVEL
      ,CHIEFNAME
      ,CHIEFROLE
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LASTMODIFDATE_B
      , :new.CURRENTBUDGET
      , :new.NOTE
      , :new.OKATO
      , :new.ADDOKATO
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.AYEAR
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.BUDGETLEVEL
      , :new.CHIEFNAME
      , :new.CHIEFROLE
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_BUDGETS_S
  AFTER UPDATE
  ON TB_BUDGETS_S
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_BUDGETS_S
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_BUDGETS_S
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUDGETS_S (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LASTMODIFDATE_B
      ,CURRENTBUDGET
      ,NOTE
      ,OKATO
      ,ADDOKATO
      ,CREATEDATE
      ,UPDATEDATE
      ,AYEAR
      ,CREATERUSER
      ,UPDATERUSER
      ,BUDGETLEVEL
      ,CHIEFNAME
      ,CHIEFROLE
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LASTMODIFDATE_B
      , :new.CURRENTBUDGET
      , :new.NOTE
      , :new.OKATO
      , :new.ADDOKATO
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.AYEAR
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.BUDGETLEVEL
      , :new.CHIEFNAME
      , :new.CHIEFROLE
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
    );
  else 
    update A_TB_BUDGETS_S
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_BUDGETS_S (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LASTMODIFDATE_B
      ,CURRENTBUDGET
      ,NOTE
      ,OKATO
      ,ADDOKATO
      ,CREATEDATE
      ,UPDATEDATE
      ,AYEAR
      ,CREATERUSER
      ,UPDATERUSER
      ,BUDGETLEVEL
      ,CHIEFNAME
      ,CHIEFROLE
      ,STARTDATE
      ,DELETEDATE
      ,EXTID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LASTMODIFDATE_B
      , :new.CURRENTBUDGET
      , :new.NOTE
      , :new.OKATO
      , :new.ADDOKATO
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.AYEAR
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.BUDGETLEVEL
      , :new.CHIEFNAME
      , :new.CHIEFROLE
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.EXTID
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_BUDGETS_S
  AFTER DELETE
  ON TB_BUDGETS_S
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUDGETS_S
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_BUDNOTIFY
  AFTER INSERT
  ON TB_BUDNOTIFY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUDNOTIFY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUDNOTIFY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DAT
      ,DOCDAT
      ,NOTIFYTYPE
      ,BUDGETREF
      ,DOCBASE
      ,VARIANT
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SENDERID
      ,SENDERRECORDID
      ,ANUMBER
      ,ATYPE
      ,DOCUMENTSTATE
      ,USERSVISA
      ,DATEINPUT
      ,ORGREF
      ,REJECTCLS
      ,REJECTNOTE
      ,PLANDOCTYPE
      ,RECORDINDEX
      ,STIMATEID
      ,CRYPTOSTATUS
      ,RVERSION
      ,DOCSTATEREF
      ,DOCNUMBER
      ,FACIALACCCLS
      ,LASTEXTRCHANGE
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,PLANKIND
      ,ASSIGNMENTSOURCE
      ,BA_LBO_FLAG
      ,KPPERIOD
      ,CLSTYPE
      ,DATE_UTV_PP
      ,PROGINDEX
      ,NOTE
      ,NOTE2
      ,DOCCHANGEDATE
      ,SIGNERS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,EXTID
      ,EXTROOTID
      ,NOTE1
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DAT
      , :new.DOCDAT
      , :new.NOTIFYTYPE
      , :new.BUDGETREF
      , :new.DOCBASE
      , :new.VARIANT
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.ANUMBER
      , :new.ATYPE
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.DATEINPUT
      , :new.ORGREF
      , :new.REJECTCLS
      , :new.REJECTNOTE
      , :new.PLANDOCTYPE
      , :new.RECORDINDEX
      , :new.STIMATEID
      , :new.CRYPTOSTATUS
      , :new.RVERSION
      , :new.DOCSTATEREF
      , :new.DOCNUMBER
      , :new.FACIALACCCLS
      , :new.LASTEXTRCHANGE
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.PLANKIND
      , :new.ASSIGNMENTSOURCE
      , :new.BA_LBO_FLAG
      , :new.KPPERIOD
      , :new.CLSTYPE
      , :new.DATE_UTV_PP
      , :new.PROGINDEX
      , :new.NOTE
      , :new.NOTE2
      , :new.DOCCHANGEDATE
      , :new.SIGNERS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.EXTID
      , :new.EXTROOTID
      , :new.NOTE1
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_BUDNOTIFY
  AFTER UPDATE
  ON TB_BUDNOTIFY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_BUDNOTIFY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_BUDNOTIFY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUDNOTIFY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DAT
      ,DOCDAT
      ,NOTIFYTYPE
      ,BUDGETREF
      ,DOCBASE
      ,VARIANT
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SENDERID
      ,SENDERRECORDID
      ,ANUMBER
      ,ATYPE
      ,DOCUMENTSTATE
      ,USERSVISA
      ,DATEINPUT
      ,ORGREF
      ,REJECTCLS
      ,REJECTNOTE
      ,PLANDOCTYPE
      ,RECORDINDEX
      ,STIMATEID
      ,CRYPTOSTATUS
      ,RVERSION
      ,DOCSTATEREF
      ,DOCNUMBER
      ,FACIALACCCLS
      ,LASTEXTRCHANGE
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,PLANKIND
      ,ASSIGNMENTSOURCE
      ,BA_LBO_FLAG
      ,KPPERIOD
      ,CLSTYPE
      ,DATE_UTV_PP
      ,PROGINDEX
      ,NOTE
      ,NOTE2
      ,DOCCHANGEDATE
      ,SIGNERS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,EXTID
      ,EXTROOTID
      ,NOTE1
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DAT
      , :new.DOCDAT
      , :new.NOTIFYTYPE
      , :new.BUDGETREF
      , :new.DOCBASE
      , :new.VARIANT
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.ANUMBER
      , :new.ATYPE
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.DATEINPUT
      , :new.ORGREF
      , :new.REJECTCLS
      , :new.REJECTNOTE
      , :new.PLANDOCTYPE
      , :new.RECORDINDEX
      , :new.STIMATEID
      , :new.CRYPTOSTATUS
      , :new.RVERSION
      , :new.DOCSTATEREF
      , :new.DOCNUMBER
      , :new.FACIALACCCLS
      , :new.LASTEXTRCHANGE
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.PLANKIND
      , :new.ASSIGNMENTSOURCE
      , :new.BA_LBO_FLAG
      , :new.KPPERIOD
      , :new.CLSTYPE
      , :new.DATE_UTV_PP
      , :new.PROGINDEX
      , :new.NOTE
      , :new.NOTE2
      , :new.DOCCHANGEDATE
      , :new.SIGNERS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.EXTID
      , :new.EXTROOTID
      , :new.NOTE1
    );
  else 
    update A_TB_BUDNOTIFY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_BUDNOTIFY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DAT
      ,DOCDAT
      ,NOTIFYTYPE
      ,BUDGETREF
      ,DOCBASE
      ,VARIANT
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SENDERID
      ,SENDERRECORDID
      ,ANUMBER
      ,ATYPE
      ,DOCUMENTSTATE
      ,USERSVISA
      ,DATEINPUT
      ,ORGREF
      ,REJECTCLS
      ,REJECTNOTE
      ,PLANDOCTYPE
      ,RECORDINDEX
      ,STIMATEID
      ,CRYPTOSTATUS
      ,RVERSION
      ,DOCSTATEREF
      ,DOCNUMBER
      ,FACIALACCCLS
      ,LASTEXTRCHANGE
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,PLANKIND
      ,ASSIGNMENTSOURCE
      ,BA_LBO_FLAG
      ,KPPERIOD
      ,CLSTYPE
      ,DATE_UTV_PP
      ,PROGINDEX
      ,NOTE
      ,NOTE2
      ,DOCCHANGEDATE
      ,SIGNERS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,EXTID
      ,EXTROOTID
      ,NOTE1
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DAT
      , :new.DOCDAT
      , :new.NOTIFYTYPE
      , :new.BUDGETREF
      , :new.DOCBASE
      , :new.VARIANT
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.ANUMBER
      , :new.ATYPE
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.DATEINPUT
      , :new.ORGREF
      , :new.REJECTCLS
      , :new.REJECTNOTE
      , :new.PLANDOCTYPE
      , :new.RECORDINDEX
      , :new.STIMATEID
      , :new.CRYPTOSTATUS
      , :new.RVERSION
      , :new.DOCSTATEREF
      , :new.DOCNUMBER
      , :new.FACIALACCCLS
      , :new.LASTEXTRCHANGE
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.PLANKIND
      , :new.ASSIGNMENTSOURCE
      , :new.BA_LBO_FLAG
      , :new.KPPERIOD
      , :new.CLSTYPE
      , :new.DATE_UTV_PP
      , :new.PROGINDEX
      , :new.NOTE
      , :new.NOTE2
      , :new.DOCCHANGEDATE
      , :new.SIGNERS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.EXTID
      , :new.EXTROOTID
      , :new.NOTE1
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_BUDNOTIFY
  AFTER DELETE
  ON TB_BUDNOTIFY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUDNOTIFY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_BUHACCCORR
  AFTER INSERT
  ON TB_BUHACCCORR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUHACCCORR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUHACCCORR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUHOPERATIONCLS
      ,DEBITACCREF
      ,CREDITACCREF
      ,BALANCECLS
      ,DEBITBUDCLSKIND
      ,CREDITBUDCLSKIND
      ,CREATEDATE
      ,UPDATEDATE
      ,CORRECTIONFLAG
      ,NAME
      ,BACKNAME
      ,HEADACTIVITYKIND
      ,ACTIVITYKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUHOPERATIONCLS
      , :new.DEBITACCREF
      , :new.CREDITACCREF
      , :new.BALANCECLS
      , :new.DEBITBUDCLSKIND
      , :new.CREDITBUDCLSKIND
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CORRECTIONFLAG
      , :new.NAME
      , :new.BACKNAME
      , :new.HEADACTIVITYKIND
      , :new.ACTIVITYKIND
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_BUHACCCORR
  AFTER UPDATE
  ON TB_BUHACCCORR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_BUHACCCORR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_BUHACCCORR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUHACCCORR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUHOPERATIONCLS
      ,DEBITACCREF
      ,CREDITACCREF
      ,BALANCECLS
      ,DEBITBUDCLSKIND
      ,CREDITBUDCLSKIND
      ,CREATEDATE
      ,UPDATEDATE
      ,CORRECTIONFLAG
      ,NAME
      ,BACKNAME
      ,HEADACTIVITYKIND
      ,ACTIVITYKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUHOPERATIONCLS
      , :new.DEBITACCREF
      , :new.CREDITACCREF
      , :new.BALANCECLS
      , :new.DEBITBUDCLSKIND
      , :new.CREDITBUDCLSKIND
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CORRECTIONFLAG
      , :new.NAME
      , :new.BACKNAME
      , :new.HEADACTIVITYKIND
      , :new.ACTIVITYKIND
    );
  else 
    update A_TB_BUHACCCORR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_BUHACCCORR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUHOPERATIONCLS
      ,DEBITACCREF
      ,CREDITACCREF
      ,BALANCECLS
      ,DEBITBUDCLSKIND
      ,CREDITBUDCLSKIND
      ,CREATEDATE
      ,UPDATEDATE
      ,CORRECTIONFLAG
      ,NAME
      ,BACKNAME
      ,HEADACTIVITYKIND
      ,ACTIVITYKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUHOPERATIONCLS
      , :new.DEBITACCREF
      , :new.CREDITACCREF
      , :new.BALANCECLS
      , :new.DEBITBUDCLSKIND
      , :new.CREDITBUDCLSKIND
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CORRECTIONFLAG
      , :new.NAME
      , :new.BACKNAME
      , :new.HEADACTIVITYKIND
      , :new.ACTIVITYKIND
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_BUHACCCORR
  AFTER DELETE
  ON TB_BUHACCCORR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUHACCCORR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_BUHOPERATIONCLS
  AFTER INSERT
  ON TB_BUHOPERATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUHOPERATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUHOPERATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CORRECTIONFLAG
      ,NAME
      ,CREATERUSER
      ,UPDATERUSER
      ,STARTDATE
      ,DELETEDATE
      ,COUNTDETAILRECORDS
      ,DOCCHANGEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CORRECTIONFLAG
      , :new.NAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.COUNTDETAILRECORDS
      , :new.DOCCHANGEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_BUHOPERATIONCLS
  AFTER UPDATE
  ON TB_BUHOPERATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_BUHOPERATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_BUHOPERATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_BUHOPERATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CORRECTIONFLAG
      ,NAME
      ,CREATERUSER
      ,UPDATERUSER
      ,STARTDATE
      ,DELETEDATE
      ,COUNTDETAILRECORDS
      ,DOCCHANGEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CORRECTIONFLAG
      , :new.NAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.COUNTDETAILRECORDS
      , :new.DOCCHANGEDATE
    );
  else 
    update A_TB_BUHOPERATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_BUHOPERATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CORRECTIONFLAG
      ,NAME
      ,CREATERUSER
      ,UPDATERUSER
      ,STARTDATE
      ,DELETEDATE
      ,COUNTDETAILRECORDS
      ,DOCCHANGEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CORRECTIONFLAG
      , :new.NAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.COUNTDETAILRECORDS
      , :new.DOCCHANGEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_BUHOPERATIONCLS
  AFTER DELETE
  ON TB_BUHOPERATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_BUHOPERATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_CORRECTIONDETAIL
  AFTER INSERT
  ON TB_CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_CORRECTIONDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_CORRECTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTID
      ,BUDGETREF
      ,SUMMA
      ,CLSTYPE
      ,FACIALACC_CLS
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FACT
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,DOCTYPE
      ,SUBKESR
      ,FUNDSSOURCE
      ,KD
      ,IFS
      ,BUHOPERATIONCLS
      ,CHANGEACC_REF
      ,CHANGEACC
      ,CHANGEORGINN
      ,CHANGEORGINN20
      ,PROGINDEX
      ,RECORDINDEX
      ,DOCUMENTPROGINDEX
      ,DOCUMENTRECORDINDEX
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
      ,ISCLSCHANGED
      ,PROMISE
      ,BUDGETPROMISE
      ,EXECDOC
      ,OKATO
      ,ADDOKATO
      ,TRANSFERTCLS
      ,ORIGINALCLSSUMMA
      ,NOTECLS
      ,OPERATIONTYPE
      ,REVERSEFLAG
      ,EXECINNERNUMBER
      ,CLSFIELFCHANGED
      ,FAORGTYPE
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,NOTEQUALEX
      ,OKTMO
      ,UINCODE
      ,INVESTOBJECT
      ,CHANGEORGNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTID
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CLSTYPE
      , :new.FACIALACC_CLS
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FACT
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DOCTYPE
      , :new.SUBKESR
      , :new.FUNDSSOURCE
      , :new.KD
      , :new.IFS
      , :new.BUHOPERATIONCLS
      , :new.CHANGEACC_REF
      , :new.CHANGEACC
      , :new.CHANGEORGINN
      , :new.CHANGEORGINN20
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.DOCUMENTPROGINDEX
      , :new.DOCUMENTRECORDINDEX
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
      , :new.ISCLSCHANGED
      , :new.PROMISE
      , :new.BUDGETPROMISE
      , :new.EXECDOC
      , :new.OKATO
      , :new.ADDOKATO
      , :new.TRANSFERTCLS
      , :new.ORIGINALCLSSUMMA
      , :new.NOTECLS
      , :new.OPERATIONTYPE
      , :new.REVERSEFLAG
      , :new.EXECINNERNUMBER
      , :new.CLSFIELFCHANGED
      , :new.FAORGTYPE
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.NOTEQUALEX
      , :new.OKTMO
      , :new.UINCODE
      , :new.INVESTOBJECT
      , :new.CHANGEORGNAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_CORRECTIONDETAIL
  AFTER UPDATE
  ON TB_CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_CORRECTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_CORRECTIONDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_CORRECTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTID
      ,BUDGETREF
      ,SUMMA
      ,CLSTYPE
      ,FACIALACC_CLS
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FACT
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,DOCTYPE
      ,SUBKESR
      ,FUNDSSOURCE
      ,KD
      ,IFS
      ,BUHOPERATIONCLS
      ,CHANGEACC_REF
      ,CHANGEACC
      ,CHANGEORGINN
      ,CHANGEORGINN20
      ,PROGINDEX
      ,RECORDINDEX
      ,DOCUMENTPROGINDEX
      ,DOCUMENTRECORDINDEX
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
      ,ISCLSCHANGED
      ,PROMISE
      ,BUDGETPROMISE
      ,EXECDOC
      ,OKATO
      ,ADDOKATO
      ,TRANSFERTCLS
      ,ORIGINALCLSSUMMA
      ,NOTECLS
      ,OPERATIONTYPE
      ,REVERSEFLAG
      ,EXECINNERNUMBER
      ,CLSFIELFCHANGED
      ,FAORGTYPE
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,NOTEQUALEX
      ,OKTMO
      ,UINCODE
      ,INVESTOBJECT
      ,CHANGEORGNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTID
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CLSTYPE
      , :new.FACIALACC_CLS
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FACT
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DOCTYPE
      , :new.SUBKESR
      , :new.FUNDSSOURCE
      , :new.KD
      , :new.IFS
      , :new.BUHOPERATIONCLS
      , :new.CHANGEACC_REF
      , :new.CHANGEACC
      , :new.CHANGEORGINN
      , :new.CHANGEORGINN20
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.DOCUMENTPROGINDEX
      , :new.DOCUMENTRECORDINDEX
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
      , :new.ISCLSCHANGED
      , :new.PROMISE
      , :new.BUDGETPROMISE
      , :new.EXECDOC
      , :new.OKATO
      , :new.ADDOKATO
      , :new.TRANSFERTCLS
      , :new.ORIGINALCLSSUMMA
      , :new.NOTECLS
      , :new.OPERATIONTYPE
      , :new.REVERSEFLAG
      , :new.EXECINNERNUMBER
      , :new.CLSFIELFCHANGED
      , :new.FAORGTYPE
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.NOTEQUALEX
      , :new.OKTMO
      , :new.UINCODE
      , :new.INVESTOBJECT
      , :new.CHANGEORGNAME
    );
  else 
    update A_TB_CORRECTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_CORRECTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTID
      ,BUDGETREF
      ,SUMMA
      ,CLSTYPE
      ,FACIALACC_CLS
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FACT
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,DOCTYPE
      ,SUBKESR
      ,FUNDSSOURCE
      ,KD
      ,IFS
      ,BUHOPERATIONCLS
      ,CHANGEACC_REF
      ,CHANGEACC
      ,CHANGEORGINN
      ,CHANGEORGINN20
      ,PROGINDEX
      ,RECORDINDEX
      ,DOCUMENTPROGINDEX
      ,DOCUMENTRECORDINDEX
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,NOTE
      ,ISCLSCHANGED
      ,PROMISE
      ,BUDGETPROMISE
      ,EXECDOC
      ,OKATO
      ,ADDOKATO
      ,TRANSFERTCLS
      ,ORIGINALCLSSUMMA
      ,NOTECLS
      ,OPERATIONTYPE
      ,REVERSEFLAG
      ,EXECINNERNUMBER
      ,CLSFIELFCHANGED
      ,FAORGTYPE
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,NOTEQUALEX
      ,OKTMO
      ,UINCODE
      ,INVESTOBJECT
      ,CHANGEORGNAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTID
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CLSTYPE
      , :new.FACIALACC_CLS
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FACT
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DOCTYPE
      , :new.SUBKESR
      , :new.FUNDSSOURCE
      , :new.KD
      , :new.IFS
      , :new.BUHOPERATIONCLS
      , :new.CHANGEACC_REF
      , :new.CHANGEACC
      , :new.CHANGEORGINN
      , :new.CHANGEORGINN20
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.DOCUMENTPROGINDEX
      , :new.DOCUMENTRECORDINDEX
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.NOTE
      , :new.ISCLSCHANGED
      , :new.PROMISE
      , :new.BUDGETPROMISE
      , :new.EXECDOC
      , :new.OKATO
      , :new.ADDOKATO
      , :new.TRANSFERTCLS
      , :new.ORIGINALCLSSUMMA
      , :new.NOTECLS
      , :new.OPERATIONTYPE
      , :new.REVERSEFLAG
      , :new.EXECINNERNUMBER
      , :new.CLSFIELFCHANGED
      , :new.FAORGTYPE
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.NOTEQUALEX
      , :new.OKTMO
      , :new.UINCODE
      , :new.INVESTOBJECT
      , :new.CHANGEORGNAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_CORRECTIONDETAIL
  AFTER DELETE
  ON TB_CORRECTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_CORRECTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_DBUSERS
  AFTER INSERT
  ON TB_DBUSERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DBUSERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DBUSERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERNAME
      ,FIRSTNAME
      ,MIDDLENAME
      ,LASTNAME
      ,NOTE
      ,PHONE
      ,DESCRIPTION
      ,DEPARTMENTCLS
      ,REMOTECLIENTREF
      ,REMOTEID
      ,CREATEDATE
      ,UPDATEDATE
      ,CRYPTOPARAMS
      ,CRYPTOID
      ,ORG_REF
      ,NOTE2
      ,EMAILADDRESS
      ,PRINCIPALNAME
      ,USERGUID
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERNAME
      , :new.FIRSTNAME
      , :new.MIDDLENAME
      , :new.LASTNAME
      , :new.NOTE
      , :new.PHONE
      , :new.DESCRIPTION
      , :new.DEPARTMENTCLS
      , :new.REMOTECLIENTREF
      , :new.REMOTEID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CRYPTOPARAMS
      , :new.CRYPTOID
      , :new.ORG_REF
      , :new.NOTE2
      , :new.EMAILADDRESS
      , :new.PRINCIPALNAME
      , :new.USERGUID
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_DBUSERS
  AFTER UPDATE
  ON TB_DBUSERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_DBUSERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_DBUSERS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DBUSERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERNAME
      ,FIRSTNAME
      ,MIDDLENAME
      ,LASTNAME
      ,NOTE
      ,PHONE
      ,DESCRIPTION
      ,DEPARTMENTCLS
      ,REMOTECLIENTREF
      ,REMOTEID
      ,CREATEDATE
      ,UPDATEDATE
      ,CRYPTOPARAMS
      ,CRYPTOID
      ,ORG_REF
      ,NOTE2
      ,EMAILADDRESS
      ,PRINCIPALNAME
      ,USERGUID
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERNAME
      , :new.FIRSTNAME
      , :new.MIDDLENAME
      , :new.LASTNAME
      , :new.NOTE
      , :new.PHONE
      , :new.DESCRIPTION
      , :new.DEPARTMENTCLS
      , :new.REMOTECLIENTREF
      , :new.REMOTEID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CRYPTOPARAMS
      , :new.CRYPTOID
      , :new.ORG_REF
      , :new.NOTE2
      , :new.EMAILADDRESS
      , :new.PRINCIPALNAME
      , :new.USERGUID
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_TB_DBUSERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_DBUSERS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERNAME
      ,FIRSTNAME
      ,MIDDLENAME
      ,LASTNAME
      ,NOTE
      ,PHONE
      ,DESCRIPTION
      ,DEPARTMENTCLS
      ,REMOTECLIENTREF
      ,REMOTEID
      ,CREATEDATE
      ,UPDATEDATE
      ,CRYPTOPARAMS
      ,CRYPTOID
      ,ORG_REF
      ,NOTE2
      ,EMAILADDRESS
      ,PRINCIPALNAME
      ,USERGUID
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERNAME
      , :new.FIRSTNAME
      , :new.MIDDLENAME
      , :new.LASTNAME
      , :new.NOTE
      , :new.PHONE
      , :new.DESCRIPTION
      , :new.DEPARTMENTCLS
      , :new.REMOTECLIENTREF
      , :new.REMOTEID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CRYPTOPARAMS
      , :new.CRYPTOID
      , :new.ORG_REF
      , :new.NOTE2
      , :new.EMAILADDRESS
      , :new.PRINCIPALNAME
      , :new.USERGUID
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_DBUSERS
  AFTER DELETE
  ON TB_DBUSERS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DBUSERS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_DESCRDOCUMENTTYPES
  AFTER INSERT
  ON TB_DESCRDOCUMENTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DESCRDOCUMENTTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DESCRDOCUMENTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTDOCTYPEREF
      ,CLASSNAME
      ,KINDOFDOC
      ,DBTABLE
      ,KINDOFFORM
      ,NAMESPACE
      ,CLASSGUID
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTDOCTYPEREF
      , :new.CLASSNAME
      , :new.KINDOFDOC
      , :new.DBTABLE
      , :new.KINDOFFORM
      , :new.NAMESPACE
      , :new.CLASSGUID
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_DESCRDOCUMENTTYPES
  AFTER UPDATE
  ON TB_DESCRDOCUMENTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_DESCRDOCUMENTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_DESCRDOCUMENTTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DESCRDOCUMENTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTDOCTYPEREF
      ,CLASSNAME
      ,KINDOFDOC
      ,DBTABLE
      ,KINDOFFORM
      ,NAMESPACE
      ,CLASSGUID
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTDOCTYPEREF
      , :new.CLASSNAME
      , :new.KINDOFDOC
      , :new.DBTABLE
      , :new.KINDOFFORM
      , :new.NAMESPACE
      , :new.CLASSGUID
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_TB_DESCRDOCUMENTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_DESCRDOCUMENTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PARENTDOCTYPEREF
      ,CLASSNAME
      ,KINDOFDOC
      ,DBTABLE
      ,KINDOFFORM
      ,NAMESPACE
      ,CLASSGUID
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PARENTDOCTYPEREF
      , :new.CLASSNAME
      , :new.KINDOFDOC
      , :new.DBTABLE
      , :new.KINDOFFORM
      , :new.NAMESPACE
      , :new.CLASSGUID
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_DESCRDOCUMENTTYPES
  AFTER DELETE
  ON TB_DESCRDOCUMENTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DESCRDOCUMENTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_DFACCOUNTSBUHTABLE
  AFTER INSERT
  ON TB_DFACCOUNTSBUHTABLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DFACCOUNTSBUHTABLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DFACCOUNTSBUHTABLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,BUDGETREF
      ,ID
      ,BUHACC
      ,ACCMODE
      ,FIXED
      ,CREATEDATE
      ,UPDATEDATE
      ,CURRENCYCLS
      ,TREASURYACCREF
      ,FINORGACCREF
      ,IFS
      ,SINGLEID
      ,ISCOMMON
      ,ISFORBUDGET
      ,ISFORBUSINESS
      ,ISFORTEMPORARY
      ,ISFORCASH
      ,CREATERUSER
      ,UPDATERUSER
      ,REGIONCLS
      ,ISFORBU_AU
      ,ISDEPOSIT
      ,FACIALACC_ADB
      ,ISFORTEMPORARYBU_AU
      ,ISFORAU
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.BUDGETREF
      , :new.ID
      , :new.BUHACC
      , :new.ACCMODE
      , :new.FIXED
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CURRENCYCLS
      , :new.TREASURYACCREF
      , :new.FINORGACCREF
      , :new.IFS
      , :new.SINGLEID
      , :new.ISCOMMON
      , :new.ISFORBUDGET
      , :new.ISFORBUSINESS
      , :new.ISFORTEMPORARY
      , :new.ISFORCASH
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.REGIONCLS
      , :new.ISFORBU_AU
      , :new.ISDEPOSIT
      , :new.FACIALACC_ADB
      , :new.ISFORTEMPORARYBU_AU
      , :new.ISFORAU
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_DFACCOUNTSBUHTABLE
  AFTER UPDATE
  ON TB_DFACCOUNTSBUHTABLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_DFACCOUNTSBUHTABLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_DFACCOUNTSBUHTABLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DFACCOUNTSBUHTABLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,BUDGETREF
      ,ID
      ,BUHACC
      ,ACCMODE
      ,FIXED
      ,CREATEDATE
      ,UPDATEDATE
      ,CURRENCYCLS
      ,TREASURYACCREF
      ,FINORGACCREF
      ,IFS
      ,SINGLEID
      ,ISCOMMON
      ,ISFORBUDGET
      ,ISFORBUSINESS
      ,ISFORTEMPORARY
      ,ISFORCASH
      ,CREATERUSER
      ,UPDATERUSER
      ,REGIONCLS
      ,ISFORBU_AU
      ,ISDEPOSIT
      ,FACIALACC_ADB
      ,ISFORTEMPORARYBU_AU
      ,ISFORAU
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.BUDGETREF
      , :new.ID
      , :new.BUHACC
      , :new.ACCMODE
      , :new.FIXED
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CURRENCYCLS
      , :new.TREASURYACCREF
      , :new.FINORGACCREF
      , :new.IFS
      , :new.SINGLEID
      , :new.ISCOMMON
      , :new.ISFORBUDGET
      , :new.ISFORBUSINESS
      , :new.ISFORTEMPORARY
      , :new.ISFORCASH
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.REGIONCLS
      , :new.ISFORBU_AU
      , :new.ISDEPOSIT
      , :new.FACIALACC_ADB
      , :new.ISFORTEMPORARYBU_AU
      , :new.ISFORAU
    );
  else 
    update A_TB_DFACCOUNTSBUHTABLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_DFACCOUNTSBUHTABLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,BUDGETREF
      ,ID
      ,BUHACC
      ,ACCMODE
      ,FIXED
      ,CREATEDATE
      ,UPDATEDATE
      ,CURRENCYCLS
      ,TREASURYACCREF
      ,FINORGACCREF
      ,IFS
      ,SINGLEID
      ,ISCOMMON
      ,ISFORBUDGET
      ,ISFORBUSINESS
      ,ISFORTEMPORARY
      ,ISFORCASH
      ,CREATERUSER
      ,UPDATERUSER
      ,REGIONCLS
      ,ISFORBU_AU
      ,ISDEPOSIT
      ,FACIALACC_ADB
      ,ISFORTEMPORARYBU_AU
      ,ISFORAU
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.BUDGETREF
      , :new.ID
      , :new.BUHACC
      , :new.ACCMODE
      , :new.FIXED
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CURRENCYCLS
      , :new.TREASURYACCREF
      , :new.FINORGACCREF
      , :new.IFS
      , :new.SINGLEID
      , :new.ISCOMMON
      , :new.ISFORBUDGET
      , :new.ISFORBUSINESS
      , :new.ISFORTEMPORARY
      , :new.ISFORCASH
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.REGIONCLS
      , :new.ISFORBU_AU
      , :new.ISDEPOSIT
      , :new.FACIALACC_ADB
      , :new.ISFORTEMPORARYBU_AU
      , :new.ISFORAU
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_DFACCOUNTSBUHTABLE
  AFTER DELETE
  ON TB_DFACCOUNTSBUHTABLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DFACCOUNTSBUHTABLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_DOCUMENTFIELDS
  AFTER INSERT
  ON TB_DOCUMENTFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DOCUMENTFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DOCUMENTFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ITFFIELDNAME
      ,NOTE
      ,ISBUDGET
      ,DOCTYPEREF
      ,DETAILNUMBER
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,TEMPLATEFIELD
      ,ONLYREAD
      ,REPORTFIELDNAME
      ,DOCUMENTCLS
      ,FIELDINFOREF
      ,CONTAINERREF
      ,ATTRFIELDKIND
      ,ATTRIBUTENAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ITFFIELDNAME
      , :new.NOTE
      , :new.ISBUDGET
      , :new.DOCTYPEREF
      , :new.DETAILNUMBER
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.TEMPLATEFIELD
      , :new.ONLYREAD
      , :new.REPORTFIELDNAME
      , :new.DOCUMENTCLS
      , :new.FIELDINFOREF
      , :new.CONTAINERREF
      , :new.ATTRFIELDKIND
      , :new.ATTRIBUTENAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_DOCUMENTFIELDS
  AFTER UPDATE
  ON TB_DOCUMENTFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_DOCUMENTFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_DOCUMENTFIELDS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_DOCUMENTFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ITFFIELDNAME
      ,NOTE
      ,ISBUDGET
      ,DOCTYPEREF
      ,DETAILNUMBER
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,TEMPLATEFIELD
      ,ONLYREAD
      ,REPORTFIELDNAME
      ,DOCUMENTCLS
      ,FIELDINFOREF
      ,CONTAINERREF
      ,ATTRFIELDKIND
      ,ATTRIBUTENAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ITFFIELDNAME
      , :new.NOTE
      , :new.ISBUDGET
      , :new.DOCTYPEREF
      , :new.DETAILNUMBER
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.TEMPLATEFIELD
      , :new.ONLYREAD
      , :new.REPORTFIELDNAME
      , :new.DOCUMENTCLS
      , :new.FIELDINFOREF
      , :new.CONTAINERREF
      , :new.ATTRFIELDKIND
      , :new.ATTRIBUTENAME
    );
  else 
    update A_TB_DOCUMENTFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_DOCUMENTFIELDS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ITFFIELDNAME
      ,NOTE
      ,ISBUDGET
      ,DOCTYPEREF
      ,DETAILNUMBER
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CREATEDATE
      ,TEMPLATEFIELD
      ,ONLYREAD
      ,REPORTFIELDNAME
      ,DOCUMENTCLS
      ,FIELDINFOREF
      ,CONTAINERREF
      ,ATTRFIELDKIND
      ,ATTRIBUTENAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ITFFIELDNAME
      , :new.NOTE
      , :new.ISBUDGET
      , :new.DOCTYPEREF
      , :new.DETAILNUMBER
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.TEMPLATEFIELD
      , :new.ONLYREAD
      , :new.REPORTFIELDNAME
      , :new.DOCUMENTCLS
      , :new.FIELDINFOREF
      , :new.CONTAINERREF
      , :new.ATTRFIELDKIND
      , :new.ATTRIBUTENAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_DOCUMENTFIELDS
  AFTER DELETE
  ON TB_DOCUMENTFIELDS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_DOCUMENTFIELDS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_EXECUTIONDOCUMENTSCAP_0
  AFTER INSERT
  ON TB_EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_EXECUTIONDOCUMENTSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_EXECUTIONDOCUMENTSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCUMENTDATE
      ,ACCEPTDATE
      ,SUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,STEPNUMBER
      ,FACIALACC_CLS
      ,RECIPIENT_REF
      ,REGISTRATIONTYPE
      ,REESTRNUMBER
      ,AGREEMENTINNERNUMBER
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,REVIEWNOTE
      ,DOCSTATEREF
      ,RVERSION
      ,EXECDOCFINSUMMA
      ,FACT
      ,DOCNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,REALID
      ,INNERNUMBER
      ,ADJUSTMENTREF
      ,ADJUSTMENTNUMBER
      ,ACCEPTED
      ,LASTACCEPTED
      ,LASTADJUSTMENT
      ,AGREEMENTREF
      ,NOTE
      ,SUPPLIERSTOREDPROPS
      ,SUPPLIER_REF
      ,SUPPLIERACC_REF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCUMENTDATE
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.STEPNUMBER
      , :new.FACIALACC_CLS
      , :new.RECIPIENT_REF
      , :new.REGISTRATIONTYPE
      , :new.REESTRNUMBER
      , :new.AGREEMENTINNERNUMBER
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REVIEWNOTE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.EXECDOCFINSUMMA
      , :new.FACT
      , :new.DOCNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.REALID
      , :new.INNERNUMBER
      , :new.ADJUSTMENTREF
      , :new.ADJUSTMENTNUMBER
      , :new.ACCEPTED
      , :new.LASTACCEPTED
      , :new.LASTADJUSTMENT
      , :new.AGREEMENTREF
      , :new.NOTE
      , :new.SUPPLIERSTOREDPROPS
      , :new.SUPPLIER_REF
      , :new.SUPPLIERACC_REF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_EXECUTIONDOCUMENTSCAP_0
  AFTER UPDATE
  ON TB_EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_EXECUTIONDOCUMENTSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_EXECUTIONDOCUMENTSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_EXECUTIONDOCUMENTSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCUMENTDATE
      ,ACCEPTDATE
      ,SUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,STEPNUMBER
      ,FACIALACC_CLS
      ,RECIPIENT_REF
      ,REGISTRATIONTYPE
      ,REESTRNUMBER
      ,AGREEMENTINNERNUMBER
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,REVIEWNOTE
      ,DOCSTATEREF
      ,RVERSION
      ,EXECDOCFINSUMMA
      ,FACT
      ,DOCNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,REALID
      ,INNERNUMBER
      ,ADJUSTMENTREF
      ,ADJUSTMENTNUMBER
      ,ACCEPTED
      ,LASTACCEPTED
      ,LASTADJUSTMENT
      ,AGREEMENTREF
      ,NOTE
      ,SUPPLIERSTOREDPROPS
      ,SUPPLIER_REF
      ,SUPPLIERACC_REF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCUMENTDATE
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.STEPNUMBER
      , :new.FACIALACC_CLS
      , :new.RECIPIENT_REF
      , :new.REGISTRATIONTYPE
      , :new.REESTRNUMBER
      , :new.AGREEMENTINNERNUMBER
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REVIEWNOTE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.EXECDOCFINSUMMA
      , :new.FACT
      , :new.DOCNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.REALID
      , :new.INNERNUMBER
      , :new.ADJUSTMENTREF
      , :new.ADJUSTMENTNUMBER
      , :new.ACCEPTED
      , :new.LASTACCEPTED
      , :new.LASTADJUSTMENT
      , :new.AGREEMENTREF
      , :new.NOTE
      , :new.SUPPLIERSTOREDPROPS
      , :new.SUPPLIER_REF
      , :new.SUPPLIERACC_REF
    );
  else 
    update A_TB_EXECUTIONDOCUMENTSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_EXECUTIONDOCUMENTSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCTYPE
      ,DOCUMENTDATE
      ,ACCEPTDATE
      ,SUMMA
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,STEPNUMBER
      ,FACIALACC_CLS
      ,RECIPIENT_REF
      ,REGISTRATIONTYPE
      ,REESTRNUMBER
      ,AGREEMENTINNERNUMBER
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,REVIEWNOTE
      ,DOCSTATEREF
      ,RVERSION
      ,EXECDOCFINSUMMA
      ,FACT
      ,DOCNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,REALID
      ,INNERNUMBER
      ,ADJUSTMENTREF
      ,ADJUSTMENTNUMBER
      ,ACCEPTED
      ,LASTACCEPTED
      ,LASTADJUSTMENT
      ,AGREEMENTREF
      ,NOTE
      ,SUPPLIERSTOREDPROPS
      ,SUPPLIER_REF
      ,SUPPLIERACC_REF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCTYPE
      , :new.DOCUMENTDATE
      , :new.ACCEPTDATE
      , :new.SUMMA
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.STEPNUMBER
      , :new.FACIALACC_CLS
      , :new.RECIPIENT_REF
      , :new.REGISTRATIONTYPE
      , :new.REESTRNUMBER
      , :new.AGREEMENTINNERNUMBER
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REVIEWNOTE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.EXECDOCFINSUMMA
      , :new.FACT
      , :new.DOCNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.REALID
      , :new.INNERNUMBER
      , :new.ADJUSTMENTREF
      , :new.ADJUSTMENTNUMBER
      , :new.ACCEPTED
      , :new.LASTACCEPTED
      , :new.LASTADJUSTMENT
      , :new.AGREEMENTREF
      , :new.NOTE
      , :new.SUPPLIERSTOREDPROPS
      , :new.SUPPLIER_REF
      , :new.SUPPLIERACC_REF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_EXECUTIONDOCUMENTSCAP_0
  AFTER DELETE
  ON TB_EXECUTIONDOCUMENTSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_EXECUTIONDOCUMENTSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_FACIALACC_CLS
  AFTER INSERT
  ON TB_FACIALACC_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALACC_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALACC_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CODE4
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
      ,FINTYPE
      ,ORG_REF
      ,DATEOPEN
      ,SERVICEACCOUNT
      ,STATUSACCOUNT
      ,HARACTERACCOUNT
      ,REGIONCLS
      ,CREATEDATE
      ,UPDATEDATE
      ,FACIALCODE
      ,MEANSTYPE
      ,GENERALORG_REF
      ,DEPARTMENTCLS
      ,RVERSION
      ,CLOSEDOCNUMBER
      ,HIGHERORG_REF
      ,BUDGETREF
      ,FCACCOUNT
      ,CLOSECODE
      ,DATECLOSE
      ,CREATERUSER
      ,UPDATERUSER
      ,NOTE
      ,NAME
      ,ISRBS
      ,ISPBS
      ,ISBU
      ,ISSEPARATEBU
      ,ISPROXY
      ,OPENDOCNUMBER
      ,ISOMS
      ,CHANGEDOCNUMBER
      ,DATECHANGE
      ,GENERALORGFACIALACC
      ,GRANTEEORG_REF
      ,PREVCLS
      ,FACIALCODEEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CODE4
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
      , :new.FINTYPE
      , :new.ORG_REF
      , :new.DATEOPEN
      , :new.SERVICEACCOUNT
      , :new.STATUSACCOUNT
      , :new.HARACTERACCOUNT
      , :new.REGIONCLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACIALCODE
      , :new.MEANSTYPE
      , :new.GENERALORG_REF
      , :new.DEPARTMENTCLS
      , :new.RVERSION
      , :new.CLOSEDOCNUMBER
      , :new.HIGHERORG_REF
      , :new.BUDGETREF
      , :new.FCACCOUNT
      , :new.CLOSECODE
      , :new.DATECLOSE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NOTE
      , :new.NAME
      , :new.ISRBS
      , :new.ISPBS
      , :new.ISBU
      , :new.ISSEPARATEBU
      , :new.ISPROXY
      , :new.OPENDOCNUMBER
      , :new.ISOMS
      , :new.CHANGEDOCNUMBER
      , :new.DATECHANGE
      , :new.GENERALORGFACIALACC
      , :new.GRANTEEORG_REF
      , :new.PREVCLS
      , :new.FACIALCODEEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_FACIALACC_CLS
  AFTER UPDATE
  ON TB_FACIALACC_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_FACIALACC_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_FACIALACC_CLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALACC_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CODE4
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
      ,FINTYPE
      ,ORG_REF
      ,DATEOPEN
      ,SERVICEACCOUNT
      ,STATUSACCOUNT
      ,HARACTERACCOUNT
      ,REGIONCLS
      ,CREATEDATE
      ,UPDATEDATE
      ,FACIALCODE
      ,MEANSTYPE
      ,GENERALORG_REF
      ,DEPARTMENTCLS
      ,RVERSION
      ,CLOSEDOCNUMBER
      ,HIGHERORG_REF
      ,BUDGETREF
      ,FCACCOUNT
      ,CLOSECODE
      ,DATECLOSE
      ,CREATERUSER
      ,UPDATERUSER
      ,NOTE
      ,NAME
      ,ISRBS
      ,ISPBS
      ,ISBU
      ,ISSEPARATEBU
      ,ISPROXY
      ,OPENDOCNUMBER
      ,ISOMS
      ,CHANGEDOCNUMBER
      ,DATECHANGE
      ,GENERALORGFACIALACC
      ,GRANTEEORG_REF
      ,PREVCLS
      ,FACIALCODEEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CODE4
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
      , :new.FINTYPE
      , :new.ORG_REF
      , :new.DATEOPEN
      , :new.SERVICEACCOUNT
      , :new.STATUSACCOUNT
      , :new.HARACTERACCOUNT
      , :new.REGIONCLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACIALCODE
      , :new.MEANSTYPE
      , :new.GENERALORG_REF
      , :new.DEPARTMENTCLS
      , :new.RVERSION
      , :new.CLOSEDOCNUMBER
      , :new.HIGHERORG_REF
      , :new.BUDGETREF
      , :new.FCACCOUNT
      , :new.CLOSECODE
      , :new.DATECLOSE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NOTE
      , :new.NAME
      , :new.ISRBS
      , :new.ISPBS
      , :new.ISBU
      , :new.ISSEPARATEBU
      , :new.ISPROXY
      , :new.OPENDOCNUMBER
      , :new.ISOMS
      , :new.CHANGEDOCNUMBER
      , :new.DATECHANGE
      , :new.GENERALORGFACIALACC
      , :new.GRANTEEORG_REF
      , :new.PREVCLS
      , :new.FACIALCODEEX
    );
  else 
    update A_TB_FACIALACC_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_FACIALACC_CLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CODE1
      ,CODE2
      ,CODE3
      ,CODE4
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
      ,FINTYPE
      ,ORG_REF
      ,DATEOPEN
      ,SERVICEACCOUNT
      ,STATUSACCOUNT
      ,HARACTERACCOUNT
      ,REGIONCLS
      ,CREATEDATE
      ,UPDATEDATE
      ,FACIALCODE
      ,MEANSTYPE
      ,GENERALORG_REF
      ,DEPARTMENTCLS
      ,RVERSION
      ,CLOSEDOCNUMBER
      ,HIGHERORG_REF
      ,BUDGETREF
      ,FCACCOUNT
      ,CLOSECODE
      ,DATECLOSE
      ,CREATERUSER
      ,UPDATERUSER
      ,NOTE
      ,NAME
      ,ISRBS
      ,ISPBS
      ,ISBU
      ,ISSEPARATEBU
      ,ISPROXY
      ,OPENDOCNUMBER
      ,ISOMS
      ,CHANGEDOCNUMBER
      ,DATECHANGE
      ,GENERALORGFACIALACC
      ,GRANTEEORG_REF
      ,PREVCLS
      ,FACIALCODEEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CODE1
      , :new.CODE2
      , :new.CODE3
      , :new.CODE4
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
      , :new.FINTYPE
      , :new.ORG_REF
      , :new.DATEOPEN
      , :new.SERVICEACCOUNT
      , :new.STATUSACCOUNT
      , :new.HARACTERACCOUNT
      , :new.REGIONCLS
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.FACIALCODE
      , :new.MEANSTYPE
      , :new.GENERALORG_REF
      , :new.DEPARTMENTCLS
      , :new.RVERSION
      , :new.CLOSEDOCNUMBER
      , :new.HIGHERORG_REF
      , :new.BUDGETREF
      , :new.FCACCOUNT
      , :new.CLOSECODE
      , :new.DATECLOSE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NOTE
      , :new.NAME
      , :new.ISRBS
      , :new.ISPBS
      , :new.ISBU
      , :new.ISSEPARATEBU
      , :new.ISPROXY
      , :new.OPENDOCNUMBER
      , :new.ISOMS
      , :new.CHANGEDOCNUMBER
      , :new.DATECHANGE
      , :new.GENERALORGFACIALACC
      , :new.GRANTEEORG_REF
      , :new.PREVCLS
      , :new.FACIALCODEEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_FACIALACC_CLS
  AFTER DELETE
  ON TB_FACIALACC_CLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALACC_CLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_FACIALFINCAPTION
  AFTER INSERT
  ON TB_FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,SOURCEDOCNUM
      ,PAYDATE
      ,ACCEPTDATE
      ,DOCUMENTDATE
      ,REESTRDATE
      ,CREDIT
      ,SOURCEACCOUNT
      ,SOURCEFACIALACC_CLS
      ,DESTACCOUNT
      ,DESTFACIALACC_CLS
      ,PROGINDEX
      ,ARHIVEDOC
      ,PAYSYMBOLCLS
      ,PAYTYPECLS
      ,NOTE
      ,PERIOD
      ,PAYPRIORITY
      ,TYPEOPERATIONCLS
      ,BUHPAYMENTCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,RECORDINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,REESTR_REF
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CLIENTBANKNUMBER
      ,CRYPTOSTATUS
      ,TRUSTNUMBER
      ,LINKEDDOCUMENT
      ,BNKRECORDID
      ,SUBPROGINDEX
      ,DOCUMENTSTATE
      ,USERSVISA
      ,TREASUARYDOCSTATECLS
      ,DEPARTMENTCLS
      ,NDS
      ,TAXNOTE
      ,MANAGERBID
      ,BIDNUMBER
      ,GROUPID
      ,GROUPSUMMA
      ,DOCSTATEREF
      ,LASTEXTRCHANGE
      ,FAXDOCCOUNT
      ,STIMATEID
      ,INTEGRATEDDOCREF
      ,REQUESTNUMBER
      ,REQUESTDATE
      ,RVERSION
      ,FEDERALFUNDSREF
      ,ELDOCREF
      ,BUHOPERATIONCLS
      ,CLSTYPE
      ,OPERATIONDIRECTION
      ,SOURCETYPE
      ,DESTTYPE
      ,CARDNUMBER
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,CASHIERPERSONALINFO
      ,BIDDATE
      ,CARDREF
      ,SOURCESTOREDPAYMENTPROPS
      ,DESTSTOREDPAYMENTPROPS
      ,STOREDPAYMENTNOTE
      ,DOCCHANGEDATE
      ,UINCODE
      ,DOCOSN
      ,SIGNERS
      ,DESTCLSTYPE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,AUTOSANCTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.SOURCEDOCNUM
      , :new.PAYDATE
      , :new.ACCEPTDATE
      , :new.DOCUMENTDATE
      , :new.REESTRDATE
      , :new.CREDIT
      , :new.SOURCEACCOUNT
      , :new.SOURCEFACIALACC_CLS
      , :new.DESTACCOUNT
      , :new.DESTFACIALACC_CLS
      , :new.PROGINDEX
      , :new.ARHIVEDOC
      , :new.PAYSYMBOLCLS
      , :new.PAYTYPECLS
      , :new.NOTE
      , :new.PERIOD
      , :new.PAYPRIORITY
      , :new.TYPEOPERATIONCLS
      , :new.BUHPAYMENTCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REESTR_REF
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CLIENTBANKNUMBER
      , :new.CRYPTOSTATUS
      , :new.TRUSTNUMBER
      , :new.LINKEDDOCUMENT
      , :new.BNKRECORDID
      , :new.SUBPROGINDEX
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.TREASUARYDOCSTATECLS
      , :new.DEPARTMENTCLS
      , :new.NDS
      , :new.TAXNOTE
      , :new.MANAGERBID
      , :new.BIDNUMBER
      , :new.GROUPID
      , :new.GROUPSUMMA
      , :new.DOCSTATEREF
      , :new.LASTEXTRCHANGE
      , :new.FAXDOCCOUNT
      , :new.STIMATEID
      , :new.INTEGRATEDDOCREF
      , :new.REQUESTNUMBER
      , :new.REQUESTDATE
      , :new.RVERSION
      , :new.FEDERALFUNDSREF
      , :new.ELDOCREF
      , :new.BUHOPERATIONCLS
      , :new.CLSTYPE
      , :new.OPERATIONDIRECTION
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.CARDNUMBER
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.CASHIERPERSONALINFO
      , :new.BIDDATE
      , :new.CARDREF
      , :new.SOURCESTOREDPAYMENTPROPS
      , :new.DESTSTOREDPAYMENTPROPS
      , :new.STOREDPAYMENTNOTE
      , :new.DOCCHANGEDATE
      , :new.UINCODE
      , :new.DOCOSN
      , :new.SIGNERS
      , :new.DESTCLSTYPE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.AUTOSANCTION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_FACIALFINCAPTION
  AFTER UPDATE
  ON TB_FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_FACIALFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_FACIALFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,SOURCEDOCNUM
      ,PAYDATE
      ,ACCEPTDATE
      ,DOCUMENTDATE
      ,REESTRDATE
      ,CREDIT
      ,SOURCEACCOUNT
      ,SOURCEFACIALACC_CLS
      ,DESTACCOUNT
      ,DESTFACIALACC_CLS
      ,PROGINDEX
      ,ARHIVEDOC
      ,PAYSYMBOLCLS
      ,PAYTYPECLS
      ,NOTE
      ,PERIOD
      ,PAYPRIORITY
      ,TYPEOPERATIONCLS
      ,BUHPAYMENTCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,RECORDINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,REESTR_REF
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CLIENTBANKNUMBER
      ,CRYPTOSTATUS
      ,TRUSTNUMBER
      ,LINKEDDOCUMENT
      ,BNKRECORDID
      ,SUBPROGINDEX
      ,DOCUMENTSTATE
      ,USERSVISA
      ,TREASUARYDOCSTATECLS
      ,DEPARTMENTCLS
      ,NDS
      ,TAXNOTE
      ,MANAGERBID
      ,BIDNUMBER
      ,GROUPID
      ,GROUPSUMMA
      ,DOCSTATEREF
      ,LASTEXTRCHANGE
      ,FAXDOCCOUNT
      ,STIMATEID
      ,INTEGRATEDDOCREF
      ,REQUESTNUMBER
      ,REQUESTDATE
      ,RVERSION
      ,FEDERALFUNDSREF
      ,ELDOCREF
      ,BUHOPERATIONCLS
      ,CLSTYPE
      ,OPERATIONDIRECTION
      ,SOURCETYPE
      ,DESTTYPE
      ,CARDNUMBER
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,CASHIERPERSONALINFO
      ,BIDDATE
      ,CARDREF
      ,SOURCESTOREDPAYMENTPROPS
      ,DESTSTOREDPAYMENTPROPS
      ,STOREDPAYMENTNOTE
      ,DOCCHANGEDATE
      ,UINCODE
      ,DOCOSN
      ,SIGNERS
      ,DESTCLSTYPE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,AUTOSANCTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.SOURCEDOCNUM
      , :new.PAYDATE
      , :new.ACCEPTDATE
      , :new.DOCUMENTDATE
      , :new.REESTRDATE
      , :new.CREDIT
      , :new.SOURCEACCOUNT
      , :new.SOURCEFACIALACC_CLS
      , :new.DESTACCOUNT
      , :new.DESTFACIALACC_CLS
      , :new.PROGINDEX
      , :new.ARHIVEDOC
      , :new.PAYSYMBOLCLS
      , :new.PAYTYPECLS
      , :new.NOTE
      , :new.PERIOD
      , :new.PAYPRIORITY
      , :new.TYPEOPERATIONCLS
      , :new.BUHPAYMENTCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REESTR_REF
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CLIENTBANKNUMBER
      , :new.CRYPTOSTATUS
      , :new.TRUSTNUMBER
      , :new.LINKEDDOCUMENT
      , :new.BNKRECORDID
      , :new.SUBPROGINDEX
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.TREASUARYDOCSTATECLS
      , :new.DEPARTMENTCLS
      , :new.NDS
      , :new.TAXNOTE
      , :new.MANAGERBID
      , :new.BIDNUMBER
      , :new.GROUPID
      , :new.GROUPSUMMA
      , :new.DOCSTATEREF
      , :new.LASTEXTRCHANGE
      , :new.FAXDOCCOUNT
      , :new.STIMATEID
      , :new.INTEGRATEDDOCREF
      , :new.REQUESTNUMBER
      , :new.REQUESTDATE
      , :new.RVERSION
      , :new.FEDERALFUNDSREF
      , :new.ELDOCREF
      , :new.BUHOPERATIONCLS
      , :new.CLSTYPE
      , :new.OPERATIONDIRECTION
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.CARDNUMBER
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.CASHIERPERSONALINFO
      , :new.BIDDATE
      , :new.CARDREF
      , :new.SOURCESTOREDPAYMENTPROPS
      , :new.DESTSTOREDPAYMENTPROPS
      , :new.STOREDPAYMENTNOTE
      , :new.DOCCHANGEDATE
      , :new.UINCODE
      , :new.DOCOSN
      , :new.SIGNERS
      , :new.DESTCLSTYPE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.AUTOSANCTION
    );
  else 
    update A_TB_FACIALFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_FACIALFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,SOURCEDOCNUM
      ,PAYDATE
      ,ACCEPTDATE
      ,DOCUMENTDATE
      ,REESTRDATE
      ,CREDIT
      ,SOURCEACCOUNT
      ,SOURCEFACIALACC_CLS
      ,DESTACCOUNT
      ,DESTFACIALACC_CLS
      ,PROGINDEX
      ,ARHIVEDOC
      ,PAYSYMBOLCLS
      ,PAYTYPECLS
      ,NOTE
      ,PERIOD
      ,PAYPRIORITY
      ,TYPEOPERATIONCLS
      ,BUHPAYMENTCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,RECORDINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,REESTR_REF
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CLIENTBANKNUMBER
      ,CRYPTOSTATUS
      ,TRUSTNUMBER
      ,LINKEDDOCUMENT
      ,BNKRECORDID
      ,SUBPROGINDEX
      ,DOCUMENTSTATE
      ,USERSVISA
      ,TREASUARYDOCSTATECLS
      ,DEPARTMENTCLS
      ,NDS
      ,TAXNOTE
      ,MANAGERBID
      ,BIDNUMBER
      ,GROUPID
      ,GROUPSUMMA
      ,DOCSTATEREF
      ,LASTEXTRCHANGE
      ,FAXDOCCOUNT
      ,STIMATEID
      ,INTEGRATEDDOCREF
      ,REQUESTNUMBER
      ,REQUESTDATE
      ,RVERSION
      ,FEDERALFUNDSREF
      ,ELDOCREF
      ,BUHOPERATIONCLS
      ,CLSTYPE
      ,OPERATIONDIRECTION
      ,SOURCETYPE
      ,DESTTYPE
      ,CARDNUMBER
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,CASHIERPERSONALINFO
      ,BIDDATE
      ,CARDREF
      ,SOURCESTOREDPAYMENTPROPS
      ,DESTSTOREDPAYMENTPROPS
      ,STOREDPAYMENTNOTE
      ,DOCCHANGEDATE
      ,UINCODE
      ,DOCOSN
      ,SIGNERS
      ,DESTCLSTYPE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,AUTOSANCTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.SOURCEDOCNUM
      , :new.PAYDATE
      , :new.ACCEPTDATE
      , :new.DOCUMENTDATE
      , :new.REESTRDATE
      , :new.CREDIT
      , :new.SOURCEACCOUNT
      , :new.SOURCEFACIALACC_CLS
      , :new.DESTACCOUNT
      , :new.DESTFACIALACC_CLS
      , :new.PROGINDEX
      , :new.ARHIVEDOC
      , :new.PAYSYMBOLCLS
      , :new.PAYTYPECLS
      , :new.NOTE
      , :new.PERIOD
      , :new.PAYPRIORITY
      , :new.TYPEOPERATIONCLS
      , :new.BUHPAYMENTCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REESTR_REF
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CLIENTBANKNUMBER
      , :new.CRYPTOSTATUS
      , :new.TRUSTNUMBER
      , :new.LINKEDDOCUMENT
      , :new.BNKRECORDID
      , :new.SUBPROGINDEX
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.TREASUARYDOCSTATECLS
      , :new.DEPARTMENTCLS
      , :new.NDS
      , :new.TAXNOTE
      , :new.MANAGERBID
      , :new.BIDNUMBER
      , :new.GROUPID
      , :new.GROUPSUMMA
      , :new.DOCSTATEREF
      , :new.LASTEXTRCHANGE
      , :new.FAXDOCCOUNT
      , :new.STIMATEID
      , :new.INTEGRATEDDOCREF
      , :new.REQUESTNUMBER
      , :new.REQUESTDATE
      , :new.RVERSION
      , :new.FEDERALFUNDSREF
      , :new.ELDOCREF
      , :new.BUHOPERATIONCLS
      , :new.CLSTYPE
      , :new.OPERATIONDIRECTION
      , :new.SOURCETYPE
      , :new.DESTTYPE
      , :new.CARDNUMBER
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.CASHIERPERSONALINFO
      , :new.BIDDATE
      , :new.CARDREF
      , :new.SOURCESTOREDPAYMENTPROPS
      , :new.DESTSTOREDPAYMENTPROPS
      , :new.STOREDPAYMENTNOTE
      , :new.DOCCHANGEDATE
      , :new.UINCODE
      , :new.DOCOSN
      , :new.SIGNERS
      , :new.DESTCLSTYPE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.AUTOSANCTION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_FACIALFINCAPTION
  AFTER DELETE
  ON TB_FACIALFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_FACIALFINDETAIL
  AFTER INSERT
  ON TB_FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALFINDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALFINDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEFACIALACC_CLS
      ,SOURCEKVR
      ,SOURCEKESR
      ,DESTFACIALACC_CLS
      ,DESTKVR
      ,DESTKESR
      ,BUDGETREF
      ,CREDIT
      ,PAYSYMBOLCLS
      ,MEMORDERNUM
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SOURCEKVSR
      ,SOURCEKCSR
      ,SOURCEKFSR
      ,SOURCESUBKESR
      ,SOURCEFACT
      ,SOURCEMEANSTYPE
      ,SOURCEFINSOURCE
      ,SOURCEFINTYPE
      ,DESTKVSR
      ,DESTKCSR
      ,DESTKFSR
      ,DESTSUBKESR
      ,DESTFACT
      ,DESTMEANSTYPE
      ,DESTFINSOURCE
      ,DESTFINTYPE
      ,REQUESTSINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,PROMISE
      ,SOURCEDOCTYPE
      ,DESTDOCTYPE
      ,SOURCEPROMISE
      ,DESTPROMISE
      ,RECORDINDEX2
      ,SOURCEBUDGETPROMISE
      ,DESTBUDGETPROMISE
      ,SUBPROGINDEX
      ,STIMATEID
      ,RVERSION
      ,SOURCEDIRECTIONCLS
      ,DESTDIRECTIONCLS
      ,SOURCEDOCBASE
      ,DESTDOCBASE
      ,SOURCEEXECDOC
      ,DESTEXECDOC
      ,BUHOPERATIONCLS
      ,SOURCEIFS
      ,DESTIFS
      ,CLSTYPE
      ,UNIONNOTIFYREF
      ,ACCEPTDATE
      ,SOURCEKD
      ,DESTKD
      ,SOURCEREGIONCLS
      ,DESTREGIONCLS
      ,DESTFUNDSSOURCE
      ,SOURCEFUNDSSOURCE
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,SOURCETRANSFERTCLS
      ,DESTTRANSFERTCLS
      ,DESTCLSTYPE
      ,SOURCEASSIGNMENTKIND
      ,DESTASSIGNMENTKIND
      ,SOURCEEXECINNERNUMBER
      ,DESTEXECINNERNUMBER
      ,SOURCESUBSIDYCLS
      ,DESTSUBSIDYCLS
      ,SOURCEFAORG_TYPE
      ,DESTFAORG_TYPE
      ,SOURCEBUDALLOCATIONCLS
      ,SOURCEPAYPROMISECLS
      ,DESTBUDALLOCATIONCLS
      ,DESTPAYPROMISECLS
      ,SOURCEINVESTOBJECT
      ,DESTINVESTOBJECT
      ,TRANSFERTORG_REF
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEFACIALACC_CLS
      , :new.SOURCEKVR
      , :new.SOURCEKESR
      , :new.DESTFACIALACC_CLS
      , :new.DESTKVR
      , :new.DESTKESR
      , :new.BUDGETREF
      , :new.CREDIT
      , :new.PAYSYMBOLCLS
      , :new.MEMORDERNUM
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SOURCEKVSR
      , :new.SOURCEKCSR
      , :new.SOURCEKFSR
      , :new.SOURCESUBKESR
      , :new.SOURCEFACT
      , :new.SOURCEMEANSTYPE
      , :new.SOURCEFINSOURCE
      , :new.SOURCEFINTYPE
      , :new.DESTKVSR
      , :new.DESTKCSR
      , :new.DESTKFSR
      , :new.DESTSUBKESR
      , :new.DESTFACT
      , :new.DESTMEANSTYPE
      , :new.DESTFINSOURCE
      , :new.DESTFINTYPE
      , :new.REQUESTSINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PROMISE
      , :new.SOURCEDOCTYPE
      , :new.DESTDOCTYPE
      , :new.SOURCEPROMISE
      , :new.DESTPROMISE
      , :new.RECORDINDEX2
      , :new.SOURCEBUDGETPROMISE
      , :new.DESTBUDGETPROMISE
      , :new.SUBPROGINDEX
      , :new.STIMATEID
      , :new.RVERSION
      , :new.SOURCEDIRECTIONCLS
      , :new.DESTDIRECTIONCLS
      , :new.SOURCEDOCBASE
      , :new.DESTDOCBASE
      , :new.SOURCEEXECDOC
      , :new.DESTEXECDOC
      , :new.BUHOPERATIONCLS
      , :new.SOURCEIFS
      , :new.DESTIFS
      , :new.CLSTYPE
      , :new.UNIONNOTIFYREF
      , :new.ACCEPTDATE
      , :new.SOURCEKD
      , :new.DESTKD
      , :new.SOURCEREGIONCLS
      , :new.DESTREGIONCLS
      , :new.DESTFUNDSSOURCE
      , :new.SOURCEFUNDSSOURCE
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.SOURCETRANSFERTCLS
      , :new.DESTTRANSFERTCLS
      , :new.DESTCLSTYPE
      , :new.SOURCEASSIGNMENTKIND
      , :new.DESTASSIGNMENTKIND
      , :new.SOURCEEXECINNERNUMBER
      , :new.DESTEXECINNERNUMBER
      , :new.SOURCESUBSIDYCLS
      , :new.DESTSUBSIDYCLS
      , :new.SOURCEFAORG_TYPE
      , :new.DESTFAORG_TYPE
      , :new.SOURCEBUDALLOCATIONCLS
      , :new.SOURCEPAYPROMISECLS
      , :new.DESTBUDALLOCATIONCLS
      , :new.DESTPAYPROMISECLS
      , :new.SOURCEINVESTOBJECT
      , :new.DESTINVESTOBJECT
      , :new.TRANSFERTORG_REF
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_FACIALFINDETAIL
  AFTER UPDATE
  ON TB_FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_FACIALFINDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_FACIALFINDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALFINDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEFACIALACC_CLS
      ,SOURCEKVR
      ,SOURCEKESR
      ,DESTFACIALACC_CLS
      ,DESTKVR
      ,DESTKESR
      ,BUDGETREF
      ,CREDIT
      ,PAYSYMBOLCLS
      ,MEMORDERNUM
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SOURCEKVSR
      ,SOURCEKCSR
      ,SOURCEKFSR
      ,SOURCESUBKESR
      ,SOURCEFACT
      ,SOURCEMEANSTYPE
      ,SOURCEFINSOURCE
      ,SOURCEFINTYPE
      ,DESTKVSR
      ,DESTKCSR
      ,DESTKFSR
      ,DESTSUBKESR
      ,DESTFACT
      ,DESTMEANSTYPE
      ,DESTFINSOURCE
      ,DESTFINTYPE
      ,REQUESTSINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,PROMISE
      ,SOURCEDOCTYPE
      ,DESTDOCTYPE
      ,SOURCEPROMISE
      ,DESTPROMISE
      ,RECORDINDEX2
      ,SOURCEBUDGETPROMISE
      ,DESTBUDGETPROMISE
      ,SUBPROGINDEX
      ,STIMATEID
      ,RVERSION
      ,SOURCEDIRECTIONCLS
      ,DESTDIRECTIONCLS
      ,SOURCEDOCBASE
      ,DESTDOCBASE
      ,SOURCEEXECDOC
      ,DESTEXECDOC
      ,BUHOPERATIONCLS
      ,SOURCEIFS
      ,DESTIFS
      ,CLSTYPE
      ,UNIONNOTIFYREF
      ,ACCEPTDATE
      ,SOURCEKD
      ,DESTKD
      ,SOURCEREGIONCLS
      ,DESTREGIONCLS
      ,DESTFUNDSSOURCE
      ,SOURCEFUNDSSOURCE
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,SOURCETRANSFERTCLS
      ,DESTTRANSFERTCLS
      ,DESTCLSTYPE
      ,SOURCEASSIGNMENTKIND
      ,DESTASSIGNMENTKIND
      ,SOURCEEXECINNERNUMBER
      ,DESTEXECINNERNUMBER
      ,SOURCESUBSIDYCLS
      ,DESTSUBSIDYCLS
      ,SOURCEFAORG_TYPE
      ,DESTFAORG_TYPE
      ,SOURCEBUDALLOCATIONCLS
      ,SOURCEPAYPROMISECLS
      ,DESTBUDALLOCATIONCLS
      ,DESTPAYPROMISECLS
      ,SOURCEINVESTOBJECT
      ,DESTINVESTOBJECT
      ,TRANSFERTORG_REF
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEFACIALACC_CLS
      , :new.SOURCEKVR
      , :new.SOURCEKESR
      , :new.DESTFACIALACC_CLS
      , :new.DESTKVR
      , :new.DESTKESR
      , :new.BUDGETREF
      , :new.CREDIT
      , :new.PAYSYMBOLCLS
      , :new.MEMORDERNUM
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SOURCEKVSR
      , :new.SOURCEKCSR
      , :new.SOURCEKFSR
      , :new.SOURCESUBKESR
      , :new.SOURCEFACT
      , :new.SOURCEMEANSTYPE
      , :new.SOURCEFINSOURCE
      , :new.SOURCEFINTYPE
      , :new.DESTKVSR
      , :new.DESTKCSR
      , :new.DESTKFSR
      , :new.DESTSUBKESR
      , :new.DESTFACT
      , :new.DESTMEANSTYPE
      , :new.DESTFINSOURCE
      , :new.DESTFINTYPE
      , :new.REQUESTSINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PROMISE
      , :new.SOURCEDOCTYPE
      , :new.DESTDOCTYPE
      , :new.SOURCEPROMISE
      , :new.DESTPROMISE
      , :new.RECORDINDEX2
      , :new.SOURCEBUDGETPROMISE
      , :new.DESTBUDGETPROMISE
      , :new.SUBPROGINDEX
      , :new.STIMATEID
      , :new.RVERSION
      , :new.SOURCEDIRECTIONCLS
      , :new.DESTDIRECTIONCLS
      , :new.SOURCEDOCBASE
      , :new.DESTDOCBASE
      , :new.SOURCEEXECDOC
      , :new.DESTEXECDOC
      , :new.BUHOPERATIONCLS
      , :new.SOURCEIFS
      , :new.DESTIFS
      , :new.CLSTYPE
      , :new.UNIONNOTIFYREF
      , :new.ACCEPTDATE
      , :new.SOURCEKD
      , :new.DESTKD
      , :new.SOURCEREGIONCLS
      , :new.DESTREGIONCLS
      , :new.DESTFUNDSSOURCE
      , :new.SOURCEFUNDSSOURCE
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.SOURCETRANSFERTCLS
      , :new.DESTTRANSFERTCLS
      , :new.DESTCLSTYPE
      , :new.SOURCEASSIGNMENTKIND
      , :new.DESTASSIGNMENTKIND
      , :new.SOURCEEXECINNERNUMBER
      , :new.DESTEXECINNERNUMBER
      , :new.SOURCESUBSIDYCLS
      , :new.DESTSUBSIDYCLS
      , :new.SOURCEFAORG_TYPE
      , :new.DESTFAORG_TYPE
      , :new.SOURCEBUDALLOCATIONCLS
      , :new.SOURCEPAYPROMISECLS
      , :new.DESTBUDALLOCATIONCLS
      , :new.DESTPAYPROMISECLS
      , :new.SOURCEINVESTOBJECT
      , :new.DESTINVESTOBJECT
      , :new.TRANSFERTORG_REF
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TB_FACIALFINDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_FACIALFINDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SOURCEFACIALACC_CLS
      ,SOURCEKVR
      ,SOURCEKESR
      ,DESTFACIALACC_CLS
      ,DESTKVR
      ,DESTKESR
      ,BUDGETREF
      ,CREDIT
      ,PAYSYMBOLCLS
      ,MEMORDERNUM
      ,NOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SOURCEKVSR
      ,SOURCEKCSR
      ,SOURCEKFSR
      ,SOURCESUBKESR
      ,SOURCEFACT
      ,SOURCEMEANSTYPE
      ,SOURCEFINSOURCE
      ,SOURCEFINTYPE
      ,DESTKVSR
      ,DESTKCSR
      ,DESTKFSR
      ,DESTSUBKESR
      ,DESTFACT
      ,DESTMEANSTYPE
      ,DESTFINSOURCE
      ,DESTFINTYPE
      ,REQUESTSINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,PROMISE
      ,SOURCEDOCTYPE
      ,DESTDOCTYPE
      ,SOURCEPROMISE
      ,DESTPROMISE
      ,RECORDINDEX2
      ,SOURCEBUDGETPROMISE
      ,DESTBUDGETPROMISE
      ,SUBPROGINDEX
      ,STIMATEID
      ,RVERSION
      ,SOURCEDIRECTIONCLS
      ,DESTDIRECTIONCLS
      ,SOURCEDOCBASE
      ,DESTDOCBASE
      ,SOURCEEXECDOC
      ,DESTEXECDOC
      ,BUHOPERATIONCLS
      ,SOURCEIFS
      ,DESTIFS
      ,CLSTYPE
      ,UNIONNOTIFYREF
      ,ACCEPTDATE
      ,SOURCEKD
      ,DESTKD
      ,SOURCEREGIONCLS
      ,DESTREGIONCLS
      ,DESTFUNDSSOURCE
      ,SOURCEFUNDSSOURCE
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,SOURCETRANSFERTCLS
      ,DESTTRANSFERTCLS
      ,DESTCLSTYPE
      ,SOURCEASSIGNMENTKIND
      ,DESTASSIGNMENTKIND
      ,SOURCEEXECINNERNUMBER
      ,DESTEXECINNERNUMBER
      ,SOURCESUBSIDYCLS
      ,DESTSUBSIDYCLS
      ,SOURCEFAORG_TYPE
      ,DESTFAORG_TYPE
      ,SOURCEBUDALLOCATIONCLS
      ,SOURCEPAYPROMISECLS
      ,DESTBUDALLOCATIONCLS
      ,DESTPAYPROMISECLS
      ,SOURCEINVESTOBJECT
      ,DESTINVESTOBJECT
      ,TRANSFERTORG_REF
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SOURCEFACIALACC_CLS
      , :new.SOURCEKVR
      , :new.SOURCEKESR
      , :new.DESTFACIALACC_CLS
      , :new.DESTKVR
      , :new.DESTKESR
      , :new.BUDGETREF
      , :new.CREDIT
      , :new.PAYSYMBOLCLS
      , :new.MEMORDERNUM
      , :new.NOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SOURCEKVSR
      , :new.SOURCEKCSR
      , :new.SOURCEKFSR
      , :new.SOURCESUBKESR
      , :new.SOURCEFACT
      , :new.SOURCEMEANSTYPE
      , :new.SOURCEFINSOURCE
      , :new.SOURCEFINTYPE
      , :new.DESTKVSR
      , :new.DESTKCSR
      , :new.DESTKFSR
      , :new.DESTSUBKESR
      , :new.DESTFACT
      , :new.DESTMEANSTYPE
      , :new.DESTFINSOURCE
      , :new.DESTFINTYPE
      , :new.REQUESTSINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.PROMISE
      , :new.SOURCEDOCTYPE
      , :new.DESTDOCTYPE
      , :new.SOURCEPROMISE
      , :new.DESTPROMISE
      , :new.RECORDINDEX2
      , :new.SOURCEBUDGETPROMISE
      , :new.DESTBUDGETPROMISE
      , :new.SUBPROGINDEX
      , :new.STIMATEID
      , :new.RVERSION
      , :new.SOURCEDIRECTIONCLS
      , :new.DESTDIRECTIONCLS
      , :new.SOURCEDOCBASE
      , :new.DESTDOCBASE
      , :new.SOURCEEXECDOC
      , :new.DESTEXECDOC
      , :new.BUHOPERATIONCLS
      , :new.SOURCEIFS
      , :new.DESTIFS
      , :new.CLSTYPE
      , :new.UNIONNOTIFYREF
      , :new.ACCEPTDATE
      , :new.SOURCEKD
      , :new.DESTKD
      , :new.SOURCEREGIONCLS
      , :new.DESTREGIONCLS
      , :new.DESTFUNDSSOURCE
      , :new.SOURCEFUNDSSOURCE
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.SOURCETRANSFERTCLS
      , :new.DESTTRANSFERTCLS
      , :new.DESTCLSTYPE
      , :new.SOURCEASSIGNMENTKIND
      , :new.DESTASSIGNMENTKIND
      , :new.SOURCEEXECINNERNUMBER
      , :new.DESTEXECINNERNUMBER
      , :new.SOURCESUBSIDYCLS
      , :new.DESTSUBSIDYCLS
      , :new.SOURCEFAORG_TYPE
      , :new.DESTFAORG_TYPE
      , :new.SOURCEBUDALLOCATIONCLS
      , :new.SOURCEPAYPROMISECLS
      , :new.DESTBUDALLOCATIONCLS
      , :new.DESTPAYPROMISECLS
      , :new.SOURCEINVESTOBJECT
      , :new.DESTINVESTOBJECT
      , :new.TRANSFERTORG_REF
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_FACIALFINDETAIL
  AFTER DELETE
  ON TB_FACIALFINDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALFINDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_FACIALFINREESTR
  AFTER INSERT
  ON TB_FACIALFINREESTR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALFINREESTR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALFINREESTR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REESTRNUMBER
      ,REESTRDATE
      ,REESTRTYPE
      ,ACCEPTED
      ,SESSIONNUMBER
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,PACKETNUMBER
      ,FICTIVEDOC
      ,FACIALACC_CLS
      ,SUMMA
      ,NOTE
      ,REESTRTYPEEX
      ,RECORDINDEX
      ,DOCSTATEREF
      ,RVERSION
      ,CRYPTOSTATUS
      ,DEPARTMENTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REESTRNUMBER
      , :new.REESTRDATE
      , :new.REESTRTYPE
      , :new.ACCEPTED
      , :new.SESSIONNUMBER
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.PACKETNUMBER
      , :new.FICTIVEDOC
      , :new.FACIALACC_CLS
      , :new.SUMMA
      , :new.NOTE
      , :new.REESTRTYPEEX
      , :new.RECORDINDEX
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.DEPARTMENTCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_FACIALFINREESTR
  AFTER UPDATE
  ON TB_FACIALFINREESTR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_FACIALFINREESTR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_FACIALFINREESTR
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FACIALFINREESTR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REESTRNUMBER
      ,REESTRDATE
      ,REESTRTYPE
      ,ACCEPTED
      ,SESSIONNUMBER
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,PACKETNUMBER
      ,FICTIVEDOC
      ,FACIALACC_CLS
      ,SUMMA
      ,NOTE
      ,REESTRTYPEEX
      ,RECORDINDEX
      ,DOCSTATEREF
      ,RVERSION
      ,CRYPTOSTATUS
      ,DEPARTMENTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REESTRNUMBER
      , :new.REESTRDATE
      , :new.REESTRTYPE
      , :new.ACCEPTED
      , :new.SESSIONNUMBER
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.PACKETNUMBER
      , :new.FICTIVEDOC
      , :new.FACIALACC_CLS
      , :new.SUMMA
      , :new.NOTE
      , :new.REESTRTYPEEX
      , :new.RECORDINDEX
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.DEPARTMENTCLS
    );
  else 
    update A_TB_FACIALFINREESTR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_FACIALFINREESTR (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REESTRNUMBER
      ,REESTRDATE
      ,REESTRTYPE
      ,ACCEPTED
      ,SESSIONNUMBER
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,PACKETNUMBER
      ,FICTIVEDOC
      ,FACIALACC_CLS
      ,SUMMA
      ,NOTE
      ,REESTRTYPEEX
      ,RECORDINDEX
      ,DOCSTATEREF
      ,RVERSION
      ,CRYPTOSTATUS
      ,DEPARTMENTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REESTRNUMBER
      , :new.REESTRDATE
      , :new.REESTRTYPE
      , :new.ACCEPTED
      , :new.SESSIONNUMBER
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.PACKETNUMBER
      , :new.FICTIVEDOC
      , :new.FACIALACC_CLS
      , :new.SUMMA
      , :new.NOTE
      , :new.REESTRTYPEEX
      , :new.RECORDINDEX
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CRYPTOSTATUS
      , :new.DEPARTMENTCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_FACIALFINREESTR
  AFTER DELETE
  ON TB_FACIALFINREESTR
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FACIALFINREESTR
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_FINDOCDETAIL
  AFTER INSERT
  ON TB_FINDOCDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FINDOCDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FINDOCDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,FINSOURCE
      ,REGIONCLS
      ,DOCTYPE
      ,FINTYPE
      ,CURRENCYCLS
      ,MEANSTYPE
      ,DFACCOUNT
      ,ACCOUNTREF
      ,ACCEPTDATE
      ,BUDGETREF
      ,SUMMA
      ,CREDIT
      ,DEBIT
      ,NOTE
      ,USERFLAG
      ,SOURCEDOCNUM
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ACCEPTORACCREF
      ,FACIALACC_CLS
      ,RECORDINDEX2
      ,BUHPAYMENTCLS
      ,REQUESTSINDEX
      ,PLANDATE
      ,PROMISE
      ,RECORDINDEX3
      ,RECORDDATE
      ,TOTALREF
      ,DOCUMENTBASETYPE
      ,TAXNOTE
      ,CURRENCYSUMMA
      ,RVERSION
      ,FEDERALFUNDSREF
      ,DIRECTIONCLS
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,DOCNUMBER
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,CLSTYPE
      ,UNIONNOTIFYREF
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.FINSOURCE
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.FINTYPE
      , :new.CURRENCYCLS
      , :new.MEANSTYPE
      , :new.DFACCOUNT
      , :new.ACCOUNTREF
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CREDIT
      , :new.DEBIT
      , :new.NOTE
      , :new.USERFLAG
      , :new.SOURCEDOCNUM
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ACCEPTORACCREF
      , :new.FACIALACC_CLS
      , :new.RECORDINDEX2
      , :new.BUHPAYMENTCLS
      , :new.REQUESTSINDEX
      , :new.PLANDATE
      , :new.PROMISE
      , :new.RECORDINDEX3
      , :new.RECORDDATE
      , :new.TOTALREF
      , :new.DOCUMENTBASETYPE
      , :new.TAXNOTE
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.FEDERALFUNDSREF
      , :new.DIRECTIONCLS
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.DOCNUMBER
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.UNIONNOTIFYREF
      , :new.TRANSFERTCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_FINDOCDETAIL
  AFTER UPDATE
  ON TB_FINDOCDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_FINDOCDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_FINDOCDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_FINDOCDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,FINSOURCE
      ,REGIONCLS
      ,DOCTYPE
      ,FINTYPE
      ,CURRENCYCLS
      ,MEANSTYPE
      ,DFACCOUNT
      ,ACCOUNTREF
      ,ACCEPTDATE
      ,BUDGETREF
      ,SUMMA
      ,CREDIT
      ,DEBIT
      ,NOTE
      ,USERFLAG
      ,SOURCEDOCNUM
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ACCEPTORACCREF
      ,FACIALACC_CLS
      ,RECORDINDEX2
      ,BUHPAYMENTCLS
      ,REQUESTSINDEX
      ,PLANDATE
      ,PROMISE
      ,RECORDINDEX3
      ,RECORDDATE
      ,TOTALREF
      ,DOCUMENTBASETYPE
      ,TAXNOTE
      ,CURRENCYSUMMA
      ,RVERSION
      ,FEDERALFUNDSREF
      ,DIRECTIONCLS
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,DOCNUMBER
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,CLSTYPE
      ,UNIONNOTIFYREF
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.FINSOURCE
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.FINTYPE
      , :new.CURRENCYCLS
      , :new.MEANSTYPE
      , :new.DFACCOUNT
      , :new.ACCOUNTREF
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CREDIT
      , :new.DEBIT
      , :new.NOTE
      , :new.USERFLAG
      , :new.SOURCEDOCNUM
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ACCEPTORACCREF
      , :new.FACIALACC_CLS
      , :new.RECORDINDEX2
      , :new.BUHPAYMENTCLS
      , :new.REQUESTSINDEX
      , :new.PLANDATE
      , :new.PROMISE
      , :new.RECORDINDEX3
      , :new.RECORDDATE
      , :new.TOTALREF
      , :new.DOCUMENTBASETYPE
      , :new.TAXNOTE
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.FEDERALFUNDSREF
      , :new.DIRECTIONCLS
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.DOCNUMBER
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.UNIONNOTIFYREF
      , :new.TRANSFERTCLS
    );
  else 
    update A_TB_FINDOCDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_FINDOCDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACT
      ,FINSOURCE
      ,REGIONCLS
      ,DOCTYPE
      ,FINTYPE
      ,CURRENCYCLS
      ,MEANSTYPE
      ,DFACCOUNT
      ,ACCOUNTREF
      ,ACCEPTDATE
      ,BUDGETREF
      ,SUMMA
      ,CREDIT
      ,DEBIT
      ,NOTE
      ,USERFLAG
      ,SOURCEDOCNUM
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ACCEPTORACCREF
      ,FACIALACC_CLS
      ,RECORDINDEX2
      ,BUHPAYMENTCLS
      ,REQUESTSINDEX
      ,PLANDATE
      ,PROMISE
      ,RECORDINDEX3
      ,RECORDDATE
      ,TOTALREF
      ,DOCUMENTBASETYPE
      ,TAXNOTE
      ,CURRENCYSUMMA
      ,RVERSION
      ,FEDERALFUNDSREF
      ,DIRECTIONCLS
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,DOCNUMBER
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,CLSTYPE
      ,UNIONNOTIFYREF
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACT
      , :new.FINSOURCE
      , :new.REGIONCLS
      , :new.DOCTYPE
      , :new.FINTYPE
      , :new.CURRENCYCLS
      , :new.MEANSTYPE
      , :new.DFACCOUNT
      , :new.ACCOUNTREF
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.SUMMA
      , :new.CREDIT
      , :new.DEBIT
      , :new.NOTE
      , :new.USERFLAG
      , :new.SOURCEDOCNUM
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ACCEPTORACCREF
      , :new.FACIALACC_CLS
      , :new.RECORDINDEX2
      , :new.BUHPAYMENTCLS
      , :new.REQUESTSINDEX
      , :new.PLANDATE
      , :new.PROMISE
      , :new.RECORDINDEX3
      , :new.RECORDDATE
      , :new.TOTALREF
      , :new.DOCUMENTBASETYPE
      , :new.TAXNOTE
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.FEDERALFUNDSREF
      , :new.DIRECTIONCLS
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.DOCNUMBER
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.UNIONNOTIFYREF
      , :new.TRANSFERTCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_FINDOCDETAIL
  AFTER DELETE
  ON TB_FINDOCDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_FINDOCDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_INCOMES32
  AFTER INSERT
  ON TB_INCOMES32
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_INCOMES32
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_INCOMES32 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,DOCCOUNT
      ,IDATE
      ,DEBIT
      ,CREDIT
      ,DOCTYPE
      ,INN
      ,ORG_REF
      ,ACCOUNTINDEX
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,GOSNI
      ,INCACCOUNT
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NOTE
      ,RECORDINDEX2
      ,ELNUM
      ,NOTEEX
      ,BUHPAYMENTCLS
      ,ACCOUNTREF
      ,ELPACKETNUM
      ,FACIALACC_CLS
      ,NDS
      ,MEANSTYPE
      ,RECORDDATE
      ,TOTALREF
      ,REQUESTSINDEX
      ,KVSR
      ,TAXNOTE
      ,DOCNUM
      ,REALPAYERORG_REF
      ,DOCDATE
      ,DOCBASE
      ,FACT
      ,RVERSION
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,SUMCOMPLETE
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,FEDERALFUNDSREF
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,CLSTYPE
      ,NDSNOTE
      ,DOGNUM
      ,SENDERID
      ,SENDERRECORDID
      ,OKATO
      ,ADDOKATO
      ,REJECTCLS
      ,REJECTCAUSE
      ,FUNDSSOURCE
      ,DIRECTIONCLS
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,FAORGTYPE
      ,OKTMO
      ,UINCODE
      ,FINTYPE
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.DOCCOUNT
      , :new.IDATE
      , :new.DEBIT
      , :new.CREDIT
      , :new.DOCTYPE
      , :new.INN
      , :new.ORG_REF
      , :new.ACCOUNTINDEX
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.GOSNI
      , :new.INCACCOUNT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NOTE
      , :new.RECORDINDEX2
      , :new.ELNUM
      , :new.NOTEEX
      , :new.BUHPAYMENTCLS
      , :new.ACCOUNTREF
      , :new.ELPACKETNUM
      , :new.FACIALACC_CLS
      , :new.NDS
      , :new.MEANSTYPE
      , :new.RECORDDATE
      , :new.TOTALREF
      , :new.REQUESTSINDEX
      , :new.KVSR
      , :new.TAXNOTE
      , :new.DOCNUM
      , :new.REALPAYERORG_REF
      , :new.DOCDATE
      , :new.DOCBASE
      , :new.FACT
      , :new.RVERSION
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.SUMCOMPLETE
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.FEDERALFUNDSREF
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.NDSNOTE
      , :new.DOGNUM
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.OKATO
      , :new.ADDOKATO
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.FUNDSSOURCE
      , :new.DIRECTIONCLS
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.FAORGTYPE
      , :new.OKTMO
      , :new.UINCODE
      , :new.FINTYPE
      , :new.INVESTOBJECT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_INCOMES32
  AFTER UPDATE
  ON TB_INCOMES32
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_INCOMES32
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_INCOMES32
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_INCOMES32 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,DOCCOUNT
      ,IDATE
      ,DEBIT
      ,CREDIT
      ,DOCTYPE
      ,INN
      ,ORG_REF
      ,ACCOUNTINDEX
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,GOSNI
      ,INCACCOUNT
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NOTE
      ,RECORDINDEX2
      ,ELNUM
      ,NOTEEX
      ,BUHPAYMENTCLS
      ,ACCOUNTREF
      ,ELPACKETNUM
      ,FACIALACC_CLS
      ,NDS
      ,MEANSTYPE
      ,RECORDDATE
      ,TOTALREF
      ,REQUESTSINDEX
      ,KVSR
      ,TAXNOTE
      ,DOCNUM
      ,REALPAYERORG_REF
      ,DOCDATE
      ,DOCBASE
      ,FACT
      ,RVERSION
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,SUMCOMPLETE
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,FEDERALFUNDSREF
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,CLSTYPE
      ,NDSNOTE
      ,DOGNUM
      ,SENDERID
      ,SENDERRECORDID
      ,OKATO
      ,ADDOKATO
      ,REJECTCLS
      ,REJECTCAUSE
      ,FUNDSSOURCE
      ,DIRECTIONCLS
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,FAORGTYPE
      ,OKTMO
      ,UINCODE
      ,FINTYPE
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.DOCCOUNT
      , :new.IDATE
      , :new.DEBIT
      , :new.CREDIT
      , :new.DOCTYPE
      , :new.INN
      , :new.ORG_REF
      , :new.ACCOUNTINDEX
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.GOSNI
      , :new.INCACCOUNT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NOTE
      , :new.RECORDINDEX2
      , :new.ELNUM
      , :new.NOTEEX
      , :new.BUHPAYMENTCLS
      , :new.ACCOUNTREF
      , :new.ELPACKETNUM
      , :new.FACIALACC_CLS
      , :new.NDS
      , :new.MEANSTYPE
      , :new.RECORDDATE
      , :new.TOTALREF
      , :new.REQUESTSINDEX
      , :new.KVSR
      , :new.TAXNOTE
      , :new.DOCNUM
      , :new.REALPAYERORG_REF
      , :new.DOCDATE
      , :new.DOCBASE
      , :new.FACT
      , :new.RVERSION
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.SUMCOMPLETE
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.FEDERALFUNDSREF
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.NDSNOTE
      , :new.DOGNUM
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.OKATO
      , :new.ADDOKATO
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.FUNDSSOURCE
      , :new.DIRECTIONCLS
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.FAORGTYPE
      , :new.OKTMO
      , :new.UINCODE
      , :new.FINTYPE
      , :new.INVESTOBJECT
    );
  else 
    update A_TB_INCOMES32
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_INCOMES32 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DOCNUMBER
      ,DOCCOUNT
      ,IDATE
      ,DEBIT
      ,CREDIT
      ,DOCTYPE
      ,INN
      ,ORG_REF
      ,ACCOUNTINDEX
      ,KD
      ,SUBKD
      ,REGIONCLS
      ,GOSNI
      ,INCACCOUNT
      ,PROGINDEX
      ,RECORDINDEX
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,NOTE
      ,RECORDINDEX2
      ,ELNUM
      ,NOTEEX
      ,BUHPAYMENTCLS
      ,ACCOUNTREF
      ,ELPACKETNUM
      ,FACIALACC_CLS
      ,NDS
      ,MEANSTYPE
      ,RECORDDATE
      ,TOTALREF
      ,REQUESTSINDEX
      ,KVSR
      ,TAXNOTE
      ,DOCNUM
      ,REALPAYERORG_REF
      ,DOCDATE
      ,DOCBASE
      ,FACT
      ,RVERSION
      ,KFSR
      ,KESR
      ,KVR
      ,KCSR
      ,SUMCOMPLETE
      ,ELDOCREF
      ,REQUESTSINDEX2
      ,FEDERALFUNDSREF
      ,BUHOPERATIONCLS
      ,IFS
      ,IFS_CORR
      ,CLSTYPE
      ,NDSNOTE
      ,DOGNUM
      ,SENDERID
      ,SENDERRECORDID
      ,OKATO
      ,ADDOKATO
      ,REJECTCLS
      ,REJECTCAUSE
      ,FUNDSSOURCE
      ,DIRECTIONCLS
      ,ISBLOCKED
      ,BLOCKEDCAUSE
      ,UNBLOCKEDDATE
      ,UNBLOCKEDCAUSE
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,FAORGTYPE
      ,OKTMO
      ,UINCODE
      ,FINTYPE
      ,INVESTOBJECT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DOCNUMBER
      , :new.DOCCOUNT
      , :new.IDATE
      , :new.DEBIT
      , :new.CREDIT
      , :new.DOCTYPE
      , :new.INN
      , :new.ORG_REF
      , :new.ACCOUNTINDEX
      , :new.KD
      , :new.SUBKD
      , :new.REGIONCLS
      , :new.GOSNI
      , :new.INCACCOUNT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.NOTE
      , :new.RECORDINDEX2
      , :new.ELNUM
      , :new.NOTEEX
      , :new.BUHPAYMENTCLS
      , :new.ACCOUNTREF
      , :new.ELPACKETNUM
      , :new.FACIALACC_CLS
      , :new.NDS
      , :new.MEANSTYPE
      , :new.RECORDDATE
      , :new.TOTALREF
      , :new.REQUESTSINDEX
      , :new.KVSR
      , :new.TAXNOTE
      , :new.DOCNUM
      , :new.REALPAYERORG_REF
      , :new.DOCDATE
      , :new.DOCBASE
      , :new.FACT
      , :new.RVERSION
      , :new.KFSR
      , :new.KESR
      , :new.KVR
      , :new.KCSR
      , :new.SUMCOMPLETE
      , :new.ELDOCREF
      , :new.REQUESTSINDEX2
      , :new.FEDERALFUNDSREF
      , :new.BUHOPERATIONCLS
      , :new.IFS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.NDSNOTE
      , :new.DOGNUM
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.OKATO
      , :new.ADDOKATO
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.FUNDSSOURCE
      , :new.DIRECTIONCLS
      , :new.ISBLOCKED
      , :new.BLOCKEDCAUSE
      , :new.UNBLOCKEDDATE
      , :new.UNBLOCKEDCAUSE
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.FAORGTYPE
      , :new.OKTMO
      , :new.UINCODE
      , :new.FINTYPE
      , :new.INVESTOBJECT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_INCOMES32
  AFTER DELETE
  ON TB_INCOMES32
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_INCOMES32
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_INNERFINSOURCE
  AFTER INSERT
  ON TB_INNERFINSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_INNERFINSOURCE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_INNERFINSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,DIRECTION
      ,KVSR
      ,DESCRIPTIONCODE
      ,MAINDESCRIPTIONCODE
      ,ITEMCODE
      ,PROGRAMCODE
      ,KESR
      ,FINSOURCEVALUE
      ,UNIONFLAG
      ,REMOTEFLAG
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CLSASPECT
      ,CREATERUSER
      ,UPDATERUSER
      ,IFS_LEVEL
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,ANALYTICALGROUPIFS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DIRECTION
      , :new.KVSR
      , :new.DESCRIPTIONCODE
      , :new.MAINDESCRIPTIONCODE
      , :new.ITEMCODE
      , :new.PROGRAMCODE
      , :new.KESR
      , :new.FINSOURCEVALUE
      , :new.UNIONFLAG
      , :new.REMOTEFLAG
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CLSASPECT
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.IFS_LEVEL
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.ANALYTICALGROUPIFS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_INNERFINSOURCE
  AFTER UPDATE
  ON TB_INNERFINSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_INNERFINSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_INNERFINSOURCE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_INNERFINSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,DIRECTION
      ,KVSR
      ,DESCRIPTIONCODE
      ,MAINDESCRIPTIONCODE
      ,ITEMCODE
      ,PROGRAMCODE
      ,KESR
      ,FINSOURCEVALUE
      ,UNIONFLAG
      ,REMOTEFLAG
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CLSASPECT
      ,CREATERUSER
      ,UPDATERUSER
      ,IFS_LEVEL
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,ANALYTICALGROUPIFS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DIRECTION
      , :new.KVSR
      , :new.DESCRIPTIONCODE
      , :new.MAINDESCRIPTIONCODE
      , :new.ITEMCODE
      , :new.PROGRAMCODE
      , :new.KESR
      , :new.FINSOURCEVALUE
      , :new.UNIONFLAG
      , :new.REMOTEFLAG
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CLSASPECT
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.IFS_LEVEL
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.ANALYTICALGROUPIFS
    );
  else 
    update A_TB_INNERFINSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_INNERFINSOURCE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,DIRECTION
      ,KVSR
      ,DESCRIPTIONCODE
      ,MAINDESCRIPTIONCODE
      ,ITEMCODE
      ,PROGRAMCODE
      ,KESR
      ,FINSOURCEVALUE
      ,UNIONFLAG
      ,REMOTEFLAG
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,STARTDATE
      ,SHORTNAME
      ,CLSASPECT
      ,CREATERUSER
      ,UPDATERUSER
      ,IFS_LEVEL
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,ANALYTICALGROUPIFS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DIRECTION
      , :new.KVSR
      , :new.DESCRIPTIONCODE
      , :new.MAINDESCRIPTIONCODE
      , :new.ITEMCODE
      , :new.PROGRAMCODE
      , :new.KESR
      , :new.FINSOURCEVALUE
      , :new.UNIONFLAG
      , :new.REMOTEFLAG
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CLSASPECT
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.IFS_LEVEL
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.ANALYTICALGROUPIFS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_INNERFINSOURCE
  AFTER DELETE
  ON TB_INNERFINSOURCE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_INNERFINSOURCE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_INTERFACES
  AFTER INSERT
  ON TB_INTERFACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_INTERFACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_INTERFACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
      ,NOTE
      ,PARAM
      ,CLS
      ,INTERFACETYPE
      ,PARAMCOLLECTION
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
      , :new.NOTE
      , :new.PARAM
      , :new.CLS
      , :new.INTERFACETYPE
      , :new.PARAMCOLLECTION
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_INTERFACES
  AFTER UPDATE
  ON TB_INTERFACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_INTERFACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_INTERFACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_INTERFACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
      ,NOTE
      ,PARAM
      ,CLS
      ,INTERFACETYPE
      ,PARAMCOLLECTION
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
      , :new.NOTE
      , :new.PARAM
      , :new.CLS
      , :new.INTERFACETYPE
      , :new.PARAMCOLLECTION
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_TB_INTERFACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_INTERFACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GUID
      ,NOTE
      ,PARAM
      ,CLS
      ,INTERFACETYPE
      ,PARAMCOLLECTION
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GUID
      , :new.NOTE
      , :new.PARAM
      , :new.CLS
      , :new.INTERFACETYPE
      , :new.PARAMCOLLECTION
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_INTERFACES
  AFTER DELETE
  ON TB_INTERFACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_INTERFACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_KD
  AFTER INSERT
  ON TB_KD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_KD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_KD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REPCODE
      ,CREATEDATE
      ,UPDATEDATE
      ,KVSR
      ,DESCRIPTIONCODE
      ,MAINDESCRIPTIONCODE
      ,ITEMCODE
      ,PROGRAMCODE
      ,KESR
      ,KDVALUE
      ,REMOTEFLAG
      ,UNIONFLAG
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,KD_LEVEL
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,ANALYTICALGROUPKD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REPCODE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KVSR
      , :new.DESCRIPTIONCODE
      , :new.MAINDESCRIPTIONCODE
      , :new.ITEMCODE
      , :new.PROGRAMCODE
      , :new.KESR
      , :new.KDVALUE
      , :new.REMOTEFLAG
      , :new.UNIONFLAG
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.KD_LEVEL
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.ANALYTICALGROUPKD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_KD
  AFTER UPDATE
  ON TB_KD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_KD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_KD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_KD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REPCODE
      ,CREATEDATE
      ,UPDATEDATE
      ,KVSR
      ,DESCRIPTIONCODE
      ,MAINDESCRIPTIONCODE
      ,ITEMCODE
      ,PROGRAMCODE
      ,KESR
      ,KDVALUE
      ,REMOTEFLAG
      ,UNIONFLAG
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,KD_LEVEL
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,ANALYTICALGROUPKD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REPCODE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KVSR
      , :new.DESCRIPTIONCODE
      , :new.MAINDESCRIPTIONCODE
      , :new.ITEMCODE
      , :new.PROGRAMCODE
      , :new.KESR
      , :new.KDVALUE
      , :new.REMOTEFLAG
      , :new.UNIONFLAG
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.KD_LEVEL
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.ANALYTICALGROUPKD
    );
  else 
    update A_TB_KD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_KD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REPCODE
      ,CREATEDATE
      ,UPDATEDATE
      ,KVSR
      ,DESCRIPTIONCODE
      ,MAINDESCRIPTIONCODE
      ,ITEMCODE
      ,PROGRAMCODE
      ,KESR
      ,KDVALUE
      ,REMOTEFLAG
      ,UNIONFLAG
      ,BUDGETREF
      ,DELETEDATE
      ,NAME
      ,KD_LEVEL
      ,STARTDATE
      ,SHORTNAME
      ,CREATERUSER
      ,UPDATERUSER
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,ANALYTICALGROUPKD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REPCODE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.KVSR
      , :new.DESCRIPTIONCODE
      , :new.MAINDESCRIPTIONCODE
      , :new.ITEMCODE
      , :new.PROGRAMCODE
      , :new.KESR
      , :new.KDVALUE
      , :new.REMOTEFLAG
      , :new.UNIONFLAG
      , :new.BUDGETREF
      , :new.DELETEDATE
      , :new.NAME
      , :new.KD_LEVEL
      , :new.STARTDATE
      , :new.SHORTNAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.ANALYTICALGROUPKD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_KD
  AFTER DELETE
  ON TB_KD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_KD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_LIMITNOTIFYCAPTION
  AFTER INSERT
  ON TB_LIMITNOTIFYCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_LIMITNOTIFYCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_LIMITNOTIFYCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,ACCEPTDATE
      ,FINSOURCE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,IMPORTID
      ,SENDERINN
      ,ANUMBER
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCUMENTSTATE
      ,USERSVISA
      ,ACCEPTSUMMA
      ,PLANDOCTYPE
      ,DOCSTATEREF
      ,RVERSION
      ,STIMATEID
      ,FACIALACCCLS
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,LASTEXTRCHANGE
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.ACCEPTDATE
      , :new.FINSOURCE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.IMPORTID
      , :new.SENDERINN
      , :new.ANUMBER
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.ACCEPTSUMMA
      , :new.PLANDOCTYPE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.STIMATEID
      , :new.FACIALACCCLS
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.LASTEXTRCHANGE
      , :new.AMONTH
      , :new.AYEAR
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_LIMITNOTIFYCAPTION
  AFTER UPDATE
  ON TB_LIMITNOTIFYCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_LIMITNOTIFYCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_LIMITNOTIFYCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_LIMITNOTIFYCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,ACCEPTDATE
      ,FINSOURCE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,IMPORTID
      ,SENDERINN
      ,ANUMBER
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCUMENTSTATE
      ,USERSVISA
      ,ACCEPTSUMMA
      ,PLANDOCTYPE
      ,DOCSTATEREF
      ,RVERSION
      ,STIMATEID
      ,FACIALACCCLS
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,LASTEXTRCHANGE
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.ACCEPTDATE
      , :new.FINSOURCE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.IMPORTID
      , :new.SENDERINN
      , :new.ANUMBER
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.ACCEPTSUMMA
      , :new.PLANDOCTYPE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.STIMATEID
      , :new.FACIALACCCLS
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.LASTEXTRCHANGE
      , :new.AMONTH
      , :new.AYEAR
    );
  else 
    update A_TB_LIMITNOTIFYCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_LIMITNOTIFYCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,ACCEPTDATE
      ,FINSOURCE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,IMPORTID
      ,SENDERINN
      ,ANUMBER
      ,DFACCOUNT
      ,SOURCEFACIALACC
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCUMENTSTATE
      ,USERSVISA
      ,ACCEPTSUMMA
      ,PLANDOCTYPE
      ,DOCSTATEREF
      ,RVERSION
      ,STIMATEID
      ,FACIALACCCLS
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,LASTEXTRCHANGE
      ,AMONTH
      ,AYEAR
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.ACCEPTDATE
      , :new.FINSOURCE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.IMPORTID
      , :new.SENDERINN
      , :new.ANUMBER
      , :new.DFACCOUNT
      , :new.SOURCEFACIALACC
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.ACCEPTSUMMA
      , :new.PLANDOCTYPE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.STIMATEID
      , :new.FACIALACCCLS
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.LASTEXTRCHANGE
      , :new.AMONTH
      , :new.AYEAR
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_LIMITNOTIFYCAPTION
  AFTER DELETE
  ON TB_LIMITNOTIFYCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_LIMITNOTIFYCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_LINKTYPE
  AFTER INSERT
  ON TB_LINKTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_LINKTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_LINKTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LINKCOMMENT
      ,TEMPLATECLS
      ,PARENTDOCCLS
      ,CHILDDOCCLS
      ,BLOCKPARENT
      ,BLOCKCHILD
      ,CANDELBLOCKPARENT
      ,CANDELBLOCKCHILD
      ,DISABLEDELPARENT
      ,DISABLEDELCHILD
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PARENTPICTURETYPE
      ,PARENTPICTURENAME
      ,CHILDPICTURETYPE
      ,CHILDPICTURENAME
      ,PICTURECOLLECTIONNAME
      ,URMUSE
      ,DELMACROSNAME
      ,NEEDDELCHILD
      ,LINKKIND
      ,SHOWEVENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LINKCOMMENT
      , :new.TEMPLATECLS
      , :new.PARENTDOCCLS
      , :new.CHILDDOCCLS
      , :new.BLOCKPARENT
      , :new.BLOCKCHILD
      , :new.CANDELBLOCKPARENT
      , :new.CANDELBLOCKCHILD
      , :new.DISABLEDELPARENT
      , :new.DISABLEDELCHILD
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PARENTPICTURETYPE
      , :new.PARENTPICTURENAME
      , :new.CHILDPICTURETYPE
      , :new.CHILDPICTURENAME
      , :new.PICTURECOLLECTIONNAME
      , :new.URMUSE
      , :new.DELMACROSNAME
      , :new.NEEDDELCHILD
      , :new.LINKKIND
      , :new.SHOWEVENT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_LINKTYPE
  AFTER UPDATE
  ON TB_LINKTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_LINKTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_LINKTYPE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_LINKTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LINKCOMMENT
      ,TEMPLATECLS
      ,PARENTDOCCLS
      ,CHILDDOCCLS
      ,BLOCKPARENT
      ,BLOCKCHILD
      ,CANDELBLOCKPARENT
      ,CANDELBLOCKCHILD
      ,DISABLEDELPARENT
      ,DISABLEDELCHILD
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PARENTPICTURETYPE
      ,PARENTPICTURENAME
      ,CHILDPICTURETYPE
      ,CHILDPICTURENAME
      ,PICTURECOLLECTIONNAME
      ,URMUSE
      ,DELMACROSNAME
      ,NEEDDELCHILD
      ,LINKKIND
      ,SHOWEVENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LINKCOMMENT
      , :new.TEMPLATECLS
      , :new.PARENTDOCCLS
      , :new.CHILDDOCCLS
      , :new.BLOCKPARENT
      , :new.BLOCKCHILD
      , :new.CANDELBLOCKPARENT
      , :new.CANDELBLOCKCHILD
      , :new.DISABLEDELPARENT
      , :new.DISABLEDELCHILD
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PARENTPICTURETYPE
      , :new.PARENTPICTURENAME
      , :new.CHILDPICTURETYPE
      , :new.CHILDPICTURENAME
      , :new.PICTURECOLLECTIONNAME
      , :new.URMUSE
      , :new.DELMACROSNAME
      , :new.NEEDDELCHILD
      , :new.LINKKIND
      , :new.SHOWEVENT
    );
  else 
    update A_TB_LINKTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_LINKTYPE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,LINKCOMMENT
      ,TEMPLATECLS
      ,PARENTDOCCLS
      ,CHILDDOCCLS
      ,BLOCKPARENT
      ,BLOCKCHILD
      ,CANDELBLOCKPARENT
      ,CANDELBLOCKCHILD
      ,DISABLEDELPARENT
      ,DISABLEDELCHILD
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,PARENTPICTURETYPE
      ,PARENTPICTURENAME
      ,CHILDPICTURETYPE
      ,CHILDPICTURENAME
      ,PICTURECOLLECTIONNAME
      ,URMUSE
      ,DELMACROSNAME
      ,NEEDDELCHILD
      ,LINKKIND
      ,SHOWEVENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.LINKCOMMENT
      , :new.TEMPLATECLS
      , :new.PARENTDOCCLS
      , :new.CHILDDOCCLS
      , :new.BLOCKPARENT
      , :new.BLOCKCHILD
      , :new.CANDELBLOCKPARENT
      , :new.CANDELBLOCKCHILD
      , :new.DISABLEDELPARENT
      , :new.DISABLEDELCHILD
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.PARENTPICTURETYPE
      , :new.PARENTPICTURENAME
      , :new.CHILDPICTURETYPE
      , :new.CHILDPICTURENAME
      , :new.PICTURECOLLECTIONNAME
      , :new.URMUSE
      , :new.DELMACROSNAME
      , :new.NEEDDELCHILD
      , :new.LINKKIND
      , :new.SHOWEVENT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_LINKTYPE
  AFTER DELETE
  ON TB_LINKTYPE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_LINKTYPE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_ORG_ACCOUNTS
  AFTER INSERT
  ON TB_ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_ORG_ACCOUNTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_ORG_ACCOUNTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ORG_REF
      ,BANK_REF
      ,ACC
      ,ACC_CLS
      ,FINTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CLOSED
      ,ACCDEFAULT
      ,BANKDEPNUMBER
      ,FACIALCODE
      ,SERVICE_ORG_REF
      ,ACOMMENT
      ,ISDEFAULT
      ,RVERSION
      ,SERVICE_ACC_REF
      ,CLOSECODE
      ,SERVICEACC
      ,FACIALACC_CLS
      ,DATEOPEN
      ,DATECLOSE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ORG_REF
      , :new.BANK_REF
      , :new.ACC
      , :new.ACC_CLS
      , :new.FINTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CLOSED
      , :new.ACCDEFAULT
      , :new.BANKDEPNUMBER
      , :new.FACIALCODE
      , :new.SERVICE_ORG_REF
      , :new.ACOMMENT
      , :new.ISDEFAULT
      , :new.RVERSION
      , :new.SERVICE_ACC_REF
      , :new.CLOSECODE
      , :new.SERVICEACC
      , :new.FACIALACC_CLS
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_ORG_ACCOUNTS
  AFTER UPDATE
  ON TB_ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_ORG_ACCOUNTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_ORG_ACCOUNTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_ORG_ACCOUNTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ORG_REF
      ,BANK_REF
      ,ACC
      ,ACC_CLS
      ,FINTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CLOSED
      ,ACCDEFAULT
      ,BANKDEPNUMBER
      ,FACIALCODE
      ,SERVICE_ORG_REF
      ,ACOMMENT
      ,ISDEFAULT
      ,RVERSION
      ,SERVICE_ACC_REF
      ,CLOSECODE
      ,SERVICEACC
      ,FACIALACC_CLS
      ,DATEOPEN
      ,DATECLOSE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ORG_REF
      , :new.BANK_REF
      , :new.ACC
      , :new.ACC_CLS
      , :new.FINTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CLOSED
      , :new.ACCDEFAULT
      , :new.BANKDEPNUMBER
      , :new.FACIALCODE
      , :new.SERVICE_ORG_REF
      , :new.ACOMMENT
      , :new.ISDEFAULT
      , :new.RVERSION
      , :new.SERVICE_ACC_REF
      , :new.CLOSECODE
      , :new.SERVICEACC
      , :new.FACIALACC_CLS
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
  else 
    update A_TB_ORG_ACCOUNTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_ORG_ACCOUNTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ORG_REF
      ,BANK_REF
      ,ACC
      ,ACC_CLS
      ,FINTYPE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,CLOSED
      ,ACCDEFAULT
      ,BANKDEPNUMBER
      ,FACIALCODE
      ,SERVICE_ORG_REF
      ,ACOMMENT
      ,ISDEFAULT
      ,RVERSION
      ,SERVICE_ACC_REF
      ,CLOSECODE
      ,SERVICEACC
      ,FACIALACC_CLS
      ,DATEOPEN
      ,DATECLOSE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ORG_REF
      , :new.BANK_REF
      , :new.ACC
      , :new.ACC_CLS
      , :new.FINTYPE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CLOSED
      , :new.ACCDEFAULT
      , :new.BANKDEPNUMBER
      , :new.FACIALCODE
      , :new.SERVICE_ORG_REF
      , :new.ACOMMENT
      , :new.ISDEFAULT
      , :new.RVERSION
      , :new.SERVICE_ACC_REF
      , :new.CLOSECODE
      , :new.SERVICEACC
      , :new.FACIALACC_CLS
      , :new.DATEOPEN
      , :new.DATECLOSE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_ORG_ACCOUNTS
  AFTER DELETE
  ON TB_ORG_ACCOUNTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_ORG_ACCOUNTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_ORGANIZATIONS
  AFTER INSERT
  ON TB_ORGANIZATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_ORGANIZATIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_ORGANIZATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GOSNI
      ,CITY
      ,COUNTRY
      ,PHONE
      ,ADDRESS
      ,ORG_CLS
      ,INN20
      ,SUBINN
      ,FACIALACC
      ,REGIONCLS
      ,DIRNAME
      ,BUGNAME
      ,DIRPHONE
      ,BUGPHONE
      ,RCORG
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,INN
      ,OKATO
      ,EMAIL
      ,WEBSITE
      ,UFKCODE
      ,ADDOKATO
      ,SHORTNAME
      ,RVERSION
      ,SENDERID
      ,KVSR
      ,OKFS
      ,OKOPF
      ,OPENDATE
      ,CLOSEDATE
      ,CHANGEDATE
      ,GENERALORG_REF
      ,FEDERALREGIONCODE
      ,ORG_TYPE
      ,BUDGETREF
      ,SUPPLIERSTATUS
      ,COUNTRYCODE
      ,DATECLOSE
      ,ORGCODE
      ,COSTAUTHORITY
      ,INCOMEAUTHORITY
      ,DEBTAUTHORITY
      ,SVRAUTHORITY
      ,CLIENTID
      ,DATEOPEN
      ,FUID
      ,OKPO
      ,OKTMO
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,OGRN
      ,REJECT_CLS
      ,REJECTCAUSE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,REMOTEPBSCODE
      ,REMOTENOTPBSCODE
      ,USECHECK_CARD
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,RECORDOWNERORGREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GOSNI
      , :new.CITY
      , :new.COUNTRY
      , :new.PHONE
      , :new.ADDRESS
      , :new.ORG_CLS
      , :new.INN20
      , :new.SUBINN
      , :new.FACIALACC
      , :new.REGIONCLS
      , :new.DIRNAME
      , :new.BUGNAME
      , :new.DIRPHONE
      , :new.BUGPHONE
      , :new.RCORG
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.INN
      , :new.OKATO
      , :new.EMAIL
      , :new.WEBSITE
      , :new.UFKCODE
      , :new.ADDOKATO
      , :new.SHORTNAME
      , :new.RVERSION
      , :new.SENDERID
      , :new.KVSR
      , :new.OKFS
      , :new.OKOPF
      , :new.OPENDATE
      , :new.CLOSEDATE
      , :new.CHANGEDATE
      , :new.GENERALORG_REF
      , :new.FEDERALREGIONCODE
      , :new.ORG_TYPE
      , :new.BUDGETREF
      , :new.SUPPLIERSTATUS
      , :new.COUNTRYCODE
      , :new.DATECLOSE
      , :new.ORGCODE
      , :new.COSTAUTHORITY
      , :new.INCOMEAUTHORITY
      , :new.DEBTAUTHORITY
      , :new.SVRAUTHORITY
      , :new.CLIENTID
      , :new.DATEOPEN
      , :new.FUID
      , :new.OKPO
      , :new.OKTMO
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.OGRN
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.REMOTEPBSCODE
      , :new.REMOTENOTPBSCODE
      , :new.USECHECK_CARD
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.RECORDOWNERORGREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_ORGANIZATIONS
  AFTER UPDATE
  ON TB_ORGANIZATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_ORGANIZATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_ORGANIZATIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_ORGANIZATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GOSNI
      ,CITY
      ,COUNTRY
      ,PHONE
      ,ADDRESS
      ,ORG_CLS
      ,INN20
      ,SUBINN
      ,FACIALACC
      ,REGIONCLS
      ,DIRNAME
      ,BUGNAME
      ,DIRPHONE
      ,BUGPHONE
      ,RCORG
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,INN
      ,OKATO
      ,EMAIL
      ,WEBSITE
      ,UFKCODE
      ,ADDOKATO
      ,SHORTNAME
      ,RVERSION
      ,SENDERID
      ,KVSR
      ,OKFS
      ,OKOPF
      ,OPENDATE
      ,CLOSEDATE
      ,CHANGEDATE
      ,GENERALORG_REF
      ,FEDERALREGIONCODE
      ,ORG_TYPE
      ,BUDGETREF
      ,SUPPLIERSTATUS
      ,COUNTRYCODE
      ,DATECLOSE
      ,ORGCODE
      ,COSTAUTHORITY
      ,INCOMEAUTHORITY
      ,DEBTAUTHORITY
      ,SVRAUTHORITY
      ,CLIENTID
      ,DATEOPEN
      ,FUID
      ,OKPO
      ,OKTMO
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,OGRN
      ,REJECT_CLS
      ,REJECTCAUSE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,REMOTEPBSCODE
      ,REMOTENOTPBSCODE
      ,USECHECK_CARD
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,RECORDOWNERORGREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GOSNI
      , :new.CITY
      , :new.COUNTRY
      , :new.PHONE
      , :new.ADDRESS
      , :new.ORG_CLS
      , :new.INN20
      , :new.SUBINN
      , :new.FACIALACC
      , :new.REGIONCLS
      , :new.DIRNAME
      , :new.BUGNAME
      , :new.DIRPHONE
      , :new.BUGPHONE
      , :new.RCORG
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.INN
      , :new.OKATO
      , :new.EMAIL
      , :new.WEBSITE
      , :new.UFKCODE
      , :new.ADDOKATO
      , :new.SHORTNAME
      , :new.RVERSION
      , :new.SENDERID
      , :new.KVSR
      , :new.OKFS
      , :new.OKOPF
      , :new.OPENDATE
      , :new.CLOSEDATE
      , :new.CHANGEDATE
      , :new.GENERALORG_REF
      , :new.FEDERALREGIONCODE
      , :new.ORG_TYPE
      , :new.BUDGETREF
      , :new.SUPPLIERSTATUS
      , :new.COUNTRYCODE
      , :new.DATECLOSE
      , :new.ORGCODE
      , :new.COSTAUTHORITY
      , :new.INCOMEAUTHORITY
      , :new.DEBTAUTHORITY
      , :new.SVRAUTHORITY
      , :new.CLIENTID
      , :new.DATEOPEN
      , :new.FUID
      , :new.OKPO
      , :new.OKTMO
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.OGRN
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.REMOTEPBSCODE
      , :new.REMOTENOTPBSCODE
      , :new.USECHECK_CARD
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.RECORDOWNERORGREF
    );
  else 
    update A_TB_ORGANIZATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_ORGANIZATIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,GOSNI
      ,CITY
      ,COUNTRY
      ,PHONE
      ,ADDRESS
      ,ORG_CLS
      ,INN20
      ,SUBINN
      ,FACIALACC
      ,REGIONCLS
      ,DIRNAME
      ,BUGNAME
      ,DIRPHONE
      ,BUGPHONE
      ,RCORG
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,INN
      ,OKATO
      ,EMAIL
      ,WEBSITE
      ,UFKCODE
      ,ADDOKATO
      ,SHORTNAME
      ,RVERSION
      ,SENDERID
      ,KVSR
      ,OKFS
      ,OKOPF
      ,OPENDATE
      ,CLOSEDATE
      ,CHANGEDATE
      ,GENERALORG_REF
      ,FEDERALREGIONCODE
      ,ORG_TYPE
      ,BUDGETREF
      ,SUPPLIERSTATUS
      ,COUNTRYCODE
      ,DATECLOSE
      ,ORGCODE
      ,COSTAUTHORITY
      ,INCOMEAUTHORITY
      ,DEBTAUTHORITY
      ,SVRAUTHORITY
      ,CLIENTID
      ,DATEOPEN
      ,FUID
      ,OKPO
      ,OKTMO
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,OGRN
      ,REJECT_CLS
      ,REJECTCAUSE
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,REMOTEPBSCODE
      ,REMOTENOTPBSCODE
      ,USECHECK_CARD
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
      ,RECORDOWNERORGREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.GOSNI
      , :new.CITY
      , :new.COUNTRY
      , :new.PHONE
      , :new.ADDRESS
      , :new.ORG_CLS
      , :new.INN20
      , :new.SUBINN
      , :new.FACIALACC
      , :new.REGIONCLS
      , :new.DIRNAME
      , :new.BUGNAME
      , :new.DIRPHONE
      , :new.BUGPHONE
      , :new.RCORG
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.INN
      , :new.OKATO
      , :new.EMAIL
      , :new.WEBSITE
      , :new.UFKCODE
      , :new.ADDOKATO
      , :new.SHORTNAME
      , :new.RVERSION
      , :new.SENDERID
      , :new.KVSR
      , :new.OKFS
      , :new.OKOPF
      , :new.OPENDATE
      , :new.CLOSEDATE
      , :new.CHANGEDATE
      , :new.GENERALORG_REF
      , :new.FEDERALREGIONCODE
      , :new.ORG_TYPE
      , :new.BUDGETREF
      , :new.SUPPLIERSTATUS
      , :new.COUNTRYCODE
      , :new.DATECLOSE
      , :new.ORGCODE
      , :new.COSTAUTHORITY
      , :new.INCOMEAUTHORITY
      , :new.DEBTAUTHORITY
      , :new.SVRAUTHORITY
      , :new.CLIENTID
      , :new.DATEOPEN
      , :new.FUID
      , :new.OKPO
      , :new.OKTMO
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.OGRN
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.REMOTEPBSCODE
      , :new.REMOTENOTPBSCODE
      , :new.USECHECK_CARD
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
      , :new.RECORDOWNERORGREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_ORGANIZATIONS
  AFTER DELETE
  ON TB_ORGANIZATIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_ORGANIZATIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_PAYDOC32
  AFTER INSERT
  ON TB_PAYDOC32
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PAYDOC32
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PAYDOC32 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,PRINTDATE
      ,ACCEPTDATE
      ,PAYERATTRREF
      ,ACCEPTORATTRREF
      ,SENDBY
      ,SUMMA
      ,CURRENCY
      ,PAYDATE
      ,PAYQUEUE
      ,TEXTNOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,SOURCEDOCNUMBER
      ,CHILDCOUNT
      ,FACIALACC_CLS
      ,ACCOUNTREF
      ,DOCTYPE
      ,SOURCEFACIALACC_CLS
      ,PARENTINDEX
      ,ANUMBER
      ,TAXNOTE
      ,REJECT_CLS
      ,REJECTCAUSE
      ,REALPAYERORG_REF
      ,ISDIVIDE
      ,CURSUM
      ,CREDIT
      ,DEBIT
      ,RVERSION
      ,BUHOPERATIONCLS
      ,MEANSTYPE
      ,PAYMENTCONDITION
      ,BUDGETREF
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.PRINTDATE
      , :new.ACCEPTDATE
      , :new.PAYERATTRREF
      , :new.ACCEPTORATTRREF
      , :new.SENDBY
      , :new.SUMMA
      , :new.CURRENCY
      , :new.PAYDATE
      , :new.PAYQUEUE
      , :new.TEXTNOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.SOURCEDOCNUMBER
      , :new.CHILDCOUNT
      , :new.FACIALACC_CLS
      , :new.ACCOUNTREF
      , :new.DOCTYPE
      , :new.SOURCEFACIALACC_CLS
      , :new.PARENTINDEX
      , :new.ANUMBER
      , :new.TAXNOTE
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.REALPAYERORG_REF
      , :new.ISDIVIDE
      , :new.CURSUM
      , :new.CREDIT
      , :new.DEBIT
      , :new.RVERSION
      , :new.BUHOPERATIONCLS
      , :new.MEANSTYPE
      , :new.PAYMENTCONDITION
      , :new.BUDGETREF
      , :new.TRANSFERTCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_PAYDOC32
  AFTER UPDATE
  ON TB_PAYDOC32
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_PAYDOC32
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_PAYDOC32
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PAYDOC32 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,PRINTDATE
      ,ACCEPTDATE
      ,PAYERATTRREF
      ,ACCEPTORATTRREF
      ,SENDBY
      ,SUMMA
      ,CURRENCY
      ,PAYDATE
      ,PAYQUEUE
      ,TEXTNOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,SOURCEDOCNUMBER
      ,CHILDCOUNT
      ,FACIALACC_CLS
      ,ACCOUNTREF
      ,DOCTYPE
      ,SOURCEFACIALACC_CLS
      ,PARENTINDEX
      ,ANUMBER
      ,TAXNOTE
      ,REJECT_CLS
      ,REJECTCAUSE
      ,REALPAYERORG_REF
      ,ISDIVIDE
      ,CURSUM
      ,CREDIT
      ,DEBIT
      ,RVERSION
      ,BUHOPERATIONCLS
      ,MEANSTYPE
      ,PAYMENTCONDITION
      ,BUDGETREF
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.PRINTDATE
      , :new.ACCEPTDATE
      , :new.PAYERATTRREF
      , :new.ACCEPTORATTRREF
      , :new.SENDBY
      , :new.SUMMA
      , :new.CURRENCY
      , :new.PAYDATE
      , :new.PAYQUEUE
      , :new.TEXTNOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.SOURCEDOCNUMBER
      , :new.CHILDCOUNT
      , :new.FACIALACC_CLS
      , :new.ACCOUNTREF
      , :new.DOCTYPE
      , :new.SOURCEFACIALACC_CLS
      , :new.PARENTINDEX
      , :new.ANUMBER
      , :new.TAXNOTE
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.REALPAYERORG_REF
      , :new.ISDIVIDE
      , :new.CURSUM
      , :new.CREDIT
      , :new.DEBIT
      , :new.RVERSION
      , :new.BUHOPERATIONCLS
      , :new.MEANSTYPE
      , :new.PAYMENTCONDITION
      , :new.BUDGETREF
      , :new.TRANSFERTCLS
    );
  else 
    update A_TB_PAYDOC32
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_PAYDOC32 (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,INPUTDATE
      ,PRINTDATE
      ,ACCEPTDATE
      ,PAYERATTRREF
      ,ACCEPTORATTRREF
      ,SENDBY
      ,SUMMA
      ,CURRENCY
      ,PAYDATE
      ,PAYQUEUE
      ,TEXTNOTE
      ,PROGINDEX
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,SOURCEDOCNUMBER
      ,CHILDCOUNT
      ,FACIALACC_CLS
      ,ACCOUNTREF
      ,DOCTYPE
      ,SOURCEFACIALACC_CLS
      ,PARENTINDEX
      ,ANUMBER
      ,TAXNOTE
      ,REJECT_CLS
      ,REJECTCAUSE
      ,REALPAYERORG_REF
      ,ISDIVIDE
      ,CURSUM
      ,CREDIT
      ,DEBIT
      ,RVERSION
      ,BUHOPERATIONCLS
      ,MEANSTYPE
      ,PAYMENTCONDITION
      ,BUDGETREF
      ,TRANSFERTCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.INPUTDATE
      , :new.PRINTDATE
      , :new.ACCEPTDATE
      , :new.PAYERATTRREF
      , :new.ACCEPTORATTRREF
      , :new.SENDBY
      , :new.SUMMA
      , :new.CURRENCY
      , :new.PAYDATE
      , :new.PAYQUEUE
      , :new.TEXTNOTE
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.SOURCEDOCNUMBER
      , :new.CHILDCOUNT
      , :new.FACIALACC_CLS
      , :new.ACCOUNTREF
      , :new.DOCTYPE
      , :new.SOURCEFACIALACC_CLS
      , :new.PARENTINDEX
      , :new.ANUMBER
      , :new.TAXNOTE
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.REALPAYERORG_REF
      , :new.ISDIVIDE
      , :new.CURSUM
      , :new.CREDIT
      , :new.DEBIT
      , :new.RVERSION
      , :new.BUHOPERATIONCLS
      , :new.MEANSTYPE
      , :new.PAYMENTCONDITION
      , :new.BUDGETREF
      , :new.TRANSFERTCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_PAYDOC32
  AFTER DELETE
  ON TB_PAYDOC32
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PAYDOC32
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_PAYMENTSCHEDULE
  AFTER INSERT
  ON TB_PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PAYMENTSCHEDULE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PAYMENTSCHEDULE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ANUMBER
      ,PARENTNUMBER
      ,KFSR
      ,KESR
      ,KVSR
      ,KCSR
      ,KVR
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,SUMMA
      ,REGION
      ,SUBKESR
      ,MEANSTYPE
      ,FINSOURCE
      ,FINTYPE
      ,FACT
      ,FACIALACC_CLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ACCEPTDATE
      ,LASTADJUSTMENT
      ,ACCEPTED
      ,LASTACCEPTED
      ,PROMISETYPE
      ,ADJUSTMENTREF
      ,OLDNUMBER
      ,SUMMAPREVIOUSYEAR
      ,SUMMAFINPREVIOUSYEAR
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,RECORDINDEX
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DIRECTIONCLS
      ,RVERSION
      ,BUHOPERATIONCLS
      ,MONTH01DELTA
      ,MONTH02DELTA
      ,MONTH03DELTA
      ,MONTH04DELTA
      ,MONTH05DELTA
      ,MONTH06DELTA
      ,MONTH07DELTA
      ,MONTH08DELTA
      ,MONTH09DELTA
      ,MONTH10DELTA
      ,MONTH11DELTA
      ,MONTH12DELTA
      ,QUARTER1DELTA
      ,QUARTER2DELTA
      ,QUARTER3DELTA
      ,QUARTER4DELTA
      ,SUMMADELTA
      ,NOTE
      ,FINYEAR
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUMMAYEAR1DELTA
      ,SUMMAYEAR2DELTA
      ,SUMMAYEAR3DELTA
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,EXECUTIONREF
      ,INNERPROMISENUM
      ,ADJUSTMENTNUMBER
      ,PROMISENUMBER
      ,SUBSIDYCLS
      ,AGREEMENTREF
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
      ,SUMMAYEAR4DELTA
      ,SUMMAOTHERYEARSDELTA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ANUMBER
      , :new.PARENTNUMBER
      , :new.KFSR
      , :new.KESR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.SUMMA
      , :new.REGION
      , :new.SUBKESR
      , :new.MEANSTYPE
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.LASTADJUSTMENT
      , :new.ACCEPTED
      , :new.LASTACCEPTED
      , :new.PROMISETYPE
      , :new.ADJUSTMENTREF
      , :new.OLDNUMBER
      , :new.SUMMAPREVIOUSYEAR
      , :new.SUMMAFINPREVIOUSYEAR
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.RECORDINDEX
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DIRECTIONCLS
      , :new.RVERSION
      , :new.BUHOPERATIONCLS
      , :new.MONTH01DELTA
      , :new.MONTH02DELTA
      , :new.MONTH03DELTA
      , :new.MONTH04DELTA
      , :new.MONTH05DELTA
      , :new.MONTH06DELTA
      , :new.MONTH07DELTA
      , :new.MONTH08DELTA
      , :new.MONTH09DELTA
      , :new.MONTH10DELTA
      , :new.MONTH11DELTA
      , :new.MONTH12DELTA
      , :new.QUARTER1DELTA
      , :new.QUARTER2DELTA
      , :new.QUARTER3DELTA
      , :new.QUARTER4DELTA
      , :new.SUMMADELTA
      , :new.NOTE
      , :new.FINYEAR
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUMMAYEAR1DELTA
      , :new.SUMMAYEAR2DELTA
      , :new.SUMMAYEAR3DELTA
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.EXECUTIONREF
      , :new.INNERPROMISENUM
      , :new.ADJUSTMENTNUMBER
      , :new.PROMISENUMBER
      , :new.SUBSIDYCLS
      , :new.AGREEMENTREF
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
      , :new.SUMMAYEAR4DELTA
      , :new.SUMMAOTHERYEARSDELTA
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_PAYMENTSCHEDULE
  AFTER UPDATE
  ON TB_PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_PAYMENTSCHEDULE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_PAYMENTSCHEDULE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PAYMENTSCHEDULE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ANUMBER
      ,PARENTNUMBER
      ,KFSR
      ,KESR
      ,KVSR
      ,KCSR
      ,KVR
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,SUMMA
      ,REGION
      ,SUBKESR
      ,MEANSTYPE
      ,FINSOURCE
      ,FINTYPE
      ,FACT
      ,FACIALACC_CLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ACCEPTDATE
      ,LASTADJUSTMENT
      ,ACCEPTED
      ,LASTACCEPTED
      ,PROMISETYPE
      ,ADJUSTMENTREF
      ,OLDNUMBER
      ,SUMMAPREVIOUSYEAR
      ,SUMMAFINPREVIOUSYEAR
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,RECORDINDEX
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DIRECTIONCLS
      ,RVERSION
      ,BUHOPERATIONCLS
      ,MONTH01DELTA
      ,MONTH02DELTA
      ,MONTH03DELTA
      ,MONTH04DELTA
      ,MONTH05DELTA
      ,MONTH06DELTA
      ,MONTH07DELTA
      ,MONTH08DELTA
      ,MONTH09DELTA
      ,MONTH10DELTA
      ,MONTH11DELTA
      ,MONTH12DELTA
      ,QUARTER1DELTA
      ,QUARTER2DELTA
      ,QUARTER3DELTA
      ,QUARTER4DELTA
      ,SUMMADELTA
      ,NOTE
      ,FINYEAR
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUMMAYEAR1DELTA
      ,SUMMAYEAR2DELTA
      ,SUMMAYEAR3DELTA
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,EXECUTIONREF
      ,INNERPROMISENUM
      ,ADJUSTMENTNUMBER
      ,PROMISENUMBER
      ,SUBSIDYCLS
      ,AGREEMENTREF
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
      ,SUMMAYEAR4DELTA
      ,SUMMAOTHERYEARSDELTA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ANUMBER
      , :new.PARENTNUMBER
      , :new.KFSR
      , :new.KESR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.SUMMA
      , :new.REGION
      , :new.SUBKESR
      , :new.MEANSTYPE
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.LASTADJUSTMENT
      , :new.ACCEPTED
      , :new.LASTACCEPTED
      , :new.PROMISETYPE
      , :new.ADJUSTMENTREF
      , :new.OLDNUMBER
      , :new.SUMMAPREVIOUSYEAR
      , :new.SUMMAFINPREVIOUSYEAR
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.RECORDINDEX
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DIRECTIONCLS
      , :new.RVERSION
      , :new.BUHOPERATIONCLS
      , :new.MONTH01DELTA
      , :new.MONTH02DELTA
      , :new.MONTH03DELTA
      , :new.MONTH04DELTA
      , :new.MONTH05DELTA
      , :new.MONTH06DELTA
      , :new.MONTH07DELTA
      , :new.MONTH08DELTA
      , :new.MONTH09DELTA
      , :new.MONTH10DELTA
      , :new.MONTH11DELTA
      , :new.MONTH12DELTA
      , :new.QUARTER1DELTA
      , :new.QUARTER2DELTA
      , :new.QUARTER3DELTA
      , :new.QUARTER4DELTA
      , :new.SUMMADELTA
      , :new.NOTE
      , :new.FINYEAR
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUMMAYEAR1DELTA
      , :new.SUMMAYEAR2DELTA
      , :new.SUMMAYEAR3DELTA
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.EXECUTIONREF
      , :new.INNERPROMISENUM
      , :new.ADJUSTMENTNUMBER
      , :new.PROMISENUMBER
      , :new.SUBSIDYCLS
      , :new.AGREEMENTREF
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
      , :new.SUMMAYEAR4DELTA
      , :new.SUMMAOTHERYEARSDELTA
    );
  else 
    update A_TB_PAYMENTSCHEDULE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_PAYMENTSCHEDULE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ANUMBER
      ,PARENTNUMBER
      ,KFSR
      ,KESR
      ,KVSR
      ,KCSR
      ,KVR
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,SUMMA
      ,REGION
      ,SUBKESR
      ,MEANSTYPE
      ,FINSOURCE
      ,FINTYPE
      ,FACT
      ,FACIALACC_CLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,BUDGETREF
      ,ACCEPTDATE
      ,LASTADJUSTMENT
      ,ACCEPTED
      ,LASTACCEPTED
      ,PROMISETYPE
      ,ADJUSTMENTREF
      ,OLDNUMBER
      ,SUMMAPREVIOUSYEAR
      ,SUMMAFINPREVIOUSYEAR
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,RECORDINDEX
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DIRECTIONCLS
      ,RVERSION
      ,BUHOPERATIONCLS
      ,MONTH01DELTA
      ,MONTH02DELTA
      ,MONTH03DELTA
      ,MONTH04DELTA
      ,MONTH05DELTA
      ,MONTH06DELTA
      ,MONTH07DELTA
      ,MONTH08DELTA
      ,MONTH09DELTA
      ,MONTH10DELTA
      ,MONTH11DELTA
      ,MONTH12DELTA
      ,QUARTER1DELTA
      ,QUARTER2DELTA
      ,QUARTER3DELTA
      ,QUARTER4DELTA
      ,SUMMADELTA
      ,NOTE
      ,FINYEAR
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUMMAYEAR1DELTA
      ,SUMMAYEAR2DELTA
      ,SUMMAYEAR3DELTA
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,EXECUTIONREF
      ,INNERPROMISENUM
      ,ADJUSTMENTNUMBER
      ,PROMISENUMBER
      ,SUBSIDYCLS
      ,AGREEMENTREF
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
      ,SUMMAYEAR4DELTA
      ,SUMMAOTHERYEARSDELTA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ANUMBER
      , :new.PARENTNUMBER
      , :new.KFSR
      , :new.KESR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.SUMMA
      , :new.REGION
      , :new.SUBKESR
      , :new.MEANSTYPE
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.BUDGETREF
      , :new.ACCEPTDATE
      , :new.LASTADJUSTMENT
      , :new.ACCEPTED
      , :new.LASTACCEPTED
      , :new.PROMISETYPE
      , :new.ADJUSTMENTREF
      , :new.OLDNUMBER
      , :new.SUMMAPREVIOUSYEAR
      , :new.SUMMAFINPREVIOUSYEAR
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.RECORDINDEX
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DIRECTIONCLS
      , :new.RVERSION
      , :new.BUHOPERATIONCLS
      , :new.MONTH01DELTA
      , :new.MONTH02DELTA
      , :new.MONTH03DELTA
      , :new.MONTH04DELTA
      , :new.MONTH05DELTA
      , :new.MONTH06DELTA
      , :new.MONTH07DELTA
      , :new.MONTH08DELTA
      , :new.MONTH09DELTA
      , :new.MONTH10DELTA
      , :new.MONTH11DELTA
      , :new.MONTH12DELTA
      , :new.QUARTER1DELTA
      , :new.QUARTER2DELTA
      , :new.QUARTER3DELTA
      , :new.QUARTER4DELTA
      , :new.SUMMADELTA
      , :new.NOTE
      , :new.FINYEAR
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUMMAYEAR1DELTA
      , :new.SUMMAYEAR2DELTA
      , :new.SUMMAYEAR3DELTA
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.EXECUTIONREF
      , :new.INNERPROMISENUM
      , :new.ADJUSTMENTNUMBER
      , :new.PROMISENUMBER
      , :new.SUBSIDYCLS
      , :new.AGREEMENTREF
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
      , :new.SUMMAYEAR4DELTA
      , :new.SUMMAOTHERYEARSDELTA
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_PAYMENTSCHEDULE
  AFTER DELETE
  ON TB_PAYMENTSCHEDULE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PAYMENTSCHEDULE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_PERCENTJOURNAL
  AFTER INSERT
  ON TB_PERCENTJOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PERCENTJOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PERCENTJOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,PERCENT
      ,PROGINDEX
      ,RECORDINDEX
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CBREF
      ,ISLAST
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.PERCENT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CBREF
      , :new.ISLAST
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_PERCENTJOURNAL
  AFTER UPDATE
  ON TB_PERCENTJOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_PERCENTJOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_PERCENTJOURNAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PERCENTJOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,PERCENT
      ,PROGINDEX
      ,RECORDINDEX
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CBREF
      ,ISLAST
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.PERCENT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CBREF
      , :new.ISLAST
    );
  else 
    update A_TB_PERCENTJOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_PERCENTJOURNAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,PERCENT
      ,PROGINDEX
      ,RECORDINDEX
      ,NOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CBREF
      ,ISLAST
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.PERCENT
      , :new.PROGINDEX
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CBREF
      , :new.ISLAST
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_PERCENTJOURNAL
  AFTER DELETE
  ON TB_PERCENTJOURNAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PERCENTJOURNAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_PROMISE_CAPTION
  AFTER INSERT
  ON TB_PROMISE_CAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PROMISE_CAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PROMISE_CAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,ACCEPTED_REVERTED
      ,AGREEMENT_DATE
      ,AGREEMENT_END
      ,AGREEMENT_NOTE
      ,AGREEMENT_TYPE
      ,AGREEMENT_SUMMA
      ,SUPPLIER_REF
      ,DELIVERY_RULES
      ,TOTALSUMM
      ,BUDGETORG_REF
      ,FACIALACC_CLS
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCUMENTSTATE
      ,USERSVISA
      ,RVERSION
      ,DOCSTATEREF
      ,STIMATEID
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,SUPPLIER_ACC_REF
      ,AGREEMENT_NUM
      ,INFONUMBER
      ,ADVANCESUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.ACCEPTED_REVERTED
      , :new.AGREEMENT_DATE
      , :new.AGREEMENT_END
      , :new.AGREEMENT_NOTE
      , :new.AGREEMENT_TYPE
      , :new.AGREEMENT_SUMMA
      , :new.SUPPLIER_REF
      , :new.DELIVERY_RULES
      , :new.TOTALSUMM
      , :new.BUDGETORG_REF
      , :new.FACIALACC_CLS
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.RVERSION
      , :new.DOCSTATEREF
      , :new.STIMATEID
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.SUPPLIER_ACC_REF
      , :new.AGREEMENT_NUM
      , :new.INFONUMBER
      , :new.ADVANCESUMMA
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_PROMISE_CAPTION
  AFTER UPDATE
  ON TB_PROMISE_CAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_PROMISE_CAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_PROMISE_CAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PROMISE_CAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,ACCEPTED_REVERTED
      ,AGREEMENT_DATE
      ,AGREEMENT_END
      ,AGREEMENT_NOTE
      ,AGREEMENT_TYPE
      ,AGREEMENT_SUMMA
      ,SUPPLIER_REF
      ,DELIVERY_RULES
      ,TOTALSUMM
      ,BUDGETORG_REF
      ,FACIALACC_CLS
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCUMENTSTATE
      ,USERSVISA
      ,RVERSION
      ,DOCSTATEREF
      ,STIMATEID
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,SUPPLIER_ACC_REF
      ,AGREEMENT_NUM
      ,INFONUMBER
      ,ADVANCESUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.ACCEPTED_REVERTED
      , :new.AGREEMENT_DATE
      , :new.AGREEMENT_END
      , :new.AGREEMENT_NOTE
      , :new.AGREEMENT_TYPE
      , :new.AGREEMENT_SUMMA
      , :new.SUPPLIER_REF
      , :new.DELIVERY_RULES
      , :new.TOTALSUMM
      , :new.BUDGETORG_REF
      , :new.FACIALACC_CLS
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.RVERSION
      , :new.DOCSTATEREF
      , :new.STIMATEID
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.SUPPLIER_ACC_REF
      , :new.AGREEMENT_NUM
      , :new.INFONUMBER
      , :new.ADVANCESUMMA
    );
  else 
    update A_TB_PROMISE_CAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_PROMISE_CAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,ACCEPTDATE
      ,ACCEPTED_REVERTED
      ,AGREEMENT_DATE
      ,AGREEMENT_END
      ,AGREEMENT_NOTE
      ,AGREEMENT_TYPE
      ,AGREEMENT_SUMMA
      ,SUPPLIER_REF
      ,DELIVERY_RULES
      ,TOTALSUMM
      ,BUDGETORG_REF
      ,FACIALACC_CLS
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,ANUMBER
      ,REJECT_CLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCUMENTSTATE
      ,USERSVISA
      ,RVERSION
      ,DOCSTATEREF
      ,STIMATEID
      ,BIDNUMBER
      ,FAXDOCCOUNT
      ,SUPPLIER_ACC_REF
      ,AGREEMENT_NUM
      ,INFONUMBER
      ,ADVANCESUMMA
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.ACCEPTDATE
      , :new.ACCEPTED_REVERTED
      , :new.AGREEMENT_DATE
      , :new.AGREEMENT_END
      , :new.AGREEMENT_NOTE
      , :new.AGREEMENT_TYPE
      , :new.AGREEMENT_SUMMA
      , :new.SUPPLIER_REF
      , :new.DELIVERY_RULES
      , :new.TOTALSUMM
      , :new.BUDGETORG_REF
      , :new.FACIALACC_CLS
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.ANUMBER
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCUMENTSTATE
      , :new.USERSVISA
      , :new.RVERSION
      , :new.DOCSTATEREF
      , :new.STIMATEID
      , :new.BIDNUMBER
      , :new.FAXDOCCOUNT
      , :new.SUPPLIER_ACC_REF
      , :new.AGREEMENT_NUM
      , :new.INFONUMBER
      , :new.ADVANCESUMMA
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_PROMISE_CAPTION
  AFTER DELETE
  ON TB_PROMISE_CAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PROMISE_CAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_PROMISE_DETAIL
  AFTER INSERT
  ON TB_PROMISE_DETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PROMISE_DETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PROMISE_DETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TITLE_REF
      ,PARENT_PROMISE
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,FACT
      ,FACIALACC_CLS
      ,DOCTYPE
      ,FINTYPE
      ,FINSOURCE
      ,SUBKESR
      ,REGIONCLS
      ,SUMMA
      ,REGISTRNUMBER
      ,CLOSEDATE
      ,CHILD_PROMISE
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,MEANSTYPE
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,MONTH01DELTA
      ,MONTH02DELTA
      ,MONTH03DELTA
      ,MONTH04DELTA
      ,MONTH05DELTA
      ,MONTH06DELTA
      ,MONTH07DELTA
      ,MONTH08DELTA
      ,MONTH09DELTA
      ,MONTH10DELTA
      ,MONTH11DELTA
      ,MONTH12DELTA
      ,STIMATEID
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUMMAYEAR1DELTA
      ,SUMMAYEAR2DELTA
      ,SUMMAYEAR3DELTA
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TITLE_REF
      , :new.PARENT_PROMISE
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.DOCTYPE
      , :new.FINTYPE
      , :new.FINSOURCE
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.SUMMA
      , :new.REGISTRNUMBER
      , :new.CLOSEDATE
      , :new.CHILD_PROMISE
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MEANSTYPE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.MONTH01DELTA
      , :new.MONTH02DELTA
      , :new.MONTH03DELTA
      , :new.MONTH04DELTA
      , :new.MONTH05DELTA
      , :new.MONTH06DELTA
      , :new.MONTH07DELTA
      , :new.MONTH08DELTA
      , :new.MONTH09DELTA
      , :new.MONTH10DELTA
      , :new.MONTH11DELTA
      , :new.MONTH12DELTA
      , :new.STIMATEID
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUMMAYEAR1DELTA
      , :new.SUMMAYEAR2DELTA
      , :new.SUMMAYEAR3DELTA
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_PROMISE_DETAIL
  AFTER UPDATE
  ON TB_PROMISE_DETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_PROMISE_DETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_PROMISE_DETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_PROMISE_DETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TITLE_REF
      ,PARENT_PROMISE
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,FACT
      ,FACIALACC_CLS
      ,DOCTYPE
      ,FINTYPE
      ,FINSOURCE
      ,SUBKESR
      ,REGIONCLS
      ,SUMMA
      ,REGISTRNUMBER
      ,CLOSEDATE
      ,CHILD_PROMISE
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,MEANSTYPE
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,MONTH01DELTA
      ,MONTH02DELTA
      ,MONTH03DELTA
      ,MONTH04DELTA
      ,MONTH05DELTA
      ,MONTH06DELTA
      ,MONTH07DELTA
      ,MONTH08DELTA
      ,MONTH09DELTA
      ,MONTH10DELTA
      ,MONTH11DELTA
      ,MONTH12DELTA
      ,STIMATEID
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUMMAYEAR1DELTA
      ,SUMMAYEAR2DELTA
      ,SUMMAYEAR3DELTA
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TITLE_REF
      , :new.PARENT_PROMISE
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.DOCTYPE
      , :new.FINTYPE
      , :new.FINSOURCE
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.SUMMA
      , :new.REGISTRNUMBER
      , :new.CLOSEDATE
      , :new.CHILD_PROMISE
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MEANSTYPE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.MONTH01DELTA
      , :new.MONTH02DELTA
      , :new.MONTH03DELTA
      , :new.MONTH04DELTA
      , :new.MONTH05DELTA
      , :new.MONTH06DELTA
      , :new.MONTH07DELTA
      , :new.MONTH08DELTA
      , :new.MONTH09DELTA
      , :new.MONTH10DELTA
      , :new.MONTH11DELTA
      , :new.MONTH12DELTA
      , :new.STIMATEID
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUMMAYEAR1DELTA
      , :new.SUMMAYEAR2DELTA
      , :new.SUMMAYEAR3DELTA
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
    );
  else 
    update A_TB_PROMISE_DETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_PROMISE_DETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TITLE_REF
      ,PARENT_PROMISE
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,FACT
      ,FACIALACC_CLS
      ,DOCTYPE
      ,FINTYPE
      ,FINSOURCE
      ,SUBKESR
      ,REGIONCLS
      ,SUMMA
      ,REGISTRNUMBER
      ,CLOSEDATE
      ,CHILD_PROMISE
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,MEANSTYPE
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,DIRECTIONCLS
      ,BUHOPERATIONCLS
      ,MONTH01DELTA
      ,MONTH02DELTA
      ,MONTH03DELTA
      ,MONTH04DELTA
      ,MONTH05DELTA
      ,MONTH06DELTA
      ,MONTH07DELTA
      ,MONTH08DELTA
      ,MONTH09DELTA
      ,MONTH10DELTA
      ,MONTH11DELTA
      ,MONTH12DELTA
      ,STIMATEID
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUMMAYEAR1DELTA
      ,SUMMAYEAR2DELTA
      ,SUMMAYEAR3DELTA
      ,ASSIGNMENTKIND
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TITLE_REF
      , :new.PARENT_PROMISE
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.FACT
      , :new.FACIALACC_CLS
      , :new.DOCTYPE
      , :new.FINTYPE
      , :new.FINSOURCE
      , :new.SUBKESR
      , :new.REGIONCLS
      , :new.SUMMA
      , :new.REGISTRNUMBER
      , :new.CLOSEDATE
      , :new.CHILD_PROMISE
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MEANSTYPE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.BUHOPERATIONCLS
      , :new.MONTH01DELTA
      , :new.MONTH02DELTA
      , :new.MONTH03DELTA
      , :new.MONTH04DELTA
      , :new.MONTH05DELTA
      , :new.MONTH06DELTA
      , :new.MONTH07DELTA
      , :new.MONTH08DELTA
      , :new.MONTH09DELTA
      , :new.MONTH10DELTA
      , :new.MONTH11DELTA
      , :new.MONTH12DELTA
      , :new.STIMATEID
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUMMAYEAR1DELTA
      , :new.SUMMAYEAR2DELTA
      , :new.SUMMAYEAR3DELTA
      , :new.ASSIGNMENTKIND
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_PROMISE_DETAIL
  AFTER DELETE
  ON TB_PROMISE_DETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_PROMISE_DETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_QUOTESTITLE
  AFTER INSERT
  ON TB_QUOTESTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_QUOTESTITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_QUOTESTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUILDDATE
      ,ACCEPTDATE
      ,INCACCOUNT
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDINDEX
      ,PROGINDEX
      ,DOCNUMBER
      ,TYPEOPERATIONCLS
      ,RVERSION
      ,REESTRDATE
      ,REESTRNUMBER
      ,SENDERID
      ,SENDERRECORDID
      ,FACIALACCCLS
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,STIMATEID
      ,SUMMA
      ,DOCSTATEREF
      ,DEPARTMENTCLS
      ,DOCCHANGEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.INCACCOUNT
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.DOCNUMBER
      , :new.TYPEOPERATIONCLS
      , :new.RVERSION
      , :new.REESTRDATE
      , :new.REESTRNUMBER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.FACIALACCCLS
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.STIMATEID
      , :new.SUMMA
      , :new.DOCSTATEREF
      , :new.DEPARTMENTCLS
      , :new.DOCCHANGEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_QUOTESTITLE
  AFTER UPDATE
  ON TB_QUOTESTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_QUOTESTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_QUOTESTITLE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_QUOTESTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUILDDATE
      ,ACCEPTDATE
      ,INCACCOUNT
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDINDEX
      ,PROGINDEX
      ,DOCNUMBER
      ,TYPEOPERATIONCLS
      ,RVERSION
      ,REESTRDATE
      ,REESTRNUMBER
      ,SENDERID
      ,SENDERRECORDID
      ,FACIALACCCLS
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,STIMATEID
      ,SUMMA
      ,DOCSTATEREF
      ,DEPARTMENTCLS
      ,DOCCHANGEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.INCACCOUNT
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.DOCNUMBER
      , :new.TYPEOPERATIONCLS
      , :new.RVERSION
      , :new.REESTRDATE
      , :new.REESTRNUMBER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.FACIALACCCLS
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.STIMATEID
      , :new.SUMMA
      , :new.DOCSTATEREF
      , :new.DEPARTMENTCLS
      , :new.DOCCHANGEDATE
    );
  else 
    update A_TB_QUOTESTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_QUOTESTITLE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUILDDATE
      ,ACCEPTDATE
      ,INCACCOUNT
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RECORDINDEX
      ,PROGINDEX
      ,DOCNUMBER
      ,TYPEOPERATIONCLS
      ,RVERSION
      ,REESTRDATE
      ,REESTRNUMBER
      ,SENDERID
      ,SENDERRECORDID
      ,FACIALACCCLS
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,STIMATEID
      ,SUMMA
      ,DOCSTATEREF
      ,DEPARTMENTCLS
      ,DOCCHANGEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.INCACCOUNT
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RECORDINDEX
      , :new.PROGINDEX
      , :new.DOCNUMBER
      , :new.TYPEOPERATIONCLS
      , :new.RVERSION
      , :new.REESTRDATE
      , :new.REESTRNUMBER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.FACIALACCCLS
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.STIMATEID
      , :new.SUMMA
      , :new.DOCSTATEREF
      , :new.DEPARTMENTCLS
      , :new.DOCCHANGEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_QUOTESTITLE
  AFTER DELETE
  ON TB_QUOTESTITLE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_QUOTESTITLE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_REQUESTS
  AFTER INSERT
  ON TB_REQUESTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_REQUESTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_REQUESTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGET
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,USERNOTE
      ,FACIALACC_CLS
      ,SOURCEACCOUNT
      ,DESTACCOUNT
      ,FACT
      ,FINSOURCE
      ,FINTYPE
      ,REGIONCLS
      ,BUHPAYMENTCLS
      ,DOCTYPE
      ,PAYDATE
      ,PAYPRIORITY
      ,SUMMAREQUESTED
      ,SUMMATOFINANCE
      ,REQUESTTYPE
      ,MEANSTYPE
      ,PAYSYMBOLCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ANUMBER
      ,PROMISE
      ,DOCUMENTBASETYPE
      ,INPUTDATE
      ,DFACCOUNT
      ,PROGINDEX
      ,PROGINDEX2
      ,RECORDINDEX
      ,INNERFINSOURCE
      ,OUTERFINSOURCE
      ,KD
      ,SUBKD
      ,PLANDATE
      ,CURRENCYCLS
      ,REQUESTSDOCSTATE
      ,TAXNOTE
      ,GOSNI
      ,CURRENCYSUMMA
      ,RVERSION
      ,DIRECTIONCLS
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,FEDERALFUNDSREF
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,CLSTYPE
      ,REESTRDATE
      ,AMONTH
      ,AYEAR
      ,EXECSUMMA
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,PAYPROMISECLS
      ,BUDALLOCATIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGET
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.USERNOTE
      , :new.FACIALACC_CLS
      , :new.SOURCEACCOUNT
      , :new.DESTACCOUNT
      , :new.FACT
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.REGIONCLS
      , :new.BUHPAYMENTCLS
      , :new.DOCTYPE
      , :new.PAYDATE
      , :new.PAYPRIORITY
      , :new.SUMMAREQUESTED
      , :new.SUMMATOFINANCE
      , :new.REQUESTTYPE
      , :new.MEANSTYPE
      , :new.PAYSYMBOLCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.PROMISE
      , :new.DOCUMENTBASETYPE
      , :new.INPUTDATE
      , :new.DFACCOUNT
      , :new.PROGINDEX
      , :new.PROGINDEX2
      , :new.RECORDINDEX
      , :new.INNERFINSOURCE
      , :new.OUTERFINSOURCE
      , :new.KD
      , :new.SUBKD
      , :new.PLANDATE
      , :new.CURRENCYCLS
      , :new.REQUESTSDOCSTATE
      , :new.TAXNOTE
      , :new.GOSNI
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.FEDERALFUNDSREF
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.REESTRDATE
      , :new.AMONTH
      , :new.AYEAR
      , :new.EXECSUMMA
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.PAYPROMISECLS
      , :new.BUDALLOCATIONCLS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_REQUESTS
  AFTER UPDATE
  ON TB_REQUESTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_REQUESTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_REQUESTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_REQUESTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGET
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,USERNOTE
      ,FACIALACC_CLS
      ,SOURCEACCOUNT
      ,DESTACCOUNT
      ,FACT
      ,FINSOURCE
      ,FINTYPE
      ,REGIONCLS
      ,BUHPAYMENTCLS
      ,DOCTYPE
      ,PAYDATE
      ,PAYPRIORITY
      ,SUMMAREQUESTED
      ,SUMMATOFINANCE
      ,REQUESTTYPE
      ,MEANSTYPE
      ,PAYSYMBOLCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ANUMBER
      ,PROMISE
      ,DOCUMENTBASETYPE
      ,INPUTDATE
      ,DFACCOUNT
      ,PROGINDEX
      ,PROGINDEX2
      ,RECORDINDEX
      ,INNERFINSOURCE
      ,OUTERFINSOURCE
      ,KD
      ,SUBKD
      ,PLANDATE
      ,CURRENCYCLS
      ,REQUESTSDOCSTATE
      ,TAXNOTE
      ,GOSNI
      ,CURRENCYSUMMA
      ,RVERSION
      ,DIRECTIONCLS
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,FEDERALFUNDSREF
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,CLSTYPE
      ,REESTRDATE
      ,AMONTH
      ,AYEAR
      ,EXECSUMMA
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,PAYPROMISECLS
      ,BUDALLOCATIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGET
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.USERNOTE
      , :new.FACIALACC_CLS
      , :new.SOURCEACCOUNT
      , :new.DESTACCOUNT
      , :new.FACT
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.REGIONCLS
      , :new.BUHPAYMENTCLS
      , :new.DOCTYPE
      , :new.PAYDATE
      , :new.PAYPRIORITY
      , :new.SUMMAREQUESTED
      , :new.SUMMATOFINANCE
      , :new.REQUESTTYPE
      , :new.MEANSTYPE
      , :new.PAYSYMBOLCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.PROMISE
      , :new.DOCUMENTBASETYPE
      , :new.INPUTDATE
      , :new.DFACCOUNT
      , :new.PROGINDEX
      , :new.PROGINDEX2
      , :new.RECORDINDEX
      , :new.INNERFINSOURCE
      , :new.OUTERFINSOURCE
      , :new.KD
      , :new.SUBKD
      , :new.PLANDATE
      , :new.CURRENCYCLS
      , :new.REQUESTSDOCSTATE
      , :new.TAXNOTE
      , :new.GOSNI
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.FEDERALFUNDSREF
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.REESTRDATE
      , :new.AMONTH
      , :new.AYEAR
      , :new.EXECSUMMA
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.PAYPROMISECLS
      , :new.BUDALLOCATIONCLS
    );
  else 
    update A_TB_REQUESTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_REQUESTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGET
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,USERNOTE
      ,FACIALACC_CLS
      ,SOURCEACCOUNT
      ,DESTACCOUNT
      ,FACT
      ,FINSOURCE
      ,FINTYPE
      ,REGIONCLS
      ,BUHPAYMENTCLS
      ,DOCTYPE
      ,PAYDATE
      ,PAYPRIORITY
      ,SUMMAREQUESTED
      ,SUMMATOFINANCE
      ,REQUESTTYPE
      ,MEANSTYPE
      ,PAYSYMBOLCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ANUMBER
      ,PROMISE
      ,DOCUMENTBASETYPE
      ,INPUTDATE
      ,DFACCOUNT
      ,PROGINDEX
      ,PROGINDEX2
      ,RECORDINDEX
      ,INNERFINSOURCE
      ,OUTERFINSOURCE
      ,KD
      ,SUBKD
      ,PLANDATE
      ,CURRENCYCLS
      ,REQUESTSDOCSTATE
      ,TAXNOTE
      ,GOSNI
      ,CURRENCYSUMMA
      ,RVERSION
      ,DIRECTIONCLS
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,FEDERALFUNDSREF
      ,BUHOPERATIONCLS
      ,IFS_CORR
      ,CLSTYPE
      ,REESTRDATE
      ,AMONTH
      ,AYEAR
      ,EXECSUMMA
      ,SUBSIDYCLS
      ,TRANSFERTCLS
      ,PAYPROMISECLS
      ,BUDALLOCATIONCLS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGET
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.USERNOTE
      , :new.FACIALACC_CLS
      , :new.SOURCEACCOUNT
      , :new.DESTACCOUNT
      , :new.FACT
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.REGIONCLS
      , :new.BUHPAYMENTCLS
      , :new.DOCTYPE
      , :new.PAYDATE
      , :new.PAYPRIORITY
      , :new.SUMMAREQUESTED
      , :new.SUMMATOFINANCE
      , :new.REQUESTTYPE
      , :new.MEANSTYPE
      , :new.PAYSYMBOLCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.PROMISE
      , :new.DOCUMENTBASETYPE
      , :new.INPUTDATE
      , :new.DFACCOUNT
      , :new.PROGINDEX
      , :new.PROGINDEX2
      , :new.RECORDINDEX
      , :new.INNERFINSOURCE
      , :new.OUTERFINSOURCE
      , :new.KD
      , :new.SUBKD
      , :new.PLANDATE
      , :new.CURRENCYCLS
      , :new.REQUESTSDOCSTATE
      , :new.TAXNOTE
      , :new.GOSNI
      , :new.CURRENCYSUMMA
      , :new.RVERSION
      , :new.DIRECTIONCLS
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.FEDERALFUNDSREF
      , :new.BUHOPERATIONCLS
      , :new.IFS_CORR
      , :new.CLSTYPE
      , :new.REESTRDATE
      , :new.AMONTH
      , :new.AYEAR
      , :new.EXECSUMMA
      , :new.SUBSIDYCLS
      , :new.TRANSFERTCLS
      , :new.PAYPROMISECLS
      , :new.BUDALLOCATIONCLS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_REQUESTS
  AFTER DELETE
  ON TB_REQUESTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_REQUESTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_REQUESTSPAYMENTS
  AFTER INSERT
  ON TB_REQUESTSPAYMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_REQUESTSPAYMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_REQUESTSPAYMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUMMA
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUMMA
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_REQUESTSPAYMENTS
  AFTER UPDATE
  ON TB_REQUESTSPAYMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_REQUESTSPAYMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_REQUESTSPAYMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_REQUESTSPAYMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUMMA
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUMMA
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
  else 
    update A_TB_REQUESTSPAYMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_REQUESTSPAYMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUMMA
      ,RECORDINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUMMA
      , :new.RECORDINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_REQUESTSPAYMENTS
  AFTER DELETE
  ON TB_REQUESTSPAYMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_REQUESTSPAYMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_SIGNSCHEMEDETAIL
  AFTER INSERT
  ON TB_SIGNSCHEMEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_SIGNSCHEMEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_SIGNSCHEMEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,SIGNREF
      ,SIGNORDER
      ,SIGNMASK
      ,FICTIVESIGN
      ,ACTIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.SIGNREF
      , :new.SIGNORDER
      , :new.SIGNMASK
      , :new.FICTIVESIGN
      , :new.ACTIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_SIGNSCHEMEDETAIL
  AFTER UPDATE
  ON TB_SIGNSCHEMEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_SIGNSCHEMEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_SIGNSCHEMEDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_SIGNSCHEMEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,SIGNREF
      ,SIGNORDER
      ,SIGNMASK
      ,FICTIVESIGN
      ,ACTIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.SIGNREF
      , :new.SIGNORDER
      , :new.SIGNMASK
      , :new.FICTIVESIGN
      , :new.ACTIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_TB_SIGNSCHEMEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_SIGNSCHEMEDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,SIGNREF
      ,SIGNORDER
      ,SIGNMASK
      ,FICTIVESIGN
      ,ACTIONREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.SIGNREF
      , :new.SIGNORDER
      , :new.SIGNMASK
      , :new.FICTIVESIGN
      , :new.ACTIONREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_SIGNSCHEMEDETAIL
  AFTER DELETE
  ON TB_SIGNSCHEMEDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_SIGNSCHEMEDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_STATE_ACTIONS
  AFTER INSERT
  ON TB_STATE_ACTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_STATE_ACTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_STATE_ACTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,INVISIBLE
      ,HINT
      ,ICONNAME
      ,ACTIONNAME
      ,ACTPOSITION
      ,DOCTYPEREF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ACTEVENT
      ,BACKACTION
      ,ISBUDGET
      ,OPTIONSPATH
      ,EXCHACCEPT
      ,EXCHREJECT
      ,EXCHPACKETSEND
      ,EXCHPACKETREM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.INVISIBLE
      , :new.HINT
      , :new.ICONNAME
      , :new.ACTIONNAME
      , :new.ACTPOSITION
      , :new.DOCTYPEREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ACTEVENT
      , :new.BACKACTION
      , :new.ISBUDGET
      , :new.OPTIONSPATH
      , :new.EXCHACCEPT
      , :new.EXCHREJECT
      , :new.EXCHPACKETSEND
      , :new.EXCHPACKETREM
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_STATE_ACTIONS
  AFTER UPDATE
  ON TB_STATE_ACTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_STATE_ACTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_STATE_ACTIONS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_STATE_ACTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,INVISIBLE
      ,HINT
      ,ICONNAME
      ,ACTIONNAME
      ,ACTPOSITION
      ,DOCTYPEREF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ACTEVENT
      ,BACKACTION
      ,ISBUDGET
      ,OPTIONSPATH
      ,EXCHACCEPT
      ,EXCHREJECT
      ,EXCHPACKETSEND
      ,EXCHPACKETREM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.INVISIBLE
      , :new.HINT
      , :new.ICONNAME
      , :new.ACTIONNAME
      , :new.ACTPOSITION
      , :new.DOCTYPEREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ACTEVENT
      , :new.BACKACTION
      , :new.ISBUDGET
      , :new.OPTIONSPATH
      , :new.EXCHACCEPT
      , :new.EXCHREJECT
      , :new.EXCHPACKETSEND
      , :new.EXCHPACKETREM
    );
  else 
    update A_TB_STATE_ACTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_STATE_ACTIONS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,INVISIBLE
      ,HINT
      ,ICONNAME
      ,ACTIONNAME
      ,ACTPOSITION
      ,DOCTYPEREF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ACTEVENT
      ,BACKACTION
      ,ISBUDGET
      ,OPTIONSPATH
      ,EXCHACCEPT
      ,EXCHREJECT
      ,EXCHPACKETSEND
      ,EXCHPACKETREM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.INVISIBLE
      , :new.HINT
      , :new.ICONNAME
      , :new.ACTIONNAME
      , :new.ACTPOSITION
      , :new.DOCTYPEREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ACTEVENT
      , :new.BACKACTION
      , :new.ISBUDGET
      , :new.OPTIONSPATH
      , :new.EXCHACCEPT
      , :new.EXCHREJECT
      , :new.EXCHPACKETSEND
      , :new.EXCHPACKETREM
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_STATE_ACTIONS
  AFTER DELETE
  ON TB_STATE_ACTIONS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_STATE_ACTIONS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_STATICLINKS
  AFTER INSERT
  ON TB_STATICLINKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_STATICLINKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_STATICLINKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,PARENTFIELDREF
      ,CHILDFIELDREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LINKKIND
      ,PARENTDELACTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.PARENTFIELDREF
      , :new.CHILDFIELDREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LINKKIND
      , :new.PARENTDELACTION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_STATICLINKS
  AFTER UPDATE
  ON TB_STATICLINKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_STATICLINKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_STATICLINKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_STATICLINKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,PARENTFIELDREF
      ,CHILDFIELDREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LINKKIND
      ,PARENTDELACTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.PARENTFIELDREF
      , :new.CHILDFIELDREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LINKKIND
      , :new.PARENTDELACTION
    );
  else 
    update A_TB_STATICLINKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_STATICLINKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,PARENTFIELDREF
      ,CHILDFIELDREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LINKKIND
      ,PARENTDELACTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.PARENTFIELDREF
      , :new.CHILDFIELDREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LINKKIND
      , :new.PARENTDELACTION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_STATICLINKS
  AFTER DELETE
  ON TB_STATICLINKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_STATICLINKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_TENDERCAPTION
  AFTER INSERT
  ON TB_TENDERCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_TENDERCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_TENDERCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,FACIALACCCLS
      ,MULTIPURPOSE
      ,DOCUMENTDATE
      ,ACCEPTDATE
      ,PERIOD
      ,ACCEPTSUMMA
      ,SALETYPE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,LASTADJUSTMENT
      ,LASTACCEPTED
      ,ADJUSTMENTREF
      ,ACCEPTED
      ,EXPORTDATE
      ,YEARACCEPTSUMMA
      ,TENDEROPTION
      ,TENDERTARGET
      ,RVERSION
      ,ALLOWANCE
      ,REFINEMENTCAUSE
      ,PREFERENCE
      ,PREFERENCESIZE
      ,SECURITY
      ,UNKNOWNAMOUNT
      ,PERIODYEAR
      ,SUPPORTUNDERTAKER
      ,AYEAR
      ,REWORKCAUSE
      ,NOTE
      ,REALID
      ,INNERNUMBER
      ,ADJUSTMENTNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,PROTOCOLREASON
      ,PROGINDEX
      ,DOCNUMBER
      ,SECURITYTSIZE
      ,SECURITYASIZE
      ,AVANSSIZE
      ,PREFERENCECRIPPLE
      ,PREFERENCERUSPRODUCT
      ,PREFERENCEPRISON
      ,AGREEMENTEXECUTIONDATE
      ,PURCHASECODE
      ,PURCHASESOCIALNKO
      ,AVERSION
      ,PARENTREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.FACIALACCCLS
      , :new.MULTIPURPOSE
      , :new.DOCUMENTDATE
      , :new.ACCEPTDATE
      , :new.PERIOD
      , :new.ACCEPTSUMMA
      , :new.SALETYPE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.LASTADJUSTMENT
      , :new.LASTACCEPTED
      , :new.ADJUSTMENTREF
      , :new.ACCEPTED
      , :new.EXPORTDATE
      , :new.YEARACCEPTSUMMA
      , :new.TENDEROPTION
      , :new.TENDERTARGET
      , :new.RVERSION
      , :new.ALLOWANCE
      , :new.REFINEMENTCAUSE
      , :new.PREFERENCE
      , :new.PREFERENCESIZE
      , :new.SECURITY
      , :new.UNKNOWNAMOUNT
      , :new.PERIODYEAR
      , :new.SUPPORTUNDERTAKER
      , :new.AYEAR
      , :new.REWORKCAUSE
      , :new.NOTE
      , :new.REALID
      , :new.INNERNUMBER
      , :new.ADJUSTMENTNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.PROTOCOLREASON
      , :new.PROGINDEX
      , :new.DOCNUMBER
      , :new.SECURITYTSIZE
      , :new.SECURITYASIZE
      , :new.AVANSSIZE
      , :new.PREFERENCECRIPPLE
      , :new.PREFERENCERUSPRODUCT
      , :new.PREFERENCEPRISON
      , :new.AGREEMENTEXECUTIONDATE
      , :new.PURCHASECODE
      , :new.PURCHASESOCIALNKO
      , :new.AVERSION
      , :new.PARENTREF
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_TENDERCAPTION
  AFTER UPDATE
  ON TB_TENDERCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_TENDERCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_TENDERCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_TENDERCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,FACIALACCCLS
      ,MULTIPURPOSE
      ,DOCUMENTDATE
      ,ACCEPTDATE
      ,PERIOD
      ,ACCEPTSUMMA
      ,SALETYPE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,LASTADJUSTMENT
      ,LASTACCEPTED
      ,ADJUSTMENTREF
      ,ACCEPTED
      ,EXPORTDATE
      ,YEARACCEPTSUMMA
      ,TENDEROPTION
      ,TENDERTARGET
      ,RVERSION
      ,ALLOWANCE
      ,REFINEMENTCAUSE
      ,PREFERENCE
      ,PREFERENCESIZE
      ,SECURITY
      ,UNKNOWNAMOUNT
      ,PERIODYEAR
      ,SUPPORTUNDERTAKER
      ,AYEAR
      ,REWORKCAUSE
      ,NOTE
      ,REALID
      ,INNERNUMBER
      ,ADJUSTMENTNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,PROTOCOLREASON
      ,PROGINDEX
      ,DOCNUMBER
      ,SECURITYTSIZE
      ,SECURITYASIZE
      ,AVANSSIZE
      ,PREFERENCECRIPPLE
      ,PREFERENCERUSPRODUCT
      ,PREFERENCEPRISON
      ,AGREEMENTEXECUTIONDATE
      ,PURCHASECODE
      ,PURCHASESOCIALNKO
      ,AVERSION
      ,PARENTREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.FACIALACCCLS
      , :new.MULTIPURPOSE
      , :new.DOCUMENTDATE
      , :new.ACCEPTDATE
      , :new.PERIOD
      , :new.ACCEPTSUMMA
      , :new.SALETYPE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.LASTADJUSTMENT
      , :new.LASTACCEPTED
      , :new.ADJUSTMENTREF
      , :new.ACCEPTED
      , :new.EXPORTDATE
      , :new.YEARACCEPTSUMMA
      , :new.TENDEROPTION
      , :new.TENDERTARGET
      , :new.RVERSION
      , :new.ALLOWANCE
      , :new.REFINEMENTCAUSE
      , :new.PREFERENCE
      , :new.PREFERENCESIZE
      , :new.SECURITY
      , :new.UNKNOWNAMOUNT
      , :new.PERIODYEAR
      , :new.SUPPORTUNDERTAKER
      , :new.AYEAR
      , :new.REWORKCAUSE
      , :new.NOTE
      , :new.REALID
      , :new.INNERNUMBER
      , :new.ADJUSTMENTNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.PROTOCOLREASON
      , :new.PROGINDEX
      , :new.DOCNUMBER
      , :new.SECURITYTSIZE
      , :new.SECURITYASIZE
      , :new.AVANSSIZE
      , :new.PREFERENCECRIPPLE
      , :new.PREFERENCERUSPRODUCT
      , :new.PREFERENCEPRISON
      , :new.AGREEMENTEXECUTIONDATE
      , :new.PURCHASECODE
      , :new.PURCHASESOCIALNKO
      , :new.AVERSION
      , :new.PARENTREF
    );
  else 
    update A_TB_TENDERCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_TENDERCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,FACIALACCCLS
      ,MULTIPURPOSE
      ,DOCUMENTDATE
      ,ACCEPTDATE
      ,PERIOD
      ,ACCEPTSUMMA
      ,SALETYPE
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,LASTADJUSTMENT
      ,LASTACCEPTED
      ,ADJUSTMENTREF
      ,ACCEPTED
      ,EXPORTDATE
      ,YEARACCEPTSUMMA
      ,TENDEROPTION
      ,TENDERTARGET
      ,RVERSION
      ,ALLOWANCE
      ,REFINEMENTCAUSE
      ,PREFERENCE
      ,PREFERENCESIZE
      ,SECURITY
      ,UNKNOWNAMOUNT
      ,PERIODYEAR
      ,SUPPORTUNDERTAKER
      ,AYEAR
      ,REWORKCAUSE
      ,NOTE
      ,REALID
      ,INNERNUMBER
      ,ADJUSTMENTNUMBER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,PROTOCOLREASON
      ,PROGINDEX
      ,DOCNUMBER
      ,SECURITYTSIZE
      ,SECURITYASIZE
      ,AVANSSIZE
      ,PREFERENCECRIPPLE
      ,PREFERENCERUSPRODUCT
      ,PREFERENCEPRISON
      ,AGREEMENTEXECUTIONDATE
      ,PURCHASECODE
      ,PURCHASESOCIALNKO
      ,AVERSION
      ,PARENTREF
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.FACIALACCCLS
      , :new.MULTIPURPOSE
      , :new.DOCUMENTDATE
      , :new.ACCEPTDATE
      , :new.PERIOD
      , :new.ACCEPTSUMMA
      , :new.SALETYPE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.LASTADJUSTMENT
      , :new.LASTACCEPTED
      , :new.ADJUSTMENTREF
      , :new.ACCEPTED
      , :new.EXPORTDATE
      , :new.YEARACCEPTSUMMA
      , :new.TENDEROPTION
      , :new.TENDERTARGET
      , :new.RVERSION
      , :new.ALLOWANCE
      , :new.REFINEMENTCAUSE
      , :new.PREFERENCE
      , :new.PREFERENCESIZE
      , :new.SECURITY
      , :new.UNKNOWNAMOUNT
      , :new.PERIODYEAR
      , :new.SUPPORTUNDERTAKER
      , :new.AYEAR
      , :new.REWORKCAUSE
      , :new.NOTE
      , :new.REALID
      , :new.INNERNUMBER
      , :new.ADJUSTMENTNUMBER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.PROTOCOLREASON
      , :new.PROGINDEX
      , :new.DOCNUMBER
      , :new.SECURITYTSIZE
      , :new.SECURITYASIZE
      , :new.AVANSSIZE
      , :new.PREFERENCECRIPPLE
      , :new.PREFERENCERUSPRODUCT
      , :new.PREFERENCEPRISON
      , :new.AGREEMENTEXECUTIONDATE
      , :new.PURCHASECODE
      , :new.PURCHASESOCIALNKO
      , :new.AVERSION
      , :new.PARENTREF
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_TENDERCAPTION
  AFTER DELETE
  ON TB_TENDERCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_TENDERCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_TRANSFERTCLS
  AFTER INSERT
  ON TB_TRANSFERTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_TRANSFERTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_TRANSFERTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGIONCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CODE
      ,RECEIVEKVSR
      ,RECEIVEKFSR
      ,RECEIVEKVR
      ,RECEIVEKESR
      ,RECEIVEKD
      ,TRANSFERKVSR
      ,TRANSFERKFSR
      ,TRANSFERKCSR
      ,TRANSFERKVR
      ,TRANSFERKESR
      ,TRANSFERKDVALUE
      ,TARGETMEANSSIGN
      ,TARGETCLS
      ,STARTDATE
      ,DELETEDATE
      ,NOTE
      ,NAME
      ,BUDGETREF
      ,RECEIVEKCSR
      ,SOURCELEVEL
      ,DESTLEVEL
      ,TRANSFERTKIND
      ,GRANTKIND
      ,TRANSFERTYEAR
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,FACT
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGIONCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CODE
      , :new.RECEIVEKVSR
      , :new.RECEIVEKFSR
      , :new.RECEIVEKVR
      , :new.RECEIVEKESR
      , :new.RECEIVEKD
      , :new.TRANSFERKVSR
      , :new.TRANSFERKFSR
      , :new.TRANSFERKCSR
      , :new.TRANSFERKVR
      , :new.TRANSFERKESR
      , :new.TRANSFERKDVALUE
      , :new.TARGETMEANSSIGN
      , :new.TARGETCLS
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.NOTE
      , :new.NAME
      , :new.BUDGETREF
      , :new.RECEIVEKCSR
      , :new.SOURCELEVEL
      , :new.DESTLEVEL
      , :new.TRANSFERTKIND
      , :new.GRANTKIND
      , :new.TRANSFERTYEAR
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.FACT
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_TRANSFERTCLS
  AFTER UPDATE
  ON TB_TRANSFERTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_TRANSFERTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_TRANSFERTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_TRANSFERTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGIONCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CODE
      ,RECEIVEKVSR
      ,RECEIVEKFSR
      ,RECEIVEKVR
      ,RECEIVEKESR
      ,RECEIVEKD
      ,TRANSFERKVSR
      ,TRANSFERKFSR
      ,TRANSFERKCSR
      ,TRANSFERKVR
      ,TRANSFERKESR
      ,TRANSFERKDVALUE
      ,TARGETMEANSSIGN
      ,TARGETCLS
      ,STARTDATE
      ,DELETEDATE
      ,NOTE
      ,NAME
      ,BUDGETREF
      ,RECEIVEKCSR
      ,SOURCELEVEL
      ,DESTLEVEL
      ,TRANSFERTKIND
      ,GRANTKIND
      ,TRANSFERTYEAR
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,FACT
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGIONCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CODE
      , :new.RECEIVEKVSR
      , :new.RECEIVEKFSR
      , :new.RECEIVEKVR
      , :new.RECEIVEKESR
      , :new.RECEIVEKD
      , :new.TRANSFERKVSR
      , :new.TRANSFERKFSR
      , :new.TRANSFERKCSR
      , :new.TRANSFERKVR
      , :new.TRANSFERKESR
      , :new.TRANSFERKDVALUE
      , :new.TARGETMEANSSIGN
      , :new.TARGETCLS
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.NOTE
      , :new.NAME
      , :new.BUDGETREF
      , :new.RECEIVEKCSR
      , :new.SOURCELEVEL
      , :new.DESTLEVEL
      , :new.TRANSFERTKIND
      , :new.GRANTKIND
      , :new.TRANSFERTYEAR
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.FACT
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  else 
    update A_TB_TRANSFERTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_TRANSFERTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGIONCLS
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,CODE
      ,RECEIVEKVSR
      ,RECEIVEKFSR
      ,RECEIVEKVR
      ,RECEIVEKESR
      ,RECEIVEKD
      ,TRANSFERKVSR
      ,TRANSFERKFSR
      ,TRANSFERKCSR
      ,TRANSFERKVR
      ,TRANSFERKESR
      ,TRANSFERKDVALUE
      ,TARGETMEANSSIGN
      ,TARGETCLS
      ,STARTDATE
      ,DELETEDATE
      ,NOTE
      ,NAME
      ,BUDGETREF
      ,RECEIVEKCSR
      ,SOURCELEVEL
      ,DESTLEVEL
      ,TRANSFERTKIND
      ,GRANTKIND
      ,TRANSFERTYEAR
      ,EXTID
      ,EXTOWNER
      ,EXTSYNCDATE
      ,FACT
      ,EXTROOTID
      ,EXTVERSION
      ,EXTVERSIONDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGIONCLS
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.CODE
      , :new.RECEIVEKVSR
      , :new.RECEIVEKFSR
      , :new.RECEIVEKVR
      , :new.RECEIVEKESR
      , :new.RECEIVEKD
      , :new.TRANSFERKVSR
      , :new.TRANSFERKFSR
      , :new.TRANSFERKCSR
      , :new.TRANSFERKVR
      , :new.TRANSFERKESR
      , :new.TRANSFERKDVALUE
      , :new.TARGETMEANSSIGN
      , :new.TARGETCLS
      , :new.STARTDATE
      , :new.DELETEDATE
      , :new.NOTE
      , :new.NAME
      , :new.BUDGETREF
      , :new.RECEIVEKCSR
      , :new.SOURCELEVEL
      , :new.DESTLEVEL
      , :new.TRANSFERTKIND
      , :new.GRANTKIND
      , :new.TRANSFERTYEAR
      , :new.EXTID
      , :new.EXTOWNER
      , :new.EXTSYNCDATE
      , :new.FACT
      , :new.EXTROOTID
      , :new.EXTVERSION
      , :new.EXTVERSIONDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_TRANSFERTCLS
  AFTER DELETE
  ON TB_TRANSFERTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_TRANSFERTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_UNLOCKDATES
  AFTER INSERT
  ON TB_UNLOCKDATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UNLOCKDATES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UNLOCKDATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,UNLOCKDATE
      ,UNLOCK
      ,NOTE
      ,JNUMBER
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,JOURNALFLAG
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,DAYKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.UNLOCKDATE
      , :new.UNLOCK
      , :new.NOTE
      , :new.JNUMBER
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.JOURNALFLAG
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.DAYKIND
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_UNLOCKDATES
  AFTER UPDATE
  ON TB_UNLOCKDATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_UNLOCKDATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_UNLOCKDATES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UNLOCKDATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,UNLOCKDATE
      ,UNLOCK
      ,NOTE
      ,JNUMBER
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,JOURNALFLAG
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,DAYKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.UNLOCKDATE
      , :new.UNLOCK
      , :new.NOTE
      , :new.JNUMBER
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.JOURNALFLAG
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.DAYKIND
    );
  else 
    update A_TB_UNLOCKDATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_UNLOCKDATES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,UNLOCKDATE
      ,UNLOCK
      ,NOTE
      ,JNUMBER
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,JOURNALFLAG
      ,DOCSTATEREF
      ,CRYPTOSTATUS
      ,DAYKIND
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.UNLOCKDATE
      , :new.UNLOCK
      , :new.NOTE
      , :new.JNUMBER
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.JOURNALFLAG
      , :new.DOCSTATEREF
      , :new.CRYPTOSTATUS
      , :new.DAYKIND
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_UNLOCKDATES
  AFTER DELETE
  ON TB_UNLOCKDATES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UNLOCKDATES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_USER_WORKPLACES
  AFTER INSERT
  ON TB_USER_WORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_USER_WORKPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_USER_WORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERS_REF
      ,WORKPLACES_REF
      ,DEFAULTWORKPLACE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERS_REF
      , :new.WORKPLACES_REF
      , :new.DEFAULTWORKPLACE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_USER_WORKPLACES
  AFTER UPDATE
  ON TB_USER_WORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_USER_WORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_USER_WORKPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_USER_WORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERS_REF
      ,WORKPLACES_REF
      ,DEFAULTWORKPLACE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERS_REF
      , :new.WORKPLACES_REF
      , :new.DEFAULTWORKPLACE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_TB_USER_WORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_USER_WORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERS_REF
      ,WORKPLACES_REF
      ,DEFAULTWORKPLACE
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERS_REF
      , :new.WORKPLACES_REF
      , :new.DEFAULTWORKPLACE
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_USER_WORKPLACES
  AFTER DELETE
  ON TB_USER_WORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_USER_WORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_UTYPEDFORMS
  AFTER INSERT
  ON TB_UTYPEDFORMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UTYPEDFORMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UTYPEDFORMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDFORMTMPLT
      ,REPORTTMPLT
      ,NOTE
      ,ONOPENDETAIL
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCTMPLT
      ,LOCKED
      ,PARAMS
      ,IMPORTLIST
      ,EXPORTLIST
      ,GROUPINDEX
      ,NAME
      ,REPORTKIND
      ,NEEDVERSION
      ,SHORTNAME
      ,MINFINCODE
      ,PARAMLIST
      ,TEXTID
      ,VERSIONNUMBER
      ,BEGINDATE
      ,ENDDATE
      ,ISCLIENT
      ,FORURM
      ,PRINTDOCLIST
      ,CONTROLLIST
      ,CONSTMPLT
      ,PERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDFORMTMPLT
      , :new.REPORTTMPLT
      , :new.NOTE
      , :new.ONOPENDETAIL
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCTMPLT
      , :new.LOCKED
      , :new.PARAMS
      , :new.IMPORTLIST
      , :new.EXPORTLIST
      , :new.GROUPINDEX
      , :new.NAME
      , :new.REPORTKIND
      , :new.NEEDVERSION
      , :new.SHORTNAME
      , :new.MINFINCODE
      , :new.PARAMLIST
      , :new.TEXTID
      , :new.VERSIONNUMBER
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.ISCLIENT
      , :new.FORURM
      , :new.PRINTDOCLIST
      , :new.CONTROLLIST
      , :new.CONSTMPLT
      , :new.PERIOD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_UTYPEDFORMS
  AFTER UPDATE
  ON TB_UTYPEDFORMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_UTYPEDFORMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_UTYPEDFORMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UTYPEDFORMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDFORMTMPLT
      ,REPORTTMPLT
      ,NOTE
      ,ONOPENDETAIL
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCTMPLT
      ,LOCKED
      ,PARAMS
      ,IMPORTLIST
      ,EXPORTLIST
      ,GROUPINDEX
      ,NAME
      ,REPORTKIND
      ,NEEDVERSION
      ,SHORTNAME
      ,MINFINCODE
      ,PARAMLIST
      ,TEXTID
      ,VERSIONNUMBER
      ,BEGINDATE
      ,ENDDATE
      ,ISCLIENT
      ,FORURM
      ,PRINTDOCLIST
      ,CONTROLLIST
      ,CONSTMPLT
      ,PERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDFORMTMPLT
      , :new.REPORTTMPLT
      , :new.NOTE
      , :new.ONOPENDETAIL
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCTMPLT
      , :new.LOCKED
      , :new.PARAMS
      , :new.IMPORTLIST
      , :new.EXPORTLIST
      , :new.GROUPINDEX
      , :new.NAME
      , :new.REPORTKIND
      , :new.NEEDVERSION
      , :new.SHORTNAME
      , :new.MINFINCODE
      , :new.PARAMLIST
      , :new.TEXTID
      , :new.VERSIONNUMBER
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.ISCLIENT
      , :new.FORURM
      , :new.PRINTDOCLIST
      , :new.CONTROLLIST
      , :new.CONSTMPLT
      , :new.PERIOD
    );
  else 
    update A_TB_UTYPEDFORMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_UTYPEDFORMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDFORMTMPLT
      ,REPORTTMPLT
      ,NOTE
      ,ONOPENDETAIL
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DOCTMPLT
      ,LOCKED
      ,PARAMS
      ,IMPORTLIST
      ,EXPORTLIST
      ,GROUPINDEX
      ,NAME
      ,REPORTKIND
      ,NEEDVERSION
      ,SHORTNAME
      ,MINFINCODE
      ,PARAMLIST
      ,TEXTID
      ,VERSIONNUMBER
      ,BEGINDATE
      ,ENDDATE
      ,ISCLIENT
      ,FORURM
      ,PRINTDOCLIST
      ,CONTROLLIST
      ,CONSTMPLT
      ,PERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDFORMTMPLT
      , :new.REPORTTMPLT
      , :new.NOTE
      , :new.ONOPENDETAIL
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DOCTMPLT
      , :new.LOCKED
      , :new.PARAMS
      , :new.IMPORTLIST
      , :new.EXPORTLIST
      , :new.GROUPINDEX
      , :new.NAME
      , :new.REPORTKIND
      , :new.NEEDVERSION
      , :new.SHORTNAME
      , :new.MINFINCODE
      , :new.PARAMLIST
      , :new.TEXTID
      , :new.VERSIONNUMBER
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.ISCLIENT
      , :new.FORURM
      , :new.PRINTDOCLIST
      , :new.CONTROLLIST
      , :new.CONSTMPLT
      , :new.PERIOD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_UTYPEDFORMS
  AFTER DELETE
  ON TB_UTYPEDFORMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UTYPEDFORMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_UTYPEDFORMSCAPTION
  AFTER INSERT
  ON TB_UTYPEDFORMSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UTYPEDFORMSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UTYPEDFORMSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGIONCLS
      ,ACCEPTDATE
      ,DOCNUMBER
      ,NOTE
      ,TYPEDFORM
      ,PROGINDEX
      ,FACIALACC_CLS
      ,ORG_REF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,EMAIL
      ,STATE
      ,ERROR
      ,SOURCEID
      ,SOURCEMAILID
      ,AUTOTASKSSERVER
      ,DEPARTMENTCLS
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,UTFRINDEX
      ,REPORTDATE
      ,ESTIMDATE
      ,SELF
      ,CLIENTSTYPE
      ,SENDKIT
      ,SENDSTS
      ,SENDDOC
      ,MANUALEXEC
      ,DATAMODE
      ,BUDGETREF
      ,REPORTYEAR
      ,REJECTCLS
      ,REJECTCAUSE
      ,DOCSTATEREF
      ,RVERSION
      ,LASTEXTRCHANGE
      ,VERSIONID
      ,CONSCLIENT
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,PARAMS
      ,FORMTEXTID
      ,REGTEXTID
      ,PERIODTEXTID
      ,REPORTMONTH
      ,ACTIVITYKIND
      ,PERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGIONCLS
      , :new.ACCEPTDATE
      , :new.DOCNUMBER
      , :new.NOTE
      , :new.TYPEDFORM
      , :new.PROGINDEX
      , :new.FACIALACC_CLS
      , :new.ORG_REF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.EMAIL
      , :new.STATE
      , :new.ERROR
      , :new.SOURCEID
      , :new.SOURCEMAILID
      , :new.AUTOTASKSSERVER
      , :new.DEPARTMENTCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.UTFRINDEX
      , :new.REPORTDATE
      , :new.ESTIMDATE
      , :new.SELF
      , :new.CLIENTSTYPE
      , :new.SENDKIT
      , :new.SENDSTS
      , :new.SENDDOC
      , :new.MANUALEXEC
      , :new.DATAMODE
      , :new.BUDGETREF
      , :new.REPORTYEAR
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.LASTEXTRCHANGE
      , :new.VERSIONID
      , :new.CONSCLIENT
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.PARAMS
      , :new.FORMTEXTID
      , :new.REGTEXTID
      , :new.PERIODTEXTID
      , :new.REPORTMONTH
      , :new.ACTIVITYKIND
      , :new.PERIOD
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_UTYPEDFORMSCAPTION
  AFTER UPDATE
  ON TB_UTYPEDFORMSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_UTYPEDFORMSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_UTYPEDFORMSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UTYPEDFORMSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGIONCLS
      ,ACCEPTDATE
      ,DOCNUMBER
      ,NOTE
      ,TYPEDFORM
      ,PROGINDEX
      ,FACIALACC_CLS
      ,ORG_REF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,EMAIL
      ,STATE
      ,ERROR
      ,SOURCEID
      ,SOURCEMAILID
      ,AUTOTASKSSERVER
      ,DEPARTMENTCLS
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,UTFRINDEX
      ,REPORTDATE
      ,ESTIMDATE
      ,SELF
      ,CLIENTSTYPE
      ,SENDKIT
      ,SENDSTS
      ,SENDDOC
      ,MANUALEXEC
      ,DATAMODE
      ,BUDGETREF
      ,REPORTYEAR
      ,REJECTCLS
      ,REJECTCAUSE
      ,DOCSTATEREF
      ,RVERSION
      ,LASTEXTRCHANGE
      ,VERSIONID
      ,CONSCLIENT
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,PARAMS
      ,FORMTEXTID
      ,REGTEXTID
      ,PERIODTEXTID
      ,REPORTMONTH
      ,ACTIVITYKIND
      ,PERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGIONCLS
      , :new.ACCEPTDATE
      , :new.DOCNUMBER
      , :new.NOTE
      , :new.TYPEDFORM
      , :new.PROGINDEX
      , :new.FACIALACC_CLS
      , :new.ORG_REF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.EMAIL
      , :new.STATE
      , :new.ERROR
      , :new.SOURCEID
      , :new.SOURCEMAILID
      , :new.AUTOTASKSSERVER
      , :new.DEPARTMENTCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.UTFRINDEX
      , :new.REPORTDATE
      , :new.ESTIMDATE
      , :new.SELF
      , :new.CLIENTSTYPE
      , :new.SENDKIT
      , :new.SENDSTS
      , :new.SENDDOC
      , :new.MANUALEXEC
      , :new.DATAMODE
      , :new.BUDGETREF
      , :new.REPORTYEAR
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.LASTEXTRCHANGE
      , :new.VERSIONID
      , :new.CONSCLIENT
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.PARAMS
      , :new.FORMTEXTID
      , :new.REGTEXTID
      , :new.PERIODTEXTID
      , :new.REPORTMONTH
      , :new.ACTIVITYKIND
      , :new.PERIOD
    );
  else 
    update A_TB_UTYPEDFORMSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_UTYPEDFORMSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGIONCLS
      ,ACCEPTDATE
      ,DOCNUMBER
      ,NOTE
      ,TYPEDFORM
      ,PROGINDEX
      ,FACIALACC_CLS
      ,ORG_REF
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,EMAIL
      ,STATE
      ,ERROR
      ,SOURCEID
      ,SOURCEMAILID
      ,AUTOTASKSSERVER
      ,DEPARTMENTCLS
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,UTFRINDEX
      ,REPORTDATE
      ,ESTIMDATE
      ,SELF
      ,CLIENTSTYPE
      ,SENDKIT
      ,SENDSTS
      ,SENDDOC
      ,MANUALEXEC
      ,DATAMODE
      ,BUDGETREF
      ,REPORTYEAR
      ,REJECTCLS
      ,REJECTCAUSE
      ,DOCSTATEREF
      ,RVERSION
      ,LASTEXTRCHANGE
      ,VERSIONID
      ,CONSCLIENT
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,PARAMS
      ,FORMTEXTID
      ,REGTEXTID
      ,PERIODTEXTID
      ,REPORTMONTH
      ,ACTIVITYKIND
      ,PERIOD
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGIONCLS
      , :new.ACCEPTDATE
      , :new.DOCNUMBER
      , :new.NOTE
      , :new.TYPEDFORM
      , :new.PROGINDEX
      , :new.FACIALACC_CLS
      , :new.ORG_REF
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.EMAIL
      , :new.STATE
      , :new.ERROR
      , :new.SOURCEID
      , :new.SOURCEMAILID
      , :new.AUTOTASKSSERVER
      , :new.DEPARTMENTCLS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.UTFRINDEX
      , :new.REPORTDATE
      , :new.ESTIMDATE
      , :new.SELF
      , :new.CLIENTSTYPE
      , :new.SENDKIT
      , :new.SENDSTS
      , :new.SENDDOC
      , :new.MANUALEXEC
      , :new.DATAMODE
      , :new.BUDGETREF
      , :new.REPORTYEAR
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.LASTEXTRCHANGE
      , :new.VERSIONID
      , :new.CONSCLIENT
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.PARAMS
      , :new.FORMTEXTID
      , :new.REGTEXTID
      , :new.PERIODTEXTID
      , :new.REPORTMONTH
      , :new.ACTIVITYKIND
      , :new.PERIOD
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_UTYPEDFORMSCAPTION
  AFTER DELETE
  ON TB_UTYPEDFORMSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UTYPEDFORMSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TB_UTYPEDFORMSVERSION
  AFTER INSERT
  ON TB_UTYPEDFORMSVERSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UTYPEDFORMSVERSION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UTYPEDFORMSVERSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDFORM
      ,VERSIONNUMBER
      ,REPORTNUMBER
      ,FORMCRC32
      ,ISCURRENT
      ,VERSIONINFO
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,USEFORURM
      ,ISCURRENTFORURM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDFORM
      , :new.VERSIONNUMBER
      , :new.REPORTNUMBER
      , :new.FORMCRC32
      , :new.ISCURRENT
      , :new.VERSIONINFO
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.USEFORURM
      , :new.ISCURRENTFORURM
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TB_UTYPEDFORMSVERSION
  AFTER UPDATE
  ON TB_UTYPEDFORMSVERSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TB_UTYPEDFORMSVERSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TB_UTYPEDFORMSVERSION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TB_UTYPEDFORMSVERSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDFORM
      ,VERSIONNUMBER
      ,REPORTNUMBER
      ,FORMCRC32
      ,ISCURRENT
      ,VERSIONINFO
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,USEFORURM
      ,ISCURRENTFORURM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDFORM
      , :new.VERSIONNUMBER
      , :new.REPORTNUMBER
      , :new.FORMCRC32
      , :new.ISCURRENT
      , :new.VERSIONINFO
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.USEFORURM
      , :new.ISCURRENTFORURM
    );
  else 
    update A_TB_UTYPEDFORMSVERSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TB_UTYPEDFORMSVERSION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TYPEDFORM
      ,VERSIONNUMBER
      ,REPORTNUMBER
      ,FORMCRC32
      ,ISCURRENT
      ,VERSIONINFO
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,USEFORURM
      ,ISCURRENTFORURM
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TYPEDFORM
      , :new.VERSIONNUMBER
      , :new.REPORTNUMBER
      , :new.FORMCRC32
      , :new.ISCURRENT
      , :new.VERSIONINFO
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.USEFORURM
      , :new.ISCURRENTFORURM
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TB_UTYPEDFORMSVERSION
  AFTER DELETE
  ON TB_UTYPEDFORMSVERSION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TB_UTYPEDFORMSVERSION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERCONTACTS
  AFTER INSERT
  ON TENDERCONTACTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERCONTACTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERCONTACTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,CONTACTREF
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CONTACTREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERCONTACTS
  AFTER UPDATE
  ON TENDERCONTACTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERCONTACTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERCONTACTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERCONTACTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,CONTACTREF
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CONTACTREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERCONTACTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERCONTACTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,CONTACTREF
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.CONTACTREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERCONTACTS
  AFTER DELETE
  ON TENDERCONTACTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERCONTACTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERLOT
  AFTER INSERT
  ON TENDERLOT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERLOT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERLOT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LOTNUMBER
      ,LOTNOTE
      ,DELIVERYDATE
      ,DELIVERYENDDATE
      ,DELIVERYNOTE
      ,TERMSOFDELIVERY
      ,TERMSOFDELIVERYNOTE
      ,OKATO
      ,OKATONOTE
      ,DELIVERYFORMNOTE
      ,SECURITYTNOTE
      ,SECURITYANOTE
      ,PREFERENCENOTE
      ,GUARANTY
      ,FINNOTE
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,PREFERENCEPRISON
      ,PREFERENCECRIPPLE
      ,STRETCHCONTRACT
      ,GUARANTYSIZE
      ,REALID
      ,SECURITYTSIZE
      ,SECURITYASIZE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LOTNUMBER
      , :new.LOTNOTE
      , :new.DELIVERYDATE
      , :new.DELIVERYENDDATE
      , :new.DELIVERYNOTE
      , :new.TERMSOFDELIVERY
      , :new.TERMSOFDELIVERYNOTE
      , :new.OKATO
      , :new.OKATONOTE
      , :new.DELIVERYFORMNOTE
      , :new.SECURITYTNOTE
      , :new.SECURITYANOTE
      , :new.PREFERENCENOTE
      , :new.GUARANTY
      , :new.FINNOTE
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.PREFERENCEPRISON
      , :new.PREFERENCECRIPPLE
      , :new.STRETCHCONTRACT
      , :new.GUARANTYSIZE
      , :new.REALID
      , :new.SECURITYTSIZE
      , :new.SECURITYASIZE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERLOT
  AFTER UPDATE
  ON TENDERLOT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERLOT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERLOT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERLOT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LOTNUMBER
      ,LOTNOTE
      ,DELIVERYDATE
      ,DELIVERYENDDATE
      ,DELIVERYNOTE
      ,TERMSOFDELIVERY
      ,TERMSOFDELIVERYNOTE
      ,OKATO
      ,OKATONOTE
      ,DELIVERYFORMNOTE
      ,SECURITYTNOTE
      ,SECURITYANOTE
      ,PREFERENCENOTE
      ,GUARANTY
      ,FINNOTE
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,PREFERENCEPRISON
      ,PREFERENCECRIPPLE
      ,STRETCHCONTRACT
      ,GUARANTYSIZE
      ,REALID
      ,SECURITYTSIZE
      ,SECURITYASIZE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LOTNUMBER
      , :new.LOTNOTE
      , :new.DELIVERYDATE
      , :new.DELIVERYENDDATE
      , :new.DELIVERYNOTE
      , :new.TERMSOFDELIVERY
      , :new.TERMSOFDELIVERYNOTE
      , :new.OKATO
      , :new.OKATONOTE
      , :new.DELIVERYFORMNOTE
      , :new.SECURITYTNOTE
      , :new.SECURITYANOTE
      , :new.PREFERENCENOTE
      , :new.GUARANTY
      , :new.FINNOTE
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.PREFERENCEPRISON
      , :new.PREFERENCECRIPPLE
      , :new.STRETCHCONTRACT
      , :new.GUARANTYSIZE
      , :new.REALID
      , :new.SECURITYTSIZE
      , :new.SECURITYASIZE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERLOT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERLOT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LOTNUMBER
      ,LOTNOTE
      ,DELIVERYDATE
      ,DELIVERYENDDATE
      ,DELIVERYNOTE
      ,TERMSOFDELIVERY
      ,TERMSOFDELIVERYNOTE
      ,OKATO
      ,OKATONOTE
      ,DELIVERYFORMNOTE
      ,SECURITYTNOTE
      ,SECURITYANOTE
      ,PREFERENCENOTE
      ,GUARANTY
      ,FINNOTE
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,PREFERENCEPRISON
      ,PREFERENCECRIPPLE
      ,STRETCHCONTRACT
      ,GUARANTYSIZE
      ,REALID
      ,SECURITYTSIZE
      ,SECURITYASIZE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LOTNUMBER
      , :new.LOTNOTE
      , :new.DELIVERYDATE
      , :new.DELIVERYENDDATE
      , :new.DELIVERYNOTE
      , :new.TERMSOFDELIVERY
      , :new.TERMSOFDELIVERYNOTE
      , :new.OKATO
      , :new.OKATONOTE
      , :new.DELIVERYFORMNOTE
      , :new.SECURITYTNOTE
      , :new.SECURITYANOTE
      , :new.PREFERENCENOTE
      , :new.GUARANTY
      , :new.FINNOTE
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.PREFERENCEPRISON
      , :new.PREFERENCECRIPPLE
      , :new.STRETCHCONTRACT
      , :new.GUARANTYSIZE
      , :new.REALID
      , :new.SECURITYTSIZE
      , :new.SECURITYASIZE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERLOT
  AFTER DELETE
  ON TENDERLOT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERLOT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDEROBJECTS
  AFTER INSERT
  ON TENDEROBJECTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDEROBJECTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDEROBJECTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OKDP
      ,SHORTNAME
      ,CODE
      ,OBJECTSPEC
      ,BRAND
      ,KESR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,MEASUREMENTCLS
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,FACIALACCCLS
      ,NOTE
      ,UPDATECAUSE
      ,ACCEPTDATE
      ,DOCUMENTDATE
      ,TENDEROBJREPLACE
      ,RVERSION
      ,WEBID
      ,OKPCLS
      ,ATTRIBUTE
      ,NAME
      ,REALID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,OKPD
      ,OKVED
      ,OKPD2
      ,OKVED2
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OKDP
      , :new.SHORTNAME
      , :new.CODE
      , :new.OBJECTSPEC
      , :new.BRAND
      , :new.KESR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MEASUREMENTCLS
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.FACIALACCCLS
      , :new.NOTE
      , :new.UPDATECAUSE
      , :new.ACCEPTDATE
      , :new.DOCUMENTDATE
      , :new.TENDEROBJREPLACE
      , :new.RVERSION
      , :new.WEBID
      , :new.OKPCLS
      , :new.ATTRIBUTE
      , :new.NAME
      , :new.REALID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.OKPD
      , :new.OKVED
      , :new.OKPD2
      , :new.OKVED2
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDEROBJECTS
  AFTER UPDATE
  ON TENDEROBJECTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDEROBJECTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDEROBJECTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDEROBJECTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OKDP
      ,SHORTNAME
      ,CODE
      ,OBJECTSPEC
      ,BRAND
      ,KESR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,MEASUREMENTCLS
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,FACIALACCCLS
      ,NOTE
      ,UPDATECAUSE
      ,ACCEPTDATE
      ,DOCUMENTDATE
      ,TENDEROBJREPLACE
      ,RVERSION
      ,WEBID
      ,OKPCLS
      ,ATTRIBUTE
      ,NAME
      ,REALID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,OKPD
      ,OKVED
      ,OKPD2
      ,OKVED2
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OKDP
      , :new.SHORTNAME
      , :new.CODE
      , :new.OBJECTSPEC
      , :new.BRAND
      , :new.KESR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MEASUREMENTCLS
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.FACIALACCCLS
      , :new.NOTE
      , :new.UPDATECAUSE
      , :new.ACCEPTDATE
      , :new.DOCUMENTDATE
      , :new.TENDEROBJREPLACE
      , :new.RVERSION
      , :new.WEBID
      , :new.OKPCLS
      , :new.ATTRIBUTE
      , :new.NAME
      , :new.REALID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.OKPD
      , :new.OKVED
      , :new.OKPD2
      , :new.OKVED2
    );
  else 
    update A_TENDEROBJECTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDEROBJECTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,OKDP
      ,SHORTNAME
      ,CODE
      ,OBJECTSPEC
      ,BRAND
      ,KESR
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,MEASUREMENTCLS
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,FACIALACCCLS
      ,NOTE
      ,UPDATECAUSE
      ,ACCEPTDATE
      ,DOCUMENTDATE
      ,TENDEROBJREPLACE
      ,RVERSION
      ,WEBID
      ,OKPCLS
      ,ATTRIBUTE
      ,NAME
      ,REALID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,OKPD
      ,OKVED
      ,OKPD2
      ,OKVED2
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.OKDP
      , :new.SHORTNAME
      , :new.CODE
      , :new.OBJECTSPEC
      , :new.BRAND
      , :new.KESR
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.MEASUREMENTCLS
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.FACIALACCCLS
      , :new.NOTE
      , :new.UPDATECAUSE
      , :new.ACCEPTDATE
      , :new.DOCUMENTDATE
      , :new.TENDEROBJREPLACE
      , :new.RVERSION
      , :new.WEBID
      , :new.OKPCLS
      , :new.ATTRIBUTE
      , :new.NAME
      , :new.REALID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.OKPD
      , :new.OKVED
      , :new.OKPD2
      , :new.OKVED2
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDEROBJECTS
  AFTER DELETE
  ON TENDEROBJECTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDEROBJECTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERPRODUCT
  AFTER INSERT
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPRODUCT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPRODUCT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,FACIALACCCLS
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACTCLS
      ,FINSOURCECLS
      ,MEANSTYPECLS
      ,TENDEROBJECTCLS
      ,ACCEPTAMOUNT
      ,ACCEPTPRICE
      ,OKATO
      ,DELIVERYDATE
      ,DELIVERYENDDATE
      ,DELIVERYPERIOD
      ,DELIVERYAMOUNT
      ,NOTE
      ,FINSPEC
      ,RECIPIENTLIST
      ,ACCEPTMONTH01
      ,ACCEPTMONTH02
      ,ACCEPTMONTH03
      ,ACCEPTMONTH04
      ,ACCEPTMONTH05
      ,ACCEPTMONTH06
      ,ACCEPTMONTH07
      ,ACCEPTMONTH08
      ,ACCEPTMONTH09
      ,ACCEPTMONTH10
      ,ACCEPTMONTH11
      ,ACCEPTMONTH12
      ,ACCEPTQUARTER1
      ,ACCEPTQUARTER2
      ,ACCEPTQUARTER3
      ,ACCEPTQUARTER4
      ,ACCEPTSUMMA
      ,REVIEWNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SENDERID
      ,SENDERRECORDID
      ,TENDEROPENDATE
      ,TENDERCLOSEDATE
      ,POSITIONNUMBER
      ,DIRECTIONCLS
      ,RVERSION
      ,TRANSPORTTERMS
      ,VATPERCENT
      ,ACCEPTVATSUMMA
      ,ACCEPTCOST
      ,ACCEPTTOTALSUMMA
      ,FINTYPE
      ,LOTREF
      ,EQUIVALENT
      ,OKATONOTE
      ,DELIVERYNOTE
      ,DELIVERYSPECNOTE
      ,GUARANTY
      ,DELIVERYFORMNOTE
      ,FINNOTE
      ,PRICEVAT
      ,GUARANTYSIZE
      ,DELIVERYSPEC
      ,TENDEROBJECTATTR
      ,REALID
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUBSIDYCLS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,TRANSFERTCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,INVESTOBJECT
      ,SUMMAOTHERYEARS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.FACIALACCCLS
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACTCLS
      , :new.FINSOURCECLS
      , :new.MEANSTYPECLS
      , :new.TENDEROBJECTCLS
      , :new.ACCEPTAMOUNT
      , :new.ACCEPTPRICE
      , :new.OKATO
      , :new.DELIVERYDATE
      , :new.DELIVERYENDDATE
      , :new.DELIVERYPERIOD
      , :new.DELIVERYAMOUNT
      , :new.NOTE
      , :new.FINSPEC
      , :new.RECIPIENTLIST
      , :new.ACCEPTMONTH01
      , :new.ACCEPTMONTH02
      , :new.ACCEPTMONTH03
      , :new.ACCEPTMONTH04
      , :new.ACCEPTMONTH05
      , :new.ACCEPTMONTH06
      , :new.ACCEPTMONTH07
      , :new.ACCEPTMONTH08
      , :new.ACCEPTMONTH09
      , :new.ACCEPTMONTH10
      , :new.ACCEPTMONTH11
      , :new.ACCEPTMONTH12
      , :new.ACCEPTQUARTER1
      , :new.ACCEPTQUARTER2
      , :new.ACCEPTQUARTER3
      , :new.ACCEPTQUARTER4
      , :new.ACCEPTSUMMA
      , :new.REVIEWNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.TENDEROPENDATE
      , :new.TENDERCLOSEDATE
      , :new.POSITIONNUMBER
      , :new.DIRECTIONCLS
      , :new.RVERSION
      , :new.TRANSPORTTERMS
      , :new.VATPERCENT
      , :new.ACCEPTVATSUMMA
      , :new.ACCEPTCOST
      , :new.ACCEPTTOTALSUMMA
      , :new.FINTYPE
      , :new.LOTREF
      , :new.EQUIVALENT
      , :new.OKATONOTE
      , :new.DELIVERYNOTE
      , :new.DELIVERYSPECNOTE
      , :new.GUARANTY
      , :new.DELIVERYFORMNOTE
      , :new.FINNOTE
      , :new.PRICEVAT
      , :new.GUARANTYSIZE
      , :new.DELIVERYSPEC
      , :new.TENDEROBJECTATTR
      , :new.REALID
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUBSIDYCLS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.TRANSFERTCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.INVESTOBJECT
      , :new.SUMMAOTHERYEARS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERPRODUCT
  AFTER UPDATE
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERPRODUCT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERPRODUCT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPRODUCT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,FACIALACCCLS
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACTCLS
      ,FINSOURCECLS
      ,MEANSTYPECLS
      ,TENDEROBJECTCLS
      ,ACCEPTAMOUNT
      ,ACCEPTPRICE
      ,OKATO
      ,DELIVERYDATE
      ,DELIVERYENDDATE
      ,DELIVERYPERIOD
      ,DELIVERYAMOUNT
      ,NOTE
      ,FINSPEC
      ,RECIPIENTLIST
      ,ACCEPTMONTH01
      ,ACCEPTMONTH02
      ,ACCEPTMONTH03
      ,ACCEPTMONTH04
      ,ACCEPTMONTH05
      ,ACCEPTMONTH06
      ,ACCEPTMONTH07
      ,ACCEPTMONTH08
      ,ACCEPTMONTH09
      ,ACCEPTMONTH10
      ,ACCEPTMONTH11
      ,ACCEPTMONTH12
      ,ACCEPTQUARTER1
      ,ACCEPTQUARTER2
      ,ACCEPTQUARTER3
      ,ACCEPTQUARTER4
      ,ACCEPTSUMMA
      ,REVIEWNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SENDERID
      ,SENDERRECORDID
      ,TENDEROPENDATE
      ,TENDERCLOSEDATE
      ,POSITIONNUMBER
      ,DIRECTIONCLS
      ,RVERSION
      ,TRANSPORTTERMS
      ,VATPERCENT
      ,ACCEPTVATSUMMA
      ,ACCEPTCOST
      ,ACCEPTTOTALSUMMA
      ,FINTYPE
      ,LOTREF
      ,EQUIVALENT
      ,OKATONOTE
      ,DELIVERYNOTE
      ,DELIVERYSPECNOTE
      ,GUARANTY
      ,DELIVERYFORMNOTE
      ,FINNOTE
      ,PRICEVAT
      ,GUARANTYSIZE
      ,DELIVERYSPEC
      ,TENDEROBJECTATTR
      ,REALID
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUBSIDYCLS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,TRANSFERTCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,INVESTOBJECT
      ,SUMMAOTHERYEARS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.FACIALACCCLS
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACTCLS
      , :new.FINSOURCECLS
      , :new.MEANSTYPECLS
      , :new.TENDEROBJECTCLS
      , :new.ACCEPTAMOUNT
      , :new.ACCEPTPRICE
      , :new.OKATO
      , :new.DELIVERYDATE
      , :new.DELIVERYENDDATE
      , :new.DELIVERYPERIOD
      , :new.DELIVERYAMOUNT
      , :new.NOTE
      , :new.FINSPEC
      , :new.RECIPIENTLIST
      , :new.ACCEPTMONTH01
      , :new.ACCEPTMONTH02
      , :new.ACCEPTMONTH03
      , :new.ACCEPTMONTH04
      , :new.ACCEPTMONTH05
      , :new.ACCEPTMONTH06
      , :new.ACCEPTMONTH07
      , :new.ACCEPTMONTH08
      , :new.ACCEPTMONTH09
      , :new.ACCEPTMONTH10
      , :new.ACCEPTMONTH11
      , :new.ACCEPTMONTH12
      , :new.ACCEPTQUARTER1
      , :new.ACCEPTQUARTER2
      , :new.ACCEPTQUARTER3
      , :new.ACCEPTQUARTER4
      , :new.ACCEPTSUMMA
      , :new.REVIEWNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.TENDEROPENDATE
      , :new.TENDERCLOSEDATE
      , :new.POSITIONNUMBER
      , :new.DIRECTIONCLS
      , :new.RVERSION
      , :new.TRANSPORTTERMS
      , :new.VATPERCENT
      , :new.ACCEPTVATSUMMA
      , :new.ACCEPTCOST
      , :new.ACCEPTTOTALSUMMA
      , :new.FINTYPE
      , :new.LOTREF
      , :new.EQUIVALENT
      , :new.OKATONOTE
      , :new.DELIVERYNOTE
      , :new.DELIVERYSPECNOTE
      , :new.GUARANTY
      , :new.DELIVERYFORMNOTE
      , :new.FINNOTE
      , :new.PRICEVAT
      , :new.GUARANTYSIZE
      , :new.DELIVERYSPEC
      , :new.TENDEROBJECTATTR
      , :new.REALID
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUBSIDYCLS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.TRANSFERTCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.INVESTOBJECT
      , :new.SUMMAOTHERYEARS
    );
  else 
    update A_TENDERPRODUCT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERPRODUCT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,FACIALACCCLS
      ,KFSR
      ,KVSR
      ,KCSR
      ,KVR
      ,KESR
      ,SUBKESR
      ,FACTCLS
      ,FINSOURCECLS
      ,MEANSTYPECLS
      ,TENDEROBJECTCLS
      ,ACCEPTAMOUNT
      ,ACCEPTPRICE
      ,OKATO
      ,DELIVERYDATE
      ,DELIVERYENDDATE
      ,DELIVERYPERIOD
      ,DELIVERYAMOUNT
      ,NOTE
      ,FINSPEC
      ,RECIPIENTLIST
      ,ACCEPTMONTH01
      ,ACCEPTMONTH02
      ,ACCEPTMONTH03
      ,ACCEPTMONTH04
      ,ACCEPTMONTH05
      ,ACCEPTMONTH06
      ,ACCEPTMONTH07
      ,ACCEPTMONTH08
      ,ACCEPTMONTH09
      ,ACCEPTMONTH10
      ,ACCEPTMONTH11
      ,ACCEPTMONTH12
      ,ACCEPTQUARTER1
      ,ACCEPTQUARTER2
      ,ACCEPTQUARTER3
      ,ACCEPTQUARTER4
      ,ACCEPTSUMMA
      ,REVIEWNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,SENDERID
      ,SENDERRECORDID
      ,TENDEROPENDATE
      ,TENDERCLOSEDATE
      ,POSITIONNUMBER
      ,DIRECTIONCLS
      ,RVERSION
      ,TRANSPORTTERMS
      ,VATPERCENT
      ,ACCEPTVATSUMMA
      ,ACCEPTCOST
      ,ACCEPTTOTALSUMMA
      ,FINTYPE
      ,LOTREF
      ,EQUIVALENT
      ,OKATONOTE
      ,DELIVERYNOTE
      ,DELIVERYSPECNOTE
      ,GUARANTY
      ,DELIVERYFORMNOTE
      ,FINNOTE
      ,PRICEVAT
      ,GUARANTYSIZE
      ,DELIVERYSPEC
      ,TENDEROBJECTATTR
      ,REALID
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,SUBSIDYCLS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,TRANSFERTCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,PROGINDEX
      ,INVESTOBJECT
      ,SUMMAOTHERYEARS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.FACIALACCCLS
      , :new.KFSR
      , :new.KVSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.SUBKESR
      , :new.FACTCLS
      , :new.FINSOURCECLS
      , :new.MEANSTYPECLS
      , :new.TENDEROBJECTCLS
      , :new.ACCEPTAMOUNT
      , :new.ACCEPTPRICE
      , :new.OKATO
      , :new.DELIVERYDATE
      , :new.DELIVERYENDDATE
      , :new.DELIVERYPERIOD
      , :new.DELIVERYAMOUNT
      , :new.NOTE
      , :new.FINSPEC
      , :new.RECIPIENTLIST
      , :new.ACCEPTMONTH01
      , :new.ACCEPTMONTH02
      , :new.ACCEPTMONTH03
      , :new.ACCEPTMONTH04
      , :new.ACCEPTMONTH05
      , :new.ACCEPTMONTH06
      , :new.ACCEPTMONTH07
      , :new.ACCEPTMONTH08
      , :new.ACCEPTMONTH09
      , :new.ACCEPTMONTH10
      , :new.ACCEPTMONTH11
      , :new.ACCEPTMONTH12
      , :new.ACCEPTQUARTER1
      , :new.ACCEPTQUARTER2
      , :new.ACCEPTQUARTER3
      , :new.ACCEPTQUARTER4
      , :new.ACCEPTSUMMA
      , :new.REVIEWNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.TENDEROPENDATE
      , :new.TENDERCLOSEDATE
      , :new.POSITIONNUMBER
      , :new.DIRECTIONCLS
      , :new.RVERSION
      , :new.TRANSPORTTERMS
      , :new.VATPERCENT
      , :new.ACCEPTVATSUMMA
      , :new.ACCEPTCOST
      , :new.ACCEPTTOTALSUMMA
      , :new.FINTYPE
      , :new.LOTREF
      , :new.EQUIVALENT
      , :new.OKATONOTE
      , :new.DELIVERYNOTE
      , :new.DELIVERYSPECNOTE
      , :new.GUARANTY
      , :new.DELIVERYFORMNOTE
      , :new.FINNOTE
      , :new.PRICEVAT
      , :new.GUARANTYSIZE
      , :new.DELIVERYSPEC
      , :new.TENDEROBJECTATTR
      , :new.REALID
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.SUBSIDYCLS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.TRANSFERTCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.PROGINDEX
      , :new.INVESTOBJECT
      , :new.SUMMAOTHERYEARS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERPRODUCT
  AFTER DELETE
  ON TENDERPRODUCT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPRODUCT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERPROPOSAL
  AFTER INSERT
  ON TENDERPROPOSAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPROPOSAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPROPOSAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUPPLIERREF
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUPPLIERREF
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERPROPOSAL
  AFTER UPDATE
  ON TENDERPROPOSAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERPROPOSAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERPROPOSAL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPROPOSAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUPPLIERREF
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUPPLIERREF
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERPROPOSAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERPROPOSAL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUPPLIERREF
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUPPLIERREF
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERPROPOSAL
  AFTER DELETE
  ON TENDERPROPOSAL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPROPOSAL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERPROPOSALDETAIL
  AFTER INSERT
  ON TENDERPROPOSALDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPROPOSALDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPROPOSALDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PRODUCTCLS
      ,AMOUNT
      ,PRICE
      ,PRICEVAT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,SUMMA
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PRODUCTCLS
      , :new.AMOUNT
      , :new.PRICE
      , :new.PRICEVAT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.SUMMA
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERPROPOSALDETAIL
  AFTER UPDATE
  ON TENDERPROPOSALDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERPROPOSALDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERPROPOSALDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPROPOSALDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PRODUCTCLS
      ,AMOUNT
      ,PRICE
      ,PRICEVAT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,SUMMA
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PRODUCTCLS
      , :new.AMOUNT
      , :new.PRICE
      , :new.PRICEVAT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.SUMMA
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERPROPOSALDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERPROPOSALDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PRODUCTCLS
      ,AMOUNT
      ,PRICE
      ,PRICEVAT
      ,COST
      ,VATPERCENT
      ,VATSUMMA
      ,SUMMA
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PRODUCTCLS
      , :new.AMOUNT
      , :new.PRICE
      , :new.PRICEVAT
      , :new.COST
      , :new.VATPERCENT
      , :new.VATSUMMA
      , :new.SUMMA
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERPROPOSALDETAIL
  AFTER DELETE
  ON TENDERPROPOSALDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPROPOSALDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERPURCHASE
  AFTER INSERT
  ON TENDERPURCHASE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPURCHASE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPURCHASE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PURCHASENUMBER
      ,AGREEMENTOBJECT
      ,SALETYPE
      ,PURCHASESTATE
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PURCHASENUMBER
      , :new.AGREEMENTOBJECT
      , :new.SALETYPE
      , :new.PURCHASESTATE
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERPURCHASE
  AFTER UPDATE
  ON TENDERPURCHASE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERPURCHASE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERPURCHASE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPURCHASE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PURCHASENUMBER
      ,AGREEMENTOBJECT
      ,SALETYPE
      ,PURCHASESTATE
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PURCHASENUMBER
      , :new.AGREEMENTOBJECT
      , :new.SALETYPE
      , :new.PURCHASESTATE
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERPURCHASE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERPURCHASE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PURCHASENUMBER
      ,AGREEMENTOBJECT
      ,SALETYPE
      ,PURCHASESTATE
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PURCHASENUMBER
      , :new.AGREEMENTOBJECT
      , :new.SALETYPE
      , :new.PURCHASESTATE
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERPURCHASE
  AFTER DELETE
  ON TENDERPURCHASE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPURCHASE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERPURCHASELOT
  AFTER INSERT
  ON TENDERPURCHASELOT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPURCHASELOT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPURCHASELOT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LOTNUMBER
      ,LOTNAME
      ,LOTSUMMA
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LOTNUMBER
      , :new.LOTNAME
      , :new.LOTSUMMA
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERPURCHASELOT
  AFTER UPDATE
  ON TENDERPURCHASELOT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERPURCHASELOT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERPURCHASELOT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERPURCHASELOT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LOTNUMBER
      ,LOTNAME
      ,LOTSUMMA
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LOTNUMBER
      , :new.LOTNAME
      , :new.LOTSUMMA
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERPURCHASELOT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERPURCHASELOT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,LOTNUMBER
      ,LOTNAME
      ,LOTSUMMA
      ,WEBID
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.LOTNUMBER
      , :new.LOTNAME
      , :new.LOTSUMMA
      , :new.WEBID
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERPURCHASELOT
  AFTER DELETE
  ON TENDERPURCHASELOT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERPURCHASELOT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERRESULTCAPTION
  AFTER INSERT
  ON TENDERRESULTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERRESULTCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERRESULTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,INNERDOCNUMBER
      ,FACIALACCCLS
      ,ACCEPTDATE
      ,PROTOCOLNUMBER
      ,PROTOCOLDATE
      ,STATEORDERREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,POSITIONNUMBERREF
      ,ACCEPTDATEFO
      ,RVERSION
      ,AGREEMENTREF
      ,DOCSTATEREF
      ,WEBID
      ,NOTE
      ,PRIORITY
      ,ALLOWANCE
      ,RESULTDOCSTATE
      ,PURCHASEREF
      ,PURCHASELOTREF
      ,RESULTORDER
      ,RESULTSALETYPE
      ,PROTOCOLREASON
      ,PROTOCOLDOCTYPE
      ,PROTOCOLDECISION
      ,PROPOSALID
      ,PROPOSALDETID
      ,TENDERPRODUCTREF
      ,AGREEMENT
      ,STATEORDER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.INNERDOCNUMBER
      , :new.FACIALACCCLS
      , :new.ACCEPTDATE
      , :new.PROTOCOLNUMBER
      , :new.PROTOCOLDATE
      , :new.STATEORDERREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.POSITIONNUMBERREF
      , :new.ACCEPTDATEFO
      , :new.RVERSION
      , :new.AGREEMENTREF
      , :new.DOCSTATEREF
      , :new.WEBID
      , :new.NOTE
      , :new.PRIORITY
      , :new.ALLOWANCE
      , :new.RESULTDOCSTATE
      , :new.PURCHASEREF
      , :new.PURCHASELOTREF
      , :new.RESULTORDER
      , :new.RESULTSALETYPE
      , :new.PROTOCOLREASON
      , :new.PROTOCOLDOCTYPE
      , :new.PROTOCOLDECISION
      , :new.PROPOSALID
      , :new.PROPOSALDETID
      , :new.TENDERPRODUCTREF
      , :new.AGREEMENT
      , :new.STATEORDER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERRESULTCAPTION
  AFTER UPDATE
  ON TENDERRESULTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERRESULTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERRESULTCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERRESULTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,INNERDOCNUMBER
      ,FACIALACCCLS
      ,ACCEPTDATE
      ,PROTOCOLNUMBER
      ,PROTOCOLDATE
      ,STATEORDERREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,POSITIONNUMBERREF
      ,ACCEPTDATEFO
      ,RVERSION
      ,AGREEMENTREF
      ,DOCSTATEREF
      ,WEBID
      ,NOTE
      ,PRIORITY
      ,ALLOWANCE
      ,RESULTDOCSTATE
      ,PURCHASEREF
      ,PURCHASELOTREF
      ,RESULTORDER
      ,RESULTSALETYPE
      ,PROTOCOLREASON
      ,PROTOCOLDOCTYPE
      ,PROTOCOLDECISION
      ,PROPOSALID
      ,PROPOSALDETID
      ,TENDERPRODUCTREF
      ,AGREEMENT
      ,STATEORDER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.INNERDOCNUMBER
      , :new.FACIALACCCLS
      , :new.ACCEPTDATE
      , :new.PROTOCOLNUMBER
      , :new.PROTOCOLDATE
      , :new.STATEORDERREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.POSITIONNUMBERREF
      , :new.ACCEPTDATEFO
      , :new.RVERSION
      , :new.AGREEMENTREF
      , :new.DOCSTATEREF
      , :new.WEBID
      , :new.NOTE
      , :new.PRIORITY
      , :new.ALLOWANCE
      , :new.RESULTDOCSTATE
      , :new.PURCHASEREF
      , :new.PURCHASELOTREF
      , :new.RESULTORDER
      , :new.RESULTSALETYPE
      , :new.PROTOCOLREASON
      , :new.PROTOCOLDOCTYPE
      , :new.PROTOCOLDECISION
      , :new.PROPOSALID
      , :new.PROPOSALDETID
      , :new.TENDERPRODUCTREF
      , :new.AGREEMENT
      , :new.STATEORDER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERRESULTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERRESULTCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,INNERDOCNUMBER
      ,FACIALACCCLS
      ,ACCEPTDATE
      ,PROTOCOLNUMBER
      ,PROTOCOLDATE
      ,STATEORDERREF
      ,REJECTCLS
      ,REJECTCAUSE
      ,CRYPTOSTATUS
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,POSITIONNUMBERREF
      ,ACCEPTDATEFO
      ,RVERSION
      ,AGREEMENTREF
      ,DOCSTATEREF
      ,WEBID
      ,NOTE
      ,PRIORITY
      ,ALLOWANCE
      ,RESULTDOCSTATE
      ,PURCHASEREF
      ,PURCHASELOTREF
      ,RESULTORDER
      ,RESULTSALETYPE
      ,PROTOCOLREASON
      ,PROTOCOLDOCTYPE
      ,PROTOCOLDECISION
      ,PROPOSALID
      ,PROPOSALDETID
      ,TENDERPRODUCTREF
      ,AGREEMENT
      ,STATEORDER
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.INNERDOCNUMBER
      , :new.FACIALACCCLS
      , :new.ACCEPTDATE
      , :new.PROTOCOLNUMBER
      , :new.PROTOCOLDATE
      , :new.STATEORDERREF
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.CRYPTOSTATUS
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.POSITIONNUMBERREF
      , :new.ACCEPTDATEFO
      , :new.RVERSION
      , :new.AGREEMENTREF
      , :new.DOCSTATEREF
      , :new.WEBID
      , :new.NOTE
      , :new.PRIORITY
      , :new.ALLOWANCE
      , :new.RESULTDOCSTATE
      , :new.PURCHASEREF
      , :new.PURCHASELOTREF
      , :new.RESULTORDER
      , :new.RESULTSALETYPE
      , :new.PROTOCOLREASON
      , :new.PROTOCOLDOCTYPE
      , :new.PROTOCOLDECISION
      , :new.PROPOSALID
      , :new.PROPOSALDETID
      , :new.TENDERPRODUCTREF
      , :new.AGREEMENT
      , :new.STATEORDER
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERRESULTCAPTION
  AFTER DELETE
  ON TENDERRESULTCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERRESULTCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERSOURCEORG
  AFTER INSERT
  ON TENDERSOURCEORG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERSOURCEORG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERSOURCEORG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,ORGID
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.ORGID
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERSOURCEORG
  AFTER UPDATE
  ON TENDERSOURCEORG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERSOURCEORG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERSOURCEORG
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERSOURCEORG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,ORGID
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.ORGID
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERSOURCEORG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERSOURCEORG (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,ORGID
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.ORGID
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERSOURCEORG
  AFTER DELETE
  ON TENDERSOURCEORG
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERSOURCEORG
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERSUPDOCUMENT
  AFTER INSERT
  ON TENDERSUPDOCUMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERSUPDOCUMENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERSUPDOCUMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,YARDSTICKREF
      ,DOCTYPECLS
      ,NOTE
      ,NAME
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,RECORDINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.YARDSTICKREF
      , :new.DOCTYPECLS
      , :new.NOTE
      , :new.NAME
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.RECORDINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERSUPDOCUMENT
  AFTER UPDATE
  ON TENDERSUPDOCUMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERSUPDOCUMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERSUPDOCUMENT
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERSUPDOCUMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,YARDSTICKREF
      ,DOCTYPECLS
      ,NOTE
      ,NAME
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,RECORDINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.YARDSTICKREF
      , :new.DOCTYPECLS
      , :new.NOTE
      , :new.NAME
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.RECORDINDEX
    );
  else 
    update A_TENDERSUPDOCUMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERSUPDOCUMENT (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,YARDSTICKREF
      ,DOCTYPECLS
      ,NOTE
      ,NAME
      ,BUDGETREF
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
      ,RVERSION
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
      ,RECORDINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.YARDSTICKREF
      , :new.DOCTYPECLS
      , :new.NOTE
      , :new.NAME
      , :new.BUDGETREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.RVERSION
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
      , :new.RECORDINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERSUPDOCUMENT
  AFTER DELETE
  ON TENDERSUPDOCUMENT
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERSUPDOCUMENT
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERSUPPLEMENTS
  AFTER INSERT
  ON TENDERSUPPLEMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERSUPPLEMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERSUPPLEMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,DOCTYPECLS
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.DOCTYPECLS
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERSUPPLEMENTS
  AFTER UPDATE
  ON TENDERSUPPLEMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERSUPPLEMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERSUPPLEMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERSUPPLEMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,DOCTYPECLS
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.DOCTYPECLS
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERSUPPLEMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERSUPPLEMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,DOCTYPECLS
      ,NOTE
      ,SENDERID
      ,SENDERRECORDID
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.DOCTYPECLS
      , :new.NOTE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERSUPPLEMENTS
  AFTER DELETE
  ON TENDERSUPPLEMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERSUPPLEMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TENDERYARDSTICKS
  AFTER INSERT
  ON TENDERYARDSTICKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERYARDSTICKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERYARDSTICKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,STARTVALUE
      ,YARDSTICKTYPE
      ,NOTE
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,LOTREF
      ,UYARDSTICK
      ,YARDSTICKNOTE
      ,PONDERABILITY
      ,YSTERMSLIMIT
      ,PRODUCTREF
      ,YARDSTICKREF
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.STARTVALUE
      , :new.YARDSTICKTYPE
      , :new.NOTE
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.LOTREF
      , :new.UYARDSTICK
      , :new.YARDSTICKNOTE
      , :new.PONDERABILITY
      , :new.YSTERMSLIMIT
      , :new.PRODUCTREF
      , :new.YARDSTICKREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TENDERYARDSTICKS
  AFTER UPDATE
  ON TENDERYARDSTICKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TENDERYARDSTICKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TENDERYARDSTICKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TENDERYARDSTICKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,STARTVALUE
      ,YARDSTICKTYPE
      ,NOTE
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,LOTREF
      ,UYARDSTICK
      ,YARDSTICKNOTE
      ,PONDERABILITY
      ,YSTERMSLIMIT
      ,PRODUCTREF
      ,YARDSTICKREF
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.STARTVALUE
      , :new.YARDSTICKTYPE
      , :new.NOTE
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.LOTREF
      , :new.UYARDSTICK
      , :new.YARDSTICKNOTE
      , :new.PONDERABILITY
      , :new.YSTERMSLIMIT
      , :new.PRODUCTREF
      , :new.YARDSTICKREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  else 
    update A_TENDERYARDSTICKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TENDERYARDSTICKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,BUDGETREF
      ,STARTVALUE
      ,YARDSTICKTYPE
      ,NOTE
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,LOTREF
      ,UYARDSTICK
      ,YARDSTICKNOTE
      ,PONDERABILITY
      ,YSTERMSLIMIT
      ,PRODUCTREF
      ,YARDSTICKREF
      ,SENDERID
      ,SENDERRECORDID
      ,SENDERIDKEY
      ,SENDERRECORDIDKEY
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.BUDGETREF
      , :new.STARTVALUE
      , :new.YARDSTICKTYPE
      , :new.NOTE
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.LOTREF
      , :new.UYARDSTICK
      , :new.YARDSTICKNOTE
      , :new.PONDERABILITY
      , :new.YSTERMSLIMIT
      , :new.PRODUCTREF
      , :new.YARDSTICKREF
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.SENDERIDKEY
      , :new.SENDERRECORDIDKEY
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TENDERYARDSTICKS
  AFTER DELETE
  ON TENDERYARDSTICKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TENDERYARDSTICKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TRANSFER15NTO70N
  AFTER INSERT
  ON TRANSFER15NTO70N
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TRANSFER15NTO70N
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TRANSFER15NTO70N (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DEBIT
      ,CREDIT
      ,DEBITECCLS
      ,CREDITECCLS
      ,BUHOPERATIONCLS
      ,DIRECTION
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DEBIT
      , :new.CREDIT
      , :new.DEBITECCLS
      , :new.CREDITECCLS
      , :new.BUHOPERATIONCLS
      , :new.DIRECTION
      , :new.PROGINDEX
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TRANSFER15NTO70N
  AFTER UPDATE
  ON TRANSFER15NTO70N
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TRANSFER15NTO70N
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TRANSFER15NTO70N
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TRANSFER15NTO70N (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DEBIT
      ,CREDIT
      ,DEBITECCLS
      ,CREDITECCLS
      ,BUHOPERATIONCLS
      ,DIRECTION
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DEBIT
      , :new.CREDIT
      , :new.DEBITECCLS
      , :new.CREDITECCLS
      , :new.BUHOPERATIONCLS
      , :new.DIRECTION
      , :new.PROGINDEX
    );
  else 
    update A_TRANSFER15NTO70N
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TRANSFER15NTO70N (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DEBIT
      ,CREDIT
      ,DEBITECCLS
      ,CREDITECCLS
      ,BUHOPERATIONCLS
      ,DIRECTION
      ,PROGINDEX
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DEBIT
      , :new.CREDIT
      , :new.DEBITECCLS
      , :new.CREDITECCLS
      , :new.BUHOPERATIONCLS
      , :new.DIRECTION
      , :new.PROGINDEX
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TRANSFER15NTO70N
  AFTER DELETE
  ON TRANSFER15NTO70N
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TRANSFER15NTO70N
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TREASUARYDOCSTATE
  AFTER INSERT
  ON TREASUARYDOCSTATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TREASUARYDOCSTATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TREASUARYDOCSTATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TREASUARYDOCSTATE
  AFTER UPDATE
  ON TREASUARYDOCSTATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TREASUARYDOCSTATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TREASUARYDOCSTATE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TREASUARYDOCSTATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_TREASUARYDOCSTATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TREASUARYDOCSTATE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TREASUARYDOCSTATE
  AFTER DELETE
  ON TREASUARYDOCSTATE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TREASUARYDOCSTATE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_TYPEOPERATIONCLS
  AFTER INSERT
  ON TYPEOPERATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TYPEOPERATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TYPEOPERATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_TYPEOPERATIONCLS
  AFTER UPDATE
  ON TYPEOPERATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_TYPEOPERATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_TYPEOPERATIONCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_TYPEOPERATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  else 
    update A_TYPEOPERATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_TYPEOPERATIONCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_TYPEOPERATIONCLS
  AFTER DELETE
  ON TYPEOPERATIONCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_TYPEOPERATIONCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSCHAINSCAPTION
  AFTER INSERT
  ON UCONSCHAINSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSCHAINSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSCHAINSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSCHAINSCAPTION
  AFTER UPDATE
  ON UCONSCHAINSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSCHAINSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSCHAINSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSCHAINSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UCONSCHAINSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSCHAINSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,NOTE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.NOTE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSCHAINSCAPTION
  AFTER DELETE
  ON UCONSCHAINSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSCHAINSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSCHAINSDETAIL
  AFTER INSERT
  ON UCONSCHAINSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSCHAINSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSCHAINSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PARENTREF
      ,CHILDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PARENTREF
      , :new.CHILDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSCHAINSDETAIL
  AFTER UPDATE
  ON UCONSCHAINSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSCHAINSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSCHAINSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSCHAINSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PARENTREF
      ,CHILDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PARENTREF
      , :new.CHILDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UCONSCHAINSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSCHAINSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,PARENTREF
      ,CHILDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.PARENTREF
      , :new.CHILDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSCHAINSDETAIL
  AFTER DELETE
  ON UCONSCHAINSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSCHAINSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSCLIENTS
  AFTER INSERT
  ON UCONSCLIENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSCLIENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSCLIENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ORG_REF
      ,REGIONCLS
      ,FACIALACC_CLS
      ,EMAIL
      ,LOGIN
      ,PASWORD
      ,ROLES
      ,IP
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CODE
      ,BEGINDATE
      ,ENDDATE
      ,OKATO
      ,KVB
      ,ORG
      ,KVB_SKIF
      ,ORG_SKIF
      ,SUBJECTTEXTID
      ,ROWORDER
      ,INCOMESADMCODES
      ,GRBSCODES
      ,IFSADMCODES
      ,BUDGETREF
      ,PARAMS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ORG_REF
      , :new.REGIONCLS
      , :new.FACIALACC_CLS
      , :new.EMAIL
      , :new.LOGIN
      , :new.PASWORD
      , :new.ROLES
      , :new.IP
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CODE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.OKATO
      , :new.KVB
      , :new.ORG
      , :new.KVB_SKIF
      , :new.ORG_SKIF
      , :new.SUBJECTTEXTID
      , :new.ROWORDER
      , :new.INCOMESADMCODES
      , :new.GRBSCODES
      , :new.IFSADMCODES
      , :new.BUDGETREF
      , :new.PARAMS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSCLIENTS
  AFTER UPDATE
  ON UCONSCLIENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSCLIENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSCLIENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSCLIENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ORG_REF
      ,REGIONCLS
      ,FACIALACC_CLS
      ,EMAIL
      ,LOGIN
      ,PASWORD
      ,ROLES
      ,IP
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CODE
      ,BEGINDATE
      ,ENDDATE
      ,OKATO
      ,KVB
      ,ORG
      ,KVB_SKIF
      ,ORG_SKIF
      ,SUBJECTTEXTID
      ,ROWORDER
      ,INCOMESADMCODES
      ,GRBSCODES
      ,IFSADMCODES
      ,BUDGETREF
      ,PARAMS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ORG_REF
      , :new.REGIONCLS
      , :new.FACIALACC_CLS
      , :new.EMAIL
      , :new.LOGIN
      , :new.PASWORD
      , :new.ROLES
      , :new.IP
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CODE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.OKATO
      , :new.KVB
      , :new.ORG
      , :new.KVB_SKIF
      , :new.ORG_SKIF
      , :new.SUBJECTTEXTID
      , :new.ROWORDER
      , :new.INCOMESADMCODES
      , :new.GRBSCODES
      , :new.IFSADMCODES
      , :new.BUDGETREF
      , :new.PARAMS
    );
  else 
    update A_UCONSCLIENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSCLIENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,ORG_REF
      ,REGIONCLS
      ,FACIALACC_CLS
      ,EMAIL
      ,LOGIN
      ,PASWORD
      ,ROLES
      ,IP
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
      ,CODE
      ,BEGINDATE
      ,ENDDATE
      ,OKATO
      ,KVB
      ,ORG
      ,KVB_SKIF
      ,ORG_SKIF
      ,SUBJECTTEXTID
      ,ROWORDER
      ,INCOMESADMCODES
      ,GRBSCODES
      ,IFSADMCODES
      ,BUDGETREF
      ,PARAMS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.ORG_REF
      , :new.REGIONCLS
      , :new.FACIALACC_CLS
      , :new.EMAIL
      , :new.LOGIN
      , :new.PASWORD
      , :new.ROLES
      , :new.IP
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
      , :new.CODE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.OKATO
      , :new.KVB
      , :new.ORG
      , :new.KVB_SKIF
      , :new.ORG_SKIF
      , :new.SUBJECTTEXTID
      , :new.ROWORDER
      , :new.INCOMESADMCODES
      , :new.GRBSCODES
      , :new.IFSADMCODES
      , :new.BUDGETREF
      , :new.PARAMS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSCLIENTS
  AFTER DELETE
  ON UCONSCLIENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSCLIENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSGROUPSCAPTION
  AFTER INSERT
  ON UCONSGROUPSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSGROUPSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSGROUPSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,NOTE
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.NOTE
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSGROUPSCAPTION
  AFTER UPDATE
  ON UCONSGROUPSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSGROUPSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSGROUPSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSGROUPSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,NOTE
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.NOTE
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UCONSGROUPSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSGROUPSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,NOTE
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.NOTE
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSGROUPSCAPTION
  AFTER DELETE
  ON UCONSGROUPSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSGROUPSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSGROUPSDETAIL
  AFTER INSERT
  ON UCONSGROUPSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSGROUPSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSGROUPSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CONSCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CONSCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSGROUPSDETAIL
  AFTER UPDATE
  ON UCONSGROUPSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSGROUPSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSGROUPSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSGROUPSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CONSCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CONSCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UCONSGROUPSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSGROUPSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CONSCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CONSCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSGROUPSDETAIL
  AFTER DELETE
  ON UCONSGROUPSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSGROUPSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSSUBJECTFORMS
  AFTER INSERT
  ON UCONSSUBJECTFORMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSSUBJECTFORMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSSUBJECTFORMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUBJECTTEXTID
      ,FORMTEXTID
      ,ISCLIENT
      ,BEGINDATE
      ,ENDDATE
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUBJECTTEXTID
      , :new.FORMTEXTID
      , :new.ISCLIENT
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSSUBJECTFORMS
  AFTER UPDATE
  ON UCONSSUBJECTFORMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSSUBJECTFORMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSSUBJECTFORMS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSSUBJECTFORMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUBJECTTEXTID
      ,FORMTEXTID
      ,ISCLIENT
      ,BEGINDATE
      ,ENDDATE
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUBJECTTEXTID
      , :new.FORMTEXTID
      , :new.ISCLIENT
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UCONSSUBJECTFORMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSSUBJECTFORMS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,SUBJECTTEXTID
      ,FORMTEXTID
      ,ISCLIENT
      ,BEGINDATE
      ,ENDDATE
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.SUBJECTTEXTID
      , :new.FORMTEXTID
      , :new.ISCLIENT
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSSUBJECTFORMS
  AFTER DELETE
  ON UCONSSUBJECTFORMS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSSUBJECTFORMS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UCONSSUBJECTTYPES
  AFTER INSERT
  ON UCONSSUBJECTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSSUBJECTTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSSUBJECTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UCONSSUBJECTTYPES
  AFTER UPDATE
  ON UCONSSUBJECTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UCONSSUBJECTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UCONSSUBJECTTYPES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UCONSSUBJECTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UCONSSUBJECTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UCONSSUBJECTTYPES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UCONSSUBJECTTYPES
  AFTER DELETE
  ON UCONSSUBJECTTYPES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UCONSSUBJECTTYPES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UFK_LOGCAPTION
  AFTER INSERT
  ON UFK_LOGCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_LOGCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_LOGCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,ERRORCLS
      ,REGIONCLS
      ,NOTE
      ,IMPORTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OPERDATE
      ,IMPORTNUMBER
      ,DELETEFLAG
      ,IMPORTEDCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.ERRORCLS
      , :new.REGIONCLS
      , :new.NOTE
      , :new.IMPORTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OPERDATE
      , :new.IMPORTNUMBER
      , :new.DELETEFLAG
      , :new.IMPORTEDCOUNT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UFK_LOGCAPTION
  AFTER UPDATE
  ON UFK_LOGCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UFK_LOGCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UFK_LOGCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_LOGCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,ERRORCLS
      ,REGIONCLS
      ,NOTE
      ,IMPORTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OPERDATE
      ,IMPORTNUMBER
      ,DELETEFLAG
      ,IMPORTEDCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.ERRORCLS
      , :new.REGIONCLS
      , :new.NOTE
      , :new.IMPORTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OPERDATE
      , :new.IMPORTNUMBER
      , :new.DELETEFLAG
      , :new.IMPORTEDCOUNT
    );
  else 
    update A_UFK_LOGCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UFK_LOGCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PROGINDEX
      ,ERRORCLS
      ,REGIONCLS
      ,NOTE
      ,IMPORTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OPERDATE
      ,IMPORTNUMBER
      ,DELETEFLAG
      ,IMPORTEDCOUNT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PROGINDEX
      , :new.ERRORCLS
      , :new.REGIONCLS
      , :new.NOTE
      , :new.IMPORTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OPERDATE
      , :new.IMPORTNUMBER
      , :new.DELETEFLAG
      , :new.IMPORTEDCOUNT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UFK_LOGCAPTION
  AFTER DELETE
  ON UFK_LOGCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_LOGCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UFK_LOGDETAIL
  AFTER INSERT
  ON UFK_LOGDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_LOGDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_LOGDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DESTRECORDINDEX
      ,SOURCEFIRSTRECORDINDEX
      ,SOURCESECONDRECORDINDEX
      ,PROGINDEX
      ,ERRORCLS
      ,REGIONCLS
      ,RECORDINDEX
      ,NOTE
      ,IMPORTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ANUMBER
      ,PACKETNUMBER
      ,GETDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DESTRECORDINDEX
      , :new.SOURCEFIRSTRECORDINDEX
      , :new.SOURCESECONDRECORDINDEX
      , :new.PROGINDEX
      , :new.ERRORCLS
      , :new.REGIONCLS
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.IMPORTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.PACKETNUMBER
      , :new.GETDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UFK_LOGDETAIL
  AFTER UPDATE
  ON UFK_LOGDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UFK_LOGDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UFK_LOGDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_LOGDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DESTRECORDINDEX
      ,SOURCEFIRSTRECORDINDEX
      ,SOURCESECONDRECORDINDEX
      ,PROGINDEX
      ,ERRORCLS
      ,REGIONCLS
      ,RECORDINDEX
      ,NOTE
      ,IMPORTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ANUMBER
      ,PACKETNUMBER
      ,GETDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DESTRECORDINDEX
      , :new.SOURCEFIRSTRECORDINDEX
      , :new.SOURCESECONDRECORDINDEX
      , :new.PROGINDEX
      , :new.ERRORCLS
      , :new.REGIONCLS
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.IMPORTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.PACKETNUMBER
      , :new.GETDATE
    );
  else 
    update A_UFK_LOGDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UFK_LOGDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DESTRECORDINDEX
      ,SOURCEFIRSTRECORDINDEX
      ,SOURCESECONDRECORDINDEX
      ,PROGINDEX
      ,ERRORCLS
      ,REGIONCLS
      ,RECORDINDEX
      ,NOTE
      ,IMPORTDATE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,ANUMBER
      ,PACKETNUMBER
      ,GETDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DESTRECORDINDEX
      , :new.SOURCEFIRSTRECORDINDEX
      , :new.SOURCESECONDRECORDINDEX
      , :new.PROGINDEX
      , :new.ERRORCLS
      , :new.REGIONCLS
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.IMPORTDATE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.ANUMBER
      , :new.PACKETNUMBER
      , :new.GETDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UFK_LOGDETAIL
  AFTER DELETE
  ON UFK_LOGDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_LOGDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UFK_RM
  AFTER INSERT
  ON UFK_RM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_RM
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_RM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,DAT_DOC
      ,SCHET
      ,VH_OST
      ,OBD
      ,OBK
      ,ISH_SALD
      ,SENDER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REGIONCODE
      ,REGION_CLS
      ,LASTPACKET
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.DAT_DOC
      , :new.SCHET
      , :new.VH_OST
      , :new.OBD
      , :new.OBK
      , :new.ISH_SALD
      , :new.SENDER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REGIONCODE
      , :new.REGION_CLS
      , :new.LASTPACKET
      , :new.ANUMBER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UFK_RM
  AFTER UPDATE
  ON UFK_RM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UFK_RM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UFK_RM
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_RM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,DAT_DOC
      ,SCHET
      ,VH_OST
      ,OBD
      ,OBK
      ,ISH_SALD
      ,SENDER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REGIONCODE
      ,REGION_CLS
      ,LASTPACKET
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.DAT_DOC
      , :new.SCHET
      , :new.VH_OST
      , :new.OBD
      , :new.OBK
      , :new.ISH_SALD
      , :new.SENDER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REGIONCODE
      , :new.REGION_CLS
      , :new.LASTPACKET
      , :new.ANUMBER
    );
  else 
    update A_UFK_RM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UFK_RM (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,DAT_DOC
      ,SCHET
      ,VH_OST
      ,OBD
      ,OBK
      ,ISH_SALD
      ,SENDER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REGIONCODE
      ,REGION_CLS
      ,LASTPACKET
      ,ANUMBER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.DAT_DOC
      , :new.SCHET
      , :new.VH_OST
      , :new.OBD
      , :new.OBK
      , :new.ISH_SALD
      , :new.SENDER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REGIONCODE
      , :new.REGION_CLS
      , :new.LASTPACKET
      , :new.ANUMBER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UFK_RM
  AFTER DELETE
  ON UFK_RM
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_RM
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UFK_SVERKA
  AFTER INSERT
  ON UFK_SVERKA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_SVERKA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_SVERKA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DFACCOUNT
      ,DOCDATE
      ,DEBITBEFORE
      ,CREDITBEFORE
      ,DEBIT
      ,CREDIT
      ,BUHACC
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DFACCOUNT
      , :new.DOCDATE
      , :new.DEBITBEFORE
      , :new.CREDITBEFORE
      , :new.DEBIT
      , :new.CREDIT
      , :new.BUHACC
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UFK_SVERKA
  AFTER UPDATE
  ON UFK_SVERKA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UFK_SVERKA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UFK_SVERKA
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_SVERKA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DFACCOUNT
      ,DOCDATE
      ,DEBITBEFORE
      ,CREDITBEFORE
      ,DEBIT
      ,CREDIT
      ,BUHACC
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DFACCOUNT
      , :new.DOCDATE
      , :new.DEBITBEFORE
      , :new.CREDITBEFORE
      , :new.DEBIT
      , :new.CREDIT
      , :new.BUHACC
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_UFK_SVERKA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UFK_SVERKA (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,DFACCOUNT
      ,DOCDATE
      ,DEBITBEFORE
      ,CREDITBEFORE
      ,DEBIT
      ,CREDIT
      ,BUHACC
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.DFACCOUNT
      , :new.DOCDATE
      , :new.DEBITBEFORE
      , :new.CREDITBEFORE
      , :new.DEBIT
      , :new.CREDIT
      , :new.BUHACC
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UFK_SVERKA
  AFTER DELETE
  ON UFK_SVERKA
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_SVERKA
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UFK_SVOD
  AFTER INSERT
  ON UFK_SVOD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_SVOD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_SVOD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,PRIZ
      ,DATA
      ,NOM
      ,QQ1
      ,QQ2
      ,QQ3
      ,QQ4
      ,QQS
      ,SENDER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OKATO
      ,NUM
      ,INN
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.PRIZ
      , :new.DATA
      , :new.NOM
      , :new.QQ1
      , :new.QQ2
      , :new.QQ3
      , :new.QQ4
      , :new.QQS
      , :new.SENDER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OKATO
      , :new.NUM
      , :new.INN
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UFK_SVOD
  AFTER UPDATE
  ON UFK_SVOD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UFK_SVOD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UFK_SVOD
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_SVOD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,PRIZ
      ,DATA
      ,NOM
      ,QQ1
      ,QQ2
      ,QQ3
      ,QQ4
      ,QQS
      ,SENDER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OKATO
      ,NUM
      ,INN
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.PRIZ
      , :new.DATA
      , :new.NOM
      , :new.QQ1
      , :new.QQ2
      , :new.QQ3
      , :new.QQ4
      , :new.QQS
      , :new.SENDER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OKATO
      , :new.NUM
      , :new.INN
    );
  else 
    update A_UFK_SVOD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UFK_SVOD (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,PRIZ
      ,DATA
      ,NOM
      ,QQ1
      ,QQ2
      ,QQ3
      ,QQ4
      ,QQS
      ,SENDER
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,OKATO
      ,NUM
      ,INN
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.PRIZ
      , :new.DATA
      , :new.NOM
      , :new.QQ1
      , :new.QQ2
      , :new.QQ3
      , :new.QQ4
      , :new.QQS
      , :new.SENDER
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.OKATO
      , :new.NUM
      , :new.INN
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UFK_SVOD
  AFTER DELETE
  ON UFK_SVOD
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_SVOD
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UFK_VP
  AFTER INSERT
  ON UFK_VP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_VP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_VP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,DATE_PROV
      ,SCHET
      ,NUM
      ,DAT_DOC
      ,SUMMA
      ,TIP_OPER
      ,TIP_DOC
      ,GL
      ,PODRAZDEL
      ,VIDRASHOD
      ,CELST
      ,KL_NUM
      ,NAZNACH
      ,SENDER
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REGIONCODE
      ,RECORDINDEX
      ,REGION_CLS
      ,ANUMBER
      ,LASTPACKET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.DATE_PROV
      , :new.SCHET
      , :new.NUM
      , :new.DAT_DOC
      , :new.SUMMA
      , :new.TIP_OPER
      , :new.TIP_DOC
      , :new.GL
      , :new.PODRAZDEL
      , :new.VIDRASHOD
      , :new.CELST
      , :new.KL_NUM
      , :new.NAZNACH
      , :new.SENDER
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REGIONCODE
      , :new.RECORDINDEX
      , :new.REGION_CLS
      , :new.ANUMBER
      , :new.LASTPACKET
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UFK_VP
  AFTER UPDATE
  ON UFK_VP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UFK_VP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UFK_VP
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UFK_VP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,DATE_PROV
      ,SCHET
      ,NUM
      ,DAT_DOC
      ,SUMMA
      ,TIP_OPER
      ,TIP_DOC
      ,GL
      ,PODRAZDEL
      ,VIDRASHOD
      ,CELST
      ,KL_NUM
      ,NAZNACH
      ,SENDER
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REGIONCODE
      ,RECORDINDEX
      ,REGION_CLS
      ,ANUMBER
      ,LASTPACKET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.DATE_PROV
      , :new.SCHET
      , :new.NUM
      , :new.DAT_DOC
      , :new.SUMMA
      , :new.TIP_OPER
      , :new.TIP_DOC
      , :new.GL
      , :new.PODRAZDEL
      , :new.VIDRASHOD
      , :new.CELST
      , :new.KL_NUM
      , :new.NAZNACH
      , :new.SENDER
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REGIONCODE
      , :new.RECORDINDEX
      , :new.REGION_CLS
      , :new.ANUMBER
      , :new.LASTPACKET
    );
  else 
    update A_UFK_VP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UFK_VP (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PACKETNUMBER
      ,GETDATE
      ,DATE_PROV
      ,SCHET
      ,NUM
      ,DAT_DOC
      ,SUMMA
      ,TIP_OPER
      ,TIP_DOC
      ,GL
      ,PODRAZDEL
      ,VIDRASHOD
      ,CELST
      ,KL_NUM
      ,NAZNACH
      ,SENDER
      ,PROCESSING
      ,AUTOPROCESSING
      ,PROCNOTE
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REGIONCODE
      ,RECORDINDEX
      ,REGION_CLS
      ,ANUMBER
      ,LASTPACKET
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PACKETNUMBER
      , :new.GETDATE
      , :new.DATE_PROV
      , :new.SCHET
      , :new.NUM
      , :new.DAT_DOC
      , :new.SUMMA
      , :new.TIP_OPER
      , :new.TIP_DOC
      , :new.GL
      , :new.PODRAZDEL
      , :new.VIDRASHOD
      , :new.CELST
      , :new.KL_NUM
      , :new.NAZNACH
      , :new.SENDER
      , :new.PROCESSING
      , :new.AUTOPROCESSING
      , :new.PROCNOTE
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REGIONCODE
      , :new.RECORDINDEX
      , :new.REGION_CLS
      , :new.ANUMBER
      , :new.LASTPACKET
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UFK_VP
  AFTER DELETE
  ON UFK_VP
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UFK_VP
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UNIONNOTIFYCAPTION
  AFTER INSERT
  ON UNIONNOTIFYCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UNIONNOTIFYCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UNIONNOTIFYCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DOCNUMBER
      ,NOTIFYNUMBER
      ,INPUTDATE
      ,DFACCOUNT
      ,ACCEPTDATE
      ,ACCEPTDATEFK
      ,PROGINDEX
      ,FACIALACCCLS
      ,DOCUMENTFORMAT
      ,ORG_REF
      ,NOTIFYTYPE
      ,NOTE
      ,KFD
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REJECTCLS
      ,REJECTCAUSE
      ,REESTRNUMBER
      ,REESTRDATE
      ,DATE_UTV_REESTR
      ,DATE_UTV_BA
      ,DATE_UTV_LBO
      ,DATE_UTV_POF
      ,DATE_UTV_PP
      ,DATE_PP
      ,SPECIALNOTECODE
      ,TIP_RR
      ,CLSTYPE
      ,NOM_PP
      ,SPECIALNOTE
      ,INPUTMONTH
      ,STIMATEID
      ,LASTEXTRCHANGE
      ,DEPARTMENTCLS
      ,SIGNERS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.NOTIFYNUMBER
      , :new.INPUTDATE
      , :new.DFACCOUNT
      , :new.ACCEPTDATE
      , :new.ACCEPTDATEFK
      , :new.PROGINDEX
      , :new.FACIALACCCLS
      , :new.DOCUMENTFORMAT
      , :new.ORG_REF
      , :new.NOTIFYTYPE
      , :new.NOTE
      , :new.KFD
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.REESTRNUMBER
      , :new.REESTRDATE
      , :new.DATE_UTV_REESTR
      , :new.DATE_UTV_BA
      , :new.DATE_UTV_LBO
      , :new.DATE_UTV_POF
      , :new.DATE_UTV_PP
      , :new.DATE_PP
      , :new.SPECIALNOTECODE
      , :new.TIP_RR
      , :new.CLSTYPE
      , :new.NOM_PP
      , :new.SPECIALNOTE
      , :new.INPUTMONTH
      , :new.STIMATEID
      , :new.LASTEXTRCHANGE
      , :new.DEPARTMENTCLS
      , :new.SIGNERS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UNIONNOTIFYCAPTION
  AFTER UPDATE
  ON UNIONNOTIFYCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UNIONNOTIFYCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UNIONNOTIFYCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UNIONNOTIFYCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DOCNUMBER
      ,NOTIFYNUMBER
      ,INPUTDATE
      ,DFACCOUNT
      ,ACCEPTDATE
      ,ACCEPTDATEFK
      ,PROGINDEX
      ,FACIALACCCLS
      ,DOCUMENTFORMAT
      ,ORG_REF
      ,NOTIFYTYPE
      ,NOTE
      ,KFD
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REJECTCLS
      ,REJECTCAUSE
      ,REESTRNUMBER
      ,REESTRDATE
      ,DATE_UTV_REESTR
      ,DATE_UTV_BA
      ,DATE_UTV_LBO
      ,DATE_UTV_POF
      ,DATE_UTV_PP
      ,DATE_PP
      ,SPECIALNOTECODE
      ,TIP_RR
      ,CLSTYPE
      ,NOM_PP
      ,SPECIALNOTE
      ,INPUTMONTH
      ,STIMATEID
      ,LASTEXTRCHANGE
      ,DEPARTMENTCLS
      ,SIGNERS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.NOTIFYNUMBER
      , :new.INPUTDATE
      , :new.DFACCOUNT
      , :new.ACCEPTDATE
      , :new.ACCEPTDATEFK
      , :new.PROGINDEX
      , :new.FACIALACCCLS
      , :new.DOCUMENTFORMAT
      , :new.ORG_REF
      , :new.NOTIFYTYPE
      , :new.NOTE
      , :new.KFD
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.REESTRNUMBER
      , :new.REESTRDATE
      , :new.DATE_UTV_REESTR
      , :new.DATE_UTV_BA
      , :new.DATE_UTV_LBO
      , :new.DATE_UTV_POF
      , :new.DATE_UTV_PP
      , :new.DATE_PP
      , :new.SPECIALNOTECODE
      , :new.TIP_RR
      , :new.CLSTYPE
      , :new.NOM_PP
      , :new.SPECIALNOTE
      , :new.INPUTMONTH
      , :new.STIMATEID
      , :new.LASTEXTRCHANGE
      , :new.DEPARTMENTCLS
      , :new.SIGNERS
    );
  else 
    update A_UNIONNOTIFYCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UNIONNOTIFYCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DOCNUMBER
      ,NOTIFYNUMBER
      ,INPUTDATE
      ,DFACCOUNT
      ,ACCEPTDATE
      ,ACCEPTDATEFK
      ,PROGINDEX
      ,FACIALACCCLS
      ,DOCUMENTFORMAT
      ,ORG_REF
      ,NOTIFYTYPE
      ,NOTE
      ,KFD
      ,SENDERID
      ,SENDERRECORDID
      ,CRYPTOSTATUS
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,REJECTCLS
      ,REJECTCAUSE
      ,REESTRNUMBER
      ,REESTRDATE
      ,DATE_UTV_REESTR
      ,DATE_UTV_BA
      ,DATE_UTV_LBO
      ,DATE_UTV_POF
      ,DATE_UTV_PP
      ,DATE_PP
      ,SPECIALNOTECODE
      ,TIP_RR
      ,CLSTYPE
      ,NOM_PP
      ,SPECIALNOTE
      ,INPUTMONTH
      ,STIMATEID
      ,LASTEXTRCHANGE
      ,DEPARTMENTCLS
      ,SIGNERS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.NOTIFYNUMBER
      , :new.INPUTDATE
      , :new.DFACCOUNT
      , :new.ACCEPTDATE
      , :new.ACCEPTDATEFK
      , :new.PROGINDEX
      , :new.FACIALACCCLS
      , :new.DOCUMENTFORMAT
      , :new.ORG_REF
      , :new.NOTIFYTYPE
      , :new.NOTE
      , :new.KFD
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CRYPTOSTATUS
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.REJECTCLS
      , :new.REJECTCAUSE
      , :new.REESTRNUMBER
      , :new.REESTRDATE
      , :new.DATE_UTV_REESTR
      , :new.DATE_UTV_BA
      , :new.DATE_UTV_LBO
      , :new.DATE_UTV_POF
      , :new.DATE_UTV_PP
      , :new.DATE_PP
      , :new.SPECIALNOTECODE
      , :new.TIP_RR
      , :new.CLSTYPE
      , :new.NOM_PP
      , :new.SPECIALNOTE
      , :new.INPUTMONTH
      , :new.STIMATEID
      , :new.LASTEXTRCHANGE
      , :new.DEPARTMENTCLS
      , :new.SIGNERS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UNIONNOTIFYCAPTION
  AFTER DELETE
  ON UNIONNOTIFYCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UNIONNOTIFYCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UNIONNOTIFYDETAIL
  AFTER INSERT
  ON UNIONNOTIFYDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UNIONNOTIFYDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UNIONNOTIFYDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
      ,IFS
      ,ACTIVITYKIND
      ,TARGETCLS
      ,CLSTYPE
      ,NOTE
      ,SUMMALIMIT
      ,SUMMAASSIGNMENT
      ,SUMMAFIN
      ,SUMMALIMITYEAR
      ,SUMMAASSIGNMENTYEAR
      ,SUMMAFINYEAR
      ,PROGINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,BA_LBO_FLAG
      ,BUHOPERATIONCLS
      ,FACT
      ,MEANSTYPE
      ,DIRECTIONCLS
      ,REGIONCLS
      ,SUBKESR
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,FINTYPE
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
      , :new.IFS
      , :new.ACTIVITYKIND
      , :new.TARGETCLS
      , :new.CLSTYPE
      , :new.NOTE
      , :new.SUMMALIMIT
      , :new.SUMMAASSIGNMENT
      , :new.SUMMAFIN
      , :new.SUMMALIMITYEAR
      , :new.SUMMAASSIGNMENTYEAR
      , :new.SUMMAFINYEAR
      , :new.PROGINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.BA_LBO_FLAG
      , :new.BUHOPERATIONCLS
      , :new.FACT
      , :new.MEANSTYPE
      , :new.DIRECTIONCLS
      , :new.REGIONCLS
      , :new.SUBKESR
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.FINTYPE
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UNIONNOTIFYDETAIL
  AFTER UPDATE
  ON UNIONNOTIFYDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UNIONNOTIFYDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UNIONNOTIFYDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UNIONNOTIFYDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
      ,IFS
      ,ACTIVITYKIND
      ,TARGETCLS
      ,CLSTYPE
      ,NOTE
      ,SUMMALIMIT
      ,SUMMAASSIGNMENT
      ,SUMMAFIN
      ,SUMMALIMITYEAR
      ,SUMMAASSIGNMENTYEAR
      ,SUMMAFINYEAR
      ,PROGINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,BA_LBO_FLAG
      ,BUHOPERATIONCLS
      ,FACT
      ,MEANSTYPE
      ,DIRECTIONCLS
      ,REGIONCLS
      ,SUBKESR
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,FINTYPE
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
      , :new.IFS
      , :new.ACTIVITYKIND
      , :new.TARGETCLS
      , :new.CLSTYPE
      , :new.NOTE
      , :new.SUMMALIMIT
      , :new.SUMMAASSIGNMENT
      , :new.SUMMAFIN
      , :new.SUMMALIMITYEAR
      , :new.SUMMAASSIGNMENTYEAR
      , :new.SUMMAFINYEAR
      , :new.PROGINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.BA_LBO_FLAG
      , :new.BUHOPERATIONCLS
      , :new.FACT
      , :new.MEANSTYPE
      , :new.DIRECTIONCLS
      , :new.REGIONCLS
      , :new.SUBKESR
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.FINTYPE
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
    );
  else 
    update A_UNIONNOTIFYDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UNIONNOTIFYDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,KVSR
      ,KCSR
      ,KFSR
      ,KVR
      ,KESR
      ,IFS
      ,ACTIVITYKIND
      ,TARGETCLS
      ,CLSTYPE
      ,NOTE
      ,SUMMALIMIT
      ,SUMMAASSIGNMENT
      ,SUMMAFIN
      ,SUMMALIMITYEAR
      ,SUMMAASSIGNMENTYEAR
      ,SUMMAFINYEAR
      ,PROGINDEX
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,SUMMAYEAR1
      ,SUMMAYEAR2
      ,SUMMAYEAR3
      ,BA_LBO_FLAG
      ,BUHOPERATIONCLS
      ,FACT
      ,MEANSTYPE
      ,DIRECTIONCLS
      ,REGIONCLS
      ,SUBKESR
      ,STIMATEID
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,FINTYPE
      ,INVESTOBJECT
      ,SUMMAYEAR4
      ,SUMMAOTHERYEARS
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.KVSR
      , :new.KCSR
      , :new.KFSR
      , :new.KVR
      , :new.KESR
      , :new.IFS
      , :new.ACTIVITYKIND
      , :new.TARGETCLS
      , :new.CLSTYPE
      , :new.NOTE
      , :new.SUMMALIMIT
      , :new.SUMMAASSIGNMENT
      , :new.SUMMAFIN
      , :new.SUMMALIMITYEAR
      , :new.SUMMAASSIGNMENTYEAR
      , :new.SUMMAFINYEAR
      , :new.PROGINDEX
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.SUMMAYEAR1
      , :new.SUMMAYEAR2
      , :new.SUMMAYEAR3
      , :new.BA_LBO_FLAG
      , :new.BUHOPERATIONCLS
      , :new.FACT
      , :new.MEANSTYPE
      , :new.DIRECTIONCLS
      , :new.REGIONCLS
      , :new.SUBKESR
      , :new.STIMATEID
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.FINTYPE
      , :new.INVESTOBJECT
      , :new.SUMMAYEAR4
      , :new.SUMMAOTHERYEARS
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UNIONNOTIFYDETAIL
  AFTER DELETE
  ON UNIONNOTIFYDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UNIONNOTIFYDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_USERSINGROUPS
  AFTER INSERT
  ON USERSINGROUPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_USERSINGROUPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_USERSINGROUPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,USERREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.USERREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_USERSINGROUPS
  AFTER UPDATE
  ON USERSINGROUPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_USERSINGROUPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_USERSINGROUPS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_USERSINGROUPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,USERREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.USERREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_USERSINGROUPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_USERSINGROUPS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,GROUPREF
      ,USERREF
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.GROUPREF
      , :new.USERREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_USERSINGROUPS
  AFTER DELETE
  ON USERSINGROUPS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_USERSINGROUPS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_USERSRIGHTS
  AFTER INSERT
  ON USERSRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_USERSRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_USERSRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,RIGHTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RIGHTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_USERSRIGHTS
  AFTER UPDATE
  ON USERSRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_USERSRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_USERSRIGHTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_USERSRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,RIGHTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RIGHTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_USERSRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_USERSRIGHTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,USERREF
      ,RIGHTREF
      ,ISREJECT
      ,OBJREF
      ,OBJECTKINDREF
      ,CREATEDATE
      ,UPDATEDATE
      ,RIGHTKINDREF
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.USERREF
      , :new.RIGHTREF
      , :new.ISREJECT
      , :new.OBJREF
      , :new.OBJECTKINDREF
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.RIGHTKINDREF
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_USERSRIGHTS
  AFTER DELETE
  ON USERSRIGHTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_USERSRIGHTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTFCTREE
  AFTER INSERT
  ON UTFCTREE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTFCTREE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTFCTREE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,UTFCPARENT
      ,UTFCKID
      ,PROGINDEX
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.UTFCPARENT
      , :new.UTFCKID
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTFCTREE
  AFTER UPDATE
  ON UTFCTREE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTFCTREE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTFCTREE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTFCTREE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,UTFCPARENT
      ,UTFCKID
      ,PROGINDEX
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.UTFCPARENT
      , :new.UTFCKID
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_UTFCTREE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTFCTREE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,UTFCPARENT
      ,UTFCKID
      ,PROGINDEX
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.UTFCPARENT
      , :new.UTFCKID
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTFCTREE
  AFTER DELETE
  ON UTFCTREE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTFCTREE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDCLSCAPTION
  AFTER INSERT
  ON UTYPEDCLSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDCLSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDCLSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLSID
      ,NAME
      ,TEXTID
      ,BEGINDATE
      ,ENDDATE
      ,OPTIONS
      ,GROUPRIGHTS
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLSID
      , :new.NAME
      , :new.TEXTID
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.OPTIONS
      , :new.GROUPRIGHTS
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDCLSCAPTION
  AFTER UPDATE
  ON UTYPEDCLSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDCLSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDCLSCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDCLSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLSID
      ,NAME
      ,TEXTID
      ,BEGINDATE
      ,ENDDATE
      ,OPTIONS
      ,GROUPRIGHTS
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLSID
      , :new.NAME
      , :new.TEXTID
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.OPTIONS
      , :new.GROUPRIGHTS
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NOTE
    );
  else 
    update A_UTYPEDCLSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDCLSCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CLSID
      ,NAME
      ,TEXTID
      ,BEGINDATE
      ,ENDDATE
      ,OPTIONS
      ,GROUPRIGHTS
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CLSID
      , :new.NAME
      , :new.TEXTID
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.OPTIONS
      , :new.GROUPRIGHTS
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDCLSCAPTION
  AFTER DELETE
  ON UTYPEDCLSCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDCLSCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDCLSDETAIL
  AFTER INSERT
  ON UTYPEDCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CODE
      ,CODESTR
      ,NOTE0
      ,NOTE1
      ,NOTE2
      ,NOTE3
      ,NOTE4
      ,NOTE5
      ,NOTE6
      ,NOTE7
      ,NOTE8
      ,NOTE9
      ,FINT0
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,FINT8
      ,FINT9
      ,FLEVEL
      ,GROUPLIST
      ,USERLIST
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DETAILINDEX
      ,NUMSTR
      ,CODEROW
      ,ROWORDER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CODE
      , :new.CODESTR
      , :new.NOTE0
      , :new.NOTE1
      , :new.NOTE2
      , :new.NOTE3
      , :new.NOTE4
      , :new.NOTE5
      , :new.NOTE6
      , :new.NOTE7
      , :new.NOTE8
      , :new.NOTE9
      , :new.FINT0
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.FINT8
      , :new.FINT9
      , :new.FLEVEL
      , :new.GROUPLIST
      , :new.USERLIST
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DETAILINDEX
      , :new.NUMSTR
      , :new.CODEROW
      , :new.ROWORDER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDCLSDETAIL
  AFTER UPDATE
  ON UTYPEDCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CODE
      ,CODESTR
      ,NOTE0
      ,NOTE1
      ,NOTE2
      ,NOTE3
      ,NOTE4
      ,NOTE5
      ,NOTE6
      ,NOTE7
      ,NOTE8
      ,NOTE9
      ,FINT0
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,FINT8
      ,FINT9
      ,FLEVEL
      ,GROUPLIST
      ,USERLIST
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DETAILINDEX
      ,NUMSTR
      ,CODEROW
      ,ROWORDER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CODE
      , :new.CODESTR
      , :new.NOTE0
      , :new.NOTE1
      , :new.NOTE2
      , :new.NOTE3
      , :new.NOTE4
      , :new.NOTE5
      , :new.NOTE6
      , :new.NOTE7
      , :new.NOTE8
      , :new.NOTE9
      , :new.FINT0
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.FINT8
      , :new.FINT9
      , :new.FLEVEL
      , :new.GROUPLIST
      , :new.USERLIST
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DETAILINDEX
      , :new.NUMSTR
      , :new.CODEROW
      , :new.ROWORDER
    );
  else 
    update A_UTYPEDCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,CODE
      ,CODESTR
      ,NOTE0
      ,NOTE1
      ,NOTE2
      ,NOTE3
      ,NOTE4
      ,NOTE5
      ,NOTE6
      ,NOTE7
      ,NOTE8
      ,NOTE9
      ,FINT0
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,FINT6
      ,FINT7
      ,FINT8
      ,FINT9
      ,FLEVEL
      ,GROUPLIST
      ,USERLIST
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DETAILINDEX
      ,NUMSTR
      ,CODEROW
      ,ROWORDER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.CODE
      , :new.CODESTR
      , :new.NOTE0
      , :new.NOTE1
      , :new.NOTE2
      , :new.NOTE3
      , :new.NOTE4
      , :new.NOTE5
      , :new.NOTE6
      , :new.NOTE7
      , :new.NOTE8
      , :new.NOTE9
      , :new.FINT0
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.FINT6
      , :new.FINT7
      , :new.FINT8
      , :new.FINT9
      , :new.FLEVEL
      , :new.GROUPLIST
      , :new.USERLIST
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DETAILINDEX
      , :new.NUMSTR
      , :new.CODEROW
      , :new.ROWORDER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDCLSDETAIL
  AFTER DELETE
  ON UTYPEDCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDDOCUMENTS
  AFTER INSERT
  ON UTYPEDDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDDOCUMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,FORURM
      ,PROGINDEX
      ,TEMPLATE
      ,BEGINDATE
      ,ENDDATE
      ,PARAMS
      ,FORMTEXTID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.FORURM
      , :new.PROGINDEX
      , :new.TEMPLATE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.PARAMS
      , :new.FORMTEXTID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDDOCUMENTS
  AFTER UPDATE
  ON UTYPEDDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDDOCUMENTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,FORURM
      ,PROGINDEX
      ,TEMPLATE
      ,BEGINDATE
      ,ENDDATE
      ,PARAMS
      ,FORMTEXTID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.FORURM
      , :new.PROGINDEX
      , :new.TEMPLATE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.PARAMS
      , :new.FORMTEXTID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UTYPEDDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDDOCUMENTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,FORURM
      ,PROGINDEX
      ,TEMPLATE
      ,BEGINDATE
      ,ENDDATE
      ,PARAMS
      ,FORMTEXTID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.FORURM
      , :new.PROGINDEX
      , :new.TEMPLATE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.PARAMS
      , :new.FORMTEXTID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDDOCUMENTS
  AFTER DELETE
  ON UTYPEDDOCUMENTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDDOCUMENTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDFORMSDETAIL
  AFTER INSERT
  ON UTYPEDFORMSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,DETAILINDEX
      ,CODESTR
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,CODEROW
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,S00
      ,S01
      ,S02
      ,S03
      ,S04
      ,S05
      ,S06
      ,S07
      ,S08
      ,S09
      ,S10
      ,S11
      ,S12
      ,S13
      ,S14
      ,S15
      ,S16
      ,S17
      ,S18
      ,S19
      ,S20
      ,NOTE
      ,FACT
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NUMSTR
      ,SENDERID
      ,SENDERRECORDID
      ,CODESTR30
      ,PROGRAMCODE
      ,ITEMCODE
      ,DESCRIPTIONCODE
      ,SUBKESR
      ,FINT6
      ,FINT7
      ,NOTE1
      ,NOTE2
      ,NOTE3
      ,NOTE4
      ,NOTE5
      ,NOTE6
      ,NOTE7
      ,NOTE8
      ,NOTE9
      ,NOTE10
      ,CURRENCYCLS
      ,OKATO
      ,CODEINT
      ,ROWORDER
      ,DIRECTIONCLS
      ,KD
      ,INNERFINSOURCE
      ,CLSTYPE
      ,S21
      ,S22
      ,S23
      ,S24
      ,S25
      ,S26
      ,S27
      ,S28
      ,S29
      ,S30
      ,S31
      ,S32
      ,S33
      ,S34
      ,S35
      ,S36
      ,S37
      ,S38
      ,S39
      ,S40
      ,FINT8
      ,FINT9
      ,FINT10
      ,NOTE11
      ,NOTE12
      ,NOTE13
      ,NOTE14
      ,NOTE15
      ,NOTE16
      ,NOTE17
      ,NOTE18
      ,NOTE19
      ,NOTE20
      ,DATE1
      ,DATE2
      ,DATE3
      ,DATE4
      ,DATE5
      ,DATE6
      ,DATE7
      ,DATE8
      ,DATE9
      ,DATE10
      ,PARENTINDEX
      ,TYPEDFORM
      ,RVERSION
      ,KFSRCODE
      ,KCSRCODE
      ,KVSRCODE
      ,KVRCODE
      ,KESRCODE
      ,SUBKESRCODE
      ,OKATOCODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.DETAILINDEX
      , :new.CODESTR
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.CODEROW
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.S00
      , :new.S01
      , :new.S02
      , :new.S03
      , :new.S04
      , :new.S05
      , :new.S06
      , :new.S07
      , :new.S08
      , :new.S09
      , :new.S10
      , :new.S11
      , :new.S12
      , :new.S13
      , :new.S14
      , :new.S15
      , :new.S16
      , :new.S17
      , :new.S18
      , :new.S19
      , :new.S20
      , :new.NOTE
      , :new.FACT
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NUMSTR
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CODESTR30
      , :new.PROGRAMCODE
      , :new.ITEMCODE
      , :new.DESCRIPTIONCODE
      , :new.SUBKESR
      , :new.FINT6
      , :new.FINT7
      , :new.NOTE1
      , :new.NOTE2
      , :new.NOTE3
      , :new.NOTE4
      , :new.NOTE5
      , :new.NOTE6
      , :new.NOTE7
      , :new.NOTE8
      , :new.NOTE9
      , :new.NOTE10
      , :new.CURRENCYCLS
      , :new.OKATO
      , :new.CODEINT
      , :new.ROWORDER
      , :new.DIRECTIONCLS
      , :new.KD
      , :new.INNERFINSOURCE
      , :new.CLSTYPE
      , :new.S21
      , :new.S22
      , :new.S23
      , :new.S24
      , :new.S25
      , :new.S26
      , :new.S27
      , :new.S28
      , :new.S29
      , :new.S30
      , :new.S31
      , :new.S32
      , :new.S33
      , :new.S34
      , :new.S35
      , :new.S36
      , :new.S37
      , :new.S38
      , :new.S39
      , :new.S40
      , :new.FINT8
      , :new.FINT9
      , :new.FINT10
      , :new.NOTE11
      , :new.NOTE12
      , :new.NOTE13
      , :new.NOTE14
      , :new.NOTE15
      , :new.NOTE16
      , :new.NOTE17
      , :new.NOTE18
      , :new.NOTE19
      , :new.NOTE20
      , :new.DATE1
      , :new.DATE2
      , :new.DATE3
      , :new.DATE4
      , :new.DATE5
      , :new.DATE6
      , :new.DATE7
      , :new.DATE8
      , :new.DATE9
      , :new.DATE10
      , :new.PARENTINDEX
      , :new.TYPEDFORM
      , :new.RVERSION
      , :new.KFSRCODE
      , :new.KCSRCODE
      , :new.KVSRCODE
      , :new.KVRCODE
      , :new.KESRCODE
      , :new.SUBKESRCODE
      , :new.OKATOCODE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDFORMSDETAIL
  AFTER UPDATE
  ON UTYPEDFORMSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDFORMSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDFORMSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,DETAILINDEX
      ,CODESTR
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,CODEROW
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,S00
      ,S01
      ,S02
      ,S03
      ,S04
      ,S05
      ,S06
      ,S07
      ,S08
      ,S09
      ,S10
      ,S11
      ,S12
      ,S13
      ,S14
      ,S15
      ,S16
      ,S17
      ,S18
      ,S19
      ,S20
      ,NOTE
      ,FACT
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NUMSTR
      ,SENDERID
      ,SENDERRECORDID
      ,CODESTR30
      ,PROGRAMCODE
      ,ITEMCODE
      ,DESCRIPTIONCODE
      ,SUBKESR
      ,FINT6
      ,FINT7
      ,NOTE1
      ,NOTE2
      ,NOTE3
      ,NOTE4
      ,NOTE5
      ,NOTE6
      ,NOTE7
      ,NOTE8
      ,NOTE9
      ,NOTE10
      ,CURRENCYCLS
      ,OKATO
      ,CODEINT
      ,ROWORDER
      ,DIRECTIONCLS
      ,KD
      ,INNERFINSOURCE
      ,CLSTYPE
      ,S21
      ,S22
      ,S23
      ,S24
      ,S25
      ,S26
      ,S27
      ,S28
      ,S29
      ,S30
      ,S31
      ,S32
      ,S33
      ,S34
      ,S35
      ,S36
      ,S37
      ,S38
      ,S39
      ,S40
      ,FINT8
      ,FINT9
      ,FINT10
      ,NOTE11
      ,NOTE12
      ,NOTE13
      ,NOTE14
      ,NOTE15
      ,NOTE16
      ,NOTE17
      ,NOTE18
      ,NOTE19
      ,NOTE20
      ,DATE1
      ,DATE2
      ,DATE3
      ,DATE4
      ,DATE5
      ,DATE6
      ,DATE7
      ,DATE8
      ,DATE9
      ,DATE10
      ,PARENTINDEX
      ,TYPEDFORM
      ,RVERSION
      ,KFSRCODE
      ,KCSRCODE
      ,KVSRCODE
      ,KVRCODE
      ,KESRCODE
      ,SUBKESRCODE
      ,OKATOCODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.DETAILINDEX
      , :new.CODESTR
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.CODEROW
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.S00
      , :new.S01
      , :new.S02
      , :new.S03
      , :new.S04
      , :new.S05
      , :new.S06
      , :new.S07
      , :new.S08
      , :new.S09
      , :new.S10
      , :new.S11
      , :new.S12
      , :new.S13
      , :new.S14
      , :new.S15
      , :new.S16
      , :new.S17
      , :new.S18
      , :new.S19
      , :new.S20
      , :new.NOTE
      , :new.FACT
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NUMSTR
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CODESTR30
      , :new.PROGRAMCODE
      , :new.ITEMCODE
      , :new.DESCRIPTIONCODE
      , :new.SUBKESR
      , :new.FINT6
      , :new.FINT7
      , :new.NOTE1
      , :new.NOTE2
      , :new.NOTE3
      , :new.NOTE4
      , :new.NOTE5
      , :new.NOTE6
      , :new.NOTE7
      , :new.NOTE8
      , :new.NOTE9
      , :new.NOTE10
      , :new.CURRENCYCLS
      , :new.OKATO
      , :new.CODEINT
      , :new.ROWORDER
      , :new.DIRECTIONCLS
      , :new.KD
      , :new.INNERFINSOURCE
      , :new.CLSTYPE
      , :new.S21
      , :new.S22
      , :new.S23
      , :new.S24
      , :new.S25
      , :new.S26
      , :new.S27
      , :new.S28
      , :new.S29
      , :new.S30
      , :new.S31
      , :new.S32
      , :new.S33
      , :new.S34
      , :new.S35
      , :new.S36
      , :new.S37
      , :new.S38
      , :new.S39
      , :new.S40
      , :new.FINT8
      , :new.FINT9
      , :new.FINT10
      , :new.NOTE11
      , :new.NOTE12
      , :new.NOTE13
      , :new.NOTE14
      , :new.NOTE15
      , :new.NOTE16
      , :new.NOTE17
      , :new.NOTE18
      , :new.NOTE19
      , :new.NOTE20
      , :new.DATE1
      , :new.DATE2
      , :new.DATE3
      , :new.DATE4
      , :new.DATE5
      , :new.DATE6
      , :new.DATE7
      , :new.DATE8
      , :new.DATE9
      , :new.DATE10
      , :new.PARENTINDEX
      , :new.TYPEDFORM
      , :new.RVERSION
      , :new.KFSRCODE
      , :new.KCSRCODE
      , :new.KVSRCODE
      , :new.KVRCODE
      , :new.KESRCODE
      , :new.SUBKESRCODE
      , :new.OKATOCODE
    );
  else 
    update A_UTYPEDFORMSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDFORMSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,DETAILINDEX
      ,CODESTR
      ,KFSR
      ,KCSR
      ,KVSR
      ,KVR
      ,KESR
      ,CODEROW
      ,FINT1
      ,FINT2
      ,FINT3
      ,FINT4
      ,FINT5
      ,S00
      ,S01
      ,S02
      ,S03
      ,S04
      ,S05
      ,S06
      ,S07
      ,S08
      ,S09
      ,S10
      ,S11
      ,S12
      ,S13
      ,S14
      ,S15
      ,S16
      ,S17
      ,S18
      ,S19
      ,S20
      ,NOTE
      ,FACT
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,NUMSTR
      ,SENDERID
      ,SENDERRECORDID
      ,CODESTR30
      ,PROGRAMCODE
      ,ITEMCODE
      ,DESCRIPTIONCODE
      ,SUBKESR
      ,FINT6
      ,FINT7
      ,NOTE1
      ,NOTE2
      ,NOTE3
      ,NOTE4
      ,NOTE5
      ,NOTE6
      ,NOTE7
      ,NOTE8
      ,NOTE9
      ,NOTE10
      ,CURRENCYCLS
      ,OKATO
      ,CODEINT
      ,ROWORDER
      ,DIRECTIONCLS
      ,KD
      ,INNERFINSOURCE
      ,CLSTYPE
      ,S21
      ,S22
      ,S23
      ,S24
      ,S25
      ,S26
      ,S27
      ,S28
      ,S29
      ,S30
      ,S31
      ,S32
      ,S33
      ,S34
      ,S35
      ,S36
      ,S37
      ,S38
      ,S39
      ,S40
      ,FINT8
      ,FINT9
      ,FINT10
      ,NOTE11
      ,NOTE12
      ,NOTE13
      ,NOTE14
      ,NOTE15
      ,NOTE16
      ,NOTE17
      ,NOTE18
      ,NOTE19
      ,NOTE20
      ,DATE1
      ,DATE2
      ,DATE3
      ,DATE4
      ,DATE5
      ,DATE6
      ,DATE7
      ,DATE8
      ,DATE9
      ,DATE10
      ,PARENTINDEX
      ,TYPEDFORM
      ,RVERSION
      ,KFSRCODE
      ,KCSRCODE
      ,KVSRCODE
      ,KVRCODE
      ,KESRCODE
      ,SUBKESRCODE
      ,OKATOCODE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.DETAILINDEX
      , :new.CODESTR
      , :new.KFSR
      , :new.KCSR
      , :new.KVSR
      , :new.KVR
      , :new.KESR
      , :new.CODEROW
      , :new.FINT1
      , :new.FINT2
      , :new.FINT3
      , :new.FINT4
      , :new.FINT5
      , :new.S00
      , :new.S01
      , :new.S02
      , :new.S03
      , :new.S04
      , :new.S05
      , :new.S06
      , :new.S07
      , :new.S08
      , :new.S09
      , :new.S10
      , :new.S11
      , :new.S12
      , :new.S13
      , :new.S14
      , :new.S15
      , :new.S16
      , :new.S17
      , :new.S18
      , :new.S19
      , :new.S20
      , :new.NOTE
      , :new.FACT
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.NUMSTR
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CODESTR30
      , :new.PROGRAMCODE
      , :new.ITEMCODE
      , :new.DESCRIPTIONCODE
      , :new.SUBKESR
      , :new.FINT6
      , :new.FINT7
      , :new.NOTE1
      , :new.NOTE2
      , :new.NOTE3
      , :new.NOTE4
      , :new.NOTE5
      , :new.NOTE6
      , :new.NOTE7
      , :new.NOTE8
      , :new.NOTE9
      , :new.NOTE10
      , :new.CURRENCYCLS
      , :new.OKATO
      , :new.CODEINT
      , :new.ROWORDER
      , :new.DIRECTIONCLS
      , :new.KD
      , :new.INNERFINSOURCE
      , :new.CLSTYPE
      , :new.S21
      , :new.S22
      , :new.S23
      , :new.S24
      , :new.S25
      , :new.S26
      , :new.S27
      , :new.S28
      , :new.S29
      , :new.S30
      , :new.S31
      , :new.S32
      , :new.S33
      , :new.S34
      , :new.S35
      , :new.S36
      , :new.S37
      , :new.S38
      , :new.S39
      , :new.S40
      , :new.FINT8
      , :new.FINT9
      , :new.FINT10
      , :new.NOTE11
      , :new.NOTE12
      , :new.NOTE13
      , :new.NOTE14
      , :new.NOTE15
      , :new.NOTE16
      , :new.NOTE17
      , :new.NOTE18
      , :new.NOTE19
      , :new.NOTE20
      , :new.DATE1
      , :new.DATE2
      , :new.DATE3
      , :new.DATE4
      , :new.DATE5
      , :new.DATE6
      , :new.DATE7
      , :new.DATE8
      , :new.DATE9
      , :new.DATE10
      , :new.PARENTINDEX
      , :new.TYPEDFORM
      , :new.RVERSION
      , :new.KFSRCODE
      , :new.KCSRCODE
      , :new.KVSRCODE
      , :new.KVRCODE
      , :new.KESRCODE
      , :new.SUBKESRCODE
      , :new.OKATOCODE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDFORMSDETAIL
  AFTER DELETE
  ON UTYPEDFORMSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDFORMSPLACES
  AFTER INSERT
  ON UTYPEDFORMSPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACE_REF
      ,TYPEDFORM
      ,ORDERBY
      ,LEVELBY
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACE_REF
      , :new.TYPEDFORM
      , :new.ORDERBY
      , :new.LEVELBY
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDFORMSPLACES
  AFTER UPDATE
  ON UTYPEDFORMSPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDFORMSPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDFORMSPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACE_REF
      ,TYPEDFORM
      ,ORDERBY
      ,LEVELBY
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACE_REF
      , :new.TYPEDFORM
      , :new.ORDERBY
      , :new.LEVELBY
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  else 
    update A_UTYPEDFORMSPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDFORMSPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACE_REF
      ,TYPEDFORM
      ,ORDERBY
      ,LEVELBY
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACE_REF
      , :new.TYPEDFORM
      , :new.ORDERBY
      , :new.LEVELBY
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDFORMSPLACES
  AFTER DELETE
  ON UTYPEDFORMSPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDFORMSREGCAPTION
  AFTER INSERT
  ON UTYPEDFORMSREGCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSREGCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSREGCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UTFINDEX
      ,TEXTID
      ,MDKTEXTID
      ,ISCLIENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UTFINDEX
      , :new.TEXTID
      , :new.MDKTEXTID
      , :new.ISCLIENT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDFORMSREGCAPTION
  AFTER UPDATE
  ON UTYPEDFORMSREGCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDFORMSREGCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDFORMSREGCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSREGCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UTFINDEX
      ,TEXTID
      ,MDKTEXTID
      ,ISCLIENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UTFINDEX
      , :new.TEXTID
      , :new.MDKTEXTID
      , :new.ISCLIENT
    );
  else 
    update A_UTYPEDFORMSREGCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDFORMSREGCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UTFINDEX
      ,TEXTID
      ,MDKTEXTID
      ,ISCLIENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UTFINDEX
      , :new.TEXTID
      , :new.MDKTEXTID
      , :new.ISCLIENT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDFORMSREGCAPTION
  AFTER DELETE
  ON UTYPEDFORMSREGCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSREGCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDFORMSREGDETAIL
  AFTER INSERT
  ON UTYPEDFORMSREGDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSREGDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSREGDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,UTFRINDEX
      ,TYPEDFORM
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,REGTEXTID
      ,FORMTEXTID
      ,BEGINDATE
      ,ENDDATE
      ,ISCLIENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.UTFRINDEX
      , :new.TYPEDFORM
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.REGTEXTID
      , :new.FORMTEXTID
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.ISCLIENT
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDFORMSREGDETAIL
  AFTER UPDATE
  ON UTYPEDFORMSREGDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDFORMSREGDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDFORMSREGDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDFORMSREGDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,UTFRINDEX
      ,TYPEDFORM
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,REGTEXTID
      ,FORMTEXTID
      ,BEGINDATE
      ,ENDDATE
      ,ISCLIENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.UTFRINDEX
      , :new.TYPEDFORM
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.REGTEXTID
      , :new.FORMTEXTID
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.ISCLIENT
    );
  else 
    update A_UTYPEDFORMSREGDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDFORMSREGDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,UTFRINDEX
      ,TYPEDFORM
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,REGTEXTID
      ,FORMTEXTID
      ,BEGINDATE
      ,ENDDATE
      ,ISCLIENT
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.UTFRINDEX
      , :new.TYPEDFORM
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.REGTEXTID
      , :new.FORMTEXTID
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.ISCLIENT
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDFORMSREGDETAIL
  AFTER DELETE
  ON UTYPEDFORMSREGDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDFORMSREGDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDIMPORTREGISTRY
  AFTER INSERT
  ON UTYPEDIMPORTREGISTRY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDIMPORTREGISTRY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDIMPORTREGISTRY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NOTE
      ,FILESIZE
      ,FILENAME
      ,CRC32
      ,ISACTIVE
      ,PARAMS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.FILESIZE
      , :new.FILENAME
      , :new.CRC32
      , :new.ISACTIVE
      , :new.PARAMS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDIMPORTREGISTRY
  AFTER UPDATE
  ON UTYPEDIMPORTREGISTRY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDIMPORTREGISTRY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDIMPORTREGISTRY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDIMPORTREGISTRY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NOTE
      ,FILESIZE
      ,FILENAME
      ,CRC32
      ,ISACTIVE
      ,PARAMS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.FILESIZE
      , :new.FILENAME
      , :new.CRC32
      , :new.ISACTIVE
      , :new.PARAMS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_UTYPEDIMPORTREGISTRY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDIMPORTREGISTRY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NOTE
      ,FILESIZE
      ,FILENAME
      ,CRC32
      ,ISACTIVE
      ,PARAMS
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NOTE
      , :new.FILESIZE
      , :new.FILENAME
      , :new.CRC32
      , :new.ISACTIVE
      , :new.PARAMS
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDIMPORTREGISTRY
  AFTER DELETE
  ON UTYPEDIMPORTREGISTRY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDIMPORTREGISTRY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDPERIODCAPTION
  AFTER INSERT
  ON UTYPEDPERIODCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDPERIODCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDPERIODCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,REPORTDATE
      ,PERIOD
      ,REGULATIONDATE
      ,EXPIRYDATE
      ,BEGINDATE
      ,ENDDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.REPORTDATE
      , :new.PERIOD
      , :new.REGULATIONDATE
      , :new.EXPIRYDATE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDPERIODCAPTION
  AFTER UPDATE
  ON UTYPEDPERIODCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDPERIODCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDPERIODCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDPERIODCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,REPORTDATE
      ,PERIOD
      ,REGULATIONDATE
      ,EXPIRYDATE
      ,BEGINDATE
      ,ENDDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.REPORTDATE
      , :new.PERIOD
      , :new.REGULATIONDATE
      , :new.EXPIRYDATE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UTYPEDPERIODCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDPERIODCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,NAME
      ,ISCLIENT
      ,REPORTDATE
      ,PERIOD
      ,REGULATIONDATE
      ,EXPIRYDATE
      ,BEGINDATE
      ,ENDDATE
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.NAME
      , :new.ISCLIENT
      , :new.REPORTDATE
      , :new.PERIOD
      , :new.REGULATIONDATE
      , :new.EXPIRYDATE
      , :new.BEGINDATE
      , :new.ENDDATE
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDPERIODCAPTION
  AFTER DELETE
  ON UTYPEDPERIODCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDPERIODCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDPERIODDETAIL
  AFTER INSERT
  ON UTYPEDPERIODDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDPERIODDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDPERIODDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PERIODTEXTID
      ,REGTEXTID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PERIODTEXTID
      , :new.REGTEXTID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDPERIODDETAIL
  AFTER UPDATE
  ON UTYPEDPERIODDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDPERIODDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDPERIODDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDPERIODDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PERIODTEXTID
      ,REGTEXTID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PERIODTEXTID
      , :new.REGTEXTID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UTYPEDPERIODDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDPERIODDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,PERIODTEXTID
      ,REGTEXTID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.PERIODTEXTID
      , :new.REGTEXTID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDPERIODDETAIL
  AFTER DELETE
  ON UTYPEDPERIODDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDPERIODDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDSOURCESCAPTION
  AFTER INSERT
  ON UTYPEDSOURCESCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDSOURCESCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDSOURCESCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,KIND
      ,FILLINGTEXTID
      ,CHAINTEXTID
      ,PARENTFORMTEXTID
      ,CHILDFORMTEXTID
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.KIND
      , :new.FILLINGTEXTID
      , :new.CHAINTEXTID
      , :new.PARENTFORMTEXTID
      , :new.CHILDFORMTEXTID
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDSOURCESCAPTION
  AFTER UPDATE
  ON UTYPEDSOURCESCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDSOURCESCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDSOURCESCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDSOURCESCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,KIND
      ,FILLINGTEXTID
      ,CHAINTEXTID
      ,PARENTFORMTEXTID
      ,CHILDFORMTEXTID
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.KIND
      , :new.FILLINGTEXTID
      , :new.CHAINTEXTID
      , :new.PARENTFORMTEXTID
      , :new.CHILDFORMTEXTID
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UTYPEDSOURCESCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDSOURCESCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,TEXTID
      ,KIND
      ,FILLINGTEXTID
      ,CHAINTEXTID
      ,PARENTFORMTEXTID
      ,CHILDFORMTEXTID
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.TEXTID
      , :new.KIND
      , :new.FILLINGTEXTID
      , :new.CHAINTEXTID
      , :new.PARENTFORMTEXTID
      , :new.CHILDFORMTEXTID
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDSOURCESCAPTION
  AFTER DELETE
  ON UTYPEDSOURCESCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDSOURCESCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_UTYPEDSOURCESDETAIL
  AFTER INSERT
  ON UTYPEDSOURCESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDSOURCESDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDSOURCESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGTEXTID
      ,SOURCETEXTID
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGTEXTID
      , :new.SOURCETEXTID
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_UTYPEDSOURCESDETAIL
  AFTER UPDATE
  ON UTYPEDSOURCESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_UTYPEDSOURCESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_UTYPEDSOURCESDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_UTYPEDSOURCESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGTEXTID
      ,SOURCETEXTID
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGTEXTID
      , :new.SOURCETEXTID
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_UTYPEDSOURCESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_UTYPEDSOURCESDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,REGTEXTID
      ,SOURCETEXTID
      ,ISCLIENT
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.REGTEXTID
      , :new.SOURCETEXTID
      , :new.ISCLIENT
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_UTYPEDSOURCESDETAIL
  AFTER DELETE
  ON UTYPEDSOURCESDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_UTYPEDSOURCESDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_VALUECLS
  AFTER INSERT
  ON VALUECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VALUECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VALUECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_VALUECLS
  AFTER UPDATE
  ON VALUECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_VALUECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_VALUECLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VALUECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  else 
    update A_VALUECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_VALUECLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_VALUECLS
  AFTER DELETE
  ON VALUECLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VALUECLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_VARCHARCONST
  AFTER INSERT
  ON VARCHARCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VARCHARCONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VARCHARCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_VARCHARCONST
  AFTER UPDATE
  ON VARCHARCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_VARCHARCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_VARCHARCONST
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VARCHARCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  else 
    update A_VARCHARCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_VARCHARCONST (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,PROGINDEX
      ,CONSTINDEX
      ,CONSTVALUE
      ,NOTE
      ,ID
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EDITDOCCODE
      ,CLOSEDATE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.PROGINDEX
      , :new.CONSTINDEX
      , :new.CONSTVALUE
      , :new.NOTE
      , :new.ID
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EDITDOCCODE
      , :new.CLOSEDATE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_VARCHARCONST
  AFTER DELETE
  ON VARCHARCONST
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VARCHARCONST
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_VARIANTCLS
  AFTER INSERT
  ON VARIANTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VARIANTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VARIANTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NAME
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_VARIANTCLS
  AFTER UPDATE
  ON VARIANTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_VARIANTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_VARIANTCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VARIANTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NAME
    );
  else 
    update A_VARIANTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_VARIANTCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,CREATEDATE
      ,UPDATEDATE
      ,CREATERUSER
      ,UPDATERUSER
      ,NAME
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.NAME
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_VARIANTCLS
  AFTER DELETE
  ON VARIANTCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VARIANTCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_VZ_OFFSET
  AFTER INSERT
  ON VZ_OFFSET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VZ_OFFSET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VZ_OFFSET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_CONVENT
      ,NUM_DOCUMENT
      ,DOCTYPE
      ,DOCUMENTDATE
      ,BUILDDATE
      ,ACCEPTDATE
      ,NOTE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_CONVENT
      , :new.NUM_DOCUMENT
      , :new.DOCTYPE
      , :new.DOCUMENTDATE
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.NOTE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_VZ_OFFSET
  AFTER UPDATE
  ON VZ_OFFSET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_VZ_OFFSET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_VZ_OFFSET
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VZ_OFFSET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_CONVENT
      ,NUM_DOCUMENT
      ,DOCTYPE
      ,DOCUMENTDATE
      ,BUILDDATE
      ,ACCEPTDATE
      ,NOTE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_CONVENT
      , :new.NUM_DOCUMENT
      , :new.DOCTYPE
      , :new.DOCUMENTDATE
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.NOTE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_VZ_OFFSET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_VZ_OFFSET (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_CONVENT
      ,NUM_DOCUMENT
      ,DOCTYPE
      ,DOCUMENTDATE
      ,BUILDDATE
      ,ACCEPTDATE
      ,NOTE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_CONVENT
      , :new.NUM_DOCUMENT
      , :new.DOCTYPE
      , :new.DOCUMENTDATE
      , :new.BUILDDATE
      , :new.ACCEPTDATE
      , :new.NOTE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_VZ_OFFSET
  AFTER DELETE
  ON VZ_OFFSET
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VZ_OFFSET
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_VZFINCAPTION
  AFTER INSERT
  ON VZFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VZFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VZFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_CONVENT
      ,NUM_DOCUMENT
      ,ACCEPTDATE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_CONVENT
      , :new.NUM_DOCUMENT
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_VZFINCAPTION
  AFTER UPDATE
  ON VZFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_VZFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_VZFINCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_VZFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_CONVENT
      ,NUM_DOCUMENT
      ,ACCEPTDATE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_CONVENT
      , :new.NUM_DOCUMENT
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  else 
    update A_VZFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_VZFINCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NUM_CONVENT
      ,NUM_DOCUMENT
      ,ACCEPTDATE
      ,BUDGETREF
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NUM_CONVENT
      , :new.NUM_DOCUMENT
      , :new.ACCEPTDATE
      , :new.BUDGETREF
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_VZFINCAPTION
  AFTER DELETE
  ON VZFINCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_VZFINCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WORKPLACES
  AFTER INSERT
  ON WORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WORKPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,HIDETABS
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.HIDETABS
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WORKPLACES
  AFTER UPDATE
  ON WORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WORKPLACES
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,HIDETABS
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.HIDETABS
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_WORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WORKPLACES (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,HIDETABS
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.HIDETABS
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WORKPLACES
  AFTER DELETE
  ON WORKPLACES
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WORKPLACES
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WORKPLACES_INTERFACE
  AFTER INSERT
  ON WORKPLACES_INTERFACE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WORKPLACES_INTERFACE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WORKPLACES_INTERFACE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACES_REF
      ,INTERFACES_REF
      ,NOTE
      ,ORDERBY
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACES_REF
      , :new.INTERFACES_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WORKPLACES_INTERFACE
  AFTER UPDATE
  ON WORKPLACES_INTERFACE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WORKPLACES_INTERFACE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WORKPLACES_INTERFACE
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WORKPLACES_INTERFACE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACES_REF
      ,INTERFACES_REF
      ,NOTE
      ,ORDERBY
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACES_REF
      , :new.INTERFACES_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_WORKPLACES_INTERFACE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WORKPLACES_INTERFACE (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACES_REF
      ,INTERFACES_REF
      ,NOTE
      ,ORDERBY
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACES_REF
      , :new.INTERFACES_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WORKPLACES_INTERFACE
  AFTER DELETE
  ON WORKPLACES_INTERFACE
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WORKPLACES_INTERFACE
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WORKPLACES_NEWREPORTS
  AFTER INSERT
  ON WORKPLACES_NEWREPORTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WORKPLACES_NEWREPORTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WORKPLACES_NEWREPORTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACES_REF
      ,REPORTS_REF
      ,NOTE
      ,ORDERBY
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACES_REF
      , :new.REPORTS_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WORKPLACES_NEWREPORTS
  AFTER UPDATE
  ON WORKPLACES_NEWREPORTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WORKPLACES_NEWREPORTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WORKPLACES_NEWREPORTS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WORKPLACES_NEWREPORTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACES_REF
      ,REPORTS_REF
      ,NOTE
      ,ORDERBY
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACES_REF
      , :new.REPORTS_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  else 
    update A_WORKPLACES_NEWREPORTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WORKPLACES_NEWREPORTS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,WORKPLACES_REF
      ,REPORTS_REF
      ,NOTE
      ,ORDERBY
      ,UPDATEDATE
      ,CREATEDATE
      ,CREATERUSER
      ,UPDATERUSER
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.WORKPLACES_REF
      , :new.REPORTS_REF
      , :new.NOTE
      , :new.ORDERBY
      , :new.UPDATEDATE
      , :new.CREATEDATE
      , :new.CREATERUSER
      , :new.UPDATERUSER
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WORKPLACES_NEWREPORTS
  AFTER DELETE
  ON WORKPLACES_NEWREPORTS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WORKPLACES_NEWREPORTS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WRITEXECUTIONCAPTION
  AFTER INSERT
  ON WRITEXECUTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITEXECUTIONCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITEXECUTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DOCNUMBER
      ,ISSUEDATE
      ,LAWDEPARTMENTDATE
      ,LAWDEPARTMENTNUMBER
      ,NUMBERDOSSIER
      ,NAMEJUDICIALDECISION
      ,NAMEJUDICIALAGENCY
      ,LEVIERACC_REF
      ,LEVIERORG_REF
      ,WRITEXECUTIONTOTALSUMMA
      ,STARTDATE
      ,ENDDATE
      ,COUNTDAYDURING
      ,FACIALACC_CLS
      ,REJECT_CLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,PROGINDEX
      ,UNIQUENUMBER
      ,PRESENTDATE
      ,SHEETSCOUNT
      ,DELIVERYDATE
      ,COURTSHEETSCOUNT
      ,DEBTORNAME
      ,WRITTYPE
      ,WRITPERIOD
      ,ISINVALID
      ,CASECATEGORY
      ,INNERNUMBER
      ,LEVIERNAME
      ,NOTE
      ,NUMBERDEPARTMENTCB
      ,NAMEJUDICIALAGENCYREF
      ,JUDICIALDECISIONDATE
      ,NUMBERPOSTNOTICE
      ,COMPLETIONDATE
      ,DATEPOSTNOTICE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.ISSUEDATE
      , :new.LAWDEPARTMENTDATE
      , :new.LAWDEPARTMENTNUMBER
      , :new.NUMBERDOSSIER
      , :new.NAMEJUDICIALDECISION
      , :new.NAMEJUDICIALAGENCY
      , :new.LEVIERACC_REF
      , :new.LEVIERORG_REF
      , :new.WRITEXECUTIONTOTALSUMMA
      , :new.STARTDATE
      , :new.ENDDATE
      , :new.COUNTDAYDURING
      , :new.FACIALACC_CLS
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.PROGINDEX
      , :new.UNIQUENUMBER
      , :new.PRESENTDATE
      , :new.SHEETSCOUNT
      , :new.DELIVERYDATE
      , :new.COURTSHEETSCOUNT
      , :new.DEBTORNAME
      , :new.WRITTYPE
      , :new.WRITPERIOD
      , :new.ISINVALID
      , :new.CASECATEGORY
      , :new.INNERNUMBER
      , :new.LEVIERNAME
      , :new.NOTE
      , :new.NUMBERDEPARTMENTCB
      , :new.NAMEJUDICIALAGENCYREF
      , :new.JUDICIALDECISIONDATE
      , :new.NUMBERPOSTNOTICE
      , :new.COMPLETIONDATE
      , :new.DATEPOSTNOTICE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WRITEXECUTIONCAPTION
  AFTER UPDATE
  ON WRITEXECUTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WRITEXECUTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WRITEXECUTIONCAPTION
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITEXECUTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DOCNUMBER
      ,ISSUEDATE
      ,LAWDEPARTMENTDATE
      ,LAWDEPARTMENTNUMBER
      ,NUMBERDOSSIER
      ,NAMEJUDICIALDECISION
      ,NAMEJUDICIALAGENCY
      ,LEVIERACC_REF
      ,LEVIERORG_REF
      ,WRITEXECUTIONTOTALSUMMA
      ,STARTDATE
      ,ENDDATE
      ,COUNTDAYDURING
      ,FACIALACC_CLS
      ,REJECT_CLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,PROGINDEX
      ,UNIQUENUMBER
      ,PRESENTDATE
      ,SHEETSCOUNT
      ,DELIVERYDATE
      ,COURTSHEETSCOUNT
      ,DEBTORNAME
      ,WRITTYPE
      ,WRITPERIOD
      ,ISINVALID
      ,CASECATEGORY
      ,INNERNUMBER
      ,LEVIERNAME
      ,NOTE
      ,NUMBERDEPARTMENTCB
      ,NAMEJUDICIALAGENCYREF
      ,JUDICIALDECISIONDATE
      ,NUMBERPOSTNOTICE
      ,COMPLETIONDATE
      ,DATEPOSTNOTICE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.ISSUEDATE
      , :new.LAWDEPARTMENTDATE
      , :new.LAWDEPARTMENTNUMBER
      , :new.NUMBERDOSSIER
      , :new.NAMEJUDICIALDECISION
      , :new.NAMEJUDICIALAGENCY
      , :new.LEVIERACC_REF
      , :new.LEVIERORG_REF
      , :new.WRITEXECUTIONTOTALSUMMA
      , :new.STARTDATE
      , :new.ENDDATE
      , :new.COUNTDAYDURING
      , :new.FACIALACC_CLS
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.PROGINDEX
      , :new.UNIQUENUMBER
      , :new.PRESENTDATE
      , :new.SHEETSCOUNT
      , :new.DELIVERYDATE
      , :new.COURTSHEETSCOUNT
      , :new.DEBTORNAME
      , :new.WRITTYPE
      , :new.WRITPERIOD
      , :new.ISINVALID
      , :new.CASECATEGORY
      , :new.INNERNUMBER
      , :new.LEVIERNAME
      , :new.NOTE
      , :new.NUMBERDEPARTMENTCB
      , :new.NAMEJUDICIALAGENCYREF
      , :new.JUDICIALDECISIONDATE
      , :new.NUMBERPOSTNOTICE
      , :new.COMPLETIONDATE
      , :new.DATEPOSTNOTICE
    );
  else 
    update A_WRITEXECUTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WRITEXECUTIONCAPTION (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,DOCNUMBER
      ,ISSUEDATE
      ,LAWDEPARTMENTDATE
      ,LAWDEPARTMENTNUMBER
      ,NUMBERDOSSIER
      ,NAMEJUDICIALDECISION
      ,NAMEJUDICIALAGENCY
      ,LEVIERACC_REF
      ,LEVIERORG_REF
      ,WRITEXECUTIONTOTALSUMMA
      ,STARTDATE
      ,ENDDATE
      ,COUNTDAYDURING
      ,FACIALACC_CLS
      ,REJECT_CLS
      ,REJECTCAUSE
      ,SENDERID
      ,SENDERRECORDID
      ,DOCSTATEREF
      ,RVERSION
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,LASTEXTRCHANGE
      ,CRYPTOSTATUS
      ,PROGINDEX
      ,UNIQUENUMBER
      ,PRESENTDATE
      ,SHEETSCOUNT
      ,DELIVERYDATE
      ,COURTSHEETSCOUNT
      ,DEBTORNAME
      ,WRITTYPE
      ,WRITPERIOD
      ,ISINVALID
      ,CASECATEGORY
      ,INNERNUMBER
      ,LEVIERNAME
      ,NOTE
      ,NUMBERDEPARTMENTCB
      ,NAMEJUDICIALAGENCYREF
      ,JUDICIALDECISIONDATE
      ,NUMBERPOSTNOTICE
      ,COMPLETIONDATE
      ,DATEPOSTNOTICE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.DOCNUMBER
      , :new.ISSUEDATE
      , :new.LAWDEPARTMENTDATE
      , :new.LAWDEPARTMENTNUMBER
      , :new.NUMBERDOSSIER
      , :new.NAMEJUDICIALDECISION
      , :new.NAMEJUDICIALAGENCY
      , :new.LEVIERACC_REF
      , :new.LEVIERORG_REF
      , :new.WRITEXECUTIONTOTALSUMMA
      , :new.STARTDATE
      , :new.ENDDATE
      , :new.COUNTDAYDURING
      , :new.FACIALACC_CLS
      , :new.REJECT_CLS
      , :new.REJECTCAUSE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.DOCSTATEREF
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.LASTEXTRCHANGE
      , :new.CRYPTOSTATUS
      , :new.PROGINDEX
      , :new.UNIQUENUMBER
      , :new.PRESENTDATE
      , :new.SHEETSCOUNT
      , :new.DELIVERYDATE
      , :new.COURTSHEETSCOUNT
      , :new.DEBTORNAME
      , :new.WRITTYPE
      , :new.WRITPERIOD
      , :new.ISINVALID
      , :new.CASECATEGORY
      , :new.INNERNUMBER
      , :new.LEVIERNAME
      , :new.NOTE
      , :new.NUMBERDEPARTMENTCB
      , :new.NAMEJUDICIALAGENCYREF
      , :new.JUDICIALDECISIONDATE
      , :new.NUMBERPOSTNOTICE
      , :new.COMPLETIONDATE
      , :new.DATEPOSTNOTICE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WRITEXECUTIONCAPTION
  AFTER DELETE
  ON WRITEXECUTIONCAPTION
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITEXECUTIONCAPTION
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WRITEXECUTIONDETAIL
  AFTER INSERT
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITEXECUTIONDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITEXECUTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FACT
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,DOCTYPE
      ,SUBKESR
      ,PROMISE
      ,BUDGETPROMISE
      ,WRITEXECUTIONSUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EXECDOC
      ,PSCHEDULEREF
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,MONTHLYDATE
      ,QUARTERLYMONTHDAY
      ,QUARTERLYMONTHNUMBER
      ,PARENTID
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,INVESTOBJECT
      ,CLSTYPE
      ,KD
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FACT
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DOCTYPE
      , :new.SUBKESR
      , :new.PROMISE
      , :new.BUDGETPROMISE
      , :new.WRITEXECUTIONSUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EXECDOC
      , :new.PSCHEDULEREF
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.MONTHLYDATE
      , :new.QUARTERLYMONTHDAY
      , :new.QUARTERLYMONTHNUMBER
      , :new.PARENTID
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.INVESTOBJECT
      , :new.CLSTYPE
      , :new.KD
      , :new.NOTE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WRITEXECUTIONDETAIL
  AFTER UPDATE
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WRITEXECUTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WRITEXECUTIONDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITEXECUTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FACT
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,DOCTYPE
      ,SUBKESR
      ,PROMISE
      ,BUDGETPROMISE
      ,WRITEXECUTIONSUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EXECDOC
      ,PSCHEDULEREF
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,MONTHLYDATE
      ,QUARTERLYMONTHDAY
      ,QUARTERLYMONTHNUMBER
      ,PARENTID
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,INVESTOBJECT
      ,CLSTYPE
      ,KD
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FACT
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DOCTYPE
      , :new.SUBKESR
      , :new.PROMISE
      , :new.BUDGETPROMISE
      , :new.WRITEXECUTIONSUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EXECDOC
      , :new.PSCHEDULEREF
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.MONTHLYDATE
      , :new.QUARTERLYMONTHDAY
      , :new.QUARTERLYMONTHNUMBER
      , :new.PARENTID
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.INVESTOBJECT
      , :new.CLSTYPE
      , :new.KD
      , :new.NOTE
    );
  else 
    update A_WRITEXECUTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WRITEXECUTIONDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,BUDGETREF
      ,RECORDINDEX
      ,FACIALACC_CLS
      ,KVSR
      ,KFSR
      ,KCSR
      ,KVR
      ,KESR
      ,DIRECTIONCLS
      ,MEANSTYPE
      ,FACT
      ,REGIONCLS
      ,FINSOURCE
      ,FINTYPE
      ,DOCTYPE
      ,SUBKESR
      ,PROMISE
      ,BUDGETPROMISE
      ,WRITEXECUTIONSUMMA
      ,SENDERID
      ,SENDERRECORDID
      ,RVERSION
      ,PROGINDEX
      ,CREATERUSER
      ,CREATEDATE
      ,UPDATERUSER
      ,UPDATEDATE
      ,EXECDOC
      ,PSCHEDULEREF
      ,MONTH01
      ,MONTH02
      ,MONTH03
      ,MONTH04
      ,MONTH05
      ,MONTH06
      ,MONTH07
      ,MONTH08
      ,MONTH09
      ,MONTH10
      ,MONTH11
      ,MONTH12
      ,QUARTER1
      ,QUARTER2
      ,QUARTER3
      ,QUARTER4
      ,MONTHLYDATE
      ,QUARTERLYMONTHDAY
      ,QUARTERLYMONTHNUMBER
      ,PARENTID
      ,BUDALLOCATIONCLS
      ,PAYPROMISECLS
      ,TRANSFERTCLS
      ,SUBSIDYCLS
      ,INVESTOBJECT
      ,CLSTYPE
      ,KD
      ,NOTE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.BUDGETREF
      , :new.RECORDINDEX
      , :new.FACIALACC_CLS
      , :new.KVSR
      , :new.KFSR
      , :new.KCSR
      , :new.KVR
      , :new.KESR
      , :new.DIRECTIONCLS
      , :new.MEANSTYPE
      , :new.FACT
      , :new.REGIONCLS
      , :new.FINSOURCE
      , :new.FINTYPE
      , :new.DOCTYPE
      , :new.SUBKESR
      , :new.PROMISE
      , :new.BUDGETPROMISE
      , :new.WRITEXECUTIONSUMMA
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.RVERSION
      , :new.PROGINDEX
      , :new.CREATERUSER
      , :new.CREATEDATE
      , :new.UPDATERUSER
      , :new.UPDATEDATE
      , :new.EXECDOC
      , :new.PSCHEDULEREF
      , :new.MONTH01
      , :new.MONTH02
      , :new.MONTH03
      , :new.MONTH04
      , :new.MONTH05
      , :new.MONTH06
      , :new.MONTH07
      , :new.MONTH08
      , :new.MONTH09
      , :new.MONTH10
      , :new.MONTH11
      , :new.MONTH12
      , :new.QUARTER1
      , :new.QUARTER2
      , :new.QUARTER3
      , :new.QUARTER4
      , :new.MONTHLYDATE
      , :new.QUARTERLYMONTHDAY
      , :new.QUARTERLYMONTHNUMBER
      , :new.PARENTID
      , :new.BUDALLOCATIONCLS
      , :new.PAYPROMISECLS
      , :new.TRANSFERTCLS
      , :new.SUBSIDYCLS
      , :new.INVESTOBJECT
      , :new.CLSTYPE
      , :new.KD
      , :new.NOTE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WRITEXECUTIONDETAIL
  AFTER DELETE
  ON WRITEXECUTIONDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITEXECUTIONDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WRITEXECUTIONNOTIFY
  AFTER INSERT
  ON WRITEXECUTIONNOTIFY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITEXECUTIONNOTIFY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITEXECUTIONNOTIFY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTIFYCLS
      ,NOTE
      ,RECORDINDEX
      ,NOTIFYNUMBER
      ,NOTIFYDATE
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESCRIPTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTIFYCLS
      , :new.NOTE
      , :new.RECORDINDEX
      , :new.NOTIFYNUMBER
      , :new.NOTIFYDATE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESCRIPTION
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WRITEXECUTIONNOTIFY
  AFTER UPDATE
  ON WRITEXECUTIONNOTIFY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WRITEXECUTIONNOTIFY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WRITEXECUTIONNOTIFY
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITEXECUTIONNOTIFY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTIFYCLS
      ,NOTE
      ,RECORDINDEX
      ,NOTIFYNUMBER
      ,NOTIFYDATE
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESCRIPTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTIFYCLS
      , :new.NOTE
      , :new.RECORDINDEX
      , :new.NOTIFYNUMBER
      , :new.NOTIFYDATE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESCRIPTION
    );
  else 
    update A_WRITEXECUTIONNOTIFY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WRITEXECUTIONNOTIFY (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTIFYCLS
      ,NOTE
      ,RECORDINDEX
      ,NOTIFYNUMBER
      ,NOTIFYDATE
      ,SENDERID
      ,SENDERRECORDID
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,DESCRIPTION
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTIFYCLS
      , :new.NOTE
      , :new.RECORDINDEX
      , :new.NOTIFYNUMBER
      , :new.NOTIFYDATE
      , :new.SENDERID
      , :new.SENDERRECORDID
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.DESCRIPTION
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WRITEXECUTIONNOTIFY
  AFTER DELETE
  ON WRITEXECUTIONNOTIFY
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITEXECUTIONNOTIFY
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WRITNOTIFYCLS
  AFTER INSERT
  ON WRITNOTIFYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITNOTIFYCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITNOTIFYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,SHORTNAME
      ,NOTE
      ,STATEFILTER
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ALLOWDOCSTATES
      ,ALLOWWRITTYPES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTE
      , :new.STATEFILTER
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ALLOWDOCSTATES
      , :new.ALLOWWRITTYPES
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WRITNOTIFYCLS
  AFTER UPDATE
  ON WRITNOTIFYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WRITNOTIFYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WRITNOTIFYCLS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITNOTIFYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,SHORTNAME
      ,NOTE
      ,STATEFILTER
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ALLOWDOCSTATES
      ,ALLOWWRITTYPES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTE
      , :new.STATEFILTER
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ALLOWDOCSTATES
      , :new.ALLOWWRITTYPES
    );
  else 
    update A_WRITNOTIFYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WRITNOTIFYCLS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,SHORTNAME
      ,NOTE
      ,STATEFILTER
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ALLOWDOCSTATES
      ,ALLOWWRITTYPES
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTE
      , :new.STATEFILTER
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ALLOWDOCSTATES
      , :new.ALLOWWRITTYPES
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WRITNOTIFYCLS
  AFTER DELETE
  ON WRITNOTIFYCLS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITNOTIFYCLS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WRITNOTIFYCLSDETAIL
  AFTER INSERT
  ON WRITNOTIFYCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITNOTIFYCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITNOTIFYCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NOTIFYCLSPART
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ISSYSTEM
      ,ISREQUIRED
      ,ISVISIBLE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NOTIFYCLSPART
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ISSYSTEM
      , :new.ISREQUIRED
      , :new.ISVISIBLE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WRITNOTIFYCLSDETAIL
  AFTER UPDATE
  ON WRITNOTIFYCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WRITNOTIFYCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WRITNOTIFYCLSDETAIL
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITNOTIFYCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NOTIFYCLSPART
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ISSYSTEM
      ,ISREQUIRED
      ,ISVISIBLE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NOTIFYCLSPART
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ISSYSTEM
      , :new.ISREQUIRED
      , :new.ISVISIBLE
    );
  else 
    update A_WRITNOTIFYCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WRITNOTIFYCLSDETAIL (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,RECORDINDEX
      ,NOTIFYCLSPART
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,ISSYSTEM
      ,ISREQUIRED
      ,ISVISIBLE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.RECORDINDEX
      , :new.NOTIFYCLSPART
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.ISSYSTEM
      , :new.ISREQUIRED
      , :new.ISVISIBLE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WRITNOTIFYCLSDETAIL
  AFTER DELETE
  ON WRITNOTIFYCLSDETAIL
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITNOTIFYCLSDETAIL
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_WRITNOTIFYCLSPART
  AFTER INSERT
  ON WRITNOTIFYCLSPART
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITNOTIFYCLSPART
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITNOTIFYCLSPART (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,SHORTNAME
      ,NOTIFY_FIELDTYPE
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,HANDBOOKID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTIFY_FIELDTYPE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.HANDBOOKID
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_WRITNOTIFYCLSPART
  AFTER UPDATE
  ON WRITNOTIFYCLSPART
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_WRITNOTIFYCLSPART
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_WRITNOTIFYCLSPART
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_WRITNOTIFYCLSPART (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,SHORTNAME
      ,NOTIFY_FIELDTYPE
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,HANDBOOKID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTIFY_FIELDTYPE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.HANDBOOKID
    );
  else 
    update A_WRITNOTIFYCLSPART
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_WRITNOTIFYCLSPART (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NAME
      ,SHORTNAME
      ,NOTIFY_FIELDTYPE
      ,NOTE
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,HANDBOOKID
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NAME
      , :new.SHORTNAME
      , :new.NOTIFY_FIELDTYPE
      , :new.NOTE
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.HANDBOOKID
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_WRITNOTIFYCLSPART
  AFTER DELETE
  ON WRITNOTIFYCLSPART
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_WRITNOTIFYCLSPART
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

CREATE OR REPLACE TRIGGER ATI_YARDSTICKS
  AFTER INSERT
  ON YARDSTICKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_YARDSTICKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_YARDSTICKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATUS
      ,NAME
      ,CONDITIONREF
      ,YARDTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATUS
      , :new.NAME
      , :new.CONDITIONREF
      , :new.YARDTYPE
    );
END;
/

CREATE OR REPLACE TRIGGER ATU_YARDSTICKS
  AFTER UPDATE
  ON YARDSTICKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
  if (:new.ID != :old.ID) then
    update A_YARDSTICKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    update A_YARDSTICKS
    set
      oper_LastFlag = null
    where oper_LastFlag = 1
      and ID = :new.ID
    ;
    insert into A_YARDSTICKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATUS
      ,NAME
      ,CONDITIONREF
      ,YARDTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,0
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATUS
      , :new.NAME
      , :new.CONDITIONREF
      , :new.YARDTYPE
    );
  else 
    update A_YARDSTICKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 1,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
     , OPER_LastFlag = null
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
    insert into A_YARDSTICKS (
       OPER_BID
      ,OPER_EID
      ,OPER_BTYPE
      ,OPER_BDATE
      ,OPER_BUSER
      ,OPER_LASTFLAG
      ,ID
      ,NOTE
      ,WEBID
      ,RVERSION
      ,CREATERUSER
      ,UPDATERUSER
      ,CREATEDATE
      ,UPDATEDATE
      ,STATUS
      ,NAME
      ,CONDITIONREF
      ,YARDTYPE
    ) values ( 
       OPER_ID$
      ,2147483647
      ,1
      ,SYSDATE
      ,USER
      ,1

      , :new.ID
      , :new.NOTE
      , :new.WEBID
      , :new.RVERSION
      , :new.CREATERUSER
      , :new.UPDATERUSER
      , :new.CREATEDATE
      , :new.UPDATEDATE
      , :new.STATUS
      , :new.NAME
      , :new.CONDITIONREF
      , :new.YARDTYPE
    );
  end if; 
END;
/

CREATE OR REPLACE TRIGGER ATD_YARDSTICKS
  AFTER DELETE
  ON YARDSTICKS
  FOR EACH ROW
DECLARE
  OPER_ID$ number(10);
BEGIN
    select g_audit.nextval into OPER_ID$ from dual;
    update A_YARDSTICKS
    set
      OPER_EID = oper_id$,
      OPER_ETYPE = 2,
      OPER_EUSER = user,
      OPER_EDATE = sysdate
    where OPER_LastFlag = 1
      and ID = :old.ID
    ;
END;
/

SPOOL OFF

exit
