SPOOL Synchronize.lst
WHENEVER SQLERROR EXIT FAILURE ROLLBACK
WHENEVER OSERROR EXIT FAILURE ROLLBACK

ALTER SESSION SET NLS_DATE_FORMAT='DD.MM.YYYY HH24:MI:SS'
/

create or replace package PKG_AUDIT_TEMP is
  MaxInt$ NUMBER(10) := 2147483647;
  OperDate$ DATE;
  OperId$ NUMBER(10);
  procedure Init(AOperId NUMBER DEFAULT NULL, AOperDate DATE DEFAULT SysDate);
  function OperDate return DATE;
  function OperId return NUMBER;
  function MaxInt return NUMBER;
end PKG_AUDIT_TEMP;
/

create or replace package body PKG_AUDIT_TEMP is
  procedure Init(AOperId NUMBER DEFAULT NULL, AOperDate DATE DEFAULT SysDate) is
  begin
    OperDate$ := AOperDate;
    if AOperId is NULL then
      select g_audit.nextval into OperId$ from dual;
    else
      OperId$ := AOperId;
    end if;
  end Init;
  function OperDate return DATE is
  begin
    return OperDate$;
  end OperDate;
  function OperId return NUMBER is
  begin
    return OperId$;
  end OperId;
  function MaxInt return NUMBER is
  begin
    return MaxInt$;
  end MaxInt;
end PKG_AUDIT_TEMP;
/

begin
  PKG_AUDIT_TEMP.Init;
end;
/


-- A_ACC_CLS

update A_ACC_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ACC_CLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ACC_CLS)
/

update A_ACC_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME
   from ACC_CLS
   where (ID) in (select ID from A_ACC_CLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME
   from A_ACC_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ACC_CLS (ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ACC_CLS
   where (ID) in (select ID from A_ACC_CLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ACC_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ACC_CLS (ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,SERVICETYPE,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ACC_CLS
where (ID) in
    (select ID from ACC_CLS
     MINUS
     select ID from A_ACC_CLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ACCCUROPERATION

update A_ACCCUROPERATION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ACCCUROPERATION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ACCCUROPERATION)
/

update A_ACCCUROPERATION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from ACCCUROPERATION
   where (ID) in (select ID from A_ACCCUROPERATION))
  MINUS
  (select ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_ACCCUROPERATION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ACCCUROPERATION (ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ACCCUROPERATION
   where (ID) in (select ID from A_ACCCUROPERATION))
  MINUS
  (select ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ACCCUROPERATION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ACCCUROPERATION (ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CURRENCY,EXCHANGE,OPERATION,CURSUMMA,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ACCCUROPERATION
where (ID) in
    (select ID from ACCCUROPERATION
     MINUS
     select ID from A_ACCCUROPERATION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ACCOUNTPLAN

update A_ACCOUNTPLAN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ACCOUNTPLAN
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ACCOUNTPLAN)
/

update A_ACCOUNTPLAN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE
   from ACCOUNTPLAN
   where (ID) in (select ID from A_ACCOUNTPLAN))
  MINUS
  (select ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE
   from A_ACCOUNTPLAN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ACCOUNTPLAN (ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ACCOUNTPLAN
   where (ID) in (select ID from A_ACCOUNTPLAN))
  MINUS
  (select ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ACCOUNTPLAN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ACCOUNTPLAN (ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,STATE,CODE1,CODE2,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ACCOUNTPLAN
where (ID) in
    (select ID from ACCOUNTPLAN
     MINUS
     select ID from A_ACCOUNTPLAN
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ACCOUNTSCONFORMITY

update A_ACCOUNTSCONFORMITY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ACCOUNTSCONFORMITY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ACCOUNTSCONFORMITY)
/

update A_ACCOUNTSCONFORMITY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS
   from ACCOUNTSCONFORMITY
   where (ID) in (select ID from A_ACCOUNTSCONFORMITY))
  MINUS
  (select ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS
   from A_ACCOUNTSCONFORMITY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ACCOUNTSCONFORMITY (ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ACCOUNTSCONFORMITY
   where (ID) in (select ID from A_ACCOUNTSCONFORMITY))
  MINUS
  (select ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ACCOUNTSCONFORMITY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ACCOUNTSCONFORMITY (ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCOUNT15N,ACCOUNT70N,BALANCECLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ACCOUNTSCONFORMITY
where (ID) in
    (select ID from ACCOUNTSCONFORMITY
     MINUS
     select ID from A_ACCOUNTSCONFORMITY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ACCOUNTSCORR

update A_ACCOUNTSCORR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ACCOUNTSCORR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ACCOUNTSCORR)
/

update A_ACCOUNTSCORR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE
   from ACCOUNTSCORR
   where (ID) in (select ID from A_ACCOUNTSCORR))
  MINUS
  (select ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE
   from A_ACCOUNTSCORR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ACCOUNTSCORR (ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ACCOUNTSCORR
   where (ID) in (select ID from A_ACCOUNTSCORR))
  MINUS
  (select ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ACCOUNTSCORR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ACCOUNTSCORR (ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DEBIT,CREDIT,NOTE,BUHOPERATIONID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ACCOUNTSCORR
where (ID) in
    (select ID from ACCOUNTSCORR
     MINUS
     select ID from A_ACCOUNTSCORR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ACCSOPERTITLE

update A_ACCSOPERTITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ACCSOPERTITLE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ACCSOPERTITLE)
/

update A_ACCSOPERTITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from ACCSOPERTITLE
   where (ID) in (select ID from A_ACCSOPERTITLE))
  MINUS
  (select ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_ACCSOPERTITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ACCSOPERTITLE (ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ACCSOPERTITLE
   where (ID) in (select ID from A_ACCSOPERTITLE))
  MINUS
  (select ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ACCSOPERTITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ACCSOPERTITLE (ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCNUMBER,NOTE,BUDGETREF,BUILDDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ACCSOPERTITLE
where (ID) in
    (select ID from ACCSOPERTITLE
     MINUS
     select ID from A_ACCSOPERTITLE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ADMISSION

update A_ADMISSION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ADMISSION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ADMISSION)
/

update A_ADMISSION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR
   from ADMISSION
   where (ID) in (select ID from A_ADMISSION))
  MINUS
  (select ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR
   from A_ADMISSION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ADMISSION (ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ADMISSION
   where (ID) in (select ID from A_ADMISSION))
  MINUS
  (select ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ADMISSION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ADMISSION (ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDREF,BUDSOURCE,BUDDEST,DAT,SUMMA,ACC,FLAG,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTYPE,KD,SUBKD,GOSNI,FACIALACC_CLS,MEANSTYPE,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,FINTYPE,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ADMISSION
where (ID) in
    (select ID from ADMISSION
     MINUS
     select ID from A_ADMISSION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_AGREEMENTSTEPS

update A_AGREEMENTSTEPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_AGREEMENTSTEPS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from AGREEMENTSTEPS)
/

update A_AGREEMENTSTEPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY
   from AGREEMENTSTEPS
   where (ID) in (select ID from A_AGREEMENTSTEPS))
  MINUS
  (select ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY
   from A_AGREEMENTSTEPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_AGREEMENTSTEPS (ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from AGREEMENTSTEPS
   where (ID) in (select ID from A_AGREEMENTSTEPS))
  MINUS
  (select ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_AGREEMENTSTEPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_AGREEMENTSTEPS (ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ANUMBER,BEGINSTEPDATE,ENDSTEPDATE,SUMMA,NOTE,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,CLOSEDOC,STEPSUMMA,STEPFINSUMMA,SENDERID,SENDERRECORDID,RECORDINDEX,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from AGREEMENTSTEPS
where (ID) in
    (select ID from AGREEMENTSTEPS
     MINUS
     select ID from A_AGREEMENTSTEPS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ALLOWANCEDETAIL

update A_ALLOWANCEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ALLOWANCEDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ALLOWANCEDETAIL)
/

update A_ALLOWANCEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE
   from ALLOWANCEDETAIL
   where (ID) in (select ID from A_ALLOWANCEDETAIL))
  MINUS
  (select ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE
   from A_ALLOWANCEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ALLOWANCEDETAIL (ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ALLOWANCEDETAIL
   where (ID) in (select ID from A_ALLOWANCEDETAIL))
  MINUS
  (select ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ALLOWANCEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ALLOWANCEDETAIL (ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,NPACODE,NPANUMBER,NPADATE,NPANAME,NPACOMMENCEMENTDATE,NPADURATION,PROGINDEX,CLSTYPE,FUNDSSOURCE,KD,KVSR,KFSR,KESR,KVR,KCSR,MEANSTYPE,FACT,NOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RVERSION,LINENUMBER,PARENTID,OPERATION,NPADESCRIPTION,BEGINDATE,ENDDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ALLOWANCEDETAIL
where (ID) in
    (select ID from ALLOWANCEDETAIL
     MINUS
     select ID from A_ALLOWANCEDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ANALYTICALGROUPIFS

update A_ANALYTICALGROUPIFS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ANALYTICALGROUPIFS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ANALYTICALGROUPIFS)
/

update A_ANALYTICALGROUPIFS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE
   from ANALYTICALGROUPIFS
   where (ID) in (select ID from A_ANALYTICALGROUPIFS))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE
   from A_ANALYTICALGROUPIFS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ANALYTICALGROUPIFS (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ANALYTICALGROUPIFS
   where (ID) in (select ID from A_ANALYTICALGROUPIFS))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ANALYTICALGROUPIFS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ANALYTICALGROUPIFS (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ANALYTICALGROUPIFS
where (ID) in
    (select ID from ANALYTICALGROUPIFS
     MINUS
     select ID from A_ANALYTICALGROUPIFS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ANALYTICALGROUPKD

update A_ANALYTICALGROUPKD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ANALYTICALGROUPKD
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ANALYTICALGROUPKD)
/

update A_ANALYTICALGROUPKD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE
   from ANALYTICALGROUPKD
   where (ID) in (select ID from A_ANALYTICALGROUPKD))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE
   from A_ANALYTICALGROUPKD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ANALYTICALGROUPKD (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ANALYTICALGROUPKD
   where (ID) in (select ID from A_ANALYTICALGROUPKD))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ANALYTICALGROUPKD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ANALYTICALGROUPKD (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ANALYTICALGROUPKD
where (ID) in
    (select ID from ANALYTICALGROUPKD
     MINUS
     select ID from A_ANALYTICALGROUPKD
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ARCHIVEDOCPARAMS

update A_ARCHIVEDOCPARAMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ARCHIVEDOCPARAMS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ARCHIVEDOCPARAMS)
/

update A_ARCHIVEDOCPARAMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR
   from ARCHIVEDOCPARAMS
   where (ID) in (select ID from A_ARCHIVEDOCPARAMS))
  MINUS
  (select ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR
   from A_ARCHIVEDOCPARAMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ARCHIVEDOCPARAMS (ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ARCHIVEDOCPARAMS
   where (ID) in (select ID from A_ARCHIVEDOCPARAMS))
  MINUS
  (select ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ARCHIVEDOCPARAMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ARCHIVEDOCPARAMS (ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,NAME,STORAGENAME,NOTE,PARAMTYPE,PARAMSIZE,CLSTYPE,GROUPNAME,PARAMORDER,HINT,PICKLIST,REQUIREDATTR,KEYATTR,READONLYATTR,HIDDENATTR,FIXEDATTR,CLOSEDATTR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,VALUEATTR,MAPPINGATTR,BANMLTATTR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ARCHIVEDOCPARAMS
where (ID) in
    (select ID from ARCHIVEDOCPARAMS
     MINUS
     select ID from A_ARCHIVEDOCPARAMS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ARCHIVEDOCTYPE

update A_ARCHIVEDOCTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ARCHIVEDOCTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ARCHIVEDOCTYPE)
/

update A_ARCHIVEDOCTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK
   from ARCHIVEDOCTYPE
   where (ID) in (select ID from A_ARCHIVEDOCTYPE))
  MINUS
  (select ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK
   from A_ARCHIVEDOCTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ARCHIVEDOCTYPE (ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ARCHIVEDOCTYPE
   where (ID) in (select ID from A_ARCHIVEDOCTYPE))
  MINUS
  (select ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ARCHIVEDOCTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ARCHIVEDOCTYPE (ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,TEMPLATECODE,TEMPLATETYPE,PERIODTYPE,SECTIONTYPE,CONSTRAINTSCRIPTNAME,CREATINGSCRIPTNAME,BEGINDATE,ENDDATE,SIGNSCHEME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ENABLEDIMPORTKINDS,LIMITPARAMS,DYNSETNAME,STORETOLINK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ARCHIVEDOCTYPE
where (ID) in
    (select ID from ARCHIVEDOCTYPE
     MINUS
     select ID from A_ARCHIVEDOCTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ARCHIVEOPLOG

update A_ARCHIVEOPLOG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ARCHIVEOPLOG
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ARCHIVEOPLOG)
/

update A_ARCHIVEOPLOG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO
   from ARCHIVEOPLOG
   where (ID) in (select ID from A_ARCHIVEOPLOG))
  MINUS
  (select ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO
   from A_ARCHIVEOPLOG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ARCHIVEOPLOG (ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ARCHIVEOPLOG
   where (ID) in (select ID from A_ARCHIVEOPLOG))
  MINUS
  (select ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ARCHIVEOPLOG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ARCHIVEOPLOG (ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DATAPACKETREF,DOCSTATEREF,OPTYPE,CREATEDATE,CREATERUSER,CREATERINFO,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ARCHIVEOPLOG
where (ID) in
    (select ID from ARCHIVEOPLOG
     MINUS
     select ID from A_ARCHIVEOPLOG
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ASSIGNMENTKIND

update A_ASSIGNMENTKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ASSIGNMENTKIND
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ASSIGNMENTKIND)
/

update A_ASSIGNMENTKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from ASSIGNMENTKIND
   where (ID) in (select ID from A_ASSIGNMENTKIND))
  MINUS
  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_ASSIGNMENTKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ASSIGNMENTKIND (ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ASSIGNMENTKIND
   where (ID) in (select ID from A_ASSIGNMENTKIND))
  MINUS
  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ASSIGNMENTKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ASSIGNMENTKIND (ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,UNRESTRICTED,NAME,STARTDATE,DELETEDATE,MARK,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ASSIGNMENTKIND
where (ID) in
    (select ID from ASSIGNMENTKIND
     MINUS
     select ID from A_ASSIGNMENTKIND
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ASSIGNMENTSOURCE

update A_ASSIGNMENTSOURCE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ASSIGNMENTSOURCE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ASSIGNMENTSOURCE)
/

update A_ASSIGNMENTSOURCE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK
   from ASSIGNMENTSOURCE
   where (ID) in (select ID from A_ASSIGNMENTSOURCE))
  MINUS
  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK
   from A_ASSIGNMENTSOURCE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ASSIGNMENTSOURCE (ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ASSIGNMENTSOURCE
   where (ID) in (select ID from A_ASSIGNMENTSOURCE))
  MINUS
  (select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ASSIGNMENTSOURCE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ASSIGNMENTSOURCE (ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NAME,STARTDATE,DELETEDATE,MARK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ASSIGNMENTSOURCE
where (ID) in
    (select ID from ASSIGNMENTSOURCE
     MINUS
     select ID from A_ASSIGNMENTSOURCE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_AUTOSANCTIONDATA

update A_AUTOSANCTIONDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_AUTOSANCTIONDATA
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from AUTOSANCTIONDATA)
/

update A_AUTOSANCTIONDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE
   from AUTOSANCTIONDATA
   where (ID) in (select ID from A_AUTOSANCTIONDATA))
  MINUS
  (select ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE
   from A_AUTOSANCTIONDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_AUTOSANCTIONDATA (ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from AUTOSANCTIONDATA
   where (ID) in (select ID from A_AUTOSANCTIONDATA))
  MINUS
  (select ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_AUTOSANCTIONDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_AUTOSANCTIONDATA (ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CODE,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,KCSR,KVSR,KVR,KESR,KD,IFS,TAXNOTE,AUTOSANCTION,ACC,NOTE,CLSTYPE,BUDGETREF,DOCTYPE,STARTDATE,DELETEDATE,PROMISE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from AUTOSANCTIONDATA
where (ID) in
    (select ID from AUTOSANCTIONDATA
     MINUS
     select ID from A_AUTOSANCTIONDATA
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BALANCECLS

update A_BALANCECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BALANCECLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BALANCECLS)
/

update A_BALANCECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME
   from BALANCECLS
   where (ID) in (select ID from A_BALANCECLS))
  MINUS
  (select ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME
   from A_BALANCECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BALANCECLS (ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BALANCECLS
   where (ID) in (select ID from A_BALANCECLS))
  MINUS
  (select ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BALANCECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BALANCECLS (ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SHORTNAME,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BALANCECLS
where (ID) in
    (select ID from BALANCECLS
     MINUS
     select ID from A_BALANCECLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_CLSREPLACEMENT

update A_BANKEXCH_CLSREPLACEMENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_CLSREPLACEMENT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_CLSREPLACEMENT)
/

update A_BANKEXCH_CLSREPLACEMENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN
   from BANKEXCH_CLSREPLACEMENT
   where (ID) in (select ID from A_BANKEXCH_CLSREPLACEMENT))
  MINUS
  (select ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN
   from A_BANKEXCH_CLSREPLACEMENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_CLSREPLACEMENT (ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_CLSREPLACEMENT
   where (ID) in (select ID from A_BANKEXCH_CLSREPLACEMENT))
  MINUS
  (select ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_CLSREPLACEMENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_CLSREPLACEMENT (ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,DESTNOTE,DESTKD,DESTSUBKD,DESTREGION,DESTGOSNI,DESTFACIALACC_CLS,DESTMEANSTYPE,DESTDOCTYPE,DESTFINTYPE,BUHPAYMENTCLS,DFACCOUNT,PROCDOCCLASS,SOURCEINN,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_CLSREPLACEMENT
where (ID) in
    (select ID from BANKEXCH_CLSREPLACEMENT
     MINUS
     select ID from A_BANKEXCH_CLSREPLACEMENT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_CONFIRM

update A_BANKEXCH_CONFIRM set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_CONFIRM
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_CONFIRM)
/

update A_BANKEXCH_CONFIRM set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT
   from BANKEXCH_CONFIRM
   where (ID) in (select ID from A_BANKEXCH_CONFIRM))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT
   from A_BANKEXCH_CONFIRM
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_CONFIRM (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_CONFIRM
   where (ID) in (select ID from A_BANKEXCH_CONFIRM))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_CONFIRM
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_CONFIRM (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,ND,DAV,PRNUM,ELNUM,VO,MFKB,LSKL,MF,LSKOR,SU,KRKB,KR,SS,EXTENSION,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_CONFIRM
where (ID) in
    (select ID from BANKEXCH_CONFIRM
     MINUS
     select ID from A_BANKEXCH_CONFIRM
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_KO_SALDO

update A_BANKEXCH_KO_SALDO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_KO_SALDO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_KO_SALDO)
/

update A_BANKEXCH_KO_SALDO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION
   from BANKEXCH_KO_SALDO
   where (ID) in (select ID from A_BANKEXCH_KO_SALDO))
  MINUS
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION
   from A_BANKEXCH_KO_SALDO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_KO_SALDO (ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_KO_SALDO
   where (ID) in (select ID from A_BANKEXCH_KO_SALDO))
  MINUS
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_KO_SALDO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_KO_SALDO (ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LS,DT,KT,IXSP,IXSA,VXSP,VXSA,DF,T_CLOCK,SENDER,D_LAST,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,INREST,SUBSIDYDAY,OTHERSUMDAY,PAYMENTSUM,UNKNOWNSUM,REESTRSUM,OUTREST,INACCREST,OUTACCREST,INACC,OUTACC,ABSTRACTKIND,INQUIRYSESSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_KO_SALDO
where (ID) in
    (select ID from BANKEXCH_KO_SALDO
     MINUS
     select ID from A_BANKEXCH_KO_SALDO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_LS_KB

update A_BANKEXCH_LS_KB set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_LS_KB
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_LS_KB)
/

update A_BANKEXCH_LS_KB set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION
   from BANKEXCH_LS_KB
   where (ID) in (select ID from A_BANKEXCH_LS_KB))
  MINUS
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION
   from A_BANKEXCH_LS_KB
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_LS_KB (ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_LS_KB
   where (ID) in (select ID from A_BANKEXCH_LS_KB))
  MINUS
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_LS_KB
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_LS_KB (ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AUTOPROCESSING,PROCESSING,PROCNOTE,SU,ND,MF,MFKB,LSK,LSD,KRSKB,DK,NA,VO,ELNUM,DVV,INNMFKB,INNMF,MFKBFIL,MFFIL,LSKL,LSKOR,PFA,T_EVENT,SENDER,CODEFORMAT,PD_REF,PACKETNUMBER,ELPACKETNUMBER,ABSTRACTKIND,INQUIRYSESSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_LS_KB
where (ID) in
    (select ID from BANKEXCH_LS_KB
     MINUS
     select ID from A_BANKEXCH_LS_KB
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_MERDOC

update A_BANKEXCH_MERDOC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_MERDOC
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_MERDOC)
/

update A_BANKEXCH_MERDOC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE
   from BANKEXCH_MERDOC
   where (ID) in (select ID from A_BANKEXCH_MERDOC))
  MINUS
  (select ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE
   from A_BANKEXCH_MERDOC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_MERDOC (ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_MERDOC
   where (ID) in (select ID from A_BANKEXCH_MERDOC))
  MINUS
  (select ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_MERDOC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_MERDOC (ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GETDATE,PROCESSING,AUTOPROCESSING,NOTE,PAYERKPP,PAYERNAME,KD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,DK,VO,MFKB,LSKL,NAMKL,MF,LSKOR,NAMKOR,SU,NKOR1,NKOR2,NKOR3,NKOR4,PAROL,SS,KRKB,INNMFKB,MFKBFIL,KR,INNMF,MFFIL,DFA,NA,T_CLOCK,PR_DOC,DPLAT,SUB_ID,ELNUMS,LS_ERR,SENDER,APRIOR,PAYKIND,IMPORTDOCREF,PRNUM,KPPA,KPPB,DPPL,DKART,DSPL,D_OTMET,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,TAXNOTE,CODEFORMAT,PRINTED,SOP,NOTINCOME,UFK_PRIM,PROCDOCCLASS,PROCUSEINFO,CODBCLAS,ND,PACKETNUMBER,ELPACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,SOURCEBANKNAME,DESTBANKNAME,DOCUMENTNAME,SOURCEFACIALCODE,DESTFACIALCODE,SOURCEINN,DESTINN,ELNUM,EXTPAYID,KOD_IST,DEPARTMENTCLS,PROCNOTE,UINCODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_MERDOC
where (ID) in
    (select ID from BANKEXCH_MERDOC
     MINUS
     select ID from A_BANKEXCH_MERDOC
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_MERKWI

update A_BANKEXCH_MERKWI set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_MERKWI
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_MERKWI)
/

update A_BANKEXCH_MERKWI set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT
   from BANKEXCH_MERKWI
   where (ID) in (select ID from A_BANKEXCH_MERKWI))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT
   from A_BANKEXCH_MERKWI
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_MERKWI (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_MERKWI
   where (ID) in (select ID from A_BANKEXCH_MERKWI))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_MERKWI
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_MERKWI (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,MFA,MFB,IDA,IDB,SUM_,COUNT_,NAMPOST,DW2,T_CLOCK,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_MERKWI
where (ID) in
    (select ID from BANKEXCH_MERKWI
     MINUS
     select ID from A_BANKEXCH_MERKWI
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_POST

update A_BANKEXCH_POST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_POST
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_POST)
/

update A_BANKEXCH_POST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT
   from BANKEXCH_POST
   where (ID) in (select ID from A_BANKEXCH_POST))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT
   from A_BANKEXCH_POST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_POST (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_POST
   where (ID) in (select ID from A_BANKEXCH_POST))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_POST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_POST (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DO_,TO_,NAMPOST,SUM_,COUNT_,SUM_P,COUNT_P,ZSUM,ZCOUNT,SENDER,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_POST
where (ID) in
    (select ID from BANKEXCH_POST
     MINUS
     select ID from A_BANKEXCH_POST
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_QUERY

update A_BANKEXCH_QUERY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_QUERY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_QUERY)
/

update A_BANKEXCH_QUERY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT
   from BANKEXCH_QUERY
   where (ID) in (select ID from A_BANKEXCH_QUERY))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT
   from A_BANKEXCH_QUERY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_QUERY (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_QUERY
   where (ID) in (select ID from A_BANKEXCH_QUERY))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_QUERY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_QUERY (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,COD_QU,DD,DV,ND,SUM_,ELNUM,MFA,LSKL,MFB,LSKOR,SENDER,ELNUMREF,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_QUERY
where (ID) in
    (select ID from BANKEXCH_QUERY
     MINUS
     select ID from A_BANKEXCH_QUERY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_QUEUE

update A_BANKEXCH_QUEUE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_QUEUE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_QUEUE)
/

update A_BANKEXCH_QUEUE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT
   from BANKEXCH_QUEUE
   where (ID) in (select ID from A_BANKEXCH_QUEUE))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT
   from A_BANKEXCH_QUEUE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_QUEUE (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_QUEUE
   where (ID) in (select ID from A_BANKEXCH_QUEUE))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_QUEUE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_QUEUE (ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,T_EVENT,SENDER,APRIOR,CODEFORMAT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_QUEUE
where (ID) in
    (select ID from BANKEXCH_QUEUE
     MINUS
     select ID from A_BANKEXCH_QUEUE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_REOUT

update A_BANKEXCH_REOUT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_REOUT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_REOUT)
/

update A_BANKEXCH_REOUT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS
   from BANKEXCH_REOUT
   where (ID) in (select ID from A_BANKEXCH_REOUT))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS
   from A_BANKEXCH_REOUT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_REOUT (ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_REOUT
   where (ID) in (select ID from A_BANKEXCH_REOUT))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_REOUT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_REOUT (ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DVV,DD,DV,DAV,ND,DK,ELNUM,VO,MFKB,LSKL,KRKB,MF,LSKOR,KR,SU,SS,DFA,NA,TYP_DOC,PR_DOC,T_EVENT,SENDER,KPPA,KPPB,DPPL,DKART,DSPL,SSTATUS,CODOKATO,NALPLAT,NALPER,NDNAL,DDNAL,TYPNAL,SU_OST,N_CH_PL,D_PL,SHIFR,N_PLDOK,D_OTMET,CODEFORMAT,SOP,CODBCLAS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_REOUT
where (ID) in
    (select ID from BANKEXCH_REOUT
     MINUS
     select ID from A_BANKEXCH_REOUT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BANKEXCH_SUBSTITUTION

update A_BANKEXCH_SUBSTITUTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BANKEXCH_SUBSTITUTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BANKEXCH_SUBSTITUTION)
/

update A_BANKEXCH_SUBSTITUTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT
   from BANKEXCH_SUBSTITUTION
   where (ID) in (select ID from A_BANKEXCH_SUBSTITUTION))
  MINUS
  (select ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT
   from A_BANKEXCH_SUBSTITUTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BANKEXCH_SUBSTITUTION (ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BANKEXCH_SUBSTITUTION
   where (ID) in (select ID from A_BANKEXCH_SUBSTITUTION))
  MINUS
  (select ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BANKEXCH_SUBSTITUTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BANKEXCH_SUBSTITUTION (ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PROCLEVEL,ORDERRULES,SOURCEMFO,SOURCEKPP,SOURCEACC,SOURCENOTE,SOURCEKD,SOURCEIFS,SOURCEDIRECTIONCLS,SOURCEBUHPAYMENTCLS,SOURCEKDFULL,SOURCEFINSOURCEFULL,SOURCEDFACCOUNT,SOURCEPROCDOCCLASS,DESTNOTE,DESTKD,DESTSUBKD,DESTREGIONCLS,DESTGOSNI,DESTFACIALACC_CLS,DESTDOCTYPE,DESTFINTYPE,DESTBUHPAYMENTCLS,DESTIFS,DESTKVSR,DESTKFSR,DESTKESR,DESTKVR,DESTKCSR,DESTDIRECTIONCLS,DESTKDFULL,DESTFINSOURCEFULL,DESTPROCDOCCLASS,DESTORG_REF,DESTACC_REF,NAMERULE,NAMEABLACTION,NOTERULE,DESTFACT,FORMTYPE,BUHOPERATIONCLS,SOURCEFEDERALFUNDSREF,DESTFEDERALFUNDSREF,SOURCETARGETCLS,DESTSUBKESR,SOURCEINN,SOURCEKVSR,SOURCEKFSR,SOURCEKESR,SOURCEKVR,SOURCEKCSR,DESTFUNDSSOURCE,DISABLED,SOURCESUMMAKIND,SOURCEKOD_IST,SOURCEDOCUMENTNAME,DESTOPERATIONDIRECTION,DESTTRANSFERTCLS,DESTSUBSIDYCLS,SOURCEFACIALACC_ORG_TYPE,SOURCEFACIALACC_CLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,DESTMEANSTYPE,SOURCEDEREFERENCE,SOURCETRANSFERTCLS,SOURCESUBSIDYCLS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTDFACCOUNT,SOURCECLSTYPE,DESTCLSTYPE,SOURCEINVESTOBJECT,DESTINVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BANKEXCH_SUBSTITUTION
where (ID) in
    (select ID from BANKEXCH_SUBSTITUTION
     MINUS
     select ID from A_BANKEXCH_SUBSTITUTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BILL_ACCORDDOC

update A_BILL_ACCORDDOC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BILL_ACCORDDOC
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BILL_ACCORDDOC)
/

update A_BILL_ACCORDDOC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from BILL_ACCORDDOC
   where (ID) in (select ID from A_BILL_ACCORDDOC))
  MINUS
  (select ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_BILL_ACCORDDOC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BILL_ACCORDDOC (ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BILL_ACCORDDOC
   where (ID) in (select ID from A_BILL_ACCORDDOC))
  MINUS
  (select ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BILL_ACCORDDOC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BILL_ACCORDDOC (ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NUM_ACCORD,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,SUMBYFIN,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BILL_ACCORDDOC
where (ID) in
    (select ID from BILL_ACCORDDOC
     MINUS
     select ID from A_BILL_ACCORDDOC
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BILLS

update A_BILLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BILLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BILLS)
/

update A_BILLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from BILLS
   where (ID) in (select ID from A_BILLS))
  MINUS
  (select ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_BILLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BILLS (ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BILLS
   where (ID) in (select ID from A_BILLS))
  MINUS
  (select ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BILLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BILLS (ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DATE_INPUT,ID_ORG,NUM_NOTIF,NOTE,BUDGETREF,SUMBYINCOMES,SUMBYBILLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BILLS
where (ID) in
    (select ID from BILLS
     MINUS
     select ID from A_BILLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BILLS_DET

update A_BILLS_DET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BILLS_DET
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BILLS_DET)
/

update A_BILLS_DET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER
   from BILLS_DET
   where (ID) in (select ID from A_BILLS_DET))
  MINUS
  (select ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER
   from A_BILLS_DET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BILLS_DET (ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BILLS_DET
   where (ID) in (select ID from A_BILLS_DET))
  MINUS
  (select ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BILLS_DET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BILLS_DET (ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SERIES,NOMINAL,DATEAMORTIZATION,SUMMAOUT,NOMINALPRICE,PROGINDEX_BILL,RECORDINDEX_BILL,REF_ISSUE,DATE_OUT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BILLS_DET
where (ID) in
    (select ID from BILLS_DET
     MINUS
     select ID from A_BILLS_DET
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BNK_DSIGNDOCUMENTS

update A_BNK_DSIGNDOCUMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BNK_DSIGNDOCUMENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BNK_DSIGNDOCUMENTS)
/

update A_BNK_DSIGNDOCUMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER
   from BNK_DSIGNDOCUMENTS
   where (ID) in (select ID from A_BNK_DSIGNDOCUMENTS))
  MINUS
  (select ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER
   from A_BNK_DSIGNDOCUMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BNK_DSIGNDOCUMENTS (ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BNK_DSIGNDOCUMENTS
   where (ID) in (select ID from A_BNK_DSIGNDOCUMENTS))
  MINUS
  (select ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BNK_DSIGNDOCUMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BNK_DSIGNDOCUMENTS (ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,DOCUMENTID,DOCSTATUS,REJECTCAUSE,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BNK_DSIGNDOCUMENTS
where (ID) in
    (select ID from BNK_DSIGNDOCUMENTS
     MINUS
     select ID from A_BNK_DSIGNDOCUMENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BNKINPUTDOC_JOURNAL

update A_BNKINPUTDOC_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BNKINPUTDOC_JOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BNKINPUTDOC_JOURNAL)
/

update A_BNKINPUTDOC_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,CREATERUSER
   from BNKINPUTDOC_JOURNAL
   where (ID) in (select ID from A_BNKINPUTDOC_JOURNAL))
  MINUS
  (select ID,CREATEDATE,CREATERUSER
   from A_BNKINPUTDOC_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BNKINPUTDOC_JOURNAL (ID,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BNKINPUTDOC_JOURNAL
   where (ID) in (select ID from A_BNKINPUTDOC_JOURNAL))
  MINUS
  (select ID,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BNKINPUTDOC_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BNKINPUTDOC_JOURNAL (ID,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BNKINPUTDOC_JOURNAL
where (ID) in
    (select ID from BNKINPUTDOC_JOURNAL
     MINUS
     select ID from A_BNKINPUTDOC_JOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BNKOUTPUTDOC_JOURNAL

update A_BNKOUTPUTDOC_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BNKOUTPUTDOC_JOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BNKOUTPUTDOC_JOURNAL)
/

update A_BNKOUTPUTDOC_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER
   from BNKOUTPUTDOC_JOURNAL
   where (ID) in (select ID from A_BNKOUTPUTDOC_JOURNAL))
  MINUS
  (select ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER
   from A_BNKOUTPUTDOC_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BNKOUTPUTDOC_JOURNAL (ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BNKOUTPUTDOC_JOURNAL
   where (ID) in (select ID from A_BNKOUTPUTDOC_JOURNAL))
  MINUS
  (select ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BNKOUTPUTDOC_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BNKOUTPUTDOC_JOURNAL (ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,STATUS,UPDATEDATE,UPDATERUSER,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BNKOUTPUTDOC_JOURNAL
where (ID) in
    (select ID from BNKOUTPUTDOC_JOURNAL
     MINUS
     select ID from A_BNKOUTPUTDOC_JOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDALLOCATIONCLS

update A_BUDALLOCATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDALLOCATIONCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDALLOCATIONCLS)
/

update A_BUDALLOCATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from BUDALLOCATIONCLS
   where (ID) in (select ID from A_BUDALLOCATIONCLS))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_BUDALLOCATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDALLOCATIONCLS (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDALLOCATIONCLS
   where (ID) in (select ID from A_BUDALLOCATIONCLS))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDALLOCATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDALLOCATIONCLS (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDALLOCATIONCLS
where (ID) in
    (select ID from BUDALLOCATIONCLS
     MINUS
     select ID from A_BUDALLOCATIONCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDGETACCOUNTS

update A_BUDGETACCOUNTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDGETACCOUNTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDGETACCOUNTS)
/

update A_BUDGETACCOUNTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from BUDGETACCOUNTS
   where (ID) in (select ID from A_BUDGETACCOUNTS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_BUDGETACCOUNTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDGETACCOUNTS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDGETACCOUNTS
   where (ID) in (select ID from A_BUDGETACCOUNTS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDGETACCOUNTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDGETACCOUNTS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDGETACCOUNTS
where (ID) in
    (select ID from BUDGETACCOUNTS
     MINUS
     select ID from A_BUDGETACCOUNTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDGETDATA

update A_BUDGETDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDGETDATA
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDGETDATA)
/

update A_BUDGETDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR
   from BUDGETDATA
   where (ID) in (select ID from A_BUDGETDATA))
  MINUS
  (select ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR
   from A_BUDGETDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDGETDATA (ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDGETDATA
   where (ID) in (select ID from A_BUDGETDATA))
  MINUS
  (select ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDGETDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDGETDATA (ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FACIALACC_CLS,ACC_REF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,MEANSTYPE,SENDERID,SENDERRECORDID,STIMATEID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,IFS,CLSTYPE,ORG_REF,UNIONNOTIFYREF,FUNDSSOURCE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,KESRCORR,ASSIGNMENTKIND,TRANSFERTCLS,KD,SUBKD,DAYPLAN,DAYPLANSUMMA,NOTE,SUBSIDYCLS,SUBSIDYCLSOLD,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,TRANSFERTORG_REF,DEPARTMENTCLS,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SENDERIDKEY,SENDERRECORDIDKEY,KVRCORR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDGETDATA
where (ID) in
    (select ID from BUDGETDATA
     MINUS
     select ID from A_BUDGETDATA
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDGETTYPE

update A_BUDGETTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDGETTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDGETTYPE)
/

update A_BUDGETTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from BUDGETTYPE
   where (ID) in (select ID from A_BUDGETTYPE))
  MINUS
  (select ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_BUDGETTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDGETTYPE (ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDGETTYPE
   where (ID) in (select ID from A_BUDGETTYPE))
  MINUS
  (select ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDGETTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDGETTYPE (ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCOUNT1,ACCOUNT2,ACCOUNT3,NAME,TRANSFERTLEVELKIND,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDGETTYPE
where (ID) in
    (select ID from BUDGETTYPE
     MINUS
     select ID from A_BUDGETTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDSTRLINK

update A_BUDSTRLINK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDSTRLINK
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDSTRLINK)
/

update A_BUDSTRLINK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER
   from BUDSTRLINK
   where (ID) in (select ID from A_BUDSTRLINK))
  MINUS
  (select ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER
   from A_BUDSTRLINK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDSTRLINK (ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDSTRLINK
   where (ID) in (select ID from A_BUDSTRLINK))
  MINUS
  (select ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDSTRLINK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDSTRLINK (ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDSTRUCT,ORG_REF,FACIALACC,CREATEDATE,UPDATEDATE,FILTERKIND,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDSTRLINK
where (ID) in
    (select ID from BUDSTRLINK
     MINUS
     select ID from A_BUDSTRLINK
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDSTRUCT

update A_BUDSTRUCT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDSTRUCT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDSTRUCT)
/

update A_BUDSTRUCT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND
   from BUDSTRUCT
   where (ID) in (select ID from A_BUDSTRUCT))
  MINUS
  (select ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND
   from A_BUDSTRUCT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDSTRUCT (ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDSTRUCT
   where (ID) in (select ID from A_BUDSTRUCT))
  MINUS
  (select ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDSTRUCT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDSTRUCT (ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,REGIONCLS,FACT,FINTYPE,MEANSTYPE,ACTUALDATE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,DIRECTIONCLS,BUDGETREF,TRANSFERTCLS,STARTDATE,ISLIMITSPEND,BUDALLOCATIONCLS,PAYPROMISECLS,SUBSIDYCLS,ASSIGNMENTKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDSTRUCT
where (ID) in
    (select ID from BUDSTRUCT
     MINUS
     select ID from A_BUDSTRUCT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUDSTRUCTRIGHTS

update A_BUDSTRUCTRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUDSTRUCTRIGHTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUDSTRUCTRIGHTS)
/

update A_BUDSTRUCTRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP
   from BUDSTRUCTRIGHTS
   where (ID) in (select ID from A_BUDSTRUCTRIGHTS))
  MINUS
  (select ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP
   from A_BUDSTRUCTRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUDSTRUCTRIGHTS (ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUDSTRUCTRIGHTS
   where (ID) in (select ID from A_BUDSTRUCTRIGHTS))
  MINUS
  (select ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUDSTRUCTRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUDSTRUCTRIGHTS (ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,USERREF,ISGROUP,RIGHTREF,KFSR,KVSR,KESR,SUBKESR,REGIONCLS,MEANSTYPE,CREATEDATE,UPDATEDATE,KFSRUP,KVSRUP,KESRUP,SUBKESRUP,REGIONCLSUP,MEANSTYPEUP,KVR,KVRUP,TRANSFERTCLS,TRANSFERTCLSUP,KCSR,KCSRUP,BUDALLOCATIONCLS,BUDALLOCATIONCLSUP,PAYPROMISECLS,PAYPROMISECLSUP,SUBSIDYCLS,SUBSIDYCLSUP,DIRECTIONCLS,DIRECTIONCLSUP,FACT,FACTUP,FINTYPE,FINTYPEUP,CREATERUSER,UPDATERUSER,ASSIGNMENTKIND,ASSIGNMENTKINDUP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUDSTRUCTRIGHTS
where (ID) in
    (select ID from BUDSTRUCTRIGHTS
     MINUS
     select ID from A_BUDSTRUCTRIGHTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUH_JOURNAL

update A_BUH_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUH_JOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUH_JOURNAL)
/

update A_BUH_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR
   from BUH_JOURNAL
   where (ID) in (select ID from A_BUH_JOURNAL))
  MINUS
  (select ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR
   from A_BUH_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUH_JOURNAL (ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUH_JOURNAL
   where (ID) in (select ID from A_BUH_JOURNAL))
  MINUS
  (select ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUH_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUH_JOURNAL (ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DAT,DEBIT,CREDIT,REGIONCLS,BUDGETREF,SUMMA,CURRENCY,NOTE,PROGINDEX,RECORDINDEX,ACCOUNTREF,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,KVSR,KFSR,KESR,KVR,KCSR,KVSR_CORR,KFSR_CORR,KESR_CORR,KVR_CORR,KCSR_CORR,KD,KD_CORR,IFS,CLSTYPE,CLSTYPE_CORR,DOCNUMBER,ACCEPTDATE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALPAYERREF,ORIGINALACCEPTORREF,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,SOURCEPROGINDEX,SOURCERECORDINDEX,DESTPROGINDEX,DESTRECORDINDEX,FACT,FACT_CORR,MEANSTYPE_CORR,REGIONCLS_CORR,FACIALACC_CLS,FACIALACC_CLS_CORR,FINSOURCE,FINSOURCE_CORR,NOTEEX,DIRECTIONCLS,DIRECTIONCLS_CORR,FINTYPE,FINTYPE_CORR,DOCTYPE,DOCTYPE_CORR,NEEDSENDUFK,NEEDPERFORM,SUBKESR,SUBKESR_CORR,DESTORGREF,REJECT_CLS,REJECTCAUSE,FUNDSSOURCE,FUNDSSOURCE_CORR,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,ISBLOCKED_COR,BLOCKEDCAUSE_COR,UNBLOCKEDDATE_COR,UNBLOCKEDCAUSE_COR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUH_JOURNAL
where (ID) in
    (select ID from BUH_JOURNAL
     MINUS
     select ID from A_BUH_JOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUHACCPLAN

update A_BUHACCPLAN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUHACCPLAN
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUHACCPLAN)
/

update A_BUHACCPLAN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS
   from BUHACCPLAN
   where (ID) in (select ID from A_BUHACCPLAN))
  MINUS
  (select ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS
   from A_BUHACCPLAN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUHACCPLAN (ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUHACCPLAN
   where (ID) in (select ID from A_BUHACCPLAN))
  MINUS
  (select ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUHACCPLAN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUHACCPLAN (ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUHACC,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,CLSTYPE,ECCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUHACCPLAN
where (ID) in
    (select ID from BUHACCPLAN
     MINUS
     select ID from A_BUHACCPLAN
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_BUHPAYMENTCLS

update A_BUHPAYMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_BUHPAYMENTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from BUHPAYMENTCLS)
/

update A_BUHPAYMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME
   from BUHPAYMENTCLS
   where (ID) in (select ID from A_BUHPAYMENTCLS))
  MINUS
  (select ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME
   from A_BUHPAYMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_BUHPAYMENTCLS (ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from BUHPAYMENTCLS
   where (ID) in (select ID from A_BUHPAYMENTCLS))
  MINUS
  (select ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_BUHPAYMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_BUHPAYMENTCLS (ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SOURCETYPE,DESTTYPE,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from BUHPAYMENTCLS
where (ID) in
    (select ID from BUHPAYMENTCLS
     MINUS
     select ID from A_BUHPAYMENTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CARDS

update A_CARDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CARDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CARDS)
/

update A_CARDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME
   from CARDS
   where (ID) in (select ID from A_CARDS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME
   from A_CARDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CARDS (ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CARDS
   where (ID) in (select ID from A_CARDS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CARDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CARDS (ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ACOMMENT,FACIALACC_CLS,CARDNUMBER,ACCOUNT,FULLCARDNUMBER,REQUEST_NUMBER,REQUEST_DATE,BANKCREATEDATE,CLIENTRECEIVEDATE,CLIENTRETURNDATE,BANKRETURNDATE,CLIENTORG,DOCSTATEREF,EMPLOYEENAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CARDS
where (ID) in
    (select ID from CARDS
     MINUS
     select ID from A_CARDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CARDSDETAIL_FACC

update A_CARDSDETAIL_FACC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CARDSDETAIL_FACC
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CARDSDETAIL_FACC)
/

update A_CARDSDETAIL_FACC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from CARDSDETAIL_FACC
   where (ID) in (select ID from A_CARDSDETAIL_FACC))
  MINUS
  (select ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_CARDSDETAIL_FACC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CARDSDETAIL_FACC (ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CARDSDETAIL_FACC
   where (ID) in (select ID from A_CARDSDETAIL_FACC))
  MINUS
  (select ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CARDSDETAIL_FACC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CARDSDETAIL_FACC (ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,FACIALACC_CLS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CARDSDETAIL_FACC
where (ID) in
    (select ID from CARDSDETAIL_FACC
     MINUS
     select ID from A_CARDSDETAIL_FACC
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CARDSDETAIL_KESR

update A_CARDSDETAIL_KESR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CARDSDETAIL_KESR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CARDSDETAIL_KESR)
/

update A_CARDSDETAIL_KESR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from CARDSDETAIL_KESR
   where (ID) in (select ID from A_CARDSDETAIL_KESR))
  MINUS
  (select ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_CARDSDETAIL_KESR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CARDSDETAIL_KESR (ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CARDSDETAIL_KESR
   where (ID) in (select ID from A_CARDSDETAIL_KESR))
  MINUS
  (select ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CARDSDETAIL_KESR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CARDSDETAIL_KESR (ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,KESR,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CARDSDETAIL_KESR
where (ID) in
    (select ID from CARDSDETAIL_KESR
     MINUS
     select ID from A_CARDSDETAIL_KESR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CBPERCENTJOURNAL

update A_CBPERCENTJOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CBPERCENTJOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CBPERCENTJOURNAL)
/

update A_CBPERCENTJOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from CBPERCENTJOURNAL
   where (ID) in (select ID from A_CBPERCENTJOURNAL))
  MINUS
  (select ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_CBPERCENTJOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CBPERCENTJOURNAL (ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CBPERCENTJOURNAL
   where (ID) in (select ID from A_CBPERCENTJOURNAL))
  MINUS
  (select ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CBPERCENTJOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CBPERCENTJOURNAL (ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PROGINDEX,ACCEPTDATE,PERCENT,NOTE,ISLAST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CBPERCENTJOURNAL
where (ID) in
    (select ID from CBPERCENTJOURNAL
     MINUS
     select ID from A_CBPERCENTJOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CLIENTDFACCOUNTLIST

update A_CLIENTDFACCOUNTLIST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CLIENTDFACCOUNTLIST
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CLIENTDFACCOUNTLIST)
/

update A_CLIENTDFACCOUNTLIST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF
   from CLIENTDFACCOUNTLIST
   where (ID) in (select ID from A_CLIENTDFACCOUNTLIST))
  MINUS
  (select ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF
   from A_CLIENTDFACCOUNTLIST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CLIENTDFACCOUNTLIST (ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CLIENTDFACCOUNTLIST
   where (ID) in (select ID from A_CLIENTDFACCOUNTLIST))
  MINUS
  (select ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CLIENTDFACCOUNTLIST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CLIENTDFACCOUNTLIST (ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACC_REF,CODEFORMAT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,TYPEINF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CLIENTDFACCOUNTLIST
where (ID) in
    (select ID from CLIENTDFACCOUNTLIST
     MINUS
     select ID from A_CLIENTDFACCOUNTLIST
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CLSCORRESPONDENTS

update A_CLSCORRESPONDENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CLSCORRESPONDENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CLSCORRESPONDENTS)
/

update A_CLSCORRESPONDENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL
   from CLSCORRESPONDENTS
   where (ID) in (select ID from A_CLSCORRESPONDENTS))
  MINUS
  (select ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL
   from A_CLSCORRESPONDENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CLSCORRESPONDENTS (ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CLSCORRESPONDENTS
   where (ID) in (select ID from A_CLSCORRESPONDENTS))
  MINUS
  (select ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CLSCORRESPONDENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CLSCORRESPONDENTS (ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KVR,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,KFSR,CORRTYPE,CORRBEL,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CLSCORRESPONDENTS
where (ID) in
    (select ID from CLSCORRESPONDENTS
     MINUS
     select ID from A_CLSCORRESPONDENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_COLLATERAL

update A_COLLATERAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_COLLATERAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from COLLATERAL)
/

update A_COLLATERAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA
   from COLLATERAL
   where (ID) in (select ID from A_COLLATERAL))
  MINUS
  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA
   from A_COLLATERAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_COLLATERAL (ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from COLLATERAL
   where (ID) in (select ID from A_COLLATERAL))
  MINUS
  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_COLLATERAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_COLLATERAL (ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,PROGINDEX,RECORDINDEX,COLLATERALTYPE,SUMMA,NOMINALSUMMA,NAME,ORG_REF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CURRENCYCLS,CURRENCYSUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from COLLATERAL
where (ID) in
    (select ID from COLLATERAL
     MINUS
     select ID from A_COLLATERAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_COLLATERALTYPE

update A_COLLATERALTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_COLLATERALTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from COLLATERALTYPE)
/

update A_COLLATERALTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from COLLATERALTYPE
   where (ID) in (select ID from A_COLLATERALTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from A_COLLATERALTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_COLLATERALTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from COLLATERALTYPE
   where (ID) in (select ID from A_COLLATERALTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_COLLATERALTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_COLLATERALTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from COLLATERALTYPE
where (ID) in
    (select ID from COLLATERALTYPE
     MINUS
     select ID from A_COLLATERALTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_COMMDIRECTIONEXPENCECLS

update A_COMMDIRECTIONEXPENCECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_COMMDIRECTIONEXPENCECLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from COMMDIRECTIONEXPENCECLS)
/

update A_COMMDIRECTIONEXPENCECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from COMMDIRECTIONEXPENCECLS
   where (ID) in (select ID from A_COMMDIRECTIONEXPENCECLS))
  MINUS
  (select ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_COMMDIRECTIONEXPENCECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_COMMDIRECTIONEXPENCECLS (ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from COMMDIRECTIONEXPENCECLS
   where (ID) in (select ID from A_COMMDIRECTIONEXPENCECLS))
  MINUS
  (select ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_COMMDIRECTIONEXPENCECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_COMMDIRECTIONEXPENCECLS (ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,OWNERLEVEL,CREATEDATE,UPDATEDATE,DELETEDATE,STARTDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from COMMDIRECTIONEXPENCECLS
where (ID) in
    (select ID from COMMDIRECTIONEXPENCECLS
     MINUS
     select ID from A_COMMDIRECTIONEXPENCECLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_COMPOUNDCLS

update A_COMPOUNDCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_COMPOUNDCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from COMPOUNDCLS)
/

update A_COMPOUNDCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE
   from COMPOUNDCLS
   where (ID) in (select ID from A_COMPOUNDCLS))
  MINUS
  (select ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE
   from A_COMPOUNDCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_COMPOUNDCLS (ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from COMPOUNDCLS
   where (ID) in (select ID from A_COMPOUNDCLS))
  MINUS
  (select ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_COMPOUNDCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_COMPOUNDCLS (ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,PROGINDEX,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from COMPOUNDCLS
where (ID) in
    (select ID from COMPOUNDCLS
     MINUS
     select ID from A_COMPOUNDCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_COMPOUNDCLSDETAIL

update A_COMPOUNDCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_COMPOUNDCLSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from COMPOUNDCLSDETAIL)
/

update A_COMPOUNDCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS
   from COMPOUNDCLSDETAIL
   where (ID) in (select ID from A_COMPOUNDCLSDETAIL))
  MINUS
  (select ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS
   from A_COMPOUNDCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_COMPOUNDCLSDETAIL (ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from COMPOUNDCLSDETAIL
   where (ID) in (select ID from A_COMPOUNDCLSDETAIL))
  MINUS
  (select ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_COMPOUNDCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_COMPOUNDCLSDETAIL (ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KFSR,KESR,SUBKESR,FINSOURCECLS,FACTCLS,MEANSTYPECLS,TYPEOPERATIONCLS,COMPOUNDCLS,PROGINDEX,CREATEDATE,UPDATEDATE,KVSR,KCSR,KVR,DIRECTIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from COMPOUNDCLSDETAIL
where (ID) in
    (select ID from COMPOUNDCLSDETAIL
     MINUS
     select ID from A_COMPOUNDCLSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CONTACTPERSONS

update A_CONTACTPERSONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CONTACTPERSONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CONTACTPERSONS)
/

update A_CONTACTPERSONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from CONTACTPERSONS
   where (ID) in (select ID from A_CONTACTPERSONS))
  MINUS
  (select ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_CONTACTPERSONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CONTACTPERSONS (ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CONTACTPERSONS
   where (ID) in (select ID from A_CONTACTPERSONS))
  MINUS
  (select ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CONTACTPERSONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CONTACTPERSONS (ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FACIALACCCLS,ORGREF,NAME,HOLDRANK,PHONENO,EMAIL,NOTE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CONTACTPERSONS
where (ID) in
    (select ID from CONTACTPERSONS
     MINUS
     select ID from A_CONTACTPERSONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CORRECTIONCAPTION

update A_CORRECTIONCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CORRECTIONCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CORRECTIONCAPTION)
/

update A_CORRECTIONCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS
   from CORRECTIONCAPTION
   where (ID) in (select ID from A_CORRECTIONCAPTION))
  MINUS
  (select ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS
   from A_CORRECTIONCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CORRECTIONCAPTION (ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CORRECTIONCAPTION
   where (ID) in (select ID from A_CORRECTIONCAPTION))
  MINUS
  (select ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CORRECTIONCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CORRECTIONCAPTION (ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PARENTID,BUDGETREF,DOCNUMBER,INPUTDATE,ACCEPTDATE,SUMMA,NOTE,DOCTYPE,PROGINDEX,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,ORIGINALNUMBER,ORIGINALDATE,ORIGINALSUMMA,ORIGINALNOTE,ORIGINALPROGINDEX,ORIGINALRECORDINDEX,ORIGINALPAYERACC_REF,ORIGINALPAYERACC,ORIGINALPAYERORGNAME,ORIGINALPAYERORGINN20,ORIGINALPAYERBANKNAME,ORIGINALPAYERBANKMFO,ORIGINALPAYERBANKCOR,ORIGINALPAYERFKORGINN,ORIGINALPAYERFKORGNAME,ORIGINALPAYERFKLS,ORIGINALACCEPTORACC_REF,ORIGINALACCEPTORACC,ORIGINALACCEPTORORGNAME,ORIGINALACCEPTORORGINN20,ORIGINALACCEPTORBANKNAME,ORIGINALACCEPTORBANKMFO,ORIGINALACCEPTORBANKCOR,ORIGINALACCEPTORFKORGINN,ORIGINALACCEPTORFKORGNAME,ORIGINALACCEPTORFKLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORIGINALACCEPTORFKCODE,ORIGINALPAYERFKCODE,ADMINACCEPTORINN,ADMINACCEPTORINN20,FKINN,FKINN20,FKNAME,TERRITORIALFKINN,TERRITORIALFKINN20,ORIGINALPAYERORGINN,ORIGINALACCEPTORORGINN,ORIGINALPAYERBANKFILNAME,ORIGINALACCEPTORBANKFILNAME,RECORDDATE,BASICNOTE,LASTEXTRCHANGE,CRYPTOSTATUS,OKATO,ELNUM,FACIALACC_CLS,ADDOKATO,PERSONALINFO,ELDOCREF,REQUESTNUMBER,DEPARTMENTCLS,DOCCHANGEDATE,SIGNERS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CORRECTIONCAPTION
where (ID) in
    (select ID from CORRECTIONCAPTION
     MINUS
     select ID from A_CORRECTIONCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CURRENCYCLS

update A_CURRENCYCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CURRENCYCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CURRENCYCLS)
/

update A_CURRENCYCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from CURRENCYCLS
   where (ID) in (select ID from A_CURRENCYCLS))
  MINUS
  (select ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_CURRENCYCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CURRENCYCLS (ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CURRENCYCLS
   where (ID) in (select ID from A_CURRENCYCLS))
  MINUS
  (select ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CURRENCYCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CURRENCYCLS (ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,KIND,VARIANT1,VARIANT2,VARIANT7,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CURRENCYCLS
where (ID) in
    (select ID from CURRENCYCLS
     MINUS
     select ID from A_CURRENCYCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CURRENCYEXCHANGE

update A_CURRENCYEXCHANGE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CURRENCYEXCHANGE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CURRENCYEXCHANGE)
/

update A_CURRENCYEXCHANGE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE
   from CURRENCYEXCHANGE
   where (ID) in (select ID from A_CURRENCYEXCHANGE))
  MINUS
  (select CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE
   from A_CURRENCYEXCHANGE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CURRENCYEXCHANGE (CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CURRENCYEXCHANGE
   where (ID) in (select ID from A_CURRENCYEXCHANGE))
  MINUS
  (select CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CURRENCYEXCHANGE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CURRENCYEXCHANGE (CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select CURRENCY,DAT,ID,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,EXCHANGE,MVBEXCHANGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CURRENCYEXCHANGE
where (ID) in
    (select ID from CURRENCYEXCHANGE
     MINUS
     select ID from A_CURRENCYEXCHANGE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_CURRENCYINCOMES

update A_CURRENCYINCOMES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_CURRENCYINCOMES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from CURRENCYINCOMES)
/

update A_CURRENCYINCOMES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE
   from CURRENCYINCOMES
   where (ID) in (select ID from A_CURRENCYINCOMES))
  MINUS
  (select ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE
   from A_CURRENCYINCOMES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_CURRENCYINCOMES (ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from CURRENCYINCOMES
   where (ID) in (select ID from A_CURRENCYINCOMES))
  MINUS
  (select ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_CURRENCYINCOMES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_CURRENCYINCOMES (ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CURDATE,CURRENCYINDEX,EXCHANGEPRICE,CURRENCYVALUE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from CURRENCYINCOMES
where (ID) in
    (select ID from CURRENCYINCOMES
     MINUS
     select ID from A_CURRENCYINCOMES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DATABASEVERSION

update A_DATABASEVERSION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (MAJOR,MINOR,BUILD) in (select MAJOR,MINOR,BUILD from A_DATABASEVERSION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select MAJOR,MINOR,BUILD from DATABASEVERSION)
/

update A_DATABASEVERSION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (MAJOR,MINOR,BUILD) in (select MAJOR,MINOR,BUILD from (
  (select VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD
   from DATABASEVERSION
   where (MAJOR,MINOR,BUILD) in (select MAJOR,MINOR,BUILD from A_DATABASEVERSION))
  MINUS
  (select VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD
   from A_DATABASEVERSION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DATABASEVERSION (VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DATABASEVERSION
   where (MAJOR,MINOR,BUILD) in (select MAJOR,MINOR,BUILD from A_DATABASEVERSION))
  MINUS
  (select VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DATABASEVERSION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DATABASEVERSION (VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select VERSION,MAJOR,MINOR,UPDATEDATE,ACOMMENT,BUILD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DATABASEVERSION
where (MAJOR,MINOR,BUILD) in
    (select MAJOR,MINOR,BUILD from DATABASEVERSION
     MINUS
     select MAJOR,MINOR,BUILD from A_DATABASEVERSION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DATAPACKET

update A_DATAPACKET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DATAPACKET
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DATAPACKET)
/

update A_DATAPACKET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS
   from DATAPACKET
   where (ID) in (select ID from A_DATAPACKET))
  MINUS
  (select ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS
   from A_DATAPACKET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DATAPACKET (ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DATAPACKET
   where (ID) in (select ID from A_DATAPACKET))
  MINUS
  (select ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DATAPACKET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DATAPACKET (ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CLIENTCODE,PACKETID,RECIPIENTCODE,PACKETCREATEDATE,REJECTDATE,PACKETDELIVERYDATE,REJECTDELIVERYDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PRIMARYDOCREF,NOTE,RVERSION,PROGINDEX,CRYPTOSTATUS,PACKETSTATE,DOCSTATEREF,ARCHIVEDOCTYPE,NAME,BUDGETREF,RSFO,DOCNUMBER,REJECTCAUSE,BINARYDATASIZE,DATALOCATION,PACKETTYPECLS,FACIALACC_CLS,REPORTDATE,SPCONSTRAINTCRC,FILECRC,FORMAT,DEPARTMENTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DATAPACKET
where (ID) in
    (select ID from DATAPACKET
     MINUS
     select ID from A_DATAPACKET
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DATAPACKETCONTENT

update A_DATAPACKETCONTENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DATAPACKETCONTENT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DATAPACKETCONTENT)
/

update A_DATAPACKETCONTENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME
   from DATAPACKETCONTENT
   where (ID) in (select ID from A_DATAPACKETCONTENT))
  MINUS
  (select ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME
   from A_DATAPACKETCONTENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DATAPACKETCONTENT (ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DATAPACKETCONTENT
   where (ID) in (select ID from A_DATAPACKETCONTENT))
  MINUS
  (select ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DATAPACKETCONTENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DATAPACKETCONTENT (ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DATAPACKETTYPE,DATASECTIONTYPE,GENERATIONTEMPLATE,PROCESSINGTEMPLATE,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,PREVIEWSCRIPTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DATAPACKETCONTENT
where (ID) in
    (select ID from DATAPACKETCONTENT
     MINUS
     select ID from A_DATAPACKETCONTENT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DATAPACKETTYPES

update A_DATAPACKETTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DATAPACKETTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DATAPACKETTYPES)
/

update A_DATAPACKETTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME
   from DATAPACKETTYPES
   where (ID) in (select ID from A_DATAPACKETTYPES))
  MINUS
  (select ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME
   from A_DATAPACKETTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DATAPACKETTYPES (ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DATAPACKETTYPES
   where (ID) in (select ID from A_DATAPACKETTYPES))
  MINUS
  (select ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DATAPACKETTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DATAPACKETTYPES (ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,PERIOD,PROCESSINGTYPE,CREATIONPERMISSIONS,ENABLED,CONSTRAINTSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ARCHIVEDOCTYPE,SIGNSCHEME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DATAPACKETTYPES
where (ID) in
    (select ID from DATAPACKETTYPES
     MINUS
     select ID from A_DATAPACKETTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DATASECTIONTYPES

update A_DATASECTIONTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DATASECTIONTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DATASECTIONTYPES)
/

update A_DATASECTIONTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME
   from DATASECTIONTYPES
   where (ID) in (select ID from A_DATASECTIONTYPES))
  MINUS
  (select ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME
   from A_DATASECTIONTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DATASECTIONTYPES (ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DATASECTIONTYPES
   where (ID) in (select ID from A_DATASECTIONTYPES))
  MINUS
  (select ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DATASECTIONTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DATASECTIONTYPES (ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATINGSCRIPTNAME,PROCESSINGSCRIPTNAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,PREVIEWSCRIPTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DATASECTIONTYPES
where (ID) in
    (select ID from DATASECTIONTYPES
     MINUS
     select ID from A_DATASECTIONTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DATECONST

update A_DATECONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DATECONST
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DATECONST)
/

update A_DATECONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE
   from DATECONST
   where (ID) in (select ID from A_DATECONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE
   from A_DATECONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DATECONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DATECONST
   where (ID) in (select ID from A_DATECONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DATECONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DATECONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DATECONST
where (ID) in
    (select ID from DATECONST
     MINUS
     select ID from A_DATECONST
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DBGROUPS

update A_DBGROUPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DBGROUPS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DBGROUPS)
/

update A_DBGROUPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER
   from DBGROUPS
   where (ID) in (select ID from A_DBGROUPS))
  MINUS
  (select ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER
   from A_DBGROUPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DBGROUPS (ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DBGROUPS
   where (ID) in (select ID from A_DBGROUPS))
  MINUS
  (select ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DBGROUPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DBGROUPS (ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,NOTE,CREATEDATE,UPDATEDATE,SYSTEMGROUPID,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DBGROUPS
where (ID) in
    (select ID from DBGROUPS
     MINUS
     select ID from A_DBGROUPS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DBRIGHTS

update A_DBRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DBRIGHTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DBRIGHTS)
/

update A_DBRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE
   from DBRIGHTS
   where (ID) in (select ID from A_DBRIGHTS))
  MINUS
  (select ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE
   from A_DBRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DBRIGHTS (ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DBRIGHTS
   where (ID) in (select ID from A_DBRIGHTS))
  MINUS
  (select ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DBRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DBRIGHTS (ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,OBJREF,RIGHTKINDREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DBRIGHTS
where (ID) in
    (select ID from DBRIGHTS
     MINUS
     select ID from A_DBRIGHTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DEBT

update A_DEBT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DEBT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DEBT)
/

update A_DEBT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT
   from DEBT
   where (ID) in (select ID from A_DEBT))
  MINUS
  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT
   from A_DEBT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DEBT (ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DEBT
   where (ID) in (select ID from A_DEBT))
  MINUS
  (select ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DEBT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DEBT (ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,PROGINDEX,RECORDINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,DFACCOUNT,DEBIT,CREDIT,ACCREF,IFS,SUBKD,DOCTYPE,SOURCEDOCNUMBER,REGIONCLS,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTORACCREF,OFS,CURRENCYCLS,BUHPAYMENTCLS,RECORDINDEX2,TOTALREF,REQUESTSINDEX,TAXNOTE,CURRENCYSUMMA,RVERSION,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,MEANSTYPE,BUHOPERATIONCLS,IFS_CORR,BONDCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DEBT
where (ID) in
    (select ID from DEBT
     MINUS
     select ID from A_DEBT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DEBTTYPE

update A_DEBTTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DEBTTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DEBTTYPE)
/

update A_DEBTTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME
   from DEBTTYPE
   where (ID) in (select ID from A_DEBTTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME
   from A_DEBTTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DEBTTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DEBTTYPE
   where (ID) in (select ID from A_DEBTTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DEBTTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DEBTTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DEBTTYPE
where (ID) in
    (select ID from DEBTTYPE
     MINUS
     select ID from A_DEBTTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOCORRESPONDENT

update A_DELOCORRESPONDENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOCORRESPONDENT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOCORRESPONDENT)
/

update A_DELOCORRESPONDENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from DELOCORRESPONDENT
   where (ID) in (select ID from A_DELOCORRESPONDENT))
  MINUS
  (select ID,NAME
   from A_DELOCORRESPONDENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOCORRESPONDENT (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOCORRESPONDENT
   where (ID) in (select ID from A_DELOCORRESPONDENT))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOCORRESPONDENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOCORRESPONDENT (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOCORRESPONDENT
where (ID) in
    (select ID from DELOCORRESPONDENT
     MINUS
     select ID from A_DELOCORRESPONDENT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOEXEC

update A_DELOEXEC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOEXEC
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOEXEC)
/

update A_DELOEXEC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from DELOEXEC
   where (ID) in (select ID from A_DELOEXEC))
  MINUS
  (select ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_DELOEXEC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOEXEC (ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOEXEC
   where (ID) in (select ID from A_DELOEXEC))
  MINUS
  (select ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOEXEC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOEXEC (ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCID,OTDEL,EXECUTOR,DATETO,DATEBACK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOEXEC
where (ID) in
    (select ID from DELOEXEC
     MINUS
     select ID from A_DELOEXEC
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOEXECUTOR

update A_DELOEXECUTOR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOEXECUTOR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOEXECUTOR)
/

update A_DELOEXECUTOR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,FULLNAME,PHONE
   from DELOEXECUTOR
   where (ID) in (select ID from A_DELOEXECUTOR))
  MINUS
  (select ID,NAME,FULLNAME,PHONE
   from A_DELOEXECUTOR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOEXECUTOR (ID,NAME,FULLNAME,PHONE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,FULLNAME,PHONE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOEXECUTOR
   where (ID) in (select ID from A_DELOEXECUTOR))
  MINUS
  (select ID,NAME,FULLNAME,PHONE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOEXECUTOR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOEXECUTOR (ID,NAME,FULLNAME,PHONE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,FULLNAME,PHONE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOEXECUTOR
where (ID) in
    (select ID from DELOEXECUTOR
     MINUS
     select ID from A_DELOEXECUTOR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOGRIF

update A_DELOGRIF set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOGRIF
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOGRIF)
/

update A_DELOGRIF set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from DELOGRIF
   where (ID) in (select ID from A_DELOGRIF))
  MINUS
  (select ID,NAME
   from A_DELOGRIF
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOGRIF (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOGRIF
   where (ID) in (select ID from A_DELOGRIF))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOGRIF
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOGRIF (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOGRIF
where (ID) in
    (select ID from DELOGRIF
     MINUS
     select ID from A_DELOGRIF
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOIN

update A_DELOIN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOIN
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOIN)
/

update A_DELOIN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS
   from DELOIN
   where (ID) in (select ID from A_DELOIN))
  MINUS
  (select ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS
   from A_DELOIN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOIN (ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOIN
   where (ID) in (select ID from A_DELOIN))
  MINUS
  (select ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOIN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOIN (ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TYPEDOC,NUMBERIN,DATEIN,CORRESPONDENT,DATEOUT,NUMBEROUT,RESOLUTION,DATEEXEC,GRIF,DATEANSWER,TOM,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NEEDCARD,DELO,CONTENTS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOIN
where (ID) in
    (select ID from DELOIN
     MINUS
     select ID from A_DELOIN
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOOTDEL

update A_DELOOTDEL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOOTDEL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOOTDEL)
/

update A_DELOOTDEL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,GR1,GR2
   from DELOOTDEL
   where (ID) in (select ID from A_DELOOTDEL))
  MINUS
  (select ID,NAME,GR1,GR2
   from A_DELOOTDEL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOOTDEL (ID,NAME,GR1,GR2,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,GR1,GR2,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOOTDEL
   where (ID) in (select ID from A_DELOOTDEL))
  MINUS
  (select ID,NAME,GR1,GR2,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOOTDEL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOOTDEL (ID,NAME,GR1,GR2,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,GR1,GR2,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOOTDEL
where (ID) in
    (select ID from DELOOTDEL
     MINUS
     select ID from A_DELOOTDEL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELOOUT

update A_DELOOUT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELOOUT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELOOUT)
/

update A_DELOOUT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from DELOOUT
   where (ID) in (select ID from A_DELOOUT))
  MINUS
  (select ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_DELOOUT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELOOUT (ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELOOUT
   where (ID) in (select ID from A_DELOOUT))
  MINUS
  (select ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELOOUT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELOOUT (ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TYPEDOC,CORRESPONDENT,DATEOUT,NUMBEROUT,CONTENTS,GRIF,EXECUTOR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELOOUT
where (ID) in
    (select ID from DELOOUT
     MINUS
     select ID from A_DELOOUT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DELORESOLUTION

update A_DELORESOLUTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DELORESOLUTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DELORESOLUTION)
/

update A_DELORESOLUTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from DELORESOLUTION
   where (ID) in (select ID from A_DELORESOLUTION))
  MINUS
  (select ID,NAME
   from A_DELORESOLUTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DELORESOLUTION (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DELORESOLUTION
   where (ID) in (select ID from A_DELORESOLUTION))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DELORESOLUTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DELORESOLUTION (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DELORESOLUTION
where (ID) in
    (select ID from DELORESOLUTION
     MINUS
     select ID from A_DELORESOLUTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DEPARTMENTCLS

update A_DEPARTMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DEPARTMENTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DEPARTMENTCLS)
/

update A_DEPARTMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME
   from DEPARTMENTCLS
   where (ID) in (select ID from A_DEPARTMENTCLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME
   from A_DEPARTMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DEPARTMENTCLS (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DEPARTMENTCLS
   where (ID) in (select ID from A_DEPARTMENTCLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DEPARTMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DEPARTMENTCLS (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,USER_REF,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DEPARTMENTCLS
where (ID) in
    (select ID from DEPARTMENTCLS
     MINUS
     select ID from A_DEPARTMENTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DESCRDOCUMENTFIELDS

update A_DESCRDOCUMENTFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DESCRDOCUMENTFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DESCRDOCUMENTFIELDS)
/

update A_DESCRDOCUMENTFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE
   from DESCRDOCUMENTFIELDS
   where (ID) in (select ID from A_DESCRDOCUMENTFIELDS))
  MINUS
  (select ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE
   from A_DESCRDOCUMENTFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DESCRDOCUMENTFIELDS (ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DESCRDOCUMENTFIELDS
   where (ID) in (select ID from A_DESCRDOCUMENTFIELDS))
  MINUS
  (select ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DESCRDOCUMENTFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DESCRDOCUMENTFIELDS (ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,VISUALFIELDTYPE,NAME,DBFIELDNAME,SOURCENAME,DOCTYPEREF,GROUPTYPE,FIELDSIZE,FIELDMASK,VALUEREQUIRED,DEFAULTVALUE,VISIBLE,DISPLAYLABEL,SOURCEDOCTYPEREF,SYSTEMFIELDTYPE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,FIELDTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DESCRDOCUMENTFIELDS
where (ID) in
    (select ID from DESCRDOCUMENTFIELDS
     MINUS
     select ID from A_DESCRDOCUMENTFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DFACCOUNTOPERATION

update A_DFACCOUNTOPERATION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DFACCOUNTOPERATION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DFACCOUNTOPERATION)
/

update A_DFACCOUNTOPERATION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS
   from DFACCOUNTOPERATION
   where (ID) in (select ID from A_DFACCOUNTOPERATION))
  MINUS
  (select ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS
   from A_DFACCOUNTOPERATION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DFACCOUNTOPERATION (ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DFACCOUNTOPERATION
   where (ID) in (select ID from A_DFACCOUNTOPERATION))
  MINUS
  (select ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DFACCOUNTOPERATION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DFACCOUNTOPERATION (ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCEPTDATE,SDFACCOUNT,DDFACCOUNT,REGIONCLS,BUDGETREF,SUMMA,NOTE,PROGINDEX,RECORDINDEX,BUHOPERATIONCLS,MEANSTYPE,DOCNUMBER,FUNDSSOURCE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,FACT,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DFACCOUNTOPERATION
where (ID) in
    (select ID from DFACCOUNTOPERATION
     MINUS
     select ID from A_DFACCOUNTOPERATION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DFUCHANGELOG

update A_DFUCHANGELOG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DFUCHANGELOG
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DFUCHANGELOG)
/

update A_DFUCHANGELOG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER
   from DFUCHANGELOG
   where (ID) in (select ID from A_DFUCHANGELOG))
  MINUS
  (select ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER
   from A_DFUCHANGELOG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DFUCHANGELOG (ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DFUCHANGELOG
   where (ID) in (select ID from A_DFUCHANGELOG))
  MINUS
  (select ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DFUCHANGELOG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DFUCHANGELOG (ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,VERSIONID,BEGINUPDATECODE,ENDUPDATECODE,LASTUPDATEDFU,ISBUDGET,INCLUDEDEL,INCLUDEBLOCKS,INCLUDEDOCS,SCRIPTCREATOR,SCRIPTCREATEDATE,NOTE,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DFUCHANGELOG
where (ID) in
    (select ID from DFUCHANGELOG
     MINUS
     select ID from A_DFUCHANGELOG
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DIRECTIONCLS

update A_DIRECTIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DIRECTIONCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DIRECTIONCLS)
/

update A_DIRECTIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from DIRECTIONCLS
   where (ID) in (select ID from A_DIRECTIONCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_DIRECTIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DIRECTIONCLS (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DIRECTIONCLS
   where (ID) in (select ID from A_DIRECTIONCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DIRECTIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DIRECTIONCLS (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DIRECTIONCLS
where (ID) in
    (select ID from DIRECTIONCLS
     MINUS
     select ID from A_DIRECTIONCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCBASE

update A_DOCBASE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCBASE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCBASE)
/

update A_DOCBASE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from DOCBASE
   where (ID) in (select ID from A_DOCBASE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_DOCBASE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCBASE (ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCBASE
   where (ID) in (select ID from A_DOCBASE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCBASE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCBASE (ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,DOCUMENTBASEDATE,DOCUMENTBASENUM,NAME,CODE,BUDGETREF,DELETEDATE,STARTDATE,KVSR,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCBASE
where (ID) in
    (select ID from DOCBASE
     MINUS
     select ID from A_DOCBASE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCLOCK

update A_DOCLOCK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCLOCK
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCLOCK)
/

update A_DOCLOCK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE
   from DOCLOCK
   where (ID) in (select ID from A_DOCLOCK))
  MINUS
  (select ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE
   from A_DOCLOCK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCLOCK (ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCLOCK
   where (ID) in (select ID from A_DOCLOCK))
  MINUS
  (select ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCLOCK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCLOCK (ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,LOCKMASK,DOCREF,DETAILNUM,RUNPOS,LOCKACTION,USERIGHTS,FORDELETE,ISSYSTEM,FORINSERT,DOCPARAM,VALIDATEMESSAGE,FORMULA,VALIDATELEVEL,VALIDATEFILTER,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCLOCK
where (ID) in
    (select ID from DOCLOCK
     MINUS
     select ID from A_DOCLOCK
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCLOCKFIELDS

update A_DOCLOCKFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCLOCKFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCLOCKFIELDS)
/

update A_DOCLOCKFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE
   from DOCLOCKFIELDS
   where (ID) in (select ID from A_DOCLOCKFIELDS))
  MINUS
  (select ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE
   from A_DOCLOCKFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCLOCKFIELDS (ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCLOCKFIELDS
   where (ID) in (select ID from A_DOCLOCKFIELDS))
  MINUS
  (select ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCLOCKFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCLOCKFIELDS (ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCLOCKREF,FIELDREF,ISSYSTEM,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCLOCKFIELDS
where (ID) in
    (select ID from DOCLOCKFIELDS
     MINUS
     select ID from A_DOCLOCKFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCTYPES

update A_DOCTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCTYPES)
/

update A_DOCTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME
   from DOCTYPES
   where (ID) in (select ID from A_DOCTYPES))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME
   from A_DOCTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCTYPES (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCTYPES
   where (ID) in (select ID from A_DOCTYPES))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCTYPES (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,RVERSION,REGISTRATIONTYPE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCTYPES
where (ID) in
    (select ID from DOCTYPES
     MINUS
     select ID from A_DOCTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCUMENTCLS

update A_DOCUMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCUMENTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCUMENTCLS)
/

update A_DOCUMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX
   from DOCUMENTCLS
   where (ID) in (select ID from A_DOCUMENTCLS))
  MINUS
  (select ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX
   from A_DOCUMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCUMENTCLS (ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCUMENTCLS
   where (ID) in (select ID from A_DOCUMENTCLS))
  MINUS
  (select ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCUMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCUMENTCLS (ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCTYPE,DOCTYPENOTE,TABLENAME,TABLENAMEURM,PRIMARYKEYNAME,PRIMARYKEYNAMEURM,LINKFIELDNAME,LINKFIELDNAMEURM,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CLSTYPE,TEMPLATEVISIBLE,SELECTIONREFBUDGET,SELECTIONREFURM,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCUMENTCLS
where (ID) in
    (select ID from DOCUMENTCLS
     MINUS
     select ID from A_DOCUMENTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCUMENTTEMPLATE

update A_DOCUMENTTEMPLATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCUMENTTEMPLATE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCUMENTTEMPLATE)
/

update A_DOCUMENTTEMPLATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from DOCUMENTTEMPLATE
   where (ID) in (select ID from A_DOCUMENTTEMPLATE))
  MINUS
  (select ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_DOCUMENTTEMPLATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCUMENTTEMPLATE (ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCUMENTTEMPLATE
   where (ID) in (select ID from A_DOCUMENTTEMPLATE))
  MINUS
  (select ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCUMENTTEMPLATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCUMENTTEMPLATE (ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCUMENTCLSREF,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCUMENTTEMPLATE
where (ID) in
    (select ID from DOCUMENTTEMPLATE
     MINUS
     select ID from A_DOCUMENTTEMPLATE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCUMENTTEMPLATEFIELDS

update A_DOCUMENTTEMPLATEFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCUMENTTEMPLATEFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCUMENTTEMPLATEFIELDS)
/

update A_DOCUMENTTEMPLATEFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from DOCUMENTTEMPLATEFIELDS
   where (ID) in (select ID from A_DOCUMENTTEMPLATEFIELDS))
  MINUS
  (select ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_DOCUMENTTEMPLATEFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCUMENTTEMPLATEFIELDS (ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCUMENTTEMPLATEFIELDS
   where (ID) in (select ID from A_DOCUMENTTEMPLATEFIELDS))
  MINUS
  (select ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCUMENTTEMPLATEFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCUMENTTEMPLATEFIELDS (ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCUMENTCLSREF,FIELDS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCUMENTTEMPLATEFIELDS
where (ID) in
    (select ID from DOCUMENTTEMPLATEFIELDS
     MINUS
     select ID from A_DOCUMENTTEMPLATEFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DOCUMENTTYPES

update A_DOCUMENTTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DOCUMENTTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DOCUMENTTYPES)
/

update A_DOCUMENTTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME
   from DOCUMENTTYPES
   where (ID) in (select ID from A_DOCUMENTTYPES))
  MINUS
  (select ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME
   from A_DOCUMENTTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DOCUMENTTYPES (ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DOCUMENTTYPES
   where (ID) in (select ID from A_DOCUMENTTYPES))
  MINUS
  (select ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DOCUMENTTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DOCUMENTTYPES (ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PROGINDEX,NAME,NOTE,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,USESTATE,DBTABLE,NEEDEDS,URMDBTABLE,ICONCOLLECTION,NEEDHIDEEDSFORM,SCHEMAVERSION,LOCKMASK,DEFAULTACTIONMACROSNAME,DOCUMENTKIND,SHORTNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DOCUMENTTYPES
where (ID) in
    (select ID from DOCUMENTTYPES
     MINUS
     select ID from A_DOCUMENTTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_DUALRIGHTS

update A_DUALRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_DUALRIGHTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from DUALRIGHTS)
/

update A_DUALRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER
   from DUALRIGHTS
   where (ID) in (select ID from A_DUALRIGHTS))
  MINUS
  (select ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER
   from A_DUALRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_DUALRIGHTS (ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from DUALRIGHTS
   where (ID) in (select ID from A_DUALRIGHTS))
  MINUS
  (select ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_DUALRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_DUALRIGHTS (ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,USERREF,ISGROUP,RIGHTREF,ISREJECT,OBJREF1,OBJREF2,CREATEDATE,UPDATEDATE,OBJREF1UP,OBJREF2UP,RIGHTKINDREF,OBJECTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from DUALRIGHTS
where (ID) in
    (select ID from DUALRIGHTS
     MINUS
     select ID from A_DUALRIGHTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ED_BUFF_DATA

update A_ED_BUFF_DATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ED_BUFF_DATA
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ED_BUFF_DATA)
/

update A_ED_BUFF_DATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from ED_BUFF_DATA
   where (ID) in (select ID from A_ED_BUFF_DATA))
  MINUS
  (select ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_ED_BUFF_DATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ED_BUFF_DATA (ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ED_BUFF_DATA
   where (ID) in (select ID from A_ED_BUFF_DATA))
  MINUS
  (select ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ED_BUFF_DATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ED_BUFF_DATA (ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DATATYPECODE,RECORDINDEX,INT_1,INT_2,INT_3,INT_4,INT_5,INT_6,INT_7,INT_8,INT_9,INT_10,INT_11,INT_12,INT_13,INT_14,INT_15,INT_16,INT_17,INT_18,INT_19,INT_20,SUM_1,SUM_2,SUM_3,SUM_4,SUM_5,SUM_6,SUM_7,SUM_8,SUM_9,SUM_10,SUM_11,SUM_12,SUM_13,SUM_14,SUM_15,SUM_16,SUM_17,SUM_18,SUM_19,SUM_20,SUM_21,SUM_22,SUM_23,SUM_24,SUM_25,SUM_26,SUM_27,SUM_28,SUM_29,SUM_30,SUM_31,SUM_32,SUM_33,SUM_34,SUM_35,SUM_36,SUM_37,SUM_38,SUM_39,SUM_40,SUM_41,SUM_42,SUM_43,SUM_44,SUM_45,NEWDATE_1,NEWDATE_2,NEWDATE_3,NEWDATE_4,NEWDATE_5,NEWDATE_6,NEWDATE_7,NEWDATE_8,NEWDATE_9,NEWDATE_10,NOTE10_1,NOTE10_2,NOTE10_3,NOTE10_4,NOTE10_5,NOTE10_6,NOTE10_7,NOTE10_8,NOTE10_9,NOTE10_10,NOTE50_1,NOTE50_2,NOTE50_3,NOTE50_4,NOTE50_5,NOTE50_6,NOTE50_7,NOTE50_8,NOTE50_9,NOTE50_10,NOTE255_1,NOTE255_2,NOTE255_3,NOTE255_4,NOTE255_5,NOTE255_6,NOTE255_7,NOTE255_8,NOTE255_9,NOTE255_10,NOTE1024_1,NOTE1024_2,NOTE1024_3,NOTE1024_4,NOTE1024_5,NOTE1024_6,NOTE1024_7,NOTE1024_8,NOTE1024_9,NOTE1024_10,NOTE4000_1,NOTE4000_2,NOTE4000_3,NOTE4000_4,NOTE4000_5,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ED_BUFF_DATA
where (ID) in
    (select ID from ED_BUFF_DATA
     MINUS
     select ID from A_ED_BUFF_DATA
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ED_CORRECTIONCAPTION

update A_ED_CORRECTIONCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ED_CORRECTIONCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ED_CORRECTIONCAPTION)
/

update A_ED_CORRECTIONCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER
   from ED_CORRECTIONCAPTION
   where (ID) in (select ID from A_ED_CORRECTIONCAPTION))
  MINUS
  (select ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER
   from A_ED_CORRECTIONCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ED_CORRECTIONCAPTION (ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ED_CORRECTIONCAPTION
   where (ID) in (select ID from A_ED_CORRECTIONCAPTION))
  MINUS
  (select ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ED_CORRECTIONCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ED_CORRECTIONCAPTION (ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ELDOCNUMBER,DOCDATE,INN,KPP,NAME,FACIALCODE,FUND_SOURCE,SOURCEINN,SOURCEKPP,SOURCEACC,PROCSTATE,PACKETNUMBER,PROCDOCCLASS,DOCUMENTNAME,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,DEPARTMENTCLS,SOURCENAME,PROCUSEINFO,DOL_RUK,NAME_RUK,DOL_ISP,NAME_ISP,TEL_ISP,DATE_POD,DOCNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ED_CORRECTIONCAPTION
where (ID) in
    (select ID from ED_CORRECTIONCAPTION
     MINUS
     select ID from A_ED_CORRECTIONCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ED_CORRECTIONDETAIL

update A_ED_CORRECTIONDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ED_CORRECTIONDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ED_CORRECTIONDETAIL)
/

update A_ED_CORRECTIONDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO
   from ED_CORRECTIONDETAIL
   where (ID) in (select ID from A_ED_CORRECTIONDETAIL))
  MINUS
  (select ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO
   from A_ED_CORRECTIONDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ED_CORRECTIONDETAIL (ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ED_CORRECTIONDETAIL
   where (ID) in (select ID from A_ED_CORRECTIONDETAIL))
  MINUS
  (select ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ED_CORRECTIONDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ED_CORRECTIONDETAIL (ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ELDOCNUMBER,KOD_DOC,ORIGINALNUMBER,ORIGINALDATE,FACIALCODE,SUMMA,CLSVALUE,CLSTYPE,DESTNAME,DESTINN,DESTKPP,ADDCLS,PURPOSE,FUND_SOURCE,NOM_ZR,DATE_ZR,NOTE,RECORDINDEX,PARENTID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKTMO,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ED_CORRECTIONDETAIL
where (ID) in
    (select ID from ED_CORRECTIONDETAIL
     MINUS
     select ID from A_ED_CORRECTIONDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ED_DETAIL

update A_ED_DETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ED_DETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ED_DETAIL)
/

update A_ED_DETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE
   from ED_DETAIL
   where (ID) in (select ID from A_ED_DETAIL))
  MINUS
  (select ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE
   from A_ED_DETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ED_DETAIL (ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ED_DETAIL
   where (ID) in (select ID from A_ED_DETAIL))
  MINUS
  (select ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ED_DETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ED_DETAIL (ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,HEADERTYPE,KR,IFS,KD,ADDCLS,SUMMA,SUMMAKIND,PROMISE,NOTE,PURPOSE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ED_DETAIL
where (ID) in
    (select ID from ED_DETAIL
     MINUS
     select ID from A_ED_DETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ED_OUTPAYDOC

update A_ED_OUTPAYDOC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ED_OUTPAYDOC
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ED_OUTPAYDOC)
/

update A_ED_OUTPAYDOC set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL
   from ED_OUTPAYDOC
   where (ID) in (select ID from A_ED_OUTPAYDOC))
  MINUS
  (select ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL
   from A_ED_OUTPAYDOC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ED_OUTPAYDOC (ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ED_OUTPAYDOC
   where (ID) in (select ID from A_ED_OUTPAYDOC))
  MINUS
  (select ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ED_OUTPAYDOC
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ED_OUTPAYDOC (ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCDATE,PAYQUEUE,PAYKIND,NOTE,TAXNOTE,BUDGETCLS,SUMMA,SOURCEKPP,SOURCENAME,SOURCEACC,SOURCEUFK_ORGNAME,SOURCEUFK_ACC,SOURCEBANKMFO,SOURCEBANKNAME,SOURCEBANKCOR,DESTKPP,DESTNAME,DESTUFK_ORGNAME,DESTACC,DESTFACIALCODE,DESTBANKMFO,DESTBANKNAME,DESTBANKCOR,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ELDOCNUMBER,PACKETDATE,PROCSTATE,PROCDOCCLASS,PROCUSEINFO,PROCNOTE,DOCSOURCE,DOCREF,ELDOCREF,PROGINDEX,ISLASTVERSION,PACKETNUMBER,SOURCEFILIALBANKNAME,DESTFILIALBANKNAME,DOCUMENTNAME,SOURCEUFKCODE,SOURCETOFK,SOURCEFACIALACC_CLS,KOD_IST,VOS_GUID,VOS_NOM,VOS_DATE,VOS_SUM,VOS_PAYERINN,VOS_PAYERKPP,DEPARTMENTCLS,DOCNUMBER,SOURCEINN,SOURCEUFK_INN,DESTINN,DESTUFK_INN,DOCOSN,UINCODE,SIGNERS,CARDNUMBER,SENDERKOD,SENDERNAME,GETERKOD,GETERNAME,BUDGETLEVEL,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ED_OUTPAYDOC
where (ID) in
    (select ID from ED_OUTPAYDOC
     MINUS
     select ID from A_ED_OUTPAYDOC
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ED_SALDO

update A_ED_SALDO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ED_SALDO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ED_SALDO)
/

update A_ED_SALDO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER
   from ED_SALDO
   where (ID) in (select ID from A_ED_SALDO))
  MINUS
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER
   from A_ED_SALDO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ED_SALDO (ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ED_SALDO
   where (ID) in (select ID from A_ED_SALDO))
  MINUS
  (select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ED_SALDO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ED_SALDO (ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GETDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACC,DEBIT,CREDIT,OUTBALANCEPASSIVE,OUTBALANCEACTIVE,INBALANCEPASSIVE,INBALANCEACTIVE,FORMDATE,TIMEACCEPT,LASTDATE,CODEFORMAT,INYEARLIMIT,INCASHCHARGE,INLIMIT,INFIN,OUTYEARLIMIT,OUTCASHCHARGE,OUTLIMIT,OUTFIN,PACKETNUMBER,ELPACKETNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ED_SALDO
where (ID) in
    (select ID from ED_SALDO
     MINUS
     select ID from A_ED_SALDO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ENUMS

update A_ENUMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ENUMS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ENUMS)
/

update A_ENUMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM
   from ENUMS
   where (ID) in (select ID from A_ENUMS))
  MINUS
  (select ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM
   from A_ENUMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ENUMS (ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ENUMS
   where (ID) in (select ID from A_ENUMS))
  MINUS
  (select ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ENUMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ENUMS (ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ISSYSTEM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ENUMS
where (ID) in
    (select ID from ENUMS
     MINUS
     select ID from A_ENUMS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ENUMVALUES

update A_ENUMVALUES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ENUMVALUES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ENUMVALUES)
/

update A_ENUMVALUES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from ENUMVALUES
   where (ID) in (select ID from A_ENUMVALUES))
  MINUS
  (select ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_ENUMVALUES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ENUMVALUES (ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ENUMVALUES
   where (ID) in (select ID from A_ENUMVALUES))
  MINUS
  (select ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ENUMVALUES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ENUMVALUES (ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ENUMREF,VAL,NAME,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ENUMVALUES
where (ID) in
    (select ID from ENUMVALUES
     MINUS
     select ID from A_ENUMVALUES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ERROR

update A_ERROR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ERROR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ERROR)
/

update A_ERROR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME
   from ERROR
   where (ID) in (select ID from A_ERROR))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME
   from A_ERROR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ERROR (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ERROR
   where (ID) in (select ID from A_ERROR))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ERROR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ERROR (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,IMPORTANCE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ERROR
where (ID) in
    (select ID from ERROR
     MINUS
     select ID from A_ERROR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ESTIMATE

update A_ESTIMATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ESTIMATE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ESTIMATE)
/

update A_ESTIMATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX
   from ESTIMATE
   where (ID) in (select ID from A_ESTIMATE))
  MINUS
  (select ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX
   from A_ESTIMATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ESTIMATE (ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ESTIMATE
   where (ID) in (select ID from A_ESTIMATE))
  MINUS
  (select ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ESTIMATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ESTIMATE (ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,OBJECT,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,RECORDINDEX,FACIALACC_CLS,CLOSEDATE,PAYMENTDATE,NOTE,SENDERID,SENDERRECORDID,PRODUCTCLS,FINSUMMA,PRICE,RVERSION,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ESTIMATE
where (ID) in
    (select ID from ESTIMATE
     MINUS
     select ID from A_ESTIMATE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_EXCHNUMBER

update A_EXCHNUMBER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (DATEEX,CODEFORMAT,NUMBERTYPE) in (select DATEEX,CODEFORMAT,NUMBERTYPE from A_EXCHNUMBER
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select DATEEX,CODEFORMAT,NUMBERTYPE from EXCHNUMBER)
/

update A_EXCHNUMBER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (DATEEX,CODEFORMAT,NUMBERTYPE) in (select DATEEX,CODEFORMAT,NUMBERTYPE from (
  (select DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE
   from EXCHNUMBER
   where (DATEEX,CODEFORMAT,NUMBERTYPE) in (select DATEEX,CODEFORMAT,NUMBERTYPE from A_EXCHNUMBER))
  MINUS
  (select DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE
   from A_EXCHNUMBER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_EXCHNUMBER (DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from EXCHNUMBER
   where (DATEEX,CODEFORMAT,NUMBERTYPE) in (select DATEEX,CODEFORMAT,NUMBERTYPE from A_EXCHNUMBER))
  MINUS
  (select DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_EXCHNUMBER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_EXCHNUMBER (DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select DATEEX,CODEFORMAT,NUMBERTYPE,ELNUM,LOCKUSER,LOCKDATE,LOCKINGFLAG,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from EXCHNUMBER
where (DATEEX,CODEFORMAT,NUMBERTYPE) in
    (select DATEEX,CODEFORMAT,NUMBERTYPE from EXCHNUMBER
     MINUS
     select DATEEX,CODEFORMAT,NUMBERTYPE from A_EXCHNUMBER
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_EXCHNUMBERLIMITS

update A_EXCHNUMBERLIMITS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (CODEFORMAT,NUMBERTYPE) in (select CODEFORMAT,NUMBERTYPE from A_EXCHNUMBERLIMITS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select CODEFORMAT,NUMBERTYPE from EXCHNUMBERLIMITS)
/

update A_EXCHNUMBERLIMITS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (CODEFORMAT,NUMBERTYPE) in (select CODEFORMAT,NUMBERTYPE from (
  (select CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER
   from EXCHNUMBERLIMITS
   where (CODEFORMAT,NUMBERTYPE) in (select CODEFORMAT,NUMBERTYPE from A_EXCHNUMBERLIMITS))
  MINUS
  (select CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER
   from A_EXCHNUMBERLIMITS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_EXCHNUMBERLIMITS (CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from EXCHNUMBERLIMITS
   where (CODEFORMAT,NUMBERTYPE) in (select CODEFORMAT,NUMBERTYPE from A_EXCHNUMBERLIMITS))
  MINUS
  (select CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_EXCHNUMBERLIMITS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_EXCHNUMBERLIMITS (CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select CODEFORMAT,NUMBERTYPE,MINNUMBER,MAXNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from EXCHNUMBERLIMITS
where (CODEFORMAT,NUMBERTYPE) in
    (select CODEFORMAT,NUMBERTYPE from EXCHNUMBERLIMITS
     MINUS
     select CODEFORMAT,NUMBERTYPE from A_EXCHNUMBERLIMITS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_EXECUTIONDOCUMENTSDETAIL

update A_EXECUTIONDOCUMENTSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_EXECUTIONDOCUMENTSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from EXECUTIONDOCUMENTSDETAIL)
/

update A_EXECUTIONDOCUMENTSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY
   from EXECUTIONDOCUMENTSDETAIL
   where (ID) in (select ID from A_EXECUTIONDOCUMENTSDETAIL))
  MINUS
  (select ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY
   from A_EXECUTIONDOCUMENTSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_EXECUTIONDOCUMENTSDETAIL (ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from EXECUTIONDOCUMENTSDETAIL
   where (ID) in (select ID from A_EXECUTIONDOCUMENTSDETAIL))
  MINUS
  (select ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_EXECUTIONDOCUMENTSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_EXECUTIONDOCUMENTSDETAIL (ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,AMOUNT,COST,VATPERCENT,VATSUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,SUMMA,SENDERID,SENDERRECORDID,PRODUCTCLS,RECORDINDEX,PRICE,RVERSION,OBJECT,PRICEVAT,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from EXECUTIONDOCUMENTSDETAIL
where (ID) in
    (select ID from EXECUTIONDOCUMENTSDETAIL
     MINUS
     select ID from A_EXECUTIONDOCUMENTSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_EXEMPTIONTITLE

update A_EXEMPTIONTITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_EXEMPTIONTITLE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from EXEMPTIONTITLE)
/

update A_EXEMPTIONTITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER
   from EXEMPTIONTITLE
   where (ID) in (select ID from A_EXEMPTIONTITLE))
  MINUS
  (select ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER
   from A_EXEMPTIONTITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_EXEMPTIONTITLE (ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from EXEMPTIONTITLE
   where (ID) in (select ID from A_EXEMPTIONTITLE))
  MINUS
  (select ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_EXEMPTIONTITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_EXEMPTIONTITLE (ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,IDATE,ACCEPTDATE,NUMINQUIRY,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from EXEMPTIONTITLE
where (ID) in
    (select ID from EXEMPTIONTITLE
     MINUS
     select ID from A_EXEMPTIONTITLE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FACT

update A_FACT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FACT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FACT)
/

update A_FACT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from FACT
   where (ID) in (select ID from A_FACT))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_FACT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FACT (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FACT
   where (ID) in (select ID from A_FACT))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FACT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FACT (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,CREATERUSER,UPDATERUSER,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FACT
where (ID) in
    (select ID from FACT
     MINUS
     select ID from A_FACT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FAXDOCS

update A_FAXDOCS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FAXDOCS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FAXDOCS)
/

update A_FAXDOCS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE
   from FAXDOCS
   where (ID) in (select ID from A_FAXDOCS))
  MINUS
  (select ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE
   from A_FAXDOCS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FAXDOCS (ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FAXDOCS
   where (ID) in (select ID from A_FAXDOCS))
  MINUS
  (select ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FAXDOCS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FAXDOCS (ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,OWNERID,OWNERDOCNUMBER,OWNERDATE,FILENAME,CLIENTID,DOCTYPE,REJECT,REJECTNOTE,CREATEDATE,UPDATEDATE,FACIALACC_CLS,PRIMARYDOCTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FAXDOCS
where (ID) in
    (select ID from FAXDOCS
     MINUS
     select ID from A_FAXDOCS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FIELDSINFO

update A_FIELDSINFO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FIELDSINFO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FIELDSINFO)
/

update A_FIELDSINFO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME
   from FIELDSINFO
   where (ID) in (select ID from A_FIELDSINFO))
  MINUS
  (select ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME
   from A_FIELDSINFO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FIELDSINFO (ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FIELDSINFO
   where (ID) in (select ID from A_FIELDSINFO))
  MINUS
  (select ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FIELDSINFO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FIELDSINFO (ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FIELDKIND,DESCRIPTIONLEVEL,ANCESTORREF,SELECTIONREF,TABLEREF,FIELDNAME,DATATYPE,SUBDATATYPE,FIELDSIZE,DISPLAYLABEL,NOTE,DEFAULTWIDTH,EDITMASK,DISPLAYFORMAT,EDITFORMAT,CANTEDIT,NOVISUALIZE,ENUMSREF,REQUIRED,FOREIGNKEY,ONDELACTION,PRIMARYKEY,ISRVERSION,LIMITPARAMNAMES,FOLLOWORDER,SORTDIRECTION,SORTORDER,AGRFUNCTION,FLAGFIELDNAME,FLAGDISPLAYLABEL,FLAGNOTE,FLAGDEFAULTWIDTH,FLAGCANTEDIT,FLAGNOVISUALIZE,FLAGREQUIRED,FLAGLIMITPARAMNAMES,FLAGAGRFUNCTION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISTIMESTAMPFIELD,ISBUDGET,AVAILABLEINDEREF,ANNOTATION,ALIAS,DEREFNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FIELDSINFO
where (ID) in
    (select ID from FIELDSINFO
     MINUS
     select ID from A_FIELDSINFO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINCLAIM

update A_FINCLAIM set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINCLAIM
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINCLAIM)
/

update A_FINCLAIM set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from FINCLAIM
   where (ID) in (select ID from A_FINCLAIM))
  MINUS
  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_FINCLAIM
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINCLAIM (ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINCLAIM
   where (ID) in (select ID from A_FINCLAIM))
  MINUS
  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINCLAIM
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINCLAIM (ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINCLAIM
where (ID) in
    (select ID from FINCLAIM
     MINUS
     select ID from A_FINCLAIM
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINCLAIMDET

update A_FINCLAIMDET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINCLAIMDET
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINCLAIMDET)
/

update A_FINCLAIMDET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from FINCLAIMDET
   where (ID) in (select ID from A_FINCLAIMDET))
  MINUS
  (select ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_FINCLAIMDET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINCLAIMDET (ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINCLAIMDET
   where (ID) in (select ID from A_FINCLAIMDET))
  MINUS
  (select ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINCLAIMDET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINCLAIMDET (ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUD_REF,REF,KD,SUBKD,GOSNI,SUMMA,ASUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINCLAIMDET
where (ID) in
    (select ID from FINCLAIMDET
     MINUS
     select ID from A_FINCLAIMDET
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINDOCCAPTION

update A_FINDOCCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINDOCCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINDOCCAPTION)
/

update A_FINDOCCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION
   from FINDOCCAPTION
   where (ID) in (select ID from A_FINDOCCAPTION))
  MINUS
  (select ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION
   from A_FINDOCCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINDOCCAPTION (ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINDOCCAPTION
   where (ID) in (select ID from A_FINDOCCAPTION))
  MINUS
  (select ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINDOCCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINDOCCAPTION (ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,MAKEDATE,ACCEPTDATE,USERNOTE,DFACCOUNT,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,ELPACKETNAME,RVERSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINDOCCAPTION
where (ID) in
    (select ID from FINDOCCAPTION
     MINUS
     select ID from A_FINDOCCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINTENDER

update A_FINTENDER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINTENDER
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINTENDER)
/

update A_FINTENDER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from FINTENDER
   where (ID) in (select ID from A_FINTENDER))
  MINUS
  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_FINTENDER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINTENDER (ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINTENDER
   where (ID) in (select ID from A_FINTENDER))
  MINUS
  (select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINTENDER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINTENDER (ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUD_REF,DAT,ACC_REF,NUMSTR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINTENDER
where (ID) in
    (select ID from FINTENDER
     MINUS
     select ID from A_FINTENDER
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINTENDERDET

update A_FINTENDERDET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINTENDERDET
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINTENDERDET)
/

update A_FINTENDERDET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from FINTENDERDET
   where (ID) in (select ID from A_FINTENDERDET))
  MINUS
  (select ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_FINTENDERDET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINTENDERDET (ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINTENDERDET
   where (ID) in (select ID from A_FINTENDERDET))
  MINUS
  (select ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINTENDERDET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINTENDERDET (ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUD_REF,REF,KFSR,KVSR,KCSR,KVR,KESR,REGION,FINTYPE,MEANSTYPE,SUMMA,ASUMMA,NOTE,REESRT,ACC_REF,FACIALACC,DOGNUM,DOGDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINTENDERDET
where (ID) in
    (select ID from FINTENDERDET
     MINUS
     select ID from A_FINTENDERDET
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINTENDERORG

update A_FINTENDERORG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINTENDERORG
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINTENDERORG)
/

update A_FINTENDERORG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACC_REF,REF
   from FINTENDERORG
   where (ID) in (select ID from A_FINTENDERORG))
  MINUS
  (select ID,ACC_REF,REF
   from A_FINTENDERORG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINTENDERORG (ID,ACC_REF,REF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACC_REF,REF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINTENDERORG
   where (ID) in (select ID from A_FINTENDERORG))
  MINUS
  (select ID,ACC_REF,REF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINTENDERORG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINTENDERORG (ID,ACC_REF,REF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACC_REF,REF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINTENDERORG
where (ID) in
    (select ID from FINTENDERORG
     MINUS
     select ID from A_FINTENDERORG
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FINTYPE

update A_FINTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FINTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FINTYPE)
/

update A_FINTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from FINTYPE
   where (ID) in (select ID from A_FINTYPE))
  MINUS
  (select ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_FINTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FINTYPE (ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FINTYPE
   where (ID) in (select ID from A_FINTYPE))
  MINUS
  (select ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FINTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FINTYPE (ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCOUNT,CREATEDATE,UPDATEDATE,GENBUHACCFLAG,NAME,CODE,BUDGETREF,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FINTYPE
where (ID) in
    (select ID from FINTYPE
     MINUS
     select ID from A_FINTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_FUNDSSOURCE

update A_FUNDSSOURCE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_FUNDSSOURCE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from FUNDSSOURCE)
/

update A_FUNDSSOURCE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE
   from FUNDSSOURCE
   where (ID) in (select ID from A_FUNDSSOURCE))
  MINUS
  (select ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE
   from A_FUNDSSOURCE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_FUNDSSOURCE (ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from FUNDSSOURCE
   where (ID) in (select ID from A_FUNDSSOURCE))
  MINUS
  (select ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_FUNDSSOURCE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_FUNDSSOURCE (ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,SHORTNAME,NOTE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from FUNDSSOURCE
where (ID) in
    (select ID from FUNDSSOURCE
     MINUS
     select ID from A_FUNDSSOURCE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GENERALDOCSDETAIL

update A_GENERALDOCSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GENERALDOCSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GENERALDOCSDETAIL)
/

update A_GENERALDOCSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from GENERALDOCSDETAIL
   where (ID) in (select ID from A_GENERALDOCSDETAIL))
  MINUS
  (select ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_GENERALDOCSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GENERALDOCSDETAIL (ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GENERALDOCSDETAIL
   where (ID) in (select ID from A_GENERALDOCSDETAIL))
  MINUS
  (select ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GENERALDOCSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GENERALDOCSDETAIL (ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FACIALACCCLS,RECORDINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GENERALDOCSDETAIL
where (ID) in
    (select ID from GENERALDOCSDETAIL
     MINUS
     select ID from A_GENERALDOCSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GENERALDOCUMENTS

update A_GENERALDOCUMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GENERALDOCUMENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GENERALDOCUMENTS)
/

update A_GENERALDOCUMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from GENERALDOCUMENTS
   where (ID) in (select ID from A_GENERALDOCUMENTS))
  MINUS
  (select ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_GENERALDOCUMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GENERALDOCUMENTS (ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GENERALDOCUMENTS
   where (ID) in (select ID from A_GENERALDOCUMENTS))
  MINUS
  (select ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GENERALDOCUMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GENERALDOCUMENTS (ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FACIALACCCLS,DOCNUMBER,DOCBASE,ARCHIVEDOCTYPE,NAME,BEGINDATE,ENDDATE,REGISTRATIONDATE,DOCTYPESLIST,REJECTCLS,REJECTCAUSE,PROGINDEX,DOCSTATEREF,LASTEXTRCHANGE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GENERALDOCUMENTS
where (ID) in
    (select ID from GENERALDOCUMENTS
     MINUS
     select ID from A_GENERALDOCUMENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GOSNI

update A_GOSNI set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GOSNI
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GOSNI)
/

update A_GOSNI set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME
   from GOSNI
   where (ID) in (select ID from A_GOSNI))
  MINUS
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME
   from A_GOSNI
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GOSNI (ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GOSNI
   where (ID) in (select ID from A_GOSNI))
  MINUS
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GOSNI
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GOSNI (ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GOSNI
where (ID) in
    (select ID from GOSNI
     MINUS
     select ID from A_GOSNI
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GROUPINF_CLS

update A_GROUPINF_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GROUPINF_CLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GROUPINF_CLS)
/

update A_GROUPINF_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from GROUPINF_CLS
   where (ID) in (select ID from A_GROUPINF_CLS))
  MINUS
  (select ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_GROUPINF_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GROUPINF_CLS (ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GROUPINF_CLS
   where (ID) in (select ID from A_GROUPINF_CLS))
  MINUS
  (select ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GROUPINF_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GROUPINF_CLS (ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GROUPINF_CLS
where (ID) in
    (select ID from GROUPINF_CLS
     MINUS
     select ID from A_GROUPINF_CLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GROUPSRIGHTS

update A_GROUPSRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GROUPSRIGHTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GROUPSRIGHTS)
/

update A_GROUPSRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER
   from GROUPSRIGHTS
   where (ID) in (select ID from A_GROUPSRIGHTS))
  MINUS
  (select ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER
   from A_GROUPSRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GROUPSRIGHTS (ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GROUPSRIGHTS
   where (ID) in (select ID from A_GROUPSRIGHTS))
  MINUS
  (select ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GROUPSRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GROUPSRIGHTS (ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GROUPREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GROUPSRIGHTS
where (ID) in
    (select ID from GROUPSRIGHTS
     MINUS
     select ID from A_GROUPSRIGHTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GROUPSWORKPLACES

update A_GROUPSWORKPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GROUPSWORKPLACES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GROUPSWORKPLACES)
/

update A_GROUPSWORKPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from GROUPSWORKPLACES
   where (ID) in (select ID from A_GROUPSWORKPLACES))
  MINUS
  (select ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_GROUPSWORKPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GROUPSWORKPLACES (ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GROUPSWORKPLACES
   where (ID) in (select ID from A_GROUPSWORKPLACES))
  MINUS
  (select ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GROUPSWORKPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GROUPSWORKPLACES (ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GROUPREF,WORKPLACEREF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GROUPSWORKPLACES
where (ID) in
    (select ID from GROUPSWORKPLACES
     MINUS
     select ID from A_GROUPSWORKPLACES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_GUARANTEE

update A_GUARANTEE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_GUARANTEE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from GUARANTEE)
/

update A_GUARANTEE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE
   from GUARANTEE
   where (ID) in (select ID from A_GUARANTEE))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE
   from A_GUARANTEE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_GUARANTEE (ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from GUARANTEE
   where (ID) in (select ID from A_GUARANTEE))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_GUARANTEE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_GUARANTEE (ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,RECORDINDEX,PROGINDEX,ACCEPTDATE,RECORDDATE,PLANDATE,CREDIT,DEBIT,SOURCEDOCNUMBER,NOTE,BUHPAYMENTCLS,DOCTYPE,PERIODSTART,PERIODEND,CURRENCYCLS,SUBRECORDINDEX,SUBPROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,PARENTID,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from GUARANTEE
where (ID) in
    (select ID from GUARANTEE
     MINUS
     select ID from A_GUARANTEE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INCCURRENCY

update A_INCCURRENCY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INCCURRENCY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INCCURRENCY)
/

update A_INCCURRENCY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CURRENCYSUM,EXCHANGE,DELTA
   from INCCURRENCY
   where (ID) in (select ID from A_INCCURRENCY))
  MINUS
  (select ID,CURRENCYSUM,EXCHANGE,DELTA
   from A_INCCURRENCY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INCCURRENCY (ID,CURRENCYSUM,EXCHANGE,DELTA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CURRENCYSUM,EXCHANGE,DELTA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INCCURRENCY
   where (ID) in (select ID from A_INCCURRENCY))
  MINUS
  (select ID,CURRENCYSUM,EXCHANGE,DELTA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INCCURRENCY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INCCURRENCY (ID,CURRENCYSUM,EXCHANGE,DELTA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CURRENCYSUM,EXCHANGE,DELTA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INCCURRENCY
where (ID) in
    (select ID from INCCURRENCY
     MINUS
     select ID from A_INCCURRENCY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INCOMES_ARREARS

update A_INCOMES_ARREARS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INCOMES_ARREARS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INCOMES_ARREARS)
/

update A_INCOMES_ARREARS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ARREARSDATE
   from INCOMES_ARREARS
   where (ID) in (select ID from A_INCOMES_ARREARS))
  MINUS
  (select ID,ARREARSDATE
   from A_INCOMES_ARREARS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INCOMES_ARREARS (ID,ARREARSDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ARREARSDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INCOMES_ARREARS
   where (ID) in (select ID from A_INCOMES_ARREARS))
  MINUS
  (select ID,ARREARSDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INCOMES_ARREARS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INCOMES_ARREARS (ID,ARREARSDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ARREARSDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INCOMES_ARREARS
where (ID) in
    (select ID from INCOMES_ARREARS
     MINUS
     select ID from A_INCOMES_ARREARS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INCOMESDATA

update A_INCOMESDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INCOMESDATA
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INCOMESDATA)
/

update A_INCOMESDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND
   from INCOMESDATA
   where (ID) in (select ID from A_INCOMESDATA))
  MINUS
  (select ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND
   from A_INCOMESDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INCOMESDATA (ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INCOMESDATA
   where (ID) in (select ID from A_INCOMESDATA))
  MINUS
  (select ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INCOMESDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INCOMESDATA (ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,KD,SUBKD,REGIONCLS,DOCTYPE,QUARTER1,QUARTER2,QUARTER3,QUARTER4,NOTE,PROGINDEX,RECORDINDEX,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACC_CLS,MEANSTYPE,RVERSION,FACT,SENDERID,SENDERRECORDID,FUNDSSOURCE,STIMATEID,TRANSFERTCLS,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,ASSIGNMENTKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INCOMESDATA
where (ID) in
    (select ID from INCOMESDATA
     MINUS
     select ID from A_INCOMESDATA
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INCOMESNOTIF

update A_INCOMESNOTIF set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INCOMESNOTIF
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INCOMESNOTIF)
/

update A_INCOMESNOTIF set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD
   from INCOMESNOTIF
   where (ID) in (select ID from A_INCOMESNOTIF))
  MINUS
  (select ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD
   from A_INCOMESNOTIF
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INCOMESNOTIF (ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INCOMESNOTIF
   where (ID) in (select ID from A_INCOMESNOTIF))
  MINUS
  (select ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INCOMESNOTIF
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INCOMESNOTIF (ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,BUILDDATE,ACCEPTDATE,DOCBASEDATE,DOCBASETYPE,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,VARIANT,ANUMBER,ATYPE,RVERSION,SENDERID,SENDERRECORDID,DOCBASENUMBER,LASTEXTRCHANGE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,PLANDOCTYPE,STIMATEID,PROGINDEX,ASSIGNMENTSOURCE,KPPERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INCOMESNOTIF
where (ID) in
    (select ID from INCOMESNOTIF
     MINUS
     select ID from A_INCOMESNOTIF
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INCTEMPLATEDETAIL

update A_INCTEMPLATEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INCTEMPLATEDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INCTEMPLATEDETAIL)
/

update A_INCTEMPLATEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF
   from INCTEMPLATEDETAIL
   where (ID) in (select ID from A_INCTEMPLATEDETAIL))
  MINUS
  (select ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF
   from A_INCTEMPLATEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INCTEMPLATEDETAIL (ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INCTEMPLATEDETAIL
   where (ID) in (select ID from A_INCTEMPLATEDETAIL))
  MINUS
  (select ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INCTEMPLATEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INCTEMPLATEDETAIL (ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KD,SUBKD,REGIONCLS,DOCTYPE,ACCOUNTINDEX,TITLE_REF,PERCENT,PERCENTTOTAL,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INCTEMPLATEDETAIL
where (ID) in
    (select ID from INCTEMPLATEDETAIL
     MINUS
     select ID from A_INCTEMPLATEDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INCTEMPLATETITLE

update A_INCTEMPLATETITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INCTEMPLATETITLE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INCTEMPLATETITLE)
/

update A_INCTEMPLATETITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF
   from INCTEMPLATETITLE
   where (ID) in (select ID from A_INCTEMPLATETITLE))
  MINUS
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF
   from A_INCTEMPLATETITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INCTEMPLATETITLE (ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INCTEMPLATETITLE
   where (ID) in (select ID from A_INCTEMPLATETITLE))
  MINUS
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INCTEMPLATETITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INCTEMPLATETITLE (ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PERCENTTOTAL,ACCEPTFLAG,KD,TEMPLATETYPE,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INCTEMPLATETITLE
where (ID) in
    (select ID from INCTEMPLATETITLE
     MINUS
     select ID from A_INCTEMPLATETITLE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INTCONST

update A_INTCONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INTCONST
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INTCONST)
/

update A_INTCONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE
   from INTCONST
   where (ID) in (select ID from A_INTCONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE
   from A_INTCONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INTCONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INTCONST
   where (ID) in (select ID from A_INTCONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INTCONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INTCONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,CREATEDATE,UPDATEDATE,ID,CREATERUSER,UPDATERUSER,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INTCONST
where (ID) in
    (select ID from INTCONST
     MINUS
     select ID from A_INTCONST
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INTERFACESBUHOP

update A_INTERFACESBUHOP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INTERFACESBUHOP
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INTERFACESBUHOP)
/

update A_INTERFACESBUHOP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER
   from INTERFACESBUHOP
   where (ID) in (select ID from A_INTERFACESBUHOP))
  MINUS
  (select ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER
   from A_INTERFACESBUHOP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INTERFACESBUHOP (ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INTERFACESBUHOP
   where (ID) in (select ID from A_INTERFACESBUHOP))
  MINUS
  (select ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INTERFACESBUHOP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INTERFACESBUHOP (ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,INTERFACECLS,BUHOPERATIONCLS,BUHOPERATIONPRIORITY,CREATEDATE,UPDATEDATE,DETAILNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INTERFACESBUHOP
where (ID) in
    (select ID from INTERFACESBUHOP
     MINUS
     select ID from A_INTERFACESBUHOP
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_INVESTOBJECT

update A_INVESTOBJECT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_INVESTOBJECT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from INVESTOBJECT)
/

update A_INVESTOBJECT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from INVESTOBJECT
   where (ID) in (select ID from A_INVESTOBJECT))
  MINUS
  (select ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_INVESTOBJECT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_INVESTOBJECT (ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from INVESTOBJECT
   where (ID) in (select ID from A_INVESTOBJECT))
  MINUS
  (select ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_INVESTOBJECT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_INVESTOBJECT (ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,SUBCODE,BUDGETFINSOURCEOBJECTCODE,NAME,SHORTNAME,OWNERLEVEL,BUDGETREF,REGIONCLS,BUDGETFINSOURCELEVEL,PARENTREF,STARTDATE,DELETEDATE,KVSR,KCSR,TARGETCLS,NOTE,MEANSTYPE,TRANSFERTCLS,FACT,OKTMO,NPAID,NPADATE,NPANUMBER,NPAGROUP,NPANAME,ADDRESS,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,SUBSIDYCLS,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from INVESTOBJECT
where (ID) in
    (select ID from INVESTOBJECT
     MINUS
     select ID from A_INVESTOBJECT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ITF_CTRL

update A_ITF_CTRL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ITF_CTRL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ITF_CTRL)
/

update A_ITF_CTRL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD
   from ITF_CTRL
   where (ID) in (select ID from A_ITF_CTRL))
  MINUS
  (select ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD
   from A_ITF_CTRL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ITF_CTRL (ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ITF_CTRL
   where (ID) in (select ID from A_ITF_CTRL))
  MINUS
  (select ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ITF_CTRL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ITF_CTRL (ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ITF_REF,CTRL_REF,NOTE,ORDERBY,CTRLOPTIONS,DOCINDEX,SCENARIOREF,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,CONTROLFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ITF_CTRL
where (ID) in
    (select ID from ITF_CTRL
     MINUS
     select ID from A_ITF_CTRL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ITF_DOCS

update A_ITF_DOCS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ITF_DOCS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ITF_DOCS)
/

update A_ITF_DOCS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from ITF_DOCS
   where (ID) in (select ID from A_ITF_DOCS))
  MINUS
  (select ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_ITF_DOCS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ITF_DOCS (ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ITF_DOCS
   where (ID) in (select ID from A_ITF_DOCS))
  MINUS
  (select ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ITF_DOCS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ITF_DOCS (ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ITF_REF,DOC_REF,NOTE,ORDERBY,DEFAULTEXEC,DOCINDEX,ELEMFILTER,ENABLE,ERRORMESSAGE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ITF_DOCS
where (ID) in
    (select ID from ITF_DOCS
     MINUS
     select ID from A_ITF_DOCS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KCSR

update A_KCSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KCSR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KCSR)
/

update A_KCSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from KCSR
   where (ID) in (select ID from A_KCSR))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_KCSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KCSR (ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KCSR
   where (ID) in (select ID from A_KCSR))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KCSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KCSR (ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,CODE,CONFORMITYCODE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KCSR
where (ID) in
    (select ID from KCSR
     MINUS
     select ID from A_KCSR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KDSHIFR

update A_KDSHIFR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KDSHIFR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KDSHIFR)
/

update A_KDSHIFR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER
   from KDSHIFR
   where (ID) in (select ID from A_KDSHIFR))
  MINUS
  (select ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER
   from A_KDSHIFR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KDSHIFR (ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KDSHIFR
   where (ID) in (select ID from A_KDSHIFR))
  MINUS
  (select ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KDSHIFR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KDSHIFR (ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SHIFR,NAME,SECTIONNAME,ROWLEVEL,TEMPLATENAME,LAYER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KDSHIFR
where (ID) in
    (select ID from KDSHIFR
     MINUS
     select ID from A_KDSHIFR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KDSHIFRDETAIL

update A_KDSHIFRDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KDSHIFRDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KDSHIFRDETAIL)
/

update A_KDSHIFRDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK
   from KDSHIFRDETAIL
   where (ID) in (select ID from A_KDSHIFRDETAIL))
  MINUS
  (select ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK
   from A_KDSHIFRDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KDSHIFRDETAIL (ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KDSHIFRDETAIL
   where (ID) in (select ID from A_KDSHIFRDETAIL))
  MINUS
  (select ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KDSHIFRDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KDSHIFRDETAIL (ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,KD,USEOLD,USENEW,KDEXT,KDEXTMASK,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KDSHIFRDETAIL
where (ID) in
    (select ID from KDSHIFRDETAIL
     MINUS
     select ID from A_KDSHIFRDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KESR

update A_KESR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KESR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KESR)
/

update A_KESR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from KESR
   where (ID) in (select ID from A_KESR))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_KESR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KESR (ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KESR
   where (ID) in (select ID from A_KESR))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KESR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KESR (ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CONTROLCODE,CREATEDATE,UPDATEDATE,ISEKR,ISEKD,ISEKI,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KESR
where (ID) in
    (select ID from KESR
     MINUS
     select ID from A_KESR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KESRSUBCODE

update A_KESRSUBCODE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KESRSUBCODE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KESRSUBCODE)
/

update A_KESRSUBCODE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from KESRSUBCODE
   where (ID) in (select ID from A_KESRSUBCODE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_KESRSUBCODE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KESRSUBCODE (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KESRSUBCODE
   where (ID) in (select ID from A_KESRSUBCODE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KESRSUBCODE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KESRSUBCODE (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KESRSUBCODE
where (ID) in
    (select ID from KESRSUBCODE
     MINUS
     select ID from A_KESRSUBCODE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KFSR

update A_KFSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KFSR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KFSR)
/

update A_KFSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from KFSR
   where (ID) in (select ID from A_KFSR))
  MINUS
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_KFSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KFSR (ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KFSR
   where (ID) in (select ID from A_KFSR))
  MINUS
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KFSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KFSR (ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KFSR
where (ID) in
    (select ID from KFSR
     MINUS
     select ID from A_KFSR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KSHK

update A_KSHK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KSHK
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KSHK)
/

update A_KSHK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from KSHK
   where (ID) in (select ID from A_KSHK))
  MINUS
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_KSHK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KSHK (ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KSHK
   where (ID) in (select ID from A_KSHK))
  MINUS
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KSHK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KSHK (ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KSHK
where (ID) in
    (select ID from KSHK
     MINUS
     select ID from A_KSHK
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KVR

update A_KVR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KVR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KVR)
/

update A_KVR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from KVR
   where (ID) in (select ID from A_KVR))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_KVR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KVR (ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KVR
   where (ID) in (select ID from A_KVR))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KVR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KVR (ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KVR
where (ID) in
    (select ID from KVR
     MINUS
     select ID from A_KVR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_KVSR

update A_KVSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_KVSR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from KVSR)
/

update A_KVSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from KVSR
   where (ID) in (select ID from A_KVSR))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_KVSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_KVSR (ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from KVSR
   where (ID) in (select ID from A_KVSR))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_KVSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_KVSR (ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,ORG_REF,CODE,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from KVSR
where (ID) in
    (select ID from KVSR
     MINUS
     select ID from A_KVSR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERBLOBS

update A_LAYERBLOBS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERBLOBS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERBLOBS)
/

update A_LAYERBLOBS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDID,VALUEINDEX
   from LAYERBLOBS
   where (ID) in (select ID from A_LAYERBLOBS))
  MINUS
  (select ID,RECORDID,VALUEINDEX
   from A_LAYERBLOBS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERBLOBS (ID,RECORDID,VALUEINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDID,VALUEINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERBLOBS
   where (ID) in (select ID from A_LAYERBLOBS))
  MINUS
  (select ID,RECORDID,VALUEINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERBLOBS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERBLOBS (ID,RECORDID,VALUEINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDID,VALUEINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERBLOBS
where (ID) in
    (select ID from LAYERBLOBS
     MINUS
     select ID from A_LAYERBLOBS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERCONTROLRULES

update A_LAYERCONTROLRULES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERCONTROLRULES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERCONTROLRULES)
/

update A_LAYERCONTROLRULES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERCONTROLRULES
   where (ID) in (select ID from A_LAYERCONTROLRULES))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERCONTROLRULES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERCONTROLRULES (ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERCONTROLRULES
   where (ID) in (select ID from A_LAYERCONTROLRULES))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERCONTROLRULES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERCONTROLRULES (ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,PROGINDEX,CONTROLRULE,CONTROLMESSAGE,SOFTCONTROL,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERCONTROLRULES
where (ID) in
    (select ID from LAYERCONTROLRULES
     MINUS
     select ID from A_LAYERCONTROLRULES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERDATA

update A_LAYERDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERDATA
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERDATA)
/

update A_LAYERDATA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS
   from LAYERDATA
   where (ID) in (select ID from A_LAYERDATA))
  MINUS
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS
   from A_LAYERDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERDATA (ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERDATA
   where (ID) in (select ID from A_LAYERDATA))
  MINUS
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERDATA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERDATA (ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,MEANSTYPE,PRODUCTREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,NATURALKEY,ACCEPTDATE,REJECTDATE,DOCSTATEREF,CRYPTOSTATUS,REJECTCAUSE,DEPARTMENTCLS,DATEOPEN,DATECLOSE,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,LOCKSTATUS,LOCKINFO,INTFIELD20,INTFIELD21,INTFIELD22,ORG_REF,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,STRFIELD25,SENDERID_FORCHECK,KCSR,BUDGETREF,INVESTOBJECT,FINTYPE,OKPD,FACT,DIRECTIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERDATA
where (ID) in
    (select ID from LAYERDATA
     MINUS
     select ID from A_LAYERDATA
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERDATA_BACKUP

update A_LAYERDATA_BACKUP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERDATA_BACKUP
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERDATA_BACKUP)
/

update A_LAYERDATA_BACKUP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID
   from LAYERDATA_BACKUP
   where (ID) in (select ID from A_LAYERDATA_BACKUP))
  MINUS
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID
   from A_LAYERDATA_BACKUP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERDATA_BACKUP (ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERDATA_BACKUP
   where (ID) in (select ID from A_LAYERDATA_BACKUP))
  MINUS
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERDATA_BACKUP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERDATA_BACKUP (ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,PRODUCTREF,KFSR,KVSR,KESR,KVR,SUBKESR,FINSOURCE,FACT,DIRECTIONCLS,MEANSTYPE,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,INTFIELD11,INTFIELD12,INTFIELD13,INTFIELD14,INTFIELD15,INTFIELD16,INTFIELD17,INTFIELD18,INTFIELD19,INTFIELD20,INTFIELD21,INTFIELD22,INTFIELD23,INTFIELD24,INTFIELD25,INTFIELD26,INTFIELD27,INTFIELD28,INTFIELD29,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,SUMFIELD16,SUMFIELD17,SUMFIELD18,SUMFIELD19,SUMFIELD20,SUMFIELD21,SUMFIELD22,SUMFIELD23,SUMFIELD24,SUMFIELD25,SUMFIELD26,SUMFIELD27,SUMFIELD28,SUMFIELD29,SUMFIELD30,SUMFIELD31,SUMFIELD32,SUMFIELD33,SUMFIELD34,SUMFIELD35,SUMFIELD36,SUMFIELD37,SUMFIELD38,SUMFIELD39,SUMFIELD40,SUMFIELD41,SUMFIELD42,SUMFIELD43,SUMFIELD44,SUMFIELD45,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,DATEFIELD05,DATEFIELD06,DATEFIELD07,DATEFIELD08,DATEFIELD09,DATEFIELD10,DATEFIELD11,DATEFIELD12,DATEFIELD13,DATEFIELD14,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,STRFIELD05,STRFIELD06,STRFIELD07,STRFIELD08,STRFIELD09,STRFIELD10,STRFIELD11,STRFIELD12,STRFIELD13,STRFIELD14,STRFIELD15,STRFIELD16,STRFIELD17,STRFIELD18,STRFIELD19,STRFIELD20,STRFIELD21,STRFIELD22,STRFIELD23,STRFIELD24,STRFIELD25,STRFIELD26,STRFIELD27,STRFIELD28,STRFIELD29,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,FLOATFIELD06,FLOATFIELD07,FLOATFIELD08,FLOATFIELD09,FLOATFIELD10,DEPARTMENTCLS,VARIANT,SUBSIDYCLS,TRANSFERTCLS,REGIONCLS,ORG_REF,KCSR,DOCUMENTID,BACKUPDATE,SOURCEID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERDATA_BACKUP
where (ID) in
    (select ID from LAYERDATA_BACKUP
     MINUS
     select ID from A_LAYERDATA_BACKUP
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERDATA_REGBK

update A_LAYERDATA_REGBK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERDATA_REGBK
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERDATA_REGBK)
/

update A_LAYERDATA_REGBK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD
   from LAYERDATA_REGBK
   where (ID) in (select ID from A_LAYERDATA_REGBK))
  MINUS
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD
   from A_LAYERDATA_REGBK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERDATA_REGBK (ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERDATA_REGBK
   where (ID) in (select ID from A_LAYERDATA_REGBK))
  MINUS
  (select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERDATA_REGBK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERDATA_REGBK (ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,LAYERREF,LAYERVERSION,FACIALACCCLS,SENDERID,SENDERRECORDID,SENDERID_FORCHECK,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,TASKREF,PRODUCTREF,OWNERUSER,EXECUTERUSER,UPDATESTATUS,UPDATEDRECORDINDEX,UPDATEGROUPINDEX,ACCEPTDATE,REJECTDATE,REJECTCAUSE,NATURALKEY,DOCSTATEREF,CRYPTOSTATUS,LOCKSTATUS,LOCKINFO,DATEOPEN,DATECLOSE,BUDGETREF,INTFIELD00,INTFIELD01,INTFIELD02,INTFIELD03,INTFIELD04,INTFIELD05,INTFIELD06,INTFIELD07,INTFIELD08,INTFIELD09,INTFIELD10,SUMFIELD00,SUMFIELD01,SUMFIELD02,SUMFIELD03,SUMFIELD04,SUMFIELD05,SUMFIELD06,SUMFIELD07,SUMFIELD08,SUMFIELD09,SUMFIELD10,SUMFIELD11,SUMFIELD12,SUMFIELD13,SUMFIELD14,SUMFIELD15,DATEFIELD00,DATEFIELD01,DATEFIELD02,DATEFIELD03,DATEFIELD04,STRFIELD00,STRFIELD01,STRFIELD02,STRFIELD03,STRFIELD04,FLOATFIELD00,FLOATFIELD01,FLOATFIELD02,FLOATFIELD03,FLOATFIELD04,FLOATFIELD05,ORG_REF,ID_KBK,REG_DATE,YEAR_SUM,YEAR_PLAN,ID_DOCUMENT,KVSR,BA,KFSR,KCSR,KVR,KESR,SUBKESR,MEANSTYPE,FACT,DIRECTION,SUBSIDY,CS,REGION,DEPARTMENT,OKPD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERDATA_REGBK
where (ID) in
    (select ID from LAYERDATA_REGBK
     MINUS
     select ID from A_LAYERDATA_REGBK
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERFIELDS

update A_LAYERFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERFIELDS)
/

update A_LAYERFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF
   from LAYERFIELDS
   where (ID) in (select ID from A_LAYERFIELDS))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF
   from A_LAYERFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERFIELDS (ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERFIELDS
   where (ID) in (select ID from A_LAYERFIELDS))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERFIELDS (ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,PROGINDEX,FIELDNAME,DISPLAYLABEL,DBNAME,FIELDTYPE,FIELDROLE,DEFAULTVALUE,READONLY,REQUIRED,HIDDEN,FIELDSIZE,MASK,CLSNAME,ENUMREF,HANDLERNAME,LINKEDFIELD,LINKEDNAME,AGGREGATEFUNC,FIELDPOSITION,WIDTH,VALIDATEVALUES,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,AGGREGATIONTYPE,NATURALKEY,CLSSTOREDNAME,FORMULA1,FORMULA2,FIELDTYPEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERFIELDS
where (ID) in
    (select ID from LAYERFIELDS
     MINUS
     select ID from A_LAYERFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERFIELDSRELATIONS

update A_LAYERFIELDSRELATIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERFIELDSRELATIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERFIELDSRELATIONS)
/

update A_LAYERFIELDSRELATIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERFIELDSRELATIONS
   where (ID) in (select ID from A_LAYERFIELDSRELATIONS))
  MINUS
  (select ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERFIELDSRELATIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERFIELDSRELATIONS (ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERFIELDSRELATIONS
   where (ID) in (select ID from A_LAYERFIELDSRELATIONS))
  MINUS
  (select ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERFIELDSRELATIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERFIELDSRELATIONS (ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,RELATIONTYPE,LEFTFIELDREF,RIGHTFIELDREF,LEFTAGRFUNCTION,RIGHTAGRFUNCTION,SENDERID,SENDERRECORDID,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERFIELDSRELATIONS
where (ID) in
    (select ID from LAYERFIELDSRELATIONS
     MINUS
     select ID from A_LAYERFIELDSRELATIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERFIELDTYPES

update A_LAYERFIELDTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERFIELDTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERFIELDTYPES)
/

update A_LAYERFIELDTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD
   from LAYERFIELDTYPES
   where (ID) in (select ID from A_LAYERFIELDTYPES))
  MINUS
  (select ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD
   from A_LAYERFIELDTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERFIELDTYPES (ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERFIELDTYPES
   where (ID) in (select ID from A_LAYERFIELDTYPES))
  MINUS
  (select ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERFIELDTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERFIELDTYPES (ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ALIAS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECOMMENDFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERFIELDTYPES
where (ID) in
    (select ID from LAYERFIELDTYPES
     MINUS
     select ID from A_LAYERFIELDTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERFIELDTYPESDETAIL

update A_LAYERFIELDTYPESDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERFIELDTYPESDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERFIELDTYPESDETAIL)
/

update A_LAYERFIELDTYPESDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE
   from LAYERFIELDTYPESDETAIL
   where (ID) in (select ID from A_LAYERFIELDTYPESDETAIL))
  MINUS
  (select ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE
   from A_LAYERFIELDTYPESDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERFIELDTYPESDETAIL (ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERFIELDTYPESDETAIL
   where (ID) in (select ID from A_LAYERFIELDTYPESDETAIL))
  MINUS
  (select ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERFIELDTYPESDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERFIELDTYPESDETAIL (ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ALIAS,RECORDINDEX,MASK,NOTE,REGEXP,FIELDSIZE,MASTERFIELDTYPE,CONTEXT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,ERRORMESSAGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERFIELDTYPESDETAIL
where (ID) in
    (select ID from LAYERFIELDTYPESDETAIL
     MINUS
     select ID from A_LAYERFIELDTYPESDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERNEEDCONTROL

update A_LAYERNEEDCONTROL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERNEEDCONTROL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERNEEDCONTROL)
/

update A_LAYERNEEDCONTROL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERNEEDCONTROL
   where (ID) in (select ID from A_LAYERNEEDCONTROL))
  MINUS
  (select ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERNEEDCONTROL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERNEEDCONTROL (ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERNEEDCONTROL
   where (ID) in (select ID from A_LAYERNEEDCONTROL))
  MINUS
  (select ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERNEEDCONTROL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERNEEDCONTROL (ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TASKREF,LAYERREF,CONTROLREF,SOFTCONTROL,RVERSION,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERNEEDCONTROL
where (ID) in
    (select ID from LAYERNEEDCONTROL
     MINUS
     select ID from A_LAYERNEEDCONTROL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERRELATIONS

update A_LAYERRELATIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERRELATIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERRELATIONS)
/

update A_LAYERRELATIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERRELATIONS
   where (ID) in (select ID from A_LAYERRELATIONS))
  MINUS
  (select ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERRELATIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERRELATIONS (ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERRELATIONS
   where (ID) in (select ID from A_LAYERRELATIONS))
  MINUS
  (select ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERRELATIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERRELATIONS (ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RELATIONTYPE,NAME,LEFTLAYER,RIGHTLAYER,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERRELATIONS
where (ID) in
    (select ID from LAYERRELATIONS
     MINUS
     select ID from A_LAYERRELATIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERS

update A_LAYERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERS)
/

update A_LAYERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET
   from LAYERS
   where (ID) in (select ID from A_LAYERS))
  MINUS
  (select ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET
   from A_LAYERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERS (ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERS
   where (ID) in (select ID from A_LAYERS))
  MINUS
  (select ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERS (ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,ALIAS,LAYERTYPE,TABLENAME,READONLY,USEVERSIONS,MACROSNAME,FACIALACCCLS,SENDERID,SENDERRECORDID,RVERSION,CRYPTOSTATUS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,VERSION,NOTE,ISGENERALIZED,ISDEPRECATED,ISMULTIBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERS
where (ID) in
    (select ID from LAYERS
     MINUS
     select ID from A_LAYERS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTABLES

update A_LAYERTABLES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTABLES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTABLES)
/

update A_LAYERTABLES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERTABLES
   where (ID) in (select ID from A_LAYERTABLES))
  MINUS
  (select ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERTABLES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTABLES (ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTABLES
   where (ID) in (select ID from A_LAYERTABLES))
  MINUS
  (select ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTABLES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTABLES (ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SYNCID,TABLENAME,NAME,DESCR,TBTYPE,SYNC,SYSTABLE,URM,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTABLES
where (ID) in
    (select ID from LAYERTABLES
     MINUS
     select ID from A_LAYERTABLES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTABLESFIELDS

update A_LAYERTABLESFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTABLESFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTABLESFIELDS)
/

update A_LAYERTABLESFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERTABLESFIELDS
   where (ID) in (select ID from A_LAYERTABLESFIELDS))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERTABLESFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTABLESFIELDS (ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTABLESFIELDS
   where (ID) in (select ID from A_LAYERTABLESFIELDS))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTABLESFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTABLESFIELDS (ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TABLEID,DBNAME,DESCR,FIELDTYPE,FIELDSIZE,SYNC,URM,REQUIRED,DEFVALUE,SYNCVALUE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTABLESFIELDS
where (ID) in
    (select ID from LAYERTABLESFIELDS
     MINUS
     select ID from A_LAYERTABLESFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTABLESFK

update A_LAYERTABLESFK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTABLESFK
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTABLESFK)
/

update A_LAYERTABLESFK set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERTABLESFK
   where (ID) in (select ID from A_LAYERTABLESFK))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERTABLESFK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTABLESFK (ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTABLESFK
   where (ID) in (select ID from A_LAYERTABLESFK))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTABLESFK
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTABLESFK (ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TABLEID,DBNAME,DESCR,FIELDS,TABLENAME,FIELDSREF,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTABLESFK
where (ID) in
    (select ID from LAYERTABLESFK
     MINUS
     select ID from A_LAYERTABLESFK
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTABLESIDX

update A_LAYERTABLESIDX set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTABLESIDX
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTABLESIDX)
/

update A_LAYERTABLESIDX set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERTABLESIDX
   where (ID) in (select ID from A_LAYERTABLESIDX))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERTABLESIDX
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTABLESIDX (ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTABLESIDX
   where (ID) in (select ID from A_LAYERTABLESIDX))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTABLESIDX
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTABLESIDX (ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TABLEID,DBNAME,DESCR,FIELDS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTABLESIDX
where (ID) in
    (select ID from LAYERTABLESIDX
     MINUS
     select ID from A_LAYERTABLESIDX
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTABLESTRIGGERS

update A_LAYERTABLESTRIGGERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTABLESTRIGGERS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTABLESTRIGGERS)
/

update A_LAYERTABLESTRIGGERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERTABLESTRIGGERS
   where (ID) in (select ID from A_LAYERTABLESTRIGGERS))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERTABLESTRIGGERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTABLESTRIGGERS (ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTABLESTRIGGERS
   where (ID) in (select ID from A_LAYERTABLESTRIGGERS))
  MINUS
  (select ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTABLESTRIGGERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTABLESTRIGGERS (ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TABLEID,DBNAME,DESCR,TRTEXT,TRTYPE,TRPOSITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTABLESTRIGGERS
where (ID) in
    (select ID from LAYERTABLESTRIGGERS
     MINUS
     select ID from A_LAYERTABLESTRIGGERS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTASKS

update A_LAYERTASKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTASKS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTASKS)
/

update A_LAYERTASKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER
   from LAYERTASKS
   where (ID) in (select ID from A_LAYERTASKS))
  MINUS
  (select ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER
   from A_LAYERTASKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTASKS (ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTASKS
   where (ID) in (select ID from A_LAYERTASKS))
  MINUS
  (select ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTASKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTASKS (ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TASKNUMBER,LAYERREF,LAYERVERSION,NOTE,FACIALACCCLS,DEADLINEDATE,ACCEPTDATE,REJECTDATE,DOCSTATEREF,REJECTCLS,REJECTCAUSE,SENDERID,SENDERRECORDID,CRYPTOSTATUS,RVERSION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,OWNERUSER,EXECUTERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTASKS
where (ID) in
    (select ID from LAYERTASKS
     MINUS
     select ID from A_LAYERTASKS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LAYERTYPES

update A_LAYERTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LAYERTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LAYERTYPES)
/

update A_LAYERTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LAYERTYPES
   where (ID) in (select ID from A_LAYERTYPES))
  MINUS
  (select ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LAYERTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LAYERTYPES (ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LAYERTYPES
   where (ID) in (select ID from A_LAYERTYPES))
  MINUS
  (select ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LAYERTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LAYERTYPES (ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,TABLENAME,READONLY,USEVERSIONS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LAYERTYPES
where (ID) in
    (select ID from LAYERTYPES
     MINUS
     select ID from A_LAYERTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LIMITFINCAPTION

update A_LIMITFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LIMITFINCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LIMITFINCAPTION)
/

update A_LIMITFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR
   from LIMITFINCAPTION
   where (ID) in (select ID from A_LIMITFINCAPTION))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR
   from A_LIMITFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LIMITFINCAPTION (ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LIMITFINCAPTION
   where (ID) in (select ID from A_LIMITFINCAPTION))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LIMITFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LIMITFINCAPTION (ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,ACCEPTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LIMITFINCAPTION
where (ID) in
    (select ID from LIMITFINCAPTION
     MINUS
     select ID from A_LIMITFINCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LIMITFINDETAIL

update A_LIMITFINDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LIMITFINDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LIMITFINDETAIL)
/

update A_LIMITFINDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT
   from LIMITFINDETAIL
   where (ID) in (select ID from A_LIMITFINDETAIL))
  MINUS
  (select ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT
   from A_LIMITFINDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LIMITFINDETAIL (ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LIMITFINDETAIL
   where (ID) in (select ID from A_LIMITFINDETAIL))
  MINUS
  (select ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LIMITFINDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LIMITFINDETAIL (ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KVR,KESR,BUDGETREF,FACIALACC,FINSOURCE,FINTYPE,SUBKESR,FACT,ACCEPTDATE,SUMMA,ACCEPTSUMMA,NOTE,REQUESTFLAG,RECORDINDEX,PROGINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCTYPES,KVSR,KCSR,KFSR,IMPORTID,SENDERINN,MEANSTYPE,ACC_REF,DFACCOUNT,SOURCEFACIALACC,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,DOCBASE,BUHOPERATIONCLS,IFS,CLSTYPE,STIMATEID,UNIONNOTIFYREF,FUNDSSOURCE,AMONTH,AYEAR,TRANSFERTCLS,REGIONCLS,SUBSIDYCLS,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LIMITFINDETAIL
where (ID) in
    (select ID from LIMITFINDETAIL
     MINUS
     select ID from A_LIMITFINDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LINKRECORDS

update A_LINKRECORDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LINKRECORDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LINKRECORDS)
/

update A_LINKRECORDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER
   from LINKRECORDS
   where (ID) in (select ID from A_LINKRECORDS))
  MINUS
  (select ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER
   from A_LINKRECORDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LINKRECORDS (ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LINKRECORDS
   where (ID) in (select ID from A_LINKRECORDS))
  MINUS
  (select ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LINKRECORDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LINKRECORDS (ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,LINKTYPEREF,PARENTID,CHILDID,CREATERUSER,CREATEDATE,SENDERID,SENDERRECORDID,ISREJECTED,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LINKRECORDS
where (ID) in
    (select ID from LINKRECORDS
     MINUS
     select ID from A_LINKRECORDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LOANCREDIT

update A_LOANCREDIT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LOANCREDIT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LOANCREDIT)
/

update A_LOANCREDIT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST
   from LOANCREDIT
   where (ID) in (select ID from A_LOANCREDIT))
  MINUS
  (select ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST
   from A_LOANCREDIT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LOANCREDIT (ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LOANCREDIT
   where (ID) in (select ID from A_LOANCREDIT))
  MINUS
  (select ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LOANCREDIT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LOANCREDIT (ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DATEINPUT,DATEAMORTIZATION,SUMMA,PROGINDEX,BUDGETREF,ORG_REF,NOTE,CONTRACTTYPE,PERIODSTART,PERIODLENGTH,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LONGDATE,ACCEPTDATE,ANUMBER,YEARTYPE,REGIONCLS,FACT,FACIALACC_CLS,LOANTYPE,DEBTTYPE,CURRENCYCLS,CBPERCENTRATE,CBFINERATE,CBFINEPERCENTRATE,PERCENT,FINE,RETURNSTARTDATE,RETURNPERIODLENGTH,PAYPERCENTSTARTDATE,PAYPERCENTPERIODLENGTH,DOCBASE,GUARANTEEKIND,GUARANTEEACCREF,EXECUTEPERIOD,DFACCOUNT,ACCREF,ADDITIONALACCREF,CURRENCYSUMMA,CONTRACTINFO,BONDCOUNT,BONDCOST,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LOANCREDIT
where (ID) in
    (select ID from LOANCREDIT
     MINUS
     select ID from A_LOANCREDIT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LOANCREDITCONTRACTS

update A_LOANCREDITCONTRACTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LOANCREDITCONTRACTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LOANCREDITCONTRACTS)
/

update A_LOANCREDITCONTRACTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from LOANCREDITCONTRACTS
   where (ID) in (select ID from A_LOANCREDITCONTRACTS))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_LOANCREDITCONTRACTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LOANCREDITCONTRACTS (ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LOANCREDITCONTRACTS
   where (ID) in (select ID from A_LOANCREDITCONTRACTS))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LOANCREDITCONTRACTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LOANCREDITCONTRACTS (ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,PROGINDEX,CONTRACTNUMBER,CONTRACTDATE,ENDDATE,CONTRACTTYPE,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LOANCREDITCONTRACTS
where (ID) in
    (select ID from LOANCREDITCONTRACTS
     MINUS
     select ID from A_LOANCREDITCONTRACTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LOANCREDITPERCENTS

update A_LOANCREDITPERCENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LOANCREDITPERCENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LOANCREDITPERCENTS)
/

update A_LOANCREDITPERCENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE
   from LOANCREDITPERCENTS
   where (ID) in (select ID from A_LOANCREDITPERCENTS))
  MINUS
  (select ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE
   from A_LOANCREDITPERCENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LOANCREDITPERCENTS (ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LOANCREDITPERCENTS
   where (ID) in (select ID from A_LOANCREDITPERCENTS))
  MINUS
  (select ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LOANCREDITPERCENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LOANCREDITPERCENTS (ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,ACCEPTDATE,SUMMA,SUBKD,BUHPAYMENTCLS,NOTE,PERIODSTART,PERIODEND,PAYPERCENTDATE,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,RECORDDATE,CURRENCYCLS,DFACCOUNT,CURRENCYSUMMA,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,KD,KVSR,KFSR,KCSR,KVR,KESR,CLSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LOANCREDITPERCENTS
where (ID) in
    (select ID from LOANCREDITPERCENTS
     MINUS
     select ID from A_LOANCREDITPERCENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LOANCREDITPLAN

update A_LOANCREDITPLAN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LOANCREDITPLAN
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LOANCREDITPLAN)
/

update A_LOANCREDITPLAN set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA
   from LOANCREDITPLAN
   where (ID) in (select ID from A_LOANCREDITPLAN))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA
   from A_LOANCREDITPLAN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LOANCREDITPLAN (ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LOANCREDITPLAN
   where (ID) in (select ID from A_LOANCREDITPLAN))
  MINUS
  (select ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LOANCREDITPLAN
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LOANCREDITPLAN (ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,PROGINDEX,PLANDATE,SUMMA,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CURRENCYCLS,CURRENCYSUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LOANCREDITPLAN
where (ID) in
    (select ID from LOANCREDITPLAN
     MINUS
     select ID from A_LOANCREDITPLAN
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_LOANTYPE

update A_LOANTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_LOANTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from LOANTYPE)
/

update A_LOANTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME
   from LOANTYPE
   where (ID) in (select ID from A_LOANTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME
   from A_LOANTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_LOANTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from LOANTYPE
   where (ID) in (select ID from A_LOANTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_LOANTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_LOANTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,BUHACCOUNT,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from LOANTYPE
where (ID) in
    (select ID from LOANTYPE
     MINUS
     select ID from A_LOANTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MANAGERBID

update A_MANAGERBID set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MANAGERBID
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MANAGERBID)
/

update A_MANAGERBID set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE
   from MANAGERBID
   where (ID) in (select ID from A_MANAGERBID))
  MINUS
  (select ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE
   from A_MANAGERBID
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MANAGERBID (ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MANAGERBID
   where (ID) in (select ID from A_MANAGERBID))
  MINUS
  (select ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MANAGERBID
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MANAGERBID (ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,MANAGERFACIALACCCLS,ARHIVEDOC,SENDERID,SENDERRECORDID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,MANAGERBIDNUMBER,MANAGERBIDDATE,DOCSTATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MANAGERBID
where (ID) in
    (select ID from MANAGERBID
     MINUS
     select ID from A_MANAGERBID
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MEANSCLS

update A_MEANSCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MEANSCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MEANSCLS)
/

update A_MEANSCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from MEANSCLS
   where (ID) in (select ID from A_MEANSCLS))
  MINUS
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_MEANSCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MEANSCLS (ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MEANSCLS
   where (ID) in (select ID from A_MEANSCLS))
  MINUS
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MEANSCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MEANSCLS (ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MEANSCLS
where (ID) in
    (select ID from MEANSCLS
     MINUS
     select ID from A_MEANSCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MEANSTYPE

update A_MEANSTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MEANSTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MEANSTYPE)
/

update A_MEANSTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from MEANSTYPE
   where (ID) in (select ID from A_MEANSTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_MEANSTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MEANSTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MEANSTYPE
   where (ID) in (select ID from A_MEANSTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MEANSTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MEANSTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,ACTIVITYKIND,TARGETCLS,NAME,STARTDATE,DELETEDATE,ACTIVITYTYPE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MEANSTYPE
where (ID) in
    (select ID from MEANSTYPE
     MINUS
     select ID from A_MEANSTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MEASUREMENTCLS

update A_MEASUREMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MEASUREMENTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MEASUREMENTCLS)
/

update A_MEASUREMENTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME
   from MEASUREMENTCLS
   where (ID) in (select ID from A_MEASUREMENTCLS))
  MINUS
  (select ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME
   from A_MEASUREMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MEASUREMENTCLS (ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MEASUREMENTCLS
   where (ID) in (select ID from A_MEASUREMENTCLS))
  MINUS
  (select ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MEASUREMENTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MEASUREMENTCLS (ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SHORTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MEASUREMENTCLS
where (ID) in
    (select ID from MEASUREMENTCLS
     MINUS
     select ID from A_MEASUREMENTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MEM_WARRANT

update A_MEM_WARRANT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MEM_WARRANT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MEM_WARRANT)
/

update A_MEM_WARRANT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE
   from MEM_WARRANT
   where (ID) in (select ID from A_MEM_WARRANT))
  MINUS
  (select ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE
   from A_MEM_WARRANT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MEM_WARRANT (ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MEM_WARRANT
   where (ID) in (select ID from A_MEM_WARRANT))
  MINUS
  (select ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MEM_WARRANT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MEM_WARRANT (ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DATE_MONTH,NUM_MEM,WORK_FL,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MEM_WARRANT
where (ID) in
    (select ID from MEM_WARRANT
     MINUS
     select ID from A_MEM_WARRANT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MONTHREPORTCAPTION

update A_MONTHREPORTCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MONTHREPORTCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MONTHREPORTCAPTION)
/

update A_MONTHREPORTCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR
   from MONTHREPORTCAPTION
   where (ID) in (select ID from A_MONTHREPORTCAPTION))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR
   from A_MONTHREPORTCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MONTHREPORTCAPTION (ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MONTHREPORTCAPTION
   where (ID) in (select ID from A_MONTHREPORTCAPTION))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MONTHREPORTCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MONTHREPORTCAPTION (ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,ACCEPTDATE,REPORTFLAG,PERIOD,KVB,ORG,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MONTHREPORTCAPTION
where (ID) in
    (select ID from MONTHREPORTCAPTION
     MINUS
     select ID from A_MONTHREPORTCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MONTHREPORTDETAIL

update A_MONTHREPORTDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MONTHREPORTDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MONTHREPORTDETAIL)
/

update A_MONTHREPORTDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from MONTHREPORTDETAIL
   where (ID) in (select ID from A_MONTHREPORTDETAIL))
  MINUS
  (select ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_MONTHREPORTDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MONTHREPORTDETAIL (ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MONTHREPORTDETAIL
   where (ID) in (select ID from A_MONTHREPORTDETAIL))
  MINUS
  (select ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MONTHREPORTDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MONTHREPORTDETAIL (ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,REPORTCODE,PAGECODE,STRINGCODE,YEARSUMMA,PLANSUMMA,FACTSUMMA,YEARSUMMAFINISH,PLANSUMMAFINISH,FACTSUMMAFINISH,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MONTHREPORTDETAIL
where (ID) in
    (select ID from MONTHREPORTDETAIL
     MINUS
     select ID from A_MONTHREPORTDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MUTNOTIFCAPT

update A_MUTNOTIFCAPT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MUTNOTIFCAPT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MUTNOTIFCAPT)
/

update A_MUTNOTIFCAPT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER
   from MUTNOTIFCAPT
   where (ID) in (select ID from A_MUTNOTIFCAPT))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER
   from A_MUTNOTIFCAPT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MUTNOTIFCAPT (ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MUTNOTIFCAPT
   where (ID) in (select ID from A_MUTNOTIFCAPT))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MUTNOTIFCAPT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MUTNOTIFCAPT (ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDSOURCE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MUTNOTIFCAPT
where (ID) in
    (select ID from MUTNOTIFCAPT
     MINUS
     select ID from A_MUTNOTIFCAPT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_MUTNOTIFDETAIL

update A_MUTNOTIFDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_MUTNOTIFDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from MUTNOTIFDETAIL)
/

update A_MUTNOTIFDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from MUTNOTIFDETAIL
   where (ID) in (select ID from A_MUTNOTIFDETAIL))
  MINUS
  (select ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_MUTNOTIFDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_MUTNOTIFDETAIL (ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from MUTNOTIFDETAIL
   where (ID) in (select ID from A_MUTNOTIFDETAIL))
  MINUS
  (select ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_MUTNOTIFDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_MUTNOTIFDETAIL (ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CAPTREF,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from MUTNOTIFDETAIL
where (ID) in
    (select ID from MUTNOTIFDETAIL
     MINUS
     select ID from A_MUTNOTIFDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_NOTIFYTYPES

update A_NOTIFYTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_NOTIFYTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from NOTIFYTYPES)
/

update A_NOTIFYTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from NOTIFYTYPES
   where (ID) in (select ID from A_NOTIFYTYPES))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_NOTIFYTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_NOTIFYTYPES (ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from NOTIFYTYPES
   where (ID) in (select ID from A_NOTIFYTYPES))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_NOTIFYTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_NOTIFYTYPES (ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from NOTIFYTYPES
where (ID) in
    (select ID from NOTIFYTYPES
     MINUS
     select ID from A_NOTIFYTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OBJECTCAPTION

update A_OBJECTCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OBJECTCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OBJECTCAPTION)
/

update A_OBJECTCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GUID,NAME,CNT,INTERFACE
   from OBJECTCAPTION
   where (ID) in (select ID from A_OBJECTCAPTION))
  MINUS
  (select ID,GUID,NAME,CNT,INTERFACE
   from A_OBJECTCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OBJECTCAPTION (ID,GUID,NAME,CNT,INTERFACE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GUID,NAME,CNT,INTERFACE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OBJECTCAPTION
   where (ID) in (select ID from A_OBJECTCAPTION))
  MINUS
  (select ID,GUID,NAME,CNT,INTERFACE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OBJECTCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OBJECTCAPTION (ID,GUID,NAME,CNT,INTERFACE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GUID,NAME,CNT,INTERFACE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OBJECTCAPTION
where (ID) in
    (select ID from OBJECTCAPTION
     MINUS
     select ID from A_OBJECTCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OBJECTDETAIL

update A_OBJECTDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OBJECTDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OBJECTDETAIL)
/

update A_OBJECTDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD
   from OBJECTDETAIL
   where (ID) in (select ID from A_OBJECTDETAIL))
  MINUS
  (select ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD
   from A_OBJECTDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OBJECTDETAIL (ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OBJECTDETAIL
   where (ID) in (select ID from A_OBJECTDETAIL))
  MINUS
  (select ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OBJECTDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OBJECTDETAIL (ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,ANUMBER,DETAILID,MASTERFIELD,DETAILFIELD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OBJECTDETAIL
where (ID) in
    (select ID from OBJECTDETAIL
     MINUS
     select ID from A_OBJECTDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OBJECTKIND

update A_OBJECTKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OBJECTKIND
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OBJECTKIND)
/

update A_OBJECTKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from OBJECTKIND
   where (ID) in (select ID from A_OBJECTKIND))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_OBJECTKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OBJECTKIND (ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OBJECTKIND
   where (ID) in (select ID from A_OBJECTKIND))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OBJECTKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OBJECTKIND (ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OBJECTKIND
where (ID) in
    (select ID from OBJECTKIND
     MINUS
     select ID from A_OBJECTKIND
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKATO

update A_OKATO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKATO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKATO)
/

update A_OKATO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME
   from OKATO
   where (ID) in (select ID from A_OKATO))
  MINUS
  (select ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME
   from A_OKATO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKATO (ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKATO
   where (ID) in (select ID from A_OKATO))
  MINUS
  (select ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKATO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKATO (ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,EXTENSION,REGIONCLS,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKATO
where (ID) in
    (select ID from OKATO
     MINUS
     select ID from A_OKATO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKDP

update A_OKDP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKDP
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKDP)
/

update A_OKDP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from OKDP
   where (ID) in (select ID from A_OKDP))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from A_OKDP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKDP (ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKDP
   where (ID) in (select ID from A_OKDP))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKDP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKDP (ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CODE4,CODE5,CODE6,SOURCECODE,NAME,MEASUREMENTCLS,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKDP
where (ID) in
    (select ID from OKDP
     MINUS
     select ID from A_OKDP
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKFS

update A_OKFS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKFS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKFS)
/

update A_OKFS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from OKFS
   where (ID) in (select ID from A_OKFS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_OKFS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKFS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKFS
   where (ID) in (select ID from A_OKFS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKFS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKFS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKFS
where (ID) in
    (select ID from OKFS
     MINUS
     select ID from A_OKFS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKOPF

update A_OKOPF set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKOPF
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKOPF)
/

update A_OKOPF set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE
   from OKOPF
   where (ID) in (select ID from A_OKOPF))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE
   from A_OKOPF
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKOPF (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKOPF
   where (ID) in (select ID from A_OKOPF))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKOPF
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKOPF (ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKOPF
where (ID) in
    (select ID from OKOPF
     MINUS
     select ID from A_OKOPF
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKP

update A_OKP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKP
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKP)
/

update A_OKP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME
   from OKP
   where (ID) in (select ID from A_OKP))
  MINUS
  (select ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME
   from A_OKP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKP (ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKP
   where (ID) in (select ID from A_OKP))
  MINUS
  (select ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKP (ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,HASCHILDS,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKP
where (ID) in
    (select ID from OKP
     MINUS
     select ID from A_OKP
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKPD

update A_OKPD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKPD
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKPD)
/

update A_OKPD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from OKPD
   where (ID) in (select ID from A_OKPD))
  MINUS
  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from A_OKPD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKPD (ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKPD
   where (ID) in (select ID from A_OKPD))
  MINUS
  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKPD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKPD (ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKPD
where (ID) in
    (select ID from OKPD
     MINUS
     select ID from A_OKPD
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKPD2

update A_OKPD2 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKPD2
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKPD2)
/

update A_OKPD2 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE
   from OKPD2
   where (ID) in (select ID from A_OKPD2))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE
   from A_OKPD2
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKPD2 (ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKPD2
   where (ID) in (select ID from A_OKPD2))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKPD2
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKPD2 (ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKPD2
where (ID) in
    (select ID from OKPD2
     MINUS
     select ID from A_OKPD2
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKTMO

update A_OKTMO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKTMO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKTMO)
/

update A_OKTMO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from OKTMO
   where (ID) in (select ID from A_OKTMO))
  MINUS
  (select ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_OKTMO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKTMO (ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKTMO
   where (ID) in (select ID from A_OKTMO))
  MINUS
  (select ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKTMO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKTMO (ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,CODE1,CODE2,NAME,NAMEOKTMO8,NOTEOKTMO8,REGIONCLS,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKTMO
where (ID) in
    (select ID from OKTMO
     MINUS
     select ID from A_OKTMO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKVED

update A_OKVED set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKVED
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKVED)
/

update A_OKVED set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from OKVED
   where (ID) in (select ID from A_OKVED))
  MINUS
  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from A_OKVED
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKVED (ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKVED
   where (ID) in (select ID from A_OKVED))
  MINUS
  (select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKVED
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKVED (ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,HASCHILDS,DELETEDATE,STARTDATE,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKVED
where (ID) in
    (select ID from OKVED
     MINUS
     select ID from A_OKVED
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OKVED2

update A_OKVED2 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OKVED2
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OKVED2)
/

update A_OKVED2 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE
   from OKVED2
   where (ID) in (select ID from A_OKVED2))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE
   from A_OKVED2
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OKVED2 (ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OKVED2
   where (ID) in (select ID from A_OKVED2))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OKVED2
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OKVED2 (ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATEDATE,UPDATEDATE,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OKVED2
where (ID) in
    (select ID from OKVED2
     MINUS
     select ID from A_OKVED2
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OLDINCOMES

update A_OLDINCOMES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OLDINCOMES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OLDINCOMES)
/

update A_OLDINCOMES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KD,ACCEPTDATE,SUMMA,REGIONCLS
   from OLDINCOMES
   where (ID) in (select ID from A_OLDINCOMES))
  MINUS
  (select ID,KD,ACCEPTDATE,SUMMA,REGIONCLS
   from A_OLDINCOMES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OLDINCOMES (ID,KD,ACCEPTDATE,SUMMA,REGIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KD,ACCEPTDATE,SUMMA,REGIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OLDINCOMES
   where (ID) in (select ID from A_OLDINCOMES))
  MINUS
  (select ID,KD,ACCEPTDATE,SUMMA,REGIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OLDINCOMES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OLDINCOMES (ID,KD,ACCEPTDATE,SUMMA,REGIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KD,ACCEPTDATE,SUMMA,REGIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OLDINCOMES
where (ID) in
    (select ID from OLDINCOMES
     MINUS
     select ID from A_OLDINCOMES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OOS_CONTRACT

update A_OOS_CONTRACT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OOS_CONTRACT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OOS_CONTRACT)
/

update A_OOS_CONTRACT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX
   from OOS_CONTRACT
   where (ID) in (select ID from A_OOS_CONTRACT))
  MINUS
  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX
   from A_OOS_CONTRACT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OOS_CONTRACT (ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OOS_CONTRACT
   where (ID) in (select ID from A_OOS_CONTRACT))
  MINUS
  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OOS_CONTRACT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OOS_CONTRACT (ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ARCHIVENAME,PACKETNAME,REGNUM,ANUMBER,SIGNDATE,VERSIONNUMBER,CUSTOMER_REGNUM,CUSTOMER_FULLNAME,CUSTOMER_INN,CUSTOMER_KPP,PROTOCOLDATE,DOCUMENTBASE,PRICE,SINGLECUSTOMERREASON_ID,SINGLECUSTOMERREASON_NAME,EXECUTIONDATE_MONTH,EXECUTIONDATE_YEAR,SUPPLIER_INN,SUPPLIER_KPP,SUPPLIER_ORGANIZATIONNAME,HREF,FCSORDER_PLACING,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BUDGET_CODE,SUPPLIER_LF_SINGULARNAME,PUBLISHDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OOS_CONTRACT
where (ID) in
    (select ID from OOS_CONTRACT
     MINUS
     select ID from A_OOS_CONTRACT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OOS_CONTRACT_FINANCES

update A_OOS_CONTRACT_FINANCES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OOS_CONTRACT_FINANCES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OOS_CONTRACT_FINANCES)
/

update A_OOS_CONTRACT_FINANCES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME
   from OOS_CONTRACT_FINANCES
   where (ID) in (select ID from A_OOS_CONTRACT_FINANCES))
  MINUS
  (select ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME
   from A_OOS_CONTRACT_FINANCES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OOS_CONTRACT_FINANCES (ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OOS_CONTRACT_FINANCES
   where (ID) in (select ID from A_OOS_CONTRACT_FINANCES))
  MINUS
  (select ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OOS_CONTRACT_FINANCES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OOS_CONTRACT_FINANCES (ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,ISBUDGETARY,AYEAR,SUBSTAGEMONTH,SUBSTAGEYEAR,KBK,PRICE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,ANUMBER,PACKETSECTION,SUBJECTNAME,MAXPRICE,PLACINGWAY_CODE,PLACINGWAY_NAME,CHANGEREASON_ID,CHANGEREASON_NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OOS_CONTRACT_FINANCES
where (ID) in
    (select ID from OOS_CONTRACT_FINANCES
     MINUS
     select ID from A_OOS_CONTRACT_FINANCES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OOS_CONTRACT_PRODUCTS

update A_OOS_CONTRACT_PRODUCTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OOS_CONTRACT_PRODUCTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OOS_CONTRACT_PRODUCTS)
/

update A_OOS_CONTRACT_PRODUCTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX
   from OOS_CONTRACT_PRODUCTS
   where (ID) in (select ID from A_OOS_CONTRACT_PRODUCTS))
  MINUS
  (select ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX
   from A_OOS_CONTRACT_PRODUCTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OOS_CONTRACT_PRODUCTS (ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OOS_CONTRACT_PRODUCTS
   where (ID) in (select ID from A_OOS_CONTRACT_PRODUCTS))
  MINUS
  (select ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OOS_CONTRACT_PRODUCTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OOS_CONTRACT_PRODUCTS (ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OOS_CONTRACT_PRODUCTS
where (ID) in
    (select ID from OOS_CONTRACT_PRODUCTS
     MINUS
     select ID from A_OOS_CONTRACT_PRODUCTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OOS_CONTRACTPROCEDURE

update A_OOS_CONTRACTPROCEDURE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OOS_CONTRACTPROCEDURE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OOS_CONTRACTPROCEDURE)
/

update A_OOS_CONTRACTPROCEDURE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX
   from OOS_CONTRACTPROCEDURE
   where (ID) in (select ID from A_OOS_CONTRACTPROCEDURE))
  MINUS
  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX
   from A_OOS_CONTRACTPROCEDURE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OOS_CONTRACTPROCEDURE (ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OOS_CONTRACTPROCEDURE
   where (ID) in (select ID from A_OOS_CONTRACTPROCEDURE))
  MINUS
  (select ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OOS_CONTRACTPROCEDURE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OOS_CONTRACTPROCEDURE (ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ARCHIVENAME,PACKETNAME,REGNUM,VERSIONNUMBER,TERMINATION_PAID,CURRENTCONTRACTSTAGE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PUBLISHDATE,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OOS_CONTRACTPROCEDURE
where (ID) in
    (select ID from OOS_CONTRACTPROCEDURE
     MINUS
     select ID from A_OOS_CONTRACTPROCEDURE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORG_ACCDEFAULTS

update A_ORG_ACCDEFAULTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORG_ACCDEFAULTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORG_ACCDEFAULTS)
/

update A_ORG_ACCDEFAULTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from ORG_ACCDEFAULTS
   where (ID) in (select ID from A_ORG_ACCDEFAULTS))
  MINUS
  (select ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_ORG_ACCDEFAULTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORG_ACCDEFAULTS (ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORG_ACCDEFAULTS
   where (ID) in (select ID from A_ORG_ACCDEFAULTS))
  MINUS
  (select ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORG_ACCDEFAULTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORG_ACCDEFAULTS (ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PAYTYPE,PAYQUEUE,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORG_ACCDEFAULTS
where (ID) in
    (select ID from ORG_ACCDEFAULTS
     MINUS
     select ID from A_ORG_ACCDEFAULTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORG_CLS

update A_ORG_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORG_CLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORG_CLS)
/

update A_ORG_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from ORG_CLS
   where (ID) in (select ID from A_ORG_CLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from A_ORG_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORG_CLS (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORG_CLS
   where (ID) in (select ID from A_ORG_CLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORG_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORG_CLS (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORG_CLS
where (ID) in
    (select ID from ORG_CLS
     MINUS
     select ID from A_ORG_CLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORG_TYPE

update A_ORG_TYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORG_TYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORG_TYPE)
/

update A_ORG_TYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from ORG_TYPE
   where (ID) in (select ID from A_ORG_TYPE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_ORG_TYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORG_TYPE (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORG_TYPE
   where (ID) in (select ID from A_ORG_TYPE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORG_TYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORG_TYPE (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORG_TYPE
where (ID) in
    (select ID from ORG_TYPE
     MINUS
     select ID from A_ORG_TYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORGATTRIBUTES

update A_ORGATTRIBUTES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORGATTRIBUTES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORGATTRIBUTES)
/

update A_ORGATTRIBUTES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR
   from ORGATTRIBUTES
   where (ID) in (select ID from A_ORGATTRIBUTES))
  MINUS
  (select ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR
   from A_ORGATTRIBUTES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORGATTRIBUTES (ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORGATTRIBUTES
   where (ID) in (select ID from A_ORGATTRIBUTES))
  MINUS
  (select ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORGATTRIBUTES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORGATTRIBUTES (ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACC_REF,ORGNAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ORGINN,ACC,ORGINN20,BANKNAME,BANKMFO,BANKCOR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORGATTRIBUTES
where (ID) in
    (select ID from ORGATTRIBUTES
     MINUS
     select ID from A_ORGATTRIBUTES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORGOPERAT

update A_ORGOPERAT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORGOPERAT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORGOPERAT)
/

update A_ORGOPERAT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS
   from ORGOPERAT
   where (ID) in (select ID from A_ORGOPERAT))
  MINUS
  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS
   from A_ORGOPERAT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORGOPERAT (ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORGOPERAT
   where (ID) in (select ID from A_ORGOPERAT))
  MINUS
  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORGOPERAT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORGOPERAT (ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,REGIONCLS,FINSOURCE,FINTYPE,ACCOUNTREF,NOWDATE,YEARREPORT,MONTHREPORT,SUMMA,GROUPINF,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SUMMA1,QUARTER1,QUARTER2,QUARTER3,QUARTER4,FACIALACC_CLS,FACT,MEANSTYPE,ACCEPTORACCREF,IFS,SUBKCSR,DIRECTIONCLS,DOCBASE,CLSTYPE,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORGOPERAT
where (ID) in
    (select ID from ORGOPERAT
     MINUS
     select ID from A_ORGOPERAT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORGSHARECAPTION

update A_ORGSHARECAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORGSHARECAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORGSHARECAPTION)
/

update A_ORGSHARECAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from ORGSHARECAPTION
   where (ID) in (select ID from A_ORGSHARECAPTION))
  MINUS
  (select ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_ORGSHARECAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORGSHARECAPTION (ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORGSHARECAPTION
   where (ID) in (select ID from A_ORGSHARECAPTION))
  MINUS
  (select ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORGSHARECAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORGSHARECAPTION (ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORGSHARECAPTION
where (ID) in
    (select ID from ORGSHARECAPTION
     MINUS
     select ID from A_ORGSHARECAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_ORGSHAREDETAIL

update A_ORGSHAREDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_ORGSHAREDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from ORGSHAREDETAIL)
/

update A_ORGSHAREDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from ORGSHAREDETAIL
   where (ID) in (select ID from A_ORGSHAREDETAIL))
  MINUS
  (select ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_ORGSHAREDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_ORGSHAREDETAIL (ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from ORGSHAREDETAIL
   where (ID) in (select ID from A_ORGSHAREDETAIL))
  MINUS
  (select ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_ORGSHAREDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_ORGSHAREDETAIL (ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACC_REF,SUMMA,BUDGETREF,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from ORGSHAREDETAIL
where (ID) in
    (select ID from ORGSHAREDETAIL
     MINUS
     select ID from A_ORGSHAREDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OTHBUDNOTIFCAPTION

update A_OTHBUDNOTIFCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OTHBUDNOTIFCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OTHBUDNOTIFCAPTION)
/

update A_OTHBUDNOTIFCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS
   from OTHBUDNOTIFCAPTION
   where (ID) in (select ID from A_OTHBUDNOTIFCAPTION))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS
   from A_OTHBUDNOTIFCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OTHBUDNOTIFCAPTION (ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OTHBUDNOTIFCAPTION
   where (ID) in (select ID from A_OTHBUDNOTIFCAPTION))
  MINUS
  (select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OTHBUDNOTIFCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OTHBUDNOTIFCAPTION (ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,ACCEPTDATE,INPUTDATE,BUDDIST,INOUT,NOTE,SPECIAL,OSNOVANIE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ANUMBER,DOCBASE,DOCSTATEREF,CRYPTOSTATUS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OTHBUDNOTIFCAPTION
where (ID) in
    (select ID from OTHBUDNOTIFCAPTION
     MINUS
     select ID from A_OTHBUDNOTIFCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_OTHBUDNOTIFDETAIL

update A_OTHBUDNOTIFDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_OTHBUDNOTIFDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from OTHBUDNOTIFDETAIL)
/

update A_OTHBUDNOTIFDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE
   from OTHBUDNOTIFDETAIL
   where (ID) in (select ID from A_OTHBUDNOTIFDETAIL))
  MINUS
  (select ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE
   from A_OTHBUDNOTIFDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_OTHBUDNOTIFDETAIL (ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from OTHBUDNOTIFDETAIL
   where (ID) in (select ID from A_OTHBUDNOTIFDETAIL))
  MINUS
  (select ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_OTHBUDNOTIFDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_OTHBUDNOTIFDETAIL (ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,QUARTER1,QUARTER2,QUARTER3,QUARTER4,KFSR,KVSR,KVR,KCSR,KESR,SUBKESR,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,FACT,DIRECTIONCLS,BUHOPERATIONCLS,IFS_CORR,MEANSTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from OTHBUDNOTIFDETAIL
where (ID) in
    (select ID from OTHBUDNOTIFDETAIL
     MINUS
     select ID from A_OTHBUDNOTIFDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAPEROPERATION

update A_PAPEROPERATION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAPEROPERATION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAPEROPERATION)
/

update A_PAPEROPERATION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR
   from PAPEROPERATION
   where (ID) in (select ID from A_PAPEROPERATION))
  MINUS
  (select ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR
   from A_PAPEROPERATION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAPEROPERATION (ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAPEROPERATION
   where (ID) in (select ID from A_PAPEROPERATION))
  MINUS
  (select ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAPEROPERATION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAPEROPERATION (ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACC_REF,ACCEPTORACC_REF,ACCEPTDATE,BUHPAYMENTCLS,DFACCOUNT,DEBIT,CREDIT,NOTE,DOCTYPE,DOCNUMBER,FACIALACC_CLS,REGIONCLS,BUHOPERATIONCLS,IFS,IFS_CORR,MEANSTYPE,CLSTYPE,KVSR,KCSR,KFSR,KVR,KESR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAPEROPERATION
where (ID) in
    (select ID from PAPEROPERATION
     MINUS
     select ID from A_PAPEROPERATION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAYDESTINATIONCLS

update A_PAYDESTINATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAYDESTINATIONCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAYDESTINATIONCLS)
/

update A_PAYDESTINATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from PAYDESTINATIONCLS
   where (ID) in (select ID from A_PAYDESTINATIONCLS))
  MINUS
  (select ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from A_PAYDESTINATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAYDESTINATIONCLS (ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAYDESTINATIONCLS
   where (ID) in (select ID from A_PAYDESTINATIONCLS))
  MINUS
  (select ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAYDESTINATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAYDESTINATIONCLS (ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PRIORITY,TAXNOTE,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAYDESTINATIONCLS
where (ID) in
    (select ID from PAYDESTINATIONCLS
     MINUS
     select ID from A_PAYDESTINATIONCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAYDOCEXCHANGE

update A_PAYDOCEXCHANGE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAYDOCEXCHANGE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAYDOCEXCHANGE)
/

update A_PAYDOCEXCHANGE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER
   from PAYDOCEXCHANGE
   where (ID) in (select ID from A_PAYDOCEXCHANGE))
  MINUS
  (select ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER
   from A_PAYDOCEXCHANGE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAYDOCEXCHANGE (ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAYDOCEXCHANGE
   where (ID) in (select ID from A_PAYDOCEXCHANGE))
  MINUS
  (select ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAYDOCEXCHANGE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAYDOCEXCHANGE (ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SENDDATE,ERROR,NOTE,PAYDOCREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,TYPEINF,STATUS,QUEUETIME,REESTRNUMBER,CODEFORMAT,PACKETNUMBER,ELPACKETNUMBER,DOCNUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAYDOCEXCHANGE
where (ID) in
    (select ID from PAYDOCEXCHANGE
     MINUS
     select ID from A_PAYDOCEXCHANGE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAYDOCTEMPLATES

update A_PAYDOCTEMPLATES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAYDOCTEMPLATES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAYDOCTEMPLATES)
/

update A_PAYDOCTEMPLATES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM
   from PAYDOCTEMPLATES
   where (ID) in (select ID from A_PAYDOCTEMPLATES))
  MINUS
  (select ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM
   from A_PAYDOCTEMPLATES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAYDOCTEMPLATES (ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAYDOCTEMPLATES
   where (ID) in (select ID from A_PAYDOCTEMPLATES))
  MINUS
  (select ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAYDOCTEMPLATES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAYDOCTEMPLATES (ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,CREATERUSER,CREATEDATE,ACOMMENT,CURSUM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAYDOCTEMPLATES
where (ID) in
    (select ID from PAYDOCTEMPLATES
     MINUS
     select ID from A_PAYDOCTEMPLATES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAYPROMISECLS

update A_PAYPROMISECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAYPROMISECLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAYPROMISECLS)
/

update A_PAYPROMISECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from PAYPROMISECLS
   where (ID) in (select ID from A_PAYPROMISECLS))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_PAYPROMISECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAYPROMISECLS (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAYPROMISECLS
   where (ID) in (select ID from A_PAYPROMISECLS))
  MINUS
  (select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAYPROMISECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAYPROMISECLS (ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,BUDGETREF,STARTDATE,DELETEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAYPROMISECLS
where (ID) in
    (select ID from PAYPROMISECLS
     MINUS
     select ID from A_PAYPROMISECLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAYSYMBOLCLS

update A_PAYSYMBOLCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAYSYMBOLCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAYSYMBOLCLS)
/

update A_PAYSYMBOLCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME
   from PAYSYMBOLCLS
   where (ID) in (select ID from A_PAYSYMBOLCLS))
  MINUS
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME
   from A_PAYSYMBOLCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAYSYMBOLCLS (ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAYSYMBOLCLS
   where (ID) in (select ID from A_PAYSYMBOLCLS))
  MINUS
  (select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAYSYMBOLCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAYSYMBOLCLS (ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAYSYMBOLCLS
where (ID) in
    (select ID from PAYSYMBOLCLS
     MINUS
     select ID from A_PAYSYMBOLCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PAYTYPECLS

update A_PAYTYPECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PAYTYPECLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PAYTYPECLS)
/

update A_PAYTYPECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from PAYTYPECLS
   where (ID) in (select ID from A_PAYTYPECLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_PAYTYPECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PAYTYPECLS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PAYTYPECLS
   where (ID) in (select ID from A_PAYTYPECLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PAYTYPECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PAYTYPECLS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PAYTYPECLS
where (ID) in
    (select ID from PAYTYPECLS
     MINUS
     select ID from A_PAYTYPECLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PERMISSIONS

update A_PERMISSIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PERMISSIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PERMISSIONS)
/

update A_PERMISSIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from PERMISSIONS
   where (ID) in (select ID from A_PERMISSIONS))
  MINUS
  (select ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_PERMISSIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PERMISSIONS (ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PERMISSIONS
   where (ID) in (select ID from A_PERMISSIONS))
  MINUS
  (select ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PERMISSIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PERMISSIONS (ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,INTERFACEREF,NAME,VAL,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PERMISSIONS
where (ID) in
    (select ID from PERMISSIONS
     MINUS
     select ID from A_PERMISSIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PLANDOCTYPE

update A_PLANDOCTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PLANDOCTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PLANDOCTYPE)
/

update A_PLANDOCTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from PLANDOCTYPE
   where (ID) in (select ID from A_PLANDOCTYPE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_PLANDOCTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PLANDOCTYPE (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PLANDOCTYPE
   where (ID) in (select ID from A_PLANDOCTYPE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PLANDOCTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PLANDOCTYPE (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PLANDOCTYPE
where (ID) in
    (select ID from PLANDOCTYPE
     MINUS
     select ID from A_PLANDOCTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PLANKIND

update A_PLANKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PLANKIND
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PLANKIND)
/

update A_PLANKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE
   from PLANKIND
   where (ID) in (select ID from A_PLANKIND))
  MINUS
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE
   from A_PLANKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PLANKIND (ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PLANKIND
   where (ID) in (select ID from A_PLANKIND))
  MINUS
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PLANKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PLANKIND (ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PLANKIND
where (ID) in
    (select ID from PLANKIND
     MINUS
     select ID from A_PLANKIND
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PROGRAMCODE

update A_PROGRAMCODE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PROGRAMCODE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PROGRAMCODE)
/

update A_PROGRAMCODE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE
   from PROGRAMCODE
   where (ID) in (select ID from A_PROGRAMCODE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE
   from A_PROGRAMCODE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PROGRAMCODE (ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PROGRAMCODE
   where (ID) in (select ID from A_PROGRAMCODE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PROGRAMCODE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PROGRAMCODE (ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,SHORTNAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PROGRAMCODE
where (ID) in
    (select ID from PROGRAMCODE
     MINUS
     select ID from A_PROGRAMCODE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PROTOCOLDOCTYPE

update A_PROTOCOLDOCTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PROTOCOLDOCTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PROTOCOLDOCTYPE)
/

update A_PROTOCOLDOCTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE
   from PROTOCOLDOCTYPE
   where (ID) in (select ID from A_PROTOCOLDOCTYPE))
  MINUS
  (select ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE
   from A_PROTOCOLDOCTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PROTOCOLDOCTYPE (ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PROTOCOLDOCTYPE
   where (ID) in (select ID from A_PROTOCOLDOCTYPE))
  MINUS
  (select ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PROTOCOLDOCTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PROTOCOLDOCTYPE (ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,ATYPE,WEBID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PROTOCOLDOCTYPE
where (ID) in
    (select ID from PROTOCOLDOCTYPE
     MINUS
     select ID from A_PROTOCOLDOCTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_PROTOCOLREASON

update A_PROTOCOLREASON set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_PROTOCOLREASON
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from PROTOCOLREASON)
/

update A_PROTOCOLREASON set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,WEBID,CREATEDATE,UPDATEDATE
   from PROTOCOLREASON
   where (ID) in (select ID from A_PROTOCOLREASON))
  MINUS
  (select ID,NAME,WEBID,CREATEDATE,UPDATEDATE
   from A_PROTOCOLREASON
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_PROTOCOLREASON (ID,NAME,WEBID,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,WEBID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from PROTOCOLREASON
   where (ID) in (select ID from A_PROTOCOLREASON))
  MINUS
  (select ID,NAME,WEBID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_PROTOCOLREASON
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_PROTOCOLREASON (ID,NAME,WEBID,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,WEBID,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from PROTOCOLREASON
where (ID) in
    (select ID from PROTOCOLREASON
     MINUS
     select ID from A_PROTOCOLREASON
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REALCONST

update A_REALCONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REALCONST
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REALCONST)
/

update A_REALCONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE
   from REALCONST
   where (ID) in (select ID from A_REALCONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE
   from A_REALCONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REALCONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REALCONST
   where (ID) in (select ID from A_REALCONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REALCONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REALCONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REALCONST
where (ID) in
    (select ID from REALCONST
     MINUS
     select ID from A_REALCONST
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_RECORDPARAMS

update A_RECORDPARAMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_RECORDPARAMS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from RECORDPARAMS)
/

update A_RECORDPARAMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT
   from RECORDPARAMS
   where (ID) in (select ID from A_RECORDPARAMS))
  MINUS
  (select ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT
   from A_RECORDPARAMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_RECORDPARAMS (ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from RECORDPARAMS
   where (ID) in (select ID from A_RECORDPARAMS))
  MINUS
  (select ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_RECORDPARAMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_RECORDPARAMS (ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCCLS,CHILDCOUNT,PARENTCOUNT,DISABLEDELCOUNT,PARENTBLOCKCOUNT,CHILDBLOCKCOUNT,COMMONPICTURECOUNT,UNIQUEPICTURECOUNT,REJECTCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from RECORDPARAMS
where (ID) in
    (select ID from RECORDPARAMS
     MINUS
     select ID from A_RECORDPARAMS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REESTRTYPE

update A_REESTRTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REESTRTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REESTRTYPE)
/

update A_REESTRTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME
   from REESTRTYPE
   where (ID) in (select ID from A_REESTRTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME
   from A_REESTRTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REESTRTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REESTRTYPE
   where (ID) in (select ID from A_REESTRTYPE))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REESTRTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REESTRTYPE (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,TREASUARYITFLIST,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REESTRTYPE
where (ID) in
    (select ID from REESTRTYPE
     MINUS
     select ID from A_REESTRTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REFCLS

update A_REFCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REFCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REFCLS)
/

update A_REFCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from REFCLS
   where (ID) in (select ID from A_REFCLS))
  MINUS
  (select ID,NAME
   from A_REFCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REFCLS (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REFCLS
   where (ID) in (select ID from A_REFCLS))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REFCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REFCLS (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REFCLS
where (ID) in
    (select ID from REFCLS
     MINUS
     select ID from A_REFCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REG_JOURNAL

update A_REG_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REG_JOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REG_JOURNAL)
/

update A_REG_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND
   from REG_JOURNAL
   where (ID) in (select ID from A_REG_JOURNAL))
  MINUS
  (select ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND
   from A_REG_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REG_JOURNAL (ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REG_JOURNAL
   where (ID) in (select ID from A_REG_JOURNAL))
  MINUS
  (select ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REG_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REG_JOURNAL (ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REGUSERS_REF,OBJECT_ID,OBJECT_TYPE,DATEBEGIN,DATEEND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REG_JOURNAL
where (ID) in
    (select ID from REG_JOURNAL
     MINUS
     select ID from A_REG_JOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REGIONCLS

update A_REGIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REGIONCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REGIONCLS)
/

update A_REGIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE
   from REGIONCLS
   where (ID) in (select ID from A_REGIONCLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE
   from A_REGIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REGIONCLS (ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REGIONCLS
   where (ID) in (select ID from A_REGIONCLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REGIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REGIONCLS (ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,BUDGETTYPE,ORGANIZATIONS,KVB_EXPORT,ORG_EXPORT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REGIONCLS
where (ID) in
    (select ID from REGIONCLS
     MINUS
     select ID from A_REGIONCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REGUSERS

update A_REGUSERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REGUSERS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REGUSERS)
/

update A_REGUSERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP
   from REGUSERS
   where (ID) in (select ID from A_REGUSERS))
  MINUS
  (select ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP
   from A_REGUSERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REGUSERS (ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REGUSERS
   where (ID) in (select ID from A_REGUSERS))
  MINUS
  (select ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REGUSERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REGUSERS (ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DBUSERNAME,DATEBEGIN,DATEEND,NETUSERNAME,NETCOMPNAME,ASESSION,PROCPID,PROCNAME,PROCVER,NETIP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REGUSERS
where (ID) in
    (select ID from REGUSERS
     MINUS
     select ID from A_REGUSERS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REJECTCLS

update A_REJECTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REJECTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REJECTCLS)
/

update A_REJECTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from REJECTCLS
   where (ID) in (select ID from A_REJECTCLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME
   from A_REJECTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REJECTCLS (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REJECTCLS
   where (ID) in (select ID from A_REJECTCLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REJECTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REJECTCLS (ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REJECTCLS
where (ID) in
    (select ID from REJECTCLS
     MINUS
     select ID from A_REJECTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTECLIENT

update A_REMOTECLIENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTECLIENT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTECLIENT)
/

update A_REMOTECLIENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES
   from REMOTECLIENT
   where (ID) in (select ID from A_REMOTECLIENT))
  MINUS
  (select ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES
   from A_REMOTECLIENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTECLIENT (ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTECLIENT
   where (ID) in (select ID from A_REMOTECLIENT))
  MINUS
  (select ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTECLIENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTECLIENT (ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CLIENTID,PASS,ORGANIZATION,CLIENTVERSION,NOTE,DATELASTSYNCHRO,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REMOTECLIENTTYPE,USESIGN,BLOCKLIST,LINKSPEED,CERTEXPIRATIONDAYS,CERTOWNERNAMES,BSID,CRYPTOID,PACKETBLOCKLIST,ISEXECUTIONUSED,USEDCOPIES,ALLOWEDCOPIES,CERTEXPIRATIONDATE,OWNCOPIES,TRANSFERTCOPIES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTECLIENT
where (ID) in
    (select ID from REMOTECLIENT
     MINUS
     select ID from A_REMOTECLIENT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTECLIENTACCOUNT

update A_REMOTECLIENTACCOUNT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTECLIENTACCOUNT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTECLIENTACCOUNT)
/

update A_REMOTECLIENTACCOUNT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from REMOTECLIENTACCOUNT
   where (ID) in (select ID from A_REMOTECLIENTACCOUNT))
  MINUS
  (select ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_REMOTECLIENTACCOUNT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTECLIENTACCOUNT (ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTECLIENTACCOUNT
   where (ID) in (select ID from A_REMOTECLIENTACCOUNT))
  MINUS
  (select ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTECLIENTACCOUNT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTECLIENTACCOUNT (ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REMOTEDOCUMENT,REMOTECLIENT,DEFAULTACCOUNT,ACCOUNT,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTECLIENTACCOUNT
where (ID) in
    (select ID from REMOTECLIENTACCOUNT
     MINUS
     select ID from A_REMOTECLIENTACCOUNT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTECLIENTTYPE

update A_REMOTECLIENTTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTECLIENTTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTECLIENTTYPE)
/

update A_REMOTECLIENTTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from REMOTECLIENTTYPE
   where (ID) in (select ID from A_REMOTECLIENTTYPE))
  MINUS
  (select ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_REMOTECLIENTTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTECLIENTTYPE (ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTECLIENTTYPE
   where (ID) in (select ID from A_REMOTECLIENTTYPE))
  MINUS
  (select ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTECLIENTTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTECLIENTTYPE (ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,NOTE,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTECLIENTTYPE
where (ID) in
    (select ID from REMOTECLIENTTYPE
     MINUS
     select ID from A_REMOTECLIENTTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEDOCUMENT

update A_REMOTEDOCUMENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEDOCUMENT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEDOCUMENT)
/

update A_REMOTEDOCUMENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from REMOTEDOCUMENT
   where (ID) in (select ID from A_REMOTEDOCUMENT))
  MINUS
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_REMOTEDOCUMENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEDOCUMENT (ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEDOCUMENT
   where (ID) in (select ID from A_REMOTEDOCUMENT))
  MINUS
  (select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEDOCUMENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEDOCUMENT (ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEDOCUMENT
where (ID) in
    (select ID from REMOTEDOCUMENT
     MINUS
     select ID from A_REMOTEDOCUMENT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEEDSRIGHT

update A_REMOTEEDSRIGHT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEEDSRIGHT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEEDSRIGHT)
/

update A_REMOTEEDSRIGHT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE
   from REMOTEEDSRIGHT
   where (ID) in (select ID from A_REMOTEEDSRIGHT))
  MINUS
  (select ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE
   from A_REMOTEEDSRIGHT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEEDSRIGHT (ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEEDSRIGHT
   where (ID) in (select ID from A_REMOTEEDSRIGHT))
  MINUS
  (select ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEEDSRIGHT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEEDSRIGHT (ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FACIALACCCLS,REMOTECLIENT,RIGHTTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,FACIALACCCLSUP,ARECURSIVE,DATAPACKETTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEEDSRIGHT
where (ID) in
    (select ID from REMOTEEDSRIGHT
     MINUS
     select ID from A_REMOTEEDSRIGHT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEINPUTRIGHT

update A_REMOTEINPUTRIGHT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEINPUTRIGHT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEINPUTRIGHT)
/

update A_REMOTEINPUTRIGHT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from REMOTEINPUTRIGHT
   where (ID) in (select ID from A_REMOTEINPUTRIGHT))
  MINUS
  (select ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_REMOTEINPUTRIGHT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEINPUTRIGHT (ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEINPUTRIGHT
   where (ID) in (select ID from A_REMOTEINPUTRIGHT))
  MINUS
  (select ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEINPUTRIGHT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEINPUTRIGHT (ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FACIALACCCLS,REMOTECLIENT,REMOTEDOCUMENT,EXCLUDE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEINPUTRIGHT
where (ID) in
    (select ID from REMOTEINPUTRIGHT
     MINUS
     select ID from A_REMOTEINPUTRIGHT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEMAILATTACHEDFILES

update A_REMOTEMAILATTACHEDFILES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEMAILATTACHEDFILES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEMAILATTACHEDFILES)
/

update A_REMOTEMAILATTACHEDFILES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ATTACHEDFILENAME,MESSAGEREF
   from REMOTEMAILATTACHEDFILES
   where (ID) in (select ID from A_REMOTEMAILATTACHEDFILES))
  MINUS
  (select ID,ATTACHEDFILENAME,MESSAGEREF
   from A_REMOTEMAILATTACHEDFILES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEMAILATTACHEDFILES (ID,ATTACHEDFILENAME,MESSAGEREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ATTACHEDFILENAME,MESSAGEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEMAILATTACHEDFILES
   where (ID) in (select ID from A_REMOTEMAILATTACHEDFILES))
  MINUS
  (select ID,ATTACHEDFILENAME,MESSAGEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEMAILATTACHEDFILES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEMAILATTACHEDFILES (ID,ATTACHEDFILENAME,MESSAGEREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ATTACHEDFILENAME,MESSAGEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEMAILATTACHEDFILES
where (ID) in
    (select ID from REMOTEMAILATTACHEDFILES
     MINUS
     select ID from A_REMOTEMAILATTACHEDFILES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEMAILCLIENTMESSAGES

update A_REMOTEMAILCLIENTMESSAGES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEMAILCLIENTMESSAGES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEMAILCLIENTMESSAGES)
/

update A_REMOTEMAILCLIENTMESSAGES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE
   from REMOTEMAILCLIENTMESSAGES
   where (ID) in (select ID from A_REMOTEMAILCLIENTMESSAGES))
  MINUS
  (select ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE
   from A_REMOTEMAILCLIENTMESSAGES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEMAILCLIENTMESSAGES (ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEMAILCLIENTMESSAGES
   where (ID) in (select ID from A_REMOTEMAILCLIENTMESSAGES))
  MINUS
  (select ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEMAILCLIENTMESSAGES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEMAILCLIENTMESSAGES (ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,MESSAGEREF,REMOTECLIENTREF,SENTDATE,RECEIVEDDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEMAILCLIENTMESSAGES
where (ID) in
    (select ID from REMOTEMAILCLIENTMESSAGES
     MINUS
     select ID from A_REMOTEMAILCLIENTMESSAGES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEMAILMESSAGES

update A_REMOTEMAILMESSAGES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEMAILMESSAGES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEMAILMESSAGES)
/

update A_REMOTEMAILMESSAGES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE
   from REMOTEMAILMESSAGES
   where (ID) in (select ID from A_REMOTEMAILMESSAGES))
  MINUS
  (select ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE
   from A_REMOTEMAILMESSAGES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEMAILMESSAGES (ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEMAILMESSAGES
   where (ID) in (select ID from A_REMOTEMAILMESSAGES))
  MINUS
  (select ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEMAILMESSAGES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEMAILMESSAGES (ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SUBJECT,TEXTFILENAME,REMINDER,CREATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEMAILMESSAGES
where (ID) in
    (select ID from REMOTEMAILMESSAGES
     MINUS
     select ID from A_REMOTEMAILMESSAGES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTEREADRIGHT

update A_REMOTEREADRIGHT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTEREADRIGHT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTEREADRIGHT)
/

update A_REMOTEREADRIGHT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from REMOTEREADRIGHT
   where (ID) in (select ID from A_REMOTEREADRIGHT))
  MINUS
  (select ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_REMOTEREADRIGHT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTEREADRIGHT (ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTEREADRIGHT
   where (ID) in (select ID from A_REMOTEREADRIGHT))
  MINUS
  (select ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTEREADRIGHT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTEREADRIGHT (ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,FACIALACCCLS,REMOTECLIENT,CLIENTID,FACIALACCCLSUP,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTEREADRIGHT
where (ID) in
    (select ID from REMOTEREADRIGHT
     MINUS
     select ID from A_REMOTEREADRIGHT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTETASKMANAGER

update A_REMOTETASKMANAGER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTETASKMANAGER
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTETASKMANAGER)
/

update A_REMOTETASKMANAGER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from REMOTETASKMANAGER
   where (ID) in (select ID from A_REMOTETASKMANAGER))
  MINUS
  (select ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_REMOTETASKMANAGER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTETASKMANAGER (ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTETASKMANAGER
   where (ID) in (select ID from A_REMOTETASKMANAGER))
  MINUS
  (select ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTETASKMANAGER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTETASKMANAGER (ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TASKENABLE,TASKDATE,TASKTIME,ISGROUP,REMOTECLIENT,REMOTEGROUP,REMOTETASKREGIME,DAYOFWEEK,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTETASKMANAGER
where (ID) in
    (select ID from REMOTETASKMANAGER
     MINUS
     select ID from A_REMOTETASKMANAGER
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTETASKMANAGERDETAIL

update A_REMOTETASKMANAGERDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTETASKMANAGERDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTETASKMANAGERDETAIL)
/

update A_REMOTETASKMANAGERDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from REMOTETASKMANAGERDETAIL
   where (ID) in (select ID from A_REMOTETASKMANAGERDETAIL))
  MINUS
  (select ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_REMOTETASKMANAGERDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTETASKMANAGERDETAIL (ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTETASKMANAGERDETAIL
   where (ID) in (select ID from A_REMOTETASKMANAGERDETAIL))
  MINUS
  (select ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTETASKMANAGERDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTETASKMANAGERDETAIL (ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REMOTETASKMANAGER,REMOTETASKTYPE,DOCTYPES,ORDERBY,PATH,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTETASKMANAGERDETAIL
where (ID) in
    (select ID from REMOTETASKMANAGERDETAIL
     MINUS
     select ID from A_REMOTETASKMANAGERDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTETASKREGIME

update A_REMOTETASKREGIME set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTETASKREGIME
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTETASKREGIME)
/

update A_REMOTETASKREGIME set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from REMOTETASKREGIME
   where (ID) in (select ID from A_REMOTETASKREGIME))
  MINUS
  (select ID,NAME
   from A_REMOTETASKREGIME
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTETASKREGIME (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTETASKREGIME
   where (ID) in (select ID from A_REMOTETASKREGIME))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTETASKREGIME
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTETASKREGIME (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTETASKREGIME
where (ID) in
    (select ID from REMOTETASKREGIME
     MINUS
     select ID from A_REMOTETASKREGIME
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REMOTETASKTYPE

update A_REMOTETASKTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REMOTETASKTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REMOTETASKTYPE)
/

update A_REMOTETASKTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from REMOTETASKTYPE
   where (ID) in (select ID from A_REMOTETASKTYPE))
  MINUS
  (select ID,NAME
   from A_REMOTETASKTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REMOTETASKTYPE (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REMOTETASKTYPE
   where (ID) in (select ID from A_REMOTETASKTYPE))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REMOTETASKTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REMOTETASKTYPE (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REMOTETASKTYPE
where (ID) in
    (select ID from REMOTETASKTYPE
     MINUS
     select ID from A_REMOTETASKTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REPLACEMENTCLSCAPTION

update A_REPLACEMENTCLSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REPLACEMENTCLSCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REPLACEMENTCLSCAPTION)
/

update A_REPLACEMENTCLSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF
   from REPLACEMENTCLSCAPTION
   where (ID) in (select ID from A_REPLACEMENTCLSCAPTION))
  MINUS
  (select ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF
   from A_REPLACEMENTCLSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REPLACEMENTCLSCAPTION (ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REPLACEMENTCLSCAPTION
   where (ID) in (select ID from A_REPLACEMENTCLSCAPTION))
  MINUS
  (select ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REPLACEMENTCLSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REPLACEMENTCLSCAPTION (ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCNUMBER,INPUTDATE,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ACCEPTDATE,REJECT_CLS,REJECT_CAUSE,PZKUSER,PZKSTARTDATE,PZKENDDATE,CLASSORIGINALDOC,NUMBERRECORDS,DOCSTATEREF,BUDGETREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REPLACEMENTCLSCAPTION
where (ID) in
    (select ID from REPLACEMENTCLSCAPTION
     MINUS
     select ID from A_REPLACEMENTCLSCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REPLACEMENTCLSDETAIL

update A_REPLACEMENTCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REPLACEMENTCLSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REPLACEMENTCLSDETAIL)
/

update A_REPLACEMENTCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE
   from REPLACEMENTCLSDETAIL
   where (ID) in (select ID from A_REPLACEMENTCLSDETAIL))
  MINUS
  (select ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE
   from A_REPLACEMENTCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REPLACEMENTCLSDETAIL (ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REPLACEMENTCLSDETAIL
   where (ID) in (select ID from A_REPLACEMENTCLSDETAIL))
  MINUS
  (select ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REPLACEMENTCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REPLACEMENTCLSDETAIL (ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,LINKID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REPLACEMENTCLSDETAIL
where (ID) in
    (select ID from REPLACEMENTCLSDETAIL
     MINUS
     select ID from A_REPLACEMENTCLSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REPLACEMENTCLSDETAILINFO

update A_REPLACEMENTCLSDETAILINFO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REPLACEMENTCLSDETAILINFO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REPLACEMENTCLSDETAILINFO)
/

update A_REPLACEMENTCLSDETAILINFO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT
   from REPLACEMENTCLSDETAILINFO
   where (ID) in (select ID from A_REPLACEMENTCLSDETAILINFO))
  MINUS
  (select ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT
   from A_REPLACEMENTCLSDETAILINFO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REPLACEMENTCLSDETAILINFO (ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REPLACEMENTCLSDETAILINFO
   where (ID) in (select ID from A_REPLACEMENTCLSDETAILINFO))
  MINUS
  (select ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REPLACEMENTCLSDETAILINFO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REPLACEMENTCLSDETAILINFO (ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,REGIONCLS,CLSTYPE,PROGINDEX,PARENTID,KVSR,KFSR,KCSR,KVR,KESR,SUBKESR,FACT,DIRECTIONCLS,MEANSTYPE,FINTYPE,FACIALACC_CLS,KD,IFS,FINSOURCE,TRANSFERTCLS,DOCBASE,ASSIGNMENTKIND,VARIANT,REESTRNUMBER,BUDGETREF,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REPLACEMENTCLSDETAILINFO
where (ID) in
    (select ID from REPLACEMENTCLSDETAILINFO
     MINUS
     select ID from A_REPLACEMENTCLSDETAILINFO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REPORTSPERMISSIONS

update A_REPORTSPERMISSIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REPORTSPERMISSIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REPORTSPERMISSIONS)
/

update A_REPORTSPERMISSIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REPORTID,USERID,PERMISSIONSTR
   from REPORTSPERMISSIONS
   where (ID) in (select ID from A_REPORTSPERMISSIONS))
  MINUS
  (select ID,REPORTID,USERID,PERMISSIONSTR
   from A_REPORTSPERMISSIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REPORTSPERMISSIONS (ID,REPORTID,USERID,PERMISSIONSTR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REPORTID,USERID,PERMISSIONSTR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REPORTSPERMISSIONS
   where (ID) in (select ID from A_REPORTSPERMISSIONS))
  MINUS
  (select ID,REPORTID,USERID,PERMISSIONSTR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REPORTSPERMISSIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REPORTSPERMISSIONS (ID,REPORTID,USERID,PERMISSIONSTR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REPORTID,USERID,PERMISSIONSTR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REPORTSPERMISSIONS
where (ID) in
    (select ID from REPORTSPERMISSIONS
     MINUS
     select ID from A_REPORTSPERMISSIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REPORTTESTERCONTROL

update A_REPORTTESTERCONTROL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REPORTTESTERCONTROL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REPORTTESTERCONTROL)
/

update A_REPORTTESTERCONTROL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GUID
   from REPORTTESTERCONTROL
   where (ID) in (select ID from A_REPORTTESTERCONTROL))
  MINUS
  (select ID,GUID
   from A_REPORTTESTERCONTROL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REPORTTESTERCONTROL (ID,GUID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GUID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REPORTTESTERCONTROL
   where (ID) in (select ID from A_REPORTTESTERCONTROL))
  MINUS
  (select ID,GUID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REPORTTESTERCONTROL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REPORTTESTERCONTROL (ID,GUID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GUID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REPORTTESTERCONTROL
where (ID) in
    (select ID from REPORTTESTERCONTROL
     MINUS
     select ID from A_REPORTTESTERCONTROL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REPORTTYPE

update A_REPORTTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REPORTTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REPORTTYPE)
/

update A_REPORTTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from REPORTTYPE
   where (ID) in (select ID from A_REPORTTYPE))
  MINUS
  (select ID,NAME
   from A_REPORTTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REPORTTYPE (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REPORTTYPE
   where (ID) in (select ID from A_REPORTTYPE))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REPORTTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REPORTTYPE (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REPORTTYPE
where (ID) in
    (select ID from REPORTTYPE
     MINUS
     select ID from A_REPORTTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_REQUESTFINCAPTION

update A_REQUESTFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_REQUESTFINCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from REQUESTFINCAPTION)
/

update A_REQUESTFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR
   from REQUESTFINCAPTION
   where (ID) in (select ID from A_REQUESTFINCAPTION))
  MINUS
  (select ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR
   from A_REQUESTFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_REQUESTFINCAPTION (ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from REQUESTFINCAPTION
   where (ID) in (select ID from A_REQUESTFINCAPTION))
  MINUS
  (select ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_REQUESTFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_REQUESTFINCAPTION (ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,INPUTDATE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ANUMBER,DFACCOUNT,SOURCEFACIALACC,SUMMA,STATE,RVERSION,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from REQUESTFINCAPTION
where (ID) in
    (select ID from REQUESTFINCAPTION
     MINUS
     select ID from A_REQUESTFINCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_RESERVEFUNDS

update A_RESERVEFUNDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_RESERVEFUNDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from RESERVEFUNDS)
/

update A_RESERVEFUNDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE
   from RESERVEFUNDS
   where (ID) in (select ID from A_RESERVEFUNDS))
  MINUS
  (select ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE
   from A_RESERVEFUNDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_RESERVEFUNDS (ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from RESERVEFUNDS
   where (ID) in (select ID from A_RESERVEFUNDS))
  MINUS
  (select ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_RESERVEFUNDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_RESERVEFUNDS (ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,MANAGERFACIALACCCLS,KFSR,GROUPITEM,TYPEFUNDSOPERATION,RESERVEDATE,SUMMA,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from RESERVEFUNDS
where (ID) in
    (select ID from RESERVEFUNDS
     MINUS
     select ID from A_RESERVEFUNDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_RIGHTKIND

update A_RIGHTKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_RIGHTKIND
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from RIGHTKIND)
/

update A_RIGHTKIND set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from RIGHTKIND
   where (ID) in (select ID from A_RIGHTKIND))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_RIGHTKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_RIGHTKIND (ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from RIGHTKIND
   where (ID) in (select ID from A_RIGHTKIND))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_RIGHTKIND
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_RIGHTKIND (ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from RIGHTKIND
where (ID) in
    (select ID from RIGHTKIND
     MINUS
     select ID from A_RIGHTKIND
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_RPS_DOCUMENT_JOURNAL

update A_RPS_DOCUMENT_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_RPS_DOCUMENT_JOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from RPS_DOCUMENT_JOURNAL)
/

update A_RPS_DOCUMENT_JOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER
   from RPS_DOCUMENT_JOURNAL
   where (ID) in (select ID from A_RPS_DOCUMENT_JOURNAL))
  MINUS
  (select ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER
   from A_RPS_DOCUMENT_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_RPS_DOCUMENT_JOURNAL (ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from RPS_DOCUMENT_JOURNAL
   where (ID) in (select ID from A_RPS_DOCUMENT_JOURNAL))
  MINUS
  (select ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_RPS_DOCUMENT_JOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_RPS_DOCUMENT_JOURNAL (ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCUMENTDATE,PACKETSIZE,CREATEDATE,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from RPS_DOCUMENT_JOURNAL
where (ID) in
    (select ID from RPS_DOCUMENT_JOURNAL
     MINUS
     select ID from A_RPS_DOCUMENT_JOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SCENARIO

update A_SCENARIO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SCENARIO
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SCENARIO)
/

update A_SCENARIO set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET
   from SCENARIO
   where (ID) in (select ID from A_SCENARIO))
  MINUS
  (select ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET
   from A_SCENARIO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SCENARIO (ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SCENARIO
   where (ID) in (select ID from A_SCENARIO))
  MINUS
  (select ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SCENARIO
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SCENARIO (ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,GENERATION,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,OPTIONSPATH,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SCENARIO
where (ID) in
    (select ID from SCENARIO
     MINUS
     select ID from A_SCENARIO
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SCHEMEBUHCACH

update A_SCHEMEBUHCACH set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SCHEMEBUHCACH
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SCHEMEBUHCACH)
/

update A_SCHEMEBUHCACH set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE
   from SCHEMEBUHCACH
   where (ID) in (select ID from A_SCHEMEBUHCACH))
  MINUS
  (select ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE
   from A_SCHEMEBUHCACH
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SCHEMEBUHCACH (ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SCHEMEBUHCACH
   where (ID) in (select ID from A_SCHEMEBUHCACH))
  MINUS
  (select ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SCHEMEBUHCACH
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SCHEMEBUHCACH (ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,DAT,DEBET,CREDIT,REGIONCLS,SUMMA,ACCREF1,ACCREF2,FILTERINDEX,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SCHEMEBUHCACH
where (ID) in
    (select ID from SCHEMEBUHCACH
     MINUS
     select ID from A_SCHEMEBUHCACH
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SELECTIONEVENTS

update A_SELECTIONEVENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SELECTIONEVENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SELECTIONEVENTS)
/

update A_SELECTIONEVENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from SELECTIONEVENTS
   where (ID) in (select ID from A_SELECTIONEVENTS))
  MINUS
  (select ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_SELECTIONEVENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SELECTIONEVENTS (ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SELECTIONEVENTS
   where (ID) in (select ID from A_SELECTIONEVENTS))
  MINUS
  (select ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SELECTIONEVENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SELECTIONEVENTS (ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,EVENTCODE,SELECTIONREF,SCRIPTNAME,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SELECTIONEVENTS
where (ID) in
    (select ID from SELECTIONEVENTS
     MINUS
     select ID from A_SELECTIONEVENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SELECTIONS

update A_SELECTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SELECTIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SELECTIONS)
/

update A_SELECTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED
   from SELECTIONS
   where (ID) in (select ID from A_SELECTIONS))
  MINUS
  (select ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED
   from A_SELECTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SELECTIONS (ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SELECTIONS
   where (ID) in (select ID from A_SELECTIONS))
  MINUS
  (select ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SELECTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SELECTIONS (ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KIND,NAME,NOTE,READONLY,USEINDOC,TABLENAME,ALIAS,TABLECODE,NEEDGROUPONDB,NEEDDISTINCT,MASTER,DISCRIMVALUE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,AVAILABLEINDEREF,CACHETYPE,FULLORMODINSREFRTIME,DELETEREFRTIME,FINDTIMEREFRESH,ANNOTATION,DEREFNAME,GROUPID,ISLOGGED,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SELECTIONS
where (ID) in
    (select ID from SELECTIONS
     MINUS
     select ID from A_SELECTIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SELECTIONSDETAIL

update A_SELECTIONSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SELECTIONSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SELECTIONSDETAIL)
/

update A_SELECTIONSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP
   from SELECTIONSDETAIL
   where (ID) in (select ID from A_SELECTIONSDETAIL))
  MINUS
  (select ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP
   from A_SELECTIONSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SELECTIONSDETAIL (ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SELECTIONSDETAIL
   where (ID) in (select ID from A_SELECTIONSDETAIL))
  MINUS
  (select ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SELECTIONSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SELECTIONSDETAIL (ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SELECTIONREF,TABLEREF,ALIAS,JOINORDER,JOINTYPE,RELATIONTYPE,JOINCONDITION,DONTUSETABLELIMITS,ADDCONDITION,LIMITNAMESLIST,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,QUERYGROUP,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SELECTIONSDETAIL
where (ID) in
    (select ID from SELECTIONSDETAIL
     MINUS
     select ID from A_SELECTIONSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNCERTIFICATE

update A_SIGNCERTIFICATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNCERTIFICATE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNCERTIFICATE)
/

update A_SIGNCERTIFICATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE
   from SIGNCERTIFICATE
   where (ID) in (select ID from A_SIGNCERTIFICATE))
  MINUS
  (select ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE
   from A_SIGNCERTIFICATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNCERTIFICATE (ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNCERTIFICATE
   where (ID) in (select ID from A_SIGNCERTIFICATE))
  MINUS
  (select ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNCERTIFICATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNCERTIFICATE (ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SERIALNUMBER,ISENABLED,STARTDATE,ENDDATE,OWNER,OWNERORGANIZATION,NOTE,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,OWNERTITLE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNCERTIFICATE
where (ID) in
    (select ID from SIGNCERTIFICATE
     MINUS
     select ID from A_SIGNCERTIFICATE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNDOCUMENTSGROUP

update A_SIGNDOCUMENTSGROUP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNDOCUMENTSGROUP
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNDOCUMENTSGROUP)
/

update A_SIGNDOCUMENTSGROUP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from SIGNDOCUMENTSGROUP
   where (ID) in (select ID from A_SIGNDOCUMENTSGROUP))
  MINUS
  (select ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_SIGNDOCUMENTSGROUP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNDOCUMENTSGROUP (ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNDOCUMENTSGROUP
   where (ID) in (select ID from A_SIGNDOCUMENTSGROUP))
  MINUS
  (select ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNDOCUMENTSGROUP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNDOCUMENTSGROUP (ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,NOTE,CLIENTREF,SCHEMAREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNDOCUMENTSGROUP
where (ID) in
    (select ID from SIGNDOCUMENTSGROUP
     MINUS
     select ID from A_SIGNDOCUMENTSGROUP
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNDOCUMENTSGROUPDETAIL

update A_SIGNDOCUMENTSGROUPDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNDOCUMENTSGROUPDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNDOCUMENTSGROUPDETAIL)
/

update A_SIGNDOCUMENTSGROUPDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from SIGNDOCUMENTSGROUPDETAIL
   where (ID) in (select ID from A_SIGNDOCUMENTSGROUPDETAIL))
  MINUS
  (select ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_SIGNDOCUMENTSGROUPDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNDOCUMENTSGROUPDETAIL (ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNDOCUMENTSGROUPDETAIL
   where (ID) in (select ID from A_SIGNDOCUMENTSGROUPDETAIL))
  MINUS
  (select ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNDOCUMENTSGROUPDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNDOCUMENTSGROUPDETAIL (ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCTYPE,DOCSTATE,FACIALACCCLS,FACIALACCCLSUP,RECORDINDEX,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNDOCUMENTSGROUPDETAIL
where (ID) in
    (select ID from SIGNDOCUMENTSGROUPDETAIL
     MINUS
     select ID from A_SIGNDOCUMENTSGROUPDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNLOG

update A_SIGNLOG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNLOG
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNLOG)
/

update A_SIGNLOG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY
   from SIGNLOG
   where (ID) in (select ID from A_SIGNLOG))
  MINUS
  (select ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY
   from A_SIGNLOG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNLOG (ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNLOG
   where (ID) in (select ID from A_SIGNLOG))
  MINUS
  (select ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNLOG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNLOG (ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCID,EDS_REF,SIGNREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,CREATERINFO,FACIALACCCLS,SENDERID,SENDERRECORDID,SIGNID,SIGNDATE,DOCTYPE,STATEHISTORYREF,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNLOG
where (ID) in
    (select ID from SIGNLOG
     MINUS
     select ID from A_SIGNLOG
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNPARAMS

update A_SIGNPARAMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNPARAMS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNPARAMS)
/

update A_SIGNPARAMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from SIGNPARAMS
   where (ID) in (select ID from A_SIGNPARAMS))
  MINUS
  (select ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_SIGNPARAMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNPARAMS (ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNPARAMS
   where (ID) in (select ID from A_SIGNPARAMS))
  MINUS
  (select ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNPARAMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNPARAMS (ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCID,SIGNREF,ISSTEPEND,ISSIGNEND,SIGNMASK,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNPARAMS
where (ID) in
    (select ID from SIGNPARAMS
     MINUS
     select ID from A_SIGNPARAMS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNPROFILE

update A_SIGNPROFILE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNPROFILE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNPROFILE)
/

update A_SIGNPROFILE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from SIGNPROFILE
   where (ID) in (select ID from A_SIGNPROFILE))
  MINUS
  (select ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_SIGNPROFILE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNPROFILE (ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNPROFILE
   where (ID) in (select ID from A_SIGNPROFILE))
  MINUS
  (select ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNPROFILE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNPROFILE (ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SIGNREF,SIGNDOCUMENTSGROUPREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNPROFILE
where (ID) in
    (select ID from SIGNPROFILE
     MINUS
     select ID from A_SIGNPROFILE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNPROFILEDETAIL

update A_SIGNPROFILEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNPROFILEDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNPROFILEDETAIL)
/

update A_SIGNPROFILEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from SIGNPROFILEDETAIL
   where (ID) in (select ID from A_SIGNPROFILEDETAIL))
  MINUS
  (select ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_SIGNPROFILEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNPROFILEDETAIL (ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNPROFILEDETAIL
   where (ID) in (select ID from A_SIGNPROFILEDETAIL))
  MINUS
  (select ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNPROFILEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNPROFILEDETAIL (ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,CERTIFICATEREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNPROFILEDETAIL
where (ID) in
    (select ID from SIGNPROFILEDETAIL
     MINUS
     select ID from A_SIGNPROFILEDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNS

update A_SIGNS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNS)
/

update A_SIGNS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE
   from SIGNS
   where (ID) in (select ID from A_SIGNS))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE
   from A_SIGNS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNS (ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNS
   where (ID) in (select ID from A_SIGNS))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNS (ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNS
where (ID) in
    (select ID from SIGNS
     MINUS
     select ID from A_SIGNS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SIGNSCHEMECAPTION

update A_SIGNSCHEMECAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SIGNSCHEMECAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SIGNSCHEMECAPTION)
/

update A_SIGNSCHEMECAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET
   from SIGNSCHEMECAPTION
   where (ID) in (select ID from A_SIGNSCHEMECAPTION))
  MINUS
  (select ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET
   from A_SIGNSCHEMECAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SIGNSCHEMECAPTION (ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SIGNSCHEMECAPTION
   where (ID) in (select ID from A_SIGNSCHEMECAPTION))
  MINUS
  (select ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SIGNSCHEMECAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SIGNSCHEMECAPTION (ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,NOTE,DOCTYPEREF,CLOSEDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SIGNSCHEMECAPTION
where (ID) in
    (select ID from SIGNSCHEMECAPTION
     MINUS
     select ID from A_SIGNSCHEMECAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SQLEXCEPTIONS

update A_SQLEXCEPTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SQLEXCEPTIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SQLEXCEPTIONS)
/

update A_SQLEXCEPTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,TEXT
   from SQLEXCEPTIONS
   where (ID) in (select ID from A_SQLEXCEPTIONS))
  MINUS
  (select ID,CODE,NAME,TEXT
   from A_SQLEXCEPTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SQLEXCEPTIONS (ID,CODE,NAME,TEXT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,TEXT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SQLEXCEPTIONS
   where (ID) in (select ID from A_SQLEXCEPTIONS))
  MINUS
  (select ID,CODE,NAME,TEXT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SQLEXCEPTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SQLEXCEPTIONS (ID,CODE,NAME,TEXT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,TEXT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SQLEXCEPTIONS
where (ID) in
    (select ID from SQLEXCEPTIONS
     MINUS
     select ID from A_SQLEXCEPTIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_ACTIONJUMPS

update A_STATE_ACTIONJUMPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_ACTIONJUMPS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_ACTIONJUMPS)
/

update A_STATE_ACTIONJUMPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from STATE_ACTIONJUMPS
   where (ID) in (select ID from A_STATE_ACTIONJUMPS))
  MINUS
  (select ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_STATE_ACTIONJUMPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_ACTIONJUMPS (ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_ACTIONJUMPS
   where (ID) in (select ID from A_STATE_ACTIONJUMPS))
  MINUS
  (select ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_ACTIONJUMPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_ACTIONJUMPS (ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACTIONREF,JUMPREF,FILTERCODE,OPTIONS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_ACTIONJUMPS
where (ID) in
    (select ID from STATE_ACTIONJUMPS
     MINUS
     select ID from A_STATE_ACTIONJUMPS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_CASCADEACTIONS

update A_STATE_CASCADEACTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_CASCADEACTIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_CASCADEACTIONS)
/

update A_STATE_CASCADEACTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF
   from STATE_CASCADEACTIONS
   where (ID) in (select ID from A_STATE_CASCADEACTIONS))
  MINUS
  (select ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF
   from A_STATE_CASCADEACTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_CASCADEACTIONS (ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_CASCADEACTIONS
   where (ID) in (select ID from A_STATE_CASCADEACTIONS))
  MINUS
  (select ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_CASCADEACTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_CASCADEACTIONS (ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SOURCEJUMPREF,MASTERFIELDNAME,ENABLED,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESTACTIONNAME,DESTDOCTYPEREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_CASCADEACTIONS
where (ID) in
    (select ID from STATE_CASCADEACTIONS
     MINUS
     select ID from A_STATE_CASCADEACTIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_DOCSTATES

update A_STATE_DOCSTATES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_DOCSTATES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_DOCSTATES)
/

update A_STATE_DOCSTATES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY
   from STATE_DOCSTATES
   where (ID) in (select ID from A_STATE_DOCSTATES))
  MINUS
  (select ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY
   from A_STATE_DOCSTATES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_DOCSTATES (ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_DOCSTATES
   where (ID) in (select ID from A_STATE_DOCSTATES))
  MINUS
  (select ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_DOCSTATES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_DOCSTATES (ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,DOCTYPEREF,STATETYPEREF,ICONNAME,STATENUMBER,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,STATEORDER,CONTROLLEVEL,COMMON_STATENAME,ISACTIVE,ISSYSTEM,POSX,POSY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_DOCSTATES
where (ID) in
    (select ID from STATE_DOCSTATES
     MINUS
     select ID from A_STATE_DOCSTATES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_FILTER

update A_STATE_FILTER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_FILTER
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_FILTER)
/

update A_STATE_FILTER set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM
   from STATE_FILTER
   where (ID) in (select ID from A_STATE_FILTER))
  MINUS
  (select ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM
   from A_STATE_FILTER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_FILTER (ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_FILTER
   where (ID) in (select ID from A_STATE_FILTER))
  MINUS
  (select ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_FILTER
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_FILTER (ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,NOTE,FILTERVALUE,FILTERFORMAT,FILTERACTIVE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ISBUDGET,FILTERVALUEURM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_FILTER
where (ID) in
    (select ID from STATE_FILTER
     MINUS
     select ID from A_STATE_FILTER
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_JUMPCONTROL

update A_STATE_JUMPCONTROL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_JUMPCONTROL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_JUMPCONTROL)
/

update A_STATE_JUMPCONTROL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET
   from STATE_JUMPCONTROL
   where (ID) in (select ID from A_STATE_JUMPCONTROL))
  MINUS
  (select ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET
   from A_STATE_JUMPCONTROL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_JUMPCONTROL (ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_JUMPCONTROL
   where (ID) in (select ID from A_STATE_JUMPCONTROL))
  MINUS
  (select ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_JUMPCONTROL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_JUMPCONTROL (ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,JUMPREF,CONTROLCODE,CONTROLOPTIONS,CONDITION,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RECORDTYPE,EXECTYPE,EXECORDER,ENABLED,ACTIONREF,FILTERCODE,FILTERNOTE,ENDSTATEREF,REFERENCEREF,STATICLINKREF,BEGINSTATEREF,SCENARIOREF,ELEMENTSCENARIOREF,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_JUMPCONTROL
where (ID) in
    (select ID from STATE_JUMPCONTROL
     MINUS
     select ID from A_STATE_JUMPCONTROL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_JUMPS

update A_STATE_JUMPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_JUMPS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_JUMPS)
/

update A_STATE_JUMPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES
   from STATE_JUMPS
   where (ID) in (select ID from A_STATE_JUMPS))
  MINUS
  (select ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES
   from A_STATE_JUMPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_JUMPS (ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_JUMPS
   where (ID) in (select ID from A_STATE_JUMPS))
  MINUS
  (select ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_JUMPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_JUMPS (ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,NOTE,BEGINSTATEREF,ENDSTATEREF,DOCTYPEREF,UPDATERUSER,CREATERUSER,CREATEDATE,UPDATEDATE,NEEDEDS,BACKJUMP,NEEDCHECKEDS,CONTROLLIST,DOCSEVENT,DOCSLIST,OPTIONSPATH,CANATTACHFILES,CANDETACTHFILES,CANREJECTATTACHEDFILES,ISACTIVE,SIGNATTACHEDFILES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_JUMPS
where (ID) in
    (select ID from STATE_JUMPS
     MINUS
     select ID from A_STATE_JUMPS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_OPENFIELDS

update A_STATE_OPENFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_OPENFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_OPENFIELDS)
/

update A_STATE_OPENFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT
   from STATE_OPENFIELDS
   where (ID) in (select ID from A_STATE_OPENFIELDS))
  MINUS
  (select ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT
   from A_STATE_OPENFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_OPENFIELDS (ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_OPENFIELDS
   where (ID) in (select ID from A_STATE_OPENFIELDS))
  MINUS
  (select ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_OPENFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_OPENFIELDS (ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCFIELDREF,JUMPREF,UPDATEDATE,CREATEDATE,UPDATERUSER,CREATERUSER,NONUSEREDIT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_OPENFIELDS
where (ID) in
    (select ID from STATE_OPENFIELDS
     MINUS
     select ID from A_STATE_OPENFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATE_TYPES

update A_STATE_TYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATE_TYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATE_TYPES)
/

update A_STATE_TYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from STATE_TYPES
   where (ID) in (select ID from A_STATE_TYPES))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER
   from A_STATE_TYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATE_TYPES (ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATE_TYPES
   where (ID) in (select ID from A_STATE_TYPES))
  MINUS
  (select ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATE_TYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATE_TYPES (ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATEDATE,UPDATEDATE,UPDATERUSER,CREATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATE_TYPES
where (ID) in
    (select ID from STATE_TYPES
     MINUS
     select ID from A_STATE_TYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATEJUMPHISTORY

update A_STATEJUMPHISTORY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATEJUMPHISTORY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATEJUMPHISTORY)
/

update A_STATEJUMPHISTORY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF
   from STATEJUMPHISTORY
   where (ID) in (select ID from A_STATEJUMPHISTORY))
  MINUS
  (select ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF
   from A_STATEJUMPHISTORY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATEJUMPHISTORY (ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATEJUMPHISTORY
   where (ID) in (select ID from A_STATEJUMPHISTORY))
  MINUS
  (select ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATEJUMPHISTORY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATEJUMPHISTORY (ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCID,BEGINSTATEREF,ENDSTATEREF,CREATERUSER,CREATEDATE,BACKJUMP,EDSREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATEJUMPHISTORY
where (ID) in
    (select ID from STATEJUMPHISTORY
     MINUS
     select ID from A_STATEJUMPHISTORY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STATUSICONS

update A_STATUSICONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STATUSICONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STATUSICONS)
/

update A_STATUSICONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE
   from STATUSICONS
   where (ID) in (select ID from A_STATUSICONS))
  MINUS
  (select ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE
   from A_STATUSICONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STATUSICONS (ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STATUSICONS
   where (ID) in (select ID from A_STATUSICONS))
  MINUS
  (select ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STATUSICONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STATUSICONS (ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NOTE,DOCREF,DOCPARAM,DETAILNUM,ICONNAME,ISSYSTEM,ICONPOS,RUNPOS,RESERVEPOS,ICONHINT,ICONKIND,LOCKMASK,FORMULA,ISBUDGET,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STATUSICONS
where (ID) in
    (select ID from STATUSICONS
     MINUS
     select ID from A_STATUSICONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STOREDATTRIBUTESCAPTION

update A_STOREDATTRIBUTESCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STOREDATTRIBUTESCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STOREDATTRIBUTESCAPTION)
/

update A_STOREDATTRIBUTESCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET
   from STOREDATTRIBUTESCAPTION
   where (ID) in (select ID from A_STOREDATTRIBUTESCAPTION))
  MINUS
  (select ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET
   from A_STOREDATTRIBUTESCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STOREDATTRIBUTESCAPTION (ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STOREDATTRIBUTESCAPTION
   where (ID) in (select ID from A_STOREDATTRIBUTESCAPTION))
  MINUS
  (select ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STOREDATTRIBUTESCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STOREDATTRIBUTESCAPTION (ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCREF,DOCPARAM,DATEOPEN,DATECLOSE,ISACTIVE,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,ISBUDGET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STOREDATTRIBUTESCAPTION
where (ID) in
    (select ID from STOREDATTRIBUTESCAPTION
     MINUS
     select ID from A_STOREDATTRIBUTESCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_STOREDATTRIBUTESDETAIL

update A_STOREDATTRIBUTESDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_STOREDATTRIBUTESDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from STOREDATTRIBUTESDETAIL)
/

update A_STOREDATTRIBUTESDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD
   from STOREDATTRIBUTESDETAIL
   where (ID) in (select ID from A_STOREDATTRIBUTESDETAIL))
  MINUS
  (select ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD
   from A_STOREDATTRIBUTESDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_STOREDATTRIBUTESDETAIL (ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from STOREDATTRIBUTESDETAIL
   where (ID) in (select ID from A_STOREDATTRIBUTESDETAIL))
  MINUS
  (select ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_STOREDATTRIBUTESDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_STOREDATTRIBUTESDETAIL (ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CONTAINER_REF,ATTRIBUTE_REF,FIELDTYPE,FIELDSIZE,NAME,SOURCEFIELD,FIELDORDER,FORMULA,READONLY,PREVVERSIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,RECORDINDEX,CALCMETHOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from STOREDATTRIBUTESDETAIL
where (ID) in
    (select ID from STOREDATTRIBUTESDETAIL
     MINUS
     select ID from A_STOREDATTRIBUTESDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SUBKCSR

update A_SUBKCSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SUBKCSR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SUBKCSR)
/

update A_SUBKCSR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from SUBKCSR
   where (ID) in (select ID from A_SUBKCSR))
  MINUS
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_SUBKCSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SUBKCSR (ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SUBKCSR
   where (ID) in (select ID from A_SUBKCSR))
  MINUS
  (select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SUBKCSR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SUBKCSR (ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SUBKCSR
where (ID) in
    (select ID from SUBKCSR
     MINUS
     select ID from A_SUBKCSR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SUBKD

update A_SUBKD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SUBKD
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SUBKD)
/

update A_SUBKD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE
   from SUBKD
   where (ID) in (select ID from A_SUBKD))
  MINUS
  (select ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE
   from A_SUBKD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SUBKD (ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SUBKD
   where (ID) in (select ID from A_SUBKD))
  MINUS
  (select ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SUBKD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SUBKD (ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,BUHACCOUNT,CREATEDATE,UPDATEDATE,NAME,STARTDATE,DELETEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SUBKD
where (ID) in
    (select ID from SUBKD
     MINUS
     select ID from A_SUBKD
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SUBSIDYCLS

update A_SUBSIDYCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SUBSIDYCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SUBSIDYCLS)
/

update A_SUBSIDYCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from SUBSIDYCLS
   where (ID) in (select ID from A_SUBSIDYCLS))
  MINUS
  (select ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_SUBSIDYCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SUBSIDYCLS (ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SUBSIDYCLS
   where (ID) in (select ID from A_SUBSIDYCLS))
  MINUS
  (select ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SUBSIDYCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SUBSIDYCLS (ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE,NAME,ORG_REF,SUBSIDYKIND,BUDGETREF,STARTDATE,DELETEDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,BELONGINGKIND,SUBSIDYYEAR,DOCUMENTCLS,DOCBASE,NPAGROUP,NPANAME,NPADATE,NPANUMBER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SUBSIDYCLS
where (ID) in
    (select ID from SUBSIDYCLS
     MINUS
     select ID from A_SUBSIDYCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SUMINPASSAGE

update A_SUMINPASSAGE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SUMINPASSAGE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SUMINPASSAGE)
/

update A_SUMINPASSAGE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE
   from SUMINPASSAGE
   where (ID) in (select ID from A_SUMINPASSAGE))
  MINUS
  (select ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE
   from A_SUMINPASSAGE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SUMINPASSAGE (ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SUMINPASSAGE
   where (ID) in (select ID from A_SUMINPASSAGE))
  MINUS
  (select ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SUMINPASSAGE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SUMINPASSAGE (ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ODATE,BUHACCOUNT,UPDATEDATE,UPDATERUSER,BUHOPERATIONCLS,SENDERID,SENDERRECORDID,CREATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SUMINPASSAGE
where (ID) in
    (select ID from SUMINPASSAGE
     MINUS
     select ID from A_SUMINPASSAGE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_SUPDOCTYPECLS

update A_SUPDOCTYPECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_SUPDOCTYPECLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from SUPDOCTYPECLS)
/

update A_SUPDOCTYPECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION
   from SUPDOCTYPECLS
   where (ID) in (select ID from A_SUPDOCTYPECLS))
  MINUS
  (select ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION
   from A_SUPDOCTYPECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_SUPDOCTYPECLS (ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from SUPDOCTYPECLS
   where (ID) in (select ID from A_SUPDOCTYPECLS))
  MINUS
  (select ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_SUPDOCTYPECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_SUPDOCTYPECLS (ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,YARDSTICKREF,NOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from SUPDOCTYPECLS
where (ID) in
    (select ID from SUPDOCTYPECLS
     MINUS
     select ID from A_SUPDOCTYPECLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TARGETCLS

update A_TARGETCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TARGETCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TARGETCLS)
/

update A_TARGETCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from TARGETCLS
   where (ID) in (select ID from A_TARGETCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_TARGETCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TARGETCLS (ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TARGETCLS
   where (ID) in (select ID from A_TARGETCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TARGETCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TARGETCLS (ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,STRCODE,NAME,STARTDATE,DELETEDATE,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TARGETCLS
where (ID) in
    (select ID from TARGETCLS
     MINUS
     select ID from A_TARGETCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_AGREEMENTS

update A_TB_AGREEMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_AGREEMENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_AGREEMENTS)
/

update A_TB_AGREEMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE
   from TB_AGREEMENTS
   where (ID) in (select ID from A_TB_AGREEMENTS))
  MINUS
  (select ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE
   from A_TB_AGREEMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_AGREEMENTS (ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_AGREEMENTS
   where (ID) in (select ID from A_TB_AGREEMENTS))
  MINUS
  (select ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_AGREEMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_AGREEMENTS (ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SUMMA,AGREEMENTDATE,AGREEMENTENDDATE,EXECUTER_REF,CLIENT_REF,FACIALACC_CLS,AGREEMENTTYPE,ACCEPTED,ACCEPTDATE,CARDADVANCEPERCENT,CARDADVANCE,CLOSEDOC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,LASTADJUSTMENT,LASTACCEPTED,FACT,REGION,CLOSEDATE,DELIVERYRULES,AGREEMENTSUMMA,AGREEMENTFINSUMMA,ADJUSTMENTREF,REESTRNUMBER,PAYMENTDATE,AGREEMENTCARDADVANCE,FINCARDADVANCE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,AGREEMENTBEGINDATE,PROTOCOLNUMBER,PROTOCOLDATE,REVIEWNOTE,DOCSTATEREF,RVERSION,EXPORTDATE,FSORGAN,FSBUDGETNAME,FSOFFBUDGET,RNYEAR,RNNUMBER,RNDATE,PROTOCOLNOTICE,PROTOCOLRESULTDATE,PROTOCOLDOCTYPE,PROTOCOLSALETYPE,NOTIFYDATE,EXECUTERACCREF,DOCBASEDATE,DOCBASENOTIFYDATE,DOCBASETEXT,DOCBASETYPE,DOCBASESUMMA,UNKNOWNAMOUNT,PROTOCOLREASON,DOCNUMBER,ADJUSTMENTDOCNUMBER,OLDDOCNUMBER,LOTMAXSUM,CLIENT_INN,CLIENT_INN20,CLIENT_NAME,EXECUTER_INN,EXECUTER_INN20,EXECUTER_NAME,EXECUTER_STATUS,EXECUTER_COUNTRY,EXECUTER_ADDRESS,EXECUTER_PHONE,REALID,ADJUSTMENTNUMBER,INNERNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REESTRVERSION,DOCTYPE,RNCLIENTID,INFONUMBER,STATEORDERINNERNUMBER,PROGINDEX,NOTE,PURPORTDOC,REESTRRECORDNUMBER,EXECUTERSTOREDPROPS,AUTOSANCTION,PURCHASECODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_AGREEMENTS
where (ID) in
    (select ID from TB_AGREEMENTS
     MINUS
     select ID from A_TB_AGREEMENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_ALLOWANCECAPTION

update A_TB_ALLOWANCECAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_ALLOWANCECAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_ALLOWANCECAPTION)
/

update A_TB_ALLOWANCECAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE
   from TB_ALLOWANCECAPTION
   where (ID) in (select ID from A_TB_ALLOWANCECAPTION))
  MINUS
  (select ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE
   from A_TB_ALLOWANCECAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_ALLOWANCECAPTION (ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_ALLOWANCECAPTION
   where (ID) in (select ID from A_TB_ALLOWANCECAPTION))
  MINUS
  (select ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_ALLOWANCECAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_ALLOWANCECAPTION (ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ALLOWANCETYPE,ACCEPTORORGREF,FACIALACC_CLS,NUMBERGENERAL,NUMBERGENERALADD,NUMBERDOC,NUMBERADD,BEGINDATE,ENDDATE,CONSTITUTIVEDOCTYPE,CONSTITUTIVEDATE,CONSTITUTIVENUMBER,CONSTITUTIVEORGAN,REGISTERFIO,REGISTERJOB,REGISTERDATE,REGISTERORGAN,RETURNNOTIFYNUMBER,RETURNNOTIFYDATE,RETURNREJECTCAUSE,RETURNDATE,RETURNFIO,RETURNJOB,SENDERID,SENDERRECORDID,REJECT_CLS,REJECTCAUSE,NUMBERRETURNTRANZACTION,NUMBERREJECTTRANZACTION,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,DOCSTATEREF,CRYPTOSTATUS,PROGINDEX,RVERSION,INPUTDATE,REQUESTNUMBER,NOTE,LASTEXTRCHANGE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_ALLOWANCECAPTION
where (ID) in
    (select ID from TB_ALLOWANCECAPTION
     MINUS
     select ID from A_TB_ALLOWANCECAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_BANKS

update A_TB_BANKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_BANKS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_BANKS)
/

update A_TB_BANKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from TB_BANKS
   where (ID) in (select ID from A_TB_BANKS))
  MINUS
  (select ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_TB_BANKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_BANKS (ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_BANKS
   where (ID) in (select ID from A_TB_BANKS))
  MINUS
  (select ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_BANKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_BANKS (ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,MFO,COR,CLOSED,UER,UERREAL,PZN,DATECLOSE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_BANKS
where (ID) in
    (select ID from TB_BANKS
     MINUS
     select ID from A_TB_BANKS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_BUDGETS_S

update A_TB_BUDGETS_S set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_BUDGETS_S
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_BUDGETS_S)
/

update A_TB_BUDGETS_S set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID
   from TB_BUDGETS_S
   where (ID) in (select ID from A_TB_BUDGETS_S))
  MINUS
  (select ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID
   from A_TB_BUDGETS_S
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_BUDGETS_S (ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_BUDGETS_S
   where (ID) in (select ID from A_TB_BUDGETS_S))
  MINUS
  (select ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_BUDGETS_S
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_BUDGETS_S (ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,LASTMODIFDATE_B,CURRENTBUDGET,NOTE,OKATO,ADDOKATO,CREATEDATE,UPDATEDATE,AYEAR,CREATERUSER,UPDATERUSER,BUDGETLEVEL,CHIEFNAME,CHIEFROLE,STARTDATE,DELETEDATE,EXTID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_BUDGETS_S
where (ID) in
    (select ID from TB_BUDGETS_S
     MINUS
     select ID from A_TB_BUDGETS_S
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_BUDNOTIFY

update A_TB_BUDNOTIFY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_BUDNOTIFY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_BUDNOTIFY)
/

update A_TB_BUDNOTIFY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1
   from TB_BUDNOTIFY
   where (ID) in (select ID from A_TB_BUDNOTIFY))
  MINUS
  (select ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1
   from A_TB_BUDNOTIFY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_BUDNOTIFY (ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_BUDNOTIFY
   where (ID) in (select ID from A_TB_BUDNOTIFY))
  MINUS
  (select ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_BUDNOTIFY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_BUDNOTIFY (ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DAT,DOCDAT,NOTIFYTYPE,BUDGETREF,DOCBASE,VARIANT,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,ANUMBER,ATYPE,DOCUMENTSTATE,USERSVISA,DATEINPUT,ORGREF,REJECTCLS,REJECTNOTE,PLANDOCTYPE,RECORDINDEX,STIMATEID,CRYPTOSTATUS,RVERSION,DOCSTATEREF,DOCNUMBER,FACIALACCCLS,LASTEXTRCHANGE,BIDNUMBER,FAXDOCCOUNT,PLANKIND,ASSIGNMENTSOURCE,BA_LBO_FLAG,KPPERIOD,CLSTYPE,DATE_UTV_PP,PROGINDEX,NOTE,NOTE2,DOCCHANGEDATE,SIGNERS,SENDERIDKEY,SENDERRECORDIDKEY,EXTID,EXTROOTID,NOTE1,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_BUDNOTIFY
where (ID) in
    (select ID from TB_BUDNOTIFY
     MINUS
     select ID from A_TB_BUDNOTIFY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_BUHACCCORR

update A_TB_BUHACCCORR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_BUHACCCORR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_BUHACCCORR)
/

update A_TB_BUHACCCORR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND
   from TB_BUHACCCORR
   where (ID) in (select ID from A_TB_BUHACCCORR))
  MINUS
  (select ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND
   from A_TB_BUHACCCORR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_BUHACCCORR (ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_BUHACCCORR
   where (ID) in (select ID from A_TB_BUHACCCORR))
  MINUS
  (select ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_BUHACCCORR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_BUHACCCORR (ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUHOPERATIONCLS,DEBITACCREF,CREDITACCREF,BALANCECLS,DEBITBUDCLSKIND,CREDITBUDCLSKIND,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,BACKNAME,HEADACTIVITYKIND,ACTIVITYKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_BUHACCCORR
where (ID) in
    (select ID from TB_BUHACCCORR
     MINUS
     select ID from A_TB_BUHACCCORR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_BUHOPERATIONCLS

update A_TB_BUHOPERATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_BUHOPERATIONCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_BUHOPERATIONCLS)
/

update A_TB_BUHOPERATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE
   from TB_BUHOPERATIONCLS
   where (ID) in (select ID from A_TB_BUHOPERATIONCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE
   from A_TB_BUHOPERATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_BUHOPERATIONCLS (ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_BUHOPERATIONCLS
   where (ID) in (select ID from A_TB_BUHOPERATIONCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_BUHOPERATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_BUHOPERATIONCLS (ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,CORRECTIONFLAG,NAME,CREATERUSER,UPDATERUSER,STARTDATE,DELETEDATE,COUNTDETAILRECORDS,DOCCHANGEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_BUHOPERATIONCLS
where (ID) in
    (select ID from TB_BUHOPERATIONCLS
     MINUS
     select ID from A_TB_BUHOPERATIONCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_CORRECTIONDETAIL

update A_TB_CORRECTIONDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_CORRECTIONDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_CORRECTIONDETAIL)
/

update A_TB_CORRECTIONDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME
   from TB_CORRECTIONDETAIL
   where (ID) in (select ID from A_TB_CORRECTIONDETAIL))
  MINUS
  (select ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME
   from A_TB_CORRECTIONDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_CORRECTIONDETAIL (ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_CORRECTIONDETAIL
   where (ID) in (select ID from A_TB_CORRECTIONDETAIL))
  MINUS
  (select ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_CORRECTIONDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_CORRECTIONDETAIL (ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PARENTID,BUDGETREF,SUMMA,CLSTYPE,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,FUNDSSOURCE,KD,IFS,BUHOPERATIONCLS,CHANGEACC_REF,CHANGEACC,CHANGEORGINN,CHANGEORGINN20,PROGINDEX,RECORDINDEX,DOCUMENTPROGINDEX,DOCUMENTRECORDINDEX,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,NOTE,ISCLSCHANGED,PROMISE,BUDGETPROMISE,EXECDOC,OKATO,ADDOKATO,TRANSFERTCLS,ORIGINALCLSSUMMA,NOTECLS,OPERATIONTYPE,REVERSEFLAG,EXECINNERNUMBER,CLSFIELFCHANGED,FAORGTYPE,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,NOTEQUALEX,OKTMO,UINCODE,INVESTOBJECT,CHANGEORGNAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_CORRECTIONDETAIL
where (ID) in
    (select ID from TB_CORRECTIONDETAIL
     MINUS
     select ID from A_TB_CORRECTIONDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_DBUSERS

update A_TB_DBUSERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_DBUSERS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_DBUSERS)
/

update A_TB_DBUSERS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER
   from TB_DBUSERS
   where (ID) in (select ID from A_TB_DBUSERS))
  MINUS
  (select ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER
   from A_TB_DBUSERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_DBUSERS (ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_DBUSERS
   where (ID) in (select ID from A_TB_DBUSERS))
  MINUS
  (select ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_DBUSERS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_DBUSERS (ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,USERNAME,FIRSTNAME,MIDDLENAME,LASTNAME,NOTE,PHONE,DESCRIPTION,DEPARTMENTCLS,REMOTECLIENTREF,REMOTEID,CREATEDATE,UPDATEDATE,CRYPTOPARAMS,CRYPTOID,ORG_REF,NOTE2,EMAILADDRESS,PRINCIPALNAME,USERGUID,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_DBUSERS
where (ID) in
    (select ID from TB_DBUSERS
     MINUS
     select ID from A_TB_DBUSERS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_DESCRDOCUMENTTYPES

update A_TB_DESCRDOCUMENTTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_DESCRDOCUMENTTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_DESCRDOCUMENTTYPES)
/

update A_TB_DESCRDOCUMENTTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from TB_DESCRDOCUMENTTYPES
   where (ID) in (select ID from A_TB_DESCRDOCUMENTTYPES))
  MINUS
  (select ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_TB_DESCRDOCUMENTTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_DESCRDOCUMENTTYPES (ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_DESCRDOCUMENTTYPES
   where (ID) in (select ID from A_TB_DESCRDOCUMENTTYPES))
  MINUS
  (select ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_DESCRDOCUMENTTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_DESCRDOCUMENTTYPES (ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PARENTDOCTYPEREF,CLASSNAME,KINDOFDOC,DBTABLE,KINDOFFORM,NAMESPACE,CLASSGUID,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_DESCRDOCUMENTTYPES
where (ID) in
    (select ID from TB_DESCRDOCUMENTTYPES
     MINUS
     select ID from A_TB_DESCRDOCUMENTTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_DFACCOUNTSBUHTABLE

update A_TB_DFACCOUNTSBUHTABLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_DFACCOUNTSBUHTABLE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_DFACCOUNTSBUHTABLE)
/

update A_TB_DFACCOUNTSBUHTABLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU
   from TB_DFACCOUNTSBUHTABLE
   where (ID) in (select ID from A_TB_DFACCOUNTSBUHTABLE))
  MINUS
  (select BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU
   from A_TB_DFACCOUNTSBUHTABLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_DFACCOUNTSBUHTABLE (BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_DFACCOUNTSBUHTABLE
   where (ID) in (select ID from A_TB_DFACCOUNTSBUHTABLE))
  MINUS
  (select BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_DFACCOUNTSBUHTABLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_DFACCOUNTSBUHTABLE (BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select BUDGETREF,ID,BUHACC,ACCMODE,FIXED,CREATEDATE,UPDATEDATE,CURRENCYCLS,TREASURYACCREF,FINORGACCREF,IFS,SINGLEID,ISCOMMON,ISFORBUDGET,ISFORBUSINESS,ISFORTEMPORARY,ISFORCASH,CREATERUSER,UPDATERUSER,REGIONCLS,ISFORBU_AU,ISDEPOSIT,FACIALACC_ADB,ISFORTEMPORARYBU_AU,ISFORAU,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_DFACCOUNTSBUHTABLE
where (ID) in
    (select ID from TB_DFACCOUNTSBUHTABLE
     MINUS
     select ID from A_TB_DFACCOUNTSBUHTABLE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_DOCUMENTFIELDS

update A_TB_DOCUMENTFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_DOCUMENTFIELDS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_DOCUMENTFIELDS)
/

update A_TB_DOCUMENTFIELDS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME
   from TB_DOCUMENTFIELDS
   where (ID) in (select ID from A_TB_DOCUMENTFIELDS))
  MINUS
  (select ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME
   from A_TB_DOCUMENTFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_DOCUMENTFIELDS (ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_DOCUMENTFIELDS
   where (ID) in (select ID from A_TB_DOCUMENTFIELDS))
  MINUS
  (select ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_DOCUMENTFIELDS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_DOCUMENTFIELDS (ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,ITFFIELDNAME,NOTE,ISBUDGET,DOCTYPEREF,DETAILNUMBER,CREATERUSER,UPDATEDATE,UPDATERUSER,CREATEDATE,TEMPLATEFIELD,ONLYREAD,REPORTFIELDNAME,DOCUMENTCLS,FIELDINFOREF,CONTAINERREF,ATTRFIELDKIND,ATTRIBUTENAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_DOCUMENTFIELDS
where (ID) in
    (select ID from TB_DOCUMENTFIELDS
     MINUS
     select ID from A_TB_DOCUMENTFIELDS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_EXECUTIONDOCUMENTSCAPTION

update A_TB_EXECUTIONDOCUMENTSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_EXECUTIONDOCUMENTSCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_EXECUTIONDOCUMENTSCAPTION)
/

update A_TB_EXECUTIONDOCUMENTSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF
   from TB_EXECUTIONDOCUMENTSCAPTION
   where (ID) in (select ID from A_TB_EXECUTIONDOCUMENTSCAPTION))
  MINUS
  (select ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF
   from A_TB_EXECUTIONDOCUMENTSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_EXECUTIONDOCUMENTSCAPTION (ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_EXECUTIONDOCUMENTSCAPTION
   where (ID) in (select ID from A_TB_EXECUTIONDOCUMENTSCAPTION))
  MINUS
  (select ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_EXECUTIONDOCUMENTSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_EXECUTIONDOCUMENTSCAPTION (ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCTYPE,DOCUMENTDATE,ACCEPTDATE,SUMMA,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,STEPNUMBER,FACIALACC_CLS,RECIPIENT_REF,REGISTRATIONTYPE,REESTRNUMBER,AGREEMENTINNERNUMBER,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,REVIEWNOTE,DOCSTATEREF,RVERSION,EXECDOCFINSUMMA,FACT,DOCNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,REALID,INNERNUMBER,ADJUSTMENTREF,ADJUSTMENTNUMBER,ACCEPTED,LASTACCEPTED,LASTADJUSTMENT,AGREEMENTREF,NOTE,SUPPLIERSTOREDPROPS,SUPPLIER_REF,SUPPLIERACC_REF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_EXECUTIONDOCUMENTSCAPTION
where (ID) in
    (select ID from TB_EXECUTIONDOCUMENTSCAPTION
     MINUS
     select ID from A_TB_EXECUTIONDOCUMENTSCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_FACIALACC_CLS

update A_TB_FACIALACC_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_FACIALACC_CLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_FACIALACC_CLS)
/

update A_TB_FACIALACC_CLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX
   from TB_FACIALACC_CLS
   where (ID) in (select ID from A_TB_FACIALACC_CLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX
   from A_TB_FACIALACC_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_FACIALACC_CLS (ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_FACIALACC_CLS
   where (ID) in (select ID from A_TB_FACIALACC_CLS))
  MINUS
  (select ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_FACIALACC_CLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_FACIALACC_CLS (ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CODE1,CODE2,CODE3,CODE4,KVSR,KCSR,KFSR,KVR,KESR,FINTYPE,ORG_REF,DATEOPEN,SERVICEACCOUNT,STATUSACCOUNT,HARACTERACCOUNT,REGIONCLS,CREATEDATE,UPDATEDATE,FACIALCODE,MEANSTYPE,GENERALORG_REF,DEPARTMENTCLS,RVERSION,CLOSEDOCNUMBER,HIGHERORG_REF,BUDGETREF,FCACCOUNT,CLOSECODE,DATECLOSE,CREATERUSER,UPDATERUSER,NOTE,NAME,ISRBS,ISPBS,ISBU,ISSEPARATEBU,ISPROXY,OPENDOCNUMBER,ISOMS,CHANGEDOCNUMBER,DATECHANGE,GENERALORGFACIALACC,GRANTEEORG_REF,PREVCLS,FACIALCODEEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_FACIALACC_CLS
where (ID) in
    (select ID from TB_FACIALACC_CLS
     MINUS
     select ID from A_TB_FACIALACC_CLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_FACIALFINCAPTION

update A_TB_FACIALFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_FACIALFINCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_FACIALFINCAPTION)
/

update A_TB_FACIALFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION
   from TB_FACIALFINCAPTION
   where (ID) in (select ID from A_TB_FACIALFINCAPTION))
  MINUS
  (select ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION
   from A_TB_FACIALFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_FACIALFINCAPTION (ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_FACIALFINCAPTION
   where (ID) in (select ID from A_TB_FACIALFINCAPTION))
  MINUS
  (select ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_FACIALFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_FACIALFINCAPTION (ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCNUMBER,SOURCEDOCNUM,PAYDATE,ACCEPTDATE,DOCUMENTDATE,REESTRDATE,CREDIT,SOURCEACCOUNT,SOURCEFACIALACC_CLS,DESTACCOUNT,DESTFACIALACC_CLS,PROGINDEX,ARHIVEDOC,PAYSYMBOLCLS,PAYTYPECLS,NOTE,PERIOD,PAYPRIORITY,TYPEOPERATIONCLS,BUHPAYMENTCLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,RECORDINDEX,SENDERID,SENDERRECORDID,REESTR_REF,REJECT_CLS,REJECTCAUSE,CLIENTBANKNUMBER,CRYPTOSTATUS,TRUSTNUMBER,LINKEDDOCUMENT,BNKRECORDID,SUBPROGINDEX,DOCUMENTSTATE,USERSVISA,TREASUARYDOCSTATECLS,DEPARTMENTCLS,NDS,TAXNOTE,MANAGERBID,BIDNUMBER,GROUPID,GROUPSUMMA,DOCSTATEREF,LASTEXTRCHANGE,FAXDOCCOUNT,STIMATEID,INTEGRATEDDOCREF,REQUESTNUMBER,REQUESTDATE,RVERSION,FEDERALFUNDSREF,ELDOCREF,BUHOPERATIONCLS,CLSTYPE,OPERATIONDIRECTION,SOURCETYPE,DESTTYPE,CARDNUMBER,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,CASHIERPERSONALINFO,BIDDATE,CARDREF,SOURCESTOREDPAYMENTPROPS,DESTSTOREDPAYMENTPROPS,STOREDPAYMENTNOTE,DOCCHANGEDATE,UINCODE,DOCOSN,SIGNERS,DESTCLSTYPE,SENDERIDKEY,SENDERRECORDIDKEY,AUTOSANCTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_FACIALFINCAPTION
where (ID) in
    (select ID from TB_FACIALFINCAPTION
     MINUS
     select ID from A_TB_FACIALFINCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_FACIALFINDETAIL

update A_TB_FACIALFINDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_FACIALFINDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_FACIALFINDETAIL)
/

update A_TB_FACIALFINDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY
   from TB_FACIALFINDETAIL
   where (ID) in (select ID from A_TB_FACIALFINDETAIL))
  MINUS
  (select ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TB_FACIALFINDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_FACIALFINDETAIL (ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_FACIALFINDETAIL
   where (ID) in (select ID from A_TB_FACIALFINDETAIL))
  MINUS
  (select ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_FACIALFINDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_FACIALFINDETAIL (ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SOURCEFACIALACC_CLS,SOURCEKVR,SOURCEKESR,DESTFACIALACC_CLS,DESTKVR,DESTKESR,BUDGETREF,CREDIT,PAYSYMBOLCLS,MEMORDERNUM,NOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SOURCEKVSR,SOURCEKCSR,SOURCEKFSR,SOURCESUBKESR,SOURCEFACT,SOURCEMEANSTYPE,SOURCEFINSOURCE,SOURCEFINTYPE,DESTKVSR,DESTKCSR,DESTKFSR,DESTSUBKESR,DESTFACT,DESTMEANSTYPE,DESTFINSOURCE,DESTFINTYPE,REQUESTSINDEX,SENDERID,SENDERRECORDID,PROMISE,SOURCEDOCTYPE,DESTDOCTYPE,SOURCEPROMISE,DESTPROMISE,RECORDINDEX2,SOURCEBUDGETPROMISE,DESTBUDGETPROMISE,SUBPROGINDEX,STIMATEID,RVERSION,SOURCEDIRECTIONCLS,DESTDIRECTIONCLS,SOURCEDOCBASE,DESTDOCBASE,SOURCEEXECDOC,DESTEXECDOC,BUHOPERATIONCLS,SOURCEIFS,DESTIFS,CLSTYPE,UNIONNOTIFYREF,ACCEPTDATE,SOURCEKD,DESTKD,SOURCEREGIONCLS,DESTREGIONCLS,DESTFUNDSSOURCE,SOURCEFUNDSSOURCE,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,SOURCETRANSFERTCLS,DESTTRANSFERTCLS,DESTCLSTYPE,SOURCEASSIGNMENTKIND,DESTASSIGNMENTKIND,SOURCEEXECINNERNUMBER,DESTEXECINNERNUMBER,SOURCESUBSIDYCLS,DESTSUBSIDYCLS,SOURCEFAORG_TYPE,DESTFAORG_TYPE,SOURCEBUDALLOCATIONCLS,SOURCEPAYPROMISECLS,DESTBUDALLOCATIONCLS,DESTPAYPROMISECLS,SOURCEINVESTOBJECT,DESTINVESTOBJECT,TRANSFERTORG_REF,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_FACIALFINDETAIL
where (ID) in
    (select ID from TB_FACIALFINDETAIL
     MINUS
     select ID from A_TB_FACIALFINDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_FACIALFINREESTR

update A_TB_FACIALFINREESTR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_FACIALFINREESTR
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_FACIALFINREESTR)
/

update A_TB_FACIALFINREESTR set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS
   from TB_FACIALFINREESTR
   where (ID) in (select ID from A_TB_FACIALFINREESTR))
  MINUS
  (select ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS
   from A_TB_FACIALFINREESTR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_FACIALFINREESTR (ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_FACIALFINREESTR
   where (ID) in (select ID from A_TB_FACIALFINREESTR))
  MINUS
  (select ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_FACIALFINREESTR
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_FACIALFINREESTR (ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REESTRNUMBER,REESTRDATE,REESTRTYPE,ACCEPTED,SESSIONNUMBER,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,PACKETNUMBER,FICTIVEDOC,FACIALACC_CLS,SUMMA,NOTE,REESTRTYPEEX,RECORDINDEX,DOCSTATEREF,RVERSION,CRYPTOSTATUS,DEPARTMENTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_FACIALFINREESTR
where (ID) in
    (select ID from TB_FACIALFINREESTR
     MINUS
     select ID from A_TB_FACIALFINREESTR
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_FINDOCDETAIL

update A_TB_FINDOCDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_FINDOCDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_FINDOCDETAIL)
/

update A_TB_FINDOCDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS
   from TB_FINDOCDETAIL
   where (ID) in (select ID from A_TB_FINDOCDETAIL))
  MINUS
  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS
   from A_TB_FINDOCDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_FINDOCDETAIL (ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_FINDOCDETAIL
   where (ID) in (select ID from A_TB_FINDOCDETAIL))
  MINUS
  (select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_FINDOCDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_FINDOCDETAIL (ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,KFSR,KCSR,KVSR,KVR,KESR,SUBKESR,FACT,FINSOURCE,REGIONCLS,DOCTYPE,FINTYPE,CURRENCYCLS,MEANSTYPE,DFACCOUNT,ACCOUNTREF,ACCEPTDATE,BUDGETREF,SUMMA,CREDIT,DEBIT,NOTE,USERFLAG,SOURCEDOCNUM,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ACCEPTORACCREF,FACIALACC_CLS,RECORDINDEX2,BUHPAYMENTCLS,REQUESTSINDEX,PLANDATE,PROMISE,RECORDINDEX3,RECORDDATE,TOTALREF,DOCUMENTBASETYPE,TAXNOTE,CURRENCYSUMMA,RVERSION,FEDERALFUNDSREF,DIRECTIONCLS,ELDOCREF,REQUESTSINDEX2,DOCNUMBER,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,UNIONNOTIFYREF,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_FINDOCDETAIL
where (ID) in
    (select ID from TB_FINDOCDETAIL
     MINUS
     select ID from A_TB_FINDOCDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_INCOMES32

update A_TB_INCOMES32 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_INCOMES32
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_INCOMES32)
/

update A_TB_INCOMES32 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT
   from TB_INCOMES32
   where (ID) in (select ID from A_TB_INCOMES32))
  MINUS
  (select ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT
   from A_TB_INCOMES32
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_INCOMES32 (ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_INCOMES32
   where (ID) in (select ID from A_TB_INCOMES32))
  MINUS
  (select ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_INCOMES32
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_INCOMES32 (ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DOCNUMBER,DOCCOUNT,IDATE,DEBIT,CREDIT,DOCTYPE,INN,ORG_REF,ACCOUNTINDEX,KD,SUBKD,REGIONCLS,GOSNI,INCACCOUNT,PROGINDEX,RECORDINDEX,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,NOTE,RECORDINDEX2,ELNUM,NOTEEX,BUHPAYMENTCLS,ACCOUNTREF,ELPACKETNUM,FACIALACC_CLS,NDS,MEANSTYPE,RECORDDATE,TOTALREF,REQUESTSINDEX,KVSR,TAXNOTE,DOCNUM,REALPAYERORG_REF,DOCDATE,DOCBASE,FACT,RVERSION,KFSR,KESR,KVR,KCSR,SUMCOMPLETE,ELDOCREF,REQUESTSINDEX2,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS,IFS_CORR,CLSTYPE,NDSNOTE,DOGNUM,SENDERID,SENDERRECORDID,OKATO,ADDOKATO,REJECTCLS,REJECTCAUSE,FUNDSSOURCE,DIRECTIONCLS,ISBLOCKED,BLOCKEDCAUSE,UNBLOCKEDDATE,UNBLOCKEDCAUSE,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,FAORGTYPE,OKTMO,UINCODE,FINTYPE,INVESTOBJECT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_INCOMES32
where (ID) in
    (select ID from TB_INCOMES32
     MINUS
     select ID from A_TB_INCOMES32
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_INNERFINSOURCE

update A_TB_INNERFINSOURCE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_INNERFINSOURCE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_INNERFINSOURCE)
/

update A_TB_INNERFINSOURCE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS
   from TB_INNERFINSOURCE
   where (ID) in (select ID from A_TB_INNERFINSOURCE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS
   from A_TB_INNERFINSOURCE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_INNERFINSOURCE (ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_INNERFINSOURCE
   where (ID) in (select ID from A_TB_INNERFINSOURCE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_INNERFINSOURCE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_INNERFINSOURCE (ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,DIRECTION,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,FINSOURCEVALUE,UNIONFLAG,REMOTEFLAG,BUDGETREF,DELETEDATE,NAME,STARTDATE,SHORTNAME,CLSASPECT,CREATERUSER,UPDATERUSER,IFS_LEVEL,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPIFS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_INNERFINSOURCE
where (ID) in
    (select ID from TB_INNERFINSOURCE
     MINUS
     select ID from A_TB_INNERFINSOURCE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_INTERFACES

update A_TB_INTERFACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_INTERFACES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_INTERFACES)
/

update A_TB_INTERFACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from TB_INTERFACES
   where (ID) in (select ID from A_TB_INTERFACES))
  MINUS
  (select ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_TB_INTERFACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_INTERFACES (ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_INTERFACES
   where (ID) in (select ID from A_TB_INTERFACES))
  MINUS
  (select ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_INTERFACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_INTERFACES (ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GUID,NOTE,PARAM,CLS,INTERFACETYPE,PARAMCOLLECTION,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_INTERFACES
where (ID) in
    (select ID from TB_INTERFACES
     MINUS
     select ID from A_TB_INTERFACES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_KD

update A_TB_KD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_KD
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_KD)
/

update A_TB_KD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD
   from TB_KD
   where (ID) in (select ID from A_TB_KD))
  MINUS
  (select ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD
   from A_TB_KD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_KD (ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_KD
   where (ID) in (select ID from A_TB_KD))
  MINUS
  (select ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_KD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_KD (ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REPCODE,CREATEDATE,UPDATEDATE,KVSR,DESCRIPTIONCODE,MAINDESCRIPTIONCODE,ITEMCODE,PROGRAMCODE,KESR,KDVALUE,REMOTEFLAG,UNIONFLAG,BUDGETREF,DELETEDATE,NAME,KD_LEVEL,STARTDATE,SHORTNAME,CREATERUSER,UPDATERUSER,EXTID,EXTOWNER,EXTSYNCDATE,EXTROOTID,EXTVERSION,EXTVERSIONDATE,ANALYTICALGROUPKD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_KD
where (ID) in
    (select ID from TB_KD
     MINUS
     select ID from A_TB_KD
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_LIMITNOTIFYCAPTION

update A_TB_LIMITNOTIFYCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_LIMITNOTIFYCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_LIMITNOTIFYCAPTION)
/

update A_TB_LIMITNOTIFYCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR
   from TB_LIMITNOTIFYCAPTION
   where (ID) in (select ID from A_TB_LIMITNOTIFYCAPTION))
  MINUS
  (select ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR
   from A_TB_LIMITNOTIFYCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_LIMITNOTIFYCAPTION (ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_LIMITNOTIFYCAPTION
   where (ID) in (select ID from A_TB_LIMITNOTIFYCAPTION))
  MINUS
  (select ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_LIMITNOTIFYCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_LIMITNOTIFYCAPTION (ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,INPUTDATE,ACCEPTDATE,FINSOURCE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,IMPORTID,SENDERINN,ANUMBER,DFACCOUNT,SOURCEFACIALACC,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,ACCEPTSUMMA,PLANDOCTYPE,DOCSTATEREF,RVERSION,STIMATEID,FACIALACCCLS,BIDNUMBER,FAXDOCCOUNT,LASTEXTRCHANGE,AMONTH,AYEAR,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_LIMITNOTIFYCAPTION
where (ID) in
    (select ID from TB_LIMITNOTIFYCAPTION
     MINUS
     select ID from A_TB_LIMITNOTIFYCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_LINKTYPE

update A_TB_LINKTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_LINKTYPE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_LINKTYPE)
/

update A_TB_LINKTYPE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT
   from TB_LINKTYPE
   where (ID) in (select ID from A_TB_LINKTYPE))
  MINUS
  (select ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT
   from A_TB_LINKTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_LINKTYPE (ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_LINKTYPE
   where (ID) in (select ID from A_TB_LINKTYPE))
  MINUS
  (select ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_LINKTYPE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_LINKTYPE (ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,LINKCOMMENT,TEMPLATECLS,PARENTDOCCLS,CHILDDOCCLS,BLOCKPARENT,BLOCKCHILD,CANDELBLOCKPARENT,CANDELBLOCKCHILD,DISABLEDELPARENT,DISABLEDELCHILD,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,PARENTPICTURETYPE,PARENTPICTURENAME,CHILDPICTURETYPE,CHILDPICTURENAME,PICTURECOLLECTIONNAME,URMUSE,DELMACROSNAME,NEEDDELCHILD,LINKKIND,SHOWEVENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_LINKTYPE
where (ID) in
    (select ID from TB_LINKTYPE
     MINUS
     select ID from A_TB_LINKTYPE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_ORG_ACCOUNTS

update A_TB_ORG_ACCOUNTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_ORG_ACCOUNTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_ORG_ACCOUNTS)
/

update A_TB_ORG_ACCOUNTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE
   from TB_ORG_ACCOUNTS
   where (ID) in (select ID from A_TB_ORG_ACCOUNTS))
  MINUS
  (select ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE
   from A_TB_ORG_ACCOUNTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_ORG_ACCOUNTS (ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_ORG_ACCOUNTS
   where (ID) in (select ID from A_TB_ORG_ACCOUNTS))
  MINUS
  (select ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_ORG_ACCOUNTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_ORG_ACCOUNTS (ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ORG_REF,BANK_REF,ACC,ACC_CLS,FINTYPE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,CLOSED,ACCDEFAULT,BANKDEPNUMBER,FACIALCODE,SERVICE_ORG_REF,ACOMMENT,ISDEFAULT,RVERSION,SERVICE_ACC_REF,CLOSECODE,SERVICEACC,FACIALACC_CLS,DATEOPEN,DATECLOSE,EXTID,EXTOWNER,EXTSYNCDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_ORG_ACCOUNTS
where (ID) in
    (select ID from TB_ORG_ACCOUNTS
     MINUS
     select ID from A_TB_ORG_ACCOUNTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_ORGANIZATIONS

update A_TB_ORGANIZATIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_ORGANIZATIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_ORGANIZATIONS)
/

update A_TB_ORGANIZATIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF
   from TB_ORGANIZATIONS
   where (ID) in (select ID from A_TB_ORGANIZATIONS))
  MINUS
  (select ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF
   from A_TB_ORGANIZATIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_ORGANIZATIONS (ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_ORGANIZATIONS
   where (ID) in (select ID from A_TB_ORGANIZATIONS))
  MINUS
  (select ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_ORGANIZATIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_ORGANIZATIONS (ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,GOSNI,CITY,COUNTRY,PHONE,ADDRESS,ORG_CLS,INN20,SUBINN,FACIALACC,REGIONCLS,DIRNAME,BUGNAME,DIRPHONE,BUGPHONE,RCORG,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,INN,OKATO,EMAIL,WEBSITE,UFKCODE,ADDOKATO,SHORTNAME,RVERSION,SENDERID,KVSR,OKFS,OKOPF,OPENDATE,CLOSEDATE,CHANGEDATE,GENERALORG_REF,FEDERALREGIONCODE,ORG_TYPE,BUDGETREF,SUPPLIERSTATUS,COUNTRYCODE,DATECLOSE,ORGCODE,COSTAUTHORITY,INCOMEAUTHORITY,DEBTAUTHORITY,SVRAUTHORITY,CLIENTID,DATEOPEN,FUID,OKPO,OKTMO,DOCSTATEREF,CRYPTOSTATUS,OGRN,REJECT_CLS,REJECTCAUSE,EXTID,EXTOWNER,EXTSYNCDATE,REMOTEPBSCODE,REMOTENOTPBSCODE,USECHECK_CARD,EXTROOTID,EXTVERSION,EXTVERSIONDATE,RECORDOWNERORGREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_ORGANIZATIONS
where (ID) in
    (select ID from TB_ORGANIZATIONS
     MINUS
     select ID from A_TB_ORGANIZATIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_PAYDOC32

update A_TB_PAYDOC32 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_PAYDOC32
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_PAYDOC32)
/

update A_TB_PAYDOC32 set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS
   from TB_PAYDOC32
   where (ID) in (select ID from A_TB_PAYDOC32))
  MINUS
  (select ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS
   from A_TB_PAYDOC32
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_PAYDOC32 (ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_PAYDOC32
   where (ID) in (select ID from A_TB_PAYDOC32))
  MINUS
  (select ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_PAYDOC32
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_PAYDOC32 (ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,INPUTDATE,PRINTDATE,ACCEPTDATE,PAYERATTRREF,ACCEPTORATTRREF,SENDBY,SUMMA,CURRENCY,PAYDATE,PAYQUEUE,TEXTNOTE,PROGINDEX,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SOURCEDOCNUMBER,CHILDCOUNT,FACIALACC_CLS,ACCOUNTREF,DOCTYPE,SOURCEFACIALACC_CLS,PARENTINDEX,ANUMBER,TAXNOTE,REJECT_CLS,REJECTCAUSE,REALPAYERORG_REF,ISDIVIDE,CURSUM,CREDIT,DEBIT,RVERSION,BUHOPERATIONCLS,MEANSTYPE,PAYMENTCONDITION,BUDGETREF,TRANSFERTCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_PAYDOC32
where (ID) in
    (select ID from TB_PAYDOC32
     MINUS
     select ID from A_TB_PAYDOC32
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_PAYMENTSCHEDULE

update A_TB_PAYMENTSCHEDULE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_PAYMENTSCHEDULE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_PAYMENTSCHEDULE)
/

update A_TB_PAYMENTSCHEDULE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA
   from TB_PAYMENTSCHEDULE
   where (ID) in (select ID from A_TB_PAYMENTSCHEDULE))
  MINUS
  (select ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA
   from A_TB_PAYMENTSCHEDULE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_PAYMENTSCHEDULE (ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_PAYMENTSCHEDULE
   where (ID) in (select ID from A_TB_PAYMENTSCHEDULE))
  MINUS
  (select ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_PAYMENTSCHEDULE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_PAYMENTSCHEDULE (ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ANUMBER,PARENTNUMBER,KFSR,KESR,KVSR,KCSR,KVR,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,SUMMA,REGION,SUBKESR,MEANSTYPE,FINSOURCE,FINTYPE,FACT,FACIALACC_CLS,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,BUDGETREF,ACCEPTDATE,LASTADJUSTMENT,ACCEPTED,LASTACCEPTED,PROMISETYPE,ADJUSTMENTREF,OLDNUMBER,SUMMAPREVIOUSYEAR,SUMMAFINPREVIOUSYEAR,QUARTER1,QUARTER2,QUARTER3,QUARTER4,RECORDINDEX,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DIRECTIONCLS,RVERSION,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,QUARTER1DELTA,QUARTER2DELTA,QUARTER3DELTA,QUARTER4DELTA,SUMMADELTA,NOTE,FINYEAR,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SENDERIDKEY,SENDERRECORDIDKEY,EXECUTIONREF,INNERPROMISENUM,ADJUSTMENTNUMBER,PROMISENUMBER,SUBSIDYCLS,AGREEMENTREF,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,SUMMAYEAR4DELTA,SUMMAOTHERYEARSDELTA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_PAYMENTSCHEDULE
where (ID) in
    (select ID from TB_PAYMENTSCHEDULE
     MINUS
     select ID from A_TB_PAYMENTSCHEDULE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_PERCENTJOURNAL

update A_TB_PERCENTJOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_PERCENTJOURNAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_PERCENTJOURNAL)
/

update A_TB_PERCENTJOURNAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST
   from TB_PERCENTJOURNAL
   where (ID) in (select ID from A_TB_PERCENTJOURNAL))
  MINUS
  (select ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST
   from A_TB_PERCENTJOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_PERCENTJOURNAL (ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_PERCENTJOURNAL
   where (ID) in (select ID from A_TB_PERCENTJOURNAL))
  MINUS
  (select ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_PERCENTJOURNAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_PERCENTJOURNAL (ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCEPTDATE,PERCENT,PROGINDEX,RECORDINDEX,NOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CBREF,ISLAST,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_PERCENTJOURNAL
where (ID) in
    (select ID from TB_PERCENTJOURNAL
     MINUS
     select ID from A_TB_PERCENTJOURNAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_PROMISE_CAPTION

update A_TB_PROMISE_CAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_PROMISE_CAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_PROMISE_CAPTION)
/

update A_TB_PROMISE_CAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA
   from TB_PROMISE_CAPTION
   where (ID) in (select ID from A_TB_PROMISE_CAPTION))
  MINUS
  (select ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA
   from A_TB_PROMISE_CAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_PROMISE_CAPTION (ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_PROMISE_CAPTION
   where (ID) in (select ID from A_TB_PROMISE_CAPTION))
  MINUS
  (select ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_PROMISE_CAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_PROMISE_CAPTION (ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,ACCEPTDATE,ACCEPTED_REVERTED,AGREEMENT_DATE,AGREEMENT_END,AGREEMENT_NOTE,AGREEMENT_TYPE,AGREEMENT_SUMMA,SUPPLIER_REF,DELIVERY_RULES,TOTALSUMM,BUDGETORG_REF,FACIALACC_CLS,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,ANUMBER,REJECT_CLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCUMENTSTATE,USERSVISA,RVERSION,DOCSTATEREF,STIMATEID,BIDNUMBER,FAXDOCCOUNT,SUPPLIER_ACC_REF,AGREEMENT_NUM,INFONUMBER,ADVANCESUMMA,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_PROMISE_CAPTION
where (ID) in
    (select ID from TB_PROMISE_CAPTION
     MINUS
     select ID from A_TB_PROMISE_CAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_PROMISE_DETAIL

update A_TB_PROMISE_DETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_PROMISE_DETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_PROMISE_DETAIL)
/

update A_TB_PROMISE_DETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS
   from TB_PROMISE_DETAIL
   where (ID) in (select ID from A_TB_PROMISE_DETAIL))
  MINUS
  (select ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS
   from A_TB_PROMISE_DETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_PROMISE_DETAIL (ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_PROMISE_DETAIL
   where (ID) in (select ID from A_TB_PROMISE_DETAIL))
  MINUS
  (select ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_PROMISE_DETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_PROMISE_DETAIL (ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TITLE_REF,PARENT_PROMISE,KFSR,KVSR,KCSR,KVR,KESR,FACT,FACIALACC_CLS,DOCTYPE,FINTYPE,FINSOURCE,SUBKESR,REGIONCLS,SUMMA,REGISTRNUMBER,CLOSEDATE,CHILD_PROMISE,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEANSTYPE,SENDERID,SENDERRECORDID,RVERSION,DIRECTIONCLS,BUHOPERATIONCLS,MONTH01DELTA,MONTH02DELTA,MONTH03DELTA,MONTH04DELTA,MONTH05DELTA,MONTH06DELTA,MONTH07DELTA,MONTH08DELTA,MONTH09DELTA,MONTH10DELTA,MONTH11DELTA,MONTH12DELTA,STIMATEID,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,SUMMAYEAR1DELTA,SUMMAYEAR2DELTA,SUMMAYEAR3DELTA,ASSIGNMENTKIND,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_PROMISE_DETAIL
where (ID) in
    (select ID from TB_PROMISE_DETAIL
     MINUS
     select ID from A_TB_PROMISE_DETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_QUOTESTITLE

update A_TB_QUOTESTITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_QUOTESTITLE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_QUOTESTITLE)
/

update A_TB_QUOTESTITLE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE
   from TB_QUOTESTITLE
   where (ID) in (select ID from A_TB_QUOTESTITLE))
  MINUS
  (select ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE
   from A_TB_QUOTESTITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_QUOTESTITLE (ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_QUOTESTITLE
   where (ID) in (select ID from A_TB_QUOTESTITLE))
  MINUS
  (select ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_QUOTESTITLE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_QUOTESTITLE (ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUILDDATE,ACCEPTDATE,INCACCOUNT,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RECORDINDEX,PROGINDEX,DOCNUMBER,TYPEOPERATIONCLS,RVERSION,REESTRDATE,REESTRNUMBER,SENDERID,SENDERRECORDID,FACIALACCCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,STIMATEID,SUMMA,DOCSTATEREF,DEPARTMENTCLS,DOCCHANGEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_QUOTESTITLE
where (ID) in
    (select ID from TB_QUOTESTITLE
     MINUS
     select ID from A_TB_QUOTESTITLE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_REQUESTS

update A_TB_REQUESTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_REQUESTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_REQUESTS)
/

update A_TB_REQUESTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS
   from TB_REQUESTS
   where (ID) in (select ID from A_TB_REQUESTS))
  MINUS
  (select ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS
   from A_TB_REQUESTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_REQUESTS (ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_REQUESTS
   where (ID) in (select ID from A_TB_REQUESTS))
  MINUS
  (select ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_REQUESTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_REQUESTS (ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGET,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,USERNOTE,FACIALACC_CLS,SOURCEACCOUNT,DESTACCOUNT,FACT,FINSOURCE,FINTYPE,REGIONCLS,BUHPAYMENTCLS,DOCTYPE,PAYDATE,PAYPRIORITY,SUMMAREQUESTED,SUMMATOFINANCE,REQUESTTYPE,MEANSTYPE,PAYSYMBOLCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PROMISE,DOCUMENTBASETYPE,INPUTDATE,DFACCOUNT,PROGINDEX,PROGINDEX2,RECORDINDEX,INNERFINSOURCE,OUTERFINSOURCE,KD,SUBKD,PLANDATE,CURRENCYCLS,REQUESTSDOCSTATE,TAXNOTE,GOSNI,CURRENCYSUMMA,RVERSION,DIRECTIONCLS,DOCSTATEREF,CRYPTOSTATUS,FEDERALFUNDSREF,BUHOPERATIONCLS,IFS_CORR,CLSTYPE,REESTRDATE,AMONTH,AYEAR,EXECSUMMA,SUBSIDYCLS,TRANSFERTCLS,PAYPROMISECLS,BUDALLOCATIONCLS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_REQUESTS
where (ID) in
    (select ID from TB_REQUESTS
     MINUS
     select ID from A_TB_REQUESTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_REQUESTSPAYMENTS

update A_TB_REQUESTSPAYMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_REQUESTSPAYMENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_REQUESTSPAYMENTS)
/

update A_TB_REQUESTSPAYMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE
   from TB_REQUESTSPAYMENTS
   where (ID) in (select ID from A_TB_REQUESTSPAYMENTS))
  MINUS
  (select ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE
   from A_TB_REQUESTSPAYMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_REQUESTSPAYMENTS (ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_REQUESTSPAYMENTS
   where (ID) in (select ID from A_TB_REQUESTSPAYMENTS))
  MINUS
  (select ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_REQUESTSPAYMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_REQUESTSPAYMENTS (ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SUMMA,RECORDINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_REQUESTSPAYMENTS
where (ID) in
    (select ID from TB_REQUESTSPAYMENTS
     MINUS
     select ID from A_TB_REQUESTSPAYMENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_SIGNSCHEMEDETAIL

update A_TB_SIGNSCHEMEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_SIGNSCHEMEDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_SIGNSCHEMEDETAIL)
/

update A_TB_SIGNSCHEMEDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from TB_SIGNSCHEMEDETAIL
   where (ID) in (select ID from A_TB_SIGNSCHEMEDETAIL))
  MINUS
  (select ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_TB_SIGNSCHEMEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_SIGNSCHEMEDETAIL (ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_SIGNSCHEMEDETAIL
   where (ID) in (select ID from A_TB_SIGNSCHEMEDETAIL))
  MINUS
  (select ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_SIGNSCHEMEDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_SIGNSCHEMEDETAIL (ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,SIGNREF,SIGNORDER,SIGNMASK,FICTIVESIGN,ACTIONREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_SIGNSCHEMEDETAIL
where (ID) in
    (select ID from TB_SIGNSCHEMEDETAIL
     MINUS
     select ID from A_TB_SIGNSCHEMEDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_STATE_ACTIONS

update A_TB_STATE_ACTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_STATE_ACTIONS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_STATE_ACTIONS)
/

update A_TB_STATE_ACTIONS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM
   from TB_STATE_ACTIONS
   where (ID) in (select ID from A_TB_STATE_ACTIONS))
  MINUS
  (select ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM
   from A_TB_STATE_ACTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_STATE_ACTIONS (ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_STATE_ACTIONS
   where (ID) in (select ID from A_TB_STATE_ACTIONS))
  MINUS
  (select ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_STATE_ACTIONS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_STATE_ACTIONS (ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,INVISIBLE,HINT,ICONNAME,ACTIONNAME,ACTPOSITION,DOCTYPEREF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ACTEVENT,BACKACTION,ISBUDGET,OPTIONSPATH,EXCHACCEPT,EXCHREJECT,EXCHPACKETSEND,EXCHPACKETREM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_STATE_ACTIONS
where (ID) in
    (select ID from TB_STATE_ACTIONS
     MINUS
     select ID from A_TB_STATE_ACTIONS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_STATICLINKS

update A_TB_STATICLINKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_STATICLINKS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_STATICLINKS)
/

update A_TB_STATICLINKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION
   from TB_STATICLINKS
   where (ID) in (select ID from A_TB_STATICLINKS))
  MINUS
  (select ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION
   from A_TB_STATICLINKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_STATICLINKS (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_STATICLINKS
   where (ID) in (select ID from A_TB_STATICLINKS))
  MINUS
  (select ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_STATICLINKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_STATICLINKS (ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,PARENTFIELDREF,CHILDFIELDREF,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LINKKIND,PARENTDELACTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_STATICLINKS
where (ID) in
    (select ID from TB_STATICLINKS
     MINUS
     select ID from A_TB_STATICLINKS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_TENDERCAPTION

update A_TB_TENDERCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_TENDERCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_TENDERCAPTION)
/

update A_TB_TENDERCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF
   from TB_TENDERCAPTION
   where (ID) in (select ID from A_TB_TENDERCAPTION))
  MINUS
  (select ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF
   from A_TB_TENDERCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_TENDERCAPTION (ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_TENDERCAPTION
   where (ID) in (select ID from A_TB_TENDERCAPTION))
  MINUS
  (select ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_TENDERCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_TENDERCAPTION (ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,FACIALACCCLS,MULTIPURPOSE,DOCUMENTDATE,ACCEPTDATE,PERIOD,ACCEPTSUMMA,SALETYPE,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,LASTADJUSTMENT,LASTACCEPTED,ADJUSTMENTREF,ACCEPTED,EXPORTDATE,YEARACCEPTSUMMA,TENDEROPTION,TENDERTARGET,RVERSION,ALLOWANCE,REFINEMENTCAUSE,PREFERENCE,PREFERENCESIZE,SECURITY,UNKNOWNAMOUNT,PERIODYEAR,SUPPORTUNDERTAKER,AYEAR,REWORKCAUSE,NOTE,REALID,INNERNUMBER,ADJUSTMENTNUMBER,SENDERIDKEY,SENDERRECORDIDKEY,PROTOCOLREASON,PROGINDEX,DOCNUMBER,SECURITYTSIZE,SECURITYASIZE,AVANSSIZE,PREFERENCECRIPPLE,PREFERENCERUSPRODUCT,PREFERENCEPRISON,AGREEMENTEXECUTIONDATE,PURCHASECODE,PURCHASESOCIALNKO,AVERSION,PARENTREF,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_TENDERCAPTION
where (ID) in
    (select ID from TB_TENDERCAPTION
     MINUS
     select ID from A_TB_TENDERCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_TRANSFERTCLS

update A_TB_TRANSFERTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_TRANSFERTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_TRANSFERTCLS)
/

update A_TB_TRANSFERTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from TB_TRANSFERTCLS
   where (ID) in (select ID from A_TB_TRANSFERTCLS))
  MINUS
  (select ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE
   from A_TB_TRANSFERTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_TRANSFERTCLS (ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_TRANSFERTCLS
   where (ID) in (select ID from A_TB_TRANSFERTCLS))
  MINUS
  (select ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_TRANSFERTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_TRANSFERTCLS (ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REGIONCLS,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,CODE,RECEIVEKVSR,RECEIVEKFSR,RECEIVEKVR,RECEIVEKESR,RECEIVEKD,TRANSFERKVSR,TRANSFERKFSR,TRANSFERKCSR,TRANSFERKVR,TRANSFERKESR,TRANSFERKDVALUE,TARGETMEANSSIGN,TARGETCLS,STARTDATE,DELETEDATE,NOTE,NAME,BUDGETREF,RECEIVEKCSR,SOURCELEVEL,DESTLEVEL,TRANSFERTKIND,GRANTKIND,TRANSFERTYEAR,EXTID,EXTOWNER,EXTSYNCDATE,FACT,EXTROOTID,EXTVERSION,EXTVERSIONDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_TRANSFERTCLS
where (ID) in
    (select ID from TB_TRANSFERTCLS
     MINUS
     select ID from A_TB_TRANSFERTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_UNLOCKDATES

update A_TB_UNLOCKDATES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_UNLOCKDATES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_UNLOCKDATES)
/

update A_TB_UNLOCKDATES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND
   from TB_UNLOCKDATES
   where (ID) in (select ID from A_TB_UNLOCKDATES))
  MINUS
  (select ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND
   from A_TB_UNLOCKDATES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_UNLOCKDATES (ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_UNLOCKDATES
   where (ID) in (select ID from A_TB_UNLOCKDATES))
  MINUS
  (select ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_UNLOCKDATES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_UNLOCKDATES (ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,UNLOCKDATE,UNLOCK,NOTE,JNUMBER,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,JOURNALFLAG,DOCSTATEREF,CRYPTOSTATUS,DAYKIND,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_UNLOCKDATES
where (ID) in
    (select ID from TB_UNLOCKDATES
     MINUS
     select ID from A_TB_UNLOCKDATES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_USER_WORKPLACES

update A_TB_USER_WORKPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_USER_WORKPLACES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_USER_WORKPLACES)
/

update A_TB_USER_WORKPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from TB_USER_WORKPLACES
   where (ID) in (select ID from A_TB_USER_WORKPLACES))
  MINUS
  (select ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_TB_USER_WORKPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_USER_WORKPLACES (ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_USER_WORKPLACES
   where (ID) in (select ID from A_TB_USER_WORKPLACES))
  MINUS
  (select ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_USER_WORKPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_USER_WORKPLACES (ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,USERS_REF,WORKPLACES_REF,DEFAULTWORKPLACE,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_USER_WORKPLACES
where (ID) in
    (select ID from TB_USER_WORKPLACES
     MINUS
     select ID from A_TB_USER_WORKPLACES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_UTYPEDFORMS

update A_TB_UTYPEDFORMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_UTYPEDFORMS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_UTYPEDFORMS)
/

update A_TB_UTYPEDFORMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD
   from TB_UTYPEDFORMS
   where (ID) in (select ID from A_TB_UTYPEDFORMS))
  MINUS
  (select ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD
   from A_TB_UTYPEDFORMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_UTYPEDFORMS (ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_UTYPEDFORMS
   where (ID) in (select ID from A_TB_UTYPEDFORMS))
  MINUS
  (select ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_UTYPEDFORMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_UTYPEDFORMS (ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TYPEDFORMTMPLT,REPORTTMPLT,NOTE,ONOPENDETAIL,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DOCTMPLT,LOCKED,PARAMS,IMPORTLIST,EXPORTLIST,GROUPINDEX,NAME,REPORTKIND,NEEDVERSION,SHORTNAME,MINFINCODE,PARAMLIST,TEXTID,VERSIONNUMBER,BEGINDATE,ENDDATE,ISCLIENT,FORURM,PRINTDOCLIST,CONTROLLIST,CONSTMPLT,PERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_UTYPEDFORMS
where (ID) in
    (select ID from TB_UTYPEDFORMS
     MINUS
     select ID from A_TB_UTYPEDFORMS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_UTYPEDFORMSCAPTION

update A_TB_UTYPEDFORMSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_UTYPEDFORMSCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_UTYPEDFORMSCAPTION)
/

update A_TB_UTYPEDFORMSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD
   from TB_UTYPEDFORMSCAPTION
   where (ID) in (select ID from A_TB_UTYPEDFORMSCAPTION))
  MINUS
  (select ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD
   from A_TB_UTYPEDFORMSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_UTYPEDFORMSCAPTION (ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_UTYPEDFORMSCAPTION
   where (ID) in (select ID from A_TB_UTYPEDFORMSCAPTION))
  MINUS
  (select ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_UTYPEDFORMSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_UTYPEDFORMSCAPTION (ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REGIONCLS,ACCEPTDATE,DOCNUMBER,NOTE,TYPEDFORM,PROGINDEX,FACIALACC_CLS,ORG_REF,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,EMAIL,STATE,ERROR,SOURCEID,SOURCEMAILID,AUTOTASKSSERVER,DEPARTMENTCLS,SENDERID,SENDERRECORDID,CRYPTOSTATUS,UTFRINDEX,REPORTDATE,ESTIMDATE,SELF,CLIENTSTYPE,SENDKIT,SENDSTS,SENDDOC,MANUALEXEC,DATAMODE,BUDGETREF,REPORTYEAR,REJECTCLS,REJECTCAUSE,DOCSTATEREF,RVERSION,LASTEXTRCHANGE,VERSIONID,CONSCLIENT,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,PARAMS,FORMTEXTID,REGTEXTID,PERIODTEXTID,REPORTMONTH,ACTIVITYKIND,PERIOD,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_UTYPEDFORMSCAPTION
where (ID) in
    (select ID from TB_UTYPEDFORMSCAPTION
     MINUS
     select ID from A_TB_UTYPEDFORMSCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TB_UTYPEDFORMSVERSION

update A_TB_UTYPEDFORMSVERSION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TB_UTYPEDFORMSVERSION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TB_UTYPEDFORMSVERSION)
/

update A_TB_UTYPEDFORMSVERSION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM
   from TB_UTYPEDFORMSVERSION
   where (ID) in (select ID from A_TB_UTYPEDFORMSVERSION))
  MINUS
  (select ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM
   from A_TB_UTYPEDFORMSVERSION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TB_UTYPEDFORMSVERSION (ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TB_UTYPEDFORMSVERSION
   where (ID) in (select ID from A_TB_UTYPEDFORMSVERSION))
  MINUS
  (select ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TB_UTYPEDFORMSVERSION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TB_UTYPEDFORMSVERSION (ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TYPEDFORM,VERSIONNUMBER,REPORTNUMBER,FORMCRC32,ISCURRENT,VERSIONINFO,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,USEFORURM,ISCURRENTFORURM,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TB_UTYPEDFORMSVERSION
where (ID) in
    (select ID from TB_UTYPEDFORMSVERSION
     MINUS
     select ID from A_TB_UTYPEDFORMSVERSION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERCONTACTS

update A_TENDERCONTACTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERCONTACTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERCONTACTS)
/

update A_TENDERCONTACTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERCONTACTS
   where (ID) in (select ID from A_TENDERCONTACTS))
  MINUS
  (select ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERCONTACTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERCONTACTS (ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERCONTACTS
   where (ID) in (select ID from A_TENDERCONTACTS))
  MINUS
  (select ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERCONTACTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERCONTACTS (ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,BUDGETREF,CONTACTREF,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERCONTACTS
where (ID) in
    (select ID from TENDERCONTACTS
     MINUS
     select ID from A_TENDERCONTACTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERLOT

update A_TENDERLOT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERLOT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERLOT)
/

update A_TENDERLOT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERLOT
   where (ID) in (select ID from A_TENDERLOT))
  MINUS
  (select ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERLOT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERLOT (ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERLOT
   where (ID) in (select ID from A_TENDERLOT))
  MINUS
  (select ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERLOT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERLOT (ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,LOTNUMBER,LOTNOTE,DELIVERYDATE,DELIVERYENDDATE,DELIVERYNOTE,TERMSOFDELIVERY,TERMSOFDELIVERYNOTE,OKATO,OKATONOTE,DELIVERYFORMNOTE,SECURITYTNOTE,SECURITYANOTE,PREFERENCENOTE,GUARANTY,FINNOTE,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,PREFERENCEPRISON,PREFERENCECRIPPLE,STRETCHCONTRACT,GUARANTYSIZE,REALID,SECURITYTSIZE,SECURITYASIZE,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERLOT
where (ID) in
    (select ID from TENDERLOT
     MINUS
     select ID from A_TENDERLOT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDEROBJECTS

update A_TENDEROBJECTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDEROBJECTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDEROBJECTS)
/

update A_TENDEROBJECTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2
   from TENDEROBJECTS
   where (ID) in (select ID from A_TENDEROBJECTS))
  MINUS
  (select ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2
   from A_TENDEROBJECTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDEROBJECTS (ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDEROBJECTS
   where (ID) in (select ID from A_TENDEROBJECTS))
  MINUS
  (select ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDEROBJECTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDEROBJECTS (ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,OKDP,SHORTNAME,CODE,OBJECTSPEC,BRAND,KESR,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,MEASUREMENTCLS,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,DOCSTATEREF,FACIALACCCLS,NOTE,UPDATECAUSE,ACCEPTDATE,DOCUMENTDATE,TENDEROBJREPLACE,RVERSION,WEBID,OKPCLS,ATTRIBUTE,NAME,REALID,SENDERIDKEY,SENDERRECORDIDKEY,OKPD,OKVED,OKPD2,OKVED2,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDEROBJECTS
where (ID) in
    (select ID from TENDEROBJECTS
     MINUS
     select ID from A_TENDEROBJECTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERPRODUCT

update A_TENDERPRODUCT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERPRODUCT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERPRODUCT)
/

update A_TENDERPRODUCT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS
   from TENDERPRODUCT
   where (ID) in (select ID from A_TENDERPRODUCT))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS
   from A_TENDERPRODUCT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERPRODUCT (ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERPRODUCT
   where (ID) in (select ID from A_TENDERPRODUCT))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERPRODUCT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERPRODUCT (ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,RECORDINDEX,FACIALACCCLS,KFSR,KVSR,KCSR,KVR,KESR,SUBKESR,FACTCLS,FINSOURCECLS,MEANSTYPECLS,TENDEROBJECTCLS,ACCEPTAMOUNT,ACCEPTPRICE,OKATO,DELIVERYDATE,DELIVERYENDDATE,DELIVERYPERIOD,DELIVERYAMOUNT,NOTE,FINSPEC,RECIPIENTLIST,ACCEPTMONTH01,ACCEPTMONTH02,ACCEPTMONTH03,ACCEPTMONTH04,ACCEPTMONTH05,ACCEPTMONTH06,ACCEPTMONTH07,ACCEPTMONTH08,ACCEPTMONTH09,ACCEPTMONTH10,ACCEPTMONTH11,ACCEPTMONTH12,ACCEPTQUARTER1,ACCEPTQUARTER2,ACCEPTQUARTER3,ACCEPTQUARTER4,ACCEPTSUMMA,REVIEWNOTE,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,SENDERID,SENDERRECORDID,TENDEROPENDATE,TENDERCLOSEDATE,POSITIONNUMBER,DIRECTIONCLS,RVERSION,TRANSPORTTERMS,VATPERCENT,ACCEPTVATSUMMA,ACCEPTCOST,ACCEPTTOTALSUMMA,FINTYPE,LOTREF,EQUIVALENT,OKATONOTE,DELIVERYNOTE,DELIVERYSPECNOTE,GUARANTY,DELIVERYFORMNOTE,FINNOTE,PRICEVAT,GUARANTYSIZE,DELIVERYSPEC,TENDEROBJECTATTR,REALID,SUMMAYEAR2,SUMMAYEAR3,SUBSIDYCLS,SENDERIDKEY,SENDERRECORDIDKEY,TRANSFERTCLS,BUDALLOCATIONCLS,PAYPROMISECLS,PROGINDEX,INVESTOBJECT,SUMMAOTHERYEARS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERPRODUCT
where (ID) in
    (select ID from TENDERPRODUCT
     MINUS
     select ID from A_TENDERPRODUCT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERPROPOSAL

update A_TENDERPROPOSAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERPROPOSAL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERPROPOSAL)
/

update A_TENDERPROPOSAL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERPROPOSAL
   where (ID) in (select ID from A_TENDERPROPOSAL))
  MINUS
  (select ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERPROPOSAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERPROPOSAL (ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERPROPOSAL
   where (ID) in (select ID from A_TENDERPROPOSAL))
  MINUS
  (select ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERPROPOSAL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERPROPOSAL (ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SUPPLIERREF,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERPROPOSAL
where (ID) in
    (select ID from TENDERPROPOSAL
     MINUS
     select ID from A_TENDERPROPOSAL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERPROPOSALDETAIL

update A_TENDERPROPOSALDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERPROPOSALDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERPROPOSALDETAIL)
/

update A_TENDERPROPOSALDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERPROPOSALDETAIL
   where (ID) in (select ID from A_TENDERPROPOSALDETAIL))
  MINUS
  (select ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERPROPOSALDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERPROPOSALDETAIL (ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERPROPOSALDETAIL
   where (ID) in (select ID from A_TENDERPROPOSALDETAIL))
  MINUS
  (select ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERPROPOSALDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERPROPOSALDETAIL (ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,PRODUCTCLS,AMOUNT,PRICE,PRICEVAT,COST,VATPERCENT,VATSUMMA,SUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERPROPOSALDETAIL
where (ID) in
    (select ID from TENDERPROPOSALDETAIL
     MINUS
     select ID from A_TENDERPROPOSALDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERPURCHASE

update A_TENDERPURCHASE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERPURCHASE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERPURCHASE)
/

update A_TENDERPURCHASE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERPURCHASE
   where (ID) in (select ID from A_TENDERPURCHASE))
  MINUS
  (select ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERPURCHASE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERPURCHASE (ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERPURCHASE
   where (ID) in (select ID from A_TENDERPURCHASE))
  MINUS
  (select ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERPURCHASE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERPURCHASE (ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PURCHASENUMBER,AGREEMENTOBJECT,SALETYPE,PURCHASESTATE,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERPURCHASE
where (ID) in
    (select ID from TENDERPURCHASE
     MINUS
     select ID from A_TENDERPURCHASE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERPURCHASELOT

update A_TENDERPURCHASELOT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERPURCHASELOT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERPURCHASELOT)
/

update A_TENDERPURCHASELOT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERPURCHASELOT
   where (ID) in (select ID from A_TENDERPURCHASELOT))
  MINUS
  (select ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERPURCHASELOT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERPURCHASELOT (ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERPURCHASELOT
   where (ID) in (select ID from A_TENDERPURCHASELOT))
  MINUS
  (select ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERPURCHASELOT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERPURCHASELOT (ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,LOTNUMBER,LOTNAME,LOTSUMMA,WEBID,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,RVERSION,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERPURCHASELOT
where (ID) in
    (select ID from TENDERPURCHASELOT
     MINUS
     select ID from A_TENDERPURCHASELOT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERRESULTCAPTION

update A_TENDERRESULTCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERRESULTCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERRESULTCAPTION)
/

update A_TENDERRESULTCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERRESULTCAPTION
   where (ID) in (select ID from A_TENDERRESULTCAPTION))
  MINUS
  (select ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERRESULTCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERRESULTCAPTION (ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERRESULTCAPTION
   where (ID) in (select ID from A_TENDERRESULTCAPTION))
  MINUS
  (select ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERRESULTCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERRESULTCAPTION (ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,INNERDOCNUMBER,FACIALACCCLS,ACCEPTDATE,PROTOCOLNUMBER,PROTOCOLDATE,STATEORDERREF,REJECTCLS,REJECTCAUSE,CRYPTOSTATUS,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,POSITIONNUMBERREF,ACCEPTDATEFO,RVERSION,AGREEMENTREF,DOCSTATEREF,WEBID,NOTE,PRIORITY,ALLOWANCE,RESULTDOCSTATE,PURCHASEREF,PURCHASELOTREF,RESULTORDER,RESULTSALETYPE,PROTOCOLREASON,PROTOCOLDOCTYPE,PROTOCOLDECISION,PROPOSALID,PROPOSALDETID,TENDERPRODUCTREF,AGREEMENT,STATEORDER,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERRESULTCAPTION
where (ID) in
    (select ID from TENDERRESULTCAPTION
     MINUS
     select ID from A_TENDERRESULTCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERSOURCEORG

update A_TENDERSOURCEORG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERSOURCEORG
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERSOURCEORG)
/

update A_TENDERSOURCEORG set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERSOURCEORG
   where (ID) in (select ID from A_TENDERSOURCEORG))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERSOURCEORG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERSOURCEORG (ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERSOURCEORG
   where (ID) in (select ID from A_TENDERSOURCEORG))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERSOURCEORG
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERSOURCEORG (ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,RECORDINDEX,ORGID,NOTE,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERSOURCEORG
where (ID) in
    (select ID from TENDERSOURCEORG
     MINUS
     select ID from A_TENDERSOURCEORG
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERSUPDOCUMENT

update A_TENDERSUPDOCUMENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERSUPDOCUMENT
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERSUPDOCUMENT)
/

update A_TENDERSUPDOCUMENT set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX
   from TENDERSUPDOCUMENT
   where (ID) in (select ID from A_TENDERSUPDOCUMENT))
  MINUS
  (select ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX
   from A_TENDERSUPDOCUMENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERSUPDOCUMENT (ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERSUPDOCUMENT
   where (ID) in (select ID from A_TENDERSUPDOCUMENT))
  MINUS
  (select ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERSUPDOCUMENT
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERSUPDOCUMENT (ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,YARDSTICKREF,DOCTYPECLS,NOTE,NAME,BUDGETREF,SENDERID,SENDERRECORDID,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,RVERSION,SENDERIDKEY,SENDERRECORDIDKEY,RECORDINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERSUPDOCUMENT
where (ID) in
    (select ID from TENDERSUPDOCUMENT
     MINUS
     select ID from A_TENDERSUPDOCUMENT
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERSUPPLEMENTS

update A_TENDERSUPPLEMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERSUPPLEMENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERSUPPLEMENTS)
/

update A_TENDERSUPPLEMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERSUPPLEMENTS
   where (ID) in (select ID from A_TENDERSUPPLEMENTS))
  MINUS
  (select ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERSUPPLEMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERSUPPLEMENTS (ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERSUPPLEMENTS
   where (ID) in (select ID from A_TENDERSUPPLEMENTS))
  MINUS
  (select ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERSUPPLEMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERSUPPLEMENTS (ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,BUDGETREF,DOCTYPECLS,NOTE,SENDERID,SENDERRECORDID,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERSUPPLEMENTS
where (ID) in
    (select ID from TENDERSUPPLEMENTS
     MINUS
     select ID from A_TENDERSUPPLEMENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TENDERYARDSTICKS

update A_TENDERYARDSTICKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TENDERYARDSTICKS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TENDERYARDSTICKS)
/

update A_TENDERYARDSTICKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY
   from TENDERYARDSTICKS
   where (ID) in (select ID from A_TENDERYARDSTICKS))
  MINUS
  (select ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY
   from A_TENDERYARDSTICKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TENDERYARDSTICKS (ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TENDERYARDSTICKS
   where (ID) in (select ID from A_TENDERYARDSTICKS))
  MINUS
  (select ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TENDERYARDSTICKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TENDERYARDSTICKS (ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,BUDGETREF,STARTVALUE,YARDSTICKTYPE,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,LOTREF,UYARDSTICK,YARDSTICKNOTE,PONDERABILITY,YSTERMSLIMIT,PRODUCTREF,YARDSTICKREF,SENDERID,SENDERRECORDID,SENDERIDKEY,SENDERRECORDIDKEY,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TENDERYARDSTICKS
where (ID) in
    (select ID from TENDERYARDSTICKS
     MINUS
     select ID from A_TENDERYARDSTICKS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TRANSFER15NTO70N

update A_TRANSFER15NTO70N set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TRANSFER15NTO70N
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TRANSFER15NTO70N)
/

update A_TRANSFER15NTO70N set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX
   from TRANSFER15NTO70N
   where (ID) in (select ID from A_TRANSFER15NTO70N))
  MINUS
  (select ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX
   from A_TRANSFER15NTO70N
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TRANSFER15NTO70N (ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TRANSFER15NTO70N
   where (ID) in (select ID from A_TRANSFER15NTO70N))
  MINUS
  (select ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TRANSFER15NTO70N
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TRANSFER15NTO70N (ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DEBIT,CREDIT,DEBITECCLS,CREDITECCLS,BUHOPERATIONCLS,DIRECTION,PROGINDEX,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TRANSFER15NTO70N
where (ID) in
    (select ID from TRANSFER15NTO70N
     MINUS
     select ID from A_TRANSFER15NTO70N
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TREASUARYDOCSTATE

update A_TREASUARYDOCSTATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TREASUARYDOCSTATE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TREASUARYDOCSTATE)
/

update A_TREASUARYDOCSTATE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from TREASUARYDOCSTATE
   where (ID) in (select ID from A_TREASUARYDOCSTATE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_TREASUARYDOCSTATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TREASUARYDOCSTATE (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TREASUARYDOCSTATE
   where (ID) in (select ID from A_TREASUARYDOCSTATE))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TREASUARYDOCSTATE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TREASUARYDOCSTATE (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TREASUARYDOCSTATE
where (ID) in
    (select ID from TREASUARYDOCSTATE
     MINUS
     select ID from A_TREASUARYDOCSTATE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_TYPEOPERATIONCLS

update A_TYPEOPERATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_TYPEOPERATIONCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from TYPEOPERATIONCLS)
/

update A_TYPEOPERATIONCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from TYPEOPERATIONCLS
   where (ID) in (select ID from A_TYPEOPERATIONCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME
   from A_TYPEOPERATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_TYPEOPERATIONCLS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from TYPEOPERATIONCLS
   where (ID) in (select ID from A_TYPEOPERATIONCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_TYPEOPERATIONCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_TYPEOPERATIONCLS (ID,CREATEDATE,UPDATEDATE,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from TYPEOPERATIONCLS
where (ID) in
    (select ID from TYPEOPERATIONCLS
     MINUS
     select ID from A_TYPEOPERATIONCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSCHAINSCAPTION

update A_UCONSCHAINSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSCHAINSCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSCHAINSCAPTION)
/

update A_UCONSCHAINSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UCONSCHAINSCAPTION
   where (ID) in (select ID from A_UCONSCHAINSCAPTION))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UCONSCHAINSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSCHAINSCAPTION (ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSCHAINSCAPTION
   where (ID) in (select ID from A_UCONSCHAINSCAPTION))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSCHAINSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSCHAINSCAPTION (ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TEXTID,NAME,ISCLIENT,NOTE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSCHAINSCAPTION
where (ID) in
    (select ID from UCONSCHAINSCAPTION
     MINUS
     select ID from A_UCONSCHAINSCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSCHAINSDETAIL

update A_UCONSCHAINSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSCHAINSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSCHAINSDETAIL)
/

update A_UCONSCHAINSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UCONSCHAINSDETAIL
   where (ID) in (select ID from A_UCONSCHAINSDETAIL))
  MINUS
  (select ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UCONSCHAINSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSCHAINSDETAIL (ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSCHAINSDETAIL
   where (ID) in (select ID from A_UCONSCHAINSDETAIL))
  MINUS
  (select ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSCHAINSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSCHAINSDETAIL (ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,PARENTREF,CHILDREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSCHAINSDETAIL
where (ID) in
    (select ID from UCONSCHAINSDETAIL
     MINUS
     select ID from A_UCONSCHAINSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSCLIENTS

update A_UCONSCLIENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSCLIENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSCLIENTS)
/

update A_UCONSCLIENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS
   from UCONSCLIENTS
   where (ID) in (select ID from A_UCONSCLIENTS))
  MINUS
  (select ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS
   from A_UCONSCLIENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSCLIENTS (ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSCLIENTS
   where (ID) in (select ID from A_UCONSCLIENTS))
  MINUS
  (select ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSCLIENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSCLIENTS (ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,ORG_REF,REGIONCLS,FACIALACC_CLS,EMAIL,LOGIN,PASWORD,ROLES,IP,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,CODE,BEGINDATE,ENDDATE,OKATO,KVB,ORG,KVB_SKIF,ORG_SKIF,SUBJECTTEXTID,ROWORDER,INCOMESADMCODES,GRBSCODES,IFSADMCODES,BUDGETREF,PARAMS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSCLIENTS
where (ID) in
    (select ID from UCONSCLIENTS
     MINUS
     select ID from A_UCONSCLIENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSGROUPSCAPTION

update A_UCONSGROUPSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSGROUPSCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSGROUPSCAPTION)
/

update A_UCONSGROUPSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UCONSGROUPSCAPTION
   where (ID) in (select ID from A_UCONSGROUPSCAPTION))
  MINUS
  (select ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UCONSGROUPSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSGROUPSCAPTION (ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSGROUPSCAPTION
   where (ID) in (select ID from A_UCONSGROUPSCAPTION))
  MINUS
  (select ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSGROUPSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSGROUPSCAPTION (ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TEXTID,NAME,NOTE,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSGROUPSCAPTION
where (ID) in
    (select ID from UCONSGROUPSCAPTION
     MINUS
     select ID from A_UCONSGROUPSCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSGROUPSDETAIL

update A_UCONSGROUPSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSGROUPSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSGROUPSDETAIL)
/

update A_UCONSGROUPSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UCONSGROUPSDETAIL
   where (ID) in (select ID from A_UCONSGROUPSDETAIL))
  MINUS
  (select ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UCONSGROUPSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSGROUPSDETAIL (ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSGROUPSDETAIL
   where (ID) in (select ID from A_UCONSGROUPSDETAIL))
  MINUS
  (select ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSGROUPSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSGROUPSDETAIL (ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,CONSCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSGROUPSDETAIL
where (ID) in
    (select ID from UCONSGROUPSDETAIL
     MINUS
     select ID from A_UCONSGROUPSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSSUBJECTFORMS

update A_UCONSSUBJECTFORMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSSUBJECTFORMS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSSUBJECTFORMS)
/

update A_UCONSSUBJECTFORMS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UCONSSUBJECTFORMS
   where (ID) in (select ID from A_UCONSSUBJECTFORMS))
  MINUS
  (select ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UCONSSUBJECTFORMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSSUBJECTFORMS (ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSSUBJECTFORMS
   where (ID) in (select ID from A_UCONSSUBJECTFORMS))
  MINUS
  (select ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSSUBJECTFORMS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSSUBJECTFORMS (ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,SUBJECTTEXTID,FORMTEXTID,ISCLIENT,BEGINDATE,ENDDATE,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSSUBJECTFORMS
where (ID) in
    (select ID from UCONSSUBJECTFORMS
     MINUS
     select ID from A_UCONSSUBJECTFORMS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UCONSSUBJECTTYPES

update A_UCONSSUBJECTTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UCONSSUBJECTTYPES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UCONSSUBJECTTYPES)
/

update A_UCONSSUBJECTTYPES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UCONSSUBJECTTYPES
   where (ID) in (select ID from A_UCONSSUBJECTTYPES))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UCONSSUBJECTTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UCONSSUBJECTTYPES (ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UCONSSUBJECTTYPES
   where (ID) in (select ID from A_UCONSSUBJECTTYPES))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UCONSSUBJECTTYPES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UCONSSUBJECTTYPES (ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TEXTID,NAME,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UCONSSUBJECTTYPES
where (ID) in
    (select ID from UCONSSUBJECTTYPES
     MINUS
     select ID from A_UCONSSUBJECTTYPES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UFK_LOGCAPTION

update A_UFK_LOGCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UFK_LOGCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UFK_LOGCAPTION)
/

update A_UFK_LOGCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT
   from UFK_LOGCAPTION
   where (ID) in (select ID from A_UFK_LOGCAPTION))
  MINUS
  (select ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT
   from A_UFK_LOGCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UFK_LOGCAPTION (ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UFK_LOGCAPTION
   where (ID) in (select ID from A_UFK_LOGCAPTION))
  MINUS
  (select ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UFK_LOGCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UFK_LOGCAPTION (ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PROGINDEX,ERRORCLS,REGIONCLS,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OPERDATE,IMPORTNUMBER,DELETEFLAG,IMPORTEDCOUNT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UFK_LOGCAPTION
where (ID) in
    (select ID from UFK_LOGCAPTION
     MINUS
     select ID from A_UFK_LOGCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UFK_LOGDETAIL

update A_UFK_LOGDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UFK_LOGDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UFK_LOGDETAIL)
/

update A_UFK_LOGDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE
   from UFK_LOGDETAIL
   where (ID) in (select ID from A_UFK_LOGDETAIL))
  MINUS
  (select ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE
   from A_UFK_LOGDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UFK_LOGDETAIL (ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UFK_LOGDETAIL
   where (ID) in (select ID from A_UFK_LOGDETAIL))
  MINUS
  (select ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UFK_LOGDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UFK_LOGDETAIL (ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DESTRECORDINDEX,SOURCEFIRSTRECORDINDEX,SOURCESECONDRECORDINDEX,PROGINDEX,ERRORCLS,REGIONCLS,RECORDINDEX,NOTE,IMPORTDATE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,ANUMBER,PACKETNUMBER,GETDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UFK_LOGDETAIL
where (ID) in
    (select ID from UFK_LOGDETAIL
     MINUS
     select ID from A_UFK_LOGDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UFK_RM

update A_UFK_RM set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UFK_RM
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UFK_RM)
/

update A_UFK_RM set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER
   from UFK_RM
   where (ID) in (select ID from A_UFK_RM))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER
   from A_UFK_RM
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UFK_RM (ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UFK_RM
   where (ID) in (select ID from A_UFK_RM))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UFK_RM
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UFK_RM (ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,DAT_DOC,SCHET,VH_OST,OBD,OBK,ISH_SALD,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,REGION_CLS,LASTPACKET,ANUMBER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UFK_RM
where (ID) in
    (select ID from UFK_RM
     MINUS
     select ID from A_UFK_RM
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UFK_SVERKA

update A_UFK_SVERKA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UFK_SVERKA
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UFK_SVERKA)
/

update A_UFK_SVERKA set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from UFK_SVERKA
   where (ID) in (select ID from A_UFK_SVERKA))
  MINUS
  (select ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_UFK_SVERKA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UFK_SVERKA (ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UFK_SVERKA
   where (ID) in (select ID from A_UFK_SVERKA))
  MINUS
  (select ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UFK_SVERKA
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UFK_SVERKA (ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,DFACCOUNT,DOCDATE,DEBITBEFORE,CREDITBEFORE,DEBIT,CREDIT,BUHACC,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UFK_SVERKA
where (ID) in
    (select ID from UFK_SVERKA
     MINUS
     select ID from A_UFK_SVERKA
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UFK_SVOD

update A_UFK_SVOD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UFK_SVOD
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UFK_SVOD)
/

update A_UFK_SVOD set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN
   from UFK_SVOD
   where (ID) in (select ID from A_UFK_SVOD))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN
   from A_UFK_SVOD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UFK_SVOD (ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UFK_SVOD
   where (ID) in (select ID from A_UFK_SVOD))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UFK_SVOD
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UFK_SVOD (ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,PROCESSING,AUTOPROCESSING,PROCNOTE,PRIZ,DATA,NOM,QQ1,QQ2,QQ3,QQ4,QQS,SENDER,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,OKATO,NUM,INN,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UFK_SVOD
where (ID) in
    (select ID from UFK_SVOD
     MINUS
     select ID from A_UFK_SVOD
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UFK_VP

update A_UFK_VP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UFK_VP
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UFK_VP)
/

update A_UFK_VP set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET
   from UFK_VP
   where (ID) in (select ID from A_UFK_VP))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET
   from A_UFK_VP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UFK_VP (ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UFK_VP
   where (ID) in (select ID from A_UFK_VP))
  MINUS
  (select ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UFK_VP
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UFK_VP (ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PACKETNUMBER,GETDATE,DATE_PROV,SCHET,NUM,DAT_DOC,SUMMA,TIP_OPER,TIP_DOC,GL,PODRAZDEL,VIDRASHOD,CELST,KL_NUM,NAZNACH,SENDER,PROCESSING,AUTOPROCESSING,PROCNOTE,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REGIONCODE,RECORDINDEX,REGION_CLS,ANUMBER,LASTPACKET,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UFK_VP
where (ID) in
    (select ID from UFK_VP
     MINUS
     select ID from A_UFK_VP
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UNIONNOTIFYCAPTION

update A_UNIONNOTIFYCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UNIONNOTIFYCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UNIONNOTIFYCAPTION)
/

update A_UNIONNOTIFYCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS
   from UNIONNOTIFYCAPTION
   where (ID) in (select ID from A_UNIONNOTIFYCAPTION))
  MINUS
  (select ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS
   from A_UNIONNOTIFYCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UNIONNOTIFYCAPTION (ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UNIONNOTIFYCAPTION
   where (ID) in (select ID from A_UNIONNOTIFYCAPTION))
  MINUS
  (select ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UNIONNOTIFYCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UNIONNOTIFYCAPTION (ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,DOCNUMBER,NOTIFYNUMBER,INPUTDATE,DFACCOUNT,ACCEPTDATE,ACCEPTDATEFK,PROGINDEX,FACIALACCCLS,DOCUMENTFORMAT,ORG_REF,NOTIFYTYPE,NOTE,KFD,SENDERID,SENDERRECORDID,CRYPTOSTATUS,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,REJECTCLS,REJECTCAUSE,REESTRNUMBER,REESTRDATE,DATE_UTV_REESTR,DATE_UTV_BA,DATE_UTV_LBO,DATE_UTV_POF,DATE_UTV_PP,DATE_PP,SPECIALNOTECODE,TIP_RR,CLSTYPE,NOM_PP,SPECIALNOTE,INPUTMONTH,STIMATEID,LASTEXTRCHANGE,DEPARTMENTCLS,SIGNERS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UNIONNOTIFYCAPTION
where (ID) in
    (select ID from UNIONNOTIFYCAPTION
     MINUS
     select ID from A_UNIONNOTIFYCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UNIONNOTIFYDETAIL

update A_UNIONNOTIFYDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UNIONNOTIFYDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UNIONNOTIFYDETAIL)
/

update A_UNIONNOTIFYDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS
   from UNIONNOTIFYDETAIL
   where (ID) in (select ID from A_UNIONNOTIFYDETAIL))
  MINUS
  (select ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS
   from A_UNIONNOTIFYDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UNIONNOTIFYDETAIL (ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UNIONNOTIFYDETAIL
   where (ID) in (select ID from A_UNIONNOTIFYDETAIL))
  MINUS
  (select ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UNIONNOTIFYDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UNIONNOTIFYDETAIL (ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,KVSR,KCSR,KFSR,KVR,KESR,IFS,ACTIVITYKIND,TARGETCLS,CLSTYPE,NOTE,SUMMALIMIT,SUMMAASSIGNMENT,SUMMAFIN,SUMMALIMITYEAR,SUMMAASSIGNMENTYEAR,SUMMAFINYEAR,PROGINDEX,SENDERID,SENDERRECORDID,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,SUMMAYEAR1,SUMMAYEAR2,SUMMAYEAR3,BA_LBO_FLAG,BUHOPERATIONCLS,FACT,MEANSTYPE,DIRECTIONCLS,REGIONCLS,SUBKESR,STIMATEID,TRANSFERTCLS,SUBSIDYCLS,BUDALLOCATIONCLS,PAYPROMISECLS,FINTYPE,INVESTOBJECT,SUMMAYEAR4,SUMMAOTHERYEARS,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UNIONNOTIFYDETAIL
where (ID) in
    (select ID from UNIONNOTIFYDETAIL
     MINUS
     select ID from A_UNIONNOTIFYDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_USERSINGROUPS

update A_USERSINGROUPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_USERSINGROUPS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from USERSINGROUPS)
/

update A_USERSINGROUPS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from USERSINGROUPS
   where (ID) in (select ID from A_USERSINGROUPS))
  MINUS
  (select ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_USERSINGROUPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_USERSINGROUPS (ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from USERSINGROUPS
   where (ID) in (select ID from A_USERSINGROUPS))
  MINUS
  (select ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_USERSINGROUPS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_USERSINGROUPS (ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,GROUPREF,USERREF,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from USERSINGROUPS
where (ID) in
    (select ID from USERSINGROUPS
     MINUS
     select ID from A_USERSINGROUPS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_USERSRIGHTS

update A_USERSRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_USERSRIGHTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from USERSRIGHTS)
/

update A_USERSRIGHTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER
   from USERSRIGHTS
   where (ID) in (select ID from A_USERSRIGHTS))
  MINUS
  (select ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER
   from A_USERSRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_USERSRIGHTS (ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from USERSRIGHTS
   where (ID) in (select ID from A_USERSRIGHTS))
  MINUS
  (select ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_USERSRIGHTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_USERSRIGHTS (ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,USERREF,RIGHTREF,ISREJECT,OBJREF,OBJECTKINDREF,CREATEDATE,UPDATEDATE,RIGHTKINDREF,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from USERSRIGHTS
where (ID) in
    (select ID from USERSRIGHTS
     MINUS
     select ID from A_USERSRIGHTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTFCTREE

update A_UTFCTREE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTFCTREE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTFCTREE)
/

update A_UTFCTREE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from UTFCTREE
   where (ID) in (select ID from A_UTFCTREE))
  MINUS
  (select ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_UTFCTREE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTFCTREE (ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTFCTREE
   where (ID) in (select ID from A_UTFCTREE))
  MINUS
  (select ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTFCTREE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTFCTREE (ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,UTFCPARENT,UTFCKID,PROGINDEX,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTFCTREE
where (ID) in
    (select ID from UTFCTREE
     MINUS
     select ID from A_UTFCTREE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDCLSCAPTION

update A_UTYPEDCLSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDCLSCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDCLSCAPTION)
/

update A_UTYPEDCLSCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE
   from UTYPEDCLSCAPTION
   where (ID) in (select ID from A_UTYPEDCLSCAPTION))
  MINUS
  (select ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE
   from A_UTYPEDCLSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDCLSCAPTION (ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDCLSCAPTION
   where (ID) in (select ID from A_UTYPEDCLSCAPTION))
  MINUS
  (select ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDCLSCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDCLSCAPTION (ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CLSID,NAME,TEXTID,BEGINDATE,ENDDATE,OPTIONS,GROUPRIGHTS,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDCLSCAPTION
where (ID) in
    (select ID from UTYPEDCLSCAPTION
     MINUS
     select ID from A_UTYPEDCLSCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDCLSDETAIL

update A_UTYPEDCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDCLSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDCLSDETAIL)
/

update A_UTYPEDCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER
   from UTYPEDCLSDETAIL
   where (ID) in (select ID from A_UTYPEDCLSDETAIL))
  MINUS
  (select ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER
   from A_UTYPEDCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDCLSDETAIL (ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDCLSDETAIL
   where (ID) in (select ID from A_UTYPEDCLSDETAIL))
  MINUS
  (select ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDCLSDETAIL (ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,CODE,CODESTR,NOTE0,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,FINT0,FINT1,FINT2,FINT3,FINT4,FINT5,FINT6,FINT7,FINT8,FINT9,FLEVEL,GROUPLIST,USERLIST,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DETAILINDEX,NUMSTR,CODEROW,ROWORDER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDCLSDETAIL
where (ID) in
    (select ID from UTYPEDCLSDETAIL
     MINUS
     select ID from A_UTYPEDCLSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDDOCUMENTS

update A_UTYPEDDOCUMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDDOCUMENTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDDOCUMENTS)
/

update A_UTYPEDDOCUMENTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UTYPEDDOCUMENTS
   where (ID) in (select ID from A_UTYPEDDOCUMENTS))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UTYPEDDOCUMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDDOCUMENTS (ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDDOCUMENTS
   where (ID) in (select ID from A_UTYPEDDOCUMENTS))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDDOCUMENTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDDOCUMENTS (ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TEXTID,NAME,ISCLIENT,FORURM,PROGINDEX,TEMPLATE,BEGINDATE,ENDDATE,PARAMS,FORMTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDDOCUMENTS
where (ID) in
    (select ID from UTYPEDDOCUMENTS
     MINUS
     select ID from A_UTYPEDDOCUMENTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDFORMSDETAIL

update A_UTYPEDFORMSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDFORMSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDFORMSDETAIL)
/

update A_UTYPEDFORMSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE
   from UTYPEDFORMSDETAIL
   where (ID) in (select ID from A_UTYPEDFORMSDETAIL))
  MINUS
  (select ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE
   from A_UTYPEDFORMSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDFORMSDETAIL (ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDFORMSDETAIL
   where (ID) in (select ID from A_UTYPEDFORMSDETAIL))
  MINUS
  (select ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDFORMSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDFORMSDETAIL (ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,DETAILINDEX,CODESTR,KFSR,KCSR,KVSR,KVR,KESR,CODEROW,FINT1,FINT2,FINT3,FINT4,FINT5,S00,S01,S02,S03,S04,S05,S06,S07,S08,S09,S10,S11,S12,S13,S14,S15,S16,S17,S18,S19,S20,NOTE,FACT,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,NUMSTR,SENDERID,SENDERRECORDID,CODESTR30,PROGRAMCODE,ITEMCODE,DESCRIPTIONCODE,SUBKESR,FINT6,FINT7,NOTE1,NOTE2,NOTE3,NOTE4,NOTE5,NOTE6,NOTE7,NOTE8,NOTE9,NOTE10,CURRENCYCLS,OKATO,CODEINT,ROWORDER,DIRECTIONCLS,KD,INNERFINSOURCE,CLSTYPE,S21,S22,S23,S24,S25,S26,S27,S28,S29,S30,S31,S32,S33,S34,S35,S36,S37,S38,S39,S40,FINT8,FINT9,FINT10,NOTE11,NOTE12,NOTE13,NOTE14,NOTE15,NOTE16,NOTE17,NOTE18,NOTE19,NOTE20,DATE1,DATE2,DATE3,DATE4,DATE5,DATE6,DATE7,DATE8,DATE9,DATE10,PARENTINDEX,TYPEDFORM,RVERSION,KFSRCODE,KCSRCODE,KVSRCODE,KVRCODE,KESRCODE,SUBKESRCODE,OKATOCODE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDFORMSDETAIL
where (ID) in
    (select ID from UTYPEDFORMSDETAIL
     MINUS
     select ID from A_UTYPEDFORMSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDFORMSPLACES

update A_UTYPEDFORMSPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDFORMSPLACES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDFORMSPLACES)
/

update A_UTYPEDFORMSPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from UTYPEDFORMSPLACES
   where (ID) in (select ID from A_UTYPEDFORMSPLACES))
  MINUS
  (select ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE
   from A_UTYPEDFORMSPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDFORMSPLACES (ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDFORMSPLACES
   where (ID) in (select ID from A_UTYPEDFORMSPLACES))
  MINUS
  (select ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDFORMSPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDFORMSPLACES (ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,WORKPLACE_REF,TYPEDFORM,ORDERBY,LEVELBY,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDFORMSPLACES
where (ID) in
    (select ID from UTYPEDFORMSPLACES
     MINUS
     select ID from A_UTYPEDFORMSPLACES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDFORMSREGCAPTION

update A_UTYPEDFORMSREGCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDFORMSREGCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDFORMSREGCAPTION)
/

update A_UTYPEDFORMSREGCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT
   from UTYPEDFORMSREGCAPTION
   where (ID) in (select ID from A_UTYPEDFORMSREGCAPTION))
  MINUS
  (select ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT
   from A_UTYPEDFORMSREGCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDFORMSREGCAPTION (ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDFORMSREGCAPTION
   where (ID) in (select ID from A_UTYPEDFORMSREGCAPTION))
  MINUS
  (select ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDFORMSREGCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDFORMSREGCAPTION (ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,UTFINDEX,TEXTID,MDKTEXTID,ISCLIENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDFORMSREGCAPTION
where (ID) in
    (select ID from UTYPEDFORMSREGCAPTION
     MINUS
     select ID from A_UTYPEDFORMSREGCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDFORMSREGDETAIL

update A_UTYPEDFORMSREGDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDFORMSREGDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDFORMSREGDETAIL)
/

update A_UTYPEDFORMSREGDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT
   from UTYPEDFORMSREGDETAIL
   where (ID) in (select ID from A_UTYPEDFORMSREGDETAIL))
  MINUS
  (select ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT
   from A_UTYPEDFORMSREGDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDFORMSREGDETAIL (ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDFORMSREGDETAIL
   where (ID) in (select ID from A_UTYPEDFORMSREGDETAIL))
  MINUS
  (select ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDFORMSREGDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDFORMSREGDETAIL (ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,UTFRINDEX,TYPEDFORM,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,REGTEXTID,FORMTEXTID,BEGINDATE,ENDDATE,ISCLIENT,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDFORMSREGDETAIL
where (ID) in
    (select ID from UTYPEDFORMSREGDETAIL
     MINUS
     select ID from A_UTYPEDFORMSREGDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDIMPORTREGISTRY

update A_UTYPEDIMPORTREGISTRY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDIMPORTREGISTRY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDIMPORTREGISTRY)
/

update A_UTYPEDIMPORTREGISTRY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from UTYPEDIMPORTREGISTRY
   where (ID) in (select ID from A_UTYPEDIMPORTREGISTRY))
  MINUS
  (select ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER
   from A_UTYPEDIMPORTREGISTRY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDIMPORTREGISTRY (ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDIMPORTREGISTRY
   where (ID) in (select ID from A_UTYPEDIMPORTREGISTRY))
  MINUS
  (select ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDIMPORTREGISTRY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDIMPORTREGISTRY (ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,NOTE,FILESIZE,FILENAME,CRC32,ISACTIVE,PARAMS,CREATEDATE,CREATERUSER,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDIMPORTREGISTRY
where (ID) in
    (select ID from UTYPEDIMPORTREGISTRY
     MINUS
     select ID from A_UTYPEDIMPORTREGISTRY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDPERIODCAPTION

update A_UTYPEDPERIODCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDPERIODCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDPERIODCAPTION)
/

update A_UTYPEDPERIODCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UTYPEDPERIODCAPTION
   where (ID) in (select ID from A_UTYPEDPERIODCAPTION))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UTYPEDPERIODCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDPERIODCAPTION (ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDPERIODCAPTION
   where (ID) in (select ID from A_UTYPEDPERIODCAPTION))
  MINUS
  (select ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDPERIODCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDPERIODCAPTION (ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TEXTID,NAME,ISCLIENT,REPORTDATE,PERIOD,REGULATIONDATE,EXPIRYDATE,BEGINDATE,ENDDATE,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDPERIODCAPTION
where (ID) in
    (select ID from UTYPEDPERIODCAPTION
     MINUS
     select ID from A_UTYPEDPERIODCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDPERIODDETAIL

update A_UTYPEDPERIODDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDPERIODDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDPERIODDETAIL)
/

update A_UTYPEDPERIODDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UTYPEDPERIODDETAIL
   where (ID) in (select ID from A_UTYPEDPERIODDETAIL))
  MINUS
  (select ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UTYPEDPERIODDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDPERIODDETAIL (ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDPERIODDETAIL
   where (ID) in (select ID from A_UTYPEDPERIODDETAIL))
  MINUS
  (select ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDPERIODDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDPERIODDETAIL (ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,PERIODTEXTID,REGTEXTID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDPERIODDETAIL
where (ID) in
    (select ID from UTYPEDPERIODDETAIL
     MINUS
     select ID from A_UTYPEDPERIODDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDSOURCESCAPTION

update A_UTYPEDSOURCESCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDSOURCESCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDSOURCESCAPTION)
/

update A_UTYPEDSOURCESCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UTYPEDSOURCESCAPTION
   where (ID) in (select ID from A_UTYPEDSOURCESCAPTION))
  MINUS
  (select ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UTYPEDSOURCESCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDSOURCESCAPTION (ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDSOURCESCAPTION
   where (ID) in (select ID from A_UTYPEDSOURCESCAPTION))
  MINUS
  (select ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDSOURCESCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDSOURCESCAPTION (ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,TEXTID,KIND,FILLINGTEXTID,CHAINTEXTID,PARENTFORMTEXTID,CHILDFORMTEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDSOURCESCAPTION
where (ID) in
    (select ID from UTYPEDSOURCESCAPTION
     MINUS
     select ID from A_UTYPEDSOURCESCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_UTYPEDSOURCESDETAIL

update A_UTYPEDSOURCESDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_UTYPEDSOURCESDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from UTYPEDSOURCESDETAIL)
/

update A_UTYPEDSOURCESDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from UTYPEDSOURCESDETAIL
   where (ID) in (select ID from A_UTYPEDSOURCESDETAIL))
  MINUS
  (select ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER
   from A_UTYPEDSOURCESDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_UTYPEDSOURCESDETAIL (ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from UTYPEDSOURCESDETAIL
   where (ID) in (select ID from A_UTYPEDSOURCESDETAIL))
  MINUS
  (select ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_UTYPEDSOURCESDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_UTYPEDSOURCESDETAIL (ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,REGTEXTID,SOURCETEXTID,ISCLIENT,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from UTYPEDSOURCESDETAIL
where (ID) in
    (select ID from UTYPEDSOURCESDETAIL
     MINUS
     select ID from A_UTYPEDSOURCESDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_VALUECLS

update A_VALUECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_VALUECLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from VALUECLS)
/

update A_VALUECLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME
   from VALUECLS
   where (ID) in (select ID from A_VALUECLS))
  MINUS
  (select ID,NAME
   from A_VALUECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_VALUECLS (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from VALUECLS
   where (ID) in (select ID from A_VALUECLS))
  MINUS
  (select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_VALUECLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_VALUECLS (ID,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from VALUECLS
where (ID) in
    (select ID from VALUECLS
     MINUS
     select ID from A_VALUECLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_VARCHARCONST

update A_VARCHARCONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_VARCHARCONST
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from VARCHARCONST)
/

update A_VARCHARCONST set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE
   from VARCHARCONST
   where (ID) in (select ID from A_VARCHARCONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE
   from A_VARCHARCONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_VARCHARCONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from VARCHARCONST
   where (ID) in (select ID from A_VARCHARCONST))
  MINUS
  (select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_VARCHARCONST
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_VARCHARCONST (PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select PROGINDEX,CONSTINDEX,CONSTVALUE,NOTE,ID,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EDITDOCCODE,CLOSEDATE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from VARCHARCONST
where (ID) in
    (select ID from VARCHARCONST
     MINUS
     select ID from A_VARCHARCONST
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_VARIANTCLS

update A_VARIANTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_VARIANTCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from VARIANTCLS)
/

update A_VARIANTCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME
   from VARIANTCLS
   where (ID) in (select ID from A_VARIANTCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME
   from A_VARIANTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_VARIANTCLS (ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from VARIANTCLS
   where (ID) in (select ID from A_VARIANTCLS))
  MINUS
  (select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_VARIANTCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_VARIANTCLS (ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,CREATEDATE,UPDATEDATE,CREATERUSER,UPDATERUSER,NAME,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from VARIANTCLS
where (ID) in
    (select ID from VARIANTCLS
     MINUS
     select ID from A_VARIANTCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_VZ_OFFSET

update A_VZ_OFFSET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_VZ_OFFSET
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from VZ_OFFSET)
/

update A_VZ_OFFSET set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from VZ_OFFSET
   where (ID) in (select ID from A_VZ_OFFSET))
  MINUS
  (select ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_VZ_OFFSET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_VZ_OFFSET (ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from VZ_OFFSET
   where (ID) in (select ID from A_VZ_OFFSET))
  MINUS
  (select ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_VZ_OFFSET
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_VZ_OFFSET (ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NUM_CONVENT,NUM_DOCUMENT,DOCTYPE,DOCUMENTDATE,BUILDDATE,ACCEPTDATE,NOTE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from VZ_OFFSET
where (ID) in
    (select ID from VZ_OFFSET
     MINUS
     select ID from A_VZ_OFFSET
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_VZFINCAPTION

update A_VZFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_VZFINCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from VZFINCAPTION)
/

update A_VZFINCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from VZFINCAPTION
   where (ID) in (select ID from A_VZFINCAPTION))
  MINUS
  (select ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER
   from A_VZFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_VZFINCAPTION (ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from VZFINCAPTION
   where (ID) in (select ID from A_VZFINCAPTION))
  MINUS
  (select ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_VZFINCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_VZFINCAPTION (ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NUM_CONVENT,NUM_DOCUMENT,ACCEPTDATE,BUDGETREF,CREATERUSER,CREATEDATE,UPDATEDATE,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from VZFINCAPTION
where (ID) in
    (select ID from VZFINCAPTION
     MINUS
     select ID from A_VZFINCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WORKPLACES

update A_WORKPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WORKPLACES
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WORKPLACES)
/

update A_WORKPLACES set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from WORKPLACES
   where (ID) in (select ID from A_WORKPLACES))
  MINUS
  (select ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_WORKPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WORKPLACES (ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WORKPLACES
   where (ID) in (select ID from A_WORKPLACES))
  MINUS
  (select ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WORKPLACES
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WORKPLACES (ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NOTE,HIDETABS,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WORKPLACES
where (ID) in
    (select ID from WORKPLACES
     MINUS
     select ID from A_WORKPLACES
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WORKPLACES_INTERFACE

update A_WORKPLACES_INTERFACE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WORKPLACES_INTERFACE
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WORKPLACES_INTERFACE)
/

update A_WORKPLACES_INTERFACE set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from WORKPLACES_INTERFACE
   where (ID) in (select ID from A_WORKPLACES_INTERFACE))
  MINUS
  (select ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_WORKPLACES_INTERFACE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WORKPLACES_INTERFACE (ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WORKPLACES_INTERFACE
   where (ID) in (select ID from A_WORKPLACES_INTERFACE))
  MINUS
  (select ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WORKPLACES_INTERFACE
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WORKPLACES_INTERFACE (ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,WORKPLACES_REF,INTERFACES_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WORKPLACES_INTERFACE
where (ID) in
    (select ID from WORKPLACES_INTERFACE
     MINUS
     select ID from A_WORKPLACES_INTERFACE
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WORKPLACES_NEWREPORTS

update A_WORKPLACES_NEWREPORTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WORKPLACES_NEWREPORTS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WORKPLACES_NEWREPORTS)
/

update A_WORKPLACES_NEWREPORTS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from WORKPLACES_NEWREPORTS
   where (ID) in (select ID from A_WORKPLACES_NEWREPORTS))
  MINUS
  (select ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER
   from A_WORKPLACES_NEWREPORTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WORKPLACES_NEWREPORTS (ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WORKPLACES_NEWREPORTS
   where (ID) in (select ID from A_WORKPLACES_NEWREPORTS))
  MINUS
  (select ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WORKPLACES_NEWREPORTS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WORKPLACES_NEWREPORTS (ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,WORKPLACES_REF,REPORTS_REF,NOTE,ORDERBY,UPDATEDATE,CREATEDATE,CREATERUSER,UPDATERUSER,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WORKPLACES_NEWREPORTS
where (ID) in
    (select ID from WORKPLACES_NEWREPORTS
     MINUS
     select ID from A_WORKPLACES_NEWREPORTS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WRITEXECUTIONCAPTION

update A_WRITEXECUTIONCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WRITEXECUTIONCAPTION
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WRITEXECUTIONCAPTION)
/

update A_WRITEXECUTIONCAPTION set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE
   from WRITEXECUTIONCAPTION
   where (ID) in (select ID from A_WRITEXECUTIONCAPTION))
  MINUS
  (select ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE
   from A_WRITEXECUTIONCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WRITEXECUTIONCAPTION (ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WRITEXECUTIONCAPTION
   where (ID) in (select ID from A_WRITEXECUTIONCAPTION))
  MINUS
  (select ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WRITEXECUTIONCAPTION
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WRITEXECUTIONCAPTION (ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,DOCNUMBER,ISSUEDATE,LAWDEPARTMENTDATE,LAWDEPARTMENTNUMBER,NUMBERDOSSIER,NAMEJUDICIALDECISION,NAMEJUDICIALAGENCY,LEVIERACC_REF,LEVIERORG_REF,WRITEXECUTIONTOTALSUMMA,STARTDATE,ENDDATE,COUNTDAYDURING,FACIALACC_CLS,REJECT_CLS,REJECTCAUSE,SENDERID,SENDERRECORDID,DOCSTATEREF,RVERSION,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,LASTEXTRCHANGE,CRYPTOSTATUS,PROGINDEX,UNIQUENUMBER,PRESENTDATE,SHEETSCOUNT,DELIVERYDATE,COURTSHEETSCOUNT,DEBTORNAME,WRITTYPE,WRITPERIOD,ISINVALID,CASECATEGORY,INNERNUMBER,LEVIERNAME,NOTE,NUMBERDEPARTMENTCB,NAMEJUDICIALAGENCYREF,JUDICIALDECISIONDATE,NUMBERPOSTNOTICE,COMPLETIONDATE,DATEPOSTNOTICE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WRITEXECUTIONCAPTION
where (ID) in
    (select ID from WRITEXECUTIONCAPTION
     MINUS
     select ID from A_WRITEXECUTIONCAPTION
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WRITEXECUTIONDETAIL

update A_WRITEXECUTIONDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WRITEXECUTIONDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WRITEXECUTIONDETAIL)
/

update A_WRITEXECUTIONDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE
   from WRITEXECUTIONDETAIL
   where (ID) in (select ID from A_WRITEXECUTIONDETAIL))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE
   from A_WRITEXECUTIONDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WRITEXECUTIONDETAIL (ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WRITEXECUTIONDETAIL
   where (ID) in (select ID from A_WRITEXECUTIONDETAIL))
  MINUS
  (select ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WRITEXECUTIONDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WRITEXECUTIONDETAIL (ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,BUDGETREF,RECORDINDEX,FACIALACC_CLS,KVSR,KFSR,KCSR,KVR,KESR,DIRECTIONCLS,MEANSTYPE,FACT,REGIONCLS,FINSOURCE,FINTYPE,DOCTYPE,SUBKESR,PROMISE,BUDGETPROMISE,WRITEXECUTIONSUMMA,SENDERID,SENDERRECORDID,RVERSION,PROGINDEX,CREATERUSER,CREATEDATE,UPDATERUSER,UPDATEDATE,EXECDOC,PSCHEDULEREF,MONTH01,MONTH02,MONTH03,MONTH04,MONTH05,MONTH06,MONTH07,MONTH08,MONTH09,MONTH10,MONTH11,MONTH12,QUARTER1,QUARTER2,QUARTER3,QUARTER4,MONTHLYDATE,QUARTERLYMONTHDAY,QUARTERLYMONTHNUMBER,PARENTID,BUDALLOCATIONCLS,PAYPROMISECLS,TRANSFERTCLS,SUBSIDYCLS,INVESTOBJECT,CLSTYPE,KD,NOTE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WRITEXECUTIONDETAIL
where (ID) in
    (select ID from WRITEXECUTIONDETAIL
     MINUS
     select ID from A_WRITEXECUTIONDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WRITEXECUTIONNOTIFY

update A_WRITEXECUTIONNOTIFY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WRITEXECUTIONNOTIFY
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WRITEXECUTIONNOTIFY)
/

update A_WRITEXECUTIONNOTIFY set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION
   from WRITEXECUTIONNOTIFY
   where (ID) in (select ID from A_WRITEXECUTIONNOTIFY))
  MINUS
  (select ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION
   from A_WRITEXECUTIONNOTIFY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WRITEXECUTIONNOTIFY (ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WRITEXECUTIONNOTIFY
   where (ID) in (select ID from A_WRITEXECUTIONNOTIFY))
  MINUS
  (select ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WRITEXECUTIONNOTIFY
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WRITEXECUTIONNOTIFY (ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NOTIFYCLS,NOTE,RECORDINDEX,NOTIFYNUMBER,NOTIFYDATE,SENDERID,SENDERRECORDID,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,DESCRIPTION,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WRITEXECUTIONNOTIFY
where (ID) in
    (select ID from WRITEXECUTIONNOTIFY
     MINUS
     select ID from A_WRITEXECUTIONNOTIFY
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WRITNOTIFYCLS

update A_WRITNOTIFYCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WRITNOTIFYCLS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WRITNOTIFYCLS)
/

update A_WRITNOTIFYCLS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES
   from WRITNOTIFYCLS
   where (ID) in (select ID from A_WRITNOTIFYCLS))
  MINUS
  (select ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES
   from A_WRITNOTIFYCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WRITNOTIFYCLS (ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WRITNOTIFYCLS
   where (ID) in (select ID from A_WRITNOTIFYCLS))
  MINUS
  (select ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WRITNOTIFYCLS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WRITNOTIFYCLS (ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,SHORTNAME,NOTE,STATEFILTER,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ALLOWDOCSTATES,ALLOWWRITTYPES,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WRITNOTIFYCLS
where (ID) in
    (select ID from WRITNOTIFYCLS
     MINUS
     select ID from A_WRITNOTIFYCLS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WRITNOTIFYCLSDETAIL

update A_WRITNOTIFYCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WRITNOTIFYCLSDETAIL
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WRITNOTIFYCLSDETAIL)
/

update A_WRITNOTIFYCLSDETAIL set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE
   from WRITNOTIFYCLSDETAIL
   where (ID) in (select ID from A_WRITNOTIFYCLSDETAIL))
  MINUS
  (select ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE
   from A_WRITNOTIFYCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WRITNOTIFYCLSDETAIL (ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WRITNOTIFYCLSDETAIL
   where (ID) in (select ID from A_WRITNOTIFYCLSDETAIL))
  MINUS
  (select ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WRITNOTIFYCLSDETAIL
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WRITNOTIFYCLSDETAIL (ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,RECORDINDEX,NOTIFYCLSPART,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,ISSYSTEM,ISREQUIRED,ISVISIBLE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WRITNOTIFYCLSDETAIL
where (ID) in
    (select ID from WRITNOTIFYCLSDETAIL
     MINUS
     select ID from A_WRITNOTIFYCLSDETAIL
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_WRITNOTIFYCLSPART

update A_WRITNOTIFYCLSPART set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_WRITNOTIFYCLSPART
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from WRITNOTIFYCLSPART)
/

update A_WRITNOTIFYCLSPART set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID
   from WRITNOTIFYCLSPART
   where (ID) in (select ID from A_WRITNOTIFYCLSPART))
  MINUS
  (select ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID
   from A_WRITNOTIFYCLSPART
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_WRITNOTIFYCLSPART (ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from WRITNOTIFYCLSPART
   where (ID) in (select ID from A_WRITNOTIFYCLSPART))
  MINUS
  (select ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_WRITNOTIFYCLSPART
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_WRITNOTIFYCLSPART (ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NAME,SHORTNAME,NOTIFY_FIELDTYPE,NOTE,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,HANDBOOKID,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from WRITNOTIFYCLSPART
where (ID) in
    (select ID from WRITNOTIFYCLSPART
     MINUS
     select ID from A_WRITNOTIFYCLSPART
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

-- A_YARDSTICKS

update A_YARDSTICKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 2
where oper_LastFlag = 1
  and (ID) in (select ID from A_YARDSTICKS
             where oper_LastFlag = 1
               and (oper_EType != 2 or oper_EType is null)
            MINUS select ID from YARDSTICKS)
/

update A_YARDSTICKS set
  oper_EId = PKG_AUDIT_TEMP.OperId,
  oper_EDate = PKG_AUDIT_TEMP.OperDate,
  oper_EUser = USER,
  oper_ESyncFlag = 1,
  oper_EType = 1,
  oper_LastFlag = NULL
where oper_LastFlag = 1
  and (ID) in (select ID from (
  (select ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE
   from YARDSTICKS
   where (ID) in (select ID from A_YARDSTICKS))
  MINUS
  (select ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE
   from A_YARDSTICKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))))
/

insert into A_YARDSTICKS (ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
(  (select ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from YARDSTICKS
   where (ID) in (select ID from A_YARDSTICKS))
  MINUS
  (select ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,1,1,PKG_AUDIT_TEMP.MaxInt
   from A_YARDSTICKS
   where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null)))
/

insert into A_YARDSTICKS (ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE,
    oper_BId,oper_BDate,oper_BUser,oper_BSyncFlag,oper_BType,oper_LastFlag,oper_EId)
select ID,NOTE,WEBID,RVERSION,CREATERUSER,UPDATERUSER,CREATEDATE,UPDATEDATE,STATUS,NAME,CONDITIONREF,YARDTYPE,
    PKG_AUDIT_TEMP.OperId,PKG_AUDIT_TEMP.OperDate,USER,1,0,1,PKG_AUDIT_TEMP.MaxInt
from YARDSTICKS
where (ID) in
    (select ID from YARDSTICKS
     MINUS
     select ID from A_YARDSTICKS
     where oper_LastFlag = 1 and (oper_EType != 2 or oper_EType is null))
/

COMMIT
/

DROP PACKAGE BODY PKG_AUDIT_TEMP
/

DROP PACKAGE PKG_AUDIT_TEMP
/


SPOOL OFF

exit
